/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridToolbarBaseAction } from "./GridToolbarBaseAction";
import { WCNativeHelper } from "igniteui-react";
import { markType } from "igniteui-react-core";
import { OverlaySettings } from "./OverlaySettings";
import { ToggleViewCancelableEventArgs } from "./ToggleViewCancelableEventArgs";
import { ToggleViewEventArgs } from "./ToggleViewEventArgs";
import { ColumnToggledEventArgs } from "./ColumnToggledEventArgs";
/**
 * @hidden
 */
export let BaseToolbarDirective = /*@__PURE__*/ (() => {
    class BaseToolbarDirective extends GridToolbarBaseAction {
        constructor() {
            super(...arguments);
            this.h = new WCNativeHelper();
            this.j = null;
            this.opening = null;
            this.opened = null;
            this.closing = null;
            this.closed = null;
            this.columnToggle = null;
        }
        get i() {
            return this.h;
        }
        get nativeElement() {
            return this.j;
        }
        set nativeElement(a) {
            this.j = a;
            this.h.o = this.j;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get l() {
            let ret_ = this.i.n("columnListHeight");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.i.v("columnListHeight", value_);
        }
        get n() {
            let ret_ = this.i.n("title");
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.i.v("title", value_);
        }
        get m() {
            let ret_ = this.i.n("prompt");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.i.v("prompt", value_);
        }
        get c() {
            let ret_ = this.i.m("overlaySettings", (a) => new OverlaySettings());
            return ret_;
        }
        set c(a) {
            let value_ = a;
            this.i.v("overlaySettings", value_);
        }
        openingChanged() {
            if (this.opening != null) {
                this.i.r("opening", (a) => this.opening(this, ToggleViewCancelableEventArgs.a(a)), false);
            }
            else {
                this.i.u("opening");
            }
        }
        openedChanged() {
            if (this.opened != null) {
                this.i.r("opened", (a) => this.opened(this, ToggleViewEventArgs.a(a)), false);
            }
            else {
                this.i.u("opened");
            }
        }
        closingChanged() {
            if (this.closing != null) {
                this.i.r("closing", (a) => this.closing(this, ToggleViewEventArgs.a(a)), false);
            }
            else {
                this.i.u("closing");
            }
        }
        closedChanged() {
            if (this.closed != null) {
                this.i.r("closed", (a) => this.closed(this, ToggleViewEventArgs.a(a)), false);
            }
            else {
                this.i.u("closed");
            }
        }
        columnToggleChanged() {
            if (this.columnToggle != null) {
                this.i.r("columnToggle", (a) => this.columnToggle(this, ColumnToggledEventArgs.a(a)), false);
            }
            else {
                this.i.u("columnToggle");
            }
        }
        get_a() {
            let ret_ = this.i.n("name");
            return ret_;
        }
        set_a(a) {
            let value_ = a;
            this.i.v("name", value_);
        }
        get a() {
            return this.get_a();
        }
        set a(a) {
            this.set_a(a);
        }
    }
    BaseToolbarDirective.$t = /*@__PURE__*/ markType(BaseToolbarDirective, 'BaseToolbarDirective', GridToolbarBaseAction.$);
    return BaseToolbarDirective;
})();
