/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, PointUtil } from "igniteui-react-core";
import { INativeCell_$type } from "./INativeCell";
import { RenderingContext } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { Line } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { CanvasPlaceholderView } from "./CanvasPlaceholderView";
import { DeviceUtils } from "igniteui-react-core";
import { Random } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { truncate, isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let CanvasGridCellBase = /*@__PURE__*/ (() => {
    class CanvasGridCellBase extends Base {
        get aa() {
            return this.o;
        }
        set aa(a) {
            this.o = a;
        }
        cm(a) {
            this.k = a;
        }
        b7() {
            this.o = true;
            if (this.k != null) {
                this.k();
            }
        }
        get isCanvasBased() {
            return true;
        }
        get bn() {
            return this.bm;
        }
        get isRemoved() {
            return this.q;
        }
        set isRemoved(a) {
            this.q = a;
        }
        co(a) {
            this.b0 = a;
            this.o = true;
            this.s = true;
        }
        constructor(a) {
            super();
            this.a = null;
            this.s = true;
            this.o = true;
            this.k = null;
            this.bm = null;
            this.q = false;
            this.b0 = null;
            this.l = false;
            this.aq = 1;
            this.au = 5;
            this.aw = 5;
            this.av = 5;
            this.at = 5;
            this.cy = null;
            this.ai = 0;
            this.ak = 0;
            this.aj = 0;
            this.ah = 0;
            this.c6 = new Rectangle();
            this.c2 = new Line();
            this.c5 = new Line();
            this.c3 = new Line();
            this.c1 = new Line();
            this.c4 = new Line();
            this.a0 = 0;
            this.a2 = 0;
            this.a3 = 0;
            this.a4 = 0;
            this.bo = null;
            this.j = null;
            this.am = 0;
            this.al = 0;
            this.ao = 0;
            this.an = 0;
            this.u = true;
            this.v = true;
            this.a1 = NaN;
            this.cx = new TextBlock();
            this.c0 = Color.u(255, 0, 0, 0);
            this.t = true;
            this.as = 0;
            this.a5 = 0;
            this.cz = Color.u(255, 255, 255, 255);
            this.m = false;
            this.g = null;
            this.c = 0;
            this.e = 0;
            this.bz = 1;
            this.r = false;
            this.az = 0;
            this.ay = 0;
            this.i = ((() => {
                let $ret = new FontInfo();
                $ret.p = "Verdana";
                $ret.e = 12;
                return $ret;
            })());
            this.p = true;
            this.br = -1;
            this.bx = 0;
            this.by = 0;
            this.n = false;
            this.bp = 0;
            this.b = 0;
            this.ar = NaN;
            this.h = null;
            this.bt = -1;
            this.ap = NaN;
            this.f = 1;
            this.ax = 1;
            this.bm = a;
        }
        get templateContext() {
            return this.j.h();
        }
        get w() {
            return this.l;
        }
        set w(a) {
            this.l = a;
        }
        get_ac() {
            return false;
        }
        get ac() {
            return this.get_ac();
        }
        ce(a, b, c, d, e) {
            this.o = true;
            this.cy = a;
            this.ai = b;
            this.ak = c;
            this.aj = d;
            this.ah = e;
            this.s = true;
        }
        cf(a) {
            this.o = true;
            this.aq = a;
            this.cx._opacity = this.aq;
        }
        get bc() {
            return this.au;
        }
        get be() {
            return this.aw;
        }
        get bd() {
            return this.av;
        }
        get bb() {
            return this.at;
        }
        get a7() {
            return this.ai;
        }
        get a9() {
            return this.ak;
        }
        get a8() {
            return this.aj;
        }
        get a6() {
            return this.ah;
        }
        get bg() {
            return this.a0;
        }
        get bi() {
            return this.a2;
        }
        get bj() {
            return this.a4;
        }
        get_ad() {
            return false;
        }
        get ad() {
            return this.get_ad();
        }
        b3(a, b, c, d, e, f) {
            let g = true;
            let h = true;
            let i = false;
            if (this.ad) {
                g = false;
                h = false;
                i = false;
            }
            this.b4(a, b, c, d, e, f, g, h, i);
        }
        get resized() {
            return this.u;
        }
        ensureCorrectSize() {
            this.u = this.x(this.ax);
            return this.u;
        }
        b4(a, b, c, d, e, f, g, h, i) {
            if (!this.t) {
                return;
            }
            if (this.bz != 1) {
                a.ae(this.bz);
            }
            let j = this.j;
            if (!this.v) {
                j = a;
            }
            this.ax = f;
            if (!i) {
                this.b5();
                this.ensureCorrectSize();
            }
            if (this.aa || this.u || i || !this.v) {
                this.aa = false;
                if (this.p || this.u || (this.i != null && this.i.i != this.br)) {
                    this.p = false;
                    this.br = this.i.i;
                    j.ad(this.i);
                }
                if (f != 1) {
                    j.aa();
                    j.ab(f, f);
                }
                if (!this.v) {
                    j.aa();
                    let k = Math.round((d - b));
                    let l = Math.round((e - c));
                    j.ag(k, l);
                }
                if (g) {
                    this.b8(j);
                }
                if (h) {
                    this.b9(j);
                }
                if (!this.v) {
                    j.z();
                }
                if (f != 1) {
                    j.z();
                }
            }
            if (!i && this.v) {
                let m = Math.round((d - b) * f);
                let n = Math.round((e - c) * f);
                if (this.am == this.ao && this.al == this.an) {
                    a.n(this.bu(), 1, m, n, this.am, this.al);
                }
                else {
                    a.o(this.bu(), 1, 0, 0, this.am, this.al, m, n, this.am, this.al);
                }
            }
            if (this.bz != 1) {
                a.ae(1);
            }
        }
        bu() {
            return this.bo.getNativeElement();
        }
        b8(a) {
            if (!this.m) {
                a.l(0, 0, this.ao, this.an);
            }
            this.c6.n = 0;
            this.c6.o = 0;
            this.c6.width = this.a5;
            this.c6.height = this.as;
            a.w(this.c6);
            if (this.cy != null) {
                if (this.ai > 0) {
                    this.c2.ap = 0;
                    this.c2.an = this.ai / 2;
                    this.c2.aq = this.as;
                    this.c2.ao = this.ai / 2;
                    this.c2._stroke = this.cy;
                    this.c2.ad = this.ai;
                    a.s(this.c2);
                }
                if (this.aj > 0) {
                    this.c3.ap = 0;
                    this.c3.an = Math.max(0, (this.a5 - (this.aj / 2)));
                    this.c3.aq = this.as;
                    this.c3.ao = Math.max(0, (this.a5 - (this.aj / 2)));
                    this.c3._stroke = this.cy;
                    this.c3.ad = this.aj;
                    a.s(this.c3);
                }
                if (this.ak > 0) {
                    this.c5.ap = this.ak / 2;
                    this.c5.an = this.ai;
                    this.c5.aq = this.ak / 2;
                    this.c5.ao = Math.max(0, (this.a5 - (this.aj / 2)));
                    this.c5._stroke = this.cy;
                    this.c5.ad = this.ak;
                    a.s(this.c5);
                }
                if (this.ah > 0) {
                    this.c1.ap = Math.max(0, this.as - (this.ah / 2));
                    this.c1.an = this.ai;
                    this.c1.aq = Math.max(0, this.as - (this.ah / 2));
                    this.c1.ao = Math.max(0, (this.a5 - (this.aj / 2)));
                    this.c1._stroke = this.cy;
                    this.c1.ad = this.ah;
                    a.s(this.c1);
                }
            }
        }
        cl(a) {
            this.ax = a;
        }
        renderStandardContent() {
            this.b4(this.j, 0, 0, 0, 0, this.ax, false, true, true);
        }
        renderStandardBackground() {
            this.b4(this.j, 0, 0, 0, 0, this.ax, true, false, true);
        }
        b9(a) {
            if (this.s) {
                this.cw(a);
                this.s = false;
            }
            if (this.cx.al != null) {
                this.cx.n = this.a0;
                this.cx.o = this.a3;
                a.x(this.cx);
                if (this.r) {
                    this.c4.ad = 1;
                    this.c4.an = this.a0;
                    this.c4.ap = this.a4 - 2;
                    this.c4.ao = this.a0 + (this.a2 - this.a0);
                    this.c4.aq = this.a4 - 2;
                    this.c4._stroke = this.cx.ao;
                    this.j.s(this.c4);
                }
            }
        }
        b5() {
            if (this.bo == null && this.v) {
                this.bo = this.bm.createElement("canvas");
                let a = this.bm.get2DCanvasContext(this.bo);
                let b = ((() => {
                    let $ret = new CanvasViewRenderer();
                    $ret.h$d = a;
                    return $ret;
                })());
                this.j = new RenderingContext(b, a);
                this.s = true;
            }
        }
        x(a) {
            let b = Math.round(this.a5 * a);
            let c = Math.round(this.as * a);
            this.am = b;
            this.al = c;
            let d = this.bf(b);
            let e = this.bf(c);
            if (d != this.ao || e != this.an) {
                this.bo.setAttribute("width", d + "px");
                this.bo.setAttribute("height", e + "px");
                this.ao = d;
                this.an = e;
                this.am = b;
                this.al = c;
                return true;
            }
            return false;
        }
        bf(a) {
            return a;
        }
        ck(a, b, c, d) {
            this.o = true;
            this.au = a;
            this.aw = b;
            this.av = c;
            this.at = d;
            this.s = true;
        }
        get bh() {
            return this.a1;
        }
        set bh(a) {
            this.a1 = a;
        }
        cp(a) {
            this.o = true;
            this.c0 = a;
            this.cx.ao = ((() => {
                let $ret = new Brush();
                $ret.color = this.c0;
                return $ret;
            })());
        }
        get_ab() {
            return false;
        }
        get ab() {
            return this.get_ab();
        }
        get ae() {
            return this.t;
        }
        set ae(a) {
            this.o = true;
            this.t = a;
        }
        get ba() {
            return this.as;
        }
        get bl() {
            return this.a5;
        }
        ch(a) {
            this.o = true;
            this.as = a;
            this.c6.height = this.as;
        }
        cr(a) {
            this.o = true;
            this.a5 = a;
            this.c6.width = this.a5;
            this.s = true;
        }
        b2() {
            if (!this.ac) {
                return;
            }
            this.l = true;
            this.g = new CanvasPlaceholderView();
            this.c = 0;
            this.e = 1;
            this.g.l = Color.u(120, 120, 120, 120);
            this.g.h = 0;
        }
        cd(a) {
            this.o = true;
            this.cz = a;
            this.m = this.cz.l == 255;
            this.c6._fill = ((() => {
                let $ret = new Brush();
                $ret.color = this.cz;
                return $ret;
            })());
        }
        cj(a) {
            this.o = true;
            this.bz = a;
        }
        cn(a) {
            this.r = a;
            this.o = true;
        }
        cv(a) {
            if (!this.ac) {
                return;
            }
            this.o = true;
            this.g.h = (a * 0.20000000298023224);
        }
        b6(a, b, c, d) {
            if (this.g != null) {
                let e = this.az;
                let f = this.ay;
                if (this.e == 1) {
                    b = truncate((b + (d / 2) - (f / 2)));
                }
                else if (this.e == 2) {
                    b = truncate((b + (d) - (f)));
                }
                if (this.c == 1) {
                    a = truncate((a + (c / 2) - (e / 2)));
                }
                else if (this.c == 2) {
                    a = truncate((a + (c) - (e)));
                }
            }
        }
        cg(a) {
            this.i = a;
            this.p = true;
            this.o = true;
            this.s = true;
        }
        cu(a) {
            if (!this.ac) {
                return;
            }
            this.o = true;
            let b = DeviceUtils.f(12);
            if (a.ag != null && !isNaN_(a.ag.e)) {
                b = a.ag.e;
            }
            if (this.ay != b) {
                this.ay = b;
            }
            let c = a.gu * 0.2;
            let d = a.fc * 0.6;
            if (this.az >= c && this.az <= d) {
                return;
            }
            let e = (CanvasGridCellBase.bw.nextDouble() * (d - c) + c);
            if (this.az != e) {
                this.az = e;
            }
        }
        cs(a, b) {
            if (!this.ac) {
                return;
            }
            this.o = true;
            this.c = a;
            this.e = b;
        }
        ct(a) {
            if (!this.ac) {
                return;
            }
            this.o = true;
        }
        cc(a) {
            this.a = a;
        }
        get d() {
            return this.b;
        }
        ci(a) {
            this.b = a;
            this.o = true;
            this.s = true;
        }
        cw(a) {
            if (this.b0 == null) {
                return;
            }
            if (a == null) {
                return;
            }
            if (this.p || (this.i != null && this.i.i != this.br)) {
                this.p = false;
                this.br = this.i.i;
                a.ad(this.i);
            }
            let b;
            if (this.h != this.i || this.bt != this.i.i) {
                this.h = this.i;
                this.bt = this.i.i;
                this.ar = FontUtil.getCurrentFontHeight(this.bm, this.i);
            }
            b = this.ar;
            let c = 0;
            let d = 0;
            let e = this.a5;
            let f = this.as;
            e -= (this.ai + this.au + this.aj + this.av);
            f -= (this.ak + this.aw + this.ah + this.at);
            e = Math.max(e, 0);
            f = Math.max(f, 0);
            let g = e;
            if (!isNaN_(this.a1) && this.a1 < e) {
                g = this.a1;
            }
            let h = this.bk(this.cx, this.b0, g, a);
            switch (this.b) {
                case 0:
                    c = this.au + this.ai;
                    break;
                case 3:
                case 1:
                    c = this.au + this.ai + ((e / 2) - (h / 2));
                    break;
                case 2:
                    c = Math.max(0, (this.a5 - (this.av + this.aj))) - h;
                    break;
            }
            switch (this.f) {
                case 0:
                    d = this.aw + this.ak;
                    break;
                case 3:
                case 1:
                    d = this.aw + this.ak + ((f / 2) - (b / 2));
                    break;
                case 2:
                    d = Math.max(0, (this.as - (this.at + this.ah))) - b;
                    break;
            }
            this.a0 = c;
            this.a2 = this.a0 + h;
            this.a3 = d;
            this.a4 = this.a3 + (b / 2);
            this.o = true;
        }
        bk(a, b, c, d) {
            let e = b;
            let f = e.length;
            let g = ("\u2026");
            if (isNaN_(this.ap)) {
                this.ap = d.g(g);
            }
            if (c <= this.ap) {
                a.al = g;
                return this.ap;
            }
            let h = d.g(e);
            if (h <= c) {
                a.al = b;
                return h;
            }
            let i = c / h;
            let j = truncate(Math.ceil(f * i));
            let k = e.substr(0, j) + g;
            let l = d.g(k);
            if (l > c) {
                f = j;
            }
            else {
                j = j + 1;
                k = e.substr(0, j) + g;
                l = d.g(k);
                if (l > c) {
                    f = j;
                }
            }
            while (h > c && f > 0) {
                f--;
                e = e.substr(0, f) + g;
                h = d.g(e);
            }
            a.al = e;
            return h;
        }
        cq(a) {
            this.f = a;
            this.o = true;
            this.s = true;
        }
        ag(a) {
            return a.isClickActionDesired;
        }
        onContactStarted(a, b) {
            if (this.a != null && this.ag(this.a)) {
                this.bx = a.pageX;
                this.by = a.pageY;
                this.a.mouseDownCell(this.bx, this.by);
            }
        }
        onContactMoved(a, b) {
            if (this.a != null && this.ag(this.a)) {
                let c = a.pageX;
                let d = a.pageY;
                if (this.a.isMouseDown) {
                    if (b) {
                        if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bs || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bs) {
                            this.a.mouseUpCell(c, d);
                        }
                        else {
                            a.stopPropagation();
                        }
                    }
                    else {
                        if (PointUtil.equals(this.a.mousePosition, null)) {
                            this.a.mouseUpCell(c, d);
                        }
                        else {
                            if (Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bq || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bq) {
                                this.a.isControlPressed = a.ctrlKey;
                                this.a.dragStarted();
                            }
                        }
                    }
                }
            }
        }
        onContactCompleted(a, b) {
            if (this.a != null && this.ag(this.a)) {
                let c = a.pageX;
                let d = a.pageY;
                if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bs || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bs || this.a.isDrag) {
                    this.a.mouseUpCell(c, d);
                }
                if (this.a.isCellDown()) {
                    this.a.isControlPressed = a.ctrlKey;
                    this.a.isShiftPressed = a.shiftKey;
                    switch (a.which) {
                        case 1:
                            this.a.clickCell(0);
                            break;
                        case 2:
                            this.a.clickCell(1);
                            break;
                        case 3:
                            this.a.clickCell(2);
                            break;
                        default:
                            this.a.clickCell(3);
                            break;
                    }
                    this.a.mouseUpCell(a.pageX, a.pageY);
                }
            }
        }
        onDoubleClick(a) {
            switch (a.which) {
                case 1:
                    this.a.doubleClicked(0);
                    break;
                case 2:
                    this.a.doubleClicked(1);
                    break;
                case 3:
                    this.a.doubleClicked(2);
                    break;
                default:
                    this.a.doubleClicked(3);
                    break;
            }
        }
        detach() {
        }
    }
    CanvasGridCellBase.$t = /*@__PURE__*/ markType(CanvasGridCellBase, 'CanvasGridCellBase', Base.$, [INativeCell_$type]);
    CanvasGridCellBase.bw = /*@__PURE__*/ new Random(0);
    CanvasGridCellBase.bs = 10;
    CanvasGridCellBase.bq = 3;
    return CanvasGridCellBase;
})();
