/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { GridColumnDataType_$type } from "./GridColumnDataType";
/**
 * @hidden
 */
export let ColumnState = /*@__PURE__*/ (() => {
    class ColumnState extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.r = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.r;
        }
        set nativeElement(a) {
            this.r = a;
            this.b.o = this.r;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get m() {
            let ret_ = this.c.n("pinned");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.c.v("pinned", value_);
        }
        get p() {
            let ret_ = this.c.n("sortable");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.c.v("sortable", value_);
        }
        get g() {
            let ret_ = this.c.n("filterable");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.c.v("filterable", value_);
        }
        get f() {
            let ret_ = this.c.n("editable");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.c.v("editable", value_);
        }
        get q() {
            let ret_ = this.c.n("sortingIgnoreCase");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.c.v("sortingIgnoreCase", value_);
        }
        get h() {
            let ret_ = this.c.n("filteringIgnoreCase");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.c.v("filteringIgnoreCase", value_);
        }
        get x() {
            let ret_ = this.c.n("headerClasses");
            return ret_;
        }
        set x(a) {
            let value_ = a;
            this.c.v("headerClasses", value_);
        }
        get y() {
            let ret_ = this.c.n("headerGroupClasses");
            return ret_;
        }
        set y(a) {
            let value_ = a;
            this.c.v("headerGroupClasses", value_);
        }
        get z() {
            let ret_ = this.c.n("maxWidth");
            return ret_;
        }
        set z(a) {
            let value_ = a;
            this.c.v("maxWidth", value_);
        }
        get i() {
            let ret_ = this.c.n("groupable");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.c.v("groupable", value_);
        }
        get l() {
            let ret_ = this.c.n("movable");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.c.v("movable", value_);
        }
        get k() {
            let ret_ = this.c.n("hidden");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.c.v("hidden", value_);
        }
        get a() {
            let ret_ = this.c.n("dataType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridColumnDataType_$type, EnumUtil.getEnumValue(GridColumnDataType_$type, this.c.f(GridColumnDataType_$type, ret_)));
            return EnumUtil.getEnumValue(GridColumnDataType_$type, ret_);
        }
        set a(a) {
            let value_ = enumGetBox(GridColumnDataType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.c.v("dataType", value_);
        }
        get j() {
            let ret_ = this.c.n("hasSummary");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.c.v("hasSummary", value_);
        }
        get v() {
            let ret_ = this.c.n("field");
            return ret_;
        }
        set v(a) {
            let value_ = a;
            this.c.v("field", value_);
        }
        get u() {
            let ret_ = this.c.n("width");
            return ret_;
        }
        set u(a) {
            let value_ = a;
            this.c.v("width", value_);
        }
        get w() {
            let ret_ = this.c.n("header");
            return ret_;
        }
        set w(a) {
            let value_ = a;
            this.c.v("header", value_);
        }
        get n() {
            let ret_ = this.c.n("resizable");
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.c.v("resizable", value_);
        }
        get o() {
            let ret_ = this.c.n("searchable");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.c.v("searchable", value_);
        }
        get d() {
            let ret_ = this.c.n("columnGroup");
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.c.v("columnGroup", value_);
        }
        get t() {
            let ret_ = this.c.n("parent");
            return ret_;
        }
        set t(a) {
            let value_ = a;
            this.c.v("parent", value_);
        }
        get e() {
            let ret_ = this.c.n("disableHiding");
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.c.v("disableHiding", value_);
        }
    }
    ColumnState.$t = /*@__PURE__*/ markType(ColumnState, 'ColumnState');
    return ColumnState;
})();
