/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseEditorView } from "./BaseEditorView";
import { runOn, delegateCombine, delegateRemove, typeCast, markType } from "igniteui-react-core";
import { IDataSource_$type } from "igniteui-react-core";
import { stringIsNullOrWhiteSpace } from "igniteui-react-core";
/**
 * @hidden
 */
export let ComboEditorView = /*@__PURE__*/ (() => {
    class ComboEditorView extends BaseEditorView {
        get ag() {
            return this.af;
        }
        set ag(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.u("DataSource", b, this.af);
            }
        }
        get aj() {
            return this.ah;
        }
        set aj(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.u("TextField", b, this.ah);
            }
        }
        get z() {
            return this.y;
        }
        set z(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.u("ValueField", b, this.y);
            }
        }
        constructor(a, b, c) {
            super(a, c);
            this.ab = null;
            this.aa = null;
            this.ae = null;
            this.ac = false;
            this.af = null;
            this.ah = null;
            this.y = null;
            this.ad = false;
            let d = a.createElement("div");
            d.setRawStyleProperty("margin-top", "-10px");
            d.setRawStyleProperty("height", "38px");
            d.setRawStyleProperty("width", "100%");
            this.container = d;
            a.getPortal(d, "MultiColumnComboBox", (e) => {
                this.aa = e.componentRef;
                this.ae = this.aa.i;
                this.aa.height = "100%";
                this.aa.density = 3;
                this.aa.baseTheme = b;
                this.aa.labelVisible = false;
                this.aa.columnHeadersVisible = false;
                this.aa.rowSeparatorsVisible = false;
                this.ae.disallowTabFocus = true;
                this.ap();
                this.w();
                if (this.ab != null) {
                    this.aa.textStyle = this.ab.fontString;
                }
                this.attachEvents();
                if (this.ac) {
                    this.onEditStarted();
                    window.setTimeout(() => this.aa.select(), 0);
                    this.ac = false;
                }
            }, false);
        }
        setFont(a) {
            this.ab = a;
            if (this.aa != null && this.ab != null) {
                this.aa.textStyle = this.ab.fontString;
            }
        }
        attachEvents() {
            if (this.aa != null) {
                let a = this.aa;
                a.selectedValueChanged = delegateCombine(a.selectedValueChanged, runOn(this, this.onComboValueChanged));
                let b = this.aa;
                b.textValueChanged = delegateCombine(b.textValueChanged, runOn(this, this.onComboTextChanged));
                let c = this.aa;
                c.gotFocus = delegateCombine(c.gotFocus, runOn(this, this.onComboGotFocus));
                let d = this.aa;
                d.lostFocus = delegateCombine(d.lostFocus, runOn(this, this.onComboLostFocus));
                let e = this.aa;
                e.keyDown = delegateCombine(e.keyDown, runOn(this, this.onInputKeyDown));
                let f = this.aa;
                f.changing = delegateCombine(f.changing, runOn(this, this.onInputChanging));
            }
        }
        detachEvents() {
            if (this.aa != null) {
                let a = this.aa;
                a.selectedValueChanged = delegateRemove(a.selectedValueChanged, runOn(this, this.onComboValueChanged));
                let b = this.aa;
                b.textValueChanged = delegateRemove(b.textValueChanged, runOn(this, this.onComboTextChanged));
                let c = this.aa;
                c.gotFocus = delegateRemove(c.gotFocus, runOn(this, this.onComboGotFocus));
                let d = this.aa;
                d.lostFocus = delegateRemove(d.lostFocus, runOn(this, this.onComboLostFocus));
                let e = this.aa;
                e.keyDown = delegateRemove(e.keyDown, runOn(this, this.onInputKeyDown));
                let f = this.aa;
                f.changing = delegateRemove(f.changing, runOn(this, this.onInputChanging));
            }
        }
        onTargetChanged() {
            if (this.aa != null) {
                this.ad = true;
                if (this.aa.value == null && this.aa.text != "") {
                    this.aa.text = "";
                }
                this.focus();
                this.ad = false;
            }
        }
        onEditStarted() {
            if (this.aa != null) {
                super.onEditStarted();
                let a = this.container.getNativeElement();
                this.aa.defaultColumnWidth = (a.clientWidth - 2).toString();
                if (!this.a.isEditRefocusDesired) {
                    this.focus();
                }
            }
            else {
                this.ac = true;
            }
        }
        onEditEnded() {
            super.onEditEnded();
            if (this.a.isEditRefocusDesired) {
                let a = this.h.rootWrapper.getNativeElement();
                if (a == document.activeElement || a.contains(document.activeElement)) {
                    this.focus();
                }
            }
            this.ac = false;
        }
        s() {
            if (this.aa != null) {
                this.ae.focus(true);
                this.aa.select();
            }
        }
        am() {
            if (this.aa != null) {
                this.aa.closeUp();
            }
        }
        u(a, b, c) {
            super.u(a, b, c);
            switch (a) {
                case "DataSource":
                case "TextField":
                case "ValueField":
                    this.ap();
                    break;
            }
        }
        w() {
            this.ad = true;
            if (this.aa != null) {
                if (this.value == null) {
                    this.aa.text = " ";
                }
                this.aa.value = this.value;
                this.s();
            }
            this.ad = false;
        }
        ap() {
            if (this.aa != null) {
                this.detachEvents();
                this.aa.dataSource = this.ag;
                this.aa.textField = this.aj;
                this.aa.valueField = this.z;
                if (this.aj != null) {
                    this.aa.fields = [this.aj];
                }
                else if (this.z != null && this.z.length > 0) {
                    this.aa.fields = [this.z[0]];
                }
                else {
                    let a = typeCast(IDataSource_$type, this.ag);
                    if (a != null && a.actualSchema != null) {
                        this.aa.fields = [a.actualSchema.propertyNames[0]];
                    }
                    else {
                        let b = (Array.isArray(this.ag));
                        if (b) {
                            let c = (this.ag.length);
                            if (c > 0) {
                                let d = (Object.keys(this.ag[0]));
                                if (d.length > 0) {
                                    this.aa.fields = [d[0]];
                                }
                            }
                        }
                    }
                }
                this.attachEvents();
            }
        }
        v() {
            super.v();
            if (this.aa != null) {
                this.aa.textColor = this.textColor._fill;
            }
        }
        onComboValueChanged(a, b) {
            this.at();
        }
        onComboTextChanged(a, b) {
            this.at();
        }
        at() {
            if (this.ad) {
                return;
            }
            if (this.aa.value != null) {
                this.q(this.aa.value, false);
            }
            else if (this.aa.value == null && stringIsNullOrWhiteSpace(this.aa.text)) {
                this.q(null, false);
            }
            else {
                this.q(this.value, false);
            }
        }
        onInputChanging(a, b) {
            this.p();
        }
        onComboLostFocus(a) {
            this.o();
        }
        onComboGotFocus(a) {
            this.n();
        }
    }
    ComboEditorView.$t = /*@__PURE__*/ markType(ComboEditorView, 'ComboEditorView', BaseEditorView.$);
    return ComboEditorView;
})();
