/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseEditorView } from "./BaseEditorView";
import { DatePicker } from "igniteui-react-inputs";
import { runOn, delegateCombine, delegateRemove, markType } from "igniteui-react-core";
import { dateMinValue } from "igniteui-react-core";
/**
 * @hidden
 */
export let DateEditorView = /*@__PURE__*/ (() => {
    class DateEditorView extends BaseEditorView {
        get ae() {
            return this.ad;
        }
        set ae(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.u("FormatString", b, this.ad);
            }
        }
        get ac() {
            return this.aa;
        }
        set ac(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.u("ShowTodayButton", b, this.aa);
            }
        }
        constructor(a, b, c) {
            super(a, c);
            this.ad = null;
            this.y = null;
            this.z = null;
            this.ab = false;
            this.aa = false;
            let d = a.createElement("div");
            d.setRawStyleProperty("width", "100%");
            d.setRawStyleProperty("margin-top", "-10px");
            d.setRawStyleProperty("height", "38px");
            this.container = d;
            let e = a.getSubRenderer(d);
            let f = a.createElement("div");
            e.append(f);
            let g = a.createElement("div");
            e.append(g);
            this.y = new DatePicker();
            this.y.ay = false;
            this.y.provideContainer(e);
            this.y.w = b;
            this.y.y = 3;
            this.y.az = this.showClearButton;
            this.y.a0 = this.ac;
            this.y.dx = this.textColor;
            this.y.be = -1;
            let h = e.getExternal(this.y, e.rootWrapper, null);
            if (this.z != null) {
                this.y.ad = this.z;
            }
            this.attachEvents();
        }
        setFont(a) {
            this.z = a;
            if (this.y != null && this.z != null) {
                this.y.ad = this.z;
            }
        }
        attachEvents() {
            if (this.y != null) {
                let a = this.y;
                a.selectedValueChanged = delegateCombine(a.selectedValueChanged, runOn(this, this.onDatePickerValueChanged));
                let b = this.y;
                b.gotFocus = delegateCombine(b.gotFocus, runOn(this, this.onDatePickerGotFocus));
                let c = this.y;
                c.lostFocus = delegateCombine(c.lostFocus, runOn(this, this.onDatePickerLostFocus));
                let d = this.y;
                d.keyDown = delegateCombine(d.keyDown, runOn(this, this.onInputKeyDown));
                let e = this.y;
                e.changing = delegateCombine(e.changing, runOn(this, this.onInputChanging));
            }
        }
        detachEvents() {
            if (this.y != null) {
                let a = this.y;
                a.selectedValueChanged = delegateRemove(a.selectedValueChanged, runOn(this, this.onDatePickerValueChanged));
                let b = this.y;
                b.gotFocus = delegateRemove(b.gotFocus, runOn(this, this.onDatePickerGotFocus));
                let c = this.y;
                c.lostFocus = delegateRemove(c.lostFocus, runOn(this, this.onDatePickerLostFocus));
                let d = this.y;
                d.keyDown = delegateRemove(d.keyDown, runOn(this, this.onInputKeyDown));
                let e = this.y;
                e.changing = delegateRemove(e.changing, runOn(this, this.onInputChanging));
            }
        }
        onTargetChanged() {
            if (this.y != null) {
                this.ab = true;
                this.focus();
                this.ab = false;
            }
        }
        onEditStarted() {
            super.onEditStarted();
            if (!this.a.isEditRefocusDesired) {
                this.focus();
            }
        }
        onEditEnded() {
            super.onEditEnded();
            if (this.a.isEditRefocusDesired) {
                let a = this.h.rootWrapper.getNativeElement();
                if (a == document.activeElement || a.contains(document.activeElement)) {
                    this.focus();
                }
            }
        }
        s() {
            if (this.y != null) {
                this.y.focus(true);
                this.y.df();
            }
        }
        ag() {
            if (this.y != null) {
                this.y.cq();
            }
        }
        u(a, b, c) {
            super.u(a, b, c);
            switch (a) {
                case "FormatString":
                    this.ak();
                    break;
                case "ShowClearButton":
                    if (this.y != null) {
                        this.y.az = this.showClearButton;
                    }
                    break;
                case "ShowTodayButton":
                    if (this.y != null) {
                        this.y.a0 = this.ac;
                    }
                    break;
            }
        }
        ak() {
            this.y.by = this.ae;
        }
        w() {
            this.ab = true;
            if (this.y != null) {
                if (this.value == null) {
                    this.y.value = dateMinValue();
                }
                else {
                    this.y.value = this.value;
                }
                if (this.focusOnValueChanged) {
                    this.s();
                }
            }
            this.ab = false;
        }
        r() {
            if (this.y != null) {
                this.y.av = !this.isEnabled;
            }
        }
        v() {
            super.v();
            if (this.y != null) {
                this.y.dx = this.textColor;
            }
        }
        onDatePickerValueChanged(a, b) {
            this.am();
        }
        am() {
            if (this.ab) {
                return;
            }
            if (+(this.y.value) != +(dateMinValue())) {
                this.q(this.y.value, false);
            }
            else if (+(this.y.value) == +(dateMinValue())) {
                this.q(null, false);
            }
            else {
                this.q(this.value, false);
            }
        }
        onInputChanging(a, b) {
            this.p();
        }
        onDatePickerLostFocus(a, b) {
            this.o();
        }
        onDatePickerGotFocus(a, b) {
            this.n();
        }
        getEditorValue() {
            if (this.y != null) {
                return this.y.value;
            }
            return null;
        }
        setEditorValue(a) {
            if (this.y != null) {
                this.y.value = a != null ? a : dateMinValue();
            }
        }
    }
    DateEditorView.$t = /*@__PURE__*/ markType(DateEditorView, 'DateEditorView', BaseEditorView.$);
    return DateEditorView;
})();
