/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PivotDimension } from "./PivotDimension";
import { PivotDimensionType_$type } from "./PivotDimensionType";
/**
 * @hidden
 */
export let DimensionsChange = /*@__PURE__*/ (() => {
    class DimensionsChange extends Base {
        constructor() {
            super(...arguments);
            this.c = new WCNativeHelper();
            this.e = null;
        }
        get d() {
            return this.c;
        }
        get nativeElement() {
            return this.e;
        }
        set nativeElement(a) {
            this.e = a;
            this.c.o = this.e;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.d.m("dimensions", (a) => new PivotDimension());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.d.v("dimensions", value_);
        }
        get b() {
            let ret_ = this.d.n("dimensionCollectionType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(PivotDimensionType_$type, EnumUtil.getEnumValue(PivotDimensionType_$type, this.d.f(PivotDimensionType_$type, ret_)));
            return EnumUtil.getEnumValue(PivotDimensionType_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(PivotDimensionType_$type, a);
            value_ = this.d.f(PivotDimensionType_$type, value_);
            this.d.v("dimensionCollectionType", value_);
        }
    }
    DimensionsChange.$t = /*@__PURE__*/ markType(DimensionsChange, 'DimensionsChange');
    return DimensionsChange;
})();
