/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventArgs, markType } from "igniteui-react-core";
/**
 * @hidden
 */
export let GridActiveCellChangedEventArgs = /*@__PURE__*/ (() => {
    class GridActiveCellChangedEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._newActiveCell = null;
            this._oldActiveCell = null;
        }
        get newActiveCell() {
            return this._newActiveCell;
        }
        set newActiveCell(a) {
            this._newActiveCell = a;
        }
        get oldActiveCell() {
            return this._oldActiveCell;
        }
        set oldActiveCell(a) {
            this._oldActiveCell = a;
        }
    }
    GridActiveCellChangedEventArgs.$t = /*@__PURE__*/ markType(GridActiveCellChangedEventArgs, 'GridActiveCellChangedEventArgs', EventArgs.$);
    return GridActiveCellChangedEventArgs;
})();
