/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, enumGetBox, EnumUtil, typeGetValue } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { BaseEventArgsDetail } from "./BaseEventArgsDetail";
import { HierarchicalGridBaseDirective } from "./HierarchicalGridBaseDirective";
import { CellType } from "./CellType";
import { RowType } from "./RowType";
import { BaseElement } from "igniteui-react";
import { ActionStrip } from "./ActionStrip";
import { DataCloneStrategy } from "./DataCloneStrategy";
import { ClipboardOptions } from "./ClipboardOptions";
import { ActionStripCollection } from "./ActionStripCollection";
import { GridRowDragGhostContext } from "./GridRowDragGhostContext";
import { GridRowEditTextTemplateContext } from "./GridRowEditTextTemplateContext";
import { GridEmptyTemplateContext } from "./GridEmptyTemplateContext";
import { GridRowEditActionsTemplateContext } from "./GridRowEditActionsTemplateContext";
import { GridRowTemplateContext } from "./GridRowTemplateContext";
import { GridTemplateContext } from "./GridTemplateContext";
import { GridHeaderTemplateContext } from "./GridHeaderTemplateContext";
import { GridToolbarCollection } from "./GridToolbarCollection";
import { PaginatorCollection } from "./PaginatorCollection";
import { GridResourceStrings } from "./GridResourceStrings";
import { FilteringLogic_$type } from "./FilteringLogic";
import { FilteringExpressionsTree } from "./FilteringExpressionsTree";
import { GridPagingMode_$type } from "./GridPagingMode";
import { GridValidationTrigger_$type } from "./GridValidationTrigger";
import { PinningConfig } from "./PinningConfig";
import { FilterMode_$type } from "./FilterMode";
import { GridSummaryPosition_$type } from "./GridSummaryPosition";
import { GridSummaryCalculationMode_$type } from "./GridSummaryCalculationMode";
import { FilteringStrategy } from "./FilteringStrategy";
import { GridSortingStrategy } from "./GridSortingStrategy";
import { SortingOptions } from "./SortingOptions";
import { HeadSelectorTemplateContext } from "./HeadSelectorTemplateContext";
import { RowSelectorTemplateContext } from "./RowSelectorTemplateContext";
import { SortingExpression } from "./SortingExpression";
import { GridSelectionMode_$type } from "./GridSelectionMode";
import { ColumnCollection } from "./ColumnCollection";
import { ForOfStateEventArgs } from "./ForOfStateEventArgs";
import { FilteringExpressionsTreeEventArgs } from "./FilteringExpressionsTreeEventArgs";
import { GridScrollEventArgs } from "./GridScrollEventArgs";
import { GridCellEventArgs } from "./GridCellEventArgs";
import { GridFormGroupCreatedEventArgs } from "./GridFormGroupCreatedEventArgs";
import { GridValidationStatusEventArgs } from "./GridValidationStatusEventArgs";
import { RowSelectionEventArgs } from "./RowSelectionEventArgs";
import { ColumnSelectionEventArgs } from "./ColumnSelectionEventArgs";
import { PinColumnCancellableEventArgs } from "./PinColumnCancellableEventArgs";
import { PinColumnEventArgs } from "./PinColumnEventArgs";
import { GridEditEventArgs } from "./GridEditEventArgs";
import { GridEditDoneEventArgs } from "./GridEditDoneEventArgs";
import { ColumnComponentEventArgs } from "./ColumnComponentEventArgs";
import { ColumnsAutoGeneratedEventArgs } from "./ColumnsAutoGeneratedEventArgs";
import { SortingEventArgs } from "./SortingEventArgs";
import { SortingExpressionEventArgs } from "./SortingExpressionEventArgs";
import { FilteringEventArgs } from "./FilteringEventArgs";
import { RowDataEventArgs } from "./RowDataEventArgs";
import { ColumnResizeEventArgs } from "./ColumnResizeEventArgs";
import { ColumnVisibilityChangingEventArgs } from "./ColumnVisibilityChangingEventArgs";
import { ColumnVisibilityChangedEventArgs } from "./ColumnVisibilityChangedEventArgs";
import { ColumnMovingStartEventArgs } from "./ColumnMovingStartEventArgs";
import { ColumnMovingEventArgs } from "./ColumnMovingEventArgs";
import { ColumnMovingEndEventArgs } from "./ColumnMovingEndEventArgs";
import { GridKeydownEventArgs } from "./GridKeydownEventArgs";
import { RowDragStartEventArgs } from "./RowDragStartEventArgs";
import { RowDragEndEventArgs } from "./RowDragEndEventArgs";
import { GridClipboardEventEventArgs } from "./GridClipboardEventEventArgs";
import { RowToggleEventArgs } from "./RowToggleEventArgs";
import { PinRowEventArgs } from "./PinRowEventArgs";
import { ActiveNodeChangeEventArgs } from "./ActiveNodeChangeEventArgs";
import { GridToolbarExportEventArgs } from "./GridToolbarExportEventArgs";
import { GridSelectionRangeEventArgs } from "./GridSelectionRangeEventArgs";
import { VoidEventArgs } from "igniteui-react";
import { ForOfDataChangingEventArgs } from "./ForOfDataChangingEventArgs";
import { Column } from "./Column";
import { DropPosition_$type } from "./DropPosition";
import { GridSelectionRange } from "./GridSelectionRange";
import { CellPosition } from "./CellPosition";
import { GridToolbar } from "./GridToolbar";
import { Paginator } from "./Paginator";
import { ObservableCollection$1 } from "igniteui-react-core";
/**
 * @hidden
 */
export let GridCreatedEventArgs = /*@__PURE__*/ (() => {
    class GridCreatedEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new GridCreatedEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new GridCreatedEventArgsDetail());
                return $ret;
            })());
        }
    }
    GridCreatedEventArgs.$t = /*@__PURE__*/ markType(GridCreatedEventArgs, 'GridCreatedEventArgs');
    return GridCreatedEventArgs;
})();
/**
 * @hidden
 */
export let GridCreatedEventArgsDetail = /*@__PURE__*/ (() => {
    class GridCreatedEventArgsDetail extends BaseEventArgsDetail {
        get h() {
            let ret_ = this.b.m("owner", (a) => new RowIsland());
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.b.v("owner", value_);
        }
        get i() {
            let ret_ = this.b.n("parentID");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.b.v("parentID", value_);
        }
        get g() {
            let ret_ = this.b.m("grid", (a) => new HierarchicalGrid());
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.b.v("grid", value_);
        }
    }
    GridCreatedEventArgsDetail.$t = /*@__PURE__*/ markType(GridCreatedEventArgsDetail, 'GridCreatedEventArgsDetail', BaseEventArgsDetail.$);
    return GridCreatedEventArgsDetail;
})();
/**
 * @hidden
 */
export let HierarchicalGrid = /*@__PURE__*/ (() => {
    class HierarchicalGrid extends HierarchicalGridBaseDirective {
        get g6() {
            let ret_ = this.d.l("childLayoutList", (a) => new RowIslandCollection(), (a) => new RowIsland(), ["RowIsland"]);
            return ret_;
        }
        get he() {
            let ret_ = this.d.n("id");
            return ret_;
        }
        set he(a) {
            let value_ = a;
            this.d.v("id", value_);
        }
        get g2() {
            let ret_ = this.d.n("data");
            return ret_;
        }
        set g2(a) {
            let value_ = a;
            this.d.v("data", value_);
        }
        get hc() {
            let ret_ = this.d.n("totalItemCount");
            return ret_;
        }
        set hc(a) {
            let value_ = a;
            this.d.v("totalItemCount", value_);
        }
        get g9() {
            let ret_ = this.d.n("expandChildren");
            return ret_;
        }
        set g9(a) {
            let value_ = a;
            this.d.v("expandChildren", value_);
        }
        get hd() {
            let ret_ = this.d.n("foreignKey");
            return ret_;
        }
        get g3() {
            let ret_ = this.d.m("selectedCells", (a) => new CellType());
            return ret_;
        }
        g7(a) {
            return this.d.g(this.nativeElement.getRowByIndex(this.d.i(a)), (b) => new RowType());
        }
        g8(a) {
            return this.d.g(this.nativeElement.getRowByKey(this.d.i(a)), (b) => new RowType());
        }
        g4(a, b) {
            return this.d.g(this.nativeElement.getCellByColumn(this.d.i(a), this.d.i(b)), (c) => new CellType());
        }
        g5(a, b) {
            return this.d.g(this.nativeElement.getCellByKey(this.d.i(a), this.d.i(b)), (c) => new CellType());
        }
        ha(a, b = -1) {
            return (this.nativeElement.pinRow(this.d.i(a), this.d.i(b)));
        }
        hb(a) {
            return (this.nativeElement.unpinRow(this.d.i(a)));
        }
        hf(a) {
            this.nativeElement.getDefaultExpandState(this.d.i(a));
        }
    }
    HierarchicalGrid.$t = /*@__PURE__*/ markType(HierarchicalGrid, 'HierarchicalGrid', HierarchicalGridBaseDirective.$);
    return HierarchicalGrid;
})();
/**
 * @hidden
 */
export let RowIsland = /*@__PURE__*/ (() => {
    class RowIsland extends BaseElement {
        constructor() {
            super(...arguments);
            this.bz = new WCNativeHelper();
            this.co = null;
            this.cx = null;
            this.cu = null;
            this.c2 = null;
            this.cv = null;
            this.c6 = null;
            this.c3 = null;
            this.c5 = null;
            this.c7 = null;
            this.c4 = null;
            this.c0 = null;
            this.cz = null;
            this.cy = null;
            this.c9 = null;
            this.da = null;
            this.db = null;
            this.c1 = null;
            this.c8 = null;
            this.cw = null;
            this.gridCreated = null;
            this.gridInitialized = null;
            this.dataPreLoad = null;
            this.filteringExpressionsTreeChange = null;
            this.advancedFilteringExpressionsTreeChange = null;
            this.gridScroll = null;
            this.cellClick = null;
            this.formGroupCreated = null;
            this.validationStatusChange = null;
            this.selected = null;
            this.rowSelectionChanging = null;
            this.columnSelectionChanging = null;
            this.columnPin = null;
            this.columnPinned = null;
            this.cellEditEnter = null;
            this.cellEditExit = null;
            this.cellEdit = null;
            this.cellEditDone = null;
            this.rowEditEnter = null;
            this.rowEdit = null;
            this.rowEditDone = null;
            this.rowEditExit = null;
            this.columnInit = null;
            this.columnsAutogenerated = null;
            this.sorting = null;
            this.sortingDone = null;
            this.filtering = null;
            this.filteringDone = null;
            this.rowAdded = null;
            this.rowDeleted = null;
            this.rowDelete = null;
            this.rowAdd = null;
            this.columnResized = null;
            this.contextMenu = null;
            this.doubleClick = null;
            this.columnVisibilityChanging = null;
            this.columnVisibilityChanged = null;
            this.columnMovingStart = null;
            this.columnMoving = null;
            this.columnMovingEnd = null;
            this.gridKeydown = null;
            this.rowDragStart = null;
            this.rowDragEnd = null;
            this.gridCopy = null;
            this.rowToggle = null;
            this.rowPinning = null;
            this.rowPinned = null;
            this.activeNodeChange = null;
            this.sortingExpressionsChange = null;
            this.toolbarExporting = null;
            this.rangeSelected = null;
            this.rendered = null;
            this.dataChanging = null;
            this.dataChanged = null;
        }
        get b0() {
            return this.bz;
        }
        get nativeElement() {
            return this.co;
        }
        set nativeElement(a) {
            this.co = a;
            this.bz.o = this.co;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get dv() {
            let ret_ = this.b0.n("childDataKey");
            return ret_;
        }
        set dv(a) {
            let value_ = a;
            this.b0.v("childDataKey", value_);
        }
        get bq() {
            let ret_ = this.b0.l("childLayoutList", (a) => new RowIslandCollection(), (a) => new RowIsland(), ["RowIsland"]);
            return ret_;
        }
        get b() {
            let ret_ = this.b0.n("data");
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.b0.v("data", value_);
        }
        get b5() {
            let ret_ = this.b0.n("expandChildren");
            return ret_;
        }
        set b5(a) {
            let value_ = a;
            this.b0.v("expandChildren", value_);
        }
        get d0() {
            let ret_ = this.b0.n("hasChildrenKey");
            return ret_;
        }
        set d0(a) {
            let value_ = a;
            this.b0.v("hasChildrenKey", value_);
        }
        get ce() {
            let ret_ = this.b0.n("showExpandAll");
            return ret_;
        }
        set ce(a) {
            let value_ = a;
            this.b0.v("showExpandAll", value_);
        }
        get b4() {
            let ret_ = this.b0.n("batchEditing");
            return ret_;
        }
        set b4(a) {
            let value_ = a;
            this.b0.v("batchEditing", value_);
        }
        get cl() {
            let ret_ = this.b0.n("snackbarDisplayTime");
            return ret_;
        }
        set cl(a) {
            let value_ = a;
            this.b0.v("snackbarDisplayTime", value_);
        }
        get b3() {
            let ret_ = this.b0.n("autoGenerate");
            return ret_;
        }
        set b3(a) {
            let value_ = a;
            this.b0.v("autoGenerate", value_);
        }
        get a() {
            let ret_ = this.b0.n("autoGenerateExclude");
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.b0.v("autoGenerateExclude", value_);
        }
        get b8() {
            let ret_ = this.b0.n("moving");
            return ret_;
        }
        set b8(a) {
            let value_ = a;
            this.b0.v("moving", value_);
        }
        get df() {
            return this.cx;
        }
        set df(a) {
            this.cx = a;
            this.b0.s("emptyGridTemplate", (b) => b, this.cx);
        }
        get dc() {
            return this.cu;
        }
        set dc(a) {
            this.cu = a;
            this.b0.s("addRowEmptyTemplate", (b) => b, this.cu);
        }
        get dk() {
            return this.c2;
        }
        set dk(a) {
            this.c2 = a;
            this.b0.s("loadingGridTemplate", (b) => b, this.c2);
        }
        get cm() {
            let ret_ = this.b0.n("summaryRowHeight");
            return ret_;
        }
        set cm(a) {
            let value_ = a;
            this.b0.v("summaryRowHeight", value_);
        }
        get x() {
            let ret_ = this.b0.m("dataCloneStrategy", (a) => new DataCloneStrategy());
            return ret_;
        }
        set x(a) {
            let value_ = a;
            this.b0.v("dataCloneStrategy", value_);
        }
        get k() {
            let ret_ = this.b0.m("clipboardOptions", (a) => new ClipboardOptions());
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.b0.v("clipboardOptions", value_);
        }
        get cs() {
            let ret_ = this.b0.n("rowClasses");
            return ret_;
        }
        set cs(a) {
            let value_ = a;
            this.b0.v("rowClasses", value_);
        }
        get ct() {
            let ret_ = this.b0.n("rowStyles");
            return ret_;
        }
        set ct(a) {
            let value_ = a;
            this.b0.v("rowStyles", value_);
        }
        get d3() {
            let ret_ = this.b0.n("primaryKey");
            return ret_;
        }
        set d3(a) {
            let value_ = a;
            this.b0.v("primaryKey", value_);
        }
        get g() {
            let ret_ = this.b0.l("actionStripComponents", (a) => new ActionStripCollection(), (a) => new ActionStrip(), ["ActionStrip"]);
            return ret_;
        }
        get dd() {
            return this.cv;
        }
        set dd(a) {
            this.cv = a;
            this.b0.s("dragGhostCustomTemplate", (b) => new GridRowDragGhostContext(), this.cv);
        }
        get dp() {
            return this.c6;
        }
        set dp(a) {
            this.c6 = a;
            this.b0.s("rowEditTextTemplate", (b) => new GridRowEditTextTemplateContext(), this.c6);
        }
        get dl() {
            return this.c3;
        }
        set dl(a) {
            this.c3 = a;
            this.b0.s("rowAddTextTemplate", (b) => new GridEmptyTemplateContext(), this.c3);
        }
        get dn() {
            return this.c5;
        }
        set dn(a) {
            this.c5 = a;
            this.b0.s("rowEditActionsTemplate", (b) => new GridRowEditActionsTemplateContext(), this.c5);
        }
        get dq() {
            return this.c7;
        }
        set dq(a) {
            this.c7 = a;
            this.b0.s("rowExpandedIndicatorTemplate", (b) => new GridRowTemplateContext(), this.c7);
        }
        get dm() {
            return this.c4;
        }
        set dm(a) {
            this.c4 = a;
            this.b0.s("rowCollapsedIndicatorTemplate", (b) => new GridRowTemplateContext(), this.c4);
        }
        get di() {
            return this.c0;
        }
        set di(a) {
            this.c0 = a;
            this.b0.s("headerExpandedIndicatorTemplate", (b) => new GridTemplateContext(), this.c0);
        }
        get dh() {
            return this.cz;
        }
        set dh(a) {
            this.cz = a;
            this.b0.s("headerCollapsedIndicatorTemplate", (b) => new GridTemplateContext(), this.cz);
        }
        get dg() {
            return this.cy;
        }
        set dg(a) {
            this.cy = a;
            this.b0.s("excelStyleHeaderIconTemplate", (b) => new GridHeaderTemplateContext(), this.cy);
        }
        get ds() {
            return this.c9;
        }
        set ds(a) {
            this.c9 = a;
            this.b0.s("sortAscendingHeaderIconTemplate", (b) => new GridHeaderTemplateContext(), this.c9);
        }
        get dt() {
            return this.da;
        }
        set dt(a) {
            this.da = a;
            this.b0.s("sortDescendingHeaderIconTemplate", (b) => new GridHeaderTemplateContext(), this.da);
        }
        get du() {
            return this.db;
        }
        set du(a) {
            this.db = a;
            this.b0.s("sortHeaderIconTemplate", (b) => new GridHeaderTemplateContext(), this.db);
        }
        get bc() {
            let ret_ = this.b0.l("toolbar", (a) => new GridToolbarCollection(), (a) => new GridToolbar(), ["GridToolbar"]);
            return ret_;
        }
        get bg() {
            let ret_ = this.b0.l("paginationComponents", (a) => new PaginatorCollection(), (a) => new Paginator(), ["Paginator"]);
            return ret_;
        }
        get a3() {
            let ret_ = this.b0.m("resourceStrings", (a) => new GridResourceStrings());
            return ret_;
        }
        set a3(a) {
            let value_ = a;
            this.b0.v("resourceStrings", value_);
        }
        get ae() {
            let ret_ = this.b0.n("filteringLogic");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilteringLogic_$type, EnumUtil.getEnumValue(FilteringLogic_$type, this.b0.f(FilteringLogic_$type, ret_)));
            return EnumUtil.getEnumValue(FilteringLogic_$type, ret_);
        }
        set ae(a) {
            let value_ = enumGetBox(FilteringLogic_$type, a);
            value_ = this.b0.f(FilteringLogic_$type, value_);
            this.b0.v("filteringLogic", value_);
        }
        get aa() {
            let ret_ = this.b0.m("filteringExpressionsTree", (a) => new FilteringExpressionsTree());
            return ret_;
        }
        set aa(a) {
            let value_ = a;
            this.b0.v("filteringExpressionsTree", value_);
        }
        get z() {
            let ret_ = this.b0.m("advancedFilteringExpressionsTree", (a) => new FilteringExpressionsTree());
            return ret_;
        }
        set z(a) {
            let value_ = a;
            this.b0.v("advancedFilteringExpressionsTree", value_);
        }
        get d1() {
            let ret_ = this.b0.n("locale");
            return ret_;
        }
        set d1(a) {
            let value_ = a;
            this.b0.v("locale", value_);
        }
        get a2() {
            let ret_ = this.b0.n("pagingMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridPagingMode_$type, EnumUtil.getEnumValue(GridPagingMode_$type, this.b0.f(GridPagingMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridPagingMode_$type, ret_);
        }
        set a2(a) {
            let value_ = enumGetBox(GridPagingMode_$type, a);
            value_ = this.b0.f(GridPagingMode_$type, value_);
            this.b0.v("pagingMode", value_);
        }
        get b6() {
            let ret_ = this.b0.n("hideRowSelectors");
            return ret_;
        }
        set b6(a) {
            let value_ = a;
            this.b0.v("hideRowSelectors", value_);
        }
        get ca() {
            let ret_ = this.b0.n("rowDraggable");
            return ret_;
        }
        set ca(a) {
            let value_ = a;
            this.b0.v("rowDraggable", value_);
        }
        get bf() {
            let ret_ = this.b0.n("validationTrigger");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridValidationTrigger_$type, EnumUtil.getEnumValue(GridValidationTrigger_$type, this.b0.f(GridValidationTrigger_$type, ret_)));
            return EnumUtil.getEnumValue(GridValidationTrigger_$type, ret_);
        }
        set bf(a) {
            let value_ = enumGetBox(GridValidationTrigger_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("validationTrigger", value_);
        }
        get cb() {
            let ret_ = this.b0.n("rowEditable");
            return ret_;
        }
        set cb(a) {
            let value_ = a;
            this.b0.v("rowEditable", value_);
        }
        get ck() {
            let ret_ = this.b0.n("rowHeight");
            return ret_;
        }
        set ck(a) {
            let value_ = a;
            this.b0.v("rowHeight", value_);
        }
        get dw() {
            let ret_ = this.b0.n("columnWidth");
            return ret_;
        }
        set dw(a) {
            let value_ = a;
            this.b0.v("columnWidth", value_);
        }
        get dy() {
            let ret_ = this.b0.n("emptyGridMessage");
            return ret_;
        }
        set dy(a) {
            let value_ = a;
            this.b0.v("emptyGridMessage", value_);
        }
        get b7() {
            let ret_ = this.b0.n("isLoading");
            return ret_;
        }
        set b7(a) {
            let value_ = a;
            this.b0.v("isLoading", value_);
        }
        get cd() {
            let ret_ = this.b0.n("shouldGenerate");
            return ret_;
        }
        set cd(a) {
            let value_ = a;
            this.b0.v("shouldGenerate", value_);
        }
        get dx() {
            let ret_ = this.b0.n("emptyFilteredGridMessage");
            return ret_;
        }
        set dx(a) {
            let value_ = a;
            this.b0.v("emptyFilteredGridMessage", value_);
        }
        get bj() {
            let ret_ = this.b0.m("pinning", (a) => new PinningConfig());
            return ret_;
        }
        set bj(a) {
            let value_ = a;
            this.b0.v("pinning", value_);
        }
        get b2() {
            let ret_ = this.b0.n("allowFiltering");
            return ret_;
        }
        set b2(a) {
            let value_ = a;
            this.b0.v("allowFiltering", value_);
        }
        get b1() {
            let ret_ = this.b0.n("allowAdvancedFiltering");
            return ret_;
        }
        set b1(a) {
            let value_ = a;
            this.b0.v("allowAdvancedFiltering", value_);
        }
        get ag() {
            let ret_ = this.b0.n("filterMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilterMode_$type, EnumUtil.getEnumValue(FilterMode_$type, this.b0.f(FilterMode_$type, ret_)));
            return EnumUtil.getEnumValue(FilterMode_$type, ret_);
        }
        set ag(a) {
            let value_ = enumGetBox(FilterMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("filterMode", value_);
        }
        get bb() {
            let ret_ = this.b0.n("summaryPosition");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSummaryPosition_$type, EnumUtil.getEnumValue(GridSummaryPosition_$type, this.b0.f(GridSummaryPosition_$type, ret_)));
            return EnumUtil.getEnumValue(GridSummaryPosition_$type, ret_);
        }
        set bb(a) {
            let value_ = enumGetBox(GridSummaryPosition_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("summaryPosition", value_);
        }
        get ba() {
            let ret_ = this.b0.n("summaryCalculationMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSummaryCalculationMode_$type, EnumUtil.getEnumValue(GridSummaryCalculationMode_$type, this.b0.f(GridSummaryCalculationMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSummaryCalculationMode_$type, ret_);
        }
        set ba(a) {
            let value_ = enumGetBox(GridSummaryCalculationMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("summaryCalculationMode", value_);
        }
        get cf() {
            let ret_ = this.b0.n("showSummaryOnCollapse");
            return ret_;
        }
        set cf(a) {
            let value_ = a;
            this.b0.v("showSummaryOnCollapse", value_);
        }
        get af() {
            let ret_ = this.b0.m("filterStrategy", (a) => new FilteringStrategy());
            return ret_;
        }
        set af(a) {
            let value_ = a;
            this.b0.v("filterStrategy", value_);
        }
        get a9() {
            let ret_ = this.b0.m("sortStrategy", (a) => new GridSortingStrategy());
            return ret_;
        }
        set a9(a) {
            let value_ = a;
            this.b0.v("sortStrategy", value_);
        }
        get bw() {
            let ret_ = this.b0.m("sortingOptions", (a) => new SortingOptions());
            return ret_;
        }
        set bw(a) {
            let value_ = a;
            this.b0.v("sortingOptions", value_);
        }
        get e() {
            let ret_ = this.b0.n("selectedRows");
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.b0.v("selectedRows", value_);
        }
        get dj() {
            return this.c1;
        }
        set dj(a) {
            this.c1 = a;
            this.b0.s("headSelectorTemplate", (b) => new HeadSelectorTemplateContext(), this.c1);
        }
        get dr() {
            return this.c8;
        }
        set dr(a) {
            this.c8 = a;
            this.b0.s("rowSelectorTemplate", (b) => new RowSelectorTemplateContext(), this.c8);
        }
        get de() {
            return this.cw;
        }
        set de(a) {
            this.cw = a;
            this.b0.s("dragIndicatorIconTemplate", (b) => new GridEmptyTemplateContext(), this.cw);
        }
        get f() {
            let ret_ = this.b0.m("sortingExpressions", (a) => new SortingExpression());
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.b0.v("sortingExpressions", value_);
        }
        get a5() {
            let ret_ = this.b0.n("cellSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.b0.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        }
        set a5(a) {
            let value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("cellSelection", value_);
        }
        get a7() {
            let ret_ = this.b0.n("rowSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.b0.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        }
        set a7(a) {
            let value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("rowSelection", value_);
        }
        get a6() {
            let ret_ = this.b0.n("columnSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.b0.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        }
        set a6(a) {
            let value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("columnSelection", value_);
        }
        get n() {
            let ret_ = this.b0.l("columns", (a) => new ColumnCollection(), (a) => new Column(), ["Column", "ColumnGroup", "ColumnLayout"]);
            return ret_;
        }
        get cn() {
            let ret_ = this.b0.n("totalRecords");
            return ret_;
        }
        set cn(a) {
            let value_ = a;
            this.b0.v("totalRecords", value_);
        }
        get cc() {
            let ret_ = this.b0.n("selectRowOnClick");
            return ret_;
        }
        set cc(a) {
            let value_ = a;
            this.b0.v("selectRowOnClick", value_);
        }
        gridCreatedChanged() {
            if (this.gridCreated != null) {
                this.b0.r("gridCreated", (a) => this.gridCreated(this, GridCreatedEventArgs.a(a)), false);
            }
            else {
                this.b0.u("gridCreated");
            }
        }
        gridInitializedChanged() {
            if (this.gridInitialized != null) {
                this.b0.r("gridInitialized", (a) => this.gridInitialized(this, GridCreatedEventArgs.a(a)), false);
            }
            else {
                this.b0.u("gridInitialized");
            }
        }
        dataPreLoadChanged() {
            if (this.dataPreLoad != null) {
                this.b0.r("dataPreLoad", (a) => this.dataPreLoad(this, ForOfStateEventArgs.b(a)), false);
            }
            else {
                this.b0.u("dataPreLoad");
            }
        }
        filteringExpressionsTreeChangeChanged() {
            if (this.filteringExpressionsTreeChange != null) {
                this.b0.r("filteringExpressionsTreeChange", (a) => this.filteringExpressionsTreeChange(this, FilteringExpressionsTreeEventArgs.b(a)), false);
            }
            else {
                this.b0.u("filteringExpressionsTreeChange");
            }
        }
        advancedFilteringExpressionsTreeChangeChanged() {
            if (this.advancedFilteringExpressionsTreeChange != null) {
                this.b0.r("advancedFilteringExpressionsTreeChange", (a) => this.advancedFilteringExpressionsTreeChange(this, FilteringExpressionsTreeEventArgs.b(a)), false);
            }
            else {
                this.b0.u("advancedFilteringExpressionsTreeChange");
            }
        }
        gridScrollChanged() {
            if (this.gridScroll != null) {
                this.b0.r("gridScroll", (a) => this.gridScroll(this, GridScrollEventArgs.a(a)), false);
            }
            else {
                this.b0.u("gridScroll");
            }
        }
        cellClickChanged() {
            if (this.cellClick != null) {
                this.b0.r("cellClick", (a) => this.cellClick(this, GridCellEventArgs.a(a)), false);
            }
            else {
                this.b0.u("cellClick");
            }
        }
        formGroupCreatedChanged() {
            if (this.formGroupCreated != null) {
                this.b0.r("formGroupCreated", (a) => this.formGroupCreated(this, GridFormGroupCreatedEventArgs.a(a)), false);
            }
            else {
                this.b0.u("formGroupCreated");
            }
        }
        validationStatusChangeChanged() {
            if (this.validationStatusChange != null) {
                this.b0.r("validationStatusChange", (a) => this.validationStatusChange(this, GridValidationStatusEventArgs.a(a)), false);
            }
            else {
                this.b0.u("validationStatusChange");
            }
        }
        selectedChanged() {
            if (this.selected != null) {
                this.b0.r("selected", (a) => this.selected(this, GridCellEventArgs.a(a)), false);
            }
            else {
                this.b0.u("selected");
            }
        }
        rowSelectionChangingChanged() {
            if (this.rowSelectionChanging != null) {
                this.b0.r("rowSelectionChanging", (a) => this.rowSelectionChanging(this, RowSelectionEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowSelectionChanging");
            }
        }
        columnSelectionChangingChanged() {
            if (this.columnSelectionChanging != null) {
                this.b0.r("columnSelectionChanging", (a) => this.columnSelectionChanging(this, ColumnSelectionEventArgs.a(a)), false);
            }
            else {
                this.b0.u("columnSelectionChanging");
            }
        }
        columnPinChanged() {
            if (this.columnPin != null) {
                this.b0.r("columnPin", (a) => this.columnPin(this, PinColumnCancellableEventArgs.a(a)), false);
            }
            else {
                this.b0.u("columnPin");
            }
        }
        columnPinnedChanged() {
            if (this.columnPinned != null) {
                this.b0.r("columnPinned", (a) => this.columnPinned(this, PinColumnEventArgs.a(a)), false);
            }
            else {
                this.b0.u("columnPinned");
            }
        }
        cellEditEnterChanged() {
            if (this.cellEditEnter != null) {
                this.b0.r("cellEditEnter", (a) => this.cellEditEnter(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.b0.u("cellEditEnter");
            }
        }
        cellEditExitChanged() {
            if (this.cellEditExit != null) {
                this.b0.r("cellEditExit", (a) => this.cellEditExit(this, GridEditDoneEventArgs.a(a)), false);
            }
            else {
                this.b0.u("cellEditExit");
            }
        }
        cellEditChanged() {
            if (this.cellEdit != null) {
                this.b0.r("cellEdit", (a) => this.cellEdit(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.b0.u("cellEdit");
            }
        }
        cellEditDoneChanged() {
            if (this.cellEditDone != null) {
                this.b0.r("cellEditDone", (a) => this.cellEditDone(this, GridEditDoneEventArgs.a(a)), false);
            }
            else {
                this.b0.u("cellEditDone");
            }
        }
        rowEditEnterChanged() {
            if (this.rowEditEnter != null) {
                this.b0.r("rowEditEnter", (a) => this.rowEditEnter(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowEditEnter");
            }
        }
        rowEditChanged() {
            if (this.rowEdit != null) {
                this.b0.r("rowEdit", (a) => this.rowEdit(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowEdit");
            }
        }
        rowEditDoneChanged() {
            if (this.rowEditDone != null) {
                this.b0.r("rowEditDone", (a) => this.rowEditDone(this, GridEditDoneEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowEditDone");
            }
        }
        rowEditExitChanged() {
            if (this.rowEditExit != null) {
                this.b0.r("rowEditExit", (a) => this.rowEditExit(this, GridEditDoneEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowEditExit");
            }
        }
        columnInitChanged() {
            if (this.columnInit != null) {
                this.b0.r("columnInit", (a) => this.columnInit(this, ColumnComponentEventArgs.b(a)), false);
            }
            else {
                this.b0.u("columnInit");
            }
        }
        columnsAutogeneratedChanged() {
            if (this.columnsAutogenerated != null) {
                this.b0.r("columnsAutogenerated", (a) => this.columnsAutogenerated(this, ColumnsAutoGeneratedEventArgs.a(a)), false);
            }
            else {
                this.b0.u("columnsAutogenerated");
            }
        }
        sortingChanged() {
            if (this.sorting != null) {
                this.b0.r("sorting", (a) => this.sorting(this, SortingEventArgs.a(a)), false);
            }
            else {
                this.b0.u("sorting");
            }
        }
        sortingDoneChanged() {
            if (this.sortingDone != null) {
                this.b0.r("sortingDone", (a) => this.sortingDone(this, SortingExpressionEventArgs.b(a)), false);
            }
            else {
                this.b0.u("sortingDone");
            }
        }
        filteringChanged() {
            if (this.filtering != null) {
                this.b0.r("filtering", (a) => this.filtering(this, FilteringEventArgs.a(a)), false);
            }
            else {
                this.b0.u("filtering");
            }
        }
        filteringDoneChanged() {
            if (this.filteringDone != null) {
                this.b0.r("filteringDone", (a) => this.filteringDone(this, FilteringExpressionsTreeEventArgs.b(a)), false);
            }
            else {
                this.b0.u("filteringDone");
            }
        }
        rowAddedChanged() {
            if (this.rowAdded != null) {
                this.b0.r("rowAdded", (a) => this.rowAdded(this, RowDataEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowAdded");
            }
        }
        rowDeletedChanged() {
            if (this.rowDeleted != null) {
                this.b0.r("rowDeleted", (a) => this.rowDeleted(this, RowDataEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowDeleted");
            }
        }
        rowDeleteChanged() {
            if (this.rowDelete != null) {
                this.b0.r("rowDelete", (a) => this.rowDelete(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowDelete");
            }
        }
        rowAddChanged() {
            if (this.rowAdd != null) {
                this.b0.r("rowAdd", (a) => this.rowAdd(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowAdd");
            }
        }
        columnResizedChanged() {
            if (this.columnResized != null) {
                this.b0.r("columnResized", (a) => this.columnResized(this, ColumnResizeEventArgs.a(a)), false);
            }
            else {
                this.b0.u("columnResized");
            }
        }
        contextMenuChanged() {
            if (this.contextMenu != null) {
                this.b0.r("contextMenu", (a) => this.contextMenu(this, GridCellEventArgs.a(a)), false);
            }
            else {
                this.b0.u("contextMenu");
            }
        }
        doubleClickChanged() {
            if (this.doubleClick != null) {
                this.b0.r("doubleClick", (a) => this.doubleClick(this, GridCellEventArgs.a(a)), false);
            }
            else {
                this.b0.u("doubleClick");
            }
        }
        columnVisibilityChangingChanged() {
            if (this.columnVisibilityChanging != null) {
                this.b0.r("columnVisibilityChanging", (a) => this.columnVisibilityChanging(this, ColumnVisibilityChangingEventArgs.a(a)), false);
            }
            else {
                this.b0.u("columnVisibilityChanging");
            }
        }
        columnVisibilityChangedChanged() {
            if (this.columnVisibilityChanged != null) {
                this.b0.r("columnVisibilityChanged", (a) => this.columnVisibilityChanged(this, ColumnVisibilityChangedEventArgs.a(a)), false);
            }
            else {
                this.b0.u("columnVisibilityChanged");
            }
        }
        columnMovingStartChanged() {
            if (this.columnMovingStart != null) {
                this.b0.r("columnMovingStart", (a) => this.columnMovingStart(this, ColumnMovingStartEventArgs.a(a)), false);
            }
            else {
                this.b0.u("columnMovingStart");
            }
        }
        columnMovingChanged() {
            if (this.columnMoving != null) {
                this.b0.r("columnMoving", (a) => this.columnMoving(this, ColumnMovingEventArgs.a(a)), false);
            }
            else {
                this.b0.u("columnMoving");
            }
        }
        columnMovingEndChanged() {
            if (this.columnMovingEnd != null) {
                this.b0.r("columnMovingEnd", (a) => this.columnMovingEnd(this, ColumnMovingEndEventArgs.a(a)), false);
            }
            else {
                this.b0.u("columnMovingEnd");
            }
        }
        gridKeydownChanged() {
            if (this.gridKeydown != null) {
                this.b0.r("gridKeydown", (a) => this.gridKeydown(this, GridKeydownEventArgs.a(a)), false);
            }
            else {
                this.b0.u("gridKeydown");
            }
        }
        rowDragStartChanged() {
            if (this.rowDragStart != null) {
                this.b0.r("rowDragStart", (a) => this.rowDragStart(this, RowDragStartEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowDragStart");
            }
        }
        rowDragEndChanged() {
            if (this.rowDragEnd != null) {
                this.b0.r("rowDragEnd", (a) => this.rowDragEnd(this, RowDragEndEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowDragEnd");
            }
        }
        gridCopyChanged() {
            if (this.gridCopy != null) {
                this.b0.r("gridCopy", (a) => this.gridCopy(this, GridClipboardEventEventArgs.b(a)), false);
            }
            else {
                this.b0.u("gridCopy");
            }
        }
        rowToggleChanged() {
            if (this.rowToggle != null) {
                this.b0.r("rowToggle", (a) => this.rowToggle(this, RowToggleEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowToggle");
            }
        }
        rowPinningChanged() {
            if (this.rowPinning != null) {
                this.b0.r("rowPinning", (a) => this.rowPinning(this, PinRowEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowPinning");
            }
        }
        rowPinnedChanged() {
            if (this.rowPinned != null) {
                this.b0.r("rowPinned", (a) => this.rowPinned(this, PinRowEventArgs.a(a)), false);
            }
            else {
                this.b0.u("rowPinned");
            }
        }
        activeNodeChangeChanged() {
            if (this.activeNodeChange != null) {
                this.b0.r("activeNodeChange", (a) => this.activeNodeChange(this, ActiveNodeChangeEventArgs.a(a)), false);
            }
            else {
                this.b0.u("activeNodeChange");
            }
        }
        sortingExpressionsChangeChanged() {
            if (this.sortingExpressionsChange != null) {
                this.b0.r("sortingExpressionsChange", (a) => this.sortingExpressionsChange(this, SortingExpressionEventArgs.b(a)), false);
            }
            else {
                this.b0.u("sortingExpressionsChange");
            }
        }
        toolbarExportingChanged() {
            if (this.toolbarExporting != null) {
                this.b0.r("toolbarExporting", (a) => this.toolbarExporting(this, GridToolbarExportEventArgs.a(a)), false);
            }
            else {
                this.b0.u("toolbarExporting");
            }
        }
        rangeSelectedChanged() {
            if (this.rangeSelected != null) {
                this.b0.r("rangeSelected", (a) => this.rangeSelected(this, GridSelectionRangeEventArgs.b(a)), false);
            }
            else {
                this.b0.u("rangeSelected");
            }
        }
        renderedChanged() {
            if (this.rendered != null) {
                this.b0.r("rendered", (a) => this.rendered(this, VoidEventArgs.b(a)), false);
            }
            else {
                this.b0.u("rendered");
            }
        }
        dataChangingChanged() {
            if (this.dataChanging != null) {
                this.b0.r("dataChanging", (a) => this.dataChanging(this, ForOfDataChangingEventArgs.a(a)), false);
            }
            else {
                this.b0.u("dataChanging");
            }
        }
        dataChangedChanged() {
            if (this.dataChanged != null) {
                this.b0.r("dataChanged", (a) => this.dataChanged(this, VoidEventArgs.b(a)), false);
            }
            else {
                this.b0.u("dataChanged");
            }
        }
        fm(a) {
            this.nativeElement.isRecordPinnedByIndex(this.b0.i(a));
        }
        gj(a) {
            this.nativeElement.toggleColumnVisibility(this.b0.i(a));
        }
        e6() {
            this.nativeElement.expandAll();
        }
        eh() {
            this.nativeElement.collapseAll();
        }
        e7(a) {
            this.nativeElement.expandRow(this.b0.i(a));
        }
        ei(a) {
            this.nativeElement.collapseRow(this.b0.i(a));
        }
        gk(a) {
            this.nativeElement.toggleRow(this.b0.i(a));
        }
        dz(a) {
            return (this.nativeElement.getHeaderGroupWidth(this.b0.i(a)));
        }
        l(a) {
            return this.b0.g(this.nativeElement.getColumnByName(this.b0.i(a)), (b) => new Column());
        }
        m(a) {
            return this.b0.g(this.nativeElement.getColumnByVisibleIndex(this.b0.i(a)), (b) => new Column());
        }
        fs() {
            this.nativeElement.recalculateAutoSizes();
        }
        fo(a, b, c) {
            this.nativeElement.moveColumn(this.b0.i(a), this.b0.i(b), this.b0.i(typeGetValue(this.b0.f(DropPosition_$type, c))));
        }
        fn() {
            this.nativeElement.markForCheck();
        }
        cp(a) {
            return (this.nativeElement.deleteRow(this.b0.i(a)));
        }
        gm(a, b, c) {
            this.nativeElement.updateCell(this.b0.i(a), this.b0.i(b), this.b0.i(c));
        }
        gn(a, b) {
            this.nativeElement.updateRow(this.b0.i(a), this.b0.i(b));
        }
        cq(a) {
            return (this.nativeElement.getRowData(this.b0.i(a)));
        }
        gf(a) {
            this.nativeElement.sort(this.b0.i(a));
        }
        e8(a, b, c, d = false) {
            this.nativeElement.filter(this.b0.i(a), this.b0.i(b), this.b0.i(c), this.b0.i(d));
        }
        e9(a, b, c) {
            this.nativeElement.filterGlobal(this.b0.i(a), this.b0.i(b), this.b0.i(c));
        }
        e4(a) {
            this.nativeElement.enableSummaries(this.b0.i(a));
        }
        e2(a) {
            this.nativeElement.disableSummaries(this.b0.i(a));
        }
        ed(a) {
            this.nativeElement.clearFilter(this.b0.i(a));
        }
        ef(a) {
            this.nativeElement.clearSort(this.b0.i(a));
        }
        b9(a, b) {
            return (this.nativeElement.pinColumn(this.b0.i(a), this.b0.i(b)));
        }
        cg(a, b) {
            return (this.nativeElement.unpinColumn(this.b0.i(a), this.b0.i(b)));
        }
        ch(a, b = false, c = false) {
            return (this.nativeElement.findNext(this.b0.i(a), this.b0.i(b), this.b0.i(c)));
        }
        ci(a, b = false, c = false) {
            return (this.nativeElement.findPrev(this.b0.i(a), this.b0.i(b), this.b0.i(c)));
        }
        cj(a = false, b = false) {
            return (this.nativeElement.refreshSearch(this.b0.i(a), this.b0.i(b)));
        }
        ee() {
            this.nativeElement.clearSearch();
        }
        fe(a = false) {
            this.nativeElement.getPinnedWidth(this.b0.i(a));
        }
        gd(a, b = false) {
            this.nativeElement.selectRows(this.b0.i(a), this.b0.i(b));
        }
        e1(a) {
            this.nativeElement.deselectRows(this.b0.i(a));
        }
        f9(a = false) {
            this.nativeElement.selectAllRows(this.b0.i(a));
        }
        ez(a = false) {
            this.nativeElement.deselectAllRows(this.b0.i(a));
        }
        ec() {
            this.nativeElement.clearCellSelection();
        }
        gc(a) {
            this.nativeElement.selectRange(this.b0.i(a));
        }
        c() {
            return this.b0.g(this.nativeElement.getSelectedRanges(), (a) => new GridSelectionRange());
        }
        fg(a = false, b = false) {
            this.nativeElement.getSelectedData(this.b0.i(a), this.b0.i(b));
        }
        d() {
            return this.b0.g(this.nativeElement.selectedColumns(), (a) => new Column());
        }
        ga(a, b = false) {
            this.nativeElement.selectColumns(this.b0.i(a), this.b0.i(b));
        }
        e0(a) {
            this.nativeElement.deselectColumns(this.b0.i(a));
        }
        ey() {
            this.nativeElement.deselectAllColumns();
        }
        f8() {
            this.nativeElement.selectAllColumns();
        }
        ff(a = false, b = false) {
            this.nativeElement.getSelectedColumnsData(this.b0.i(a), this.b0.i(b));
        }
        fp(a, b, c) {
            this.nativeElement.navigateTo(this.b0.i(a), this.b0.i(b), this.b0.i(c));
        }
        i(a, b, c) {
            return this.b0.g(this.nativeElement.getNextCell(this.b0.i(a), this.b0.i(b), this.b0.i(c)), (d) => new CellPosition());
        }
        j(a, b, c) {
            return this.b0.g(this.nativeElement.getPreviousCell(this.b0.i(a), this.b0.i(b), this.b0.i(c)), (d) => new CellPosition());
        }
        fq(a) {
            this.nativeElement.openAdvancedFilteringDialog(this.b0.i(a));
        }
        eg(a) {
            this.nativeElement.closeAdvancedFilteringDialog(this.b0.i(a));
        }
        e5(a, b) {
            this.nativeElement.endEdit(this.b0.i(a), this.b0.i(b));
        }
        d6(a, b = false) {
            this.nativeElement.beginAddRowById(this.b0.i(a), this.b0.i(b));
        }
        get d2() {
            let ret_ = this.b0.n("name");
            return ret_;
        }
        set d2(a) {
            let value_ = a;
            this.b0.v("name", value_);
        }
    }
    RowIsland.$t = /*@__PURE__*/ markType(RowIsland, 'RowIsland', BaseElement.$);
    return RowIsland;
})();
/**
 * @hidden
 */
export let RowIslandCollection = /*@__PURE__*/ (() => {
    class RowIslandCollection extends ObservableCollection$1 {
        constructor() {
            super(RowIsland.$, 0);
        }
    }
    RowIslandCollection.$t = /*@__PURE__*/ markType(RowIslandCollection, 'RowIslandCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(RowIsland.$));
    return RowIslandCollection;
})();
