/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseEventArgsDetail } from "./BaseEventArgsDetail";
import { GridKeydownTargetType_$type } from "./GridKeydownTargetType";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
/**
 * @hidden
 */
export let GridKeydownEventArgsDetail = /*@__PURE__*/ (() => {
    class GridKeydownEventArgsDetail extends BaseEventArgsDetail {
        get h() {
            let ret_ = this.b.n("targetType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridKeydownTargetType_$type, EnumUtil.getEnumValue(GridKeydownTargetType_$type, this.b.f(GridKeydownTargetType_$type, ret_)));
            return EnumUtil.getEnumValue(GridKeydownTargetType_$type, ret_);
        }
        set h(a) {
            let value_ = enumGetBox(GridKeydownTargetType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b.v("targetType", value_);
        }
        get k() {
            let ret_ = this.b.n("target");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.b.v("target", value_);
        }
        get j() {
            let ret_ = this.b.n("event");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.b.v("event", value_);
        }
        get i() {
            let ret_ = this.b.n("cancel");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.b.v("cancel", value_);
        }
    }
    GridKeydownEventArgsDetail.$t = /*@__PURE__*/ markType(GridKeydownEventArgsDetail, 'GridKeydownEventArgsDetail', BaseEventArgsDetail.$);
    GridKeydownEventArgsDetail.__marshalByValueIgnore = ["event"];
    return GridKeydownEventArgsDetail;
})();
