/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseToolbarDirective } from "./BaseToolbarDirective";
import { enumGetBox, markType } from "igniteui-react-core";
import { ExporterEventArgs } from "./ExporterEventArgs";
import { VoidEventArgs } from "igniteui-react";
import { GridToolbarExporterType_$type } from "./GridToolbarExporterType";
/**
 * @hidden
 */
export let GridToolbarExporter = /*@__PURE__*/ (() => {
    class GridToolbarExporter extends BaseToolbarDirective {
        constructor() {
            super(...arguments);
            this.exportStarted = null;
            this.exportEnded = null;
        }
        get w() {
            let ret_ = this.i.n("exportCSV");
            return ret_;
        }
        set w(a) {
            let value_ = a;
            this.i.v("exportCSV", value_);
        }
        get x() {
            let ret_ = this.i.n("exportExcel");
            return ret_;
        }
        set x(a) {
            let value_ = a;
            this.i.v("exportExcel", value_);
        }
        get z() {
            let ret_ = this.i.n("filename");
            return ret_;
        }
        set z(a) {
            let value_ = a;
            this.i.v("filename", value_);
        }
        get y() {
            let ret_ = this.i.n("isExporting");
            return ret_;
        }
        set y(a) {
            let value_ = a;
            this.i.v("isExporting", value_);
        }
        exportStartedChanged() {
            if (this.exportStarted != null) {
                this.i.r("exportStarted", (a) => this.exportStarted(this, ExporterEventArgs.a(a)), false);
            }
            else {
                this.i.u("exportStarted");
            }
        }
        exportEndedChanged() {
            if (this.exportEnded != null) {
                this.i.r("exportEnded", (a) => this.exportEnded(this, VoidEventArgs.b(a)), false);
            }
            else {
                this.i.u("exportEnded");
            }
        }
        ab(a, b) {
            this.nativeElement.export(this.i.i(enumGetBox(GridToolbarExporterType_$type, a)), this.i.i(b));
        }
    }
    GridToolbarExporter.$t = /*@__PURE__*/ markType(GridToolbarExporter, 'GridToolbarExporter', BaseToolbarDirective.$);
    return GridToolbarExporter;
})();
