/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { ValidationStatus_$type } from "./ValidationStatus";
import { ValidationErrors } from "./ValidationErrors";
/**
 * @hidden
 */
export let GridValidationState = /*@__PURE__*/ (() => {
    class GridValidationState extends Base {
        constructor() {
            super(...arguments);
            this.c = new WCNativeHelper();
            this.e = null;
        }
        get d() {
            return this.c;
        }
        get nativeElement() {
            return this.e;
        }
        set nativeElement(a) {
            this.e = a;
            this.c.o = this.e;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get b() {
            let ret_ = this.d.n("status");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(ValidationStatus_$type, EnumUtil.getEnumValue(ValidationStatus_$type, this.d.f(ValidationStatus_$type, ret_)));
            return EnumUtil.getEnumValue(ValidationStatus_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(ValidationStatus_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("status", value_);
        }
        get a() {
            let ret_ = this.d.m("errors", (a) => new ValidationErrors());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.d.v("errors", value_);
        }
    }
    GridValidationState.$t = /*@__PURE__*/ markType(GridValidationState, 'GridValidationState');
    return GridValidationState;
})();
