/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridBaseDirective } from "./GridBaseDirective";
import { markType } from "igniteui-react-core";
import { ForOfStateEventArgs } from "./ForOfStateEventArgs";
/**
 * @hidden
 */
export let HierarchicalGridBaseDirective = /*@__PURE__*/ (() => {
    class HierarchicalGridBaseDirective extends GridBaseDirective {
        constructor() {
            super(...arguments);
            this.dataPreLoad = null;
        }
        get g0() {
            let ret_ = this.d.n("hasChildrenKey");
            return ret_;
        }
        set g0(a) {
            let value_ = a;
            this.d.v("hasChildrenKey", value_);
        }
        get gz() {
            let ret_ = this.d.n("showExpandAll");
            return ret_;
        }
        set gz(a) {
            let value_ = a;
            this.d.v("showExpandAll", value_);
        }
        get gy() {
            let ret_ = this.d.n("rootGrid");
            return ret_;
        }
        set gy(a) {
            let value_ = a;
            this.d.v("rootGrid", value_);
        }
        dataPreLoadChanged() {
            if (this.dataPreLoad != null) {
                this.d.r("dataPreLoad", (a) => this.dataPreLoad(this, ForOfStateEventArgs.b(a)), false);
            }
            else {
                this.d.u("dataPreLoad");
            }
        }
    }
    HierarchicalGridBaseDirective.$t = /*@__PURE__*/ markType(HierarchicalGridBaseDirective, 'HierarchicalGridBaseDirective', GridBaseDirective.$);
    return HierarchicalGridBaseDirective;
})();
