/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { Base, runOn, markType } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ImageCell = /*@__PURE__*/ (() => {
    class ImageCell extends GridCellBase {
        get co() {
            return this.cn;
        }
        get cl() {
            return this.ck;
        }
        set cl(a) {
            this.ck = a;
        }
        constructor(a) {
            super(a);
            this.cn = null;
            this.ch = 1;
            this.ci = 3;
            this.cp = null;
            this.cj = false;
            this.ck = 1;
            this.cm = null;
            this.cn = a.createElement("img");
            this.cn.listen("load", runOn(this, this.cs));
            this.cm = a.createElement("div");
            this.cm.setRawStyleProperty("background-size", "contain");
            this.cm.setRawStyleProperty("background-repeat", "no-repeat");
            this.cm.setRawStyleProperty("background-position", "center");
            this.cm.setRawStyleProperty("width", "100%");
            this.cm.setRawStyleProperty("height", "100%");
            this.ae.setRawStyleProperty("text-align", "left");
            this.ae.setRawStyleProperty("vertical-align", "middle");
            this.ae.append(this.cm);
        }
        cs(a) {
            this.cj = false;
            if (!stringIsNullOrEmpty(this.cp)) {
                this.cm.setRawStyleProperty("opacity", "1");
                this.cm.setRawStyleProperty("background-image", "url(" + this.cp + ")");
            }
        }
        ct(a, b) {
            if (a == this.cp) {
                return;
            }
            this.cq();
            this.cm.setRawStyleProperty("opacity", "0");
            if (a == null || a.length == 0) {
                this.cr(this.cn);
                return;
            }
            if (Base.equalsStatic(a, this.cp)) {
                return;
            }
            this.cx(a, b);
            let img_ = this.cn.getNativeElement();
            if (img_ != null && (img_.complete)) {
                this.cj = false;
                this.cn.setRawStyleProperty("opacity", "1");
                this.cm.setRawStyleProperty("background-image", "url(" + this.cp + ")");
            }
        }
        cr(a) {
            a.setAttribute("src", "");
            this.cm.setRawStyleProperty("background-image", "");
        }
        cw(a) {
            switch (a) {
                case 1:
                    this.cm.setRawStyleProperty("background-size", "100% 100%");
                    break;
                case 2:
                    this.cm.setRawStyleProperty("background-size", "auto");
                    break;
                case 0:
                    this.cm.setRawStyleProperty("background-size", "contain");
                    break;
            }
        }
        cx(a, b) {
            this.cj = true;
            this.cp = a;
            this.co.setAttribute("src", a);
        }
        cq() {
            if (this.cj) {
                this.cr(this.cn);
                this.cp = "";
            }
        }
        cu(a) {
            this.ch = a;
        }
        cv(a) {
            this.ci = a;
        }
        get_w() {
            return true;
        }
        bp(a, b, c) {
            super.bp(a, b, c);
            if (a == "Indent" || a == "IsCollapsable") {
                this.cm.setRawStyleProperty("margin-left", this.a0 + this.a2 + this.a1 + "px");
            }
        }
    }
    ImageCell.$t = /*@__PURE__*/ markType(ImageCell, 'ImageCell', GridCellBase.$);
    return ImageCell;
})();
