/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-react-core";
/**
 * Indicates when the grid should merge cells with same values.
 */
export var MergedCellMode = /*@__PURE__*/ (function (MergedCellMode) {
    /**
     * At the grid level it defaults to Never. At the column level it defers
     * to the grid level.
     */
    MergedCellMode[MergedCellMode["Default"] = 0] = "Default";
    /**
     * The grid will never merge cells.
     */
    MergedCellMode[MergedCellMode["Never"] = 1] = "Never";
    /**
     * The grid will always merge cells.
     */
    MergedCellMode[MergedCellMode["Always"] = 2] = "Always";
    /**
     * The grid will only merge cells after a sort occurs.
     */
    MergedCellMode[MergedCellMode["OnlyWhenSorted"] = 3] = "OnlyWhenSorted";
    return MergedCellMode;
})({});
/**
 * @hidden
 */
export let MergedCellMode_$type = /*@__PURE__*/ markEnum('MergedCellMode', 'Default,0|Never,1|Always,2|OnlyWhenSorted,3');
