/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PositionStrategy } from "./PositionStrategy";
import { ScrollStrategy } from "./ScrollStrategy";
/**
 * @hidden
 */
export let OverlaySettings = /*@__PURE__*/ (() => {
    class OverlaySettings extends Base {
        constructor() {
            super(...arguments);
            this.c = new WCNativeHelper();
            this.h = null;
        }
        get d() {
            return this.c;
        }
        get nativeElement() {
            return this.h;
        }
        set nativeElement(a) {
            this.h = a;
            this.c.o = this.h;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get j() {
            let ret_ = this.d.m("target", (a) => { });
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.d.v("target", value_);
        }
        get a() {
            let ret_ = this.d.m("positionStrategy", (a) => new PositionStrategy());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.d.v("positionStrategy", value_);
        }
        get b() {
            let ret_ = this.d.m("scrollStrategy", (a) => new ScrollStrategy());
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.d.v("scrollStrategy", value_);
        }
        get g() {
            let ret_ = this.d.n("modal");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.d.v("modal", value_);
        }
        get f() {
            let ret_ = this.d.n("closeOnOutsideClick");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.d.v("closeOnOutsideClick", value_);
        }
        get e() {
            let ret_ = this.d.n("closeOnEscape");
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.d.v("closeOnEscape", value_);
        }
    }
    OverlaySettings.$t = /*@__PURE__*/ markType(OverlaySettings, 'OverlaySettings');
    return OverlaySettings;
})();
