/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { ColumnPinningPosition_$type } from "./ColumnPinningPosition";
import { RowPinningPosition_$type } from "./RowPinningPosition";
/**
 * @hidden
 */
export let PinningConfig = /*@__PURE__*/ (() => {
    class PinningConfig extends Base {
        constructor() {
            super(...arguments);
            this.c = new WCNativeHelper();
            this.e = null;
        }
        get d() {
            return this.c;
        }
        get nativeElement() {
            return this.e;
        }
        set nativeElement(a) {
            this.e = a;
            this.c.o = this.e;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.d.n("columns");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(ColumnPinningPosition_$type, EnumUtil.getEnumValue(ColumnPinningPosition_$type, this.d.f(ColumnPinningPosition_$type, ret_)));
            return EnumUtil.getEnumValue(ColumnPinningPosition_$type, ret_);
        }
        set a(a) {
            let value_ = enumGetBox(ColumnPinningPosition_$type, a);
            value_ = this.d.f(ColumnPinningPosition_$type, value_);
            this.d.v("columns", value_);
        }
        get b() {
            let ret_ = this.d.n("rows");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(RowPinningPosition_$type, EnumUtil.getEnumValue(RowPinningPosition_$type, this.d.f(RowPinningPosition_$type, ret_)));
            return EnumUtil.getEnumValue(RowPinningPosition_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(RowPinningPosition_$type, a);
            value_ = this.d.f(RowPinningPosition_$type, value_);
            this.d.v("rows", value_);
        }
    }
    PinningConfig.$t = /*@__PURE__*/ markType(PinningConfig, 'PinningConfig');
    return PinningConfig;
})();
