/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PivotAggregationType_$type } from "./PivotAggregationType";
/**
 * @hidden
 */
export let PivotAggregator = /*@__PURE__*/ (() => {
    class PivotAggregator extends Base {
        constructor() {
            super(...arguments);
            this.c = new WCNativeHelper();
            this.e = null;
            this.aggregator = null;
        }
        get d() {
            return this.c;
        }
        get nativeElement() {
            return this.e;
        }
        set nativeElement(a) {
            this.e = a;
            this.c.o = this.e;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get g() {
            let ret_ = this.d.n("key");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.d.v("key", value_);
        }
        get h() {
            let ret_ = this.d.n("label");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.d.v("label", value_);
        }
        get b() {
            let ret_ = this.d.n("aggregatorName");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(PivotAggregationType_$type, EnumUtil.getEnumValue(PivotAggregationType_$type, this.d.f(PivotAggregationType_$type, ret_)));
            return EnumUtil.getEnumValue(PivotAggregationType_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(PivotAggregationType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("aggregatorName", value_);
        }
        aggregatorChanged() {
            if (this.aggregator != null) {
                let value_ = this.aggregator;
                this.d.v("aggregator", value_);
            }
            else {
                let value_ = null;
                this.d.v("aggregator", value_);
            }
        }
    }
    PivotAggregator.$t = /*@__PURE__*/ markType(PivotAggregator, 'PivotAggregator');
    return PivotAggregator;
})();
