/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PivotDimension } from "./PivotDimension";
import { FilteringExpressionsTree } from "./FilteringExpressionsTree";
import { SortingDirection_$type } from "./SortingDirection";
import { GridColumnDataType_$type } from "./GridColumnDataType";
/**
 * @hidden
 */
export let PivotDimensionDetail = /*@__PURE__*/ (() => {
    class PivotDimensionDetail extends Base {
        constructor() {
            super(...arguments);
            this.f = new WCNativeHelper();
            this.j = null;
            this.memberFunction = null;
        }
        get g() {
            return this.f;
        }
        get nativeElement() {
            return this.j;
        }
        set nativeElement(a) {
            this.j = a;
            this.f.o = this.j;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get d() {
            let ret_ = this.g.m("childLevel", (a) => new PivotDimension());
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.g.v("childLevel", value_);
        }
        get l() {
            let ret_ = this.g.n("memberName");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.g.v("memberName", value_);
        }
        memberFunctionChanged() {
            if (this.memberFunction != null) {
                let value_ = this.memberFunction;
                this.g.v("memberFunction", value_);
            }
            else {
                let value_ = null;
                this.g.v("memberFunction", value_);
            }
        }
        get h() {
            let ret_ = this.g.n("enabled");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.g.v("enabled", value_);
        }
        get a() {
            let ret_ = this.g.m("filter", (a) => new FilteringExpressionsTree());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.g.v("filter", value_);
        }
        get e() {
            let ret_ = this.g.n("sortDirection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(SortingDirection_$type, EnumUtil.getEnumValue(SortingDirection_$type, this.g.f(SortingDirection_$type, ret_)));
            return EnumUtil.getEnumValue(SortingDirection_$type, ret_);
        }
        set e(a) {
            let value_ = enumGetBox(SortingDirection_$type, a);
            value_ = this.g.f(SortingDirection_$type, value_);
            this.g.v("sortDirection", value_);
        }
        get b() {
            let ret_ = this.g.n("dataType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridColumnDataType_$type, EnumUtil.getEnumValue(GridColumnDataType_$type, this.g.f(GridColumnDataType_$type, ret_)));
            return EnumUtil.getEnumValue(GridColumnDataType_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(GridColumnDataType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("dataType", value_);
        }
        get m() {
            let ret_ = this.g.n("width");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.g.v("width", value_);
        }
        get i() {
            let ret_ = this.g.n("level");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.g.v("level", value_);
        }
    }
    PivotDimensionDetail.$t = /*@__PURE__*/ markType(PivotDimensionDetail, 'PivotDimensionDetail');
    return PivotDimensionDetail;
})();
