/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PivotAggregator } from "./PivotAggregator";
import { PivotAggregatorCollection } from "./PivotAggregatorCollection";
import { GridColumnDataType_$type } from "./GridColumnDataType";
/**
 * @hidden
 */
export let PivotValueDetail = /*@__PURE__*/ (() => {
    class PivotValueDetail extends Base {
        constructor() {
            super(...arguments);
            this.e = new WCNativeHelper();
            this.h = null;
            this.formatter = null;
        }
        get f() {
            return this.e;
        }
        get nativeElement() {
            return this.h;
        }
        set nativeElement(a) {
            this.h = a;
            this.e.o = this.h;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get l() {
            let ret_ = this.f.n("member");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.f.v("member", value_);
        }
        get k() {
            let ret_ = this.f.n("displayName");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.f.v("displayName", value_);
        }
        get b() {
            let ret_ = this.f.m("aggregate", (a) => new PivotAggregator());
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.f.v("aggregate", value_);
        }
        get c() {
            let ret_ = this.f.k("aggregateList", (a) => new PivotAggregatorCollection(), (a) => new PivotAggregator());
            return ret_;
        }
        get g() {
            let ret_ = this.f.n("enabled");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.f.v("enabled", value_);
        }
        get j() {
            let ret_ = this.f.n("styles");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.f.v("styles", value_);
        }
        get a() {
            let ret_ = this.f.n("dataType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridColumnDataType_$type, EnumUtil.getEnumValue(GridColumnDataType_$type, this.f.f(GridColumnDataType_$type, ret_)));
            return EnumUtil.getEnumValue(GridColumnDataType_$type, ret_);
        }
        set a(a) {
            let value_ = enumGetBox(GridColumnDataType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.f.v("dataType", value_);
        }
        formatterChanged() {
            if (this.formatter != null) {
                let value_ = this.formatter;
                this.f.v("formatter", value_);
            }
            else {
                let value_ = null;
                this.f.v("formatter", value_);
            }
        }
    }
    PivotValueDetail.$t = /*@__PURE__*/ markType(PivotValueDetail, 'PivotValueDetail');
    return PivotValueDetail;
})();
