/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { GridHorizontalAlignment_$type } from "./GridHorizontalAlignment";
import { GridVerticalAlignment_$type } from "./GridVerticalAlignment";
import { PositionSize } from "./PositionSize";
/**
 * @hidden
 */
export let PositionSettings = /*@__PURE__*/ (() => {
    class PositionSettings extends Base {
        constructor() {
            super(...arguments);
            this.f = new WCNativeHelper();
            this.h = null;
        }
        get g() {
            return this.f;
        }
        get nativeElement() {
            return this.h;
        }
        set nativeElement(a) {
            this.h = a;
            this.f.o = this.h;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get j() {
            let ret_ = this.g.m("target", (a) => { });
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.g.v("target", value_);
        }
        get a() {
            let ret_ = this.g.n("horizontalDirection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridHorizontalAlignment_$type, EnumUtil.getEnumValue(GridHorizontalAlignment_$type, this.g.f(GridHorizontalAlignment_$type, ret_)));
            return EnumUtil.getEnumValue(GridHorizontalAlignment_$type, ret_);
        }
        set a(a) {
            let value_ = enumGetBox(GridHorizontalAlignment_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("horizontalDirection", value_);
        }
        get c() {
            let ret_ = this.g.n("verticalDirection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridVerticalAlignment_$type, EnumUtil.getEnumValue(GridVerticalAlignment_$type, this.g.f(GridVerticalAlignment_$type, ret_)));
            return EnumUtil.getEnumValue(GridVerticalAlignment_$type, ret_);
        }
        set c(a) {
            let value_ = enumGetBox(GridVerticalAlignment_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("verticalDirection", value_);
        }
        get b() {
            let ret_ = this.g.n("horizontalStartPoint");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridHorizontalAlignment_$type, EnumUtil.getEnumValue(GridHorizontalAlignment_$type, this.g.f(GridHorizontalAlignment_$type, ret_)));
            return EnumUtil.getEnumValue(GridHorizontalAlignment_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(GridHorizontalAlignment_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("horizontalStartPoint", value_);
        }
        get d() {
            let ret_ = this.g.n("verticalStartPoint");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridVerticalAlignment_$type, EnumUtil.getEnumValue(GridVerticalAlignment_$type, this.g.f(GridVerticalAlignment_$type, ret_)));
            return EnumUtil.getEnumValue(GridVerticalAlignment_$type, ret_);
        }
        set d(a) {
            let value_ = enumGetBox(GridVerticalAlignment_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("verticalStartPoint", value_);
        }
        get e() {
            let ret_ = this.g.m("minSize", (a) => new PositionSize());
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.g.v("minSize", value_);
        }
    }
    PositionSettings.$t = /*@__PURE__*/ markType(PositionSettings, 'PositionSettings');
    return PositionSettings;
})();
