/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { JsonDictionaryItem } from "igniteui-react-core";
import { toNullable, Number_$type, markType } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { nullableNotEquals } from "igniteui-react-core";
/**
 * @hidden
 */
export let SaveLayoutFilterInfo = /*@__PURE__*/ (() => {
    class SaveLayoutFilterInfo extends JsonDictionaryItem {
        q(a) {
            let b = a;
            if (b.g("ColumnName")) {
                let c = b.item("ColumnName");
                this.o = c.value.toString();
            }
            if (b.g("Operator")) {
                let d = b.item("Operator");
                this.n = toNullable(Number_$type, parseInt(d.value.toString()));
            }
            if (b.g("Value")) {
                let e = b.item("Value");
                this.p = e.value.toString();
            }
            if (b.g("FilterArguments")) {
                let f = b.item("FilterArguments");
                let g = f.items.length;
                if (g > 0) {
                    if (this.m == null) {
                        this.m = new List$1(SaveLayoutFilterInfo.$, 0);
                    }
                }
                for (let h = 0; h < g; h++) {
                    let i = new SaveLayoutFilterInfo();
                    i.q(f.items[h]);
                    this.m.add(i);
                }
            }
            if (b.g("Left")) {
                let j = b.item("Left");
                if (this.e == null) {
                    this.e = new SaveLayoutFilterInfo();
                }
                this.e.q(j);
            }
            if (b.g("Right")) {
                let k = b.item("Right");
                if (this.f == null) {
                    this.f = new SaveLayoutFilterInfo();
                }
                this.f.q(k);
            }
            if (b.g("IsFunction")) {
                let l = b.item("IsFunction");
                this.h = l.value;
            }
            if (b.g("IsLiteral")) {
                let m = b.item("IsLiteral");
                this.i = m.value;
            }
            if (b.g("IsOperation")) {
                let n = b.item("IsOperation");
                this.k = n.value;
            }
            if (b.g("IsPropertyReference")) {
                let o = b.item("IsPropertyReference");
                this.l = o.value;
            }
            if (b.g("IsNull")) {
                let p = b.item("IsNull");
                this.j = p.value;
            }
            if (b.g("IsAutoGenerated")) {
                let q = b.item("IsAutoGenerated");
                this.g = q.value;
            }
        }
        d(a) {
            a.i("{");
            a.h();
            a.g();
            a.i("\"ColumnName\": " + "\"" + this.o + "\"");
            if (nullableNotEquals(this.n, null)) {
                a.i(",");
                a.h();
                a.i("\"Operator\": " + this.n.value);
            }
            if (this.p != null) {
                a.i(",");
                a.h();
                a.i("\"Value\": " + "\"" + this.p + "\"");
            }
            if (this.m != null) {
                a.i(",");
                a.h();
                a.i("\"FilterArguments\": [");
                for (let b = 0; b < this.m.count; b++) {
                    if (b != 0) {
                        a.i(",");
                    }
                    this.m._inner[b].d(a);
                }
                a.i("]");
            }
            if (this.e != null) {
                a.i(",");
                a.h();
                a.i("\"Left\": ");
                this.e.d(a);
            }
            if (this.f != null) {
                a.i(",");
                a.h();
                a.i("\"Right\": ");
                this.f.d(a);
            }
            a.i(",");
            a.h();
            a.i("\"IsFunction\": " + this.h);
            a.i(",");
            a.h();
            a.i("\"IsLiteral\": " + this.i);
            a.i(",");
            a.h();
            a.i("\"IsOperation\": " + this.k);
            a.i(",");
            a.h();
            a.i("\"IsPropertyReference\": " + this.l);
            a.i(",");
            a.h();
            a.i("\"IsNull\": " + this.j);
            a.i(",");
            a.h();
            a.i("\"IsAutoGenerated\": " + this.g);
            a.h();
            a.e();
            a.i("}");
        }
        constructor() {
            super();
            this.o = null;
            this.n = toNullable(Number_$type, null);
            this.p = null;
            this.m = null;
            this.e = null;
            this.f = null;
            this.h = false;
            this.i = false;
            this.k = false;
            this.l = false;
            this.j = false;
            this.g = false;
            this.o = null;
            this.n = toNullable(Number_$type, null);
            this.p = null;
            this.e = null;
            this.f = null;
            this.h = false;
            this.i = false;
            this.k = false;
            this.l = false;
            this.j = false;
            this.g = false;
        }
    }
    SaveLayoutFilterInfo.$t = /*@__PURE__*/ markType(SaveLayoutFilterInfo, 'SaveLayoutFilterInfo', JsonDictionaryItem.$);
    return SaveLayoutFilterInfo;
})();
