/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseEventArgs } from "./BaseEventArgs";
import { WCNativeHelper } from "igniteui-react";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { SortingDirection_$type } from "./SortingDirection";
import { SortingStrategy } from "./SortingStrategy";
/**
 * @hidden
 */
export let SortingExpression = /*@__PURE__*/ (() => {
    class SortingExpression extends BaseEventArgs {
        constructor() {
            super(...arguments);
            this.e = new WCNativeHelper();
            this.h = null;
        }
        get f() {
            return this.e;
        }
        get nativeElement() {
            return this.h;
        }
        set nativeElement(a) {
            this.h = a;
            this.e.o = this.h;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get j() {
            let ret_ = this.f.n("fieldName");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.f.v("fieldName", value_);
        }
        get c() {
            let ret_ = this.f.n("dir");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(SortingDirection_$type, EnumUtil.getEnumValue(SortingDirection_$type, this.f.f(SortingDirection_$type, ret_)));
            return EnumUtil.getEnumValue(SortingDirection_$type, ret_);
        }
        set c(a) {
            let value_ = enumGetBox(SortingDirection_$type, a);
            value_ = this.f.f(SortingDirection_$type, value_);
            this.f.v("dir", value_);
        }
        get g() {
            let ret_ = this.f.n("ignoreCase");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.f.v("ignoreCase", value_);
        }
        get d() {
            let ret_ = this.f.m("strategy", (a) => new SortingStrategy());
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.f.v("strategy", value_);
        }
    }
    SortingExpression.$t = /*@__PURE__*/ markType(SortingExpression, 'SortingExpression', BaseEventArgs.$);
    return SortingExpression;
})();
