/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { TemplateCellContainer } from "./TemplateCellContainer";
import { runOn, markType } from "igniteui-react-core";
import { BaseDOMEventProxy } from "igniteui-react-core";
/**
 * @hidden
 */
export let TemplateCell = /*@__PURE__*/ (() => {
    class TemplateCell extends GridCellBase {
        get ci() {
            return this.ch;
        }
        constructor(a) {
            super(a);
            this.ch = null;
            this.ch = new TemplateCellContainer(a);
            this.ch.element.setRawStyleProperty("box-sizing", "border-box");
            this.ae.append(this.ch.element);
            this.ae.listen("keydown", runOn(this, this.cj));
        }
        get_w() {
            return true;
        }
        bp(a, b, c) {
            super.bp(a, b, c);
            if (a == "Indent" || a == "IsCollapsable") {
                this.ch.element.setRawStyleProperty("margin-left", this.a0 + this.a2 + this.a1 + "px");
            }
        }
        be() {
            let a = this.ch.element.getNativeElement();
            if (a.contains(document.activeElement)) {
                return;
            }
            super.be();
        }
        cj(a) {
            let b = this.ch.element.getNativeElement();
            if (b.contains(document.activeElement) && document.activeElement.nodeName == "INPUT") {
                let c = BaseDOMEventProxy.c0(a);
                if (c == 14 || c == 16) {
                    a.stopPropagation();
                }
            }
        }
    }
    TemplateCell.$t = /*@__PURE__*/ markType(TemplateCell, 'TemplateCell', GridCellBase.$);
    return TemplateCell;
})();
