/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { markType } from "igniteui-react-core";
/**
 * @hidden
 */
export let TextCell = /*@__PURE__*/ (() => {
    class TextCell extends GridCellBase {
        get ci() {
            return this.ch;
        }
        b6(a, b) {
            super.b6(a, b);
            let c = Math.max(0, a - b - (this.a0 + this.a2 + this.a1));
            if (this.ck != c) {
                this.ck = c;
                this.ch.setRawStyleProperty("max-width", c.toString() + "px");
            }
        }
        b0(a, b) {
            super.b0(a, b);
            let c = Math.max(0, a - b);
            if (this.cj != c) {
                this.cj = c;
                this.ch.setRawStyleProperty("max-height", c.toString() + "px");
            }
        }
        constructor(a) {
            super(a);
            this.ch = null;
            this.ck = -1;
            this.cj = -1;
            this.ch = a.createElement("span");
            this.ae.setRawStyleProperty("text-align", "left");
            this.ch.setRawStyleProperty("display", "inline-block");
            this.ch.setRawStyleProperty("line-height", "normal");
            this.ch.setRawStyleProperty("vertical-align", "middle");
            this.ch.setRawStyleProperty("overflow", "hidden");
            this.ch.setRawStyleProperty("white-space", "nowrap");
            this.ch.setRawStyleProperty("text-overflow", "ellipsis");
            this.ae.setRawStyleProperty("vertical-align", "middle");
            this.ae.append(this.ch);
        }
        get_w() {
            return true;
        }
        bp(a, b, c) {
            super.bp(a, b, c);
            if (a == "Indent" || a == "IsCollapsable") {
                this.ch.setRawStyleProperty("margin-left", this.a0 + this.a2 + this.a1 + "px");
            }
        }
    }
    TextCell.$t = /*@__PURE__*/ markType(TextCell, 'TextCell', GridCellBase.$);
    return TextCell;
})();
