/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { GridSortIndicator } from "./GridSortIndicator";
import { GridFilterDialog } from "./GridFilterDialog";
import { ColumnOptionsIconBehavior_$type } from "./ColumnOptionsIconBehavior";
import { ColumnOptionsIconAlignment_$type } from "./ColumnOptionsIconAlignment";
import { enumGetBox, runOn, delegateCombine, markType } from "igniteui-react-core";
/**
 * @hidden
 */
export let TextHeaderCell = /*@__PURE__*/ (() => {
    class TextHeaderCell extends GridCellBase {
        get cv() {
            return this.cs;
        }
        get cp() {
            return this.co;
        }
        get cn() {
            return this.cm;
        }
        get cl() {
            return this.ck;
        }
        set cl(a) {
            let b = this.ck;
            this.ck = a;
            this.bp("ColumnOptionsIconBehavior", enumGetBox(ColumnOptionsIconBehavior_$type, b), enumGetBox(ColumnOptionsIconBehavior_$type, this.ck));
        }
        get cj() {
            return this.ci;
        }
        set cj(a) {
            let b = this.ci;
            this.ci = a;
            this.bp("ColumnOptionsIconAlignment", enumGetBox(ColumnOptionsIconAlignment_$type, b), enumGetBox(ColumnOptionsIconAlignment_$type, this.ci));
        }
        x(a) {
            return true;
        }
        b6(a, b) {
            super.b6(a, b);
            a -= 21;
            if (this.cr) {
                a -= 15;
            }
            let c = Math.max(0, a - b);
            if (c != this.cx) {
                this.cx = c;
                this.cs.setRawStyleProperty("max-width", c.toString() + "px");
            }
        }
        b0(a, b) {
            super.b0(a, b);
            let c = Math.max(0, a - b);
            if (this.cw != c) {
                this.cw = c;
                this.cs.setRawStyleProperty("max-height", c.toString() + "px");
            }
        }
        b7(a, b, c, d) {
            this.cm.a7();
        }
        constructor(a) {
            super(a);
            this.cs = null;
            this.co = null;
            this.cm = null;
            this.ci = 0;
            this.ch = 0;
            this.ck = 3;
            this.cu = null;
            this.cx = -1;
            this.cw = -1;
            this.cq = false;
            this.ct = null;
            this.cr = false;
            this.cs = a.createElement("span");
            this.ae.setRawStyleProperty("text-align", "left");
            this.ae.setRawStyleProperty("vertical-align", "middle");
            this.cs.setRawStyleProperty("display", "inline-block");
            this.cs.setRawStyleProperty("line-height", "normal");
            this.cs.setRawStyleProperty("vertical-align", "middle");
            this.cs.setRawStyleProperty("overflow", "hidden");
            this.cs.setRawStyleProperty("white-space", "nowrap");
            this.cs.setRawStyleProperty("text-overflow", "ellipsis");
            this.ae.append(this.cs);
            let b = 18;
            let c = 18;
            let d = a.createElement("div");
            d.setAttribute("aria-hidden", "true");
            d.setRawStyleProperty("display", "none");
            d.setRawStyleProperty("vertical-align", "middle");
            d.setRawStyleProperty("width", b + "px");
            d.setRawStyleProperty("height", c + "px");
            this.ct = d;
            let e = a.getSubRenderer(d);
            this.cm = new GridFilterDialog();
            this.cm.bg(e, this.ae, a);
            this.ae.append(d);
            this.cm.a8(b, c);
            this.cm.af = 24;
            let f = this.cm.x;
            this.cm.x = false;
            this.cm.a5();
            this.cm.x = f;
            let g = 18;
            let h = 18;
            d = a.createElement("div");
            d.setAttribute("aria-hidden", "true");
            d.setRawStyleProperty("display", "inline-block");
            d.setRawStyleProperty("vertical-align", "middle");
            d.setRawStyleProperty("width", "0px");
            d.setRawStyleProperty("height", h + "px");
            d.setRawStyleProperty("margin", "0 0 0 5px");
            this.cu = d;
            e = a.getSubRenderer(d);
            this.co = new GridSortIndicator();
            this.co.l = false;
            this.co.ax(e);
            this.ae.append(d);
            this.co.ar(g, h);
            let i = this.co;
            i.propertyChanged = delegateCombine(i.propertyChanged, runOn(this, this.c0));
            let j = this.cm;
            j.dialogOpening = delegateCombine(j.dialogOpening, runOn(this, this.c1));
            let k = this.cm;
            k.filterChanging = delegateCombine(k.filterChanging, runOn(this, this.c3));
            let l = this.cm;
            l.filterChanged = delegateCombine(l.filterChanged, runOn(this, this.c2));
            this.ae.listen("mouseenter", runOn(this, this.c7));
            this.ae.listen("mouseleave", runOn(this, this.c6));
        }
        c0(a, b) {
            switch (b.propertyName) {
                case "CurrentOpacity":
                    if (this.cp.r > 0) {
                        this.cu.setRawStyleProperty("width", "18px");
                        if (this.ch == 2) {
                            this.cu.setRawStyleProperty("margin", "0 5px 0 0");
                        }
                        else {
                            this.cu.setRawStyleProperty("margin", "0 0 0 5px");
                        }
                    }
                    else {
                        this.cu.setRawStyleProperty("width", "0px");
                        this.cu.setRawStyleProperty("margin", "0");
                    }
                    break;
            }
        }
        c7(a) {
            if (this.b.isGridDragging) {
                return;
            }
            switch (this.cl) {
                case 2:
                case 3:
                    this.cm.bl();
                    break;
            }
        }
        c6(a) {
            switch (this.cl) {
                case 2:
                case 3:
                    this.cm.a5();
                    break;
            }
        }
        c2(a, b) {
            this.b.columnFilterChanged(b.a);
        }
        c3(a, b) {
            this.b.columnFilterChanging(b.a);
        }
        c1(a, b) {
            if (this.b != null) {
                b.a = this.f.getColumn();
                this.b.cancelEditMode(false);
            }
        }
        bn(a, b, c) {
            super.bn(a, b, c);
            this.ch = c;
            this.cm.k = c;
            if (c == 2) {
                this.ae.removeChild(this.cu);
                this.ae.removeChild(this.ct);
                this.cs.before(this.ct);
                this.ct.before(this.cu);
                if (this.cj == 1) {
                    this.ct.setRawStyleProperty("margin", "0 5px 0 0");
                    this.cm.l = this.ch;
                }
                else {
                    this.ct.setRawStyleProperty("margin", "0");
                    this.cm.l = 0;
                }
            }
            else {
                this.ae.removeChild(this.cu);
                this.ae.removeChild(this.cs);
                this.ct.before(this.cs);
                this.ct.before(this.cu);
                if (this.cj == 1) {
                    this.ct.setRawStyleProperty("margin", "0 0 0 5px");
                    this.cm.l = this.ch;
                }
                else {
                    this.ct.setRawStyleProperty("margin", "0");
                    this.cm.l = 2;
                }
            }
        }
        b4(a, b, c, d) {
            super.b4(a, b, c, d);
            this.cm.ai = a;
            this.cm.aj = c;
        }
        c5() {
            if (this.cj == 2 || this.cj == 0) {
                if (this.ch == 2) {
                    this.cm.l = 0;
                }
                else {
                    this.cm.l = 2;
                }
            }
            else {
                this.cm.l = this.ch;
                if (this.ch == 2) {
                    this.ct.setRawStyleProperty("margin", "0 5px 0 0");
                }
                else {
                    this.ct.setRawStyleProperty("margin", "0 0 0 5px");
                }
            }
        }
        c4() {
            switch (this.cl) {
                case 1:
                    this.cm.x = false;
                    this.cm.bl();
                    break;
                case 2:
                    this.cm.x = false;
                    break;
                case 3:
                    this.cm.x = true;
                    break;
            }
        }
        bp(a, b, c) {
            super.bp(a, b, c);
            switch (a) {
                case "ColumnOptionsIconAlignment":
                    this.c5();
                    break;
                case "ColumnOptionsIconBehavior":
                    this.c4();
                    break;
            }
        }
        onContactStarted(e_, a) {
            if (e_.button == 2) {
                return;
            }
            let filterIconCanvas_ = this.cm.aq();
            let b = (e_.originalEvent.srcElement === filterIconCanvas_ || e_.originalEvent.target === filterIconCanvas_);
            if (b) {
                this.cq = true;
                return;
            }
            if (this.cm.y) {
                this.cm.a2();
            }
            super.onContactStarted(e_, a);
        }
        onContactCompleted(e_, a) {
            if (!this.cq) {
                super.onContactCompleted(e_, a);
            }
            this.cq = false;
        }
        detach() {
            super.detach();
            if (this.cm != null) {
                this.cm.a2();
            }
        }
        get_u() {
            return true;
        }
    }
    TextHeaderCell.$t = /*@__PURE__*/ markType(TextHeaderCell, 'TextHeaderCell', GridCellBase.$);
    return TextHeaderCell;
})();
