/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { markType } from "igniteui-react-core";
import { intDivide } from "igniteui-react-core";
/**
 * @hidden
 */
export let VerticalSeparatorCell = /*@__PURE__*/ (() => {
    class VerticalSeparatorCell extends GridCellBase {
        constructor(a) {
            super(a);
            this.ci = null;
            this.ch = null;
            this.cj = 0;
            this.ck = 0;
            this.ci = a.createElement("div");
            this.ci.setRawStyleProperty("position", "absolute");
            this.ci.setRawStyleProperty("pointer-events", "none");
            this.ae.append(this.ci);
        }
        by(a, b, c, d, e) {
            if (a == null) {
                if (this.ch != null) {
                    this.ch.remove();
                    this.ch = null;
                }
            }
            else {
                this.cl();
                this.cj = b;
                this.ck = d;
            }
            this.cm();
        }
        b6(a, b) {
            super.b6(a, b);
            this.cm();
        }
        bx(a) {
            this.ci.setRawStyleProperty("background-color", a.colorString);
        }
        cm() {
            if (this.ch != null) {
                this.ci.setRawStyleProperty("height", "100%");
                this.ci.setRawStyleProperty("width", this.ae.width() - (this.cj + this.ck) + "px");
                this.ci.setRawStyleProperty("left", intDivide(this.ae.width(), 2) + "px");
                this.ch.setRawStyleProperty("width", "100%");
                this.ch.setRawStyleProperty("height", "100%");
            }
            else {
                this.ci.setRawStyleProperty("height", "100%");
                this.ci.setRawStyleProperty("width", this.ae.width() + "px");
                this.ci.setRawStyleProperty("left", "0px");
            }
        }
        cl() {
            if (this.ch == null) {
                this.ch = this.ab.createElement("div");
                this.ch.setRawStyleProperty("position", "absolute");
                this.ch.setRawStyleProperty("background-color", "rgba(0,0,0,0)");
                this.ae.getNativeElement().insertBefore(this.ch.getNativeElement(), this.ci.getNativeElement());
            }
        }
    }
    VerticalSeparatorCell.$t = /*@__PURE__*/ markType(VerticalSeparatorCell, 'VerticalSeparatorCell', GridCellBase.$);
    return VerticalSeparatorCell;
})();
