import { GridKeydownTargetType_$type } from "./GridKeydownTargetType";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ActiveNodeChangeEventArgsDetail as ActiveNodeChangeEventArgsDetail_internal } from "./ActiveNodeChangeEventArgsDetail";
import { ensureEnum } from "igniteui-react-core";
export class IgrActiveNodeChangeEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new ActiveNodeChangeEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get row() {
        return this.i.j;
    }
    set row(v) {
        this.i.j = +v;
    }
    get column() {
        return this.i.h;
    }
    set column(v) {
        this.i.h = +v;
    }
    get level() {
        return this.i.i;
    }
    set level(v) {
        this.i.i = +v;
    }
    get tag() {
        return this.i.g;
    }
    set tag(v) {
        this.i.g = ensureEnum(GridKeydownTargetType_$type, v);
    }
}
