import { Cell as Cell_internal } from "./Cell";
export class IgrCell {
    createImplementation() {
        return new Cell_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get primaryKey() {
        return this.i.h;
    }
    set primaryKey(v) {
        this.i.h = v;
    }
    get state() {
        return this.i.i;
    }
    set state(v) {
        this.i.i = v;
    }
    get pendingValue() {
        return this.i.g;
    }
    set pendingValue(v) {
        this.i.g = v;
    }
    get editValue() {
        return this.i.e;
    }
    set editValue(v) {
        this.i.e = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
    castToNumber(value) {
        let iv = this.i.d(value);
        return (iv);
    }
}
