import { IgrDataGridColumn } from "./igr-data-grid-column";
import { ColumnHiddenChangedEventArgs as ColumnHiddenChangedEventArgs_internal } from "./ColumnHiddenChangedEventArgs";
import { ensureBool } from "igniteui-react-core";
export class IgrColumnHiddenChangedEventArgs {
    createImplementation() {
        return new ColumnHiddenChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get column() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrDataGridColumn._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set column(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    get isHidden() {
        return this.i.b;
    }
    set isHidden(v) {
        this.i.b = ensureBool(v);
    }
}
