import { IgrDefinitionBase } from "./igr-definition-base";
import { ColumnMovingSeparator } from "./ColumnMovingSeparator";
export class IgrColumnMovingSeparator extends IgrDefinitionBase {
    createImplementation() {
        return new ColumnMovingSeparator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets the separator width for this column.
    */
    get separatorWidth() {
        return this.i.er;
    }
    set separatorWidth(v) {
        this.i.er = +v;
    }
    get actualOpacity() {
        return this.i.eo;
    }
    set actualOpacity(v) {
        this.i.eo = +v;
    }
    get opacity() {
        return this.i.ep;
    }
    set opacity(v) {
        this.i.ep = +v;
    }
}
