import { IgrColumn } from "./igr-column";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ColumnMovingStartEventArgsDetail as ColumnMovingStartEventArgsDetail_internal } from "./ColumnMovingStartEventArgsDetail";
export class IgrColumnMovingStartEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new ColumnMovingStartEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get source() {
        const r = this.i.g;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrColumn._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set source(v) {
        v == null ? this.i.g = null : this.i.g = v.i;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.source && this.source.name && this.source.name == name) {
            return this.source;
        }
        return null;
    }
}
