import { IgrDefinitionBase } from "./igr-definition-base";
import { ColumnResizingSeparator } from "./ColumnResizingSeparator";
export class IgrColumnResizingSeparator extends IgrDefinitionBase {
    createImplementation() {
        return new ColumnResizingSeparator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    get actualOpacity() {
        return this.i.eo;
    }
    set actualOpacity(v) {
        this.i.eo = +v;
    }
    get opacity() {
        return this.i.ep;
    }
    set opacity(v) {
        this.i.ep = +v;
    }
}
