import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ColumnVisibilityChangedEventArgsDetail as ColumnVisibilityChangedEventArgsDetail_internal } from "./ColumnVisibilityChangedEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
export class IgrColumnVisibilityChangedEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new ColumnVisibilityChangedEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get column() {
        return this.i.h;
    }
    set column(v) {
        this.i.h = v;
    }
    /**
     * The new hidden state that the column will have, if operation is succesfull.
     * Will be `true` when hiding and `false` when showing.
    */
    get newValue() {
        return this.i.g;
    }
    set newValue(v) {
        this.i.g = ensureBool(v);
    }
}
