import { ColumnVisibilityChangingEventArgsDetail as ColumnVisibilityChangingEventArgsDetail_internal } from "./ColumnVisibilityChangingEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
export class IgrColumnVisibilityChangingEventArgsDetail {
    createImplementation() {
        return new ColumnVisibilityChangingEventArgsDetail_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get column() {
        return this.i.f;
    }
    set column(v) {
        this.i.f = v;
    }
    /**
     * The new hidden state that the column will have, if operation is succesfull.
     * Will be `true` when hiding and `false` when showing.
    */
    get newValue() {
        return this.i.d;
    }
    set newValue(v) {
        this.i.d = ensureBool(v);
    }
    /**
     * Provides the ability to cancel the event.
    */
    get cancel() {
        return this.i.c;
    }
    set cancel(v) {
        this.i.c = ensureBool(v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
