import { IgrBaseDateTimeFilteringOperand } from "./igr-base-date-time-filtering-operand";
import { DateFilteringOperand as DateFilteringOperand_internal } from "./DateFilteringOperand";
/**
 * Provides filtering operations for Dates
 * @export
*/
export class IgrDateFilteringOperand extends IgrBaseDateTimeFilteringOperand {
    createImplementation() {
        let impl = new DateFilteringOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
}
