import { IgrSummaryOperand } from "./igr-summary-operand";
import { DateSummaryOperand as DateSummaryOperand_internal } from "./DateSummaryOperand";
export class IgrDateSummaryOperand extends IgrSummaryOperand {
    createImplementation() {
        let impl = new DateSummaryOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    latest(data) {
        this.i.j(data);
    }
    earliest(data) {
        this.i.i(data);
    }
    operate(data, allData, fieldName, groupRecord) {
        let iv = this.i.h(data, allData, fieldName, (groupRecord == null ? null : groupRecord.i));
        let ret = [];
        for (let i = 0; i < iv.length; i++) {
            let impl = iv[i];
            if (!impl.externalObject) {
                let e = impl.nativeElement;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    }
}
