import { IgrCellInfo } from "./igr-cell-info";
import { EditorRowCellModel as EditorRowCellModel_internal } from "./EditorRowCellModel";
/**
 * Represents info about the current cell.
*/
export class IgrEditorRowCellInfo extends IgrCellInfo {
    createImplementation() {
        return new EditorRowCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
}
