import { IgrBaseEventArgs } from "./igr-base-event-args";
import { ForOfState as ForOfState_internal } from "./ForOfState";
export class IgrForOfState extends IgrBaseEventArgs {
    createImplementation() {
        let impl = new ForOfState_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get startIndex() {
        return this.i.f;
    }
    set startIndex(v) {
        this.i.f = +v;
    }
    get chunkSize() {
        return this.i.e;
    }
    set chunkSize(v) {
        this.i.e = +v;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
