import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { GridActionsBaseDirective as GridActionsBaseDirective_internal } from './GridActionsBaseDirective';
import { IgrGridActionsBaseDirective as IgrGridActionsBaseDirective } from './igr-grid-actions-base-directive';
export class IgrGridActionsBaseDirectiveCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrGridActionsBaseDirective.$type) {
            IgrGridActionsBaseDirective.$type = markType(IgrGridActionsBaseDirective, "IgrGridActionsBaseDirective");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrGridActionsBaseDirective.$type) {
            IgrGridActionsBaseDirective.$type = markType(IgrGridActionsBaseDirective, "IgrGridActionsBaseDirective");
        }
        let coll = new SyncableObservableCollection$2(IgrGridActionsBaseDirective.$type, GridActionsBaseDirective_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgrGridActionsBaseDirective._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
