import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { GridFilterDialogViewModelRow as GridFilterDialogViewModelRow_internal } from './GridFilterDialogViewModelRow';
import { IgrGridFilterDialogViewModelRow as IgrGridFilterDialogViewModelRow } from './igr-grid-filter-dialog-view-model-row';
export class IgrGridFilterDialogViewModelRowCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrGridFilterDialogViewModelRow.$type) {
            IgrGridFilterDialogViewModelRow.$type = markType(IgrGridFilterDialogViewModelRow, "IgrGridFilterDialogViewModelRow");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrGridFilterDialogViewModelRow.$type) {
            IgrGridFilterDialogViewModelRow.$type = markType(IgrGridFilterDialogViewModelRow, "IgrGridFilterDialogViewModelRow");
        }
        let coll = new SyncableObservableCollection$2(IgrGridFilterDialogViewModelRow.$type, GridFilterDialogViewModelRow_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrGridFilterDialogViewModelRow();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
