import { GridKeydownTargetType_$type } from "./GridKeydownTargetType";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GridKeydownEventArgsDetail as GridKeydownEventArgsDetail_internal } from "./GridKeydownEventArgsDetail";
import { ensureEnum, ensureBool } from "igniteui-react-core";
export class IgrGridKeydownEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new GridKeydownEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get targetType() {
        return this.i.h;
    }
    set targetType(v) {
        this.i.h = ensureEnum(GridKeydownTargetType_$type, v);
    }
    get target() {
        return this.i.k;
    }
    set target(v) {
        this.i.k = v;
    }
    get event() {
        return this.i.j;
    }
    set event(v) {
        this.i.j = v;
    }
    get cancel() {
        return this.i.i;
    }
    set cancel(v) {
        this.i.i = ensureBool(v);
    }
}
