import { GridRowEditEndedEventArgs as GridRowEditEndedEventArgs_internal } from "./GridRowEditEndedEventArgs";
export class IgrGridRowEditEndedEventArgs {
    createImplementation() {
        return new GridRowEditEndedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets the row that ended editing.
    */
    get row() {
        return this.i.a;
    }
    set row(v) {
        this.i.a = +v;
    }
    /**
     * Gets the row item.
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
}
