import { GridSelectionRangeDetail as GridSelectionRangeDetail_internal } from "./GridSelectionRangeDetail";
export class IgrGridSelectionRangeDetail {
    createImplementation() {
        return new GridSelectionRangeDetail_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get rowStart() {
        return this.i.f;
    }
    set rowStart(v) {
        this.i.f = +v;
    }
    get rowEnd() {
        return this.i.e;
    }
    set rowEnd(v) {
        this.i.e = +v;
    }
    get columnStart() {
        return this.i.d;
    }
    set columnStart(v) {
        this.i.d = +v;
    }
    get columnEnd() {
        return this.i.c;
    }
    set columnEnd(v) {
        this.i.c = +v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
