import { GridStateInfoEventArgs as GridStateInfoEventArgs_internal } from "./GridStateInfoEventArgs";
import { interfaceToInternal } from "igniteui-react-core";
import { GridStateInfo } from "./GridStateInfo";
export class IgrGridStateInfoEventArgs {
    createImplementation() {
        return new GridStateInfoEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get detail() {
        return this.i.a.nativeElement;
    }
    set detail(v) {
        this.i.a = interfaceToInternal(v, () => new GridStateInfo());
    }
}
