import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { GridToolbarBaseAction as GridToolbarBaseAction_internal } from './GridToolbarBaseAction';
import { IgrGridToolbarBaseAction as IgrGridToolbarBaseAction } from './igr-grid-toolbar-base-action';
export class IgrGridToolbarBaseActionCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrGridToolbarBaseAction.$type) {
            IgrGridToolbarBaseAction.$type = markType(IgrGridToolbarBaseAction, "IgrGridToolbarBaseAction");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrGridToolbarBaseAction.$type) {
            IgrGridToolbarBaseAction.$type = markType(IgrGridToolbarBaseAction, "IgrGridToolbarBaseAction");
        }
        let coll = new SyncableObservableCollection$2(IgrGridToolbarBaseAction.$type, GridToolbarBaseAction_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgrGridToolbarBaseAction._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
