import { ValidationStatus_$type } from "./ValidationStatus";
import { GridValidationStatusEventArgsDetail as GridValidationStatusEventArgsDetail_internal } from "./GridValidationStatusEventArgsDetail";
import { ensureEnum } from "igniteui-react-core";
export class IgrGridValidationStatusEventArgsDetail {
    createImplementation() {
        return new GridValidationStatusEventArgsDetail_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get status() {
        return this.i.b;
    }
    set status(v) {
        this.i.b = ensureEnum(ValidationStatus_$type, v);
    }
    get owner() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        return r.externalObject;
    }
    set owner(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.owner && this.owner.name && this.owner.name == name) {
            return this.owner;
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
