import { IgrGroupByRecord } from "./igr-group-by-record";
import { GroupByRowSelectorTemplateDetails as GroupByRowSelectorTemplateDetails_internal } from "./GroupByRowSelectorTemplateDetails";
export class IgrGroupByRowSelectorTemplateDetails {
    createImplementation() {
        return new GroupByRowSelectorTemplateDetails_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get selectedCount() {
        return this.i.d;
    }
    set selectedCount(v) {
        this.i.d = +v;
    }
    get totalCount() {
        return this.i.e;
    }
    set totalCount(v) {
        this.i.e = +v;
    }
    get groupRow() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrGroupByRecord();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set groupRow(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.groupRow && this.groupRow.name && this.groupRow.name == name) {
            return this.groupRow;
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
