import { IgrSummaryOperand } from "./igr-summary-operand";
import { NumberSummaryOperand as NumberSummaryOperand_internal } from "./NumberSummaryOperand";
export class IgrNumberSummaryOperand extends IgrSummaryOperand {
    createImplementation() {
        let impl = new NumberSummaryOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    min(data) {
        let iv = this.i.k(data);
        return (iv);
    }
    max(data) {
        let iv = this.i.j(data);
        return (iv);
    }
    sum(data) {
        let iv = this.i.l(data);
        return (iv);
    }
    average(data) {
        let iv = this.i.i(data);
        return (iv);
    }
    operate(data, allData, fieldName, groupRecord) {
        let iv = this.i.h(data, allData, fieldName, (groupRecord == null ? null : groupRecord.i));
        let ret = [];
        for (let i = 0; i < iv.length; i++) {
            let impl = iv[i];
            if (!impl.externalObject) {
                let e = impl.nativeElement;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    }
}
