import { OperatorSelectorValueChangedEventArgs as OperatorSelectorValueChangedEventArgs_internal } from "./OperatorSelectorValueChangedEventArgs";
/**
 * Event arguments for the ComparisonOperatorSelector ValueChanged event.
*/
export class IgrOperatorSelectorValueChangedEventArgs {
    createImplementation() {
        return new OperatorSelectorValueChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get oldValue() {
        return this.i.oldValue;
    }
    set oldValue(v) {
        this.i.oldValue = v;
    }
    get newValue() {
        return this.i.newValue;
    }
    set newValue(v) {
        this.i.newValue = v;
    }
}
