import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { PivotAggregator as PivotAggregator_internal } from './PivotAggregator';
import { IgrPivotAggregator as IgrPivotAggregator } from './igr-pivot-aggregator';
export class IgrPivotAggregatorCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrPivotAggregator.$type) {
            IgrPivotAggregator.$type = markType(IgrPivotAggregator, "IgrPivotAggregator");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrPivotAggregator.$type) {
            IgrPivotAggregator.$type = markType(IgrPivotAggregator, "IgrPivotAggregator");
        }
        let coll = new SyncableObservableCollection$2(IgrPivotAggregator.$type, PivotAggregator_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrPivotAggregator();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
