/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IgrColumnModule } from './igr-column-module';
import { IgrGridToolbarModule } from './igr-grid-toolbar-module';
import { IgrGridToolbarActionsModule } from './igr-grid-toolbar-actions-module';
import { IgrGridToolbarTitleModule } from './igr-grid-toolbar-title-module';
import { IgrGridToolbarAdvancedFilteringModule } from './igr-grid-toolbar-advanced-filtering-module';
import { IgrGridToolbarExporterModule } from './igr-grid-toolbar-exporter-module';
import { IgrGridToolbarHidingModule } from './igr-grid-toolbar-hiding-module';
import { IgrGridToolbarPinningModule } from './igr-grid-toolbar-pinning-module';
import { IgrActionStripModule } from './igr-action-strip-module';
import { IgrGridActionsBaseDirectiveModule } from './igr-grid-actions-base-directive-module';
import { IgrGridEditingActionsModule } from './igr-grid-editing-actions-module';
import { IgrGridPinningActionsModule } from './igr-grid-pinning-actions-module';
import { IgrPivotDateDimensionModule } from './igr-pivot-date-dimension-module';
import { IgrPivotGridValueTemplateContext } from './igr-pivot-grid-value-template-context';
import { IgrPivotGrid } from './igr-pivot-grid';
import { IgrTemplateContainerModule } from "igniteui-react-core";
import { IgrChildContentModule } from "igniteui-react-core";
import { TypeRegistrar } from "igniteui-react-core";
export class IgrPivotGridModule {
    static register() {
        IgrColumnModule.register();
        IgrGridToolbarModule.register();
        IgrGridToolbarActionsModule.register();
        IgrGridToolbarTitleModule.register();
        IgrGridToolbarAdvancedFilteringModule.register();
        IgrGridToolbarExporterModule.register();
        IgrGridToolbarHidingModule.register();
        IgrGridToolbarPinningModule.register();
        IgrActionStripModule.register();
        IgrGridActionsBaseDirectiveModule.register();
        IgrGridEditingActionsModule.register();
        IgrGridPinningActionsModule.register();
        IgrPivotDateDimensionModule.register();
        TypeRegistrar.registerCons('IgrPivotGridValueTemplateContext', IgrPivotGridValueTemplateContext);
        TypeRegistrar.registerCons('IgrPivotGrid', IgrPivotGrid);
        TypeRegistrar.registerCons('IgrPivotGrid', IgrPivotGrid);
        IgrTemplateContainerModule.register();
        IgrChildContentModule.register();
    }
}
