import { ResponsiveStateEnteredEventArgs as ResponsiveStateEnteredEventArgs_internal } from "./ResponsiveStateEnteredEventArgs";
/**
 * Information about the entered action.
*/
export class IgrResponsiveStateEnteredEventArgs {
    createImplementation() {
        return new ResponsiveStateEnteredEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
}
