import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { RowExportingEventArgsDetail as RowExportingEventArgsDetail_internal } from "./RowExportingEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
/**
 * rowExporting event arguments
 * this.exporterService.rowExporting.subscribe((args: IRowExportingEventArgs) => {
 * // set args properties here
 * })
*/
export class IgrRowExportingEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new RowExportingEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Contains the exporting row data
    */
    get rowData() {
        return this.i.i;
    }
    set rowData(v) {
        this.i.i = v;
    }
    /**
     * Contains the exporting row index
    */
    get rowIndex() {
        return this.i.h;
    }
    set rowIndex(v) {
        this.i.h = +v;
    }
    /**
     * Skip the exporting row when set to true
    */
    get cancel() {
        return this.i.g;
    }
    set cancel(v) {
        this.i.g = ensureBool(v);
    }
}
