import { SummaryOperand as SummaryOperand_internal } from "./SummaryOperand";
export class IgrSummaryOperand {
    createImplementation() {
        let impl = new SummaryOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
    count(data) {
        let iv = this.i.d(data);
        return (iv);
    }
    operate(data, _allData, _fieldName, _groupRecord) {
        let iv = this.i.a(data, _allData, _fieldName, (_groupRecord == null ? null : _groupRecord.i));
        let ret = [];
        for (let i = 0; i < iv.length; i++) {
            let impl = iv[i];
            if (!impl.externalObject) {
                let e = impl.nativeElement;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    }
}
