import { IgrCellInfo } from "./igr-cell-info";
import { TemplateCellModel as TemplateCellModel_internal } from "./TemplateCellModel";
/**
 * Represents backing information for a template cell.
*/
export class IgrTemplateCellInfo extends IgrCellInfo {
    createImplementation() {
        return new TemplateCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets the value to provide to the template.
    */
    get value() {
        return this.i.ll;
    }
    set value(v) {
        this.i.ll = v;
    }
}
