/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType, PointUtil } from "igniteui-react-core";
import { INativeCell_$type } from "./INativeCell";
import { RenderingContext } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { Line } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { CanvasPlaceholderView } from "./CanvasPlaceholderView";
import { DeviceUtils } from "igniteui-react-core";
import { Random } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { truncate, isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var CanvasGridCellBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CanvasGridCellBase, _super);
    function CanvasGridCellBase(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.s = true;
        _this.o = true;
        _this.k = null;
        _this.bm = null;
        _this.q = false;
        _this.b0 = null;
        _this.l = false;
        _this.aq = 1;
        _this.au = 5;
        _this.aw = 5;
        _this.av = 5;
        _this.at = 5;
        _this.cy = null;
        _this.ai = 0;
        _this.ak = 0;
        _this.aj = 0;
        _this.ah = 0;
        _this.c6 = new Rectangle();
        _this.c2 = new Line();
        _this.c5 = new Line();
        _this.c3 = new Line();
        _this.c1 = new Line();
        _this.c4 = new Line();
        _this.a0 = 0;
        _this.a2 = 0;
        _this.a3 = 0;
        _this.a4 = 0;
        _this.bo = null;
        _this.j = null;
        _this.am = 0;
        _this.al = 0;
        _this.ao = 0;
        _this.an = 0;
        _this.u = true;
        _this.v = true;
        _this.a1 = NaN;
        _this.cx = new TextBlock();
        _this.c0 = Color.u(255, 0, 0, 0);
        _this.t = true;
        _this.as = 0;
        _this.a5 = 0;
        _this.cz = Color.u(255, 255, 255, 255);
        _this.m = false;
        _this.g = null;
        _this.c = 0;
        _this.e = 0;
        _this.bz = 1;
        _this.r = false;
        _this.az = 0;
        _this.ay = 0;
        _this.i = ((function () {
            var $ret = new FontInfo();
            $ret.p = "Verdana";
            $ret.e = 12;
            return $ret;
        })());
        _this.p = true;
        _this.br = -1;
        _this.bx = 0;
        _this.by = 0;
        _this.n = false;
        _this.bp = 0;
        _this.b = 0;
        _this.ar = NaN;
        _this.h = null;
        _this.bt = -1;
        _this.ap = NaN;
        _this.f = 1;
        _this.ax = 1;
        _this.bm = a;
        return _this;
    }
    Object.defineProperty(CanvasGridCellBase.prototype, "aa", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            this.o = a;
        },
        enumerable: false,
        configurable: true
    });
    CanvasGridCellBase.prototype.cm = function (a) {
        this.k = a;
    };
    CanvasGridCellBase.prototype.b7 = function () {
        this.o = true;
        if (this.k != null) {
            this.k();
        }
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "isCanvasBased", {
        get: function () {
            return true;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bn", {
        get: function () {
            return this.bm;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "isRemoved", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            this.q = a;
        },
        enumerable: false,
        configurable: true
    });
    CanvasGridCellBase.prototype.co = function (a) {
        this.b0 = a;
        this.o = true;
        this.s = true;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "templateContext", {
        get: function () {
            return this.j.h();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "w", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            this.l = a;
        },
        enumerable: false,
        configurable: true
    });
    CanvasGridCellBase.prototype.get_ac = function () {
        return false;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "ac", {
        get: function () {
            return this.get_ac();
        },
        enumerable: false,
        configurable: true
    });
    CanvasGridCellBase.prototype.ce = function (a, b, c, d, e) {
        this.o = true;
        this.cy = a;
        this.ai = b;
        this.ak = c;
        this.aj = d;
        this.ah = e;
        this.s = true;
    };
    CanvasGridCellBase.prototype.cf = function (a) {
        this.o = true;
        this.aq = a;
        this.cx._opacity = this.aq;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "bc", {
        get: function () {
            return this.au;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "be", {
        get: function () {
            return this.aw;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bd", {
        get: function () {
            return this.av;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bb", {
        get: function () {
            return this.at;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "a7", {
        get: function () {
            return this.ai;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "a9", {
        get: function () {
            return this.ak;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "a8", {
        get: function () {
            return this.aj;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "a6", {
        get: function () {
            return this.ah;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bg", {
        get: function () {
            return this.a0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bi", {
        get: function () {
            return this.a2;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bj", {
        get: function () {
            return this.a4;
        },
        enumerable: false,
        configurable: true
    });
    CanvasGridCellBase.prototype.get_ad = function () {
        return false;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "ad", {
        get: function () {
            return this.get_ad();
        },
        enumerable: false,
        configurable: true
    });
    CanvasGridCellBase.prototype.b3 = function (a, b, c, d, e, f) {
        var g = true;
        var h = true;
        var i = false;
        if (this.ad) {
            g = false;
            h = false;
            i = false;
        }
        this.b4(a, b, c, d, e, f, g, h, i);
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "resized", {
        get: function () {
            return this.u;
        },
        enumerable: false,
        configurable: true
    });
    CanvasGridCellBase.prototype.ensureCorrectSize = function () {
        this.u = this.x(this.ax);
        return this.u;
    };
    CanvasGridCellBase.prototype.b4 = function (a, b, c, d, e, f, g, h, i) {
        if (!this.t) {
            return;
        }
        if (this.bz != 1) {
            a.ae(this.bz);
        }
        var j = this.j;
        if (!this.v) {
            j = a;
        }
        this.ax = f;
        if (!i) {
            this.b5();
            this.ensureCorrectSize();
        }
        if (this.aa || this.u || i || !this.v) {
            this.aa = false;
            if (this.p || this.u || (this.i != null && this.i.i != this.br)) {
                this.p = false;
                this.br = this.i.i;
                j.ad(this.i);
            }
            if (f != 1) {
                j.aa();
                j.ab(f, f);
            }
            if (!this.v) {
                j.aa();
                var k = Math.round((d - b));
                var l = Math.round((e - c));
                j.ag(k, l);
            }
            if (g) {
                this.b8(j);
            }
            if (h) {
                this.b9(j);
            }
            if (!this.v) {
                j.z();
            }
            if (f != 1) {
                j.z();
            }
        }
        if (!i && this.v) {
            var m = Math.round((d - b) * f);
            var n = Math.round((e - c) * f);
            if (this.am == this.ao && this.al == this.an) {
                a.n(this.bu(), 1, m, n, this.am, this.al);
            }
            else {
                a.o(this.bu(), 1, 0, 0, this.am, this.al, m, n, this.am, this.al);
            }
        }
        if (this.bz != 1) {
            a.ae(1);
        }
    };
    CanvasGridCellBase.prototype.bu = function () {
        return this.bo.getNativeElement();
    };
    CanvasGridCellBase.prototype.b8 = function (a) {
        if (!this.m) {
            a.l(0, 0, this.ao, this.an);
        }
        this.c6.n = 0;
        this.c6.o = 0;
        this.c6.width = this.a5;
        this.c6.height = this.as;
        a.w(this.c6);
        if (this.cy != null) {
            if (this.ai > 0) {
                this.c2.ap = 0;
                this.c2.an = this.ai / 2;
                this.c2.aq = this.as;
                this.c2.ao = this.ai / 2;
                this.c2._stroke = this.cy;
                this.c2.ad = this.ai;
                a.s(this.c2);
            }
            if (this.aj > 0) {
                this.c3.ap = 0;
                this.c3.an = Math.max(0, (this.a5 - (this.aj / 2)));
                this.c3.aq = this.as;
                this.c3.ao = Math.max(0, (this.a5 - (this.aj / 2)));
                this.c3._stroke = this.cy;
                this.c3.ad = this.aj;
                a.s(this.c3);
            }
            if (this.ak > 0) {
                this.c5.ap = this.ak / 2;
                this.c5.an = this.ai;
                this.c5.aq = this.ak / 2;
                this.c5.ao = Math.max(0, (this.a5 - (this.aj / 2)));
                this.c5._stroke = this.cy;
                this.c5.ad = this.ak;
                a.s(this.c5);
            }
            if (this.ah > 0) {
                this.c1.ap = Math.max(0, this.as - (this.ah / 2));
                this.c1.an = this.ai;
                this.c1.aq = Math.max(0, this.as - (this.ah / 2));
                this.c1.ao = Math.max(0, (this.a5 - (this.aj / 2)));
                this.c1._stroke = this.cy;
                this.c1.ad = this.ah;
                a.s(this.c1);
            }
        }
    };
    CanvasGridCellBase.prototype.cl = function (a) {
        this.ax = a;
    };
    CanvasGridCellBase.prototype.renderStandardContent = function () {
        this.b4(this.j, 0, 0, 0, 0, this.ax, false, true, true);
    };
    CanvasGridCellBase.prototype.renderStandardBackground = function () {
        this.b4(this.j, 0, 0, 0, 0, this.ax, true, false, true);
    };
    CanvasGridCellBase.prototype.b9 = function (a) {
        if (this.s) {
            this.cw(a);
            this.s = false;
        }
        if (this.cx.al != null) {
            this.cx.n = this.a0;
            this.cx.o = this.a3;
            a.x(this.cx);
            if (this.r) {
                this.c4.ad = 1;
                this.c4.an = this.a0;
                this.c4.ap = this.a4 - 2;
                this.c4.ao = this.a0 + (this.a2 - this.a0);
                this.c4.aq = this.a4 - 2;
                this.c4._stroke = this.cx.ao;
                this.j.s(this.c4);
            }
        }
    };
    CanvasGridCellBase.prototype.b5 = function () {
        if (this.bo == null && this.v) {
            this.bo = this.bm.createElement("canvas");
            var a_1 = this.bm.get2DCanvasContext(this.bo);
            var b = ((function () {
                var $ret = new CanvasViewRenderer();
                $ret.h$d = a_1;
                return $ret;
            })());
            this.j = new RenderingContext(b, a_1);
            this.s = true;
        }
    };
    CanvasGridCellBase.prototype.x = function (a) {
        var b = Math.round(this.a5 * a);
        var c = Math.round(this.as * a);
        this.am = b;
        this.al = c;
        var d = this.bf(b);
        var e = this.bf(c);
        if (d != this.ao || e != this.an) {
            this.bo.setAttribute("width", d + "px");
            this.bo.setAttribute("height", e + "px");
            this.ao = d;
            this.an = e;
            this.am = b;
            this.al = c;
            return true;
        }
        return false;
    };
    CanvasGridCellBase.prototype.bf = function (a) {
        return a;
    };
    CanvasGridCellBase.prototype.ck = function (a, b, c, d) {
        this.o = true;
        this.au = a;
        this.aw = b;
        this.av = c;
        this.at = d;
        this.s = true;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "bh", {
        get: function () {
            return this.a1;
        },
        set: function (a) {
            this.a1 = a;
        },
        enumerable: false,
        configurable: true
    });
    CanvasGridCellBase.prototype.cp = function (a) {
        var _this = this;
        this.o = true;
        this.c0 = a;
        this.cx.ao = ((function () {
            var $ret = new Brush();
            $ret.color = _this.c0;
            return $ret;
        })());
    };
    CanvasGridCellBase.prototype.get_ab = function () {
        return false;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "ab", {
        get: function () {
            return this.get_ab();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "ae", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            this.o = true;
            this.t = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "ba", {
        get: function () {
            return this.as;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bl", {
        get: function () {
            return this.a5;
        },
        enumerable: false,
        configurable: true
    });
    CanvasGridCellBase.prototype.ch = function (a) {
        this.o = true;
        this.as = a;
        this.c6.height = this.as;
    };
    CanvasGridCellBase.prototype.cr = function (a) {
        this.o = true;
        this.a5 = a;
        this.c6.width = this.a5;
        this.s = true;
    };
    CanvasGridCellBase.prototype.b2 = function () {
        if (!this.ac) {
            return;
        }
        this.l = true;
        this.g = new CanvasPlaceholderView();
        this.c = 0;
        this.e = 1;
        this.g.l = Color.u(120, 120, 120, 120);
        this.g.h = 0;
    };
    CanvasGridCellBase.prototype.cd = function (a) {
        var _this = this;
        this.o = true;
        this.cz = a;
        this.m = this.cz.l == 255;
        this.c6._fill = ((function () {
            var $ret = new Brush();
            $ret.color = _this.cz;
            return $ret;
        })());
    };
    CanvasGridCellBase.prototype.cj = function (a) {
        this.o = true;
        this.bz = a;
    };
    CanvasGridCellBase.prototype.cn = function (a) {
        this.r = a;
        this.o = true;
    };
    CanvasGridCellBase.prototype.cv = function (a) {
        if (!this.ac) {
            return;
        }
        this.o = true;
        this.g.h = (a * 0.20000000298023224);
    };
    CanvasGridCellBase.prototype.b6 = function (a, b, c, d) {
        if (this.g != null) {
            var e = this.az;
            var f = this.ay;
            if (this.e == 1) {
                b = truncate((b + (d / 2) - (f / 2)));
            }
            else if (this.e == 2) {
                b = truncate((b + (d) - (f)));
            }
            if (this.c == 1) {
                a = truncate((a + (c / 2) - (e / 2)));
            }
            else if (this.c == 2) {
                a = truncate((a + (c) - (e)));
            }
        }
    };
    CanvasGridCellBase.prototype.cg = function (a) {
        this.i = a;
        this.p = true;
        this.o = true;
        this.s = true;
    };
    CanvasGridCellBase.prototype.cu = function (a) {
        if (!this.ac) {
            return;
        }
        this.o = true;
        var b = DeviceUtils.f(12);
        if (a.ag != null && !isNaN_(a.ag.e)) {
            b = a.ag.e;
        }
        if (this.ay != b) {
            this.ay = b;
        }
        var c = a.gu * 0.2;
        var d = a.fc * 0.6;
        if (this.az >= c && this.az <= d) {
            return;
        }
        var e = (CanvasGridCellBase.bw.nextDouble() * (d - c) + c);
        if (this.az != e) {
            this.az = e;
        }
    };
    CanvasGridCellBase.prototype.cs = function (a, b) {
        if (!this.ac) {
            return;
        }
        this.o = true;
        this.c = a;
        this.e = b;
    };
    CanvasGridCellBase.prototype.ct = function (a) {
        if (!this.ac) {
            return;
        }
        this.o = true;
    };
    CanvasGridCellBase.prototype.cc = function (a) {
        this.a = a;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "d", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    CanvasGridCellBase.prototype.ci = function (a) {
        this.b = a;
        this.o = true;
        this.s = true;
    };
    CanvasGridCellBase.prototype.cw = function (a) {
        if (this.b0 == null) {
            return;
        }
        if (a == null) {
            return;
        }
        if (this.p || (this.i != null && this.i.i != this.br)) {
            this.p = false;
            this.br = this.i.i;
            a.ad(this.i);
        }
        var b;
        if (this.h != this.i || this.bt != this.i.i) {
            this.h = this.i;
            this.bt = this.i.i;
            this.ar = FontUtil.getCurrentFontHeight(this.bm, this.i);
        }
        b = this.ar;
        var c = 0;
        var d = 0;
        var e = this.a5;
        var f = this.as;
        e -= (this.ai + this.au + this.aj + this.av);
        f -= (this.ak + this.aw + this.ah + this.at);
        e = Math.max(e, 0);
        f = Math.max(f, 0);
        var g = e;
        if (!isNaN_(this.a1) && this.a1 < e) {
            g = this.a1;
        }
        var h = this.bk(this.cx, this.b0, g, a);
        switch (this.b) {
            case 0:
                c = this.au + this.ai;
                break;
            case 3:
            case 1:
                c = this.au + this.ai + ((e / 2) - (h / 2));
                break;
            case 2:
                c = Math.max(0, (this.a5 - (this.av + this.aj))) - h;
                break;
        }
        switch (this.f) {
            case 0:
                d = this.aw + this.ak;
                break;
            case 3:
            case 1:
                d = this.aw + this.ak + ((f / 2) - (b / 2));
                break;
            case 2:
                d = Math.max(0, (this.as - (this.at + this.ah))) - b;
                break;
        }
        this.a0 = c;
        this.a2 = this.a0 + h;
        this.a3 = d;
        this.a4 = this.a3 + (b / 2);
        this.o = true;
    };
    CanvasGridCellBase.prototype.bk = function (a, b, c, d) {
        var e = b;
        var f = e.length;
        var g = ("\u2026");
        if (isNaN_(this.ap)) {
            this.ap = d.g(g);
        }
        if (c <= this.ap) {
            a.al = g;
            return this.ap;
        }
        var h = d.g(e);
        if (h <= c) {
            a.al = b;
            return h;
        }
        var i = c / h;
        var j = truncate(Math.ceil(f * i));
        var k = e.substr(0, j) + g;
        var l = d.g(k);
        if (l > c) {
            f = j;
        }
        else {
            j = j + 1;
            k = e.substr(0, j) + g;
            l = d.g(k);
            if (l > c) {
                f = j;
            }
        }
        while (h > c && f > 0) {
            f--;
            e = e.substr(0, f) + g;
            h = d.g(e);
        }
        a.al = e;
        return h;
    };
    CanvasGridCellBase.prototype.cq = function (a) {
        this.f = a;
        this.o = true;
        this.s = true;
    };
    CanvasGridCellBase.prototype.ag = function (a) {
        return a.isClickActionDesired;
    };
    CanvasGridCellBase.prototype.onContactStarted = function (a, b) {
        if (this.a != null && this.ag(this.a)) {
            this.bx = a.pageX;
            this.by = a.pageY;
            this.a.mouseDownCell(this.bx, this.by);
        }
    };
    CanvasGridCellBase.prototype.onContactMoved = function (a, b) {
        if (this.a != null && this.ag(this.a)) {
            var c = a.pageX;
            var d = a.pageY;
            if (this.a.isMouseDown) {
                if (b) {
                    if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bs || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bs) {
                        this.a.mouseUpCell(c, d);
                    }
                    else {
                        a.stopPropagation();
                    }
                }
                else {
                    if (PointUtil.equals(this.a.mousePosition, null)) {
                        this.a.mouseUpCell(c, d);
                    }
                    else {
                        if (Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bq || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bq) {
                            this.a.isControlPressed = a.ctrlKey;
                            this.a.dragStarted();
                        }
                    }
                }
            }
        }
    };
    CanvasGridCellBase.prototype.onContactCompleted = function (a, b) {
        if (this.a != null && this.ag(this.a)) {
            var c = a.pageX;
            var d = a.pageY;
            if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bs || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bs || this.a.isDrag) {
                this.a.mouseUpCell(c, d);
            }
            if (this.a.isCellDown()) {
                this.a.isControlPressed = a.ctrlKey;
                this.a.isShiftPressed = a.shiftKey;
                switch (a.which) {
                    case 1:
                        this.a.clickCell(0);
                        break;
                    case 2:
                        this.a.clickCell(1);
                        break;
                    case 3:
                        this.a.clickCell(2);
                        break;
                    default:
                        this.a.clickCell(3);
                        break;
                }
                this.a.mouseUpCell(a.pageX, a.pageY);
            }
        }
    };
    CanvasGridCellBase.prototype.onDoubleClick = function (a) {
        switch (a.which) {
            case 1:
                this.a.doubleClicked(0);
                break;
            case 2:
                this.a.doubleClicked(1);
                break;
            case 3:
                this.a.doubleClicked(2);
                break;
            default:
                this.a.doubleClicked(3);
                break;
        }
    };
    CanvasGridCellBase.prototype.detach = function () {
    };
    CanvasGridCellBase.$t = markType(CanvasGridCellBase, 'CanvasGridCellBase', Base.$, [INativeCell_$type]);
    CanvasGridCellBase.bw = new Random(0);
    CanvasGridCellBase.bs = 10;
    CanvasGridCellBase.bq = 3;
    return CanvasGridCellBase;
}(Base));
export { CanvasGridCellBase };
