/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-react-core";
/**
 * Identifies the operator type of a column comparison condition.
 */
export var ColumnComparisonConditionOperatorType = /*@__PURE__*/ (function (ColumnComparisonConditionOperatorType) {
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Equals"] = 0] = "Equals";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["NotEquals"] = 1] = "NotEquals";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["LessThan"] = 2] = "LessThan";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["LessThanOrEqualTo"] = 3] = "LessThanOrEqualTo";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["GreaterThan"] = 4] = "GreaterThan";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["GreaterThanOrEqualTo"] = 5] = "GreaterThanOrEqualTo";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Top"] = 6] = "Top";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Bottom"] = 7] = "Bottom";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["TopPercentile"] = 8] = "TopPercentile";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["BottomPercentile"] = 9] = "BottomPercentile";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["True"] = 10] = "True";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["False"] = 11] = "False";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Contains"] = 12] = "Contains";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["DoesNotContain"] = 13] = "DoesNotContain";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["StartsWith"] = 14] = "StartsWith";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["DoesNotStartWith"] = 15] = "DoesNotStartWith";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["EndsWith"] = 16] = "EndsWith";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["DoesNotEndWith"] = 17] = "DoesNotEndWith";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Today"] = 18] = "Today";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Tomorrow"] = 19] = "Tomorrow";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Yesterday"] = 20] = "Yesterday";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["NextWeek"] = 21] = "NextWeek";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["ThisWeek"] = 22] = "ThisWeek";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["LastWeek"] = 23] = "LastWeek";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["NextMonth"] = 24] = "NextMonth";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["ThisMonth"] = 25] = "ThisMonth";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["LastMonth"] = 26] = "LastMonth";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["NextQuarter"] = 27] = "NextQuarter";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["ThisQuarter"] = 28] = "ThisQuarter";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["LastQuarter"] = 29] = "LastQuarter";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["NextYear"] = 30] = "NextYear";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["ThisYear"] = 31] = "ThisYear";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["LastYear"] = 32] = "LastYear";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["YearToDate"] = 33] = "YearToDate";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Q1"] = 34] = "Q1";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Q2"] = 35] = "Q2";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Q3"] = 36] = "Q3";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Q4"] = 37] = "Q4";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Month"] = 38] = "Month";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Year"] = 39] = "Year";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Empty"] = 40] = "Empty";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["NotEmpty"] = 41] = "NotEmpty";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["IsNull"] = 42] = "IsNull";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["IsNotNull"] = 43] = "IsNotNull";
    ColumnComparisonConditionOperatorType[ColumnComparisonConditionOperatorType["Custom"] = 44] = "Custom";
    return ColumnComparisonConditionOperatorType;
})({});
/**
 * @hidden
 */
export var ColumnComparisonConditionOperatorType_$type = /*@__PURE__*/ markEnum('ColumnComparisonConditionOperatorType', 'Equals,0|NotEquals,1|LessThan,2|LessThanOrEqualTo,3|GreaterThan,4|GreaterThanOrEqualTo,5|Top,6|Bottom,7|TopPercentile,8|BottomPercentile,9|True,10|False,11|Contains,12|DoesNotContain,13|StartsWith,14|DoesNotStartWith,15|EndsWith,16|DoesNotEndWith,17|Today,18|Tomorrow,19|Yesterday,20|NextWeek,21|ThisWeek,22|LastWeek,23|NextMonth,24|ThisMonth,25|LastMonth,26|NextQuarter,27|ThisQuarter,28|LastQuarter,29|NextYear,30|ThisYear,31|LastYear,32|YearToDate,33|Q1,34|Q2,35|Q3,36|Q4,37|Month,38|Year,39|Empty,40|NotEmpty,41|IsNull,42|IsNotNull,43|Custom,44');
