/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseEditorView } from "./BaseEditorView";
import { DatePicker } from "igniteui-react-inputs";
import { runOn, delegateCombine, delegateRemove, markType } from "igniteui-react-core";
import { dateMinValue } from "igniteui-react-core";
/**
 * @hidden
 */
var DateEditorView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DateEditorView, _super);
    function DateEditorView(a, b, c) {
        var _this = _super.call(this, a, c) || this;
        _this.ad = null;
        _this.y = null;
        _this.z = null;
        _this.ab = false;
        _this.aa = false;
        var d = a.createElement("div");
        d.setRawStyleProperty("width", "100%");
        d.setRawStyleProperty("margin-top", "-10px");
        d.setRawStyleProperty("height", "38px");
        _this.container = d;
        var e = a.getSubRenderer(d);
        var f = a.createElement("div");
        e.append(f);
        var g = a.createElement("div");
        e.append(g);
        _this.y = new DatePicker();
        _this.y.ay = false;
        _this.y.provideContainer(e);
        _this.y.w = b;
        _this.y.y = 3;
        _this.y.az = _this.showClearButton;
        _this.y.a0 = _this.ac;
        _this.y.dx = _this.textColor;
        _this.y.be = -1;
        var h = e.getExternal(_this.y, e.rootWrapper, null);
        if (_this.z != null) {
            _this.y.ad = _this.z;
        }
        _this.attachEvents();
        return _this;
    }
    Object.defineProperty(DateEditorView.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.u("FormatString", b, this.ad);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DateEditorView.prototype, "ac", {
        get: function () {
            return this.aa;
        },
        set: function (a) {
            var b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.u("ShowTodayButton", b, this.aa);
            }
        },
        enumerable: false,
        configurable: true
    });
    DateEditorView.prototype.setFont = function (a) {
        this.z = a;
        if (this.y != null && this.z != null) {
            this.y.ad = this.z;
        }
    };
    DateEditorView.prototype.attachEvents = function () {
        if (this.y != null) {
            var a = this.y;
            a.selectedValueChanged = delegateCombine(a.selectedValueChanged, runOn(this, this.onDatePickerValueChanged));
            var b = this.y;
            b.gotFocus = delegateCombine(b.gotFocus, runOn(this, this.onDatePickerGotFocus));
            var c = this.y;
            c.lostFocus = delegateCombine(c.lostFocus, runOn(this, this.onDatePickerLostFocus));
            var d = this.y;
            d.keyDown = delegateCombine(d.keyDown, runOn(this, this.onInputKeyDown));
            var e = this.y;
            e.changing = delegateCombine(e.changing, runOn(this, this.onInputChanging));
        }
    };
    DateEditorView.prototype.detachEvents = function () {
        if (this.y != null) {
            var a = this.y;
            a.selectedValueChanged = delegateRemove(a.selectedValueChanged, runOn(this, this.onDatePickerValueChanged));
            var b = this.y;
            b.gotFocus = delegateRemove(b.gotFocus, runOn(this, this.onDatePickerGotFocus));
            var c = this.y;
            c.lostFocus = delegateRemove(c.lostFocus, runOn(this, this.onDatePickerLostFocus));
            var d = this.y;
            d.keyDown = delegateRemove(d.keyDown, runOn(this, this.onInputKeyDown));
            var e = this.y;
            e.changing = delegateRemove(e.changing, runOn(this, this.onInputChanging));
        }
    };
    DateEditorView.prototype.onTargetChanged = function () {
        if (this.y != null) {
            this.ab = true;
            this.focus();
            this.ab = false;
        }
    };
    DateEditorView.prototype.onEditStarted = function () {
        _super.prototype.onEditStarted.call(this);
        if (!this.a.isEditRefocusDesired) {
            this.focus();
        }
    };
    DateEditorView.prototype.onEditEnded = function () {
        _super.prototype.onEditEnded.call(this);
        if (this.a.isEditRefocusDesired) {
            var a = this.h.rootWrapper.getNativeElement();
            if (a == document.activeElement || a.contains(document.activeElement)) {
                this.focus();
            }
        }
    };
    DateEditorView.prototype.s = function () {
        if (this.y != null) {
            this.y.focus(true);
            this.y.df();
        }
    };
    DateEditorView.prototype.ag = function () {
        if (this.y != null) {
            this.y.cq();
        }
    };
    DateEditorView.prototype.u = function (a, b, c) {
        _super.prototype.u.call(this, a, b, c);
        switch (a) {
            case "FormatString":
                this.ak();
                break;
            case "ShowClearButton":
                if (this.y != null) {
                    this.y.az = this.showClearButton;
                }
                break;
            case "ShowTodayButton":
                if (this.y != null) {
                    this.y.a0 = this.ac;
                }
                break;
        }
    };
    DateEditorView.prototype.ak = function () {
        this.y.by = this.ae;
    };
    DateEditorView.prototype.w = function () {
        this.ab = true;
        if (this.y != null) {
            if (this.value == null) {
                this.y.value = dateMinValue();
            }
            else {
                this.y.value = this.value;
            }
            if (this.focusOnValueChanged) {
                this.s();
            }
        }
        this.ab = false;
    };
    DateEditorView.prototype.r = function () {
        if (this.y != null) {
            this.y.av = !this.isEnabled;
        }
    };
    DateEditorView.prototype.v = function () {
        _super.prototype.v.call(this);
        if (this.y != null) {
            this.y.dx = this.textColor;
        }
    };
    DateEditorView.prototype.onDatePickerValueChanged = function (a, b) {
        this.am();
    };
    DateEditorView.prototype.am = function () {
        if (this.ab) {
            return;
        }
        if (+(this.y.value) != +(dateMinValue())) {
            this.q(this.y.value, false);
        }
        else if (+(this.y.value) == +(dateMinValue())) {
            this.q(null, false);
        }
        else {
            this.q(this.value, false);
        }
    };
    DateEditorView.prototype.onInputChanging = function (a, b) {
        this.p();
    };
    DateEditorView.prototype.onDatePickerLostFocus = function (a, b) {
        this.o();
    };
    DateEditorView.prototype.onDatePickerGotFocus = function (a, b) {
        this.n();
    };
    DateEditorView.prototype.getEditorValue = function () {
        if (this.y != null) {
            return this.y.value;
        }
        return null;
    };
    DateEditorView.prototype.setEditorValue = function (a) {
        if (this.y != null) {
            this.y.value = a != null ? a : dateMinValue();
        }
    };
    DateEditorView.$t = markType(DateEditorView, 'DateEditorView', BaseEditorView.$);
    return DateEditorView;
}(BaseEditorView));
export { DateEditorView };
