/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseEventArgsDetail } from "./BaseEventArgsDetail";
import { DisplayDensity_$type } from "./DisplayDensity";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
/**
 * @hidden
 */
var DensityChangedEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DensityChangedEventArgsDetail, _super);
    function DensityChangedEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(DensityChangedEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.n("oldDensity");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DisplayDensity_$type, EnumUtil.getEnumValue(DisplayDensity_$type, this.b.f(DisplayDensity_$type, ret_)));
            return EnumUtil.getEnumValue(DisplayDensity_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(DisplayDensity_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b.v("oldDensity", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DensityChangedEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.n("newDensity");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DisplayDensity_$type, EnumUtil.getEnumValue(DisplayDensity_$type, this.b.f(DisplayDensity_$type, ret_)));
            return EnumUtil.getEnumValue(DisplayDensity_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(DisplayDensity_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b.v("newDensity", value_);
        },
        enumerable: false,
        configurable: true
    });
    DensityChangedEventArgsDetail.$t = markType(DensityChangedEventArgsDetail, 'DensityChangedEventArgsDetail', BaseEventArgsDetail.$);
    return DensityChangedEventArgsDetail;
}(BaseEventArgsDetail));
export { DensityChangedEventArgsDetail };
