/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "igniteui-react";
import { WCNativeHelper } from "igniteui-react";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { DisplayDensity_$type } from "./DisplayDensity";
import { DensityChangedEventArgs } from "./DensityChangedEventArgs";
/**
 * @hidden
 */
var DisplayDensityBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DisplayDensityBase, _super);
    function DisplayDensityBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = new WCNativeHelper();
        _this.e = null;
        _this.densityChanged = null;
        return _this;
    }
    Object.defineProperty(DisplayDensityBase.prototype, "d", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DisplayDensityBase.prototype, "nativeElement", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
            this.c.o = this.e;
        },
        enumerable: false,
        configurable: true
    });
    DisplayDensityBase.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(DisplayDensityBase.prototype, "b", {
        get: function () {
            var ret_ = this.d.n("displayDensity");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DisplayDensity_$type, EnumUtil.getEnumValue(DisplayDensity_$type, this.d.f(DisplayDensity_$type, ret_)));
            return EnumUtil.getEnumValue(DisplayDensity_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(DisplayDensity_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("displayDensity", value_);
        },
        enumerable: false,
        configurable: true
    });
    DisplayDensityBase.prototype.densityChangedChanged = function () {
        var _this = this;
        if (this.densityChanged != null) {
            this.d.r("densityChanged", function (a) { return _this.densityChanged(_this, DensityChangedEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("densityChanged");
        }
    };
    DisplayDensityBase.$t = markType(DisplayDensityBase, 'DisplayDensityBase', BaseElement.$);
    return DisplayDensityBase;
}(BaseElement));
export { DisplayDensityBase };
