/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridBaseDirective } from "./GridBaseDirective";
import { markType } from "igniteui-react-core";
import { GridMasterDetailContext } from "./GridMasterDetailContext";
import { GroupByRecord } from "./GroupByRecord";
import { GroupingExpression } from "./GroupingExpression";
import { GroupByExpandState } from "./GroupByExpandState";
import { GridGroupingStrategy } from "./GridGroupingStrategy";
import { GroupByRowSelectorTemplateContext } from "./GroupByRowSelectorTemplateContext";
import { GroupByRowTemplateContext } from "./GroupByRowTemplateContext";
import { CellType } from "./CellType";
import { ForOfStateEventArgs } from "./ForOfStateEventArgs";
import { GroupingDoneEventArgs } from "./GroupingDoneEventArgs";
import { RowType } from "./RowType";
import { stringStartsWith } from "igniteui-react-core";
import { parseBool } from "igniteui-react-core";
/**
 * @hidden
 */
var Grid = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Grid, _super);
    function Grid() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.hj = null;
        _this.hi = null;
        _this.hk = null;
        _this.hl = null;
        _this.dataPreLoad = null;
        _this.groupingDone = null;
        return _this;
    }
    Object.defineProperty(Grid.prototype, "ha", {
        get: function () {
            var ret_ = this.d.n("groupsExpanded");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("groupsExpanded", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "hn", {
        get: function () {
            return this.hj;
        },
        set: function (a) {
            this.hj = a;
            this.d.s("dropAreaTemplate", function (b) { return b; }, this.hj);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "hm", {
        get: function () {
            return this.hi;
        },
        set: function (a) {
            this.hi = a;
            this.d.s("detailTemplate", function (b) { return new GridMasterDetailContext(); }, this.hi);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "hr", {
        get: function () {
            var ret_ = this.d.n("id");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("id", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "g1", {
        get: function () {
            var ret_ = this.d.m("groupsRecords", function (a) { return new GroupByRecord(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "gx", {
        get: function () {
            var ret_ = this.d.n("data");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("data", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "hg", {
        get: function () {
            var ret_ = this.d.n("totalItemCount");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("totalItemCount", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "g0", {
        get: function () {
            var ret_ = this.d.m("groupingExpressions", function (a) { return new GroupingExpression(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("groupingExpressions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "gz", {
        get: function () {
            var ret_ = this.d.m("groupingExpansionState", function (a) { return new GroupByExpandState(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("groupingExpansionState", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "hb", {
        get: function () {
            var ret_ = this.d.n("hideGroupedColumns");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("hideGroupedColumns", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "g6", {
        get: function () {
            var ret_ = this.d.m("groupStrategy", function (a) { return new GridGroupingStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("groupStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "hq", {
        get: function () {
            var ret_ = this.d.n("dropAreaMessage");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("dropAreaMessage", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "ho", {
        get: function () {
            return this.hk;
        },
        set: function (a) {
            this.hk = a;
            this.d.s("groupByRowSelectorTemplate", function (b) { return new GroupByRowSelectorTemplateContext(); }, this.hk);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "hp", {
        get: function () {
            return this.hl;
        },
        set: function (a) {
            this.hl = a;
            this.d.s("groupRowTemplate", function (b) { return new GroupByRowTemplateContext(); }, this.hl);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "he", {
        get: function () {
            var ret_ = this.d.n("showGroupArea");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("showGroupArea", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Grid.prototype, "g2", {
        get: function () {
            var ret_ = this.d.m("selectedCells", function (a) { return new CellType(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Grid.prototype.dataPreLoadChanged = function () {
        var _this = this;
        if (this.dataPreLoad != null) {
            this.d.r("dataPreLoad", function (a) { return _this.dataPreLoad(_this, ForOfStateEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("dataPreLoad");
        }
    };
    Grid.prototype.groupingDoneChanged = function () {
        var _this = this;
        if (this.groupingDone != null) {
            this.d.r("groupingDone", function (a) { return _this.groupingDone(_this, GroupingDoneEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("groupingDone");
        }
    };
    Grid.prototype.hy = function (a) {
        this.nativeElement.groupBy(this.d.i(a));
    };
    Grid.prototype.hu = function (a) {
        this.nativeElement.clearGrouping(this.d.i(a));
    };
    Grid.prototype.hc = function (a) {
        return (this.nativeElement.isExpandedGroup(this.d.i(a)));
    };
    Grid.prototype.h2 = function (a) {
        this.nativeElement.toggleGroup(this.d.i(a));
    };
    Grid.prototype.h0 = function (a, b) {
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.selectRowsInGroup(this.d.i(a), this.d.i(b));
    };
    Grid.prototype.hw = function (a) {
        this.nativeElement.deselectRowsInGroup(this.d.i(a));
    };
    Grid.prototype.hx = function (a) {
        this.nativeElement.fullyExpandGroup(this.d.i(a));
    };
    Grid.prototype.h1 = function () {
        this.nativeElement.toggleAllGroupRows();
    };
    Grid.prototype.gy = function (a, b) {
        if (a === void 0) {
            a = false;
        }
        if (b === void 0) {
            b = false;
        }
        return (this.nativeElement.getSelectedData(this.d.i(a), this.d.i(b)));
    };
    Grid.prototype.g8 = function (a) {
        return this.d.g(this.nativeElement.getRowByIndex(this.d.i(a)), function (b) { return new RowType(); });
    };
    Grid.prototype.g9 = function (a) {
        return this.d.g(this.nativeElement.getRowByKey(this.d.i(a)), function (b) { return new RowType(); });
    };
    Grid.prototype.g3 = function (a, b) {
        return this.d.g(this.nativeElement.getCellByColumn(this.d.i(a), this.d.i(b)), function (c) { return new CellType(); });
    };
    Grid.prototype.g4 = function (a, b) {
        return this.d.g(this.nativeElement.getCellByKey(this.d.i(a), this.d.i(b)), function (c) { return new CellType(); });
    };
    Grid.prototype.hd = function (a, b) {
        if (b === void 0) {
            b = -1;
        }
        return (this.nativeElement.pinRow(this.d.i(a), this.d.i(b)));
    };
    Grid.prototype.hf = function (a) {
        return (this.nativeElement.unpinRow(this.d.i(a)));
    };
    Grid.prototype.hh = function (a) {
        if (a == null) {
            return null;
        }
        if (!stringStartsWith(a, "@@e:")) {
            return null;
        }
        a = a.substr(4);
        var b = a.split('@');
        var c = b[0];
        var d = b[1];
        switch (c) {
            case "RowType":
                if (stringStartsWith(d, "Index:")) {
                    d = d.substr(6);
                    return this.externalObject.getRowByIndex(parseInt(d));
                }
                else if (stringStartsWith(d, "Key:")) {
                    d = d.substr(4);
                    var g = this.gx;
                    for (var f = 0; f < g.length; f++) {
                        var e = g[f];
                        var h = e[this.ed];
                        if (h != null) {
                            if ((typeof h == "string")) {
                                return this.externalObject.getRowByKey(d);
                            }
                            if ((typeof h == "number")) {
                                return this.externalObject.getRowByKey(parseFloat(d));
                            }
                            if ((typeof h == "boolean")) {
                                return this.externalObject.getRowByKey(parseBool(d));
                            }
                            if ((h instanceof Date)) {
                                return this.externalObject.getRowByKey(new Date(d));
                            }
                            break;
                        }
                    }
                    return this.externalObject.getRowByKey(d);
                }
                return null;
        }
        return null;
    };
    Grid.prototype.hs = function (a) {
        this.nativeElement.addRow(a);
    };
    Grid.prototype.ht = function (a) {
        this.nativeElement.beginAddRowByIndex(a);
    };
    Grid.$t = markType(Grid, 'Grid', GridBaseDirective.$);
    return Grid;
}(GridBaseDirective));
export { Grid };
