/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridColumnOptionsViewBase } from "./GridColumnOptionsViewBase";
import { FontInfo } from "igniteui-react-core";
import { GridColumnOptionsUtilities } from "./GridColumnOptionsUtilities";
import { markType, enumGetBox, runOn, delegateCombine, typeCast } from "igniteui-react-core";
import { GridColumnOptionsBase } from "./GridColumnOptionsBase";
import { StringComparer } from "igniteui-react-core";
import { GridColumnOptionsSimpleSectionBase } from "./GridColumnOptionsSimpleSectionBase";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { truncate } from "igniteui-react-core";
import { stringIsNullOrWhiteSpace } from "igniteui-react-core";
import { stringFormat1 } from "igniteui-react-core";
/**
 * @hidden
 */
var GridColumnOptionsView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridColumnOptionsView, _super);
    function GridColumnOptionsView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.v = null;
        _this.z = null;
        _this.x = null;
        _this.y = null;
        _this.q = null;
        _this.aa = null;
        _this.o = null;
        _this.t = null;
        _this.s = null;
        _this.w = null;
        _this.r = null;
        _this.u = null;
        return _this;
    }
    Object.defineProperty(GridColumnOptionsView.prototype, "n", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    GridColumnOptionsView.prototype.p = function () {
        var a = this.e;
        var b = a.createElement("div");
        var c = a.createElement("header");
        b.append(c);
        var d = a.createElement("h4");
        c.append(d);
        c.setRawText(this.n.dx);
        return b;
    };
    GridColumnOptionsView.prototype.ad = function () {
        if (null != this.u) {
            var a = this.n;
            var b = a.dx;
            this.u.setRawText(b);
            if (null != a.cf) {
                this.u.setStyleProperty("font", a.cf.fontString);
            }
        }
    };
    GridColumnOptionsView.prototype.j = function () {
        _super.prototype.j.call(this);
        this.m();
    };
    GridColumnOptionsView.prototype.m = function () {
        _super.prototype.m.call(this);
        if (null != this.g) {
            this.g.setStyleProperty("padding", this.n.d5());
            this.g.setStyleProperty("box-sizing", "border-box");
        }
        this.ad();
        var a;
        var b;
        if (null != this.v) {
            a = this.v;
            b = this.n.cp;
            GridColumnOptionsUtilities.j(a, b, "flex");
        }
        if (null != this.z) {
            a = this.z;
            b = this.n.c3;
            GridColumnOptionsUtilities.j(a, b);
        }
        if (null != this.x) {
            a = this.x;
            b = this.n.cx;
            GridColumnOptionsUtilities.j(a, b);
        }
        if (null != this.y) {
            a = this.y;
            b = this.n.c0;
            GridColumnOptionsUtilities.j(a, b);
        }
        if (null != this.w) {
            a = this.w;
            b = this.n.cu;
            GridColumnOptionsUtilities.j(a, b);
        }
        if (null != this.r) {
            a = this.r;
            b = this.n.co;
            GridColumnOptionsUtilities.j(a, b);
        }
        if (null != this.q) {
            a = this.q;
            b = this.n.cl;
            GridColumnOptionsUtilities.j(a, b);
        }
        if (null != this.aa) {
            a = this.aa;
            b = this.n.c6;
            GridColumnOptionsUtilities.j(a, b);
        }
        if (null != this.o) {
            a = this.o;
            GridColumnOptionsUtilities.j(a, true);
        }
    };
    GridColumnOptionsView.prototype.ab = function () {
        var a = this.e;
        var b = a.createElement("header");
        this.v.append(b);
        var c = a.createElement("h4");
        c.setStyleProperty("margin-top", "0");
        c.setStyleProperty("margin-bottom", "0");
        b.append(c);
        this.u = c;
        this.t.append(b);
        this.ad();
    };
    GridColumnOptionsView.prototype.ac = function (a, b, c, d, e, f, g, h, i, j, k) {
        this.v = a;
        this.z = b;
        this.x = c;
        this.y = d;
        this.q = e;
        this.aa = f;
        this.o = g;
        this.t = h;
        this.s = i;
        this.w = j;
        this.r = k;
        this.s.setStyleProperty("display", "flex");
        this.s.setStyleProperty("flex-direction", "row");
        this.s.setStyleProperty("flex-wrap", "no-wrap");
        this.s.setStyleProperty("align-items", "center");
        this.s.setStyleProperty("justify-content", "space-between");
        this.v.setStyleProperty("display", "flex");
        this.v.setStyleProperty("flex-direction", "row");
        this.v.setStyleProperty("flex-wrap", "no-wrap");
        this.v.setStyleProperty("align-items", "center");
        this.v.setStyleProperty("justify-content", "space-between");
        this.v.setStyleProperty("margin-bottom", "5px");
        this.ab();
        this.z.setStyleProperty("margin-bottom", "8px");
        this.x.setStyleProperty("margin-bottom", "8px");
        this.y.setStyleProperty("margin-bottom", "8px");
    };
    GridColumnOptionsView.$t = markType(GridColumnOptionsView, 'GridColumnOptionsView', GridColumnOptionsViewBase.$);
    return GridColumnOptionsView;
}(GridColumnOptionsViewBase));
export { GridColumnOptionsView };
/**
 * @hidden
 */
var GridColumnOptions = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridColumnOptions, _super);
    function GridColumnOptions() {
        var _this = _super.call(this) || this;
        _this.b1 = null;
        _this.by = null;
        _this.b0 = null;
        _this.bx = null;
        _this.bw = null;
        _this.bv = null;
        _this.b2 = null;
        _this.bu = null;
        _this.ch = null;
        _this.ce = null;
        _this.cd = null;
        _this.c9 = truncate(DeviceUtils.g(8));
        _this.db = truncate(DeviceUtils.g(4));
        _this.da = truncate(DeviceUtils.g(8));
        _this.c8 = truncate(DeviceUtils.g(8));
        _this.cq = true;
        _this.c1 = true;
        _this.cv = true;
        _this.cy = true;
        _this.cs = true;
        _this.cm = true;
        _this.cj = true;
        _this.c4 = true;
        _this.e3 = null;
        _this.ex = null;
        _this.e0 = null;
        _this.d9 = null;
        _this.ec = null;
        _this.eg = null;
        _this.en = null;
        _this.eq = null;
        _this.eu = null;
        _this.dn = null;
        _this.dr = null;
        _this.du = null;
        _this.b6 = 0;
        _this.b4 = 0;
        _this.b5 = 0;
        _this.b3 = 0;
        _this.d0 = null;
        _this.fk = BrushUtil.h(255, 24, 29, 31);
        _this.fj = BrushUtil.h(255, 248, 248, 248);
        _this.applyButtonClick = null;
        _this.cancelButtonClick = null;
        return _this;
    }
    GridColumnOptions.prototype.f = function () {
        return new GridColumnOptionsView();
    };
    GridColumnOptions.prototype.a6 = function () {
        _super.prototype.a6.call(this);
        var a = this.column;
        if (null != this.b1) {
            this.b1.column = a;
        }
        if (null != this.by) {
            this.by.column = a;
        }
        if (null != this.b0) {
            this.b0.column = a;
        }
        if (null != this.bx) {
            this.bx.column = a;
        }
        if (null != this.bw) {
            this.bw.column = a;
        }
        if (null != this.bv) {
            this.bv.column = a;
        }
        if (null != this.b2) {
            this.b2.column = a;
        }
        this.fi();
    };
    GridColumnOptions.prototype.bb = function (a, b) {
        _super.prototype.bb.call(this, a, b);
        switch (b.propertyName) {
            case "HeaderClickAction":
            case "ColumnMovingMode":
                this.fi();
                break;
        }
    };
    GridColumnOptions.prototype.be = function (a, b, c) {
        _super.prototype.be.call(this, a, b, c);
        switch (a) {
            case "HeaderVisible":
            case "SortOptionsVisible":
            case "MoveOptionsVisible":
            case "PinOptionsVisible":
            case "HideOptionsVisible":
            case "FilterOptionsVisible":
            case "PaddingTop":
            case "PaddingRight":
            case "PaddingBottom":
            case "PaddingLeft":
                this.fi();
                break;
            case "ActualLabelTextStyle":
            case "ActualBaseTheme":
            case "ActualButtonDensity":
            case "ActualButtonTextStyle":
            case "ActualDensity":
            case "ActualFilterListDensity":
            case "ActualSummaryListDensity":
            case "BackgroundColor":
            case "TextColor":
                this.fg();
                break;
            case "ColumnNameTextStyle":
                this.fh();
                break;
            case "ActualColumnNameTextStyle":
                this.fi();
                break;
            case "FilterListDensity":
                this.b7 = this.filterListDensity == 0 ? this.q : this.filterListDensity;
                break;
            case "SummaryListDensity":
                this.b8 = this.summaryListDensity == 0 ? this.q : this.summaryListDensity;
                break;
        }
    };
    GridColumnOptions.prototype.fi = function () {
        this.bz.m();
    };
    Object.defineProperty(GridColumnOptions.prototype, "dx", {
        get: function () {
            var a = this.column;
            return (null != a) ? a.im : "(No column selected)";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "ci", {
        get: function () {
            if (null == this.ch) {
                this.ch = new FontInfo();
                this.ch.p = "Verdana";
                this.ch.e = 16;
            }
            return this.ch;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "cp", {
        get: function () {
            return this.cr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "c3", {
        get: function () {
            return this.c2 && this.b1.bs();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "cx", {
        get: function () {
            return this.cw && this.by.bs();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "c0", {
        get: function () {
            return this.cz && this.b0.bs();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "cu", {
        get: function () {
            return this.ct && this.bx.bs();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "co", {
        get: function () {
            return this.cn && this.bw.bs();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "cl", {
        get: function () {
            return this.ck && this.bv.bs();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "c6", {
        get: function () {
            return this.c5 && this.b2.bs();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "bz", {
        get: function () {
            return this.e;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "cg", {
        get: function () {
            return this.ce;
        },
        set: function (a) {
            var b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.bc("ColumnNameTextStyle", b, this.ce);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "cf", {
        get: function () {
            return this.cd;
        },
        set: function (a) {
            var b = this.cd;
            this.cd = a;
            if (this.cd != b) {
                this.bc("ActualColumnNameTextStyle", b, this.cd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "dh", {
        get: function () {
            return this.c9;
        },
        set: function (a) {
            var b = this.c9;
            this.c9 = a;
            if (this.c9 != b) {
                this.bc("PaddingLeft", b, this.c9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "dj", {
        get: function () {
            return this.db;
        },
        set: function (a) {
            var b = this.db;
            this.db = a;
            if (this.db != b) {
                this.bc("PaddingTop", b, this.db);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "di", {
        get: function () {
            return this.da;
        },
        set: function (a) {
            var b = this.da;
            this.da = a;
            if (this.da != b) {
                this.bc("PaddingRight", b, this.da);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "dg", {
        get: function () {
            return this.c8;
        },
        set: function (a) {
            var b = this.c8;
            this.c8 = a;
            if (this.c8 != b) {
                this.bc("PaddingBottom", b, this.c8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "cr", {
        get: function () {
            return this.cq;
        },
        set: function (a) {
            if (a == this.cq) {
                return;
            }
            var b = this.cq;
            this.cq = a;
            this.bc("HeaderVisible", b, this.cq);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "c2", {
        get: function () {
            return this.c1;
        },
        set: function (a) {
            if (a == this.c1) {
                return;
            }
            var b = this.c1;
            this.c1 = a;
            this.bc("SortOptionsVisible", b, this.c1);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "cw", {
        get: function () {
            return this.cv;
        },
        set: function (a) {
            if (a == this.cv) {
                return;
            }
            var b = this.cv;
            this.cv = a;
            this.bc("MoveOptionsVisible", b, this.cv);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "cz", {
        get: function () {
            return this.cy;
        },
        set: function (a) {
            if (a == this.cy) {
                return;
            }
            var b = this.cy;
            this.cy = a;
            this.bc("PinOptionsVisible", b, this.cy);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "ct", {
        get: function () {
            return this.cs;
        },
        set: function (a) {
            if (a == this.cs) {
                return;
            }
            var b = this.cs;
            this.cs = a;
            this.bc("HideOptionsVisible", b, this.cs);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "cn", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            if (a == this.cm) {
                return;
            }
            var b = this.cm;
            this.cm = a;
            this.bc("GroupOptionsVisible", b, this.cm);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "ck", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            if (a == this.cj) {
                return;
            }
            var b = this.cj;
            this.cj = a;
            this.bc("FilterOptionsVisible", b, this.cj);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "c5", {
        get: function () {
            return this.c4;
        },
        set: function (a) {
            if (a == this.c4) {
                return;
            }
            var b = this.c4;
            this.c4 = a;
            this.bc("SummaryOptionsVisible", b, this.c4);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "e4", {
        get: function () {
            return this.e3 != null ? this.e3 : !stringIsNullOrWhiteSpace(this.ai.b1("Column_Sort")) ? this.ai.b1("Column_Sort") : "Sort";
        },
        set: function (a) {
            var b = this.e4;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.e3 = a;
            if (null != this.b1) {
                this.b1.by = a;
            }
            this.bc("SortHeaderCaption", b, this.e3);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "ey", {
        get: function () {
            return this.ex != null ? this.ex : !stringIsNullOrWhiteSpace(this.ai.b1("Column_Sort_Ascending")) ? this.ai.b1("Column_Sort_Ascending") : "Asc";
        },
        set: function (a) {
            var b = this.ey;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.ex = a;
            if (null != this.b1) {
                this.b1.b5 = a;
            }
            this.bc("SortAscendingCaption", b, this.ex);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "e1", {
        get: function () {
            return this.e0 != null ? this.e0 : !stringIsNullOrWhiteSpace(this.ai.b1("Column_Sort_Descending")) ? this.ai.b1("Column_Sort_Descending") : "Desc";
        },
        set: function (a) {
            var b = this.e1;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.e0 = a;
            if (null != this.b1) {
                this.b1.b9 = a;
            }
            this.bc("SortDescendingCaption", b, this.e0);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "ea", {
        get: function () {
            return this.d9 != null ? this.d9 : !stringIsNullOrWhiteSpace(this.ai.b1("Column_Move")) ? this.ai.b1("Column_Move") : "Move";
        },
        set: function (a) {
            var b = this.ea;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.d9 = a;
            if (null != this.by) {
                this.by.by = a;
            }
            this.bc("MoveHeaderCaption", b, this.d9);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "ed", {
        get: function () {
            return this.ec != null ? this.ec : !stringIsNullOrWhiteSpace(this.ai.b1("Column_Move_Left")) ? this.ai.b1("Column_Move_Left") : "Left";
        },
        set: function (a) {
            var b = this.ed;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.ec = a;
            if (null != this.by) {
                this.by.b8 = a;
            }
            this.bc("MoveLeftCaption", b, this.ec);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "eh", {
        get: function () {
            return this.eg != null ? this.eg : !stringIsNullOrWhiteSpace(this.ai.b1("Column_Move_Right")) ? this.ai.b1("Column_Move_Right") : "Right";
        },
        set: function (a) {
            var b = this.eh;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.eg = a;
            if (null != this.by) {
                this.by.cc = a;
            }
            this.bc("MoveRightCaption", b, this.eg);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "eo", {
        get: function () {
            return this.en != null ? this.en : !stringIsNullOrWhiteSpace(this.ai.b1("Column_Pin")) ? this.ai.b1("Column_Pin") : "Pin";
        },
        set: function (a) {
            var b = this.eo;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.en = a;
            if (null != this.b0) {
                this.b0.by = a;
            }
            this.bc("PinHeaderCaption", b, this.en);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "er", {
        get: function () {
            return this.eq != null ? this.eq : !stringIsNullOrWhiteSpace(this.ai.b1("Column_Pin_Left")) ? this.ai.b1("Column_Pin_Left") : "Left";
        },
        set: function (a) {
            var b = this.er;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.eq = a;
            if (null != this.b0) {
                this.b0.b6 = a;
            }
            this.bc("PinLeftCaption", b, this.eq);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "ev", {
        get: function () {
            return this.eu != null ? this.eu : !stringIsNullOrWhiteSpace(this.ai.b1("Column_Pin_Right")) ? this.ai.b1("Column_Pin_Right") : "Right";
        },
        set: function (a) {
            var b = this.ev;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.eu = a;
            if (null != this.b0) {
                this.b0.ca = a;
            }
            this.bc("PinRightCaption", b, this.eu);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "dp", {
        get: function () {
            return this.dn != null ? this.dn : !stringIsNullOrWhiteSpace(this.ai.b1("Apply")) ? this.ai.b1("Apply") : "Apply";
        },
        set: function (a) {
            var b = this.dp;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.dn = a;
            if (null != this.bu) {
                this.bu.bz = a;
            }
            this.bc("ApplyFiltersButtonCaption", b, this.dn);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "ds", {
        get: function () {
            return this.dr != null ? this.dr : !stringIsNullOrWhiteSpace(this.ai.b1("Cancel")) ? this.ai.b1("Cancel") : "Cancel";
        },
        set: function (a) {
            var b = this.ds;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.dr = a;
            if (null != this.bu) {
                this.bu.b3 = a;
            }
            this.bc("CancelFiltersButtonCaption", b, this.dr);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "dv", {
        get: function () {
            return this.du != null ? this.du : !stringIsNullOrWhiteSpace(this.ai.b1("Clear_Column_Filter")) ? this.ai.b1("Clear_Column_Filter") : "Clear column filters";
        },
        set: function (a) {
            var b = this.dv;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.du = a;
            if (null != this.bv) {
                this.bv.b7 = a;
            }
            this.bc("ClearColumnFiltersCaption", b, this.du);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "summaryListDensity", {
        get: function () {
            return this.b6;
        },
        set: function (a) {
            var b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.bc("SummaryListDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.b6));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "b8", {
        get: function () {
            return this.b4;
        },
        set: function (a) {
            var b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.bc("ActualSummaryListDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.b4));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "filterListDensity", {
        get: function () {
            return this.b5;
        },
        set: function (a) {
            var b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.bc("FilterListDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "b7", {
        get: function () {
            return this.b3;
        },
        set: function (a) {
            var b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.bc("ActualFilterListDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "d1", {
        get: function () {
            return this.d0 != null ? this.d0 : !stringIsNullOrWhiteSpace(this.ai.b1("Search")) ? this.ai.b1("Search") : "Search";
        },
        set: function (a) {
            if (0 == StringComparer.b.compare(a, this.d0)) {
                return;
            }
            var b = this.d0;
            this.d0 = a;
            if (null != this.bv) {
                this.bv.cc = a;
            }
            this.bc("FilterListPlaceholderText", b, this.d0);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "fm", {
        get: function () {
            return this.fk;
        },
        set: function (a) {
            var b = this.fk;
            this.fk = a;
            if (b != this.fk) {
                this.bc("SummaryListTextColor", b, this.fk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridColumnOptions.prototype, "fl", {
        get: function () {
            return this.fj;
        },
        set: function (a) {
            var b = this.fj;
            this.fj = a;
            if (b != this.fj) {
                this.bc("SummaryListBackground", b, this.fj);
            }
        },
        enumerable: false,
        configurable: true
    });
    GridColumnOptions.prototype.notifySizeChanged = function () {
        this.e.j();
    };
    GridColumnOptions.prototype.provideContent = function (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s) {
        this.bz.ac(a, b, c, d, e, f, g, h, i, j, k);
        this.b1 = l;
        this.b1.by = this.e4;
        this.b1.b5 = this.ey;
        this.b1.b9 = this.e1;
        this.by = m;
        this.by.by = this.ea;
        this.by.b8 = this.ed;
        this.by.cc = this.eh;
        this.b0 = n;
        this.b0.by = this.eo;
        this.b0.b6 = this.er;
        this.b0.ca = this.ev;
        this.bx = o;
        this.bx.bw = false;
        this.bw = p;
        this.bw.bw = false;
        this.bv = q;
        this.bv.b7 = this.dv;
        this.bv.cc = this.d1;
        var t = this.b1;
        t.propertyChanged = delegateCombine(t.propertyChanged, runOn(this, this.fb));
        var u = this.by;
        u.propertyChanged = delegateCombine(u.propertyChanged, runOn(this, this.fb));
        var v = this.b0;
        v.propertyChanged = delegateCombine(v.propertyChanged, runOn(this, this.fb));
        var w = this.bx;
        w.propertyChanged = delegateCombine(w.propertyChanged, runOn(this, this.fb));
        var x = this.bw;
        x.propertyChanged = delegateCombine(x.propertyChanged, runOn(this, this.fb));
        var y = this.bv;
        y.propertyChanged = delegateCombine(y.propertyChanged, runOn(this, this.fb));
        this.b2 = r;
        this.bu = s;
        this.bu.bz = this.dp;
        this.bu.b3 = this.ds;
        var z = this.bu;
        z.applyButtonClick = delegateCombine(z.applyButtonClick, runOn(this, this.fd));
        var aa = this.bu;
        aa.cancelButtonClick = delegateCombine(aa.cancelButtonClick, runOn(this, this.fe));
        this.fh();
        this.bl();
        this.bi();
        this.fg();
    };
    GridColumnOptions.prototype.d5 = function () {
        return stringFormat1("{0}px {1}px {2}px {3}px", this.dj.toString(), this.di.toString(), this.dg.toString(), this.dh.toString());
    };
    GridColumnOptions.prototype.fh = function () {
        this.cf = (null == this.cg) ? this.ci : this.cg;
    };
    GridColumnOptions.prototype.fg = function () {
        var a = [this.b1, this.by, this.b0, this.bx, this.bw, this.bv, this.b2, this.bu];
        for (var c = 0; c < a.length; c++) {
            var b = a[c];
            if (null != b) {
                b.bo = this.bo;
                b.br = this.br;
                b.density = this.q;
                b.buttonDensity = this.p;
                b.j = this.i;
            }
            var d = typeCast(GridColumnOptionsSimpleSectionBase.$, b);
            if (null != d) {
                d.ag = this.aa;
                d.ab = this.z;
            }
        }
        if (null != this.bv) {
            this.bv.b2 = this.b7;
        }
        if (null != this.b2) {
            this.b2.b5 = this.b8;
            this.b2.cv = this.fm;
            this.b2.cu = this.fl;
        }
    };
    GridColumnOptions.prototype.fd = function (a, b) {
        var c = [this.b1, this.by, this.b0, this.bx, this.bw, this.bv, this.b2];
        for (var e = 0; e < c.length; e++) {
            var d = c[e];
            d.bt();
        }
        if (null != this.applyButtonClick) {
            this.applyButtonClick(this, b);
        }
    };
    GridColumnOptions.prototype.fe = function (a, b) {
        var c = [this.b1, this.by, this.b0, this.bx, this.bw, this.bv, this.b2];
        for (var e = 0; e < c.length; e++) {
            var d = c[e];
            d.bu();
        }
        if (null != this.cancelButtonClick) {
            this.cancelButtonClick(this, b);
        }
    };
    GridColumnOptions.prototype.fb = function (a, b) {
        switch (b.propertyName) {
        }
    };
    GridColumnOptions.$t = markType(GridColumnOptions, 'GridColumnOptions', GridColumnOptionsBase.$);
    return GridColumnOptions;
}(GridColumnOptionsBase));
export { GridColumnOptions };
