/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseEventArgsDetail } from "./BaseEventArgsDetail";
import { GridKeydownTargetType_$type } from "./GridKeydownTargetType";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
/**
 * @hidden
 */
var GridKeydownEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridKeydownEventArgsDetail, _super);
    function GridKeydownEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(GridKeydownEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.n("targetType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridKeydownTargetType_$type, EnumUtil.getEnumValue(GridKeydownTargetType_$type, this.b.f(GridKeydownTargetType_$type, ret_)));
            return EnumUtil.getEnumValue(GridKeydownTargetType_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridKeydownTargetType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b.v("targetType", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridKeydownEventArgsDetail.prototype, "k", {
        get: function () {
            var ret_ = this.b.n("target");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("target", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridKeydownEventArgsDetail.prototype, "j", {
        get: function () {
            var ret_ = this.b.n("event");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("event", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridKeydownEventArgsDetail.prototype, "i", {
        get: function () {
            var ret_ = this.b.n("cancel");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("cancel", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridKeydownEventArgsDetail.$t = markType(GridKeydownEventArgsDetail, 'GridKeydownEventArgsDetail', BaseEventArgsDetail.$);
    GridKeydownEventArgsDetail.__marshalByValueIgnore = ["event"];
    return GridKeydownEventArgsDetail;
}(BaseEventArgsDetail));
export { GridKeydownEventArgsDetail };
