/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { ColumnPinningPosition_$type } from "./ColumnPinningPosition";
import { RowPinningPosition_$type } from "./RowPinningPosition";
/**
 * @hidden
 */
var PinningConfig = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PinningConfig, _super);
    function PinningConfig() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = new WCNativeHelper();
        _this.e = null;
        return _this;
    }
    Object.defineProperty(PinningConfig.prototype, "d", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinningConfig.prototype, "nativeElement", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
            this.c.o = this.e;
        },
        enumerable: false,
        configurable: true
    });
    PinningConfig.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(PinningConfig.prototype, "a", {
        get: function () {
            var ret_ = this.d.n("columns");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(ColumnPinningPosition_$type, EnumUtil.getEnumValue(ColumnPinningPosition_$type, this.d.f(ColumnPinningPosition_$type, ret_)));
            return EnumUtil.getEnumValue(ColumnPinningPosition_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(ColumnPinningPosition_$type, a);
            value_ = this.d.f(ColumnPinningPosition_$type, value_);
            this.d.v("columns", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinningConfig.prototype, "b", {
        get: function () {
            var ret_ = this.d.n("rows");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(RowPinningPosition_$type, EnumUtil.getEnumValue(RowPinningPosition_$type, this.d.f(RowPinningPosition_$type, ret_)));
            return EnumUtil.getEnumValue(RowPinningPosition_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(RowPinningPosition_$type, a);
            value_ = this.d.f(RowPinningPosition_$type, value_);
            this.d.v("rows", value_);
        },
        enumerable: false,
        configurable: true
    });
    PinningConfig.$t = markType(PinningConfig, 'PinningConfig');
    return PinningConfig;
}(Base));
export { PinningConfig };
