/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PivotAggregator } from "./PivotAggregator";
import { PivotAggregatorCollection } from "./PivotAggregatorCollection";
import { GridColumnDataType_$type } from "./GridColumnDataType";
/**
 * @hidden
 */
var PivotValueDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PivotValueDetail, _super);
    function PivotValueDetail() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e = new WCNativeHelper();
        _this.h = null;
        _this.formatter = null;
        return _this;
    }
    Object.defineProperty(PivotValueDetail.prototype, "f", {
        get: function () {
            return this.e;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotValueDetail.prototype, "nativeElement", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            this.h = a;
            this.e.o = this.h;
        },
        enumerable: false,
        configurable: true
    });
    PivotValueDetail.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(PivotValueDetail.prototype, "l", {
        get: function () {
            var ret_ = this.f.n("member");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.v("member", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotValueDetail.prototype, "k", {
        get: function () {
            var ret_ = this.f.n("displayName");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.v("displayName", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotValueDetail.prototype, "b", {
        get: function () {
            var ret_ = this.f.m("aggregate", function (a) { return new PivotAggregator(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.v("aggregate", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotValueDetail.prototype, "c", {
        get: function () {
            var ret_ = this.f.k("aggregateList", function (a) { return new PivotAggregatorCollection(); }, function (a) { return new PivotAggregator(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotValueDetail.prototype, "g", {
        get: function () {
            var ret_ = this.f.n("enabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.v("enabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotValueDetail.prototype, "j", {
        get: function () {
            var ret_ = this.f.n("styles");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.v("styles", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotValueDetail.prototype, "a", {
        get: function () {
            var ret_ = this.f.n("dataType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridColumnDataType_$type, EnumUtil.getEnumValue(GridColumnDataType_$type, this.f.f(GridColumnDataType_$type, ret_)));
            return EnumUtil.getEnumValue(GridColumnDataType_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridColumnDataType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.f.v("dataType", value_);
        },
        enumerable: false,
        configurable: true
    });
    PivotValueDetail.prototype.formatterChanged = function () {
        if (this.formatter != null) {
            var value_ = this.formatter;
            this.f.v("formatter", value_);
        }
        else {
            var value_ = null;
            this.f.v("formatter", value_);
        }
    };
    PivotValueDetail.$t = markType(PivotValueDetail, 'PivotValueDetail');
    return PivotValueDetail;
}(Base));
export { PivotValueDetail };
