/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { GridHorizontalAlignment_$type } from "./GridHorizontalAlignment";
import { GridVerticalAlignment_$type } from "./GridVerticalAlignment";
import { PositionSize } from "./PositionSize";
/**
 * @hidden
 */
var PositionSettings = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PositionSettings, _super);
    function PositionSettings() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f = new WCNativeHelper();
        _this.h = null;
        return _this;
    }
    Object.defineProperty(PositionSettings.prototype, "g", {
        get: function () {
            return this.f;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PositionSettings.prototype, "nativeElement", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            this.h = a;
            this.f.o = this.h;
        },
        enumerable: false,
        configurable: true
    });
    PositionSettings.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(PositionSettings.prototype, "j", {
        get: function () {
            var ret_ = this.g.m("target", function (a) { });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("target", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PositionSettings.prototype, "a", {
        get: function () {
            var ret_ = this.g.n("horizontalDirection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridHorizontalAlignment_$type, EnumUtil.getEnumValue(GridHorizontalAlignment_$type, this.g.f(GridHorizontalAlignment_$type, ret_)));
            return EnumUtil.getEnumValue(GridHorizontalAlignment_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridHorizontalAlignment_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("horizontalDirection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PositionSettings.prototype, "c", {
        get: function () {
            var ret_ = this.g.n("verticalDirection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridVerticalAlignment_$type, EnumUtil.getEnumValue(GridVerticalAlignment_$type, this.g.f(GridVerticalAlignment_$type, ret_)));
            return EnumUtil.getEnumValue(GridVerticalAlignment_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridVerticalAlignment_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("verticalDirection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PositionSettings.prototype, "b", {
        get: function () {
            var ret_ = this.g.n("horizontalStartPoint");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridHorizontalAlignment_$type, EnumUtil.getEnumValue(GridHorizontalAlignment_$type, this.g.f(GridHorizontalAlignment_$type, ret_)));
            return EnumUtil.getEnumValue(GridHorizontalAlignment_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridHorizontalAlignment_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("horizontalStartPoint", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PositionSettings.prototype, "d", {
        get: function () {
            var ret_ = this.g.n("verticalStartPoint");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridVerticalAlignment_$type, EnumUtil.getEnumValue(GridVerticalAlignment_$type, this.g.f(GridVerticalAlignment_$type, ret_)));
            return EnumUtil.getEnumValue(GridVerticalAlignment_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridVerticalAlignment_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("verticalStartPoint", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PositionSettings.prototype, "e", {
        get: function () {
            var ret_ = this.g.m("minSize", function (a) { return new PositionSize(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("minSize", value_);
        },
        enumerable: false,
        configurable: true
    });
    PositionSettings.$t = markType(PositionSettings, 'PositionSettings');
    return PositionSettings;
}(Base));
export { PositionSettings };
