/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseEventArgs } from "./BaseEventArgs";
import { WCNativeHelper } from "igniteui-react";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { SortingDirection_$type } from "./SortingDirection";
import { SortingStrategy } from "./SortingStrategy";
/**
 * @hidden
 */
var SortingExpression = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SortingExpression, _super);
    function SortingExpression() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e = new WCNativeHelper();
        _this.h = null;
        return _this;
    }
    Object.defineProperty(SortingExpression.prototype, "f", {
        get: function () {
            return this.e;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SortingExpression.prototype, "nativeElement", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            this.h = a;
            this.e.o = this.h;
        },
        enumerable: false,
        configurable: true
    });
    SortingExpression.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(SortingExpression.prototype, "j", {
        get: function () {
            var ret_ = this.f.n("fieldName");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.v("fieldName", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SortingExpression.prototype, "c", {
        get: function () {
            var ret_ = this.f.n("dir");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(SortingDirection_$type, EnumUtil.getEnumValue(SortingDirection_$type, this.f.f(SortingDirection_$type, ret_)));
            return EnumUtil.getEnumValue(SortingDirection_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SortingDirection_$type, a);
            value_ = this.f.f(SortingDirection_$type, value_);
            this.f.v("dir", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SortingExpression.prototype, "g", {
        get: function () {
            var ret_ = this.f.n("ignoreCase");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.v("ignoreCase", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SortingExpression.prototype, "d", {
        get: function () {
            var ret_ = this.f.m("strategy", function (a) { return new SortingStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.v("strategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    SortingExpression.$t = markType(SortingExpression, 'SortingExpression', BaseEventArgs.$);
    return SortingExpression;
}(BaseEventArgs));
export { SortingExpression };
