/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridCellBase } from "./GridCellBase";
import { markType } from "igniteui-react-core";
/**
 * @hidden
 */
var SummaryCell = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SummaryCell, _super);
    function SummaryCell(a) {
        var _this = _super.call(this, a) || this;
        _this.ch = null;
        _this.ci = null;
        _this.cj = null;
        _this.cn = -1;
        _this.cm = -1;
        _this.ae.setRawStyleProperty("vertical-align", "middle");
        _this.cj = a.createElement("div");
        _this.ch = a.createElement("span");
        _this.ch.setRawStyleProperty("display", "inline-block");
        _this.ch.setRawStyleProperty("width", "40%");
        _this.ch.setRawStyleProperty("white-space", "nowrap");
        _this.ch.setRawStyleProperty("text-overflow", "ellipsis");
        _this.ch.setRawStyleProperty("vertical-align", "middle");
        _this.ch.setRawStyleProperty("overflow", "hidden");
        _this.cj.append(_this.ch);
        _this.ci = a.createElement("span");
        _this.ci.setRawStyleProperty("display", "inline-block");
        _this.ci.setRawStyleProperty("width", "60%");
        _this.ci.setRawStyleProperty("text-align", "right");
        _this.ci.setRawStyleProperty("white-space", "nowrap");
        _this.ci.setRawStyleProperty("text-overflow", "ellipsis");
        _this.ci.setRawStyleProperty("vertical-align", "middle");
        _this.ci.setRawStyleProperty("overflow", "hidden");
        _this.cj.append(_this.ci);
        _this.ae.append(_this.cj);
        return _this;
    }
    Object.defineProperty(SummaryCell.prototype, "ck", {
        get: function () {
            return this.ch;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SummaryCell.prototype, "cl", {
        get: function () {
            return this.ci;
        },
        enumerable: false,
        configurable: true
    });
    SummaryCell.prototype.b6 = function (a, b) {
        _super.prototype.b6.call(this, a, b);
        var c = Math.max(0, a - b);
        if (this.cn != c) {
            this.cn = c;
        }
    };
    SummaryCell.prototype.b0 = function (a, b) {
        _super.prototype.b0.call(this, a, b);
        var c = Math.max(0, a - b);
        if (this.cm != c) {
            this.cm = c;
        }
    };
    SummaryCell.prototype.get_w = function () {
        return false;
    };
    SummaryCell.prototype.bp = function (a, b, c) {
        _super.prototype.bp.call(this, a, b, c);
        if (a == "Indent" || a == "IsCollapsable") {
            this.cj.setRawStyleProperty("margin-left", this.a0 + this.a2 + this.a1 + "px");
        }
    };
    SummaryCell.$t = markType(SummaryCell, 'SummaryCell', GridCellBase.$);
    return SummaryCell;
}(GridCellBase));
export { SummaryCell };
