/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridCellBase } from "./GridCellBase";
import { markType } from "igniteui-react-core";
/**
 * @hidden
 */
var TextCell = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TextCell, _super);
    function TextCell(a) {
        var _this = _super.call(this, a) || this;
        _this.ch = null;
        _this.ck = -1;
        _this.cj = -1;
        _this.ch = a.createElement("span");
        _this.ae.setRawStyleProperty("text-align", "left");
        _this.ch.setRawStyleProperty("display", "inline-block");
        _this.ch.setRawStyleProperty("line-height", "normal");
        _this.ch.setRawStyleProperty("vertical-align", "middle");
        _this.ch.setRawStyleProperty("overflow", "hidden");
        _this.ch.setRawStyleProperty("white-space", "nowrap");
        _this.ch.setRawStyleProperty("text-overflow", "ellipsis");
        _this.ae.setRawStyleProperty("vertical-align", "middle");
        _this.ae.append(_this.ch);
        return _this;
    }
    Object.defineProperty(TextCell.prototype, "ci", {
        get: function () {
            return this.ch;
        },
        enumerable: false,
        configurable: true
    });
    TextCell.prototype.b6 = function (a, b) {
        _super.prototype.b6.call(this, a, b);
        var c = Math.max(0, a - b - (this.a0 + this.a2 + this.a1));
        if (this.ck != c) {
            this.ck = c;
            this.ch.setRawStyleProperty("max-width", c.toString() + "px");
        }
    };
    TextCell.prototype.b0 = function (a, b) {
        _super.prototype.b0.call(this, a, b);
        var c = Math.max(0, a - b);
        if (this.cj != c) {
            this.cj = c;
            this.ch.setRawStyleProperty("max-height", c.toString() + "px");
        }
    };
    TextCell.prototype.get_w = function () {
        return true;
    };
    TextCell.prototype.bp = function (a, b, c) {
        _super.prototype.bp.call(this, a, b, c);
        if (a == "Indent" || a == "IsCollapsable") {
            this.ch.setRawStyleProperty("margin-left", this.a0 + this.a2 + this.a1 + "px");
        }
    };
    TextCell.$t = markType(TextCell, 'TextCell', GridCellBase.$);
    return TextCell;
}(GridCellBase));
export { TextCell };
