/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "igniteui-react";
import { WCNativeHelper } from "igniteui-react";
import { markType } from "igniteui-react-core";
import { ToggleViewEventArgs } from "./ToggleViewEventArgs";
import { ToggleViewCancelableEventArgs } from "./ToggleViewCancelableEventArgs";
/**
 * @hidden
 */
var ToggleDirective = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToggleDirective, _super);
    function ToggleDirective() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f = new WCNativeHelper();
        _this.h = null;
        _this.opened = null;
        _this.opening = null;
        _this.closed = null;
        _this.closing = null;
        _this.appended = null;
        return _this;
    }
    Object.defineProperty(ToggleDirective.prototype, "g", {
        get: function () {
            return this.f;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToggleDirective.prototype, "nativeElement", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            this.h = a;
            this.f.o = this.h;
        },
        enumerable: false,
        configurable: true
    });
    ToggleDirective.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(ToggleDirective.prototype, "j", {
        get: function () {
            var ret_ = this.g.n("id");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("id", value_);
        },
        enumerable: false,
        configurable: true
    });
    ToggleDirective.prototype.openedChanged = function () {
        var _this = this;
        if (this.opened != null) {
            this.g.r("opened", function (a) { return _this.opened(_this, ToggleViewEventArgs.a(a)); }, false);
        }
        else {
            this.g.u("opened");
        }
    };
    ToggleDirective.prototype.openingChanged = function () {
        var _this = this;
        if (this.opening != null) {
            this.g.r("opening", function (a) { return _this.opening(_this, ToggleViewCancelableEventArgs.a(a)); }, false);
        }
        else {
            this.g.u("opening");
        }
    };
    ToggleDirective.prototype.closedChanged = function () {
        var _this = this;
        if (this.closed != null) {
            this.g.r("closed", function (a) { return _this.closed(_this, ToggleViewEventArgs.a(a)); }, false);
        }
        else {
            this.g.u("closed");
        }
    };
    ToggleDirective.prototype.closingChanged = function () {
        var _this = this;
        if (this.closing != null) {
            this.g.r("closing", function (a) { return _this.closing(_this, ToggleViewCancelableEventArgs.a(a)); }, false);
        }
        else {
            this.g.u("closing");
        }
    };
    ToggleDirective.prototype.appendedChanged = function () {
        var _this = this;
        if (this.appended != null) {
            this.g.r("appended", function (a) { return _this.appended(_this, ToggleViewEventArgs.a(a)); }, false);
        }
        else {
            this.g.u("appended");
        }
    };
    ToggleDirective.prototype.n = function (a) {
        this.nativeElement.open(this.g.i(a));
    };
    ToggleDirective.prototype.t = function (a) {
        this.nativeElement.toggle(this.g.i(a));
    };
    ToggleDirective.prototype.q = function () {
        this.nativeElement.reposition();
    };
    ToggleDirective.prototype.s = function (a, b) {
        this.nativeElement.setOffset(this.g.i(a), this.g.i(b));
    };
    ToggleDirective.$t = markType(ToggleDirective, 'ToggleDirective', BaseElement.$);
    return ToggleDirective;
}(BaseElement));
export { ToggleDirective };
