/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridBaseDirective } from "./GridBaseDirective";
import { markType } from "igniteui-react-core";
import { TreeGridRecord } from "./TreeGridRecord";
import { CellType } from "./CellType";
import { RowType } from "./RowType";
/**
 * @hidden
 */
var TreeGrid = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreeGrid, _super);
    function TreeGrid() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ha = null;
        return _this;
    }
    Object.defineProperty(TreeGrid.prototype, "hc", {
        get: function () {
            var ret_ = this.d.n("childDataKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("childDataKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeGrid.prototype, "hd", {
        get: function () {
            var ret_ = this.d.n("foreignKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("foreignKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeGrid.prototype, "he", {
        get: function () {
            var ret_ = this.d.n("hasChildrenKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("hasChildrenKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeGrid.prototype, "g6", {
        get: function () {
            var ret_ = this.d.n("cascadeOnDelete");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("cascadeOnDelete", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeGrid.prototype, "hf", {
        get: function () {
            var ret_ = this.d.n("id");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("id", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeGrid.prototype, "g0", {
        get: function () {
            var ret_ = this.d.m("rootRecords", function (a) { return new TreeGridRecord(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("rootRecords", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeGrid.prototype, "gz", {
        get: function () {
            var ret_ = this.d.m("processedRootRecords", function (a) { return new TreeGridRecord(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("processedRootRecords", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeGrid.prototype, "gx", {
        get: function () {
            var ret_ = this.d.n("data");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("data", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeGrid.prototype, "g9", {
        get: function () {
            var ret_ = this.d.n("expansionDepth");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("expansionDepth", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeGrid.prototype, "hb", {
        get: function () {
            return this.ha;
        },
        set: function (a) {
            this.ha = a;
            this.d.s("rowLoadingIndicatorTemplate", function (b) { return b; }, this.ha);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TreeGrid.prototype, "g1", {
        get: function () {
            var ret_ = this.d.m("selectedCells", function (a) { return new CellType(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    TreeGrid.prototype.hk = function (a) {
        this.nativeElement.getDefaultExpandState(this.d.i(a));
    };
    TreeGrid.prototype.hj = function () {
        this.nativeElement.expandAll();
    };
    TreeGrid.prototype.hi = function () {
        this.nativeElement.collapseAll();
    };
    TreeGrid.prototype.hg = function (a, b) {
        this.nativeElement.addRow(this.d.i(a), this.d.i(b));
    };
    TreeGrid.prototype.hh = function (a, b) {
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.beginAddRowByIndex(this.d.i(a), this.d.i(b));
    };
    TreeGrid.prototype.gy = function (a, b) {
        if (a === void 0) {
            a = false;
        }
        if (b === void 0) {
            b = false;
        }
        return (this.nativeElement.getSelectedData(this.d.i(a), this.d.i(b)));
    };
    TreeGrid.prototype.g4 = function (a) {
        return this.d.g(this.nativeElement.getRowByIndex(this.d.i(a)), function (b) { return new RowType(); });
    };
    TreeGrid.prototype.g5 = function (a) {
        return this.d.g(this.nativeElement.getRowByKey(this.d.i(a)), function (b) { return new RowType(); });
    };
    TreeGrid.prototype.g2 = function (a, b) {
        return this.d.g(this.nativeElement.getCellByColumn(this.d.i(a), this.d.i(b)), function (c) { return new CellType(); });
    };
    TreeGrid.prototype.g3 = function (a, b) {
        return this.d.g(this.nativeElement.getCellByKey(this.d.i(a), this.d.i(b)), function (c) { return new CellType(); });
    };
    TreeGrid.prototype.g7 = function (a, b) {
        if (b === void 0) {
            b = -1;
        }
        return (this.nativeElement.pinRow(this.d.i(a), this.d.i(b)));
    };
    TreeGrid.prototype.g8 = function (a) {
        return (this.nativeElement.unpinRow(this.d.i(a)));
    };
    TreeGrid.$t = markType(TreeGrid, 'TreeGrid', GridBaseDirective.$);
    return TreeGrid;
}(GridBaseDirective));
export { TreeGrid };
