/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridCellBase } from "./GridCellBase";
import { markType } from "igniteui-react-core";
import { intDivide } from "igniteui-react-core";
/**
 * @hidden
 */
var VerticalSeparatorCell = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalSeparatorCell, _super);
    function VerticalSeparatorCell(a) {
        var _this = _super.call(this, a) || this;
        _this.ci = null;
        _this.ch = null;
        _this.cj = 0;
        _this.ck = 0;
        _this.ci = a.createElement("div");
        _this.ci.setRawStyleProperty("position", "absolute");
        _this.ci.setRawStyleProperty("pointer-events", "none");
        _this.ae.append(_this.ci);
        return _this;
    }
    VerticalSeparatorCell.prototype.by = function (a, b, c, d, e) {
        if (a == null) {
            if (this.ch != null) {
                this.ch.remove();
                this.ch = null;
            }
        }
        else {
            this.cl();
            this.cj = b;
            this.ck = d;
        }
        this.cm();
    };
    VerticalSeparatorCell.prototype.b6 = function (a, b) {
        _super.prototype.b6.call(this, a, b);
        this.cm();
    };
    VerticalSeparatorCell.prototype.bx = function (a) {
        this.ci.setRawStyleProperty("background-color", a.colorString);
    };
    VerticalSeparatorCell.prototype.cm = function () {
        if (this.ch != null) {
            this.ci.setRawStyleProperty("height", "100%");
            this.ci.setRawStyleProperty("width", this.ae.width() - (this.cj + this.ck) + "px");
            this.ci.setRawStyleProperty("left", intDivide(this.ae.width(), 2) + "px");
            this.ch.setRawStyleProperty("width", "100%");
            this.ch.setRawStyleProperty("height", "100%");
        }
        else {
            this.ci.setRawStyleProperty("height", "100%");
            this.ci.setRawStyleProperty("width", this.ae.width() + "px");
            this.ci.setRawStyleProperty("left", "0px");
        }
    };
    VerticalSeparatorCell.prototype.cl = function () {
        if (this.ch == null) {
            this.ch = this.ab.createElement("div");
            this.ch.setRawStyleProperty("position", "absolute");
            this.ch.setRawStyleProperty("background-color", "rgba(0,0,0,0)");
            this.ae.getNativeElement().insertBefore(this.ch.getNativeElement(), this.ci.getNativeElement());
        }
    };
    VerticalSeparatorCell.$t = markType(VerticalSeparatorCell, 'VerticalSeparatorCell', GridCellBase.$);
    return VerticalSeparatorCell;
}(GridCellBase));
export { VerticalSeparatorCell };
