import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { ActionStrip as ActionStrip_internal } from './ActionStrip';
import { IgrActionStrip as IgrActionStrip } from './igr-action-strip';
var IgrActionStripCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrActionStripCollection, _super);
    function IgrActionStripCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrActionStrip.$type) {
            IgrActionStrip.$type = markType(IgrActionStrip, "IgrActionStrip");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrActionStripCollection.prototype._createInnerColl = function () {
        if (!IgrActionStrip.$type) {
            IgrActionStrip.$type = markType(IgrActionStrip, "IgrActionStrip");
        }
        var coll = new SyncableObservableCollection$2(IgrActionStrip.$type, ActionStrip_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrActionStrip._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrActionStripCollection;
}(IgCollection));
export { IgrActionStripCollection };
