import { __extends } from "tslib";
import { GridKeydownTargetType_$type } from "./GridKeydownTargetType";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ActiveNodeChangeEventArgsDetail as ActiveNodeChangeEventArgsDetail_internal } from "./ActiveNodeChangeEventArgsDetail";
import { ensureEnum } from "igniteui-react-core";
var IgrActiveNodeChangeEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrActiveNodeChangeEventArgsDetail, _super);
    function IgrActiveNodeChangeEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrActiveNodeChangeEventArgsDetail.prototype.createImplementation = function () {
        return new ActiveNodeChangeEventArgsDetail_internal();
    };
    Object.defineProperty(IgrActiveNodeChangeEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrActiveNodeChangeEventArgsDetail.prototype, "row", {
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrActiveNodeChangeEventArgsDetail.prototype, "column", {
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrActiveNodeChangeEventArgsDetail.prototype, "level", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrActiveNodeChangeEventArgsDetail.prototype, "tag", {
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = ensureEnum(GridKeydownTargetType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrActiveNodeChangeEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrActiveNodeChangeEventArgsDetail };
