import { __extends } from "tslib";
import * as React from 'react';
import { IgrBaseToolbarDirective } from "./igr-base-toolbar-directive";
import { BaseToolbarColumnActionsDirective } from "./BaseToolbarColumnActionsDirective";
var IgrBaseToolbarColumnActionsDirective = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrBaseToolbarColumnActionsDirective, _super);
    function IgrBaseToolbarColumnActionsDirective(props) {
        return _super.call(this, props) || this;
    }
    IgrBaseToolbarColumnActionsDirective.prototype.createImplementation = function () {
        return new BaseToolbarColumnActionsDirective();
    };
    Object.defineProperty(IgrBaseToolbarColumnActionsDirective.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrBaseToolbarColumnActionsDirective.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        var style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        var div = React.createElement("", {
            ref: this._getMainRef,
            class: this.props.className,
            style: style,
            children: children
        });
        return div;
    };
    IgrBaseToolbarColumnActionsDirective.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    Object.defineProperty(IgrBaseToolbarColumnActionsDirective.prototype, "name", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrBaseToolbarColumnActionsDirective;
}(IgrBaseToolbarDirective));
export { IgrBaseToolbarColumnActionsDirective };
