import { CancelableEventArgsDetail as CancelableEventArgsDetail_internal } from "./CancelableEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
var IgrCancelableEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrCancelableEventArgsDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrCancelableEventArgsDetail.prototype.createImplementation = function () {
        return new CancelableEventArgsDetail_internal();
    };
    Object.defineProperty(IgrCancelableEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrCancelableEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrCancelableEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrCancelableEventArgsDetail.prototype, "cancel", {
        /**
         * Provides the ability to cancel the event.
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrCancelableEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrCancelableEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrCancelableEventArgsDetail;
}());
export { IgrCancelableEventArgsDetail };
