import { CheckedChangedEventArgs as CheckedChangedEventArgs_internal } from "./CheckedChangedEventArgs";
import { ensureBool } from "igniteui-react-core";
var IgrCheckedChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrCheckedChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrCheckedChangedEventArgs.prototype.createImplementation = function () {
        return new CheckedChangedEventArgs_internal();
    };
    Object.defineProperty(IgrCheckedChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrCheckedChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrCheckedChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrCheckedChangedEventArgs.prototype, "index", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCheckedChangedEventArgs.prototype, "isChecked", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrCheckedChangedEventArgs;
}());
export { IgrCheckedChangedEventArgs };
