import { IgrColumnExportingEventArgsDetail } from "./igr-column-exporting-event-args-detail";
import { ColumnExportingEventArgs as ColumnExportingEventArgs_internal } from "./ColumnExportingEventArgs";
/**
 * columnExporting event arguments
 * ```typescript
 * this.exporterService.columnExporting.subscribe((args: IColumnExportingEventArgs) => {
 * // set args properties here
 * });
 * ```
*/
var IgrColumnExportingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnExportingEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrColumnExportingEventArgs.prototype.createImplementation = function () {
        return new ColumnExportingEventArgs_internal();
    };
    Object.defineProperty(IgrColumnExportingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnExportingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrColumnExportingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrColumnExportingEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrColumnExportingEventArgsDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrColumnExportingEventArgs;
}());
export { IgrColumnExportingEventArgs };
