import { __extends } from "tslib";
import { IgrDefinitionBase } from "./igr-definition-base";
import { ColumnMovingSeparator } from "./ColumnMovingSeparator";
var IgrColumnMovingSeparator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrColumnMovingSeparator, _super);
    function IgrColumnMovingSeparator(props) {
        return _super.call(this, props) || this;
    }
    IgrColumnMovingSeparator.prototype.createImplementation = function () {
        return new ColumnMovingSeparator();
    };
    Object.defineProperty(IgrColumnMovingSeparator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnMovingSeparator.prototype, "separatorWidth", {
        /**
         * Gets or sets the separator width for this column.
        */
        get: function () {
            return this.i.er;
        },
        set: function (v) {
            this.i.er = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnMovingSeparator.prototype, "actualOpacity", {
        get: function () {
            return this.i.eo;
        },
        set: function (v) {
            this.i.eo = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnMovingSeparator.prototype, "opacity", {
        get: function () {
            return this.i.ep;
        },
        set: function (v) {
            this.i.ep = +v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrColumnMovingSeparator;
}(IgrDefinitionBase));
export { IgrColumnMovingSeparator };
