import { ColumnSelectionEventArgsDetail as ColumnSelectionEventArgsDetail_internal } from "./ColumnSelectionEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
var IgrColumnSelectionEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnSelectionEventArgsDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrColumnSelectionEventArgsDetail.prototype.createImplementation = function () {
        return new ColumnSelectionEventArgsDetail_internal();
    };
    Object.defineProperty(IgrColumnSelectionEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnSelectionEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrColumnSelectionEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrColumnSelectionEventArgsDetail.prototype, "oldSelection", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.c = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnSelectionEventArgsDetail.prototype, "newSelection", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnSelectionEventArgsDetail.prototype, "added", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.a = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnSelectionEventArgsDetail.prototype, "removed", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.d = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnSelectionEventArgsDetail.prototype, "cancel", {
        /**
         * Provides the ability to cancel the event.
        */
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnSelectionEventArgsDetail.prototype, "owner", {
        /**
         * Provides reference to the owner component.
        */
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnSelectionEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrColumnSelectionEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrColumnSelectionEventArgsDetail;
}());
export { IgrColumnSelectionEventArgsDetail };
