import { __extends } from "tslib";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ColumnVisibilityChangedEventArgsDetail as ColumnVisibilityChangedEventArgsDetail_internal } from "./ColumnVisibilityChangedEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
var IgrColumnVisibilityChangedEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrColumnVisibilityChangedEventArgsDetail, _super);
    function IgrColumnVisibilityChangedEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrColumnVisibilityChangedEventArgsDetail.prototype.createImplementation = function () {
        return new ColumnVisibilityChangedEventArgsDetail_internal();
    };
    Object.defineProperty(IgrColumnVisibilityChangedEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnVisibilityChangedEventArgsDetail.prototype, "column", {
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnVisibilityChangedEventArgsDetail.prototype, "newValue", {
        /**
         * The new hidden state that the column will have, if operation is succesfull.
         * Will be `true` when hiding and `false` when showing.
        */
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrColumnVisibilityChangedEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrColumnVisibilityChangedEventArgsDetail };
