import { __extends } from "tslib";
import { IgrSummaryOperand } from "./igr-summary-operand";
import { DateSummaryOperand as DateSummaryOperand_internal } from "./DateSummaryOperand";
var IgrDateSummaryOperand = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDateSummaryOperand, _super);
    function IgrDateSummaryOperand() {
        return _super.call(this) || this;
    }
    IgrDateSummaryOperand.prototype.createImplementation = function () {
        var impl = new DateSummaryOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    };
    Object.defineProperty(IgrDateSummaryOperand.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrDateSummaryOperand.prototype.latest = function (data) {
        this.i.j(data);
    };
    IgrDateSummaryOperand.prototype.earliest = function (data) {
        this.i.i(data);
    };
    IgrDateSummaryOperand.prototype.operate = function (data, allData, fieldName, groupRecord) {
        var iv = this.i.h(data, allData, fieldName, (groupRecord == null ? null : groupRecord.i));
        var ret = [];
        for (var i = 0; i < iv.length; i++) {
            var impl = iv[i];
            if (!impl.externalObject) {
                var e = impl.nativeElement;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    };
    return IgrDateSummaryOperand;
}(IgrSummaryOperand));
export { IgrDateSummaryOperand };
