import { __extends } from "tslib";
import { DisplayDensity_$type } from "./DisplayDensity";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { DensityChangedEventArgsDetail as DensityChangedEventArgsDetail_internal } from "./DensityChangedEventArgsDetail";
import { ensureEnum } from "igniteui-react-core";
var IgrDensityChangedEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDensityChangedEventArgsDetail, _super);
    function IgrDensityChangedEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrDensityChangedEventArgsDetail.prototype.createImplementation = function () {
        return new DensityChangedEventArgsDetail_internal();
    };
    Object.defineProperty(IgrDensityChangedEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDensityChangedEventArgsDetail.prototype, "oldDensity", {
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = ensureEnum(DisplayDensity_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDensityChangedEventArgsDetail.prototype, "newDensity", {
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = ensureEnum(DisplayDensity_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrDensityChangedEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrDensityChangedEventArgsDetail };
