import { IgrFilteringExpressionsTree } from "./igr-filtering-expressions-tree";
import { FilteringEventArgsDetail as FilteringEventArgsDetail_internal } from "./FilteringEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
var IgrFilteringEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrFilteringEventArgsDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrFilteringEventArgsDetail.prototype.createImplementation = function () {
        return new FilteringEventArgsDetail_internal();
    };
    Object.defineProperty(IgrFilteringEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrFilteringEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrFilteringEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrFilteringEventArgsDetail.prototype, "filteringExpressions", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrFilteringExpressionsTree();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrFilteringEventArgsDetail.prototype, "owner", {
        /**
         * Provides reference to the owner component.
        */
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrFilteringEventArgsDetail.prototype, "cancel", {
        /**
         * Provides the ability to cancel the event.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrFilteringEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.filteringExpressions && this.filteringExpressions.name && this.filteringExpressions.name == name) {
            return this.filteringExpressions;
        }
        return null;
    };
    IgrFilteringEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrFilteringEventArgsDetail;
}());
export { IgrFilteringEventArgsDetail };
