import { IgrFilteringEventArgsDetail } from "./igr-filtering-event-args-detail";
import { FilteringEventArgs as FilteringEventArgs_internal } from "./FilteringEventArgs";
var IgrFilteringEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrFilteringEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrFilteringEventArgs.prototype.createImplementation = function () {
        return new FilteringEventArgs_internal();
    };
    Object.defineProperty(IgrFilteringEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrFilteringEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrFilteringEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrFilteringEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrFilteringEventArgsDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrFilteringEventArgs;
}());
export { IgrFilteringEventArgs };
