import { FilteringExpressionsTreeOrFilteringExpression as FilteringExpressionsTreeOrFilteringExpression_internal } from "./FilteringExpressionsTreeOrFilteringExpression";
var IgrFilteringExpressionsTreeOrFilteringExpression = /** @class */ /*@__PURE__*/ (function () {
    function IgrFilteringExpressionsTreeOrFilteringExpression() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrFilteringExpressionsTreeOrFilteringExpression.prototype.createImplementation = function () {
        return new FilteringExpressionsTreeOrFilteringExpression_internal();
    };
    Object.defineProperty(IgrFilteringExpressionsTreeOrFilteringExpression.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrFilteringExpressionsTreeOrFilteringExpression.prototype.onImplementationCreated = function () {
    };
    IgrFilteringExpressionsTreeOrFilteringExpression.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrFilteringExpressionsTreeOrFilteringExpression.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrFilteringExpressionsTreeOrFilteringExpression;
}());
export { IgrFilteringExpressionsTreeOrFilteringExpression };
