import { FilteringExpressionsTreeOrFilteringOperation as FilteringExpressionsTreeOrFilteringOperation_internal } from "./FilteringExpressionsTreeOrFilteringOperation";
var IgrFilteringExpressionsTreeOrFilteringOperation = /** @class */ /*@__PURE__*/ (function () {
    function IgrFilteringExpressionsTreeOrFilteringOperation() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrFilteringExpressionsTreeOrFilteringOperation.prototype.createImplementation = function () {
        return new FilteringExpressionsTreeOrFilteringOperation_internal();
    };
    Object.defineProperty(IgrFilteringExpressionsTreeOrFilteringOperation.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrFilteringExpressionsTreeOrFilteringOperation.prototype.onImplementationCreated = function () {
    };
    IgrFilteringExpressionsTreeOrFilteringOperation.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrFilteringExpressionsTreeOrFilteringOperation.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrFilteringExpressionsTreeOrFilteringOperation;
}());
export { IgrFilteringExpressionsTreeOrFilteringOperation };
