import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { GridActionsBaseDirective as GridActionsBaseDirective_internal } from './GridActionsBaseDirective';
import { IgrGridActionsBaseDirective as IgrGridActionsBaseDirective } from './igr-grid-actions-base-directive';
var IgrGridActionsBaseDirectiveCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridActionsBaseDirectiveCollection, _super);
    function IgrGridActionsBaseDirectiveCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrGridActionsBaseDirective.$type) {
            IgrGridActionsBaseDirective.$type = markType(IgrGridActionsBaseDirective, "IgrGridActionsBaseDirective");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrGridActionsBaseDirectiveCollection.prototype._createInnerColl = function () {
        if (!IgrGridActionsBaseDirective.$type) {
            IgrGridActionsBaseDirective.$type = markType(IgrGridActionsBaseDirective, "IgrGridActionsBaseDirective");
        }
        var coll = new SyncableObservableCollection$2(IgrGridActionsBaseDirective.$type, GridActionsBaseDirective_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrGridActionsBaseDirective._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrGridActionsBaseDirectiveCollection;
}(IgCollection));
export { IgrGridActionsBaseDirectiveCollection };
