import { GridCellIdentifier as GridCellIdentifier_internal } from "./GridCellIdentifier";
var IgrGridCellIdentifier = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridCellIdentifier() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridCellIdentifier.prototype.createImplementation = function () {
        return new GridCellIdentifier_internal();
    };
    Object.defineProperty(IgrGridCellIdentifier.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridCellIdentifier.prototype.onImplementationCreated = function () {
    };
    IgrGridCellIdentifier.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridCellIdentifier.prototype, "rowID", {
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCellIdentifier.prototype, "columnID", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCellIdentifier.prototype, "rowIndex", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridCellIdentifier.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrGridCellIdentifier.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridCellIdentifier;
}());
export { IgrGridCellIdentifier };
