import { IgrGridClipboardEventDetail } from "./igr-grid-clipboard-event-detail";
import { GridClipboardEventEventArgs as GridClipboardEventEventArgs_internal } from "./GridClipboardEventEventArgs";
var IgrGridClipboardEventEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridClipboardEventEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridClipboardEventEventArgs.prototype.createImplementation = function () {
        return new GridClipboardEventEventArgs_internal();
    };
    Object.defineProperty(IgrGridClipboardEventEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridClipboardEventEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridClipboardEventEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridClipboardEventEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrGridClipboardEventDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridClipboardEventEventArgs;
}());
export { IgrGridClipboardEventEventArgs };
