import { __extends } from "tslib";
import { IgrRowIsland } from "./igr-row-island";
import { IgrHierarchicalGrid } from "./igr-hierarchical-grid";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GridCreatedEventArgsDetail as GridCreatedEventArgsDetail_internal } from "./GridCreatedEventArgsDetail";
var IgrGridCreatedEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridCreatedEventArgsDetail, _super);
    function IgrGridCreatedEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrGridCreatedEventArgsDetail.prototype.createImplementation = function () {
        return new GridCreatedEventArgsDetail_internal();
    };
    Object.defineProperty(IgrGridCreatedEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCreatedEventArgsDetail.prototype, "owner", {
        get: function () {
            var r = this.i.h;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrRowIsland._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.h = null : this.i.h = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCreatedEventArgsDetail.prototype, "parentID", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCreatedEventArgsDetail.prototype, "grid", {
        get: function () {
            var r = this.i.g;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrHierarchicalGrid({});
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.g = null : this.i.g = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridCreatedEventArgsDetail.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.owner && this.owner.name && this.owner.name == name) {
            return this.owner;
        }
        if (this.grid && this.grid.name && this.grid.name == name) {
            return this.grid;
        }
        return null;
    };
    return IgrGridCreatedEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrGridCreatedEventArgsDetail };
