import { __extends } from "tslib";
import { IgrGridCellIdentifier } from "./igr-grid-cell-identifier";
import { IgrColumn } from "./igr-column";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GridEditDoneEventArgsDetail as GridEditDoneEventArgsDetail_internal } from "./GridEditDoneEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
var IgrGridEditDoneEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridEditDoneEventArgsDetail, _super);
    function IgrGridEditDoneEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrGridEditDoneEventArgsDetail.prototype.createImplementation = function () {
        return new GridEditDoneEventArgsDetail_internal();
    };
    Object.defineProperty(IgrGridEditDoneEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridEditDoneEventArgsDetail.prototype, "rowID", {
        get: function () {
            return this.i.p;
        },
        set: function (v) {
            this.i.p = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridEditDoneEventArgsDetail.prototype, "primaryKey", {
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridEditDoneEventArgsDetail.prototype, "cellID", {
        get: function () {
            var r = this.i.i;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrGridCellIdentifier();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.i = null : this.i.i = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridEditDoneEventArgsDetail.prototype, "rowData", {
        get: function () {
            return this.i.o;
        },
        set: function (v) {
            this.i.o = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridEditDoneEventArgsDetail.prototype, "oldValue", {
        get: function () {
            return this.i.m;
        },
        set: function (v) {
            this.i.m = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridEditDoneEventArgsDetail.prototype, "newValue", {
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridEditDoneEventArgsDetail.prototype, "column", {
        get: function () {
            var r = this.i.g;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.g = null : this.i.g = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridEditDoneEventArgsDetail.prototype, "owner", {
        get: function () {
            var r = this.i.h;
            if (r == null) {
                return null;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.h = null : this.i.h = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridEditDoneEventArgsDetail.prototype, "isAddRow", {
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridEditDoneEventArgsDetail.prototype, "valid", {
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrGridEditDoneEventArgsDetail.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.cellID && this.cellID.name && this.cellID.name == name) {
            return this.cellID;
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        if (this.owner && this.owner.name && this.owner.name == name) {
            return this.owner;
        }
        return null;
    };
    return IgrGridEditDoneEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrGridEditDoneEventArgsDetail };
