import { GridEmptyTemplateContext as GridEmptyTemplateContext_internal } from "./GridEmptyTemplateContext";
var IgrGridEmptyTemplateContext = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridEmptyTemplateContext() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridEmptyTemplateContext.prototype.createImplementation = function () {
        return new GridEmptyTemplateContext_internal();
    };
    Object.defineProperty(IgrGridEmptyTemplateContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridEmptyTemplateContext.prototype.onImplementationCreated = function () {
    };
    IgrGridEmptyTemplateContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrGridEmptyTemplateContext.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrGridEmptyTemplateContext.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridEmptyTemplateContext;
}());
export { IgrGridEmptyTemplateContext };
