import { IgrDataGridColumn } from "./igr-data-grid-column";
import { GridFilterDialogOpeningEventArgs as GridFilterDialogOpeningEventArgs_internal } from "./GridFilterDialogOpeningEventArgs";
var IgrGridFilterDialogOpeningEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridFilterDialogOpeningEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridFilterDialogOpeningEventArgs.prototype.createImplementation = function () {
        return new GridFilterDialogOpeningEventArgs_internal();
    };
    Object.defineProperty(IgrGridFilterDialogOpeningEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridFilterDialogOpeningEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridFilterDialogOpeningEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridFilterDialogOpeningEventArgs.prototype, "column", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrDataGridColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridFilterDialogOpeningEventArgs;
}());
export { IgrGridFilterDialogOpeningEventArgs };
