import { IgrFilterExpressionCollection } from "igniteui-react-core";
import { GridFilterExpressionsEventArgs as GridFilterExpressionsEventArgs_internal } from "./GridFilterExpressionsEventArgs";
var IgrGridFilterExpressionsEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridFilterExpressionsEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridFilterExpressionsEventArgs.prototype.createImplementation = function () {
        return new GridFilterExpressionsEventArgs_internal();
    };
    Object.defineProperty(IgrGridFilterExpressionsEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridFilterExpressionsEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridFilterExpressionsEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridFilterExpressionsEventArgs.prototype, "filterExpressions", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrFilterExpressionCollection();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridFilterExpressionsEventArgs;
}());
export { IgrGridFilterExpressionsEventArgs };
