import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { FilterOperand as FilterOperand_internal } from './FilterOperand';
import { IgrFilterOperand as IgrFilterOperand } from './igr-filter-operand';
var IgrGridFilterOperandsCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridFilterOperandsCollection, _super);
    function IgrGridFilterOperandsCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrFilterOperand.$type) {
            IgrFilterOperand.$type = markType(IgrFilterOperand, "IgrFilterOperand");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrGridFilterOperandsCollection.prototype._createInnerColl = function () {
        if (!IgrFilterOperand.$type) {
            IgrFilterOperand.$type = markType(IgrFilterOperand, "IgrFilterOperand");
        }
        var coll = new SyncableObservableCollection$2(IgrFilterOperand.$type, FilterOperand_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrFilterOperand();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrGridFilterOperandsCollection;
}(IgCollection));
export { IgrGridFilterOperandsCollection };
