import { IgrHeaderType } from "./igr-header-type";
import { GridHeaderTemplateContext as GridHeaderTemplateContext_internal } from "./GridHeaderTemplateContext";
var IgrGridHeaderTemplateContext = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridHeaderTemplateContext() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridHeaderTemplateContext.prototype.createImplementation = function () {
        return new GridHeaderTemplateContext_internal();
    };
    Object.defineProperty(IgrGridHeaderTemplateContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridHeaderTemplateContext.prototype.onImplementationCreated = function () {
    };
    IgrGridHeaderTemplateContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridHeaderTemplateContext.prototype, "implicit", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrHeaderType();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridHeaderTemplateContext.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.implicit && this.implicit.name && this.implicit.name == name) {
            return this.implicit;
        }
        return null;
    };
    IgrGridHeaderTemplateContext.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridHeaderTemplateContext;
}());
export { IgrGridHeaderTemplateContext };
