import { __extends } from "tslib";
import { GridKeydownTargetType_$type } from "./GridKeydownTargetType";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GridKeydownEventArgsDetail as GridKeydownEventArgsDetail_internal } from "./GridKeydownEventArgsDetail";
import { ensureEnum, ensureBool } from "igniteui-react-core";
var IgrGridKeydownEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridKeydownEventArgsDetail, _super);
    function IgrGridKeydownEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrGridKeydownEventArgsDetail.prototype.createImplementation = function () {
        return new GridKeydownEventArgsDetail_internal();
    };
    Object.defineProperty(IgrGridKeydownEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridKeydownEventArgsDetail.prototype, "targetType", {
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = ensureEnum(GridKeydownTargetType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridKeydownEventArgsDetail.prototype, "target", {
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridKeydownEventArgsDetail.prototype, "event", {
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridKeydownEventArgsDetail.prototype, "cancel", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridKeydownEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrGridKeydownEventArgsDetail };
