import { GridMasterDetailContext as GridMasterDetailContext_internal } from "./GridMasterDetailContext";
var IgrGridMasterDetailContext = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridMasterDetailContext() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridMasterDetailContext.prototype.createImplementation = function () {
        return new GridMasterDetailContext_internal();
    };
    Object.defineProperty(IgrGridMasterDetailContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridMasterDetailContext.prototype.onImplementationCreated = function () {
    };
    IgrGridMasterDetailContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridMasterDetailContext.prototype, "implicit", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridMasterDetailContext.prototype, "index", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridMasterDetailContext.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrGridMasterDetailContext.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridMasterDetailContext;
}());
export { IgrGridMasterDetailContext };
