import { GridRowDragGhostContext as GridRowDragGhostContext_internal } from "./GridRowDragGhostContext";
var IgrGridRowDragGhostContext = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridRowDragGhostContext() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridRowDragGhostContext.prototype.createImplementation = function () {
        return new GridRowDragGhostContext_internal();
    };
    Object.defineProperty(IgrGridRowDragGhostContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridRowDragGhostContext.prototype.onImplementationCreated = function () {
    };
    IgrGridRowDragGhostContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridRowDragGhostContext.prototype, "implicit", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridRowDragGhostContext.prototype, "data", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridRowDragGhostContext.prototype, "grid", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridRowDragGhostContext.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.grid && this.grid.name && this.grid.name == name) {
            return this.grid;
        }
        return null;
    };
    IgrGridRowDragGhostContext.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridRowDragGhostContext;
}());
export { IgrGridRowDragGhostContext };
