import { __extends } from "tslib";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GridScrollEventArgsDetail as GridScrollEventArgsDetail_internal } from "./GridScrollEventArgsDetail";
/**
 * Event emitted when a grid is scrolled.
*/
var IgrGridScrollEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridScrollEventArgsDetail, _super);
    function IgrGridScrollEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrGridScrollEventArgsDetail.prototype.createImplementation = function () {
        return new GridScrollEventArgsDetail_internal();
    };
    Object.defineProperty(IgrGridScrollEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridScrollEventArgsDetail.prototype, "direction", {
        /**
         * The scroll direction - vertical or horizontal.
        */
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridScrollEventArgsDetail.prototype, "event", {
        /**
         * The original browser scroll event.
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridScrollEventArgsDetail.prototype, "scrollPosition", {
        /**
         * The new scroll position
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = +v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridScrollEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrGridScrollEventArgsDetail };
