import { IgrGridScrollEventArgsDetail } from "./igr-grid-scroll-event-args-detail";
import { GridScrollEventArgs as GridScrollEventArgs_internal } from "./GridScrollEventArgs";
/**
 * Event emitted when a grid is scrolled.
*/
var IgrGridScrollEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridScrollEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridScrollEventArgs.prototype.createImplementation = function () {
        return new GridScrollEventArgs_internal();
    };
    Object.defineProperty(IgrGridScrollEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridScrollEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridScrollEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridScrollEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrGridScrollEventArgsDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridScrollEventArgs;
}());
export { IgrGridScrollEventArgs };
