import { GridSelectionRangeDetail as GridSelectionRangeDetail_internal } from "./GridSelectionRangeDetail";
var IgrGridSelectionRangeDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridSelectionRangeDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridSelectionRangeDetail.prototype.createImplementation = function () {
        return new GridSelectionRangeDetail_internal();
    };
    Object.defineProperty(IgrGridSelectionRangeDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridSelectionRangeDetail.prototype.onImplementationCreated = function () {
    };
    IgrGridSelectionRangeDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridSelectionRangeDetail.prototype, "rowStart", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridSelectionRangeDetail.prototype, "rowEnd", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridSelectionRangeDetail.prototype, "columnStart", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridSelectionRangeDetail.prototype, "columnEnd", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridSelectionRangeDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrGridSelectionRangeDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridSelectionRangeDetail;
}());
export { IgrGridSelectionRangeDetail };
