import { IgrGridSelectionRangeDetail } from "./igr-grid-selection-range-detail";
import { GridSelectionRangeEventArgs as GridSelectionRangeEventArgs_internal } from "./GridSelectionRangeEventArgs";
var IgrGridSelectionRangeEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridSelectionRangeEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridSelectionRangeEventArgs.prototype.createImplementation = function () {
        return new GridSelectionRangeEventArgs_internal();
    };
    Object.defineProperty(IgrGridSelectionRangeEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridSelectionRangeEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridSelectionRangeEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridSelectionRangeEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrGridSelectionRangeDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridSelectionRangeEventArgs;
}());
export { IgrGridSelectionRangeEventArgs };
