import { IgrColumnSummaryDescriptionCollection } from "./igr-column-summary-description-collection";
import { GridSummaryDescriptionsChangedEventArgs as GridSummaryDescriptionsChangedEventArgs_internal } from "./GridSummaryDescriptionsChangedEventArgs";
/**
 * Information about the current summaries applied to the grid.
*/
var IgrGridSummaryDescriptionsChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridSummaryDescriptionsChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridSummaryDescriptionsChangedEventArgs.prototype.createImplementation = function () {
        return new GridSummaryDescriptionsChangedEventArgs_internal();
    };
    Object.defineProperty(IgrGridSummaryDescriptionsChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridSummaryDescriptionsChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridSummaryDescriptionsChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridSummaryDescriptionsChangedEventArgs.prototype, "summaryDescriptions", {
        get: function () {
            var r = this.i.summaryDescriptions;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrColumnSummaryDescriptionCollection();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.summaryDescriptions = null : this.i.summaryDescriptions = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridSummaryDescriptionsChangedEventArgs;
}());
export { IgrGridSummaryDescriptionsChangedEventArgs };
