import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { GridToolbarContent as GridToolbarContent_internal } from './GridToolbarContent';
import { IgrGridToolbarContent as IgrGridToolbarContent } from './igr-grid-toolbar-content';
var IgrGridToolbarContentCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridToolbarContentCollection, _super);
    function IgrGridToolbarContentCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrGridToolbarContent.$type) {
            IgrGridToolbarContent.$type = markType(IgrGridToolbarContent, "IgrGridToolbarContent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrGridToolbarContentCollection.prototype._createInnerColl = function () {
        if (!IgrGridToolbarContent.$type) {
            IgrGridToolbarContent.$type = markType(IgrGridToolbarContent, "IgrGridToolbarContent");
        }
        var coll = new SyncableObservableCollection$2(IgrGridToolbarContent.$type, GridToolbarContent_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrGridToolbarContent._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrGridToolbarContentCollection;
}(IgCollection));
export { IgrGridToolbarContentCollection };
