import { GridToolbarTemplateContext as GridToolbarTemplateContext_internal } from "./GridToolbarTemplateContext";
var IgrGridToolbarTemplateContext = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridToolbarTemplateContext() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridToolbarTemplateContext.prototype.createImplementation = function () {
        return new GridToolbarTemplateContext_internal();
    };
    Object.defineProperty(IgrGridToolbarTemplateContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridToolbarTemplateContext.prototype.onImplementationCreated = function () {
    };
    IgrGridToolbarTemplateContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridToolbarTemplateContext.prototype, "implicit", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridToolbarTemplateContext.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.implicit && this.implicit.name && this.implicit.name == name) {
            return this.implicit;
        }
        return null;
    };
    IgrGridToolbarTemplateContext.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridToolbarTemplateContext;
}());
export { IgrGridToolbarTemplateContext };
