import { ValidationStatus_$type } from "./ValidationStatus";
import { GridValidationStatusEventArgsDetail as GridValidationStatusEventArgsDetail_internal } from "./GridValidationStatusEventArgsDetail";
import { ensureEnum } from "igniteui-react-core";
var IgrGridValidationStatusEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridValidationStatusEventArgsDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridValidationStatusEventArgsDetail.prototype.createImplementation = function () {
        return new GridValidationStatusEventArgsDetail_internal();
    };
    Object.defineProperty(IgrGridValidationStatusEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridValidationStatusEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrGridValidationStatusEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridValidationStatusEventArgsDetail.prototype, "status", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureEnum(ValidationStatus_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridValidationStatusEventArgsDetail.prototype, "owner", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridValidationStatusEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.owner && this.owner.name && this.owner.name == name) {
            return this.owner;
        }
        return null;
    };
    IgrGridValidationStatusEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridValidationStatusEventArgsDetail;
}());
export { IgrGridValidationStatusEventArgsDetail };
