import { __extends } from "tslib";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GroupingDoneEventArgsDetail as GroupingDoneEventArgsDetail_internal } from "./GroupingDoneEventArgsDetail";
import { IgrColumn } from "./igr-column";
var IgrGroupingDoneEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGroupingDoneEventArgsDetail, _super);
    function IgrGroupingDoneEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrGroupingDoneEventArgsDetail.prototype.createImplementation = function () {
        return new GroupingDoneEventArgsDetail_internal();
    };
    Object.defineProperty(IgrGroupingDoneEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGroupingDoneEventArgsDetail.prototype, "expressions", {
        get: function () {
            if (!this.i.g) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.g.length; i++) {
                var impl = this.i.g[i];
                ret.push(impl.nativeElement);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i]);
            }
            this.i.g = arr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGroupingDoneEventArgsDetail.prototype, "groupedColumns", {
        get: function () {
            if (!this.i.h) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.h.length; i++) {
                var impl = this.i.h[i];
                if (!impl.externalObject) {
                    if (impl instanceof IgrColumn) {
                        ret.push(impl);
                        continue;
                    }
                    var e = IgrColumn._createFromInternal(impl);
                    e._implementation = impl;
                    impl.externalObject = e;
                }
                ret.push(impl.externalObject);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i].i);
            }
            this.i.h = arr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGroupingDoneEventArgsDetail.prototype, "ungroupedColumns", {
        get: function () {
            if (!this.i.i) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.i.length; i++) {
                var impl = this.i.i[i];
                if (!impl.externalObject) {
                    if (impl instanceof IgrColumn) {
                        ret.push(impl);
                        continue;
                    }
                    var e = IgrColumn._createFromInternal(impl);
                    e._implementation = impl;
                    impl.externalObject = e;
                }
                ret.push(impl.externalObject);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i].i);
            }
            this.i.i = arr;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGroupingDoneEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrGroupingDoneEventArgsDetail };
