import { __extends } from "tslib";
import { IgrDefinitionBase } from "./igr-definition-base";
import { HeaderRowSeparator } from "./HeaderRowSeparator";
/**
 * Represents a Header Row separator. This is used to visually separate the header row from the rest of the rows in a grid.
*/
var IgrHeaderRowSeparator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrHeaderRowSeparator, _super);
    function IgrHeaderRowSeparator(props) {
        return _super.call(this, props) || this;
    }
    IgrHeaderRowSeparator.prototype.createImplementation = function () {
        return new HeaderRowSeparator();
    };
    Object.defineProperty(IgrHeaderRowSeparator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    return IgrHeaderRowSeparator;
}(IgrDefinitionBase));
export { IgrHeaderRowSeparator };
