import { __extends } from "tslib";
import { IgrSummaryOperand } from "./igr-summary-operand";
import { NumberSummaryOperand as NumberSummaryOperand_internal } from "./NumberSummaryOperand";
var IgrNumberSummaryOperand = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrNumberSummaryOperand, _super);
    function IgrNumberSummaryOperand() {
        return _super.call(this) || this;
    }
    IgrNumberSummaryOperand.prototype.createImplementation = function () {
        var impl = new NumberSummaryOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    };
    Object.defineProperty(IgrNumberSummaryOperand.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrNumberSummaryOperand.prototype.min = function (data) {
        var iv = this.i.k(data);
        return (iv);
    };
    IgrNumberSummaryOperand.prototype.max = function (data) {
        var iv = this.i.j(data);
        return (iv);
    };
    IgrNumberSummaryOperand.prototype.sum = function (data) {
        var iv = this.i.l(data);
        return (iv);
    };
    IgrNumberSummaryOperand.prototype.average = function (data) {
        var iv = this.i.i(data);
        return (iv);
    };
    IgrNumberSummaryOperand.prototype.operate = function (data, allData, fieldName, groupRecord) {
        var iv = this.i.h(data, allData, fieldName, (groupRecord == null ? null : groupRecord.i));
        var ret = [];
        for (var i = 0; i < iv.length; i++) {
            var impl = iv[i];
            if (!impl.externalObject) {
                var e = impl.nativeElement;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    };
    return IgrNumberSummaryOperand;
}(IgrSummaryOperand));
export { IgrNumberSummaryOperand };
