import { OperatorSelectorValueChangedEventArgs as OperatorSelectorValueChangedEventArgs_internal } from "./OperatorSelectorValueChangedEventArgs";
/**
 * Event arguments for the ComparisonOperatorSelector ValueChanged event.
*/
var IgrOperatorSelectorValueChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrOperatorSelectorValueChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrOperatorSelectorValueChangedEventArgs.prototype.createImplementation = function () {
        return new OperatorSelectorValueChangedEventArgs_internal();
    };
    Object.defineProperty(IgrOperatorSelectorValueChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrOperatorSelectorValueChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrOperatorSelectorValueChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrOperatorSelectorValueChangedEventArgs.prototype, "oldValue", {
        get: function () {
            return this.i.oldValue;
        },
        set: function (v) {
            this.i.oldValue = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOperatorSelectorValueChangedEventArgs.prototype, "newValue", {
        get: function () {
            return this.i.newValue;
        },
        set: function (v) {
            this.i.newValue = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrOperatorSelectorValueChangedEventArgs;
}());
export { IgrOperatorSelectorValueChangedEventArgs };
