import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { Paginator as Paginator_internal } from './Paginator';
import { IgrPaginator as IgrPaginator } from './igr-paginator';
var IgrPaginatorCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPaginatorCollection, _super);
    function IgrPaginatorCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrPaginator.$type) {
            IgrPaginator.$type = markType(IgrPaginator, "IgrPaginator");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrPaginatorCollection.prototype._createInnerColl = function () {
        if (!IgrPaginator.$type) {
            IgrPaginator.$type = markType(IgrPaginator, "IgrPaginator");
        }
        var coll = new SyncableObservableCollection$2(IgrPaginator.$type, Paginator_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrPaginator._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrPaginatorCollection;
}(IgCollection));
export { IgrPaginatorCollection };
