import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { PivotAggregator as PivotAggregator_internal } from './PivotAggregator';
import { IgrPivotAggregator as IgrPivotAggregator } from './igr-pivot-aggregator';
var IgrPivotAggregatorCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPivotAggregatorCollection, _super);
    function IgrPivotAggregatorCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrPivotAggregator.$type) {
            IgrPivotAggregator.$type = markType(IgrPivotAggregator, "IgrPivotAggregator");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrPivotAggregatorCollection.prototype._createInnerColl = function () {
        if (!IgrPivotAggregator.$type) {
            IgrPivotAggregator.$type = markType(IgrPivotAggregator, "IgrPivotAggregator");
        }
        var coll = new SyncableObservableCollection$2(IgrPivotAggregator.$type, PivotAggregator_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrPivotAggregator();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrPivotAggregatorCollection;
}(IgCollection));
export { IgrPivotAggregatorCollection };
