import { IgrPivotConfiguration } from "./igr-pivot-configuration";
import { PivotConfigurationChangedEventArgsDetail as PivotConfigurationChangedEventArgsDetail_internal } from "./PivotConfigurationChangedEventArgsDetail";
/**
 * Event emitted when pivot configuration is changed.
*/
var IgrPivotConfigurationChangedEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrPivotConfigurationChangedEventArgsDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPivotConfigurationChangedEventArgsDetail.prototype.createImplementation = function () {
        return new PivotConfigurationChangedEventArgsDetail_internal();
    };
    Object.defineProperty(IgrPivotConfigurationChangedEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPivotConfigurationChangedEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrPivotConfigurationChangedEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPivotConfigurationChangedEventArgsDetail.prototype, "pivotConfiguration", {
        /**
         * The new configuration.
        */
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrPivotConfiguration();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrPivotConfigurationChangedEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.pivotConfiguration && this.pivotConfiguration.name && this.pivotConfiguration.name == name) {
            return this.pivotConfiguration;
        }
        return null;
    };
    IgrPivotConfigurationChangedEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrPivotConfigurationChangedEventArgsDetail;
}());
export { IgrPivotConfigurationChangedEventArgsDetail };
