import { IgrPivotConfigurationChangedEventArgsDetail } from "./igr-pivot-configuration-changed-event-args-detail";
import { PivotConfigurationChangedEventArgs as PivotConfigurationChangedEventArgs_internal } from "./PivotConfigurationChangedEventArgs";
/**
 * Event emitted when pivot configuration is changed.
*/
var IgrPivotConfigurationChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrPivotConfigurationChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPivotConfigurationChangedEventArgs.prototype.createImplementation = function () {
        return new PivotConfigurationChangedEventArgs_internal();
    };
    Object.defineProperty(IgrPivotConfigurationChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPivotConfigurationChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrPivotConfigurationChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPivotConfigurationChangedEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrPivotConfigurationChangedEventArgsDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrPivotConfigurationChangedEventArgs;
}());
export { IgrPivotConfigurationChangedEventArgs };
