import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { PivotDimension as PivotDimension_internal } from './PivotDimension';
import { IgrPivotDimension as IgrPivotDimension } from './igr-pivot-dimension';
var IgrPivotDimensionCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPivotDimensionCollection, _super);
    function IgrPivotDimensionCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrPivotDimension.$type) {
            IgrPivotDimension.$type = markType(IgrPivotDimension, "IgrPivotDimension");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrPivotDimensionCollection.prototype._createInnerColl = function () {
        if (!IgrPivotDimension.$type) {
            IgrPivotDimension.$type = markType(IgrPivotDimension, "IgrPivotDimension");
        }
        var coll = new SyncableObservableCollection$2(IgrPivotDimension.$type, PivotDimension_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrPivotDimension();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrPivotDimensionCollection;
}(IgCollection));
export { IgrPivotDimensionCollection };
