import { IgrPivotValue } from "./igr-pivot-value";
import { PivotGridValueTemplateContext as PivotGridValueTemplateContext_internal } from "./PivotGridValueTemplateContext";
var IgrPivotGridValueTemplateContext = /** @class */ /*@__PURE__*/ (function () {
    function IgrPivotGridValueTemplateContext() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPivotGridValueTemplateContext.prototype.createImplementation = function () {
        return new PivotGridValueTemplateContext_internal();
    };
    Object.defineProperty(IgrPivotGridValueTemplateContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPivotGridValueTemplateContext.prototype.onImplementationCreated = function () {
    };
    IgrPivotGridValueTemplateContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPivotGridValueTemplateContext.prototype, "implicit", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrPivotValue();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrPivotGridValueTemplateContext.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.implicit && this.implicit.name && this.implicit.name == name) {
            return this.implicit;
        }
        return null;
    };
    IgrPivotGridValueTemplateContext.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrPivotGridValueTemplateContext;
}());
export { IgrPivotGridValueTemplateContext };
