import { __extends } from "tslib";
import { IgrRowType } from "./igr-row-type";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { RowDragEndEventArgsDetail as RowDragEndEventArgsDetail_internal } from "./RowDragEndEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
var IgrRowDragEndEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRowDragEndEventArgsDetail, _super);
    function IgrRowDragEndEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrRowDragEndEventArgsDetail.prototype.createImplementation = function () {
        return new RowDragEndEventArgsDetail_internal();
    };
    Object.defineProperty(IgrRowDragEndEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowDragEndEventArgsDetail.prototype, "dragDirective", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowDragEndEventArgsDetail.prototype, "dragData", {
        get: function () {
            var r = this.i.g;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrRowType();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.g = null : this.i.g = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowDragEndEventArgsDetail.prototype, "animation", {
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrRowDragEndEventArgsDetail.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.dragData && this.dragData.name && this.dragData.name == name) {
            return this.dragData;
        }
        return null;
    };
    return IgrRowDragEndEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrRowDragEndEventArgsDetail };
