import { IgrRowExportingEventArgsDetail } from "./igr-row-exporting-event-args-detail";
import { RowExportingEventArgs as RowExportingEventArgs_internal } from "./RowExportingEventArgs";
/**
 * rowExporting event arguments
 * this.exporterService.rowExporting.subscribe((args: IRowExportingEventArgs) => {
 * // set args properties here
 * })
*/
var IgrRowExportingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrRowExportingEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrRowExportingEventArgs.prototype.createImplementation = function () {
        return new RowExportingEventArgs_internal();
    };
    Object.defineProperty(IgrRowExportingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrRowExportingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrRowExportingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrRowExportingEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrRowExportingEventArgsDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrRowExportingEventArgs;
}());
export { IgrRowExportingEventArgs };
