import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { GridState as GridState_internal } from './GridState';
import { IgrGridState as IgrGridState } from './igr-grid-state';
var IgrStateCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStateCollection, _super);
    function IgrStateCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrGridState.$type) {
            IgrGridState.$type = markType(IgrGridState, "IgrGridState");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrStateCollection.prototype._createInnerColl = function () {
        if (!IgrGridState.$type) {
            IgrGridState.$type = markType(IgrGridState, "IgrGridState");
        }
        var coll = new SyncableObservableCollection$2(IgrGridState.$type, GridState_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrGridState._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrStateCollection;
}(IgCollection));
export { IgrStateCollection };
