import { __extends } from "tslib";
import { IgrFilteringOperand } from "./igr-filtering-operand";
import { StringFilteringOperand as StringFilteringOperand_internal } from "./StringFilteringOperand";
/**
 * Provides filtering operations for strings
 * @export
*/
var IgrStringFilteringOperand = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStringFilteringOperand, _super);
    function IgrStringFilteringOperand() {
        return _super.call(this) || this;
    }
    IgrStringFilteringOperand.prototype.createImplementation = function () {
        var impl = new StringFilteringOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    };
    Object.defineProperty(IgrStringFilteringOperand.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrStringFilteringOperand.prototype.applyIgnoreCase = function (a, ignoreCase) {
        var iv = this.i.k(a, ignoreCase);
        return (iv);
    };
    return IgrStringFilteringOperand;
}(IgrFilteringOperand));
export { IgrStringFilteringOperand };
