import { SummaryOperand as SummaryOperand_internal } from "./SummaryOperand";
var IgrSummaryOperand = /** @class */ /*@__PURE__*/ (function () {
    function IgrSummaryOperand() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrSummaryOperand.prototype.createImplementation = function () {
        var impl = new SummaryOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    };
    Object.defineProperty(IgrSummaryOperand.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrSummaryOperand.prototype.onImplementationCreated = function () {
    };
    IgrSummaryOperand.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrSummaryOperand.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrSummaryOperand.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    IgrSummaryOperand.prototype.count = function (data) {
        var iv = this.i.d(data);
        return (iv);
    };
    IgrSummaryOperand.prototype.operate = function (data, _allData, _fieldName, _groupRecord) {
        var iv = this.i.a(data, _allData, _fieldName, (_groupRecord == null ? null : _groupRecord.i));
        var ret = [];
        for (var i = 0; i < iv.length; i++) {
            var impl = iv[i];
            if (!impl.externalObject) {
                var e = impl.nativeElement;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    };
    return IgrSummaryOperand;
}());
export { IgrSummaryOperand };
