import { SummaryTemplateContext as SummaryTemplateContext_internal } from "./SummaryTemplateContext";
var IgrSummaryTemplateContext = /** @class */ /*@__PURE__*/ (function () {
    function IgrSummaryTemplateContext() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrSummaryTemplateContext.prototype.createImplementation = function () {
        return new SummaryTemplateContext_internal();
    };
    Object.defineProperty(IgrSummaryTemplateContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrSummaryTemplateContext.prototype.onImplementationCreated = function () {
    };
    IgrSummaryTemplateContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrSummaryTemplateContext.prototype, "implicit", {
        get: function () {
            if (!this.i.a) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.a.length; i++) {
                var impl = this.i.a[i];
                ret.push(impl.nativeElement);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i]);
            }
            this.i.a = arr;
        },
        enumerable: false,
        configurable: true
    });
    IgrSummaryTemplateContext.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrSummaryTemplateContext.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrSummaryTemplateContext;
}());
export { IgrSummaryTemplateContext };
