import { __extends } from "tslib";
import { IgrTemplateCellInfo } from "./igr-template-cell-info";
import { TemplateHeaderCellModel as TemplateHeaderCellModel_internal } from "./TemplateHeaderCellModel";
import { ensureBool } from "igniteui-react-core";
/**
 * Backing information for the template header cells.
*/
var IgrTemplateHeaderCellInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTemplateHeaderCellInfo, _super);
    function IgrTemplateHeaderCellInfo() {
        return _super.call(this) || this;
    }
    IgrTemplateHeaderCellInfo.prototype.createImplementation = function () {
        return new TemplateHeaderCellModel_internal();
    };
    Object.defineProperty(IgrTemplateHeaderCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTemplateHeaderCellInfo.prototype, "isFilterUIVisible", {
        /**
         * Sets or gets whether the filter UI should be visible in the header.
        */
        get: function () {
            return this.i.lo;
        },
        set: function (v) {
            this.i.lo = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrTemplateHeaderCellInfo;
}(IgrTemplateCellInfo));
export { IgrTemplateHeaderCellInfo };
