import { __extends } from "tslib";
import { IgrSummaryOperand } from "./igr-summary-operand";
import { TimeSummaryOperand as TimeSummaryOperand_internal } from "./TimeSummaryOperand";
var IgrTimeSummaryOperand = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTimeSummaryOperand, _super);
    function IgrTimeSummaryOperand() {
        return _super.call(this) || this;
    }
    IgrTimeSummaryOperand.prototype.createImplementation = function () {
        var impl = new TimeSummaryOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    };
    Object.defineProperty(IgrTimeSummaryOperand.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrTimeSummaryOperand.prototype.latestTime = function (data) {
        this.i.j(data);
    };
    IgrTimeSummaryOperand.prototype.earliestTime = function (data) {
        this.i.i(data);
    };
    IgrTimeSummaryOperand.prototype.operate = function (data, allData, fieldName, groupRecord) {
        var iv = this.i.h(data, allData, fieldName, (groupRecord == null ? null : groupRecord.i));
        var ret = [];
        for (var i = 0; i < iv.length; i++) {
            var impl = iv[i];
            if (!impl.externalObject) {
                var e = impl.nativeElement;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    };
    return IgrTimeSummaryOperand;
}(IgrSummaryOperand));
export { IgrTimeSummaryOperand };
