
import { IgcColumnComponent } from './igc-column-component';
import { IgcRowType } from './igc-row-type';
import { IgcGridBaseDirective } from './igc-grid-base-directive';
import { IgcGridValidationState } from './igc-grid-validation-state';


/* jsonAPIManageCollectionInMarkup */


/* marshalByValue */
/* jsonAPIComplexObject */

    export declare class IgcCellType
    {

          
    public set value(value: any);
          public get value(): any;
  
          
    public set editValue(value: any);
          public get editValue(): any;
  
          
    public set selected(value: boolean);
          public get selected(): boolean;
  
          
    public set active(value: boolean);
          public get active(): boolean;
  
          
    public set editable(value: boolean);
          public get editable(): boolean;
  
          
    public set editMode(value: boolean);
          public get editMode(): boolean;
  
          
    public set column(value: IgcColumnComponent);
          public get column(): IgcColumnComponent;
  
          
    /* blazorCSSuppress */
    public set row(value: IgcRowType);
          public get row(): IgcRowType;
  
          
    public set grid(value: IgcGridBaseDirective);
          public get grid(): IgcGridBaseDirective;
  
          
    public id?: { rowID: any; columnID: number; rowIndex: number; };
  
          
    public cellID?: any;
  
          
    public validation?: IgcGridValidationState;
  
          
    public readonly?: boolean;
  
          
    public title?: any;
  
          
    public set width(value: string);
          public get width(): string;
  
          
    public visibleColumnIndex?: number;
  
            
    public update(value: any): void;

            
    public setEditMode?(value: boolean): void;

            
    public calculateSizeToFit?(range: any): number;

    }


        