
import { IgcRowIslandComponent } from './igc-row-island-component';





    export declare class IgcChildGridRowComponent
    {

          
    public set layout(value: IgcRowIslandComponent);
          public get layout(): IgcRowIslandComponent;
  
          

    /**
     *  The data passed to the row component.
     *
     * ```typescript
     * // get the row data for the first selected row
     * let selectedRowData = this.grid.selectedRows[0].data;
     * ```
     */
    public set data(value: any);
          public get data(): any;
  
          
    /**
     * The index of the row.
     *
     * ```typescript
     * // get the index of the second selected row
     * let selectedRowIndex = this.grid.selectedRows[1].index;
     * ```
     */
    public set index(value: number);
          public get index(): number;
  
                

    public get level(): number;
        
          

    /**
     * Returns whether the row is expanded.
     * ```typescript
     * const RowExpanded = this.grid1.rowList.first.expanded;
     * ```
     */
    public set expanded(value: boolean);
          public get expanded(): boolean;
  
    }


        