
import { Point } from './common';
                import { HorizontalAlignment } from './horizontal-alignment';
import { VerticalAlignment } from './vertical-alignment';
import { IgcSize } from './igc-size';


/* jsonAPIPlainObject */



    export declare class IgcPositionSettings
    {

          
    /**
     * Attaching target for the component to show
     *
     * @deprecated in version 10.2.0. Set the target point/element in the overlay settings instead
     */
    public target?: HTMLElement | Point;
  
          
    /** Direction in which the component should show */
    public horizontalDirection?: HorizontalAlignment;
  
          
    /** Direction in which the component should show */
    public verticalDirection?: VerticalAlignment;
  
          
    /** Target's starting point */
    public horizontalStartPoint?: HorizontalAlignment;
  
          
    /** Target's starting point */
    public verticalStartPoint?: VerticalAlignment;
  
          
    /** The size up to which element may shrink when shown in elastic position strategy */
    public minSize?: IgcSize;
  
    }


        