import { Base, Type } from "igniteui-react-core";
import { IEditorView } from "./IEditorView";
import { DomRenderer } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ICellActionManager } from "./ICellActionManager";
import { FontInfo } from "igniteui-react-core";
import { KeyEventArgs } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class BaseEditorView extends Base implements IEditorView {
    static $t: Type;
    private d;
    private i;
    private e;
    private c;
    private f;
    private b;
    h: DomRenderer;
    private _container;
    get container(): any;
    set container(a: any);
    g: boolean;
    get value(): any;
    set value(a: any);
    get isEnabled(): boolean;
    set isEnabled(a: boolean);
    get focusOnValueChanged(): boolean;
    set focusOnValueChanged(a: boolean);
    get showClearButton(): boolean;
    set showClearButton(a: boolean);
    private x;
    get textColor(): Brush;
    set textColor(a: Brush);
    valueProvided: (sender: IEditorView, value: any, ignoreValue: boolean) => void;
    protected q(a: any, b: boolean): void;
    userTyping: (sender: IEditorView) => void;
    protected p(): void;
    lostFocus: (sender: IEditorView) => void;
    protected o(): void;
    gotFocus: (sender: IEditorView) => void;
    protected n(): void;
    protected a: ICellActionManager;
    constructor(a: DomRenderer, b: ICellActionManager);
    setFont(a: FontInfo): void;
    attachEvents(): void;
    detachEvents(): void;
    onTargetChanged(): void;
    onEditEnded(): void;
    onEditStarted(): void;
    cleanUp(): void;
    focus(): void;
    protected s(): void;
    getEditorValue(): any;
    setEditorValue(a: any): void;
    protected u(a: string, b: any, c: any): void;
    protected w(): void;
    protected r(): void;
    protected v(): void;
    protected onInputKeyDown(a: any, b: KeyEventArgs): void;
}
