import { GridToolbarBaseAction } from "./GridToolbarBaseAction";
import { WCNativeHelper } from "igniteui-react";
import { Type } from "igniteui-react-core";
import { OverlaySettings } from "./OverlaySettings";
import { ToggleViewCancelableEventArgs } from "./ToggleViewCancelableEventArgs";
import { ToggleViewEventArgs } from "./ToggleViewEventArgs";
import { ColumnToggledEventArgs } from "./ColumnToggledEventArgs";
/**
 * @hidden
 */
export declare abstract class BaseToolbarDirective extends GridToolbarBaseAction {
    static $t: Type;
    private h;
    protected get i(): WCNativeHelper;
    private j;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get l(): string;
    set l(a: string);
    get n(): string;
    set n(a: string);
    get m(): string;
    set m(a: string);
    get c(): OverlaySettings;
    set c(a: OverlaySettings);
    opening: (sender: any, args: ToggleViewCancelableEventArgs) => void;
    openingChanged(): void;
    opened: (sender: any, args: ToggleViewEventArgs) => void;
    openedChanged(): void;
    closing: (sender: any, args: ToggleViewEventArgs) => void;
    closingChanged(): void;
    closed: (sender: any, args: ToggleViewEventArgs) => void;
    closedChanged(): void;
    columnToggle: (sender: any, args: ColumnToggledEventArgs) => void;
    columnToggleChanged(): void;
    protected get_a(): string;
    protected set_a(a: string): void;
    get a(): string;
    set a(a: string);
}
