import { Base, Type } from "igniteui-react-core";
import { ICellPresenter } from "./ICellPresenter";
import { INativeCell } from "./INativeCell";
import { CanvasGridCellBase } from "./CanvasGridCellBase";
import { CellModel } from "./CellModel";
/**
 * @hidden
 */
export declare class CanvasCellPresenterBase extends Base implements ICellPresenter {
    static $t: Type;
    a: CanvasGridCellBase;
    constructor(a: CanvasGridCellBase);
    modelUpdated(a: CellModel): void;
    protected b(a: CellModel): void;
    private c;
    get nativeCell(): INativeCell;
    get isCanvasBased(): boolean;
}
