import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { XInputGroup } from "igniteui-react-inputs";
import { XInput } from "igniteui-react-inputs";
import { ControlDisplayDensity } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { CheckboxListIndexType } from "./CheckboxListIndexType";
import { DataGrid } from "./DataGrid";
import { GridSelectedKeysCollection } from "./GridSelectedKeysCollection";
import { InputGroupDisplayType } from "igniteui-react-inputs";
import { BaseControlTheme } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ScrollbarStyle } from "igniteui-react-core";
import { CheckedChangedEventArgs } from "./CheckedChangedEventArgs";
import { DataGridCellEventArgs } from "./DataGridCellEventArgs";
import { SelectAllCheckboxChangedEventArgs } from "./SelectAllCheckboxChangedEventArgs";
/**
 * @hidden
 */
export declare class CheckboxListView extends Base {
    static $t: Type;
    private e;
    private j;
    private a;
    private i;
    private h;
    private c;
    constructor();
    b: CheckboxList;
    n(): void;
    f: DomRenderer;
    m(a: DomRenderer): void;
    v(): void;
    w(a: DomRenderer): void;
    s(): void;
    o(a: DomWrapper, b: any, c: boolean): void;
    z(): void;
    x(): void;
    private k;
    l(): void;
    t(a: number, b: boolean): void;
    u(a: boolean): void;
    q(a: any): void;
    private ah;
    af(): void;
    ai(): void;
    ae(): void;
    private d;
    private g;
    ag(a?: boolean): void;
    private r;
    ad(): void;
    ab(): void;
    ac(): void;
    y(): void;
    aa(a: Thickness): void;
    p(a: any): void;
}
/**
 * @hidden
 */
export declare class CheckboxList extends Base implements INotifyPropertyChanged {
    static $t: Type;
    m: CheckboxListView;
    h: DataGrid;
    private i;
    private ab;
    private d;
    private ai;
    private c;
    private o;
    private q;
    get r(): XInputGroup;
    set r(a: XInputGroup);
    get p(): XInput;
    set p(a: XInput);
    private aj;
    static readonly dx: Brush;
    static readonly bt: string;
    private get e();
    private ag;
    private get ah();
    private f;
    get g(): GridSelectedKeysCollection;
    private a;
    get b(): string[];
    set b(a: string[]);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    private cr;
    private cl;
    private cm;
    checkedChanged: (sender: any, args: CheckedChangedEventArgs) => void;
    ci(a: number, b: boolean): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer, b: DataGrid, c: any): void;
    provideSelectAllSection(a: any): void;
    cb(a: any, b: DataGridCellEventArgs): void;
    private b8;
    cj(a: string): void;
    private ay;
    get itemsSource(): any;
    set itemsSource(a: any);
    private a0;
    get bc(): string;
    set bc(a: string);
    private a2;
    get b0(): string;
    set b0(a: string);
    private a1;
    get bg(): string;
    set bg(a: string);
    private s;
    get t(): InputGroupDisplayType;
    set t(a: InputGroupDisplayType);
    private au;
    get ax(): number;
    set ax(a: number);
    get av(): number;
    private ac;
    get ae(): FontInfo;
    set ae(a: FontInfo);
    private k;
    get l(): CheckboxListIndexType;
    set l(a: CheckboxListIndexType);
    private x;
    get y(): BaseControlTheme;
    set y(a: BaseControlTheme);
    private z;
    get aa(): ControlDisplayDensity;
    set aa(a: ControlDisplayDensity);
    private dd;
    get du(): Brush;
    set du(a: Brush);
    private db;
    get ds(): Brush;
    set ds(a: Brush);
    private de;
    get dv(): Brush;
    set dv(a: Brush);
    private dc;
    get dt(): Brush;
    set dt(a: Brush);
    private ad;
    get af(): FontInfo;
    set af(a: FontInfo);
    private c7;
    get dl(): Brush;
    set dl(a: Brush);
    private c5;
    get dj(): Brush;
    set dj(a: Brush);
    private c8;
    get dm(): Brush;
    set dm(a: Brush);
    private c6;
    get dk(): Brush;
    set dk(a: Brush);
    private c9;
    get dn(): Brush;
    set dn(a: Brush);
    private v;
    get w(): ScrollbarStyle;
    set w(a: ScrollbarStyle);
    private da;
    get dr(): Brush;
    set dr(a: Brush);
    protected cn(a: string, b: any, c: any): void;
    protected cs(a: string, b: any, c: any): void;
    private cz;
    private c0;
    private co;
    cq(): void;
    c1(): void;
    updateHrMargin(a: Thickness): void;
    provideHrElement(a: any): void;
    ck(): void;
    private cc;
    private j;
    cw(a: number): void;
    b5(a: number): void;
    cy(): void;
    b9(): void;
    cg(a: number, b: any, c: any): void;
    cd(): void;
    ce(a: number, b: any): void;
    cf(a: number, b: any): void;
    b6(a: any[]): void;
    cx(a: any[]): void;
    private bw;
    get bx(): string;
    set bx(a: string);
    private df;
    get dw(): Brush;
    set dw(a: Brush);
    private c3;
    get dh(): Brush;
    set dh(a: Brush);
    get ao(): boolean;
    private ar;
    get as(): boolean;
    set as(a: boolean);
    static dp: Brush;
    private c4;
    get di(): Brush;
    set di(a: Brush);
    static dq: Brush;
    private dg;
    get dy(): Brush;
    set dy(a: Brush);
    selectAllCheckboxChanged: (sender: any, args: SelectAllCheckboxChangedEventArgs) => void;
    cp(a: boolean): void;
    al(): boolean;
    ak(): boolean;
    private aw;
    b7(): void;
    private ap;
    get aq(): boolean;
    set aq(a: boolean);
    private am;
    get an(): boolean;
    set an(a: boolean);
}
