import { Type } from "igniteui-react-core";
/**
 * Identifies the operator type of a column comparison condition.
 */
export declare enum ColumnComparisonConditionOperatorType {
    Equals = 0,
    NotEquals = 1,
    LessThan = 2,
    LessThanOrEqualTo = 3,
    GreaterThan = 4,
    GreaterThanOrEqualTo = 5,
    Top = 6,
    Bottom = 7,
    TopPercentile = 8,
    BottomPercentile = 9,
    True = 10,
    False = 11,
    Contains = 12,
    DoesNotContain = 13,
    StartsWith = 14,
    DoesNotStartWith = 15,
    EndsWith = 16,
    DoesNotEndWith = 17,
    Today = 18,
    Tomorrow = 19,
    Yesterday = 20,
    NextWeek = 21,
    ThisWeek = 22,
    LastWeek = 23,
    NextMonth = 24,
    ThisMonth = 25,
    LastMonth = 26,
    NextQuarter = 27,
    ThisQuarter = 28,
    LastQuarter = 29,
    NextYear = 30,
    ThisYear = 31,
    LastYear = 32,
    YearToDate = 33,
    Q1 = 34,
    Q2 = 35,
    Q3 = 36,
    Q4 = 37,
    Month = 38,
    Year = 39,
    Empty = 40,
    NotEmpty = 41,
    IsNull = 42,
    IsNotNull = 43,
    Custom = 44
}
/**
 * @hidden
 */
export declare let ColumnComparisonConditionOperatorType_$type: Type;
