import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { CanvasGestureDOMEventProxy } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { GroupInfo } from "./GroupInfo";
import { XIcon } from "igniteui-react-inputs";
import { IColumnGrouping } from "./IColumnGrouping";
import { DataGrid } from "./DataGrid";
import { BaseControlTheme } from "igniteui-react-core";
import { ColumnGroupingVisualModelExport } from "./ColumnGroupingVisualModelExport";
/**
 * @hidden
 */
export declare class ColumnGroupingView extends Base {
    static $t: Type;
    constructor();
    e: ColumnGrouping;
    ai(): void;
    private t;
    private r;
    private i;
    private g;
    private h;
    private n;
    get o(): DomRenderer;
    get u(): DomWrapper;
    get v(): DomWrapper;
    s: DomWrapper;
    get w(): DomWrapper;
    p: DomWrapper;
    get l(): List$1<DomWrapper>;
    get j(): List$1<DomWrapper>;
    get k(): List$1<DomWrapper>;
    d: CanvasGestureDOMEventProxy;
    ah(a: DomRenderer): void;
    an(): void;
    ao(): void;
    private y;
    ar(): void;
    aq(): void;
    ap(): void;
    as(): Rect;
    ac(): void;
    am(a: XIcon, b: any): void;
    private x;
    private af;
    private z;
    private aa;
    private ab;
    private f;
    private q;
    private m;
    private aj;
    private ak;
    private al;
    private ae;
    private ad;
    a(): number[];
    b(a: DomWrapper): number[];
    c(): number[];
    ag(): void;
}
/**
 * @hidden
 */
export declare class ColumnGrouping extends Base implements IColumnGrouping, INotifyPropertyChanged {
    static $t: Type;
    private d;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private static readonly x;
    private static readonly ac;
    private static readonly aa;
    private static readonly ah;
    private static readonly ad;
    private q;
    private e;
    private r;
    private s;
    private t;
    private u;
    constructor();
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private l;
    private get m();
    o: boolean;
    private b;
    get targetGrid(): DataGrid;
    set targetGrid(a: DataGrid);
    private f;
    get g(): BaseControlTheme;
    set g(a: BaseControlTheme);
    private h;
    get i(): ControlDisplayDensity;
    set i(a: ControlDisplayDensity);
    private w;
    get al(): string;
    set al(a: string);
    private bg;
    get bm(): Brush;
    set bm(a: Brush);
    private j;
    get k(): FontInfo;
    set k(a: FontInfo);
    private bf;
    get bl(): Brush;
    set bl(a: Brush);
    private bc;
    get bi(): Brush;
    set bi(a: Brush);
    private bd;
    get bj(): Brush;
    set bj(a: Brush);
    private be;
    get bk(): Brush;
    set bk(a: Brush);
    private bb;
    get bh(): Brush;
    set bh(a: Brush);
    protected ay(a: string, b: any, c: any): void;
    protected az(a: string, b: any, c: any): void;
    private a4;
    private ba;
    private a9;
    private a8;
    private a3;
    private a5;
    p(): List$1<GroupInfo>;
    private aw;
    private v;
    private n;
    private av;
    at(a: any, b: boolean): void;
    aq(a: any): void;
    as(a: any): void;
    ar(a: any): void;
    ap(): void;
    ao(a: string): void;
    a1(a: string): void;
    a2(a: string, b: number): void;
    private a7;
    private a6;
    exportVisualModel(): any;
    exportSerializedVisualModel(): string;
    a(): ColumnGroupingVisualModelExport;
}
