import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { XIcon } from "igniteui-react-inputs";
import { OperatorSelectorOpeningEventArgs } from "./OperatorSelectorOpeningEventArgs";
import { OperatorSelectorClosingEventArgs } from "./OperatorSelectorClosingEventArgs";
import { Popup } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { OperatorModel } from "./OperatorModel";
import { DataGrid } from "./DataGrid";
import { SRProvider } from "igniteui-react-core";
import { XButton } from "igniteui-react-inputs";
import { TemplateColumn } from "./TemplateColumn";
import { List$1 } from "igniteui-react-core";
import { ColumnComparisonConditionOperatorType } from "./ColumnComparisonConditionOperatorType";
import { DataSourceSchemaPropertyType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { OperatorSelectorValueChangedEventArgs } from "./OperatorSelectorValueChangedEventArgs";
/**
 * @hidden
 */
export declare class ComparisonOperatorSelectorView extends Base {
    static $t: Type;
    private i;
    private d;
    private c;
    private h;
    private f;
    private m;
    private b;
    private j;
    private e;
    k: number;
    l: number;
    g: DomRenderer;
    a: ComparisonOperatorSelector;
    constructor(a: ComparisonOperatorSelector);
    u(a: any): void;
    w(): Rect;
    t(a: any, b: OperatorModel): void;
    private q;
    private s;
    private r;
    private n;
    private onDocumentKeyDown;
    private onDocumentMouseDown;
    v(a: any): void;
}
/**
 * @hidden
 */
export declare class ComparisonOperatorSelector extends Base implements INotifyPropertyChanged {
    static $t: Type;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected eg(a: string, b: any, c: any): void;
    protected ei(a: string, b: any, c: any): void;
    protected static readonly dw: string;
    protected static readonly bt: string;
    protected static readonly ca: string;
    protected static readonly ad: string;
    protected static readonly bn: string;
    protected static readonly dl: string;
    protected static readonly bp: string;
    protected static readonly br: string;
    protected static readonly bo: string;
    protected static readonly bw: string;
    protected static readonly bx: string;
    protected static readonly b2: string;
    protected static readonly b3: string;
    protected static readonly bq: string;
    protected static readonly b9: string;
    protected static readonly ds: string;
    protected static readonly dt: string;
    protected static readonly d0: string;
    protected static readonly dn: string;
    protected static readonly b5: string;
    protected static readonly by: string;
    protected static readonly dr: string;
    protected static readonly b8: string;
    protected static readonly b1: string;
    protected static readonly dp: string;
    protected static readonly b6: string;
    protected static readonly bz: string;
    protected static readonly dq: string;
    protected static readonly b7: string;
    protected static readonly b0: string;
    protected static readonly dz: string;
    protected static readonly dh: string;
    protected static readonly di: string;
    protected static readonly dj: string;
    protected static readonly dk: string;
    protected static readonly b4: string;
    protected static readonly dy: string;
    protected static readonly du: string;
    protected static readonly ab: string;
    protected static readonly dv: string;
    protected static readonly ac: string;
    protected static readonly af: string;
    private r;
    protected get s(): SRProvider;
    protected e: ComparisonOperatorSelectorView;
    q: Popup;
    p: XIcon;
    o: XButton;
    f: DataGrid;
    n: TemplateColumn;
    v: List$1<OperatorModel>;
    u: List$1<OperatorModel>;
    private g;
    get i(): OperatorModel;
    set i(a: OperatorModel);
    private t;
    private a;
    get b(): ColumnComparisonConditionOperatorType;
    set b(a: ColumnComparisonConditionOperatorType);
    ae: string;
    x: number;
    private c;
    get d(): DataSourceSchemaPropertyType;
    set d(a: DataSourceSchemaPropertyType);
    private w;
    get z(): number;
    set z(a: number);
    private eo;
    get eq(): Brush;
    set eq(a: Brush);
    private en;
    get ep(): Brush;
    set ep(a: Brush);
    valueChanged: (sender: any, args: OperatorSelectorValueChangedEventArgs) => void;
    opening: (sender: any, args: OperatorSelectorOpeningEventArgs) => void;
    opened: (sender: any, args: OperatorSelectorOpeningEventArgs) => void;
    closing: (sender: any, args: OperatorSelectorClosingEventArgs) => void;
    get dd(): string;
    get ck(): string;
    get cj(): string;
    get cz(): string;
    get cr(): string;
    get cs(): string;
    get cl(): string;
    get cm(): string;
    get db(): string;
    get cb(): string;
    get dc(): string;
    get cc(): string;
    get c9(): string;
    get da(): string;
    get dg(): string;
    get c7(): string;
    get cw(): string;
    get cp(): string;
    get c5(): string;
    get cu(): string;
    get cn(): string;
    get c6(): string;
    get cv(): string;
    get co(): string;
    get c8(): string;
    get cx(): string;
    get cq(): string;
    get df(): string;
    get c0(): string;
    get c1(): string;
    get c2(): string;
    get c3(): string;
    get ct(): string;
    get de(): string;
    get c4(): string;
    get cg(): string;
    get ci(): string;
    get cf(): string;
    get cd(): string;
    get ce(): string;
    get ch(): string;
    get cy(): string;
    constructor();
    ej(a: any): void;
    ea(): void;
    eb(a: Popup, b: XIcon, c: DataGrid): void;
    private eh;
    private ed;
    private ef;
    private ee;
    private bv;
    private bu;
    private d4;
    private h;
    private d2;
    private d5;
    private d3;
    private d6;
    y(): number;
    em(): void;
    d8(): void;
    d1(a: string, b: string, c: string, d: number): void;
    d7(): void;
    ek(a: string, b: number): void;
    private ec;
    private d9;
    private el;
}
