import { Base, Type } from "igniteui-react-core";
import { ICellRenderingEngine } from "./ICellRenderingEngine";
import { DomWrapper, DomRenderer } from "igniteui-react-core";
import { VisualModel } from "./VisualModel";
import { DataGridPresenterManager } from "./DataGridPresenterManager";
import { CellModel } from "./CellModel";
/**
 * @hidden
 */
export declare class DataGridCellLayoutPanel extends Base implements ICellRenderingEngine {
    static $t: Type;
    private e;
    private l;
    private r;
    private _element;
    get element(): DomWrapper;
    set element(a: DomWrapper);
    private g;
    private j;
    protected get s(): DomRenderer;
    protected get f(): VisualModel;
    private _rootElement;
    get rootElement(): DomWrapper;
    set rootElement(a: DomWrapper);
    constructor(a: DomRenderer, b: DataGridPresenterManager, c: number);
    refresh(a: VisualModel, b: boolean): void;
    viewportChanged(): void;
    private n;
    private h;
    invalidateVisibility(a: () => void): void;
    get initialRefreshFinished(): boolean;
    ag(a: number, b: number, c: number, d: number): void;
    ar(a: CellModel): void;
    private m;
    as(a: boolean): void;
    private _requestAnimationFrame;
    private get requestAnimationFrame();
    private set requestAnimationFrame(value);
    protected ac(a: () => void): void;
    private v;
    private p;
    private o;
    private z;
    protected an(): void;
    private k;
    private ab;
    private ad;
    private af;
    private ae;
    private aa;
    private ao;
    private ap;
    private aq;
    private at;
    private am;
    private au;
    private al;
    private av;
    private ak;
    q: number;
    private c;
    private a;
    private d;
    private b;
    private aw;
    private ax;
    private w;
    private x;
    private y;
    protected ah(a: CellModel, b: DomWrapper): void;
    protected aj(a: CellModel, b: DomWrapper): void;
    protected ai(a: CellModel, b: DomWrapper): void;
    detach(): void;
    attach(): void;
}
