import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { XButton } from "igniteui-react-inputs";
import { IDataGridComponent } from "./IDataGridComponent";
import { DataGrid } from "./DataGrid";
import { BaseControlTheme } from "igniteui-react-core";
import { ColumnChooser } from "./ColumnChooser";
import { ColumnPinning } from "./ColumnPinning";
/**
 * @hidden
 */
export declare class DataGridToolbarView extends Base {
    static $t: Type;
    private k;
    private f;
    private d;
    private e;
    private h;
    private i;
    private j;
    private g;
    constructor();
    a: DataGridToolbar;
    s(): void;
    private c;
    p(a: DomRenderer): void;
    ad(): void;
    z(): void;
    aa(): void;
    y(): void;
    ah(): void;
    ai(): void;
    v(): void;
    ae(): void;
    ab(): void;
    private n;
    x(): void;
    af(): void;
    ag(): void;
    private u;
    private w;
    ac(): void;
    private b;
    t(): void;
    l(): void;
    private m;
    private q;
    private r;
    o(): void;
}
/**
 * @hidden
 */
export declare class DataGridToolbar extends Base implements INotifyPropertyChanged, IDataGridComponent {
    static $t: Type;
    private e;
    private c;
    private d;
    s: number;
    t: number;
    g: XButton;
    h: XButton;
    private static readonly ao;
    private static readonly ap;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer, b: ColumnChooser, c: ColumnPinning): void;
    private a;
    get b(): DataGrid;
    set b(a: DataGrid);
    private y;
    get ar(): string;
    set ar(a: string);
    private m;
    get n(): FontInfo;
    set n(a: FontInfo);
    private bd;
    get bg(): Brush;
    set bg(a: Brush);
    private bb;
    get be(): Brush;
    set be(a: Brush);
    private bc;
    get bf(): Brush;
    set bf(a: Brush);
    private o;
    get q(): boolean;
    set q(a: boolean);
    private u;
    get ad(): string;
    set ad(a: string);
    private v;
    get af(): string;
    set af(a: string);
    private p;
    get r(): boolean;
    set r(a: boolean);
    private w;
    get ai(): string;
    set ai(a: string);
    private x;
    get ak(): string;
    set ak(a: string);
    private bh;
    get bi(): Thickness;
    set bi(a: Thickness);
    private k;
    get l(): ControlDisplayDensity;
    set l(a: ControlDisplayDensity);
    private i;
    get j(): BaseControlTheme;
    set j(a: BaseControlTheme);
    protected a0(a: string, b: any, c: any): void;
    protected a1(a: string, b: any, c: any): void;
    private az;
    private a4;
    private a3;
    a5(a: any, b: DomRenderer, c: DomWrapper, d: DomWrapper, e: string): void;
    av(): void;
    private a6;
    private a7;
    private a8;
    private ax;
    private a9;
    private ba;
    exportVisualModel(): any;
    exportSerializedVisualModel(): string;
    private f;
}
