import { Base, Point, Type } from "igniteui-react-core";
import { IDraggerView } from "./IDraggerView";
import { IDragger } from "./IDragger";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { CanvasGestureDOMEventProxy } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class DraggerView extends Base implements IDraggerView {
    static $t: Type;
    private _model;
    get model(): IDragger;
    set model(a: IDragger);
    protected c: DomRenderer;
    d: DomWrapper;
    a: CanvasGestureDOMEventProxy;
    constructor(a: IDragger);
    provideContainer(a: any): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    private b;
    private e;
    private f;
    captureMouse(): void;
    releaseMouse(): void;
    transformPoint(a: number, b: number): Point;
    private g;
    private h;
    onViewportSizeChanged(a: number, b: number): void;
    addCloneCellToDom(): void;
    removeCloneCellFromDom(): void;
    getTopAndLeft(): number[];
    getWindowScrollPos(): number[];
}
