import { GridCellBase } from "./GridCellBase";
import { DataSourceSchemaPropertyType } from "igniteui-react-core";
import { Type } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { EditorType } from "./EditorType";
import { DomRenderer, NormalizedEvent } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class EditorCell extends GridCellBase {
    static $t: Type;
    private cn;
    private cw;
    private cv;
    private cu;
    private ct;
    private dc;
    private dd;
    private de;
    private cx;
    private c0;
    private c4;
    private c1;
    private cj;
    get ck(): DataSourceSchemaPropertyType;
    set ck(a: DataSourceSchemaPropertyType);
    private dg;
    get di(): any;
    set di(a: any);
    private cy;
    get cz(): FontInfo;
    set cz(a: FontInfo);
    private cl;
    get cm(): EditorType;
    set cm(a: EditorType);
    private df;
    get dh(): any;
    set dh(a: any);
    private dj;
    get dm(): string;
    set dm(a: string);
    private ch;
    get ci(): string[];
    set ci(a: string[]);
    private c2;
    get da(): boolean;
    set da(a: boolean);
    private dk;
    get dr(): string;
    set dr(a: string);
    private c3;
    get db(): boolean;
    set db(a: boolean);
    c6: boolean;
    c7: boolean;
    c5: boolean;
    constructor(a: DomRenderer);
    private cs;
    private cr;
    private cq;
    private cp;
    private co;
    private ea;
    private dy;
    private dz;
    ed(a: boolean): void;
    protected ef(): void;
    protected d3(): void;
    protected d7(): void;
    protected d2(): void;
    d8(): void;
    protected d1(): void;
    protected d4(): void;
    protected ec(): void;
    eh(a: string, b: number, c: number, d: number, e: number): void;
    private ei;
    d0(): void;
    bo(): void;
    be(): void;
    protected bp(a: string, b: any, c: any): void;
    private eg;
    private ee;
    private c9;
    private c8;
    private eb;
    private d9;
    private d6;
    private d5;
    onContactStarted(a: NormalizedEvent, b: boolean): void;
    onContactCompleted(a: NormalizedEvent, b: boolean): void;
    onDoubleClick(a: NormalizedEvent): void;
}
