import { GridBaseDirective } from "./GridBaseDirective";
import { Type } from "igniteui-react-core";
import { GridMasterDetailContext } from "./GridMasterDetailContext";
import { GroupByRecord } from "./GroupByRecord";
import { GroupingExpression } from "./GroupingExpression";
import { GroupByExpandState } from "./GroupByExpandState";
import { GridGroupingStrategy } from "./GridGroupingStrategy";
import { GroupByRowSelectorTemplateContext } from "./GroupByRowSelectorTemplateContext";
import { GroupByRowTemplateContext } from "./GroupByRowTemplateContext";
import { CellType } from "./CellType";
import { ForOfStateEventArgs } from "./ForOfStateEventArgs";
import { GroupingDoneEventArgs } from "./GroupingDoneEventArgs";
import { RowType } from "./RowType";
/**
 * @hidden
 */
export declare class Grid extends GridBaseDirective {
    static $t: Type;
    get ha(): boolean;
    set ha(a: boolean);
    private hj;
    get hn(): (arg: any) => any;
    set hn(a: (arg: any) => any);
    private hi;
    get hm(): (arg: GridMasterDetailContext) => any;
    set hm(a: (arg: GridMasterDetailContext) => any);
    get hr(): string;
    set hr(a: string);
    get g1(): GroupByRecord[];
    get gx(): any[];
    set gx(a: any[]);
    get hg(): number;
    set hg(a: number);
    get g0(): GroupingExpression[];
    set g0(a: GroupingExpression[]);
    get gz(): GroupByExpandState[];
    set gz(a: GroupByExpandState[]);
    get hb(): boolean;
    set hb(a: boolean);
    get g6(): GridGroupingStrategy;
    set g6(a: GridGroupingStrategy);
    get hq(): string;
    set hq(a: string);
    private hk;
    get ho(): (arg: GroupByRowSelectorTemplateContext) => any;
    set ho(a: (arg: GroupByRowSelectorTemplateContext) => any);
    private hl;
    get hp(): (arg: GroupByRowTemplateContext) => any;
    set hp(a: (arg: GroupByRowTemplateContext) => any);
    get he(): boolean;
    set he(a: boolean);
    get g2(): CellType[];
    dataPreLoad: (sender: any, args: ForOfStateEventArgs) => void;
    dataPreLoadChanged(): void;
    groupingDone: (sender: any, args: GroupingDoneEventArgs) => void;
    groupingDoneChanged(): void;
    hy(a: GroupingExpression[]): void;
    hu(a: string): void;
    hc(a: GroupByRecord): boolean;
    h2(a: GroupByRecord): void;
    h0(a: GroupByRecord, b?: boolean): void;
    hw(a: GroupByRecord): void;
    hx(a: GroupByRecord): void;
    h1(): void;
    gy(a?: boolean, b?: boolean): any[];
    g8(a: number): RowType;
    g9(a: any): RowType;
    g3(a: number, b: string): CellType;
    g4(a: any, b: string): CellType;
    hd(a: any, b?: number): boolean;
    hf(a: any): boolean;
    hh(a: string): any;
    hs(a: any): void;
    ht(a: number): void;
}
