import { GridColumnOptionsViewBase } from "./GridColumnOptionsViewBase";
import { FontInfo } from "igniteui-react-core";
import { Type, PropertyChangedEventArgs } from "igniteui-react-core";
import { GridColumnOptionsBase } from "./GridColumnOptionsBase";
import { GridColumnSortOptions } from "./GridColumnSortOptions";
import { GridColumnMoveOptions } from "./GridColumnMoveOptions";
import { GridColumnPinOptions } from "./GridColumnPinOptions";
import { GridColumnHideOptions } from "./GridColumnHideOptions";
import { GridColumnGroupOptions } from "./GridColumnGroupOptions";
import { GridColumnFilterOptions } from "./GridColumnFilterOptions";
import { GridColumnSummaryOptions } from "./GridColumnSummaryOptions";
import { GridColumnButtonOptions } from "./GridColumnButtonOptions";
import { ControlDisplayDensity } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ApplyButtonClickEventArgs } from "./ApplyButtonClickEventArgs";
import { CancelButtonClickEventArgs } from "./CancelButtonClickEventArgs";
/**
 * @hidden
 */
export declare class GridColumnOptionsView extends GridColumnOptionsViewBase {
    static $t: Type;
    private v;
    private z;
    private x;
    private y;
    private q;
    private aa;
    private o;
    private t;
    private s;
    private w;
    private r;
    private u;
    private get n();
    private p;
    private ad;
    j(): void;
    m(): void;
    ab(): void;
    ac(a: any, b: any, c: any, d: any, e: any, f: any, g: any, h: any, i: any, j: any, k: any): void;
}
/**
 * @hidden
 */
export declare class GridColumnOptions extends GridColumnOptionsBase {
    static $t: Type;
    private b1;
    private by;
    private b0;
    private bx;
    private bw;
    private bv;
    private b2;
    private bu;
    constructor();
    protected f(): GridColumnOptionsViewBase;
    protected a6(): void;
    protected bb(a: any, b: PropertyChangedEventArgs): void;
    protected be(a: string, b: any, c: any): void;
    private fi;
    get dx(): string;
    private ch;
    private get ci();
    get cp(): boolean;
    get c3(): boolean;
    get cx(): boolean;
    get c0(): boolean;
    get cu(): boolean;
    get co(): boolean;
    get cl(): boolean;
    get c6(): boolean;
    get bz(): GridColumnOptionsView;
    private ce;
    get cg(): FontInfo;
    set cg(a: FontInfo);
    private cd;
    get cf(): FontInfo;
    set cf(a: FontInfo);
    private c9;
    get dh(): number;
    set dh(a: number);
    private db;
    get dj(): number;
    set dj(a: number);
    private da;
    get di(): number;
    set di(a: number);
    private c8;
    get dg(): number;
    set dg(a: number);
    private cq;
    get cr(): boolean;
    set cr(a: boolean);
    private c1;
    get c2(): boolean;
    set c2(a: boolean);
    private cv;
    get cw(): boolean;
    set cw(a: boolean);
    private cy;
    get cz(): boolean;
    set cz(a: boolean);
    private cs;
    get ct(): boolean;
    set ct(a: boolean);
    private cm;
    get cn(): boolean;
    set cn(a: boolean);
    private cj;
    get ck(): boolean;
    set ck(a: boolean);
    private c4;
    get c5(): boolean;
    set c5(a: boolean);
    private e3;
    get e4(): string;
    set e4(a: string);
    private ex;
    get ey(): string;
    set ey(a: string);
    private e0;
    get e1(): string;
    set e1(a: string);
    private d9;
    get ea(): string;
    set ea(a: string);
    private ec;
    get ed(): string;
    set ed(a: string);
    private eg;
    get eh(): string;
    set eh(a: string);
    private en;
    get eo(): string;
    set eo(a: string);
    private eq;
    get er(): string;
    set er(a: string);
    private eu;
    get ev(): string;
    set ev(a: string);
    private dn;
    get dp(): string;
    set dp(a: string);
    private dr;
    get ds(): string;
    set ds(a: string);
    private du;
    get dv(): string;
    set dv(a: string);
    private b6;
    get summaryListDensity(): ControlDisplayDensity;
    set summaryListDensity(a: ControlDisplayDensity);
    private b4;
    get b8(): ControlDisplayDensity;
    set b8(a: ControlDisplayDensity);
    private b5;
    get filterListDensity(): ControlDisplayDensity;
    set filterListDensity(a: ControlDisplayDensity);
    private b3;
    get b7(): ControlDisplayDensity;
    set b7(a: ControlDisplayDensity);
    private d0;
    get d1(): string;
    set d1(a: string);
    private fk;
    get fm(): Brush;
    set fm(a: Brush);
    private fj;
    get fl(): Brush;
    set fl(a: Brush);
    notifySizeChanged(): void;
    provideContent(a: any, b: any, c: any, d: any, e: any, f: any, g: any, h: any, i: any, j: any, k: any, l: GridColumnSortOptions, m: GridColumnMoveOptions, n: GridColumnPinOptions, o: GridColumnHideOptions, p: GridColumnGroupOptions, q: GridColumnFilterOptions, r: GridColumnSummaryOptions, s: GridColumnButtonOptions): void;
    d5(): string;
    fh(): void;
    private fg;
    applyButtonClick: (sender: any, args: ApplyButtonClickEventArgs) => void;
    cancelButtonClick: (sender: any, args: CancelButtonClickEventArgs) => void;
    private fd;
    private fe;
    private fb;
}
