import { BaseToolbarDirective } from "./BaseToolbarDirective";
import { Type } from "igniteui-react-core";
import { ExporterEventArgs } from "./ExporterEventArgs";
import { VoidEventArgs } from "igniteui-react";
import { GridToolbarExporterType } from "./GridToolbarExporterType";
import { ToggleDirective } from "./ToggleDirective";
/**
 * @hidden
 */
export declare class GridToolbarExporter extends BaseToolbarDirective {
    static $t: Type;
    get w(): boolean;
    set w(a: boolean);
    get x(): boolean;
    set x(a: boolean);
    get z(): string;
    set z(a: string);
    get y(): boolean;
    set y(a: boolean);
    exportStarted: (sender: any, args: ExporterEventArgs) => void;
    exportStartedChanged(): void;
    exportEnded: (sender: any, args: VoidEventArgs) => void;
    exportEndedChanged(): void;
    ab(a: GridToolbarExporterType, b: ToggleDirective): void;
}
