import { Type } from "igniteui-react-core";
/**
 * Enumerates the different display modes a group header can use.
 */
export declare enum GroupHeaderDisplayMode {
    /**
     * Each group is preceded by a single section header that combines multiple groups into one.
     */
    Combined = 0,
    /**
     * Each group may be preceded by multiple section headers, one for each group.
     */
    Split = 1
}
/**
 * @hidden
 */
export declare let GroupHeaderDisplayMode_$type: Type;
