import { Type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
/**
 * @hidden
 */
export interface IEditorView {
    readonly container: any;
    value: any;
    isEnabled: boolean;
    focusOnValueChanged: boolean;
    showClearButton: boolean;
    textColor: Brush;
    setFont(a: FontInfo): void;
    attachEvents(): void;
    detachEvents(): void;
    onTargetChanged(): void;
    onEditEnded(): void;
    onEditStarted(): void;
    cleanUp(): void;
    focus(): void;
    getEditorValue(): any;
    setEditorValue(a: any): void;
    valueProvided: (sender: IEditorView, value: any, ignoreValue: boolean) => void;
    userTyping: (sender: IEditorView) => void;
    gotFocus: (sender: IEditorView) => void;
    lostFocus: (sender: IEditorView) => void;
}
/**
 * @hidden
 */
export declare let IEditorView_$type: Type;
