import { NormalizedEvent } from "igniteui-react-core";
import { Type } from "igniteui-react-core";
/**
 * @hidden
 */
export interface INativeCell {
    isRemoved: boolean;
    onContactStarted(a: NormalizedEvent, b: boolean): void;
    onContactCompleted(a: NormalizedEvent, b: boolean): void;
    onContactMoved(a: NormalizedEvent, b: boolean): void;
    onDoubleClick(a: NormalizedEvent): void;
    detach(): void;
}
/**
 * @hidden
 */
export declare let INativeCell_$type: Type;
