import { Base, Type } from "igniteui-react-core";
import { CheckboxList } from "./CheckboxList";
import { List$1 } from "igniteui-react-core";
import { SummaryChooserItem } from "./SummaryChooserItem";
import { SRProvider } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { SummaryChangedEventArgs } from "./SummaryChangedEventArgs";
/**
 * @hidden
 */
export interface ISummaryChooserView {
    readonly renderer: any;
    model: SummaryChooser;
    readonly container: any;
    provideContainer(a: any): void;
    onItemInserted(): void;
    onItemRemoved(): void;
}
/**
 * @hidden
 */
export declare let ISummaryChooserView_$type: Type;
/**
 * @hidden
 */
export declare class SummaryChooserView extends Base implements ISummaryChooserView {
    static $t: Type;
    private b;
    private a;
    private c;
    private _model;
    get model(): SummaryChooser;
    set model(a: SummaryChooser);
    get renderer(): any;
    private d;
    get container(): any;
    provideContainer(a: any): void;
    onItemInserted(): void;
    onItemRemoved(): void;
    private e;
}
/**
 * @hidden
 */
export declare class SummaryChooser extends Base {
    static $t: Type;
    constructor();
    c: ISummaryChooserView;
    get r(): List$1<SummaryChooserItem>;
    get f(): CheckboxList;
    private e;
    private q;
    private o;
    protected get p(): SRProvider;
    private s;
    get aa(): string;
    set aa(a: string);
    private t;
    get ag(): string;
    set ag(a: string);
    private v;
    get ap(): string;
    set ap(a: string);
    private u;
    get al(): string;
    set al(a: string);
    private w;
    get at(): string;
    set at(a: string);
    private l;
    get n(): ControlDisplayDensity;
    set n(a: ControlDisplayDensity);
    private k;
    get m(): ControlDisplayDensity;
    set m(a: ControlDisplayDensity);
    private a8;
    get ba(): Brush;
    set ba(a: Brush);
    private h;
    get j(): BaseControlTheme;
    set j(a: BaseControlTheme);
    private g;
    get i(): BaseControlTheme;
    set i(a: BaseControlTheme);
    private a7;
    get a9(): Brush;
    set a9(a: Brush);
    summaryChanged: (sender: any, args: SummaryChangedEventArgs) => void;
    a1(a: CheckboxList): void;
    private az;
    private a6;
    protected a0(a: string, b: any, c: any): void;
    a2(a: any): void;
    ay(): void;
    a4(a: string, b: boolean): void;
    ax(a: string, b: string): void;
    a3(a: string): void;
    a5(a: string, b: string): void;
    b(): string[];
    a(): string[];
}
