import { GridCellBase } from "./GridCellBase";
import { DomWrapper, DomRenderer } from "igniteui-react-core";
import { CellContentHorizontalAlignment } from "./CellContentHorizontalAlignment";
import { CellContentVerticalAlignment } from "./CellContentVerticalAlignment";
import { Type } from "igniteui-react-core";
import { ImageResourceType } from "./ImageResourceType";
import { ImageStretchOptions } from "./ImageStretchOptions";
/**
 * @hidden
 */
export declare class ImageCell extends GridCellBase {
    static $t: Type;
    private cn;
    private ch;
    private ci;
    private cp;
    private cj;
    private ck;
    private cm;
    get co(): DomWrapper;
    get cl(): number;
    set cl(a: number);
    constructor(a: DomRenderer);
    private cs;
    ct(a: string, b: ImageResourceType): void;
    private cr;
    cw(a: ImageStretchOptions): void;
    private cx;
    cq(): void;
    cu(a: CellContentHorizontalAlignment): void;
    cv(a: CellContentVerticalAlignment): void;
    protected get_w(): boolean;
    protected bp(a: string, b: any, c: any): void;
}
