import { Type } from "igniteui-react-core";
/**
 * Indicates how the grid should merge cells.
 */
export declare enum MergedCellEvaluationCriteria {
    /**
     * Defaults to RawValue
     */
    Default = 0,
    /**
     * Merge cells from adjacent rows when the raw values from the cells are the same.
     */
    RawValue = 1,
    /**
     * Merge cells from adjacent rows when the formatted value from the cells is the same.
     */
    FormattedText = 2
}
/**
 * @hidden
 */
export declare let MergedCellEvaluationCriteria_$type: Type;
