import { DisplayDensityBaseElement } from "./DisplayDensityBaseElement";
import { Type } from "igniteui-react-core";
import { OverlaySettings } from "./OverlaySettings";
import { PaginatorResourceStrings } from "./PaginatorResourceStrings";
import { NumberEventArgs } from "igniteui-react";
import { PageCancellableEventArgs } from "./PageCancellableEventArgs";
import { PageEventArgs } from "./PageEventArgs";
/**
 * @hidden
 */
export declare class Paginator extends DisplayDensityBaseElement {
    static $t: Type;
    get r(): number;
    set r(a: number);
    get p(): number;
    set p(a: number);
    get q(): number;
    set q(a: number);
    get s(): number;
    set s(a: number);
    get i(): number[];
    set i(a: number[]);
    get l(): OverlaySettings;
    set l(a: OverlaySettings);
    get o(): PaginatorResourceStrings;
    set o(a: PaginatorResourceStrings);
    perPageChange: (sender: any, args: NumberEventArgs) => void;
    perPageChangeChanged(): void;
    pageChange: (sender: any, args: NumberEventArgs) => void;
    pageChangeChanged(): void;
    paging: (sender: any, args: PageCancellableEventArgs) => void;
    pagingChanged(): void;
    pagingDone: (sender: any, args: PageEventArgs) => void;
    pagingDoneChanged(): void;
    u(): void;
    aa(): void;
    w(a: number): void;
    get t(): string;
    set t(a: string);
}
