import { Base, Type } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PivotAggregator } from "./PivotAggregator";
import { PivotAggregatorCollection } from "./PivotAggregatorCollection";
import { GridColumnDataType } from "./GridColumnDataType";
import { PivotGridRecord } from "./PivotGridRecord";
import { PivotDimension } from "./PivotDimension";
/**
 * @hidden
 */
export declare class PivotValue extends Base {
    static $t: Type;
    private e;
    protected get f(): WCNativeHelper;
    private h;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get l(): string;
    set l(a: string);
    get k(): string;
    set k(a: string);
    get b(): PivotAggregator;
    set b(a: PivotAggregator);
    get c(): PivotAggregatorCollection;
    get g(): boolean;
    set g(a: boolean);
    get j(): any;
    set j(a: any);
    get a(): GridColumnDataType;
    set a(a: GridColumnDataType);
    formatter: (value: any, rowData: PivotGridRecord, columnData: PivotGridColumn) => void;
    formatterChanged(): void;
}
/**
 * @hidden
 */
export declare class PivotGridColumn extends Base {
    static $t: Type;
    private c;
    protected get d(): WCNativeHelper;
    private e;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get g(): string;
    set g(a: string);
    get a(): PivotDimension[];
    set a(a: PivotDimension[]);
    get b(): PivotValue;
    set b(a: PivotValue);
}
