import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { TemplateCellUpdatingEventArgs } from "./TemplateCellUpdatingEventArgs";
import { XInputGroup } from "igniteui-react-inputs";
import { MultiColumnComboBox } from "./MultiColumnComboBox";
import { XCheckbox } from "igniteui-react-inputs";
import { XButton } from "igniteui-react-inputs";
import { DataGrid } from "./DataGrid";
import { PropertyEditorPropertyDescriptionCollection } from "igniteui-react-layouts";
import { InputGroupDisplayType } from "igniteui-react-inputs";
import { BaseControlTheme } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { TypeDescriptionContext } from "igniteui-react-core";
import { ComponentRenderer } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class PropertyEditorView extends Base {
    static $t: Type;
    private o;
    private n;
    constructor();
    b: PropertyEditor;
    z(): void;
    j: DomRenderer;
    m: DomWrapper;
    f: RenderingContext;
    l: DomWrapper;
    x(a: DomRenderer): void;
    ad(): void;
    ab(): void;
    w(): void;
    ae(): void;
    private c;
    private af;
    private d;
    private _gridExternal;
    private a;
    e(): FontInfo;
    y(): void;
    aa(): void;
    v(): void;
    h(): number;
    i(a: string): number;
    g: boolean;
    t(a: TemplateCellUpdatingEventArgs, b: (arg1: XInputGroup, arg2: boolean) => void): void;
    s(a: TemplateCellUpdatingEventArgs, b: (arg1: MultiColumnComboBox, arg2: boolean) => void): void;
    r(a: TemplateCellUpdatingEventArgs, b: (arg1: XCheckbox, arg2: boolean) => void): void;
    q(a: TemplateCellUpdatingEventArgs, b: (arg1: XButton, arg2: boolean) => void): void;
    private k;
    u(a: any, b: (arg1: any) => void): void;
    ac(ig_: XButton, a: string): void;
}
/**
 * @hidden
 */
export declare class PropertyEditor extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private m;
    l: DataGrid;
    private ab;
    private d;
    private ah;
    private c;
    private n;
    private o;
    private ai;
    private static readonly eb;
    private static readonly cj;
    private get e();
    private af;
    private get ag();
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    private dz;
    private dn;
    private an;
    notifySizeChanged(): void;
    dk(a: DataGrid, b: any): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private dj;
    dv(a: string): void;
    private t;
    get actualProperties(): PropertyEditorPropertyDescriptionCollection;
    set actualProperties(a: PropertyEditorPropertyDescriptionCollection);
    private u;
    get properties(): PropertyEditorPropertyDescriptionCollection;
    set properties(a: PropertyEditorPropertyDescriptionCollection);
    private bx;
    get b9(): string;
    set b9(a: string);
    private p;
    get q(): InputGroupDisplayType;
    set q(a: InputGroupDisplayType);
    private bn;
    get bs(): number;
    set bs(a: number);
    private ac;
    get ad(): FontInfo;
    set ad(a: FontInfo);
    ae(): FontInfo;
    private x;
    get y(): BaseControlTheme;
    set y(a: BaseControlTheme);
    private z;
    get aa(): ControlDisplayDensity;
    set aa(a: ControlDisplayDensity);
    protected dw(a: string, b: any, c: any): void;
    protected d0(a: string, b: any, c: any): void;
    private ar;
    private d3;
    private d4;
    private dy;
    d5(): void;
    private cp;
    ed(): Size;
    private bp;
    private d2;
    private cu;
    private dp;
    private ba;
    private bm;
    private bd;
    private a0;
    private bl;
    private bk;
    private bj;
    private bi;
    private bh;
    private bg;
    private bf;
    private bc;
    private bb;
    private a9;
    private a6;
    private a7;
    private a5;
    private a3;
    private a4;
    private a2;
    private ay;
    private a8;
    private az;
    private ax;
    private a1;
    private aw;
    private be;
    private cc;
    private ct;
    private di;
    private dh;
    private dg;
    private df;
    private de;
    private dd;
    private dc;
    private da;
    private cz;
    private c7;
    private b;
    private a;
    private cq;
    private dl;
    private cm;
    private bv;
    private am;
    private dx;
    private at;
    private as;
    private av;
    private cb;
    private c5;
    private db;
    private c9;
    private c8;
    private c4;
    private c3;
    private c1;
    private c2;
    private c0;
    private cx;
    private c6;
    private cy;
    private cw;
    private s;
    private au;
    private bq;
    private co;
    private cv;
    private cs;
    private dm;
    dt(a: number, b: any, c: any): void;
    dq(): void;
    dr(a: number, b: any): void;
    ds(a: number, b: any): void;
    private h;
    get j(): TypeDescriptionContext;
    set j(a: TypeDescriptionContext);
    private i;
    get k(): TypeDescriptionContext;
    set k(a: TypeDescriptionContext);
    private f;
    get g(): ComponentRenderer;
    set g(a: ComponentRenderer);
    private bt;
    get bu(): any;
    set bu(a: any);
    private bw;
    get b7(): string;
    set b7(a: string);
    private aj;
    get ao(): boolean;
    set ao(a: boolean);
    private al;
    get aq(): boolean;
    set aq(a: boolean);
    private ak;
    get ap(): boolean;
    set ap(a: boolean);
    static d9: Brush;
    private d6;
    get d8(): Brush;
    set d8(a: Brush);
    static ea: Brush;
    d7: Brush;
    get ec(): Brush;
    set ec(a: Brush);
    private br;
    private bo;
    private r;
    private cn;
}
