import { GridCellBase } from "./GridCellBase";
import { DomWrapper, DomRenderer, NormalizedEvent } from "igniteui-react-core";
import { GridSortIndicator } from "./GridSortIndicator";
import { GridFilterDialog } from "./GridFilterDialog";
import { ColumnOptionsIconBehavior } from "./ColumnOptionsIconBehavior";
import { ColumnOptionsIconAlignment } from "./ColumnOptionsIconAlignment";
import { ICellActionManager } from "./ICellActionManager";
import { Type } from "igniteui-react-core";
import { CellContentHorizontalAlignment } from "./CellContentHorizontalAlignment";
/**
 * @hidden
 */
export declare class TextHeaderCell extends GridCellBase {
    static $t: Type;
    private cs;
    private co;
    private cm;
    private ci;
    private ch;
    get cv(): DomWrapper;
    get cp(): GridSortIndicator;
    get cn(): GridFilterDialog;
    private ck;
    get cl(): ColumnOptionsIconBehavior;
    set cl(a: ColumnOptionsIconBehavior);
    get cj(): ColumnOptionsIconAlignment;
    set cj(a: ColumnOptionsIconAlignment);
    protected x(a: ICellActionManager): boolean;
    private cu;
    private cx;
    b6(a: number, b: number): void;
    private cw;
    b0(a: number, b: number): void;
    protected b7(a: number, b: number, c: number, d: number): void;
    constructor(a: DomRenderer);
    private c0;
    private c7;
    private c6;
    private c2;
    private c3;
    private c1;
    bn(a: DomWrapper, b: DomWrapper, c: CellContentHorizontalAlignment): void;
    b4(a: number, b: number, c: number, d: number): void;
    private c5;
    private c4;
    protected bp(a: string, b: any, c: any): void;
    private cq;
    onContactStarted(e_: NormalizedEvent, a: boolean): void;
    onContactCompleted(e_: NormalizedEvent, a: boolean): void;
    detach(): void;
    protected get_u(): boolean;
    ct: DomWrapper;
    cr: boolean;
}
