import * as React from 'react';
import { IgrBaseToolbarDirective, IIgrBaseToolbarDirectiveProps } from "./igr-base-toolbar-directive";
import { BaseToolbarColumnActionsDirective } from "./BaseToolbarColumnActionsDirective";
export declare class IgrBaseToolbarColumnActionsDirective<P extends IIgrBaseToolbarColumnActionsDirectiveProps = IIgrBaseToolbarColumnActionsDirectiveProps> extends IgrBaseToolbarDirective<P> {
    protected createImplementation(): BaseToolbarColumnActionsDirective;
    /**
                                 * @hidden
                                 */
    get i(): BaseToolbarColumnActionsDirective;
    constructor(props: P);
    render(): React.DOMElement<any, Element>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    get name(): string;
    set name(v: string);
}
export interface IIgrBaseToolbarColumnActionsDirectiveProps extends IIgrBaseToolbarDirectiveProps {
    name?: string;
}
