import { CellRange as CellRange_internal } from "./CellRange";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * An indentifier for a specific cell in the grid.
*/
export declare class IgrCellRange {
    protected createImplementation(): CellRange_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): CellRange_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the start column of the range.
    */
    get startColumn(): number;
    set startColumn(v: number);
    /**
     * Gets or sets the end column of the range.
    */
    get endColumn(): number;
    set endColumn(v: number);
    /**
     * Gets or sets the start row of the range.
    */
    get startRow(): number;
    set startRow(v: number);
    /**
     * Gets or sets the end row of the range.
    */
    get endRow(): number;
    set endRow(v: number);
    findByName(name: string): any;
}
