import { CellStyleRequestedEventArgs as CellStyleRequestedEventArgs_internal } from "./CellStyleRequestedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the style request for a cell.
*/
export declare class IgrCellStyleRequestedEventArgs {
    protected createImplementation(): CellStyleRequestedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): CellStyleRequestedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The proposed style key for the cell. Used for recycling the cell.
    */
    get styleKey(): string;
    set styleKey(v: string);
    /**
     * The resolved value for the cell.
    */
    get resolvedValue(): any;
    set resolvedValue(v: any);
    /**
     * The row number for the cell.
    */
    get rowNumber(): number;
    set rowNumber(v: number);
}
