import { IgrCellType } from "./igr-cell-type";
import { CellTemplateContext as CellTemplateContext_internal } from "./CellTemplateContext";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrCellTemplateContext {
    protected createImplementation(): CellTemplateContext_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): CellTemplateContext_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get implicit(): any;
    set implicit(v: any);
    get additionalTemplateContext(): any;
    set additionalTemplateContext(v: any);
    get cell(): IgrCellType;
    set cell(v: IgrCellType);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
