import { IgrColumn } from "./igr-column";
import { IgrRowType } from "./igr-row-type";
import { IgrGridBaseDirective } from "./igr-grid-base-directive";
import { IgrGridCellIdentifier } from "./igr-grid-cell-identifier";
import { IgrGridValidationState } from "./igr-grid-validation-state";
import { CellType as CellType_internal } from "./CellType";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrCellType {
    protected createImplementation(): CellType_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): CellType_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get value(): any;
    set value(v: any);
    get editValue(): any;
    set editValue(v: any);
    get selected(): boolean;
    set selected(v: boolean);
    get active(): boolean;
    set active(v: boolean);
    get editable(): boolean;
    set editable(v: boolean);
    get editMode(): boolean;
    set editMode(v: boolean);
    get column(): IgrColumn;
    set column(v: IgrColumn);
    get row(): IgrRowType;
    set row(v: IgrRowType);
    get grid(): IgrGridBaseDirective;
    set grid(v: IgrGridBaseDirective);
    get id(): IgrGridCellIdentifier;
    set id(v: IgrGridCellIdentifier);
    get cellID(): any;
    set cellID(v: any);
    get validation(): IgrGridValidationState;
    set validation(v: IgrGridValidationState);
    get readonly(): boolean;
    set readonly(v: boolean);
    get title(): any;
    set title(v: any);
    get width(): string;
    set width(v: string);
    get visibleColumnIndex(): number;
    set visibleColumnIndex(v: number);
    findByName(name: string): any;
    setNativeElement(element: any): void;
    update(value: any): void;
    setEditMode(value: boolean): void;
    calculateSizeToFit(range: any): number;
}
