import { IgrColumnExportingEventArgsDetail } from "./igr-column-exporting-event-args-detail";
import { ColumnExportingEventArgs as ColumnExportingEventArgs_internal } from "./ColumnExportingEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * columnExporting event arguments
 * ```typescript
 * this.exporterService.columnExporting.subscribe((args: IColumnExportingEventArgs) => {
 * // set args properties here
 * });
 * ```
*/
export declare class IgrColumnExportingEventArgs {
    protected createImplementation(): ColumnExportingEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ColumnExportingEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get detail(): IgrColumnExportingEventArgsDetail;
    set detail(v: IgrColumnExportingEventArgsDetail);
}
