import * as React from 'react';
import { IgrColumnGroup, IIgrColumnGroupProps } from "./igr-column-group";
import { ColumnLayout } from "./ColumnLayout";
/**
 * Column layout for declaration of Multi-row Layout
 * @igxParent IgxGridComponent
*/
export declare class IgrColumnLayout<P extends IIgrColumnLayoutProps = IIgrColumnLayoutProps> extends IgrColumnGroup<P> {
    protected createImplementation(): ColumnLayout;
    /**
                                 * @hidden
                                 */
    get i(): ColumnLayout;
    constructor(props: P);
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
}
export interface IIgrColumnLayoutProps extends IIgrColumnGroupProps {
}
