import { IgrDefinitionBase, IIgrDefinitionBaseProps } from "./igr-definition-base";
import { ColumnMovingSeparator } from "./ColumnMovingSeparator";
export declare class IgrColumnMovingSeparator extends IgrDefinitionBase<IIgrColumnMovingSeparatorProps> {
    protected createImplementation(): ColumnMovingSeparator;
    /**
                                 * @hidden
                                 */
    get i(): ColumnMovingSeparator;
    constructor(props: IIgrColumnMovingSeparatorProps);
    /**
     * Gets or sets the separator width for this column.
    */
    get separatorWidth(): number;
    set separatorWidth(v: number);
    get actualOpacity(): number;
    set actualOpacity(v: number);
    get opacity(): number;
    set opacity(v: number);
}
export interface IIgrColumnMovingSeparatorProps extends IIgrDefinitionBaseProps {
    /**
     * Gets or sets the separator width for this column.
    */
    separatorWidth?: number | string;
    actualOpacity?: number | string;
    opacity?: number | string;
}
