import { IgrDataGridColumn } from "./igr-data-grid-column";
import { PinnedPositions } from "./PinnedPositions";
import { ColumnPinnedChangedEventArgs as ColumnPinnedChangedEventArgs_internal } from "./ColumnPinnedChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Event arguments for the ColumnPinnedChanged event.
*/
export declare class IgrColumnPinnedChangedEventArgs {
    protected createImplementation(): ColumnPinnedChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ColumnPinnedChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The column whose pinned state has changed.
    */
    get column(): IgrDataGridColumn;
    set column(v: IgrDataGridColumn);
    /**
     * The new pinned state for the column.
    */
    get pinned(): PinnedPositions;
    set pinned(v: PinnedPositions);
}
