import { ColumnSelectionEventArgsDetail as ColumnSelectionEventArgsDetail_internal } from "./ColumnSelectionEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrColumnSelectionEventArgsDetail {
    protected createImplementation(): ColumnSelectionEventArgsDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ColumnSelectionEventArgsDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get oldSelection(): string[];
    set oldSelection(v: string[]);
    get newSelection(): string[];
    set newSelection(v: string[]);
    get added(): string[];
    set added(v: string[]);
    get removed(): string[];
    set removed(v: string[]);
    /**
     * Provides the ability to cancel the event.
    */
    get cancel(): boolean;
    set cancel(v: boolean);
    /**
     * Provides reference to the owner component.
    */
    get owner(): any;
    set owner(v: any);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
