import { IgrColumnSummaryDescription } from "./igr-column-summary-description";
import { ColumnSummaryDescriptionCollection as ColumnSummaryDescriptionCollection_internal } from "./ColumnSummaryDescriptionCollection";
export declare class IgrColumnSummaryDescriptionCollection {
    protected createImplementation(): ColumnSummaryDescriptionCollection_internal;
    protected _implementation: any;
    get i(): ColumnSummaryDescriptionCollection_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    item(index: number, value?: IgrColumnSummaryDescription): IgrColumnSummaryDescription;
    get count(): number;
    toArray(): IgrColumnSummaryDescription[];
    [Symbol.iterator](): Generator<any, void, unknown>;
    /**
 * Gets or sets whether this collection should detach the sync when the target collection changes.
*/
    get shouldDetachOnTargetChange(): boolean;
    set shouldDetachOnTargetChange(v: boolean);
    findByName(name: string): any;
    add(item: IgrColumnSummaryDescription): boolean;
    insert(index: number, item: IgrColumnSummaryDescription): void;
    clear(): void;
    indexOf(item: IgrColumnSummaryDescription): number;
    remove(item: IgrColumnSummaryDescription): boolean;
    removeAt(index: number): IgrColumnSummaryDescription;
}
