import { IgrColumn } from "./igr-column";
import { ColumnTemplateContext as ColumnTemplateContext_internal } from "./ColumnTemplateContext";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrColumnTemplateContext {
    protected createImplementation(): ColumnTemplateContext_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ColumnTemplateContext_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get implicit(): IgrColumn;
    set implicit(v: IgrColumn);
    get column(): IgrColumn;
    set column(v: IgrColumn);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
