import { IgrCellInfo } from './igr-cell-info';
import { IgrDataGrid } from './igr-data-grid';
import { DataGridCellEventArgs as DataGridCellEventArgs_internal } from "./DataGridCellEventArgs";
import { MouseButton } from "igniteui-react-core";
/**
 * Information about the cell in context.
*/
export declare class IgrDataGridCellEventArgs {
    protected createImplementation(): DataGridCellEventArgs_internal;
    protected _implementation: any;
    get i(): DataGridCellEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The backing information for the current cell.
    */
    get cellInfo(): IgrCellInfo;
    /**
 * Gets the grid owning the cell.
*/
    get grid(): IgrDataGrid;
    set grid(v: IgrDataGrid);
    /**
     * Gets which click type it is.
    */
    get button(): MouseButton;
    set button(v: MouseButton);
    /**
     * Is this a double click?
    */
    get isDoubleClick(): boolean;
    set isDoubleClick(v: boolean);
}
