import { IgrDefinitionBase, IIgrDefinitionBaseProps } from "./igr-definition-base";
import { EditRowDefinition } from "./EditRowDefinition";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export declare class IgrEditRowDefinition extends IgrDefinitionBase<IIgrEditRowDefinitionProps> {
    protected createImplementation(): EditRowDefinition;
    /**
                                 * @hidden
                                 */
    get i(): EditRowDefinition;
    constructor(props: IIgrEditRowDefinitionProps);
}
export interface IIgrEditRowDefinitionProps extends IIgrDefinitionBaseProps {
}
