import { IgrFilteringExpressionsTree } from "./igr-filtering-expressions-tree";
import { FilteringEventArgsDetail as FilteringEventArgsDetail_internal } from "./FilteringEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrFilteringEventArgsDetail {
    protected createImplementation(): FilteringEventArgsDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): FilteringEventArgsDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get filteringExpressions(): IgrFilteringExpressionsTree;
    set filteringExpressions(v: IgrFilteringExpressionsTree);
    /**
     * Provides reference to the owner component.
    */
    get owner(): any;
    set owner(v: any);
    /**
     * Provides the ability to cancel the event.
    */
    get cancel(): boolean;
    set cancel(v: boolean);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
