import { IgrGridCellPosition } from "./igr-grid-cell-position";
import { GridActiveCellChangedEventArgs as GridActiveCellChangedEventArgs_internal } from "./GridActiveCellChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the change to the selected cells in the grid.
*/
export declare class IgrGridActiveCellChangedEventArgs {
    protected createImplementation(): GridActiveCellChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridActiveCellChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The new active cell.
    */
    get newActiveCell(): IgrGridCellPosition;
    set newActiveCell(v: IgrGridCellPosition);
    /**
     * The old active cell.
    */
    get oldActiveCell(): IgrGridCellPosition;
    set oldActiveCell(v: IgrGridCellPosition);
}
