import { GridCellPosition as GridCellPosition_internal } from "./GridCellPosition";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrGridCellPosition {
    protected createImplementation(): GridCellPosition_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridCellPosition_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the row position of the cell.
    */
    get rowIndex(): number;
    set rowIndex(v: number);
    /**
     * Gets or sets the column position of the cell.  Can be null for spanning elements like section headers.
    */
    get columnUniqueKey(): string;
    set columnUniqueKey(v: string);
    findByName(name: string): any;
}
