import * as React from 'react';
import { GridColumnMoveOptions } from './GridColumnMoveOptions';
import { IgrGridColumnOptionsSimpleSectionBase } from "./igr-grid-column-options-simple-section-base";
import { IIgrGridColumnOptionsSimpleSectionBaseProps } from "./igr-grid-column-options-simple-section-base";
export declare class IgrGridColumnMoveOptions extends IgrGridColumnOptionsSimpleSectionBase<IIgrGridColumnOptionsSimpleSectionBaseProps> {
    private _mainDiv;
    private _initialized;
    private _elRef;
    private _reactRenderer;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
        children: any[];
    }, any>;
    constructor(props: IIgrGridColumnMoveOptionsProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): GridColumnMoveOptions;
    get i(): GridColumnMoveOptions;
    get moveLeftCaption(): string;
    set moveLeftCaption(v: string);
    get moveRightCaption(): string;
    set moveRightCaption(v: string);
}
export interface IIgrGridColumnMoveOptionsProps extends IIgrGridColumnOptionsSimpleSectionBaseProps {
    moveLeftCaption?: string;
    moveRightCaption?: string;
}
