import * as React from 'react';
import { GridColumnSortOptions } from './GridColumnSortOptions';
import { IgrGridColumnOptionsSimpleSectionBase } from "./igr-grid-column-options-simple-section-base";
import { IIgrGridColumnOptionsSimpleSectionBaseProps } from "./igr-grid-column-options-simple-section-base";
import { ColumnSortDirection } from "./ColumnSortDirection";
export declare class IgrGridColumnSortOptions extends IgrGridColumnOptionsSimpleSectionBase<IIgrGridColumnOptionsSimpleSectionBaseProps> {
    private _mainDiv;
    private _initialized;
    private _elRef;
    private _reactRenderer;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
        children: any[];
    }, any>;
    constructor(props: IIgrGridColumnSortOptionsProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): GridColumnSortOptions;
    get i(): GridColumnSortOptions;
    get ascendingCaption(): string;
    set ascendingCaption(v: string);
    get descendingCaption(): string;
    set descendingCaption(v: string);
    get sortDirection(): ColumnSortDirection;
    set sortDirection(v: ColumnSortDirection);
}
export interface IIgrGridColumnSortOptionsProps extends IIgrGridColumnOptionsSimpleSectionBaseProps {
    ascendingCaption?: string;
    descendingCaption?: string;
    sortDirection?: ColumnSortDirection | string;
}
