import { GridDataCommittedEventArgs as GridDataCommittedEventArgs_internal } from "./GridDataCommittedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
import { DataSourceAggregatedResult } from "igniteui-react-core";
/**
 * Event arguments for the DataCommitted event.
*/
export declare class IgrGridDataCommittedEventArgs {
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridDataCommittedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the ID for this commit.
    */
    get commitID(): number;
    set commitID(v: number);
    /**
     * Gets a list of the changes that were committed.
    */
    get changes(): DataSourceAggregatedResult[];
    set changes(v: DataSourceAggregatedResult[]);
}
