import { IgrGridCellIdentifier } from "./igr-grid-cell-identifier";
import { IgrColumn } from "./igr-column";
import { IgrGridBaseDirective } from "./igr-grid-base-directive";
import { GridEditEventArgsDetail as GridEditEventArgsDetail_internal } from "./GridEditEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrGridEditEventArgsDetail {
    protected createImplementation(): GridEditEventArgsDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridEditEventArgsDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Provides the ability to cancel the event.
    */
    get cancel(): boolean;
    set cancel(v: boolean);
    get rowID(): any;
    set rowID(v: any);
    get primaryKey(): any;
    set primaryKey(v: any);
    get cellID(): IgrGridCellIdentifier;
    set cellID(v: IgrGridCellIdentifier);
    get rowData(): any;
    set rowData(v: any);
    get oldValue(): any;
    set oldValue(v: any);
    get newValue(): any;
    set newValue(v: any);
    get column(): IgrColumn;
    set column(v: IgrColumn);
    get owner(): IgrGridBaseDirective;
    set owner(v: IgrGridBaseDirective);
    get isAddRow(): boolean;
    set isAddRow(v: boolean);
    get valid(): boolean;
    set valid(v: boolean);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
