import * as React from 'react';
import { IgrRowDirective, IIgrRowDirectiveProps } from "./igr-row-directive";
import { GridRow } from "./GridRow";
export declare class IgrGridRow extends IgrRowDirective<IIgrGridRowProps> {
    protected createImplementation(): GridRow;
    /**
                                 * @hidden
                                 */
    get i(): GridRow;
    constructor(props: IIgrGridRowProps);
    componentDidMount(): void;
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    getContext(col: any, row: any): void;
    getContextMRL(pinnedCols: any, row: any): void;
}
export interface IIgrGridRowProps extends IIgrRowDirectiveProps {
}
