import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GridScrollEventArgsDetail as GridScrollEventArgsDetail_internal } from "./GridScrollEventArgsDetail";
/**
 * Event emitted when a grid is scrolled.
*/
export declare class IgrGridScrollEventArgsDetail extends IgrBaseEventArgsDetail {
    protected createImplementation(): GridScrollEventArgsDetail_internal;
    /**
                                 * @hidden
                                 */
    get i(): GridScrollEventArgsDetail_internal;
    constructor();
    /**
     * The scroll direction - vertical or horizontal.
    */
    get direction(): string;
    set direction(v: string);
    /**
     * The original browser scroll event.
    */
    get event(): any;
    set event(v: any);
    /**
     * The new scroll position
    */
    get scrollPosition(): number;
    set scrollPosition(v: number);
}
