import { IgrGridSelectedItemsCollection } from "./igr-grid-selected-items-collection";
import { GridSelectedItemsChangedEventArgs as GridSelectedItemsChangedEventArgs_internal } from "./GridSelectedItemsChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the changing selected items in the grid.
*/
export declare class IgrGridSelectedItemsChangedEventArgs {
    protected createImplementation(): GridSelectedItemsChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridSelectedItemsChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    private _currentItems;
    /**
     * The items added to the selection.
    */
    get currentItems(): IgrGridSelectedItemsCollection;
    set currentItems(v: IgrGridSelectedItemsCollection);
    private _addedItems;
    /**
     * The items added to the selection.
    */
    get addedItems(): IgrGridSelectedItemsCollection;
    set addedItems(v: IgrGridSelectedItemsCollection);
    private _removedItems;
    /**
     * The items removed from the selection.
    */
    get removedItems(): IgrGridSelectedItemsCollection;
    set removedItems(v: IgrGridSelectedItemsCollection);
}
