import { IgrGridSelectedKeysCollection } from "./igr-grid-selected-keys-collection";
import { GridSelectedKeysChangedEventArgs as GridSelectedKeysChangedEventArgs_internal } from "./GridSelectedKeysChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the change to the selected keys in the grid.
*/
export declare class IgrGridSelectedKeysChangedEventArgs {
    protected createImplementation(): GridSelectedKeysChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridSelectedKeysChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    private _currentKeys;
    /**
     * All keys in the selection.
    */
    get currentKeys(): IgrGridSelectedKeysCollection;
    set currentKeys(v: IgrGridSelectedKeysCollection);
    private _addedKeys;
    /**
     * The keys added to the selection.
    */
    get addedKeys(): IgrGridSelectedKeysCollection;
    set addedKeys(v: IgrGridSelectedKeysCollection);
    private _removedKeys;
    /**
     * The keys removed from the selection.
    */
    get removedKeys(): IgrGridSelectedKeysCollection;
    set removedKeys(v: IgrGridSelectedKeysCollection);
}
