import { GridSizeChangedEventArgs as GridSizeChangedEventArgs_internal } from "./GridSizeChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Event arguments for the SizeChanged event.
*/
export declare class IgrGridSizeChangedEventArgs {
    protected createImplementation(): GridSizeChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridSizeChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The new width.
    */
    get width(): number;
    set width(v: number);
    /**
     * The new height.
    */
    get height(): number;
    set height(v: number);
}
