import { IgrColumnSortDescriptionCollection } from "./igr-column-sort-description-collection";
import { GridSortDescriptionsChangedEventArgs as GridSortDescriptionsChangedEventArgs_internal } from "./GridSortDescriptionsChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the current sorting applied to the grid.
*/
export declare class IgrGridSortDescriptionsChangedEventArgs {
    protected createImplementation(): GridSortDescriptionsChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridSortDescriptionsChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get sortDescriptions(): IgrColumnSortDescriptionCollection;
    set sortDescriptions(v: IgrColumnSortDescriptionCollection);
}
