import * as React from 'react';
import { IgrBaseToolbarColumnActionsDirective, IIgrBaseToolbarColumnActionsDirectiveProps } from "./igr-base-toolbar-column-actions-directive";
import { GridToolbarHiding } from "./GridToolbarHiding";
/**
 * Provides a pre-configured column hiding component for the grid.
 * @igxModule IgxGridToolbarModule
 * @igxParent IgxGridToolbarComponent
 * @example
 * ```html
 * ```
*/
export declare class IgrGridToolbarHiding<P extends IIgrGridToolbarHidingProps = IIgrGridToolbarHidingProps> extends IgrBaseToolbarColumnActionsDirective<P> {
    protected createImplementation(): GridToolbarHiding;
    /**
                                 * @hidden
                                 */
    get i(): GridToolbarHiding;
    constructor(props: P);
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
}
export interface IIgrGridToolbarHidingProps extends IIgrBaseToolbarColumnActionsDirectiveProps {
}
