import * as React from 'react';
import { IgrBaseToolbarColumnActionsDirective, IIgrBaseToolbarColumnActionsDirectiveProps } from "./igr-base-toolbar-column-actions-directive";
import { GridToolbarPinning } from "./GridToolbarPinning";
/**
 * Provides a pre-configured column pinning component for the grid.
 * @igxModule IgxGridToolbarModule
 * @igxParent IgxGridToolbarComponent
 * @example
 * ```html
 * ```
*/
export declare class IgrGridToolbarPinning<P extends IIgrGridToolbarPinningProps = IIgrGridToolbarPinningProps> extends IgrBaseToolbarColumnActionsDirective<P> {
    protected createImplementation(): GridToolbarPinning;
    /**
                                 * @hidden
                                 */
    get i(): GridToolbarPinning;
    constructor(props: P);
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
}
export interface IIgrGridToolbarPinningProps extends IIgrBaseToolbarColumnActionsDirectiveProps {
}
