import { IgrSortingExpression } from "./igr-sorting-expression";
import { IgrColumn } from "./igr-column";
import { GroupByRecord as GroupByRecord_internal } from "./GroupByRecord";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrGroupByRecord {
    protected createImplementation(): GroupByRecord_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GroupByRecord_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get expression(): IgrSortingExpression;
    set expression(v: IgrSortingExpression);
    get level(): number;
    set level(v: number);
    get records(): any[];
    set records(v: any[]);
    get value(): any;
    set value(v: any);
    get groupParent(): IgrGroupByRecord;
    set groupParent(v: IgrGroupByRecord);
    get groups(): IgrGroupByRecord[];
    set groups(v: IgrGroupByRecord[]);
    get height(): number;
    set height(v: number);
    get column(): IgrColumn;
    set column(v: IgrColumn);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
