import { IgrDefinitionBase, IIgrDefinitionBaseProps } from "./igr-definition-base";
import { HeaderRowSeparator } from "./HeaderRowSeparator";
/**
 * Represents a Header Row separator. This is used to visually separate the header row from the rest of the rows in a grid.
*/
export declare class IgrHeaderRowSeparator extends IgrDefinitionBase<IIgrHeaderRowSeparatorProps> {
    protected createImplementation(): HeaderRowSeparator;
    /**
                                 * @hidden
                                 */
    get i(): HeaderRowSeparator;
    constructor(props: IIgrHeaderRowSeparatorProps);
}
export interface IIgrHeaderRowSeparatorProps extends IIgrDefinitionBaseProps {
}
