import { PageChangedEventArgs as PageChangedEventArgs_internal } from "./PageChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrPageChangedEventArgs {
    protected createImplementation(): PageChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PageChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the index for the page that just changed.
    */
    get page(): number;
    set page(v: number);
    /**
     * Gets the data for the page that just changed.
    */
    get data(): any[];
    set data(v: any[]);
}
