import { IgrPinColumnCancellableEventArgsDetail } from "./igr-pin-column-cancellable-event-args-detail";
import { PinColumnCancellableEventArgs as PinColumnCancellableEventArgs_internal } from "./PinColumnCancellableEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * The event arguments before a column's pin state is changed.
 * `insertAtIndex`specifies at which index in the pinned/unpinned area the column is inserted.
 * Can be changed in the `columnPin` event.
 * `isPinned` returns the actual pin state of the column. When pinning/unpinning is succesfull,
 * the value of `isPinned` will change accordingly when read in the "-ing" and "-ed" event.
*/
export declare class IgrPinColumnCancellableEventArgs {
    protected createImplementation(): PinColumnCancellableEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PinColumnCancellableEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get detail(): IgrPinColumnCancellableEventArgsDetail;
    set detail(v: IgrPinColumnCancellableEventArgsDetail);
}
