import { IgrPivotConfiguration } from "./igr-pivot-configuration";
import { PivotConfigurationChangedEventArgsDetail as PivotConfigurationChangedEventArgsDetail_internal } from "./PivotConfigurationChangedEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Event emitted when pivot configuration is changed.
*/
export declare class IgrPivotConfigurationChangedEventArgsDetail {
    protected createImplementation(): PivotConfigurationChangedEventArgsDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PivotConfigurationChangedEventArgsDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The new configuration.
    */
    get pivotConfiguration(): IgrPivotConfiguration;
    set pivotConfiguration(v: IgrPivotConfiguration);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
