export interface IgrPivotDateDimensionOptions {
    /**
     * Enables/Disables total value of all periods.
    */
    total?: boolean | string;
    /**
     * Enables/Disables dimensions per year from provided periods.
    */
    years?: boolean | string;
    quarters?: boolean | string;
    /**
     * Enables/Disables dimensions per month from provided periods.
    */
    months?: boolean | string;
    /**
     * Enabled/Disables dimensions for the full date provided
    */
    fullDate?: boolean | string;
}
