import { PrimaryKeyValue as PrimaryKeyValue_internal } from "./PrimaryKeyValue";
/**
 * A primary key value.
*/
export declare class IgrPrimaryKeyValue {
    protected _implementation: any;
    get i(): PrimaryKeyValue_internal;
    private onImplementationCreated;
    constructor(primaryKey?: string[], primaryKeyValue?: any[]);
    protected _provideImplementation(i: any): void;
    static createIdentityKey(item: any): IgrPrimaryKeyValue;
    /**
 * The primary key associated with this value.
*/
    get key(): string[];
    set key(v: string[]);
    /**
     * The value of the keys for this primary key value.
    */
    get value(): any[];
    set value(v: any[]);
    findByName(name: string): any;
    /**
 * Determines if two primary key values are equal.

* @param other  * The other key value to check against.
*/
    equals(other: any): boolean;
}
