import { IgrRowType } from "./igr-row-type";
import { RowDragStartEventArgsDetail as RowDragStartEventArgsDetail_internal } from "./RowDragStartEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrRowDragStartEventArgsDetail {
    protected createImplementation(): RowDragStartEventArgsDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): RowDragStartEventArgsDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get dragDirective(): any;
    set dragDirective(v: any);
    get dragData(): IgrRowType;
    set dragData(v: IgrRowType);
    /**
     * Provides the ability to cancel the event.
    */
    get cancel(): boolean;
    set cancel(v: boolean);
    /**
     * Provides reference to the owner component.
    */
    get owner(): any;
    set owner(v: any);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
