import { IgrDefinitionBase, IIgrDefinitionBaseProps } from "./igr-definition-base";
import { RowSeparator } from "./RowSeparator";
/**
 * Represents a Row separator, this is used to visually separate the rows in a grid
*/
export declare class IgrRowSeparator extends IgrDefinitionBase<IIgrRowSeparatorProps> {
    protected createImplementation(): RowSeparator;
    /**
                                 * @hidden
                                 */
    get i(): RowSeparator;
    constructor(props: IIgrRowSeparatorProps);
}
export interface IIgrRowSeparatorProps extends IIgrDefinitionBaseProps {
}
