import { IgrGroupByRecord } from "./igr-group-by-record";
import { IgrGridValidationState } from "./igr-grid-validation-state";
import { IgrTreeGridRecord } from "./igr-tree-grid-record";
import { IgrGridBaseDirective } from "./igr-grid-base-directive";
import { RowType as RowType_internal } from "./RowType";
import { ContentChildrenManager } from "igniteui-react-core";
import { IgrCellType } from "./igr-cell-type";
export declare class IgrRowType {
    protected createImplementation(): RowType_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): RowType_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get index(): number;
    set index(v: number);
    get viewIndex(): number;
    set viewIndex(v: number);
    get isGroupByRow(): boolean;
    set isGroupByRow(v: boolean);
    get isSummaryRow(): boolean;
    set isSummaryRow(v: boolean);
    get groupRow(): IgrGroupByRecord;
    set groupRow(v: IgrGroupByRecord);
    get key(): any;
    set key(v: any);
    get validation(): IgrGridValidationState;
    set validation(v: IgrGridValidationState);
    get data(): any;
    set data(v: any);
    get cells(): IgrCellType[];
    set cells(v: IgrCellType[]);
    get disabled(): boolean;
    set disabled(v: boolean);
    get pinned(): boolean;
    set pinned(v: boolean);
    get selected(): boolean;
    set selected(v: boolean);
    get expanded(): boolean;
    set expanded(v: boolean);
    get deleted(): boolean;
    set deleted(v: boolean);
    get inEditMode(): boolean;
    set inEditMode(v: boolean);
    get children(): IgrRowType[];
    set children(v: IgrRowType[]);
    get parent(): IgrRowType;
    set parent(v: IgrRowType);
    get hasChildren(): boolean;
    set hasChildren(v: boolean);
    get treeRow(): IgrTreeGridRecord;
    set treeRow(v: IgrTreeGridRecord);
    get addRowUI(): boolean;
    set addRowUI(v: boolean);
    get focused(): boolean;
    set focused(v: boolean);
    get grid(): IgrGridBaseDirective;
    set grid(v: IgrGridBaseDirective);
    get ephemeralKey(): string;
    findByName(name: string): any;
    setNativeElement(element: any): void;
    update(value: any): void;
    del(): any;
    pin(): void;
    unpin(): void;
}
