import { DataSourceSummaryOperand } from "igniteui-react-core";
import { SummaryData as SummaryData_internal } from "./SummaryData";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Object used to store summary information for group headers.
*/
export declare class IgrSummaryData {
    protected createImplementation(): SummaryData_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): SummaryData_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get summaryName(): string;
    set summaryName(v: string);
    get summaryValue(): any;
    set summaryValue(v: any);
    get summaryOperand(): DataSourceSummaryOperand;
    set summaryOperand(v: DataSourceSummaryOperand);
    get formattedText(): string;
    set formattedText(v: string);
    get formattedValue(): string;
    set formattedValue(v: string);
    findByName(name: string): any;
}
