export interface IgrSummaryResult {
    key?: string;
    label?: string;
    summaryResult?: any;
    /**
     * Apply default formatting based on the grid column type.
     * ```typescript
     * const result: IgxSummaryResult = {
     * key: 'key',
     * label: 'label',
     * defaultFormatting: true
     * }
     * ```
     * @memberof IgxSummaryResult
    */
    defaultFormatting?: boolean | string;
}
