import { IgrTemplateCellInfo } from "./igr-template-cell-info";
import { TemplateHeaderCellModel as TemplateHeaderCellModel_internal } from "./TemplateHeaderCellModel";
/**
 * Backing information for the template header cells.
*/
export declare class IgrTemplateHeaderCellInfo extends IgrTemplateCellInfo {
    protected createImplementation(): TemplateHeaderCellModel_internal;
    /**
                                 * @hidden
                                 */
    get i(): TemplateHeaderCellModel_internal;
    constructor();
    /**
     * Sets or gets whether the filter UI should be visible in the header.
    */
    get isFilterUIVisible(): boolean;
    set isFilterUIVisible(v: boolean);
}
