import { IgrCellInfo } from './igr-cell-info';
import { TemplateHeaderCellUpdatingEventArgs as TemplateHeaderCellUpdatingEventArgs_internal } from "./TemplateHeaderCellUpdatingEventArgs";
/**
 * Information about the header cell that has content which is being created or updated.
*/
export declare class IgrTemplateHeaderCellUpdatingEventArgs {
    protected createImplementation(): TemplateHeaderCellUpdatingEventArgs_internal;
    protected _implementation: any;
    get i(): TemplateHeaderCellUpdatingEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    get isCanvasBased(): boolean;
    /**
     * The host in which to add or update content if this is a DOM based cell.
    */
    get content(): Element;
    get context(): CanvasRenderingContext2D;
    ensureCorrectSize(): boolean;
    renderStandardBackground(): void;
    renderStandardContent(): void;
    /**
     * The backing information for the current cell.
    */
    get cellInfo(): IgrCellInfo;
}
