import { ValuesChangeDetail as ValuesChangeDetail_internal } from "./ValuesChangeDetail";
import { ContentChildrenManager } from "igniteui-react-core";
import { IgrPivotValue } from "./igr-pivot-value";
/**
 * Event emitted when values list is changed.
*/
export declare class IgrValuesChangeDetail {
    protected createImplementation(): ValuesChangeDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ValuesChangeDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The new list of values.
    */
    get values(): IgrPivotValue[];
    set values(v: IgrPivotValue[]);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
