/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DisplayDensityBaseElement } from "./DisplayDensityBaseElement";
import { GridActionsBaseDirectiveCollection } from "./GridActionsBaseDirectiveCollection";
import { markType } from "igniteui-react-core";
import { GridActionsBaseDirective } from "./GridActionsBaseDirective";
import { ActionStripResourceStrings } from "./ActionStripResourceStrings";
/**
 * @hidden
 */
export let ActionStrip = /*@__PURE__*/ (() => {
    class ActionStrip extends DisplayDensityBaseElement {
        get j() {
            let ret_ = this.d.l("actionButtons", (a) => new GridActionsBaseDirectiveCollection(), (a) => new GridActionsBaseDirective(), ["GridActionsBaseDirective", "GridEditingActions", "GridPinningActions"]);
            return ret_;
        }
        get k() {
            let ret_ = this.d.n("hidden");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.d.v("hidden", value_);
        }
        get i() {
            let ret_ = this.d.m("resourceStrings", (a) => new ActionStripResourceStrings());
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.d.v("resourceStrings", value_);
        }
        n(a) {
            this.nativeElement.show(this.d.i(a));
        }
        m() {
            this.nativeElement.hide();
        }
        get l() {
            let ret_ = this.d.n("name");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.d.v("name", value_);
        }
    }
    ActionStrip.$t = /*@__PURE__*/ markType(ActionStrip, 'ActionStrip', DisplayDensityBaseElement.$);
    return ActionStrip;
})();
