/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseEventArgsDetail } from "./BaseEventArgsDetail";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { GridKeydownTargetType_$type } from "./GridKeydownTargetType";
/**
 * @hidden
 */
export let ActiveNodeChangeEventArgsDetail = /*@__PURE__*/ (() => {
    class ActiveNodeChangeEventArgsDetail extends BaseEventArgsDetail {
        get j() {
            let ret_ = this.b.n("row");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.b.v("row", value_);
        }
        get h() {
            let ret_ = this.b.n("column");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.b.v("column", value_);
        }
        get i() {
            let ret_ = this.b.n("level");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.b.v("level", value_);
        }
        get g() {
            let ret_ = this.b.n("tag");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridKeydownTargetType_$type, EnumUtil.getEnumValue(GridKeydownTargetType_$type, this.b.f(GridKeydownTargetType_$type, ret_)));
            return EnumUtil.getEnumValue(GridKeydownTargetType_$type, ret_);
        }
        set g(a) {
            let value_ = enumGetBox(GridKeydownTargetType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b.v("tag", value_);
        }
    }
    ActiveNodeChangeEventArgsDetail.$t = /*@__PURE__*/ markType(ActiveNodeChangeEventArgsDetail, 'ActiveNodeChangeEventArgsDetail', BaseEventArgsDetail.$);
    return ActiveNodeChangeEventArgsDetail;
})();
