/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventArgs, markType } from "igniteui-react-core";
/**
 * @hidden
 */
export let CellStyleRequestedEventArgs = /*@__PURE__*/ (() => {
    class CellStyleRequestedEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._styleKey = null;
            this._resolvedValue = null;
            this._rowNumber = 0;
        }
        get styleKey() {
            return this._styleKey;
        }
        set styleKey(a) {
            this._styleKey = a;
        }
        get resolvedValue() {
            return this._resolvedValue;
        }
        set resolvedValue(a) {
            this._resolvedValue = a;
        }
        get rowNumber() {
            return this._rowNumber;
        }
        set rowNumber(a) {
            this._rowNumber = a;
        }
    }
    CellStyleRequestedEventArgs.$t = /*@__PURE__*/ markType(CellStyleRequestedEventArgs, 'CellStyleRequestedEventArgs', EventArgs.$);
    return CellStyleRequestedEventArgs;
})();
