/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, delegateCombine, fromEnum, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, delegateRemove, enumGetBox } from "igniteui-react-core";
import { DomWrapper_$type } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { XCheckbox } from "igniteui-react-inputs";
import { XPrefix } from "igniteui-react-inputs";
import { XInputGroup } from "igniteui-react-inputs";
import { XIcon } from "igniteui-react-inputs";
import { XInput } from "igniteui-react-inputs";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { PrimaryKeyValue } from "./PrimaryKeyValue";
import { Thickness } from "igniteui-react-core";
import { CheckboxListIndexType_$type } from "./CheckboxListIndexType";
import { SRProvider } from "igniteui-react-core";
import { GridSelectedKeysCollection } from "./GridSelectedKeysCollection";
import { InputGroupDisplayType_$type } from "igniteui-react-inputs";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ScrollbarStyle_$type } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { FilterFactory } from "igniteui-react-core";
import { CheckedChangedEventArgs } from "./CheckedChangedEventArgs";
import { TemplateColumn } from "./TemplateColumn";
import { DataSourceSchemaPropertyType_$type } from "igniteui-react-core";
import { FastReflectionHelper } from "igniteui-react-core";
import { ColumnWidth } from "./ColumnWidth";
import { DateTimeColumn } from "./DateTimeColumn";
import { NumericColumn } from "./NumericColumn";
import { TextColumn } from "./TextColumn";
import { ArgumentException } from "igniteui-react-core";
import { SelectAllCheckboxChangedEventArgs } from "./SelectAllCheckboxChangedEventArgs";
import { stringIsNullOrWhiteSpace } from "igniteui-react-core";
/**
 * @hidden
 */
export let CheckboxListView = /*@__PURE__*/ (() => {
    class CheckboxListView extends Base {
        constructor() {
            super();
            this.e = new Dictionary$2(DomWrapper_$type, XCheckbox.$, 0);
            this.j = null;
            this.a = null;
            this.i = null;
            this.h = null;
            this.c = null;
            this.b = null;
            this.f = null;
            this.d = false;
            this.g = null;
        }
        n() {
        }
        m(a) {
            if (a == null) {
                this.f = null;
                this.e.clear();
                return;
            }
            this.f = a;
            this.v();
            this.ae();
            this.ah();
            this.s();
            let b = Math.round(a.rootWrapper.width());
            let c = Math.round(a.rootWrapper.height());
            this.f.rootWrapper.setStyleProperty("position", "relative");
            this.f.rootWrapper.setStyleProperty("padding-bottom", "4px");
        }
        v() {
            if (this.f != null) {
                this.w(this.f);
            }
        }
        w(a) {
            let b = a.rootWrapper.getChildAt(0);
            this.h = b;
            this.b.r = new XInputGroup();
            let c = a.getSubRenderer(b);
            this.b.r.provideContainer(c);
            let d = c.getExternal(this.b.r, c.rootWrapper, c.getExternal(this.b, null, null));
            this.b.r.d = this.b.t;
            this.b.r.p = this.b.y;
            this.b.r.t = this.b.aa;
            let e = a.createElement("div");
            let f = a.getSubRenderer(e);
            let g = new XPrefix();
            g.provideContainer(f);
            let h = f.getExternal(g, f.rootWrapper, f.getExternal(this.b, null, null));
            let i = a.createElement("div");
            let j = a.getSubRenderer(i);
            this.c = new XIcon();
            this.c.provideContainer(j);
            this.c.fill = this.b.du;
            this.c.svgPath = CheckboxList.bt;
            let k = f.getExternal(this.c, j.rootWrapper, j.getExternal(this.b, null, null));
            g.appendContentChild(i);
            this.b.r.appendContentChild(e);
            this.b.r.inputs.add(g);
            let l = a.createElement("div");
            l.setRawStyleProperty("flex-grow", "1");
            let m = a.getSubRenderer(l);
            this.b.p = new XInput();
            this.b.p.provideContainer(m);
            this.b.p.b8 = "text";
            let n = m.getExternal(this.b.p, m.rootWrapper, m.getExternal(this.b, null, null));
            if (this.b.bg != null) {
                this.b.p.cg = this.b.bg;
            }
            this.b.r.appendContentChild(l);
            this.b.r.inputs.add(this.b.p);
            this.b.ck();
        }
        s() {
            if (this.f != null) {
                let a = this.f.rootWrapper.getChildAt(3);
                a.setStyleProperty("width", "100%");
                a.setStyleProperty("margin", "4px 0px 0px 0px");
                if (this.b.as == false) {
                    a.setStyleProperty("height", "calc(100% - 50px");
                }
                else {
                    a.setStyleProperty("height", "calc(100% - 75px");
                }
                if (!this.b.aq && !this.b.as) {
                    a.setStyleProperty("height", "100%");
                }
            }
        }
        o(a, b, c) {
            let d = null;
            if (a.getChildCount() == 0) {
                d = new XCheckbox();
                let e = this.f.getSubRenderer(a);
                d.provideContainer(e);
                let f = this.f.getExternal(d, e.rootWrapper, this.f.getExternal(this.b, null, null));
                this.e.addItem(a, d);
                d.n = this.b.y;
                d.y = true;
                d.change = delegateCombine(d.change, runOn(this, this.k));
                let g = this.f.createElement("div");
                a.setStyleProperty("display", "flex");
                a.setStyleProperty("height", "100%");
                a.setStyleProperty("align-items", "center");
                switch (this.b.aa) {
                    case 1:
                        a.setStyleProperty("margin-top", "-4px");
                        break;
                    case 2:
                        a.setStyleProperty("margin-top", "-1px");
                        break;
                    case 3:
                        a.setStyleProperty("margin-top", "1px");
                        break;
                }
                a.append(g);
            }
            else {
                d = this.e.item(a);
            }
            if (d != null) {
                let h = d.z;
                try {
                    d.z = true;
                    d.a4 = b;
                    if (c) {
                        if (this.b.l == 0) {
                            d.checked = false;
                        }
                        else {
                            d.checked = true;
                        }
                    }
                    else {
                        if (this.b.l == 0) {
                            d.checked = true;
                        }
                        else {
                            d.checked = false;
                        }
                    }
                }
                finally {
                    d.z = h;
                }
                d.dk = this.b.dl;
                d.dd = this.b.dj;
                d.dl = this.b.dm;
                d.de = this.b.dk;
                d.dm = this.b.dn;
            }
        }
        z() {
            if (this.e != null) {
                for (let a of fromEnum(this.e)) {
                    let b = a.value;
                    b.n = this.b.y;
                }
            }
            if (this.a != null) {
                this.a.n = this.b.y;
            }
        }
        x() {
        }
        k(a, b) {
            let c = a;
            let d = parseInt(c.a4.toString());
            let e = c.checked;
            if (e == true) {
                if (this.b.l == 0) {
                    this.b.cw(d);
                }
                else {
                    this.b.b5(d);
                }
            }
            else {
                if (this.b.l == 0) {
                    this.b.b5(d);
                }
                else {
                    this.b.cw(d);
                }
            }
            this.b.ci(d, e);
            this.ag(false);
        }
        l() {
        }
        t(a, b) {
            for (let c of fromEnum(this.e)) {
                let d = c.value;
                let e = parseInt(d.a4.toString());
                if (e == a) {
                    d.checked = b;
                    this.b.ci(e, b);
                }
            }
            this.ag();
        }
        u(a) {
            for (let b of fromEnum(this.e)) {
                let c = b.value;
                c.checked = a;
            }
        }
        q(a) {
            this.j = a;
            if (null != this.j) {
                this.j.setStyleProperty("margin", "5px 0px 4px 0px");
            }
        }
        ah() {
            let a = this.f;
            if (null == a || null == this.j) {
                return;
            }
            let b = a.createElement("div");
            let c = a.getSubRenderer(b);
            this.a = new XCheckbox();
            this.a.provideContainer(c);
            let d = this.f.getExternal(this.a, c.rootWrapper, this.f.getExternal(this.b, null, null));
            this.a.n = this.b.y;
            this.i = a.createElement("label");
            this.i.setRawText(this.b.bx);
            this.i.setStyleProperty("font-size", "13px");
            this.j.setStyleProperty("display", "flex");
            this.j.setStyleProperty("flex-direction", "row");
            this.j.setStyleProperty("font-family", "Verdana");
            this.j.setStyleProperty("align-items", "center");
            this.j.append(b);
            this.j.append(this.i);
            this.ai();
            this.af();
            let e = this.a;
            e.change = delegateCombine(e.change, runOn(this, this.r));
            this.a.y = true;
        }
        af() {
            if (null != this.i) {
                this.i.setRawText(this.b.bx);
                NativeUI.q(this.i, this.b.dh);
            }
        }
        ai() {
            if (null != this.i) {
                let a = this.b.as ? "flex" : "none";
                this.j.setStyleProperty("display", a);
            }
        }
        ae() {
            if (this.h != null) {
                this.h.setStyleProperty("display", this.b.aq ? "block" : "none");
            }
            if (this.g != null) {
                this.g.setStyleProperty("display", this.b.aq ? "block" : "none");
            }
        }
        ag(a = true) {
            let b = this.d;
            this.d = true;
            let c = this.a.z;
            this.a.z = a;
            try {
                if (this.b.ao) {
                    this.a.indeterminate = true;
                    return;
                }
                this.a.indeterminate = false;
                if (this.b.l == 0) {
                    this.a.checked = this.b.g.count == 0;
                }
                else {
                    this.a.checked = this.b.g.count != 0;
                }
            }
            finally {
                this.a.z = c;
                this.d = b;
            }
        }
        r(a, b) {
            if (this.d || b.isIndeterminate) {
                return;
            }
            if (b.isChecked) {
                this.b.cy();
                this.b.cp(b.isChecked);
            }
            else {
                this.b.b9();
                this.b.cp(b.isChecked);
            }
        }
        ad() {
            let a = this.f;
            if (null == a) {
                return;
            }
            let b = a.rootWrapper;
            if (null != b) {
                NativeUI.q(b, this.b.dy);
                NativeUI.m(b, this.b.di);
            }
        }
        ab() {
            if (this.c != null) {
                this.c.fill = this.b.du;
            }
        }
        ac() {
            if (this.b.ae != null) {
                this.i.setStyleProperty("font", this.b.ae.fontString);
            }
            else {
                this.i.setStyleProperty("font-family", "Verdana");
                this.i.setStyleProperty("font-size", 13 + "px");
            }
        }
        y() {
            this.a.dk = this.b.dl;
            this.a.dd = this.b.dj;
            this.a.dl = this.b.dm;
            this.a.de = this.b.dk;
            this.a.dm = this.b.dn;
        }
        aa(a) {
            if (this.g != null) {
                NativeUI.w(this.g, a);
            }
        }
        p(a) {
            this.g = a;
        }
    }
    CheckboxListView.$t = /*@__PURE__*/ markType(CheckboxListView, 'CheckboxListView');
    return CheckboxListView;
})();
/**
 * @hidden
 */
export let CheckboxList = /*@__PURE__*/ (() => {
    class CheckboxList extends Base {
        get r() {
            return this.q;
        }
        set r(a) {
            this.q = a;
        }
        get p() {
            return this.o;
        }
        set p(a) {
            this.o = a;
        }
        get e() {
            if (this.h == null) {
                return null;
            }
            return this.h.actualDataSource;
        }
        get ah() {
            if (this.ag == null) {
                this.ag = new SRProvider(this.m.f);
                this.ag.cb("DataGrid");
            }
            return this.ag;
        }
        get g() {
            return this.f;
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.cn("PrimaryKey", b, this.a);
            }
        }
        constructor() {
            super();
            this.m = null;
            this.h = null;
            this.i = null;
            this.ab = null;
            this.d = null;
            this.ai = false;
            this.c = null;
            this.o = null;
            this.q = null;
            this.aj = false;
            this.ag = null;
            this.f = new GridSelectedKeysCollection();
            this.a = null;
            this.propertyChanged = null;
            this.checkedChanged = null;
            this.ay = null;
            this.a0 = null;
            this.a2 = null;
            this.a1 = null;
            this.s = 3;
            this.au = -1;
            this.ac = null;
            this.k = 1;
            this.x = 1;
            this.z = 2;
            this.dd = BrushUtil.h(255, 24, 29, 31);
            this.db = null;
            this.de = null;
            this.dc = null;
            this.ad = null;
            this.c7 = null;
            this.c5 = null;
            this.c8 = null;
            this.c6 = null;
            this.c9 = null;
            this.v = 0;
            this.da = null;
            this.bw = null;
            this.df = null;
            this.c3 = CheckboxList.dq;
            this.ar = true;
            this.c4 = CheckboxList.dp;
            this.dg = CheckboxList.dq;
            this.selectAllCheckboxChanged = null;
            this.aw = -1;
            this.ap = true;
            this.am = true;
            let a = this.f;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.cr));
            this.d = new FilterFactory();
            let b = new CheckboxListView();
            b.b = this;
            this.m = b;
            this.m.n();
        }
        cr(a, b) {
            if (this.e == null || this.e.actualSchema == null || this.ai) {
                return;
            }
            switch (b.action) {
                case 0:
                    for (let c = 0; c < b.newItems.count; c++) {
                        this.cl(b.newItems.item(c));
                    }
                    break;
                case 1:
                    for (let d = 0; d < b.oldItems.count; d++) {
                        this.cm(b.oldItems.item(d));
                    }
                    break;
                case 2:
                    for (let e = 0; e < b.oldItems.count; e++) {
                        this.cm(b.oldItems.item(e));
                    }
                    for (let f = 0; f < b.newItems.count; f++) {
                        this.cl(b.newItems.item(f));
                    }
                    break;
                case 4:
                    this.m.u(this.l == 0);
                    for (let g = 0; g < this.g.ae.count; g++) {
                        this.cl(this.g.ae._inner[g]);
                    }
                    break;
            }
        }
        cl(a) {
            let b = this.e.indexOfKey(a.value);
            if (b >= 0) {
                this.m.t(b, this.l == 1);
            }
        }
        cm(a) {
            let b = this.e.indexOfKey(a.value);
            if (b >= 0) {
                this.m.t(b, this.l == 0);
            }
        }
        ci(a, b) {
            if (this.checkedChanged != null && this.aj == false) {
                this.checkedChanged(this, ((() => {
                    let $ret = new CheckedChangedEventArgs();
                    $ret.b = a;
                    $ret.a = b;
                    return $ret;
                })()));
            }
        }
        notifySizeChanged() {
            this.m.l();
        }
        destroy() {
            if (this.h != null) {
                let a = this.h;
                a.cellClicked = delegateRemove(a.cellClicked, runOn(this, this.cb));
                if (this.h.actualDataSource != null) {
                    let b = this.h.actualDataSource;
                    b.schemaChanged = delegateRemove(b.schemaChanged, runOn(this, this.co));
                }
            }
            if (this.o != null) {
                let c = this.o;
                c.change = delegateRemove(c.change, runOn(this, this.cc));
            }
            this.provideContainer(null, null, null);
            if (this.i != null) {
                let d = this.i;
                d.cellUpdating = delegateRemove(d.cellUpdating, runOn(this, this.b8));
            }
        }
        provideContainer(a, b, c) {
            this.h = b;
            if (null != this.h) {
                this.h.scrollbarStyle = this.w;
                this.h.scrollbarBackground = this.dr;
                this.h.headerHeight = 0;
                this.h.rowSeparatorHeight = 0;
                this.h.defaultColumnMinWidth = NaN;
                this.h.autoGenerateColumns = false;
                this.h.activationMode = 0;
                this.h.editMode = 0;
                let d = this.h;
                d.cellClicked = delegateCombine(d.cellClicked, runOn(this, this.cb));
                if (this.ay != null) {
                    this.h.itemsSource = this.ay;
                    this.b7();
                    this.cq();
                }
                if (this.a0 != null) {
                    this.cq();
                    this.c1();
                }
            }
            this.m.q(c);
            this.m.m(a);
        }
        provideSelectAllSection(a) {
            this.m.q(a);
        }
        cb(a, b) {
            if (b.cellInfo.l.a5 == 0) {
                return;
            }
            let c = b.cellInfo.l.x;
            if (-1 == c) {
                return;
            }
            let d = this.j(b.cellInfo.g4);
            if (this.g.contains(d)) {
                this.g.remove(d);
            }
            else {
                this.g.add(d);
            }
        }
        b8(a, b) {
            let c = b.cellInfo.l.x;
            if (-1 == c) {
                return;
            }
            let d = false;
            if (b.cellInfo.g4 != null) {
                let e = this.j(b.cellInfo.g4);
                if (this.g.contains(e)) {
                    d = true;
                }
            }
            this.m.o(b.content.element, c, d);
        }
        cj(a) {
            if (this.a0 != null) {
                let b = this.d.property(this.a0).cast(enumGetBox(DataSourceSchemaPropertyType_$type, 0)).toLower();
                let c = b.contains(a);
                if (!this.h.filterExpressions.k.contains(this.c)) {
                    this.c = c;
                    this.h.filterExpressions.add(this.c);
                }
                else {
                    let d = this.h.filterExpressions.k.indexOf(this.c);
                    this.h.filterExpressions.k.item(d, this.c = c);
                }
            }
        }
        get itemsSource() {
            return this.ay;
        }
        set itemsSource(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.cn("ItemsSource", b, this.ay);
            }
        }
        get bc() {
            return this.a0;
        }
        set bc(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.cn("DataMemberPath", b, this.a0);
            }
        }
        get b0() {
            return this.a2;
        }
        set b0(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.cn("SelectedMemberPath", b, this.a2);
            }
        }
        get bg() {
            return this.a1;
        }
        set bg(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.cn("FilterPlaceholderText", b, this.a1);
            }
        }
        get t() {
            return this.s;
        }
        set t(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.cn("SearchInputType", enumGetBox(InputGroupDisplayType_$type, b), enumGetBox(InputGroupDisplayType_$type, this.s));
            }
        }
        get ax() {
            return this.au;
        }
        set ax(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.cn("RowHeight", b, this.au);
            }
        }
        get av() {
            if (this.h != null) {
                return this.h.actualRowHeight;
            }
            return -1;
        }
        get ae() {
            return this.ac;
        }
        set ae(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.cn("CellTextStyle", b, this.ac);
            }
        }
        get l() {
            return this.k;
        }
        set l(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.cn("IndexType", enumGetBox(CheckboxListIndexType_$type, b), enumGetBox(CheckboxListIndexType_$type, this.k));
            }
        }
        get y() {
            return this.x;
        }
        set y(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.cn("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.x));
            }
        }
        get aa() {
            return this.z;
        }
        set aa(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.cn("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.z));
            }
        }
        get du() {
            return this.dd;
        }
        set du(a) {
            let b = this.dd;
            this.dd = a;
            if (b != this.dd) {
                this.cn("SearchIconColor", b, this.dd);
            }
        }
        get ds() {
            return this.db;
        }
        set ds(a) {
            let b = this.db;
            this.db = a;
            if (b != this.db) {
                this.cn("SearchBackgroundColor", b, this.db);
            }
        }
        get dv() {
            return this.de;
        }
        set dv(a) {
            let b = this.de;
            this.de = a;
            if (b != this.de) {
                this.cn("SearchTextColor", b, this.de);
            }
        }
        get dt() {
            return this.dc;
        }
        set dt(a) {
            let b = this.dc;
            this.dc = a;
            if (b != this.dc) {
                this.cn("SearchBorderColor", b, this.dc);
            }
        }
        get af() {
            return this.ad;
        }
        set af(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.cn("SearchTextStyle", b, this.ad);
            }
        }
        get dl() {
            return this.c7;
        }
        set dl(a) {
            let b = this.c7;
            this.c7 = a;
            if (b != this.c7) {
                this.cn("CheckboxTickColor", b, this.c7);
            }
        }
        get dj() {
            return this.c5;
        }
        set dj(a) {
            let b = this.c5;
            this.c5 = a;
            if (b != this.c5) {
                this.cn("CheckboxCheckedBackgroundColor", b, this.c5);
            }
        }
        get dm() {
            return this.c8;
        }
        set dm(a) {
            let b = this.c8;
            this.c8 = a;
            if (b != this.c8) {
                this.cn("CheckboxUncheckedBackgroundColor", b, this.c8);
            }
        }
        get dk() {
            return this.c6;
        }
        set dk(a) {
            let b = this.c6;
            this.c6 = a;
            if (b != this.c6) {
                this.cn("CheckboxCheckedBorderColor", b, this.c6);
            }
        }
        get dn() {
            return this.c9;
        }
        set dn(a) {
            let b = this.c9;
            this.c9 = a;
            if (b != this.c9) {
                this.cn("CheckboxUncheckedBorderColor", b, this.c9);
            }
        }
        get w() {
            return this.v;
        }
        set w(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.cn("ScrollbarStyle", enumGetBox(ScrollbarStyle_$type, b), enumGetBox(ScrollbarStyle_$type, this.v));
            }
        }
        get dr() {
            return this.da;
        }
        set dr(a) {
            let b = this.da;
            this.da = a;
            if (b != this.da) {
                this.cn("ScrollbarBackground", b, this.da);
            }
        }
        cn(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.cs(a, b, c);
        }
        cs(a, b, c) {
            switch (a) {
                case "ItemsSource":
                    if (this.h != null) {
                        this.l = 1;
                        if (c != null) {
                            this.h.groupDescriptions.n();
                            this.h.sortDescriptions.n();
                            this.h.filterExpressions.clear();
                            this.h.summaryDescriptions.n();
                        }
                        if (this.h.actualDataSource != null) {
                            let d = this.h.actualDataSource;
                            d.schemaChanged = delegateRemove(d.schemaChanged, runOn(this, this.co));
                        }
                        this.h.itemsSource = this.ay;
                        this.b7();
                        if (this.h.actualDataSource != null) {
                            let e = this.h.actualDataSource;
                            e.schemaChanged = delegateCombine(e.schemaChanged, runOn(this, this.co));
                        }
                        this.aj = true;
                        this.cq();
                        this.aj = false;
                        this.m.ag();
                    }
                    break;
                case "DataMemberPath":
                case "SelectedMemberPath":
                    if (this.h != null) {
                        if (this.a0 != null) {
                            this.cq();
                            this.c1();
                        }
                    }
                    break;
                case "PrimaryKey":
                    if (this.h != null) {
                        this.h.primaryKey = this.b;
                    }
                    break;
                case "SelectAllCaptionTextColor":
                    this.dh = null != this.dw ? this.dw : CheckboxList.dq;
                    break;
                case "SelectAllCaption":
                case "ActualSelectAllCaptionTextColor":
                    this.m.af();
                    break;
                case "showSelectAll":
                    this.m.ai();
                    this.m.s();
                    break;
                case "ShowFilter":
                    this.m.ae();
                    this.m.s();
                    break;
                case "FilterPlaceholderText":
                    if (this.o != null) {
                        this.o.cg = this.bg;
                    }
                    break;
                case "SearchInputType":
                    if (this.q != null) {
                        this.q.d = this.t;
                    }
                    break;
                case "RowHeight":
                    if (this.h != null) {
                        this.h.rowHeight = this.ax;
                    }
                    break;
                case "CellTextStyle":
                    if (this.h != null) {
                        this.h.cellTextStyle = this.ae;
                    }
                    this.m.ac();
                    break;
                case "BackgroundColor":
                case "TextColor":
                    let f = this.h;
                    if (null != f) {
                        f.cellTextColor = this.dy;
                        f.cellBackground = this.di;
                        f.cellSelectedBackground = this.di;
                    }
                    this.m.ad();
                    break;
                case "BaseTheme":
                    this.c0();
                    break;
                case "Density":
                    this.cz();
                    break;
                case "IsRowHoverEnabled":
                    if (this.h != null) {
                        this.h.isRowHoverEnabled = this.an;
                    }
                    break;
                case "ScrollbarStyle":
                    if (this.h != null) {
                        this.h.scrollbarStyle = this.w;
                    }
                    break;
                case "ScrollbarBackground":
                    if (this.h != null) {
                        this.h.scrollbarBackground = this.dr;
                    }
                    break;
                case "SearchIconColor":
                    this.m.ab();
                    break;
                case "SearchBackgroundColor":
                    this.r.mc = this.ds;
                    break;
                case "SearchBorderColor":
                    this.r.md = this.dt;
                    break;
                case "SearchTextColor":
                    this.p.d8 = this.dv;
                    break;
                case "SearchTextStyle":
                    this.p.af = this.af;
                    break;
                case "CheckboxTickColor":
                case "CheckboxCheckedBackgroundColor":
                case "CheckboxUncheckedBackgroundColor":
                case "CheckboxCheckedBorderColor":
                case "CheckboxUncheckedBorderColor":
                    this.m.y();
                    if (this.h != null) {
                        this.h.w9();
                    }
                    break;
            }
        }
        cz() {
            if (this.h != null) {
                this.h.density = this.aa;
            }
            if (this.q != null) {
                this.q.t = this.aa;
            }
            this.m.x();
        }
        c0() {
            if (this.q != null) {
                this.q.p = this.y;
            }
            this.m.z();
        }
        co(a, b) {
            this.aj = true;
            this.b7();
            if (b.schema != null) {
                this.cq();
                for (let c = 0; c < this.g.count; c++) {
                    this.cl(this.g._inner[c]);
                }
                this.m.ag();
            }
            this.aj = false;
        }
        cq() {
            if (this.ab == null && this.a2 != null && this.a2 != "") {
                this.ab = new FastReflectionHelper(false, this.a2);
            }
            if (this.ay != null && this.ab != null && this.h.actualDataSource.actualSchema != null) {
                this.ab.propertyName = this.a2;
                let a = this.h.actualDataSource.actualCount;
                for (let b = 0; b < a; b++) {
                    let c = this.h.actualDataSource.getItemAtIndex(b);
                    let d = this.ab.getPropertyValue(c);
                    if (d == true) {
                        let e = this.j(c);
                        if (!this.g.contains(e)) {
                            this.g.add(e);
                        }
                    }
                }
            }
        }
        c1() {
            this.h.actualColumns.clear();
            this.h.primaryKey = this.b;
            this.h.isGroupRowSticky = false;
            this.h.rowHeight = this.ax;
            this.h.cellBackground = this.di;
            this.h.cellSelectedBackground = this.di;
            this.h.density = this.aa;
            this.h.isRowHoverEnabled = this.an;
            this.h.borderWidth = new Thickness(0, 0);
            if (this.ae != null) {
                this.h.cellTextStyle = this.ae;
            }
            let a = new TemplateColumn();
            if (this.a2 == null) {
                this.a2 = "";
            }
            a.i8 = this.a2;
            a.jz = "CheckboxColumn";
            let b = new ColumnWidth();
            b.c = false;
            b.f = 28;
            a.width = b;
            a.h2 = 0;
            a.h3 = 0;
            a.cellUpdating = delegateCombine(a.cellUpdating, runOn(this, this.b8));
            this.h.columns.add(a);
            this.i = a;
            let c = this.h.actualDataSource.resolveSchemaPropertyType(this.a0);
            let d;
            switch (c) {
                case 8:
                case 9:
                    d = new DateTimeColumn();
                    break;
                case 1:
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                case 10:
                    d = new NumericColumn();
                    break;
                case 2:
                case 11:
                case 0:
                default:
                    d = new TextColumn();
                    break;
            }
            d.i8 = this.a0;
            d.jz = "DataColumn";
            d.h2 = 0;
            d.e = 0;
            this.h.columns.add(d);
        }
        updateHrMargin(a) {
            this.m.aa(a);
        }
        provideHrElement(a) {
            this.m.p(a);
        }
        ck() {
            let a = this.p;
            a.changing = delegateCombine(a.changing, runOn(this, this.cc));
        }
        cc(a, b) {
            let c = b.value.toLowerCase();
            this.cj(c);
        }
        j(a) {
            if (this.b == null) {
                return PrimaryKeyValue.createIdentityKey(a);
            }
            let b = new Array(this.b.length);
            let c = new Array(this.b.length);
            for (let d = 0; d < b.length; d++) {
                b[d] = this.b[d];
                c[d] = this.e.getItemProperty(a, b[d]);
            }
            return new PrimaryKeyValue(b, c);
        }
        cw(a) {
            this.ai = true;
            let b = this.e.getItemAtIndex(a);
            let c = this.j(b);
            this.g.remove(c);
            this.ai = false;
        }
        b5(a) {
            this.ai = true;
            let b = this.e.getItemAtIndex(a);
            let c = this.j(b);
            this.g.add(c);
            this.ai = false;
        }
        cy() {
            this.l = 0;
            this.g.clear();
            this.cd();
            this.m.ag();
        }
        b9() {
            this.l = 1;
            this.g.clear();
            this.cd();
            this.m.ag();
        }
        cg(a, b, c) {
            if (this.h != null) {
                this.h.notifySetItem(a, b, c);
            }
        }
        cd() {
            if (this.h != null) {
                this.h.notifyClearItems();
            }
        }
        ce(a, b) {
            if (this.h != null) {
                this.h.notifyInsertItem(a, b);
            }
            ;
        }
        cf(a, b) {
            if (this.h != null) {
                this.h.notifyRemoveItem(a, b);
            }
            ;
        }
        b6(a) {
            let b = null;
            if (this.b == null || this.b.length == 0) {
                b = new PrimaryKeyValue(null, a);
            }
            else if (this.b.length == a.length) {
                b = new PrimaryKeyValue(this.b, a);
            }
            else {
                throw new ArgumentException(1, "value length must match PrimaryKey length");
            }
            if (b != null) {
                this.g.add(b);
            }
        }
        cx(a) {
            let b = null;
            if (this.b == null || this.b.length == 0) {
                b = new PrimaryKeyValue(null, a);
            }
            else if (this.b.length == a.length) {
                b = new PrimaryKeyValue(this.b, a);
            }
            else {
                throw new ArgumentException(1, "value length must match PrimaryKey length");
            }
            if (this.g.contains(b)) {
                this.g.remove(b);
            }
        }
        get bx() {
            return this.bw != null ? this.bw : !stringIsNullOrWhiteSpace(this.ah.b1("Select_All")) ? this.ah.b1("Select_All") : "(Select All)";
        }
        set bx(a) {
            if (a == this.bw) {
                return;
            }
            let b = this.bw;
            this.bw = a;
            this.cn("SelectAllCaption", b, this.bw);
        }
        get dw() {
            return this.df;
        }
        set dw(a) {
            let b = this.df;
            this.df = a;
            if (b != this.df) {
                this.cn("SelectAllCaptionTextColor", b, a);
            }
        }
        get dh() {
            return this.c3;
        }
        set dh(a) {
            let b = this.c3;
            this.c3 = a;
            if (b != this.c3) {
                this.cn("ActualSelectAllCaptionTextColor", b, a);
            }
        }
        get ao() {
            if (-1 == this.aw) {
                return false;
            }
            let a = this.g.count;
            if (0 == a) {
                return false;
            }
            if (a == this.aw) {
                return false;
            }
            return true;
        }
        get as() {
            return this.ar;
        }
        set as(a) {
            if (a == this.ar) {
                return;
            }
            let b = this.ar;
            this.ar = a;
            this.cn("showSelectAll", b, this.ar);
        }
        get di() {
            return this.c4;
        }
        set di(a) {
            let b = this.c4;
            this.c4 = a;
            if (b != this.c4) {
                this.cn("BackgroundColor", b, a);
            }
        }
        get dy() {
            return this.dg;
        }
        set dy(a) {
            let b = this.dg;
            this.dg = a;
            if (b != this.dg) {
                this.cn("TextColor", b, a);
            }
        }
        cp(a) {
            if (this.selectAllCheckboxChanged != null) {
                this.selectAllCheckboxChanged(this, ((() => {
                    let $ret = new SelectAllCheckboxChangedEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
        }
        al() {
            if (-1 == this.aw) {
                return true;
            }
            let a = this.g.count;
            switch (this.l) {
                case 0: return this.aw == a;
                case 1: return 0 == a;
                default: return false;
            }
        }
        ak() {
            if (-1 == this.aw) {
                return false;
            }
            let a = this.g.count;
            switch (this.l) {
                case 0: return 0 == a;
                case 1: return this.aw == a;
                default: return false;
            }
        }
        b7() {
            let a = this.h.actualDataSource;
            if (null != a) {
                if (null == a.actualSchema) {
                    this.aw = -1;
                    return;
                }
                let b = a.actualCount;
                this.aw = b;
            }
            else {
                this.aw = -1;
            }
        }
        get aq() {
            return this.ap;
        }
        set aq(a) {
            if (a == this.ap) {
                return;
            }
            let b = this.ap;
            this.ap = a;
            this.cn("ShowFilter", b, this.ap);
        }
        get an() {
            return this.am;
        }
        set an(a) {
            if (a == this.am) {
                return;
            }
            let b = this.am;
            this.am = a;
            this.cn("IsRowHoverEnabled", b, this.am);
        }
    }
    CheckboxList.$t = /*@__PURE__*/ markType(CheckboxList, 'CheckboxList', Base.$, [INotifyPropertyChanged_$type]);
    CheckboxList.dx = /*@__PURE__*/ BrushUtil.h(255, 24, 29, 31);
    CheckboxList.bt = "M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14z";
    CheckboxList.dp = /*@__PURE__*/ BrushUtil.h(255, 248, 248, 248);
    CheckboxList.dq = /*@__PURE__*/ BrushUtil.h(255, 24, 29, 31);
    return CheckboxList;
})();
