/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Column } from "./Column";
import { ColumnCollection } from "./ColumnCollection";
import { markType } from "igniteui-react-core";
import { ColumnTemplateContext } from "./ColumnTemplateContext";
/**
 * @hidden
 */
export let ColumnGroup = /*@__PURE__*/ (() => {
    class ColumnGroup extends Column {
        constructor() {
            super(...arguments);
            this.bg = null;
        }
        get be() {
            let ret_ = this.i.l("children", (a) => new ColumnCollection(), (a) => new Column(), ["Column", "ColumnGroup", "ColumnLayout"]);
            return ret_;
        }
        get bf() {
            let ret_ = this.i.n("collapsible");
            return ret_;
        }
        set bf(a) {
            let value_ = a;
            this.i.v("collapsible", value_);
        }
        get bh() {
            return this.bg;
        }
        set bh(a) {
            this.bg = a;
            this.i.s("collapsibleIndicatorTemplate", (b) => new ColumnTemplateContext(), this.bg);
        }
    }
    ColumnGroup.$t = /*@__PURE__*/ markType(ColumnGroup, 'ColumnGroup', Column.$);
    return ColumnGroup;
})();
