/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-react-core";
import { IColumnGroupingVisualModelExport_$type } from "./IColumnGroupingVisualModelExport";
import { StringBuilder } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let ColumnGroupingVisualModelExport = /*@__PURE__*/ (() => {
    class ColumnGroupingVisualModelExport extends Base {
        constructor() {
            super(...arguments);
            this.b = 0;
            this.a = 0;
            this.o = null;
            this.h = 0;
            this.f = 0;
            this.e = 0;
            this.i = 0;
            this.l = null;
            this.m = null;
            this.n = null;
            this.g = 0;
            this.j = null;
            this.k = null;
            this.c = null;
            this.d = null;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.l("{");
            a.l("density : " + this.b + ", ");
            a.l("baseTheme : " + this.a + ", ");
            a.l("title : " + this.o + ", ");
            a.l("top : " + this.h + ", ");
            a.l("left : " + this.f + ", ");
            a.l("height : " + this.e + ", ");
            a.l("width : " + this.i + ", ");
            if (!stringIsNullOrEmpty(this.l)) {
                a.l("textStyleFontStyle : \"" + this.l + "\", ");
            }
            if (!stringIsNullOrEmpty(this.m)) {
                a.l("textStyleFontVariant : \"" + this.m + "\", ");
            }
            if (!stringIsNullOrEmpty(this.n)) {
                a.l("textStyleFontWeight : \"" + this.n + "\", ");
            }
            if (!stringIsNullOrEmpty(this.j)) {
                a.l("textStyleFontFamily : \"" + this.j + "\", ");
            }
            if (!stringIsNullOrEmpty(this.k)) {
                a.l("textStyleFontStretch : \"" + this.k + "\", ");
            }
            if (!isNaN_(this.g)) {
                a.l("textStyleFontSize : " + this.g + ", ");
            }
            a.l("groupPipsModels: [");
            for (let b = 0; b < this.c.count; b++) {
                if (b != 0) {
                    a.l(",");
                }
                a.l(this.c._inner[b].h());
            }
            a.l("],");
            a.l("iconsModels: [");
            for (let c = 0; c < this.d.count; c++) {
                if (c != 0) {
                    a.l(",");
                }
                a.l(this.d._inner[c].j());
            }
            a.l("]");
            a.l("}");
            return a.toString();
        }
    }
    ColumnGroupingVisualModelExport.$t = /*@__PURE__*/ markType(ColumnGroupingVisualModelExport, 'ColumnGroupingVisualModelExport', Base.$, [IColumnGroupingVisualModelExport_$type]);
    return ColumnGroupingVisualModelExport;
})();
