/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { CellModel } from "./CellModel";
import { FontUtil } from "igniteui-react-core";
/**
 * @hidden
 */
export let ContentCellModelHelper = /*@__PURE__*/ (() => {
    class ContentCellModelHelper extends Base {
        static g(a) {
            if (a == null) {
                return ContentCellModelHelper.f;
            }
            return a.color;
        }
        static c(a, b, c) {
            switch (c) {
                case 0:
                    a.setRawStyleProperty("text-align", "left");
                    break;
                case 1:
                    a.setRawStyleProperty("text-align", "center");
                    break;
                case 2:
                    a.setRawStyleProperty("text-align", "right");
                    break;
                case 3:
                    a.setRawStyleProperty("text-align", "center");
                    break;
            }
        }
        static e(a, b, c) {
            switch (c) {
                case 0:
                    b.setRawStyleProperty("vertical-align", "top");
                    break;
                case 1:
                    b.setRawStyleProperty("vertical-align", "center");
                    break;
                case 2:
                    b.setRawStyleProperty("vertical-align", "bottom");
                    break;
                case 3:
                    b.setRawStyleProperty("vertical-align", "center");
                    break;
            }
        }
        static a(a, b, c, d, e) {
            if (b.ay) {
                if (b.a3(CellModel.es) || b.a3(CellModel.d5) || b.a3(CellModel.gt) || b.a2("IsRowPinned") || b.a2("IsRowSticky") || b.a2("PinnedRowOpacity")) {
                    let f = Math.min(1, Math.max(0, b.ck));
                    let g = b.b8 * (1 - f);
                    d.setRawStyleProperty("opacity", g.toString());
                    if (b.bd) {
                        e.cf(b.b8 * f);
                    }
                }
                if (b.a3(CellModel.eg)) {
                    ContentCellModelHelper.d(d, b.k2);
                    if (b.bd) {
                        e.cc(b.k2);
                    }
                }
                if (b.a3(CellModel.fx)) {
                    switch (b.aa) {
                        case 0:
                            d.setRawStyleProperty("white-space", "nowrap");
                            d.setRawStyleProperty("text-overflow", "ellipsis");
                            break;
                        case 3:
                        case 2:
                            d.setRawStyleProperty("white-space", "pre-wrap");
                            d.setRawStyleProperty("text-overflow", "ellipsis");
                            break;
                        case 1:
                            d.setRawStyleProperty("white-space", "nowrap");
                            d.setRawStyleProperty("text-overflow", "clip");
                            break;
                    }
                }
                if (b.a3(CellModel.fe) || b.a3(CellModel.gs)) {
                    let h = b.g;
                    let i = b.i;
                    ContentCellModelHelper.c(c, d, h);
                    e.bn(c, d, h);
                    ContentCellModelHelper.e(c, d, i);
                    if (b.bd) {
                        e.cb(h, i);
                    }
                }
                if (b.a2("ActualFontInfo")) {
                    ContentCellModelHelper.b(a, d, b.ae);
                }
                if (b.a2("IsEdited") || b.a2("IsDeleted")) {
                    if (b.a4 || b.a1) {
                        if (b.a1) {
                            d.setRawStyleProperty("text-decoration", "line-through");
                        }
                        else {
                            d.setRawStyleProperty("text-decoration", "none");
                        }
                    }
                    else {
                        d.setRawStyleProperty("text-decoration", "none");
                    }
                }
            }
        }
        static b(a, b, c) {
            if (c == null) {
                c = FontUtil.getDefaultFont(a);
            }
            b.setRawStyleProperty("font", c.fontString);
        }
        static d(a, b) {
            let c = ContentCellModelHelper.g(b);
            a.setRawStyleProperty("color", c.colorString);
        }
    }
    ContentCellModelHelper.$t = /*@__PURE__*/ markType(ContentCellModelHelper, 'ContentCellModelHelper');
    ContentCellModelHelper.f = /*@__PURE__*/ Color.u(0, 0, 0, 0);
    return ContentCellModelHelper;
})();
