/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseEventArgsDetail } from "./BaseEventArgsDetail";
import { DisplayDensity_$type } from "./DisplayDensity";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
/**
 * @hidden
 */
export let DensityChangedEventArgsDetail = /*@__PURE__*/ (() => {
    class DensityChangedEventArgsDetail extends BaseEventArgsDetail {
        get h() {
            let ret_ = this.b.n("oldDensity");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DisplayDensity_$type, EnumUtil.getEnumValue(DisplayDensity_$type, this.b.f(DisplayDensity_$type, ret_)));
            return EnumUtil.getEnumValue(DisplayDensity_$type, ret_);
        }
        set h(a) {
            let value_ = enumGetBox(DisplayDensity_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b.v("oldDensity", value_);
        }
        get g() {
            let ret_ = this.b.n("newDensity");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DisplayDensity_$type, EnumUtil.getEnumValue(DisplayDensity_$type, this.b.f(DisplayDensity_$type, ret_)));
            return EnumUtil.getEnumValue(DisplayDensity_$type, ret_);
        }
        set g(a) {
            let value_ = enumGetBox(DisplayDensity_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b.v("newDensity", value_);
        }
    }
    DensityChangedEventArgsDetail.$t = /*@__PURE__*/ markType(DensityChangedEventArgsDetail, 'DensityChangedEventArgsDetail', BaseEventArgsDetail.$);
    return DensityChangedEventArgsDetail;
})();
