/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "igniteui-react";
import { WCNativeHelper } from "igniteui-react";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { DisplayDensity_$type } from "./DisplayDensity";
import { DensityChangedEventArgs } from "./DensityChangedEventArgs";
/**
 * @hidden
 */
export let DisplayDensityBase = /*@__PURE__*/ (() => {
    class DisplayDensityBase extends BaseElement {
        constructor() {
            super(...arguments);
            this.c = new WCNativeHelper();
            this.e = null;
            this.densityChanged = null;
        }
        get d() {
            return this.c;
        }
        get nativeElement() {
            return this.e;
        }
        set nativeElement(a) {
            this.e = a;
            this.c.o = this.e;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get b() {
            let ret_ = this.d.n("displayDensity");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DisplayDensity_$type, EnumUtil.getEnumValue(DisplayDensity_$type, this.d.f(DisplayDensity_$type, ret_)));
            return EnumUtil.getEnumValue(DisplayDensity_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(DisplayDensity_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("displayDensity", value_);
        }
        densityChangedChanged() {
            if (this.densityChanged != null) {
                this.d.r("densityChanged", (a) => this.densityChanged(this, DensityChangedEventArgs.a(a)), false);
            }
            else {
                this.d.u("densityChanged");
            }
        }
    }
    DisplayDensityBase.$t = /*@__PURE__*/ markType(DisplayDensityBase, 'DisplayDensityBase', BaseElement.$);
    return DisplayDensityBase;
})();
