/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "igniteui-react";
import { WCNativeHelper } from "igniteui-react";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { DisplayDensity_$type } from "./DisplayDensity";
import { DensityChangedEventArgs } from "./DensityChangedEventArgs";
/**
 * @hidden
 */
export let DisplayDensityBaseElement = /*@__PURE__*/ (() => {
    class DisplayDensityBaseElement extends BaseElement {
        constructor() {
            super(...arguments);
            this.c = new WCNativeHelper();
            this.e = null;
            this.onDensityChanged = null;
        }
        get d() {
            return this.c;
        }
        get nativeElement() {
            return this.e;
        }
        set nativeElement(a) {
            this.e = a;
            this.c.o = this.e;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get b() {
            let ret_ = this.d.n("displayDensity");
            ret_ = enumGetBox(DisplayDensity_$type, EnumUtil.getEnumValue(DisplayDensity_$type, EnumUtil.parse(DisplayDensity_$type, ret_.toString(), true)));
            return EnumUtil.getEnumValue(DisplayDensity_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(DisplayDensity_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("displayDensity", value_);
        }
        onDensityChangedChanged() {
            if (this.onDensityChanged != null) {
                this.d.r("onDensityChanged", (a) => this.onDensityChanged(this, DensityChangedEventArgs.a(a)), false);
            }
            else {
                this.d.u("onDensityChanged");
            }
        }
    }
    DisplayDensityBaseElement.$t = /*@__PURE__*/ markType(DisplayDensityBaseElement, 'DisplayDensityBaseElement', BaseElement.$);
    return DisplayDensityBaseElement;
})();
