/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { ComparisonOperatorSelector } from "./ComparisonOperatorSelector";
import { XIcon } from "igniteui-react-inputs";
import { DataSourceSchemaPropertyType_$type } from "igniteui-react-core";
import { EditorType_$type } from "./EditorType";
import { Base, runOn, delegateCombine, typeCast, delegateRemove, enumGetBox, markType } from "igniteui-react-core";
import { TextEditorView } from "./TextEditorView";
import { NumericEditorView } from "./NumericEditorView";
import { DateEditorView } from "./DateEditorView";
import { ColumnComparisonConditionOperatorType_$type } from "./ColumnComparisonConditionOperatorType";
import { ColumnComparisonFilterCondition } from "./ColumnComparisonFilterCondition";
import { ColumnCustomFilterCondition } from "./ColumnCustomFilterCondition";
import { tryParseNumber } from "igniteui-react-core";
/**
 * @hidden
 */
export let FilterCell = /*@__PURE__*/ (() => {
    class FilterCell extends GridCellBase {
        constructor(a) {
            super(a);
            this.c4 = null;
            this.c6 = null;
            this.c2 = null;
            this.c3 = null;
            this.c5 = null;
            this.cv = null;
            this.cu = null;
            this.ct = null;
            this.ck = null;
            this.cw = null;
            this.cr = null;
            this.cz = true;
            this.cl = 0;
            this.c0 = true;
            this.cp = null;
            this.cx = null;
            this.c7 = null;
            this.ch = null;
            this.d6 = null;
            this.c4 = a.createElement("div");
            this.c4.setStyleProperty("display", "flex");
            this.c4.setStyleProperty("flex-direction", "row");
            this.c4.setStyleProperty("align-items", "center");
            this.c4.setStyleProperty("height", "100%");
            this.ae.append(this.c4);
            this.c6 = a.createElement("div");
            this.c2 = a.getSubRenderer(this.c6);
            this.ck = new ComparisonOperatorSelector();
            this.ck.ej(this.c2);
            this.c6.setStyleProperty("width", "24px");
            this.c6.setStyleProperty("height", "24px");
            this.c4.append(this.c6);
            this.c3 = a.createElement("div");
            this.c3.setStyleProperty("display", "flex");
            this.c3.setStyleProperty("flex", "1");
            this.c3.setStyleProperty("margin", "0 4px");
            this.c4.append(this.c3);
            this.c5 = a.createElement("div");
            this.c5.setStyleProperty("transform", "scale(0.75)");
            this.cw = new XIcon();
            this.cw.provideContainer(a.getSubRenderer(this.c5));
            this.c4.append(this.c5);
            this.dp();
        }
        cs(a) {
            switch (this.cm) {
                case 0:
                case 1:
                    if (this.cv == null) {
                        this.cv = new TextEditorView(this.ab, this.f.getTheme(), this.b);
                    }
                    return this.cv;
                case 2:
                    if (this.cu == null) {
                        this.cu = new NumericEditorView(this.ab, this.f.getTheme(), this.b);
                    }
                    return this.cu;
                case 3:
                    if (this.ct == null) {
                        this.ct = new DateEditorView(this.ab, this.f.getTheme(), this.b);
                    }
                    return this.ct;
                default: return null;
            }
        }
        d1() {
            this.c3.removeChildren();
        }
        dm() {
            this.c3.append(this.cr.container);
        }
        du() {
            if (this.ae.getChildCount() == 0) {
                this.ae.append(this.c4);
            }
        }
        ds() {
            if (this.ae.getChildCount() > 0) {
                this.ae.removeChildren();
            }
        }
        bp(a, b, c) {
            super.bp(a, b, c);
            this.d0(a, b, c);
        }
        bo() {
            this.dy();
        }
        d2(a, b, c, d) {
            if (this.d != null) {
                let e = this.c6.getNativeElement();
                this.d.update("SelectorTop", (e.offsetTop));
                this.d.update("SelectorLeft", (e.offsetLeft));
                let f = this.c3.getNativeElement();
                this.d.update("EditorTop", (f.offsetTop));
                this.d.update("EditorLeft", (f.offsetLeft));
                let g = this.c5.getNativeElement();
                this.d.update("ClearIconTop", (g.offsetTop));
                this.d.update("ClearIconLeft", (g.offsetLeft));
            }
        }
        dp() {
            let a = this.ck;
            a.valueChanged = delegateCombine(a.valueChanged, runOn(this, this.dz));
            this.cw.svgPath = FilterCell.c9;
            this.d4(false);
            let b = this.cw;
            b.clicked = delegateCombine(b.clicked, runOn(this, this.dn));
        }
        dy() {
            if (this.cr == null) {
                this.dt();
            }
        }
        cn() {
            let a = 1;
            switch (this.cj) {
                case 11:
                case 2:
                case 0:
                    a = 1;
                    break;
                case 8:
                    a = 3;
                    break;
                case 10:
                case 6:
                case 5:
                case 1:
                case 3:
                case 4:
                case 7:
                    a = 2;
                    break;
            }
            switch (this.ck.b) {
                case 6:
                case 8:
                case 7:
                case 9:
                    a = 2;
                    break;
                case 38:
                    a = 1;
                    break;
                case 39:
                    a = 2;
                    break;
            }
            if (this.ck.b == 44) {
                if (this.cq != null && this.cq.count > 0) {
                    let b = this.cq._inner[this.ck.x];
                    switch (b.b) {
                        case 0:
                        case 1:
                            a = 1;
                            break;
                        case 2:
                            a = 2;
                            break;
                        case 3:
                            a = 3;
                            break;
                    }
                }
            }
            return a;
        }
        d4(a) {
            if (this.cw != null) {
                this.cw.disabled = !a;
                this.cw.ai = a ? 1 : 0.3;
            }
        }
        di(a) {
            if (!this.cz) {
                return;
            }
            if (this.ck.b == 44) {
                if (this.cq != null && this.cq.count > 0) {
                    this.b.applyCustomFilter(this.ck.ae, this.ck.x, a);
                }
            }
            else {
                this.b.applyFilter(this.ck.b, a);
            }
        }
        dj() {
            if (!this.cz) {
                return;
            }
            if (this.b != null) {
                this.b.clearFilter();
            }
        }
        d0(a, b, c) {
            switch (a) {
                case "DataType":
                    this.dr();
                    break;
                case "EditorType":
                    this.dt();
                    break;
                case "FontInfo":
                    this.dx();
                    break;
                case "Filter":
                    this.dv();
                    break;
                case "FilterOperands":
                    this.dq();
                    break;
                case "FilterValue":
                    this.dw();
                    break;
                case "IsEditorEnabled":
                    this.cr.isEnabled = this.c1;
                    break;
                case "TextColor":
                    this.ck.eq = this.d7;
                    this.cw.fill = this.d7;
                    this.cr.textColor = this.d7;
                    break;
            }
        }
        dv() {
            this.cz = false;
            if (this.cr != null) {
                if (this.ci != null) {
                    if (typeCast(ColumnComparisonFilterCondition.$, this.ci) !== null) {
                        let a = typeCast(ColumnComparisonFilterCondition.$, this.ci);
                        this.ck.b = a.operator;
                        let b = this.cr.getEditorValue();
                        if (b != null) {
                            if (!Base.equalsStatic(b, a.value)) {
                                this.cr.value = a.value;
                                this.c8 = a.value;
                            }
                        }
                        else {
                            this.cr.value = a.value;
                            this.c8 = a.value;
                        }
                    }
                    else if (typeCast(ColumnCustomFilterCondition.$, this.ci) !== null) {
                        let c = typeCast(ColumnCustomFilterCondition.$, this.ci);
                        this.ck.ek(c.id, c.index);
                        let d = this.cr.getEditorValue();
                        if (d != null) {
                            if (!Base.equalsStatic(d, c.value)) {
                                this.cr.value = c.value;
                                this.c8 = c.value;
                            }
                        }
                        else {
                            this.cr.value = c.value;
                            this.c8 = c.value;
                        }
                    }
                    else if (!(typeCast(ColumnCustomFilterCondition.$, this.ci) !== null)) {
                        this.c8 = null;
                        this.cr.value = this.c8;
                        this.cr.setEditorValue(this.c8);
                    }
                }
                else {
                    this.c8 = null;
                    this.cr.value = this.c8;
                    this.cr.setEditorValue(this.c8);
                    if (!this.c1) {
                        this.ck.b = 0;
                    }
                }
            }
            this.cz = true;
        }
        dq() {
            this.ck.d7();
            for (let a = 0; a < this.cq.count; a++) {
                this.ck.d1(this.cq._inner[a].e, this.cq._inner[a].f, this.cq._inner[a].g, a);
            }
        }
        dr() {
            if (this.cj == 11) {
                this.c1 = false;
            }
            this.cm = this.cn();
        }
        dw() {
            this.d4(this.c8 != null);
            if (this.c8 == null || Base.equalsStatic(this.c8, "")) {
                this.dj();
            }
            else {
                this.di(this.c8);
            }
            if (this.d != null) {
                this.d.update("FilterValue", this.c8);
            }
        }
        dt() {
            if (this.cr != null) {
                this.cr.detachEvents();
                let a = this.cr;
                a.valueProvided = delegateRemove(a.valueProvided, runOn(this, this.d3));
            }
            this.d1();
            this.cr = this.cs(this.cm);
            this.cr.onEditStarted();
            if (this.cr != null) {
                this.cr.attachEvents();
                this.cr.setFont(this.cy);
                this.cr.isEnabled = this.c1;
                this.cr.focusOnValueChanged = false;
                this.cr.showClearButton = false;
                let b = this.cr;
                b.valueProvided = delegateCombine(b.valueProvided, runOn(this, this.d3));
                this.dm();
            }
            this.dn(null, null);
        }
        dx() {
            if (this.cy != null) {
                if (this.cr != null) {
                    this.cr.setFont(this.cy);
                }
            }
        }
        dz(a, b) {
            this.cm = this.cn();
            switch (b.newValue) {
                case 40:
                case 11:
                case 43:
                case 42:
                case 26:
                case 29:
                case 23:
                case 32:
                case 24:
                case 27:
                case 21:
                case 30:
                case 25:
                case 28:
                case 22:
                case 31:
                case 41:
                case 34:
                case 35:
                case 36:
                case 37:
                case 18:
                case 19:
                case 10:
                case 33:
                case 20:
                    this.c1 = false;
                    break;
                default:
                    this.c1 = true;
                    break;
            }
            if (this.cj == 11) {
                this.c1 = false;
            }
            if (b.newValue == 44) {
                if (this.cq != null && this.cq.count > 0) {
                    let c = this.cq._inner[this.ck.x];
                    this.c1 = c.d;
                }
            }
            if (!this.c1) {
                this.di(null);
                this.d4(true);
            }
            else if (this.c8 != null && !Base.equalsStatic(this.c8, "")) {
                this.di(this.c8);
            }
            else {
                this.dj();
                this.d4(false);
            }
            if (this.d != null) {
                this.d.update("OperatorType", enumGetBox(ColumnComparisonConditionOperatorType_$type, this.ck.b));
            }
        }
        dn(a, b) {
            if (b != null) {
                if (!this.c1) {
                    this.ck.b = 0;
                    this.dj();
                }
            }
            this.c8 = null;
            if (this.cr != null) {
                this.cr.setEditorValue(null);
                this.cr.value = null;
            }
        }
        d3(a, b, c) {
            if (this.cm == 2) {
                if (typeof b === 'string') {
                    let d;
                    if (((() => { let e = tryParseNumber(b, d); d = e.p1; return e.ret; })())) {
                        b = d;
                    }
                }
            }
            this.c8 = b;
        }
        d5(a, b, c, d) {
            this.d2(a, b, c, d);
        }
        co(a, b) {
            if (a != null) {
                for (let c = 0; c < this.cq.count; c++) {
                    if (this.cq._inner[c].g == a) {
                        return this.cq._inner[c];
                    }
                }
            }
            if (b >= 0 && b < this.cq.count) {
                return this.cq._inner[b];
            }
            return null;
        }
        dl() {
            this.du();
        }
        dk() {
            this.ds();
        }
        get cj() {
            return this.ck.d;
        }
        set cj(a) {
            let b = this.ck.d;
            this.ck.d = a;
            if (b != a) {
                this.bp("DataType", enumGetBox(DataSourceSchemaPropertyType_$type, b), enumGetBox(DataSourceSchemaPropertyType_$type, this.ck.d));
            }
        }
        get cm() {
            return this.cl;
        }
        set cm(a) {
            let b = this.cl;
            this.cl = a;
            if (b != a) {
                this.bp("EditorType", enumGetBox(EditorType_$type, b), enumGetBox(EditorType_$type, this.cl));
            }
        }
        get c1() {
            return this.c0;
        }
        set c1(a) {
            let b = this.c0;
            this.c0 = a;
            if (b != this.c0) {
                this.bp("IsEditorEnabled", b, this.c0);
            }
        }
        get cq() {
            return this.cp;
        }
        set cq(a) {
            let b = this.cp;
            this.cp = a;
            if (this.cp != null) {
                this.bp("FilterOperands", b, this.cp);
            }
        }
        get cy() {
            return this.cx;
        }
        set cy(a) {
            let b = this.cx;
            this.cx = a;
            if (b != this.cx) {
                this.bp("FontInfo", b, this.cx);
            }
        }
        get c8() {
            return this.c7;
        }
        set c8(a) {
            let b = this.c7;
            this.c7 = a;
            if (b != this.c7) {
                this.bp("FilterValue", b, this.c7);
            }
        }
        get ci() {
            return this.ch;
        }
        set ci(a) {
            let b = this.ch;
            this.ch = a;
            if (b != a) {
                this.bp("Filter", b, this.ch);
            }
        }
        get d7() {
            return this.d6;
        }
        set d7(a) {
            let b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.bp("TextColor", b, this.d6);
            }
        }
    }
    FilterCell.$t = /*@__PURE__*/ markType(FilterCell, 'FilterCell', GridCellBase.$);
    FilterCell.c9 = "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z";
    return FilterCell;
})();
