/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CellModelExport } from "./CellModelExport";
import { DataSourceSchemaPropertyType_$type } from "igniteui-react-core";
import { ColumnComparisonConditionOperatorType_$type } from "./ColumnComparisonConditionOperatorType";
import { enumGetBox, markType } from "igniteui-react-core";
/**
 * @hidden
 */
export let FilterCellModelExport = /*@__PURE__*/ (() => {
    class FilterCellModelExport extends CellModelExport {
        constructor() {
            super(...arguments);
            this.af = 0;
            this.ag = false;
            this.ae = 0;
            this.an = null;
            this.am = 0;
            this.al = 0;
            this.ak = 0;
            this.aj = 0;
            this.ai = 0;
            this.ah = 0;
        }
        get_ac() {
            return "FilterCell";
        }
        ad(a) {
            super.ad(a);
            a.l("dataType: '" + enumGetBox(DataSourceSchemaPropertyType_$type, this.af) + "', ");
            a.l("isEnabled: " + this.ag.toString().toLowerCase() + ", ");
            a.l("filterValue: '" + this.an + "', ");
            a.l("operatorType: '" + enumGetBox(ColumnComparisonConditionOperatorType_$type, this.ae) + "', ");
            a.l("selectorTop: '" + this.am + "', ");
            a.l("selectorLeft: '" + this.al + "', ");
            a.l("editorTop: '" + this.ak + "', ");
            a.l("editorLeft: '" + this.aj + "', ");
            a.l("clearIconTop: '" + this.ai + "', ");
            a.l("clearIconLeft: '" + this.ah + "', ");
        }
    }
    FilterCellModelExport.$t = /*@__PURE__*/ markType(FilterCellModelExport, 'FilterCellModelExport', CellModelExport.$);
    return FilterCellModelExport;
})();
