/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-react-core";
/**
 * Indicates how filters will treat case sensitivity.
 */
export var FilterComparisonType = /*@__PURE__*/ (function (FilterComparisonType) {
    /**
     * The default case sensitivity. Default is CaseInsensitive.
     */
    FilterComparisonType[FilterComparisonType["Default"] = 0] = "Default";
    /**
     * Filtering is performed without case sensitivity.
     */
    FilterComparisonType[FilterComparisonType["CaseInsensitive"] = 1] = "CaseInsensitive";
    /**
     * Filtering is performed with case sensitivity.
     */
    FilterComparisonType[FilterComparisonType["CaseSensitive"] = 2] = "CaseSensitive";
    return FilterComparisonType;
})({});
/**
 * @hidden
 */
export let FilterComparisonType_$type = /*@__PURE__*/ markEnum('FilterComparisonType', 'Default,0|CaseInsensitive,1|CaseSensitive,2');
