/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { FilteringExpressionsTreeOrFilteringExpression } from "./FilteringExpressionsTreeOrFilteringExpression";
import { FilteringLogic_$type } from "./FilteringLogic";
import { FilteringExpressionsTreeType_$type } from "./FilteringExpressionsTreeType";
/**
 * @hidden
 */
export let FilteringExpressionsTreeDetail = /*@__PURE__*/ (() => {
    class FilteringExpressionsTreeDetail extends Base {
        constructor() {
            super(...arguments);
            this.e = new WCNativeHelper();
            this.i = null;
        }
        get f() {
            return this.e;
        }
        get nativeElement() {
            return this.i;
        }
        set nativeElement(a) {
            this.i = a;
            this.e.o = this.i;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.f.n("filteringOperands");
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.f.v("filteringOperands", value_);
        }
        get d() {
            let ret_ = this.f.n("operator");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilteringLogic_$type, EnumUtil.getEnumValue(FilteringLogic_$type, this.f.f(FilteringLogic_$type, ret_)));
            return EnumUtil.getEnumValue(FilteringLogic_$type, ret_);
        }
        set d(a) {
            let value_ = enumGetBox(FilteringLogic_$type, a);
            value_ = this.f.f(FilteringLogic_$type, value_);
            this.f.v("operator", value_);
        }
        get k() {
            let ret_ = this.f.n("fieldName");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.f.v("fieldName", value_);
        }
        get c() {
            let ret_ = this.f.n("type");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilteringExpressionsTreeType_$type, EnumUtil.getEnumValue(FilteringExpressionsTreeType_$type, this.f.f(FilteringExpressionsTreeType_$type, ret_)));
            return EnumUtil.getEnumValue(FilteringExpressionsTreeType_$type, ret_);
        }
        set c(a) {
            let value_ = enumGetBox(FilteringExpressionsTreeType_$type, a);
            value_ = this.f.f(FilteringExpressionsTreeType_$type, value_);
            this.f.v("type", value_);
        }
        g(a) {
            return (this.nativeElement.empty(this.f.i(a)));
        }
        b(a) {
            return this.f.g(this.nativeElement.find(this.f.i(a)), (b) => new FilteringExpressionsTreeOrFilteringExpression());
        }
        h(a) {
            return (this.nativeElement.findIndex(this.f.i(a)));
        }
    }
    FilteringExpressionsTreeDetail.$t = /*@__PURE__*/ markType(FilteringExpressionsTreeDetail, 'FilteringExpressionsTreeDetail');
    return FilteringExpressionsTreeDetail;
})();
