/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType, PointUtil } from "igniteui-react-core";
import { INativeCell_$type } from "./INativeCell";
import { GridExpansionIndicator } from "./GridExpansionIndicator";
import { PlaceholderView } from "./PlaceholderView";
import { Color } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { Random } from "igniteui-react-core";
import { intDivide, truncate, isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let GridCellBase = /*@__PURE__*/ (() => {
    class GridCellBase extends Base {
        get b() {
            return this.a;
        }
        get f() {
            return this.e;
        }
        get d() {
            return this.c;
        }
        get ab() {
            return this.aa;
        }
        get ae() {
            return this.ac;
        }
        get isRemoved() {
            return this.p;
        }
        set isRemoved(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.bp("IsRemoved", b, this.p);
            }
        }
        get a2() {
            return this.ap;
        }
        get a0() {
            return this.an;
        }
        get a1() {
            return this.ao;
        }
        get a3() {
            return this.as;
        }
        set a3(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.bp("Indent", b, this.as);
            }
        }
        get s() {
            return this.m;
        }
        set s(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.bp("IsCollapsable", b, this.m);
            }
        }
        get t() {
            return this.n;
        }
        set t(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.bp("IsExpanded", b, this.n);
            }
        }
        get v() {
            return this.o;
        }
        set v(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.bp("IsHitTestVisible", b, this.o);
            }
        }
        constructor(a) {
            super();
            this.a = null;
            this.e = null;
            this.c = null;
            this.aa = null;
            this.ac = null;
            this.p = false;
            this.ad = null;
            this.i = null;
            this.ap = 0;
            this.am = 24;
            this.ao = 0;
            this.an = 0;
            this.as = 0;
            this.m = false;
            this.n = false;
            this.o = true;
            this.k = false;
            this.au = 0;
            this.aw = 0;
            this.av = 0;
            this.at = 0;
            this.ah = 0;
            this.aj = 0;
            this.ai = 0;
            this.ag = 0;
            this.cg = null;
            this.aq = 0;
            this.az = 0;
            this.ar = 0;
            this.j = null;
            this.g = 0;
            this.h = 0;
            this.z = 0;
            this.y = 0;
            this.q = false;
            this.a5 = 0;
            this.a6 = 0;
            this.af = 0;
            this.ay = -1;
            this.ak = 0;
            this.l = false;
            this.aa = a;
            this.ac = this.aa.createElement("div");
            this.ac.setAttribute("tabindex", "-1");
            this.ac.setRawStyleProperty("position", "absolute");
            this.ac.setRawStyleProperty("overflow", "hidden");
            this.ac.setRawStyleProperty("box-sizing", "border-box");
            this.ac.setRawStyleProperty("outline", "none");
            let b = (window.navigator.msPointerEnabled && window.MSGesture !== undefined);
            let c = (window.PointerEvent !== undefined);
            let d = (window.TouchEvent);
            if ((b || c)) {
                this.ac.listen("pointerdown", runOn(this, this.bq));
                this.ac.listen("pointerup", runOn(this, this.bu));
                this.ac.listen("pointermove", runOn(this, this.bt));
                this.ac.listen("pointerleave", runOn(this, this.bs));
                this.ac.listen("pointerenter", runOn(this, this.br));
            }
            else {
                this.ac.listen("mousedown", runOn(this, this.bg));
                this.ac.listen("mouseup", runOn(this, this.bk));
                this.ac.listen("mousemove", runOn(this, this.bj));
                this.ac.listen("mouseleave", runOn(this, this.bi));
                this.ac.listen("touchstart", runOn(this, this.b8));
                this.ac.listen("touchend", runOn(this, this.ca));
                this.ac.listen("touchmove", runOn(this, this.b9));
            }
        }
        bf() {
            this.ao = 10;
            this.an = this.a3 * 24;
            this.ap = 24;
            if (this.ad == null) {
                this.ad = this.aa.createElement("div");
                this.ad.setRawStyleProperty("display", "inline-block");
                this.ad.setRawStyleProperty("vertical-align", "middle");
                this.ad.setRawStyleProperty("width", this.ap + "px");
                this.ad.setRawStyleProperty("height", this.ap + "px");
                this.ad.setRawStyleProperty("cursor", "pointer");
                this.ad.setRawStyleProperty("position", "absolute");
                this.ad.setRawXPosition(this.au + this.an);
                this.ad.setRawYPosition(intDivide(this.aq, 2) - intDivide(this.am, 2));
            }
            if (this.i == null) {
                let a = this.aa.getSubRenderer(this.ad);
                this.i = new GridExpansionIndicator();
                this.i.ab(a);
                this.i.y(24, 24);
            }
            if (this.ad.parent() == null) {
                this.ac.append(this.ad);
            }
        }
        bv() {
            this.ap = 0;
            this.ao = 0;
            if (this.ad != null) {
                if (this.ad.parent() != null) {
                    this.ad.remove();
                }
            }
        }
        get r() {
            return this.k;
        }
        set r(a) {
            this.k = a;
        }
        get_w() {
            return false;
        }
        get w() {
            return this.get_w();
        }
        b4(a, b, c, d) {
            this.au = a;
            this.aw = b;
            this.av = c;
            this.at = d;
            this.ac.setRawStyleProperty("padding-left", a.toString() + "px");
            this.ac.setRawStyleProperty("padding-top", b.toString() + "px");
            this.ac.setRawStyleProperty("padding-right", c.toString() + "px");
            this.ac.setRawStyleProperty("padding-bottom", d.toString() + "px");
        }
        by(a, b, c, d, e) {
            this.ah = b;
            this.aj = c;
            this.ai = d;
            this.ag = e;
            this.cg = a;
            if (a == null) {
                this.ac.setRawStyleProperty("border", "");
            }
            else {
                this.ac.setRawStyleProperty("border-color", a._fill);
                this.ac.setRawStyleProperty("border-left-width", b.toString() + "px");
                this.ac.setRawStyleProperty("border-top-width", c.toString() + "px");
                this.ac.setRawStyleProperty("border-right-width", d.toString() + "px");
                this.ac.setRawStyleProperty("border-bottom-width", e.toString() + "px");
                this.ac.setRawStyleProperty("border-style", "solid");
            }
        }
        get_u() {
            return false;
        }
        get u() {
            return this.get_u();
        }
        b0(a, b) {
            if (this.aq != a || this.ar != b) {
                let c = this.aq;
                this.aq = a;
                this.ar = b;
                let d = Math.max(0, this.aq - this.ar);
                this.ac.setRawStyleProperty("height", a.toString() + "px");
                this.ac.setRawStyleProperty("line-height", d.toString() + "px");
                if (this.ad != null) {
                    this.ad.setRawYPosition(intDivide(this.aq, 2) - intDivide(this.ap, 2));
                }
                this.b7(this.az, this.aq, this.az, c);
            }
        }
        b6(a, b) {
            if (this.az != a) {
                let c = this.az;
                this.az = a;
                this.ac.setRawStyleProperty("width", a.toString() + "px");
                this.b7(this.az, this.aq, c, this.aq);
            }
        }
        b7(a, b, c, d) {
        }
        bd() {
            if (!this.w) {
                return;
            }
            this.k = true;
            this.j = new PlaceholderView(this.aa);
            this.g = 0;
            this.h = 1;
            this.j.l = Color.u(120, 120, 120, 120);
            this.j.i = 0;
            this.ac.append(this.j.g);
        }
        bx(a) {
            this.ac.setRawStyleProperty("background-color", a.colorString);
        }
        b3(a) {
            this.ac.setRawStyleProperty("opacity", a.toString());
        }
        cf(a) {
            if (!this.w) {
                return;
            }
            this.j.i = (a * 0.20000000298023224);
        }
        cd(a, b, c, d) {
            if (this.j != null) {
                let e = this.z;
                let f = this.y;
                if (this.h == 1) {
                    b = truncate((b + (d / 2) - (f / 2)));
                }
                else if (this.h == 2) {
                    b = truncate((b + (d) - (f)));
                }
                if (this.g == 1) {
                    a = truncate((a + (c / 2) - (e / 2)));
                }
                else if (this.g == 2) {
                    a = truncate((a + (c) - (e)));
                }
                this.j.g.setRawXPosition(a);
                this.j.g.setRawYPosition(b);
            }
        }
        bn(a, b, c) {
        }
        ce(a) {
            if (!this.w) {
                return;
            }
            let b = DeviceUtils.f(12);
            if (a.ag != null && !isNaN_(a.ag.e)) {
                b = a.ag.e;
            }
            if (this.y != b) {
                this.y = b;
                this.j.d = (b);
            }
            let c = a.gu * 0.2;
            let d = a.fc * 0.6;
            if (this.z >= c && this.z <= d && !this.q) {
                return;
            }
            this.q = false;
            let e = (GridCellBase.a4.nextDouble() * (d - c) + c);
            if (this.z != e) {
                this.z = e;
                this.j.e = e;
            }
            this.cd(this.au + this.an + this.ap, this.aw, this.az - (this.au + this.av), this.aq - (this.aw + this.at));
        }
        cb(a, b) {
            if (!this.w) {
                return;
            }
            this.g = a;
            this.h = b;
            this.q = true;
        }
        cc(a) {
            if (!this.w) {
                return;
            }
            if (a != null) {
                this.j.l = a.color;
            }
        }
        bw(a) {
            this.a = a;
        }
        b2(a) {
            this.e = a;
        }
        bz(a) {
            this.c = a;
        }
        b1(a, b) {
            switch (b) {
                case 0:
                    this.ae.setRawStyleProperty("text-align", "left");
                    break;
                case 1:
                    this.ae.setRawStyleProperty("text-align", "center");
                    break;
                case 2:
                    this.ae.setRawStyleProperty("text-align", "right");
                    break;
                case 3:
                    this.ae.setRawStyleProperty("text-align", "center");
                    break;
            }
        }
        b5(a, b) {
            switch (b) {
                case 0:
                    a.setRawStyleProperty("vertical-align", "top");
                    break;
                case 1:
                    a.setRawStyleProperty("vertical-align", "center");
                    break;
                case 2:
                    a.setRawStyleProperty("vertical-align", "bottom");
                    break;
                case 3:
                    a.setRawStyleProperty("vertical-align", "center");
                    break;
            }
        }
        x(a) {
            return a.isClickActionDesired;
        }
        bg(a) {
            this.onContactStarted(a, false);
        }
        bk(a) {
            this.onContactCompleted(a, false);
        }
        bj(a) {
            this.onContactMoved(a, false);
        }
        bi(a) {
            this.bm(a, false);
        }
        bh(a) {
            this.bl(a, false);
        }
        bq(e_) {
            let a = (e_.originalEvent.pointerType);
            if (a == "touch") {
                this.b8(e_);
            }
            else {
                this.bg(e_);
            }
        }
        bt(e_) {
            let a = (e_.originalEvent.pointerType);
            if (a == "touch") {
                this.b9(e_);
            }
            else {
                this.bj(e_);
            }
        }
        bu(e_) {
            let a = (e_.originalEvent.pointerType);
            if (a == "touch") {
                this.ca(e_);
            }
            else {
                this.bk(e_);
            }
        }
        bs(e_) {
            let a = (e_.originalEvent.pointerType);
            if (a != "touch") {
                this.bi(e_);
            }
        }
        br(e_) {
            let a = (e_.originalEvent.pointerType);
            if (a != "touch") {
                this.bh(e_);
            }
        }
        b8(a) {
            this.onContactStarted(a, true);
        }
        b9(a) {
            this.onContactMoved(a, true);
        }
        ca(a) {
            this.onContactCompleted(a, true);
        }
        onContactStarted(e_, a) {
            let b = false;
            if (this.s) {
                let indicator_ = this.i.q();
                b = (e_.originalEvent.srcElement === indicator_ || e_.originalEvent.target === indicator_);
            }
            this.l = false;
            if (b) {
                this.l = true;
            }
            else {
                if (this.a != null && this.x(this.a)) {
                    this.a5 = e_.pageX;
                    this.a6 = e_.pageY;
                    if (this.ay != e_.which) {
                        this.ak = 0;
                    }
                    this.ay = e_.which;
                    this.a.mouseDownCell(this.a5, this.a6);
                }
            }
        }
        onContactMoved(a, b) {
            if (this.a != null) {
                let c = a.pageX;
                let d = a.pageY;
                if (this.x(this.a)) {
                    if (this.a.isMouseDown) {
                        if (b) {
                            if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > GridCellBase.ax || Math.abs(d - this.a.mousePosition.y) > GridCellBase.ax) {
                                this.a.mouseUpCell(c, d);
                            }
                            else {
                                a.stopPropagation();
                            }
                        }
                        else {
                            if (PointUtil.equals(this.a.mousePosition, null)) {
                                this.a.mouseUpCell(c, d);
                            }
                            else if (this.ay == 1) {
                                if (Math.abs(c - this.a.mousePosition.x) > GridCellBase.al || Math.abs(d - this.a.mousePosition.y) > GridCellBase.al) {
                                    this.a.isControlPressed = a.ctrlKey;
                                    this.a.dragStarted();
                                }
                            }
                        }
                    }
                }
                if (this.a.isHoverActionDesired) {
                    this.a.mouseIsOver(c, d);
                }
            }
        }
        onContactCompleted(e_, a) {
            this.ak++;
            window.setTimeout(() => this.ak = 0, 250);
            let b = false;
            if (this.s) {
                let indicator_ = this.i.q();
                b = (e_.originalEvent.srcElement === indicator_ || e_.originalEvent.target === indicator_);
            }
            if (this.l && b) {
                this.b.clickExpansionIndicator();
            }
            else {
                if (this.a != null && this.x(this.a)) {
                    let c = e_.pageX;
                    let d = e_.pageY;
                    if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > GridCellBase.ax || Math.abs(d - this.a.mousePosition.y) > GridCellBase.ax || this.a.isDrag) {
                        this.a.mouseUpCell(c, d);
                    }
                    if (this.a.isCellDown()) {
                        this.a.isControlPressed = e_.ctrlKey;
                        this.a.isShiftPressed = e_.shiftKey;
                        if (this.ak > 1) {
                            switch (this.ay) {
                                case 1:
                                    this.a.doubleClicked(0);
                                    break;
                                case 2:
                                    this.a.doubleClicked(1);
                                    break;
                                case 3:
                                    this.a.doubleClicked(2);
                                    break;
                                default:
                                    this.a.doubleClicked(3);
                                    break;
                            }
                        }
                        else {
                            switch (e_.which) {
                                case 1:
                                    this.a.clickCell(0);
                                    break;
                                case 2:
                                    this.a.clickCell(1);
                                    break;
                                case 3:
                                    this.a.clickCell(2);
                                    break;
                                default:
                                    this.a.clickCell(3);
                                    break;
                            }
                        }
                        this.a.mouseUpCell(e_.pageX, e_.pageY);
                    }
                }
            }
            this.l = false;
        }
        bm(a, b) {
            if (this.a != null && this.a.isLeaveActionDesired) {
                let c = a.pageX;
                let d = a.pageY;
                this.a.mouseLeaveCell(c, d);
            }
        }
        bl(a, b) {
            if (this.a != null && this.a.isEnterActionDesired) {
                let c = a.pageX;
                let d = a.pageY;
                this.a.mouseEnterCell(c, d);
            }
        }
        onDoubleClick(a) {
        }
        bp(a, b, c) {
            switch (a) {
                case "Indent":
                    this.an = this.a3 * 24;
                    this.ao = this.a3 > 0 ? 10 : 0;
                    if (this.ad != null) {
                        this.ad.setRawXPosition(this.au + this.an);
                        this.ad.setRawYPosition(intDivide(this.aq, 2) - intDivide(this.am, 2));
                    }
                    break;
                case "IsCollapsable":
                    if (this.s) {
                        this.bf();
                    }
                    else {
                        this.bv();
                    }
                    break;
                case "IsExpanded":
                    if (this.i != null) {
                        this.i.g = this.t;
                    }
                    break;
                case "IsHitTestVisible":
                    this.ae.setRawStyleProperty("pointer-events", this.v ? "auto" : "none");
                    break;
            }
        }
        bo() {
        }
        be() {
            this.ac.focus(true);
        }
        bc() {
            if (this.a != null) {
                let a = this.ac.clone();
                this.a.passCellClone(a);
            }
        }
        detach() {
        }
    }
    GridCellBase.$t = /*@__PURE__*/ markType(GridCellBase, 'GridCellBase', Base.$, [INativeCell_$type]);
    GridCellBase.a4 = /*@__PURE__*/ new Random(0);
    GridCellBase.ax = 10;
    GridCellBase.al = 3;
    return GridCellBase;
})();
