/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridColumnOptionsSectionBase } from "./GridColumnOptionsSectionBase";
import { StringComparer } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
/**
 * @hidden
 */
export let GridColumnOptionsSimpleSectionBase = /*@__PURE__*/ (() => {
    class GridColumnOptionsSimpleSectionBase extends GridColumnOptionsSectionBase {
        constructor() {
            super();
            this.bx = null;
            this.bv = true;
        }
        get by() {
            if (null == this.bx) {
                return this.b0;
            }
            return this.bx;
        }
        set by(a) {
            let b = this.by;
            if (0 == StringComparer.b.compare(a, b)) {
                return;
            }
            this.bx = a;
            this.bc("Caption", b, this.bx);
        }
        get bw() {
            return this.bv;
        }
        set bw(a) {
            let b = this.bw;
            if (a == b) {
                return;
            }
            this.bv = a;
            this.bc("ShowCaption", b, this.bv);
        }
        be(a, b, c) {
            super.be(a, b, c);
            switch (a) {
                case "ShowCaption":
                case "Caption":
                    this.e.m();
                    break;
            }
        }
    }
    GridColumnOptionsSimpleSectionBase.$t = /*@__PURE__*/ markType(GridColumnOptionsSimpleSectionBase, 'GridColumnOptionsSimpleSectionBase', GridColumnOptionsSectionBase.$);
    return GridColumnOptionsSimpleSectionBase;
})();
