/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-react-core";
/**
 * Enumerates the different display modes a group header can use.
 */
export var GroupHeaderDisplayMode = /*@__PURE__*/ (function (GroupHeaderDisplayMode) {
    /**
     * Each group is preceded by a single section header that combines multiple groups into one.
     */
    GroupHeaderDisplayMode[GroupHeaderDisplayMode["Combined"] = 0] = "Combined";
    /**
     * Each group may be preceded by multiple section headers, one for each group.
     */
    GroupHeaderDisplayMode[GroupHeaderDisplayMode["Split"] = 1] = "Split";
    return GroupHeaderDisplayMode;
})({});
/**
 * @hidden
 */
export let GroupHeaderDisplayMode_$type = /*@__PURE__*/ markEnum('GroupHeaderDisplayMode', 'Combined,0|Split,1');
