/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-react-core";
/**
 * Indicates how the grid should merge cells.
 */
export var MergedCellEvaluationCriteria = /*@__PURE__*/ (function (MergedCellEvaluationCriteria) {
    /**
     * Defaults to RawValue
     */
    MergedCellEvaluationCriteria[MergedCellEvaluationCriteria["Default"] = 0] = "Default";
    /**
     * Merge cells from adjacent rows when the raw values from the cells are the same.
     */
    MergedCellEvaluationCriteria[MergedCellEvaluationCriteria["RawValue"] = 1] = "RawValue";
    /**
     * Merge cells from adjacent rows when the formatted value from the cells is the same.
     */
    MergedCellEvaluationCriteria[MergedCellEvaluationCriteria["FormattedText"] = 2] = "FormattedText";
    return MergedCellEvaluationCriteria;
})({});
/**
 * @hidden
 */
export let MergedCellEvaluationCriteria_$type = /*@__PURE__*/ markEnum('MergedCellEvaluationCriteria', 'Default,0|RawValue,1|FormattedText,2');
