/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { TextEditorView } from "./TextEditorView";
import { markType } from "igniteui-react-core";
import { tryParseNumber } from "igniteui-react-core";
/**
 * @hidden
 */
export let NumericEditorView = /*@__PURE__*/ (() => {
    class NumericEditorView extends TextEditorView {
        constructor(a, b, c) {
            super(a, b, c);
            this.y.b8 = "number";
        }
        getEditorValue() {
            if (this.y == null || this.y.cq == null) {
                return null;
            }
            let a = NaN;
            let b = tryParseNumber(this.y.cq, a);
            a = b.p1;
            return a;
        }
    }
    NumericEditorView.$t = /*@__PURE__*/ markType(NumericEditorView, 'NumericEditorView', TextEditorView.$);
    return NumericEditorView;
})();
