/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventArgs, markType } from "igniteui-react-core";
/**
 * @hidden
 */
export let PageChangedEventArgs = /*@__PURE__*/ (() => {
    class PageChangedEventArgs extends EventArgs {
        constructor() {
            super(...arguments);
            this._page = 0;
            this._data = null;
        }
        get page() {
            return this._page;
        }
        set page(a) {
            this._page = a;
        }
        get data() {
            return this._data;
        }
        set data(a) {
            this._data = a;
        }
    }
    PageChangedEventArgs.$t = /*@__PURE__*/ markType(PageChangedEventArgs, 'PageChangedEventArgs', EventArgs.$);
    return PageChangedEventArgs;
})();
