/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PivotDimensionStrategy } from "./PivotDimensionStrategy";
import { PivotDimension } from "./PivotDimension";
import { PivotDimensionCollection } from "./PivotDimensionCollection";
import { PivotValueCollection } from "./PivotValueCollection";
import { PivotKeys } from "./PivotKeys";
import { PivotValue } from "./PivotValue";
/**
 * @hidden
 */
export let PivotConfiguration = /*@__PURE__*/ (() => {
    class PivotConfiguration extends Base {
        constructor() {
            super(...arguments);
            this.h = new WCNativeHelper();
            this.j = null;
        }
        get i() {
            return this.h;
        }
        get nativeElement() {
            return this.j;
        }
        set nativeElement(a) {
            this.j = a;
            this.h.o = this.j;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get e() {
            let ret_ = this.i.m("rowStrategy", (a) => new PivotDimensionStrategy());
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.i.v("rowStrategy", value_);
        }
        get d() {
            let ret_ = this.i.m("columnStrategy", (a) => new PivotDimensionStrategy());
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.i.v("columnStrategy", value_);
        }
        get c() {
            let ret_ = this.i.k("rows", (a) => new PivotDimensionCollection(), (a) => new PivotDimension());
            return ret_;
        }
        get a() {
            let ret_ = this.i.k("columns", (a) => new PivotDimensionCollection(), (a) => new PivotDimension());
            return ret_;
        }
        get g() {
            let ret_ = this.i.k("values", (a) => new PivotValueCollection(), (a) => new PivotValue());
            return ret_;
        }
        get b() {
            let ret_ = this.i.k("filters", (a) => new PivotDimensionCollection(), (a) => new PivotDimension());
            return ret_;
        }
        get f() {
            let ret_ = this.i.m("pivotKeys", (a) => new PivotKeys());
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.i.v("pivotKeys", value_);
        }
    }
    PivotConfiguration.$t = /*@__PURE__*/ markType(PivotConfiguration, 'PivotConfiguration');
    return PivotConfiguration;
})();
