/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { PivotDimension } from "./PivotDimension";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { GridColumnDataType_$type } from "./GridColumnDataType";
import { GridResourceStrings } from "./GridResourceStrings";
import { PivotDateDimensionOptions } from "./PivotDateDimensionOptions";
/**
 * @hidden
 */
export let PivotDateDimension = /*@__PURE__*/ (() => {
    class PivotDateDimension extends PivotDimension {
        get t() {
            let ret_ = this.g.n("enabled");
            return ret_;
        }
        set t(a) {
            let value_ = a;
            this.g.v("enabled", value_);
        }
        get p() {
            let ret_ = this.g.n("dataType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridColumnDataType_$type, EnumUtil.getEnumValue(GridColumnDataType_$type, this.g.f(GridColumnDataType_$type, ret_)));
            return EnumUtil.getEnumValue(GridColumnDataType_$type, ret_);
        }
        set p(a) {
            let value_ = enumGetBox(GridColumnDataType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("dataType", value_);
        }
        get q() {
            let ret_ = this.g.m("resourceStrings", (a) => new GridResourceStrings());
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.g.v("resourceStrings", value_);
        }
        get s() {
            let ret_ = this.g.m("baseDimension", (a) => new PivotDimension());
            return ret_;
        }
        set s(a) {
            let value_ = a;
            this.g.v("baseDimension", value_);
        }
        get r() {
            let ret_ = this.g.m("options", (a) => new PivotDateDimensionOptions());
            return ret_;
        }
        set r(a) {
            let value_ = a;
            this.g.v("options", value_);
        }
    }
    PivotDateDimension.$t = /*@__PURE__*/ markType(PivotDateDimension, 'PivotDateDimension', PivotDimension.$);
    return PivotDateDimension;
})();
