/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { SortingOptionsMode_$type } from "./SortingOptionsMode";
/**
 * @hidden
 */
export let SortingOptions = /*@__PURE__*/ (() => {
    class SortingOptions extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.d = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.d;
        }
        set nativeElement(a) {
            this.d = a;
            this.b.o = this.d;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.c.n("mode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(SortingOptionsMode_$type, EnumUtil.getEnumValue(SortingOptionsMode_$type, this.c.f(SortingOptionsMode_$type, ret_)));
            return EnumUtil.getEnumValue(SortingOptionsMode_$type, ret_);
        }
        set a(a) {
            let value_ = enumGetBox(SortingOptionsMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.c.v("mode", value_);
        }
    }
    SortingOptions.$t = /*@__PURE__*/ markType(SortingOptions, 'SortingOptions');
    return SortingOptions;
})();
