/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { markType } from "igniteui-react-core";
/**
 * @hidden
 */
export let SummaryCell = /*@__PURE__*/ (() => {
    class SummaryCell extends GridCellBase {
        get ck() {
            return this.ch;
        }
        get cl() {
            return this.ci;
        }
        b6(a, b) {
            super.b6(a, b);
            let c = Math.max(0, a - b);
            if (this.cn != c) {
                this.cn = c;
            }
        }
        b0(a, b) {
            super.b0(a, b);
            let c = Math.max(0, a - b);
            if (this.cm != c) {
                this.cm = c;
            }
        }
        constructor(a) {
            super(a);
            this.ch = null;
            this.ci = null;
            this.cj = null;
            this.cn = -1;
            this.cm = -1;
            this.ae.setRawStyleProperty("vertical-align", "middle");
            this.cj = a.createElement("div");
            this.ch = a.createElement("span");
            this.ch.setRawStyleProperty("display", "inline-block");
            this.ch.setRawStyleProperty("width", "40%");
            this.ch.setRawStyleProperty("white-space", "nowrap");
            this.ch.setRawStyleProperty("text-overflow", "ellipsis");
            this.ch.setRawStyleProperty("vertical-align", "middle");
            this.ch.setRawStyleProperty("overflow", "hidden");
            this.cj.append(this.ch);
            this.ci = a.createElement("span");
            this.ci.setRawStyleProperty("display", "inline-block");
            this.ci.setRawStyleProperty("width", "60%");
            this.ci.setRawStyleProperty("text-align", "right");
            this.ci.setRawStyleProperty("white-space", "nowrap");
            this.ci.setRawStyleProperty("text-overflow", "ellipsis");
            this.ci.setRawStyleProperty("vertical-align", "middle");
            this.ci.setRawStyleProperty("overflow", "hidden");
            this.cj.append(this.ci);
            this.ae.append(this.cj);
        }
        get_w() {
            return false;
        }
        bp(a, b, c) {
            super.bp(a, b, c);
            if (a == "Indent" || a == "IsCollapsable") {
                this.cj.setRawStyleProperty("margin-left", this.a0 + this.a2 + this.a1 + "px");
            }
        }
    }
    SummaryCell.$t = /*@__PURE__*/ markType(SummaryCell, 'SummaryCell', GridCellBase.$);
    return SummaryCell;
})();
