/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { TemplateCellModel } from "./TemplateCellModel";
import { CellModel } from "./CellModel";
import { markType } from "igniteui-react-core";
import { TemplateHeaderCellModelExport } from "./TemplateHeaderCellModelExport";
/**
 * @hidden
 */
export let TemplateHeaderCellModel = /*@__PURE__*/ (() => {
    class TemplateHeaderCellModel extends TemplateCellModel {
        constructor() {
            super(...arguments);
            this.ln = false;
        }
        get lo() {
            return this.ln;
        }
        set lo(a) {
            let b = this.ln;
            this.ln = a;
            if (this.ln != b) {
                this.j8("IsFilterUIVisible", TemplateHeaderCellModel.lp, b, this.ln);
            }
        }
        kh(a, b) {
            super.kh(a, b);
            if (a == "IsFilterUIVisible") {
                this.lo = b;
            }
        }
        g2(a) {
            if (a == "IsFilterUIVisible") {
                return this.lo;
            }
            return super.g2(a);
        }
        b(a) {
            if (a == null) {
                a = new TemplateHeaderCellModelExport();
            }
            a = super.b(a);
            let b = a;
            b.ae = this.ll;
            return b;
        }
    }
    TemplateHeaderCellModel.$t = /*@__PURE__*/ markType(TemplateHeaderCellModel, 'TemplateHeaderCellModel', TemplateCellModel.$);
    TemplateHeaderCellModel.lp = /*@__PURE__*/ CellModel.fb("IsFilterUIVisible");
    return TemplateHeaderCellModel;
})();
