/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CellModelExport } from "./CellModelExport";
import { markType } from "igniteui-react-core";
/**
 * @hidden
 */
export let TextCellModelExport = /*@__PURE__*/ (() => {
    class TextCellModelExport extends CellModelExport {
        constructor() {
            super(...arguments);
            this.af = null;
            this.ae = null;
        }
        get_ac() {
            return "TextCell";
        }
        ad(a) {
            super.ad(a);
            a.l("textValue : \"" + this.af + "\", ");
            a.l("formatString : \"" + this.ae + "\", ");
        }
    }
    TextCellModelExport.$t = /*@__PURE__*/ markType(TextCellModelExport, 'TextCellModelExport', CellModelExport.$);
    return TextCellModelExport;
})();
