/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseEditorView } from "./BaseEditorView";
import { XInputGroup } from "igniteui-react-inputs";
import { XInput } from "igniteui-react-inputs";
import { runOn, delegateCombine, delegateRemove, markType } from "igniteui-react-core";
/**
 * @hidden
 */
export let TextEditorView = /*@__PURE__*/ (() => {
    class TextEditorView extends BaseEditorView {
        constructor(a, b, c) {
            super(a, c);
            this.aa = null;
            this.z = null;
            this.y = null;
            let d = a.createElement("div");
            d.setRawStyleProperty("display", "flex");
            d.setRawStyleProperty("width", "100%");
            d.setRawStyleProperty("margin-top", "-10px");
            d.setRawStyleProperty("height", "38px");
            this.container = d;
            let e = a.getSubRenderer(d);
            this.z = new XInputGroup();
            this.z.provideContainer(e);
            this.z.d = 0;
            this.z.p = b;
            this.z.t = 3;
            this.z.disabled = !this.isEnabled;
            let f = e.getExternal(this.z, e.rootWrapper, null);
            let g = a.createElement("div");
            g.setRawStyleProperty("width", "100%");
            let h = a.getSubRenderer(g);
            this.y = new XInput();
            this.y.provideContainer(h);
            this.y.b8 = "text";
            this.y.disabled = !this.isEnabled;
            this.y.d8 = this.textColor;
            let i = e.getExternal(this.y, h.rootWrapper, null);
            this.z.appendContentChild(g);
            this.z.inputs.add(this.y);
        }
        setFont(a) {
            if (this.y != null) {
                this.y.af = a;
            }
        }
        attachEvents() {
            if (this.y != null) {
                let a = this.y;
                a.changing = delegateCombine(a.changing, runOn(this, this.ac));
                let b = this.y;
                b.keyDown = delegateCombine(b.keyDown, runOn(this, this.onInputKeyDown));
                let c = this.y;
                c.compositionEnd = delegateCombine(c.compositionEnd, runOn(this, this.ab));
                let d = this.y;
                d.gotFocus = delegateCombine(d.gotFocus, runOn(this, this.ad));
                let e = this.y;
                e.lostFocus = delegateCombine(e.lostFocus, runOn(this, this.ae));
            }
        }
        detachEvents() {
            if (this.y != null) {
                let a = this.y;
                a.changing = delegateRemove(a.changing, runOn(this, this.ac));
                let b = this.y;
                b.keyDown = delegateRemove(b.keyDown, runOn(this, this.onInputKeyDown));
                let c = this.y;
                c.compositionEnd = delegateRemove(c.compositionEnd, runOn(this, this.ab));
                let d = this.y;
                d.gotFocus = delegateRemove(d.gotFocus, runOn(this, this.ad));
                let e = this.y;
                e.lostFocus = delegateRemove(e.lostFocus, runOn(this, this.ae));
            }
        }
        onTargetChanged() {
            this.aa = null;
            if (this.y != null) {
                this.focus();
            }
        }
        onEditStarted() {
            super.onEditStarted();
            if (!this.a.isEditRefocusDesired) {
                this.focus();
            }
        }
        onEditEnded() {
            super.onEditEnded();
            if (this.a.isEditRefocusDesired) {
                let a = this.h.rootWrapper.getNativeElement();
                if (a == document.activeElement || a.contains(document.activeElement)) {
                    this.y.ct();
                    this.focus();
                }
            }
        }
        s() {
            if (this.y != null) {
                this.y.focus(true);
                if (this.y.b8 != "date") {
                    window.setTimeout(() => this.y.dp(), 0);
                }
            }
        }
        w() {
            if (this.y != null) {
                if (this.value != null) {
                    this.aa = null;
                    this.y.cq = null;
                    this.y.cq = this.value.toString();
                    if (this.focusOnValueChanged) {
                        this.s();
                    }
                }
                else {
                    this.y.cq = null;
                }
            }
        }
        r() {
            if (this.z != null) {
                this.z.disabled = !this.isEnabled;
            }
            if (this.y != null) {
                this.y.disabled = !this.isEnabled;
            }
        }
        v() {
            super.v();
            if (this.y != null) {
                this.y.d8 = this.textColor;
            }
        }
        ac(a, b) {
            this.p();
            if (b.isCompositionInProgress) {
                return;
            }
            if (this.aa != null && this.aa != b.value) {
                this.aa = null;
                return;
            }
            this.q(b.value, false);
        }
        ab(a, b) {
            this.aa = b.value;
            this.q(this.y.cq, false);
        }
        ae(a, b) {
            this.o();
        }
        ad(a, b) {
            this.n();
        }
        getEditorValue() {
            if (this.y != null) {
                return this.y.cq;
            }
            return null;
        }
        setEditorValue(a) {
            if (this.y != null) {
                this.y.cq = a;
            }
        }
    }
    TextEditorView.$t = /*@__PURE__*/ markType(TextEditorView, 'TextEditorView', BaseEditorView.$);
    return TextEditorView;
})();
