/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "igniteui-react";
import { WCNativeHelper } from "igniteui-react";
import { markType } from "igniteui-react-core";
import { ToggleViewEventArgs } from "./ToggleViewEventArgs";
import { ToggleViewCancelableEventArgs } from "./ToggleViewCancelableEventArgs";
/**
 * @hidden
 */
export let ToggleDirective = /*@__PURE__*/ (() => {
    class ToggleDirective extends BaseElement {
        constructor() {
            super(...arguments);
            this.f = new WCNativeHelper();
            this.h = null;
            this.opened = null;
            this.opening = null;
            this.closed = null;
            this.closing = null;
            this.appended = null;
        }
        get g() {
            return this.f;
        }
        get nativeElement() {
            return this.h;
        }
        set nativeElement(a) {
            this.h = a;
            this.f.o = this.h;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get j() {
            let ret_ = this.g.n("id");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.g.v("id", value_);
        }
        openedChanged() {
            if (this.opened != null) {
                this.g.r("opened", (a) => this.opened(this, ToggleViewEventArgs.a(a)), false);
            }
            else {
                this.g.u("opened");
            }
        }
        openingChanged() {
            if (this.opening != null) {
                this.g.r("opening", (a) => this.opening(this, ToggleViewCancelableEventArgs.a(a)), false);
            }
            else {
                this.g.u("opening");
            }
        }
        closedChanged() {
            if (this.closed != null) {
                this.g.r("closed", (a) => this.closed(this, ToggleViewEventArgs.a(a)), false);
            }
            else {
                this.g.u("closed");
            }
        }
        closingChanged() {
            if (this.closing != null) {
                this.g.r("closing", (a) => this.closing(this, ToggleViewCancelableEventArgs.a(a)), false);
            }
            else {
                this.g.u("closing");
            }
        }
        appendedChanged() {
            if (this.appended != null) {
                this.g.r("appended", (a) => this.appended(this, ToggleViewEventArgs.a(a)), false);
            }
            else {
                this.g.u("appended");
            }
        }
        n(a) {
            this.nativeElement.open(this.g.i(a));
        }
        t(a) {
            this.nativeElement.toggle(this.g.i(a));
        }
        q() {
            this.nativeElement.reposition();
        }
        s(a, b) {
            this.nativeElement.setOffset(this.g.i(a), this.g.i(b));
        }
    }
    ToggleDirective.$t = /*@__PURE__*/ markType(ToggleDirective, 'ToggleDirective', BaseElement.$);
    return ToggleDirective;
})();
