/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridBaseDirective } from "./GridBaseDirective";
import { markType } from "igniteui-react-core";
import { TreeGridRecord } from "./TreeGridRecord";
import { CellType } from "./CellType";
import { RowType } from "./RowType";
/**
 * @hidden
 */
export let TreeGrid = /*@__PURE__*/ (() => {
    class TreeGrid extends GridBaseDirective {
        constructor() {
            super(...arguments);
            this.ha = null;
        }
        get hc() {
            let ret_ = this.d.n("childDataKey");
            return ret_;
        }
        set hc(a) {
            let value_ = a;
            this.d.v("childDataKey", value_);
        }
        get hd() {
            let ret_ = this.d.n("foreignKey");
            return ret_;
        }
        set hd(a) {
            let value_ = a;
            this.d.v("foreignKey", value_);
        }
        get he() {
            let ret_ = this.d.n("hasChildrenKey");
            return ret_;
        }
        set he(a) {
            let value_ = a;
            this.d.v("hasChildrenKey", value_);
        }
        get g6() {
            let ret_ = this.d.n("cascadeOnDelete");
            return ret_;
        }
        set g6(a) {
            let value_ = a;
            this.d.v("cascadeOnDelete", value_);
        }
        get hf() {
            let ret_ = this.d.n("id");
            return ret_;
        }
        set hf(a) {
            let value_ = a;
            this.d.v("id", value_);
        }
        get g0() {
            let ret_ = this.d.m("rootRecords", (a) => new TreeGridRecord());
            return ret_;
        }
        set g0(a) {
            let value_ = a;
            this.d.v("rootRecords", value_);
        }
        get gz() {
            let ret_ = this.d.m("processedRootRecords", (a) => new TreeGridRecord());
            return ret_;
        }
        set gz(a) {
            let value_ = a;
            this.d.v("processedRootRecords", value_);
        }
        get gx() {
            let ret_ = this.d.n("data");
            return ret_;
        }
        set gx(a) {
            let value_ = a;
            this.d.v("data", value_);
        }
        get g9() {
            let ret_ = this.d.n("expansionDepth");
            return ret_;
        }
        set g9(a) {
            let value_ = a;
            this.d.v("expansionDepth", value_);
        }
        get hb() {
            return this.ha;
        }
        set hb(a) {
            this.ha = a;
            this.d.s("rowLoadingIndicatorTemplate", (b) => b, this.ha);
        }
        get g1() {
            let ret_ = this.d.m("selectedCells", (a) => new CellType());
            return ret_;
        }
        hk(a) {
            this.nativeElement.getDefaultExpandState(this.d.i(a));
        }
        hj() {
            this.nativeElement.expandAll();
        }
        hi() {
            this.nativeElement.collapseAll();
        }
        hg(a, b) {
            this.nativeElement.addRow(this.d.i(a), this.d.i(b));
        }
        hh(a, b = false) {
            this.nativeElement.beginAddRowByIndex(this.d.i(a), this.d.i(b));
        }
        gy(a = false, b = false) {
            return (this.nativeElement.getSelectedData(this.d.i(a), this.d.i(b)));
        }
        g4(a) {
            return this.d.g(this.nativeElement.getRowByIndex(this.d.i(a)), (b) => new RowType());
        }
        g5(a) {
            return this.d.g(this.nativeElement.getRowByKey(this.d.i(a)), (b) => new RowType());
        }
        g2(a, b) {
            return this.d.g(this.nativeElement.getCellByColumn(this.d.i(a), this.d.i(b)), (c) => new CellType());
        }
        g3(a, b) {
            return this.d.g(this.nativeElement.getCellByKey(this.d.i(a), this.d.i(b)), (c) => new CellType());
        }
        g7(a, b = -1) {
            return (this.nativeElement.pinRow(this.d.i(a), this.d.i(b)));
        }
        g8(a) {
            return (this.nativeElement.unpinRow(this.d.i(a)));
        }
    }
    TreeGrid.$t = /*@__PURE__*/ markType(TreeGrid, 'TreeGrid', GridBaseDirective.$);
    return TreeGrid;
})();
