import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { ActionStrip as ActionStrip_internal } from './ActionStrip';
import { IgrActionStrip as IgrActionStrip } from './igr-action-strip';
export class IgrActionStripCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrActionStrip.$type) {
            IgrActionStrip.$type = markType(IgrActionStrip, "IgrActionStrip");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrActionStrip.$type) {
            IgrActionStrip.$type = markType(IgrActionStrip, "IgrActionStrip");
        }
        let coll = new SyncableObservableCollection$2(IgrActionStrip.$type, ActionStrip_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgrActionStrip._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
