import { IgrFilteringOperand } from "./igr-filtering-operand";
import { BooleanFilteringOperand as BooleanFilteringOperand_internal } from "./BooleanFilteringOperand";
/**
 * Provides filtering operations for booleans
 * @export
*/
export class IgrBooleanFilteringOperand extends IgrFilteringOperand {
    createImplementation() {
        let impl = new BooleanFilteringOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
}
