import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { ColumnExchanger as ColumnExchanger_internal } from './ColumnExchanger';
import { IgrColumnExchanger as IgrColumnExchanger } from './igr-column-exchanger';
export class IgrColumnExchangersCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrColumnExchanger.$type) {
            IgrColumnExchanger.$type = markType(IgrColumnExchanger, "IgrColumnExchanger");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrColumnExchanger.$type) {
            IgrColumnExchanger.$type = markType(IgrColumnExchanger, "IgrColumnExchanger");
        }
        let coll = new SyncableObservableCollection$2(IgrColumnExchanger.$type, ColumnExchanger_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrColumnExchanger();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
