import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { ColumnPropertySetter as ColumnPropertySetter_internal } from './ColumnPropertySetter';
import { IgrColumnPropertySetter as IgrColumnPropertySetter } from './igr-column-property-setter';
export class IgrColumnPropertySettersCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrColumnPropertySetter.$type) {
            IgrColumnPropertySetter.$type = markType(IgrColumnPropertySetter, "IgrColumnPropertySetter");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrColumnPropertySetter.$type) {
            IgrColumnPropertySetter.$type = markType(IgrColumnPropertySetter, "IgrColumnPropertySetter");
        }
        let coll = new SyncableObservableCollection$2(IgrColumnPropertySetter.$type, ColumnPropertySetter_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrColumnPropertySetter();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
