import { IgrColumn } from "./igr-column";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ColumnResizeEventArgsDetail as ColumnResizeEventArgsDetail_internal } from "./ColumnResizeEventArgsDetail";
export class IgrColumnResizeEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new ColumnResizeEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get column() {
        const r = this.i.g;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrColumn._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set column(v) {
        v == null ? this.i.g = null : this.i.g = v.i;
    }
    get prevWidth() {
        return this.i.i;
    }
    set prevWidth(v) {
        this.i.i = v;
    }
    get newWidth() {
        return this.i.h;
    }
    set newWidth(v) {
        this.i.h = v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        return null;
    }
}
