import { DisplayDensity_$type } from "./DisplayDensity";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { DensityChangedEventArgsDetail as DensityChangedEventArgsDetail_internal } from "./DensityChangedEventArgsDetail";
import { ensureEnum } from "igniteui-react-core";
export class IgrDensityChangedEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new DensityChangedEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get oldDensity() {
        return this.i.h;
    }
    set oldDensity(v) {
        this.i.h = ensureEnum(DisplayDensity_$type, v);
    }
    get newDensity() {
        return this.i.g;
    }
    set newDensity(v) {
        this.i.g = ensureEnum(DisplayDensity_$type, v);
    }
}
