import { IgrDefinitionBase } from "./igr-definition-base";
import { EditRowDefinition } from "./EditRowDefinition";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export class IgrEditRowDefinition extends IgrDefinitionBase {
    createImplementation() {
        return new EditRowDefinition();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
}
