import { IgrDefinitionBase } from "./igr-definition-base";
import { EditorDefinition } from "./EditorDefinition";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export class IgrEditorDefinition extends IgrDefinitionBase {
    createImplementation() {
        return new EditorDefinition();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
}
