import { ExporterEventArgsDetail as ExporterEventArgsDetail_internal } from "./ExporterEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
export class IgrExporterEventArgsDetail {
    createImplementation() {
        return new ExporterEventArgsDetail_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get exporter() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        return r.externalObject;
    }
    set exporter(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    get options() {
        const r = this.i.b;
        if (r == null) {
            return null;
        }
        return r.externalObject;
    }
    set options(v) {
        v == null ? this.i.b = null : this.i.b = v.i;
    }
    get grid() {
        const r = this.i.c;
        if (r == null) {
            return null;
        }
        return r.externalObject;
    }
    set grid(v) {
        v == null ? this.i.c = null : this.i.c = v.i;
    }
    get cancel() {
        return this.i.f;
    }
    set cancel(v) {
        this.i.f = ensureBool(v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.exporter && this.exporter.name && this.exporter.name == name) {
            return this.exporter;
        }
        if (this.options && this.options.name && this.options.name == name) {
            return this.options;
        }
        if (this.grid && this.grid.name && this.grid.name == name) {
            return this.grid;
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
