import { IgrCellType } from "./igr-cell-type";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GridCellEventArgsDetail as GridCellEventArgsDetail_internal } from "./GridCellEventArgsDetail";
export class IgrGridCellEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new GridCellEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get cell() {
        const r = this.i.h;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrCellType();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set cell(v) {
        v == null ? this.i.h = null : this.i.h = v.i;
    }
    get event() {
        return this.i.i;
    }
    set event(v) {
        this.i.i = v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.cell && this.cell.name && this.cell.name == name) {
            return this.cell;
        }
        return null;
    }
}
