import { GridCellIdentifier as GridCellIdentifier_internal } from "./GridCellIdentifier";
export class IgrGridCellIdentifier {
    createImplementation() {
        return new GridCellIdentifier_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get rowID() {
        return this.i.g;
    }
    set rowID(v) {
        this.i.g = v;
    }
    get columnID() {
        return this.i.c;
    }
    set columnID(v) {
        this.i.c = +v;
    }
    get rowIndex() {
        return this.i.d;
    }
    set rowIndex(v) {
        this.i.d = +v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
