import { IgrRowIsland } from "./igr-row-island";
import { IgrHierarchicalGrid } from "./igr-hierarchical-grid";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GridCreatedEventArgsDetail as GridCreatedEventArgsDetail_internal } from "./GridCreatedEventArgsDetail";
export class IgrGridCreatedEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new GridCreatedEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get owner() {
        const r = this.i.h;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrRowIsland._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set owner(v) {
        v == null ? this.i.h = null : this.i.h = v.i;
    }
    get parentID() {
        return this.i.i;
    }
    set parentID(v) {
        this.i.i = v;
    }
    get grid() {
        const r = this.i.g;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrHierarchicalGrid({});
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set grid(v) {
        v == null ? this.i.g = null : this.i.g = v.i;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.owner && this.owner.name && this.owner.name == name) {
            return this.owner;
        }
        if (this.grid && this.grid.name && this.grid.name == name) {
            return this.grid;
        }
        return null;
    }
}
