import { GridFilterDialogViewModelGrouping as GridFilterDialogViewModelGrouping_internal } from "./GridFilterDialogViewModelGrouping";
import { ensureBool } from "igniteui-react-core";
export class IgrGridFilterDialogViewModelGrouping {
    createImplementation() {
        return new GridFilterDialogViewModelGrouping_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get startIndex() {
        return this.i.c;
    }
    set startIndex(v) {
        this.i.c = +v;
    }
    get endIndex() {
        return this.i.b;
    }
    set endIndex(v) {
        this.i.b = +v;
    }
    get isOrGrouping() {
        return this.i.a;
    }
    set isOrGrouping(v) {
        this.i.a = ensureBool(v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}
