import { GridFilterDialogViewModelRow as GridFilterDialogViewModelRow_internal } from "./GridFilterDialogViewModelRow";
export class IgrGridFilterDialogViewModelRow {
    createImplementation() {
        return new GridFilterDialogViewModelRow_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get operatorTypes() {
        return this.i.f;
    }
    set operatorTypes(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.f = v;
    }
    get operators() {
        return this.i.e;
    }
    set operators(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.e = v;
    }
    get currentOperator() {
        return this.i.l;
    }
    set currentOperator(v) {
        this.i.l = v;
    }
    get operandNumber() {
        return this.i.d;
    }
    set operandNumber(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.d = v;
    }
    get operand1() {
        return this.i.i;
    }
    set operand1(v) {
        this.i.i = v;
    }
    get operand2() {
        return this.i.j;
    }
    set operand2(v) {
        this.i.j = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}
