import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { FilterOperand as FilterOperand_internal } from './FilterOperand';
import { IgrFilterOperand as IgrFilterOperand } from './igr-filter-operand';
export class IgrGridFilterOperandsCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrFilterOperand.$type) {
            IgrFilterOperand.$type = markType(IgrFilterOperand, "IgrFilterOperand");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrFilterOperand.$type) {
            IgrFilterOperand.$type = markType(IgrFilterOperand, "IgrFilterOperand");
        }
        let coll = new SyncableObservableCollection$2(IgrFilterOperand.$type, FilterOperand_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrFilterOperand();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
