import { GridToolbarExportEventArgs as GridToolbarExportEventArgs_internal } from "./GridToolbarExportEventArgs";
import { interfaceToInternal } from "igniteui-react-core";
import { GridToolbarExportEventArgsDetail } from "./GridToolbarExportEventArgsDetail";
export class IgrGridToolbarExportEventArgs {
    createImplementation() {
        return new GridToolbarExportEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get detail() {
        return this.i.b.nativeElement;
    }
    set detail(v) {
        this.i.b = interfaceToInternal(v, () => new GridToolbarExportEventArgsDetail());
    }
}
