import { IgrDefinitionBase } from "./igr-definition-base";
import { HeaderRowSeparator } from "./HeaderRowSeparator";
/**
 * Represents a Header Row separator. This is used to visually separate the header row from the rest of the rows in a grid.
*/
export class IgrHeaderRowSeparator extends IgrDefinitionBase {
    createImplementation() {
        return new HeaderRowSeparator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
}
