import { IgrFilteringOperand } from "./igr-filtering-operand";
import { NumberFilteringOperand as NumberFilteringOperand_internal } from "./NumberFilteringOperand";
/**
 * Provides filtering operations for numbers
 * @export
*/
export class IgrNumberFilteringOperand extends IgrFilteringOperand {
    createImplementation() {
        let impl = new NumberFilteringOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
}
