import { OperatorSelectorOpeningEventArgs as OperatorSelectorOpeningEventArgs_internal } from "./OperatorSelectorOpeningEventArgs";
/**
 * Event arguments for the Opening event.
*/
export class IgrOperatorSelectorOpeningEventArgs {
    createImplementation() {
        return new OperatorSelectorOpeningEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
}
