import { RowSelectorTemplateDetails as RowSelectorTemplateDetails_internal } from "./RowSelectorTemplateDetails";
import { ensureBool } from "igniteui-react-core";
export class IgrRowSelectorTemplateDetails {
    createImplementation() {
        return new RowSelectorTemplateDetails_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get index() {
        return this.i.d;
    }
    set index(v) {
        this.i.d = +v;
    }
    /**
     * @deprecated Use the `key` property instead.
     * @deprecated Use the `key` property instead.
    */
    get rowID() {
        return this.i.h;
    }
    set rowID(v) {
        this.i.h = v;
    }
    get key() {
        return this.i.f;
    }
    set key(v) {
        this.i.f = v;
    }
    get selected() {
        return this.i.c;
    }
    set selected(v) {
        this.i.c = ensureBool(v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
    select() {
        this.i.j();
    }
    deselect() {
        this.i.i();
    }
}
