import { IgrDefinitionBase } from "./igr-definition-base";
import { RowSeparator } from "./RowSeparator";
/**
 * Represents a Row separator, this is used to visually separate the rows in a grid
*/
export class IgrRowSeparator extends IgrDefinitionBase {
    createImplementation() {
        return new RowSeparator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
}
