import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { RowToggleEventArgsDetail as RowToggleEventArgsDetail_internal } from "./RowToggleEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
export class IgrRowToggleEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new RowToggleEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get rowID() {
        return this.i.i;
    }
    set rowID(v) {
        this.i.i = v;
    }
    get expanded() {
        return this.i.h;
    }
    set expanded(v) {
        this.i.h = ensureBool(v);
    }
    get cancel() {
        return this.i.g;
    }
    set cancel(v) {
        this.i.g = ensureBool(v);
    }
}
