import { IgrFilteringOperand } from "./igr-filtering-operand";
import { StringFilteringOperand as StringFilteringOperand_internal } from "./StringFilteringOperand";
/**
 * Provides filtering operations for strings
 * @export
*/
export class IgrStringFilteringOperand extends IgrFilteringOperand {
    createImplementation() {
        let impl = new StringFilteringOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    applyIgnoreCase(a, ignoreCase) {
        let iv = this.i.k(a, ignoreCase);
        return (iv);
    }
}
