import { IgrCellInfo } from "./igr-cell-info";
import { TextCellModel as TextCellModel_internal } from "./TextCellModel";
/**
 * Backing information for a text cell in the grid.
*/
export class IgrTextCellInfo extends IgrCellInfo {
    createImplementation() {
        return new TextCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets the text value for the cell.
    */
    get textValue() {
        return this.i.ll;
    }
    set textValue(v) {
        this.i.ll = v;
    }
}
