/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { DisplayDensityBaseElement } from "./DisplayDensityBaseElement";
import { GridActionsBaseDirectiveCollection } from "./GridActionsBaseDirectiveCollection";
import { markType } from "igniteui-react-core";
import { GridActionsBaseDirective } from "./GridActionsBaseDirective";
import { ActionStripResourceStrings } from "./ActionStripResourceStrings";
/**
 * @hidden
 */
var ActionStrip = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ActionStrip, _super);
    function ActionStrip() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(ActionStrip.prototype, "j", {
        get: function () {
            var ret_ = this.d.l("actionButtons", function (a) { return new GridActionsBaseDirectiveCollection(); }, function (a) { return new GridActionsBaseDirective(); }, ["GridActionsBaseDirective", "GridEditingActions", "GridPinningActions"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ActionStrip.prototype, "k", {
        get: function () {
            var ret_ = this.d.n("hidden");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("hidden", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ActionStrip.prototype, "i", {
        get: function () {
            var ret_ = this.d.m("resourceStrings", function (a) { return new ActionStripResourceStrings(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("resourceStrings", value_);
        },
        enumerable: false,
        configurable: true
    });
    ActionStrip.prototype.n = function (a) {
        this.nativeElement.show(this.d.i(a));
    };
    ActionStrip.prototype.m = function () {
        this.nativeElement.hide();
    };
    Object.defineProperty(ActionStrip.prototype, "l", {
        get: function () {
            var ret_ = this.d.n("name");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("name", value_);
        },
        enumerable: false,
        configurable: true
    });
    ActionStrip.$t = markType(ActionStrip, 'ActionStrip', DisplayDensityBaseElement.$);
    return ActionStrip;
}(DisplayDensityBaseElement));
export { ActionStrip };
