/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "igniteui-react";
import { WCNativeHelper } from "igniteui-react";
import { Base, markType, enumGetBox, EnumUtil, typeGetValue, typeCast, Date_$type } from "igniteui-react-core";
import { BaseEventArgs } from "./BaseEventArgs";
import { RowExportingEventArgs } from "./RowExportingEventArgs";
import { GridCellIdentifier } from "./GridCellIdentifier";
import { GridValidationState } from "./GridValidationState";
import { SummaryResult } from "./SummaryResult";
import { GridColumnDataType_$type } from "./GridColumnDataType";
import { FilteringOperand } from "./FilteringOperand";
import { SortingStrategy } from "./SortingStrategy";
import { SummaryTemplateContext } from "./SummaryTemplateContext";
import { ColumnPipeArgs } from "./ColumnPipeArgs";
import { BaseEventArgsDetail } from "./BaseEventArgsDetail";
import { ObservableCollection$1 } from "igniteui-react-core";
import { FilteringExpressionsTree } from "./FilteringExpressionsTree";
import { DisplayDensityBase } from "./DisplayDensityBase";
import { ActionStrip } from "./ActionStrip";
import { DataCloneStrategy } from "./DataCloneStrategy";
import { ClipboardOptions } from "./ClipboardOptions";
import { ActionStripCollection } from "./ActionStripCollection";
import { GridRowEditTextTemplateContext } from "./GridRowEditTextTemplateContext";
import { GridEmptyTemplateContext } from "./GridEmptyTemplateContext";
import { GridRowEditActionsTemplateContext } from "./GridRowEditActionsTemplateContext";
import { PaginatorCollection } from "./PaginatorCollection";
import { GridResourceStrings } from "./GridResourceStrings";
import { FilteringLogic_$type } from "./FilteringLogic";
import { GridPagingMode_$type } from "./GridPagingMode";
import { GridValidationTrigger_$type } from "./GridValidationTrigger";
import { PinningConfig } from "./PinningConfig";
import { FilterMode_$type } from "./FilterMode";
import { GridSummaryPosition_$type } from "./GridSummaryPosition";
import { GridSummaryCalculationMode_$type } from "./GridSummaryCalculationMode";
import { SortingOptions } from "./SortingOptions";
import { HeadSelectorTemplateContext } from "./HeadSelectorTemplateContext";
import { RowSelectorTemplateContext } from "./RowSelectorTemplateContext";
import { SortingExpression } from "./SortingExpression";
import { GridSelectionMode_$type } from "./GridSelectionMode";
import { ForOfState } from "./ForOfState";
import { OverlayOutletDirective } from "./OverlayOutletDirective";
import { StateCollection } from "./StateCollection";
import { FilteringExpressionsTreeEventArgs } from "./FilteringExpressionsTreeEventArgs";
import { GridScrollEventArgs } from "./GridScrollEventArgs";
import { RowSelectionEventArgs } from "./RowSelectionEventArgs";
import { ColumnSelectionEventArgs } from "./ColumnSelectionEventArgs";
import { SortingEventArgs } from "./SortingEventArgs";
import { SortingExpressionEventArgs } from "./SortingExpressionEventArgs";
import { FilteringEventArgs } from "./FilteringEventArgs";
import { RowDataEventArgs } from "./RowDataEventArgs";
import { ColumnVisibilityChangingEventArgs } from "./ColumnVisibilityChangingEventArgs";
import { ColumnVisibilityChangedEventArgs } from "./ColumnVisibilityChangedEventArgs";
import { GridKeydownEventArgs } from "./GridKeydownEventArgs";
import { GridClipboardEventEventArgs } from "./GridClipboardEventEventArgs";
import { RowToggleEventArgs } from "./RowToggleEventArgs";
import { ActiveNodeChangeEventArgs } from "./ActiveNodeChangeEventArgs";
import { GridSelectionRangeEventArgs } from "./GridSelectionRangeEventArgs";
import { VoidEventArgs } from "igniteui-react";
import { ForOfDataChangingEventArgs } from "./ForOfDataChangingEventArgs";
import { DropPosition_$type } from "./DropPosition";
import { GridSelectionRange } from "./GridSelectionRange";
import { CellPosition } from "./CellPosition";
import { Paginator } from "./Paginator";
import { GridState } from "./GridState";
import { DisplayDensityBaseElement } from "./DisplayDensityBaseElement";
import { GridToolbarContentCollection } from "./GridToolbarContentCollection";
import { ValidationStatus_$type } from "./ValidationStatus";
import { DisplayDensity_$type } from "./DisplayDensity";
import { SortingDirection_$type } from "./SortingDirection";
import { TreeGridRecord } from "./TreeGridRecord";
/**
 * @hidden
 */
var BaseExporter = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BaseExporter, _super);
    function BaseExporter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = new WCNativeHelper();
        _this.f = null;
        _this.exportEnded = null;
        _this.rowExporting = null;
        _this.columnExporting = null;
        return _this;
    }
    Object.defineProperty(BaseExporter.prototype, "e", {
        get: function () {
            return this.d;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseExporter.prototype, "nativeElement", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            this.f = a;
            this.d.o = this.f;
        },
        enumerable: false,
        configurable: true
    });
    BaseExporter.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    BaseExporter.prototype.exportEndedChanged = function () {
        var _this = this;
        if (this.exportEnded != null) {
            this.e.r("exportEnded", function (a) { return _this.exportEnded(_this, BaseEventArgs.a(a)); }, false);
        }
        else {
            this.e.u("exportEnded");
        }
    };
    BaseExporter.prototype.rowExportingChanged = function () {
        var _this = this;
        if (this.rowExporting != null) {
            this.e.r("rowExporting", function (a) { return _this.rowExporting(_this, RowExportingEventArgs.a(a)); }, false);
        }
        else {
            this.e.u("rowExporting");
        }
    };
    BaseExporter.prototype.columnExportingChanged = function () {
        var _this = this;
        if (this.columnExporting != null) {
            this.e.r("columnExporting", function (a) { return _this.columnExporting(_this, ColumnExportingEventArgs.a(a)); }, false);
        }
        else {
            this.e.u("columnExporting");
        }
    };
    BaseExporter.prototype.l = function (a, b) {
        this.nativeElement.export(this.e.i(a), this.e.i(b));
    };
    BaseExporter.prototype.j = function (a, b) {
        this.nativeElement.exportData(this.e.i(a), this.e.i(b));
    };
    BaseExporter.prototype.h = function (a) {
        this.nativeElement.addPivotGridColumns(this.e.i(a));
    };
    BaseExporter.$t = markType(BaseExporter, 'BaseExporter', BaseElement.$);
    return BaseExporter;
}(BaseElement));
export { BaseExporter };
/**
 * @hidden
 */
var CellTemplateContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CellTemplateContext, _super);
    function CellTemplateContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.d = null;
        return _this;
    }
    Object.defineProperty(CellTemplateContext.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellTemplateContext.prototype, "nativeElement", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            this.b.o = this.d;
        },
        enumerable: false,
        configurable: true
    });
    CellTemplateContext.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(CellTemplateContext.prototype, "f", {
        get: function () {
            var ret_ = this.c.n("implicit");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("implicit", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellTemplateContext.prototype, "e", {
        get: function () {
            var ret_ = this.c.n("additionalTemplateContext");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("additionalTemplateContext", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellTemplateContext.prototype, "a", {
        get: function () {
            var ret_ = this.c.m("cell", function (a) { return new CellType(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("cell", value_);
        },
        enumerable: false,
        configurable: true
    });
    CellTemplateContext.$t = markType(CellTemplateContext, 'CellTemplateContext');
    return CellTemplateContext;
}(Base));
export { CellTemplateContext };
/**
 * @hidden
 */
var CellType = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CellType, _super);
    function CellType() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.g = new WCNativeHelper();
        _this.p = null;
        return _this;
    }
    Object.defineProperty(CellType.prototype, "h", {
        get: function () {
            return this.g;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "nativeElement", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            this.p = a;
            this.g.o = this.p;
        },
        enumerable: false,
        configurable: true
    });
    CellType.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(CellType.prototype, "u", {
        get: function () {
            var ret_ = this.h.n("value");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("value", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "r", {
        get: function () {
            var ret_ = this.h.n("editValue");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("editValue", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "m", {
        get: function () {
            var ret_ = this.h.n("selected");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("selected", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "i", {
        get: function () {
            var ret_ = this.h.n("active");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("active", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "j", {
        get: function () {
            var ret_ = this.h.n("editable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("editable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "k", {
        get: function () {
            var ret_ = this.h.n("editMode");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("editMode", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "b", {
        get: function () {
            var ret_ = this.h.m("column", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("column", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "f", {
        get: function () {
            var ret_ = this.h.m("row", function (a) { return new RowType(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("row", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "c", {
        get: function () {
            var ret_ = this.h.n("grid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("grid", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "d", {
        get: function () {
            var ret_ = this.h.m("id", function (a) { return new GridCellIdentifier(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("id", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "q", {
        get: function () {
            var ret_ = this.h.n("cellID");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("cellID", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "e", {
        get: function () {
            var ret_ = this.h.m("validation", function (a) { return new GridValidationState(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("validation", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "l", {
        get: function () {
            var ret_ = this.h.n("readonly");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("readonly", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "t", {
        get: function () {
            var ret_ = this.h.n("title");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("title", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "v", {
        get: function () {
            var ret_ = this.h.n("width");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("width", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CellType.prototype, "o", {
        get: function () {
            var ret_ = this.h.n("visibleColumnIndex");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.h.v("visibleColumnIndex", value_);
        },
        enumerable: false,
        configurable: true
    });
    CellType.prototype.y = function (a) {
        this.nativeElement.update(this.h.i(a));
    };
    CellType.prototype.w = function (a) {
        this.nativeElement.setEditMode(this.h.i(a));
    };
    CellType.prototype.n = function (a) {
        return (this.nativeElement.calculateSizeToFit(this.h.i(a)));
    };
    CellType.$t = markType(CellType, 'CellType');
    CellType.__marshalByValueIgnore = ["row"];
    return CellType;
}(Base));
export { CellType };
/**
 * @hidden
 */
var Column = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Column, _super);
    function Column() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.h = new WCNativeHelper();
        _this.ah = null;
        _this.av = null;
        _this.aq = null;
        _this.at = null;
        _this.au = null;
        _this.ar = null;
        _this.as = null;
        return _this;
    }
    Object.defineProperty(Column.prototype, "i", {
        get: function () {
            return this.h;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "nativeElement", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            this.ah = a;
            this.h.o = this.ah;
        },
        enumerable: false,
        configurable: true
    });
    Column.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(Column.prototype, "a2", {
        get: function () {
            var ret_ = this.i.n("field");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("field", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "a3", {
        get: function () {
            var ret_ = this.i.n("header");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("header", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "a9", {
        get: function () {
            var ret_ = this.i.n("title");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("title", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "z", {
        get: function () {
            var ret_ = this.i.n("sortable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("sortable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "x", {
        get: function () {
            var ret_ = this.i.n("selectable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("selectable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "p", {
        get: function () {
            var ret_ = this.i.n("groupable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("groupable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "m", {
        get: function () {
            var ret_ = this.i.n("editable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("editable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "n", {
        get: function () {
            var ret_ = this.i.n("filterable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("filterable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "v", {
        get: function () {
            var ret_ = this.i.n("resizable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("resizable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "j", {
        get: function () {
            var ret_ = this.i.n("autosizeHeader");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("autosizeHeader", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "q", {
        get: function () {
            var ret_ = this.i.n("hasSummary");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("hasSummary", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "r", {
        get: function () {
            var ret_ = this.i.n("hidden");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("hidden", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "y", {
        get: function () {
            var ret_ = this.i.n("selected");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("selected", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "k", {
        get: function () {
            var ret_ = this.i.n("disableHiding");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("disableHiding", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "l", {
        get: function () {
            var ret_ = this.i.n("disablePinning");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("disablePinning", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "s", {
        get: function () {
            var ret_ = this.i.n("movable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("movable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "ba", {
        get: function () {
            var ret_ = this.i.n("width");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("width", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "a6", {
        get: function () {
            var ret_ = this.i.n("maxWidth");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("maxWidth", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "a4", {
        get: function () {
            var ret_ = this.i.n("headerClasses");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("headerClasses", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "am", {
        get: function () {
            var ret_ = this.i.n("headerStyles");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("headerStyles", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "a5", {
        get: function () {
            var ret_ = this.i.n("headerGroupClasses");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("headerGroupClasses", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "al", {
        get: function () {
            var ret_ = this.i.n("headerGroupStyles");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("headerGroupStyles", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "aj", {
        get: function () {
            var ret_ = this.i.n("cellClasses");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("cellClasses", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "ak", {
        get: function () {
            var ret_ = this.i.n("cellStyles");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("cellStyles", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "b", {
        get: function () {
            var ret_ = this.i.n("formatter");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("formatter", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "g", {
        get: function () {
            var ret_ = this.i.n("summaryFormatter");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("summaryFormatter", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "o", {
        get: function () {
            var ret_ = this.i.n("filteringIgnoreCase");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("filteringIgnoreCase", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "aa", {
        get: function () {
            var ret_ = this.i.n("sortingIgnoreCase");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("sortingIgnoreCase", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "w", {
        get: function () {
            var ret_ = this.i.n("searchable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("searchable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "e", {
        get: function () {
            var ret_ = this.i.n("dataType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridColumnDataType_$type, EnumUtil.getEnumValue(GridColumnDataType_$type, this.i.f(GridColumnDataType_$type, ret_)));
            return EnumUtil.getEnumValue(GridColumnDataType_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridColumnDataType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.i.v("dataType", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "af", {
        get: function () {
            var ret_ = this.i.n("rowEnd");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("rowEnd", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "ad", {
        get: function () {
            var ret_ = this.i.n("colEnd");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("colEnd", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "ag", {
        get: function () {
            var ret_ = this.i.n("rowStart");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("rowStart", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "ae", {
        get: function () {
            var ret_ = this.i.n("colStart");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("colStart", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "ai", {
        get: function () {
            var ret_ = this.i.n("additionalTemplateContext");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("additionalTemplateContext", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "a7", {
        get: function () {
            var ret_ = this.i.n("minWidth");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("minWidth", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "u", {
        get: function () {
            var ret_ = this.i.n("pinned");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("pinned", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "ap", {
        get: function () {
            var ret_ = this.i.n("summaries");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("summaries", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "d", {
        get: function () {
            var ret_ = this.i.m("filters", function (a) { return new FilteringOperand(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("filters", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "f", {
        get: function () {
            var ret_ = this.i.m("sortStrategy", function (a) { return new SortingStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("sortStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "a1", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            this.av = a;
            this.i.s("summaryTemplate", function (b) { return new SummaryTemplateContext(); }, this.av);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "aw", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            this.aq = a;
            this.i.s("bodyTemplate", function (b) { return new CellTemplateContext(); }, this.aq);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "az", {
        get: function () {
            return this.at;
        },
        set: function (a) {
            this.at = a;
            this.i.s("headerTemplate", function (b) { return new ColumnTemplateContext(); }, this.at);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "a0", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            this.au = a;
            this.i.s("inlineEditorTemplate", function (b) { return new CellTemplateContext(); }, this.au);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "ax", {
        get: function () {
            return this.ar;
        },
        set: function (a) {
            this.ar = a;
            this.i.s("errorTemplate", function (b) { return new CellTemplateContext(); }, this.ar);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "ay", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            this.as = a;
            this.i.s("filterCellTemplate", function (b) { return new ColumnTemplateContext(); }, this.as);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "ac", {
        get: function () {
            var ret_ = this.i.n("visibleWhenCollapsed");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("visibleWhenCollapsed", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "c", {
        get: function () {
            var ret_ = this.i.m("pipeArgs", function (a) { return new ColumnPipeArgs(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("pipeArgs", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "ao", {
        get: function () {
            var ret_ = this.i.n("parent");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("parent", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "a", {
        get: function () {
            var ret_ = this.i.m("columnChildren", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("columnChildren", value_);
        },
        enumerable: false,
        configurable: true
    });
    Column.prototype.t = function (a) {
        if (a === void 0) {
            a = -1;
        }
        return (this.nativeElement.pin(this.i.i(a)));
    };
    Column.prototype.ab = function (a) {
        if (a === void 0) {
            a = -1;
        }
        return (this.nativeElement.unpin(this.i.i(a)));
    };
    Column.prototype.bc = function (a) {
        this.nativeElement.move(this.i.i(a));
    };
    Column.prototype.bb = function (a) {
        if (a === void 0) {
            a = false;
        }
        this.nativeElement.autosize(this.i.i(a));
    };
    Object.defineProperty(Column.prototype, "a8", {
        get: function () {
            var ret_ = this.i.n("name");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("name", value_);
        },
        enumerable: false,
        configurable: true
    });
    Column.$t = markType(Column, 'Column', BaseElement.$);
    return Column;
}(BaseElement));
export { Column };
/**
 * @hidden
 */
var ColumnComponentEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnComponentEventArgs, _super);
    function ColumnComponentEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        return _this;
    }
    ColumnComponentEventArgs.b = function (a) {
        return ((function () {
            var $ret = new ColumnComponentEventArgs();
            $ret.a = WCNativeHelper.h(a, function (b) { return new Column(); });
            return $ret;
        })());
    };
    ColumnComponentEventArgs.$t = markType(ColumnComponentEventArgs, 'ColumnComponentEventArgs');
    return ColumnComponentEventArgs;
}(Base));
export { ColumnComponentEventArgs };
/**
 * @hidden
 */
var ColumnExportingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnExportingEventArgs, _super);
    function ColumnExportingEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    ColumnExportingEventArgs.a = function (a) {
        return ((function () {
            var $ret = new ColumnExportingEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new ColumnExportingEventArgsDetail(); });
            return $ret;
        })());
    };
    ColumnExportingEventArgs.$t = markType(ColumnExportingEventArgs, 'ColumnExportingEventArgs');
    return ColumnExportingEventArgs;
}(Base));
export { ColumnExportingEventArgs };
/**
 * @hidden
 */
var ColumnExportingEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnExportingEventArgsDetail, _super);
    function ColumnExportingEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(ColumnExportingEventArgsDetail.prototype, "l", {
        get: function () {
            var ret_ = this.b.n("header");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("header", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnExportingEventArgsDetail.prototype, "k", {
        get: function () {
            var ret_ = this.b.n("field");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("field", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnExportingEventArgsDetail.prototype, "j", {
        get: function () {
            var ret_ = this.b.n("columnIndex");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("columnIndex", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnExportingEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.n("cancel");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("cancel", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnExportingEventArgsDetail.prototype, "i", {
        get: function () {
            var ret_ = this.b.n("skipFormatter");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("skipFormatter", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnExportingEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.n("grid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("grid", value_);
        },
        enumerable: false,
        configurable: true
    });
    ColumnExportingEventArgsDetail.$t = markType(ColumnExportingEventArgsDetail, 'ColumnExportingEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnExportingEventArgsDetail;
}(BaseEventArgsDetail));
export { ColumnExportingEventArgsDetail };
/**
 * @hidden
 */
var ColumnMovingEndEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnMovingEndEventArgs, _super);
    function ColumnMovingEndEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    ColumnMovingEndEventArgs.a = function (a) {
        return ((function () {
            var $ret = new ColumnMovingEndEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new ColumnMovingEndEventArgsDetail(); });
            return $ret;
        })());
    };
    ColumnMovingEndEventArgs.$t = markType(ColumnMovingEndEventArgs, 'ColumnMovingEndEventArgs');
    return ColumnMovingEndEventArgs;
}(Base));
export { ColumnMovingEndEventArgs };
/**
 * @hidden
 */
var ColumnMovingEndEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnMovingEndEventArgsDetail, _super);
    function ColumnMovingEndEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(ColumnMovingEndEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.m("source", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("source", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnMovingEndEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.m("target", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("target", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnMovingEndEventArgsDetail.prototype, "i", {
        get: function () {
            var ret_ = this.b.n("cancel");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("cancel", value_);
        },
        enumerable: false,
        configurable: true
    });
    ColumnMovingEndEventArgsDetail.$t = markType(ColumnMovingEndEventArgsDetail, 'ColumnMovingEndEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnMovingEndEventArgsDetail;
}(BaseEventArgsDetail));
export { ColumnMovingEndEventArgsDetail };
/**
 * @hidden
 */
var ColumnMovingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnMovingEventArgs, _super);
    function ColumnMovingEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    ColumnMovingEventArgs.a = function (a) {
        return ((function () {
            var $ret = new ColumnMovingEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new ColumnMovingEventArgsDetail(); });
            return $ret;
        })());
    };
    ColumnMovingEventArgs.$t = markType(ColumnMovingEventArgs, 'ColumnMovingEventArgs');
    return ColumnMovingEventArgs;
}(Base));
export { ColumnMovingEventArgs };
/**
 * @hidden
 */
var ColumnMovingEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnMovingEventArgsDetail, _super);
    function ColumnMovingEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(ColumnMovingEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.m("source", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("source", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnMovingEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.n("cancel");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("cancel", value_);
        },
        enumerable: false,
        configurable: true
    });
    ColumnMovingEventArgsDetail.$t = markType(ColumnMovingEventArgsDetail, 'ColumnMovingEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnMovingEventArgsDetail;
}(BaseEventArgsDetail));
export { ColumnMovingEventArgsDetail };
/**
 * @hidden
 */
var ColumnMovingStartEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnMovingStartEventArgs, _super);
    function ColumnMovingStartEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    ColumnMovingStartEventArgs.a = function (a) {
        return ((function () {
            var $ret = new ColumnMovingStartEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new ColumnMovingStartEventArgsDetail(); });
            return $ret;
        })());
    };
    ColumnMovingStartEventArgs.$t = markType(ColumnMovingStartEventArgs, 'ColumnMovingStartEventArgs');
    return ColumnMovingStartEventArgs;
}(Base));
export { ColumnMovingStartEventArgs };
/**
 * @hidden
 */
var ColumnMovingStartEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnMovingStartEventArgsDetail, _super);
    function ColumnMovingStartEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(ColumnMovingStartEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.m("source", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("source", value_);
        },
        enumerable: false,
        configurable: true
    });
    ColumnMovingStartEventArgsDetail.$t = markType(ColumnMovingStartEventArgsDetail, 'ColumnMovingStartEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnMovingStartEventArgsDetail;
}(BaseEventArgsDetail));
export { ColumnMovingStartEventArgsDetail };
/**
 * @hidden
 */
var ColumnResizeEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnResizeEventArgs, _super);
    function ColumnResizeEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    ColumnResizeEventArgs.a = function (a) {
        return ((function () {
            var $ret = new ColumnResizeEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new ColumnResizeEventArgsDetail(); });
            return $ret;
        })());
    };
    ColumnResizeEventArgs.$t = markType(ColumnResizeEventArgs, 'ColumnResizeEventArgs');
    return ColumnResizeEventArgs;
}(Base));
export { ColumnResizeEventArgs };
/**
 * @hidden
 */
var ColumnResizeEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnResizeEventArgsDetail, _super);
    function ColumnResizeEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(ColumnResizeEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.m("column", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("column", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnResizeEventArgsDetail.prototype, "i", {
        get: function () {
            var ret_ = this.b.n("prevWidth");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("prevWidth", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnResizeEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.n("newWidth");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("newWidth", value_);
        },
        enumerable: false,
        configurable: true
    });
    ColumnResizeEventArgsDetail.$t = markType(ColumnResizeEventArgsDetail, 'ColumnResizeEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnResizeEventArgsDetail;
}(BaseEventArgsDetail));
export { ColumnResizeEventArgsDetail };
/**
 * @hidden
 */
var ColumnsAutoGeneratedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnsAutoGeneratedEventArgs, _super);
    function ColumnsAutoGeneratedEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    ColumnsAutoGeneratedEventArgs.a = function (a) {
        return ((function () {
            var $ret = new ColumnsAutoGeneratedEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new ColumnsAutoGeneratedEventArgsDetail(); });
            return $ret;
        })());
    };
    ColumnsAutoGeneratedEventArgs.$t = markType(ColumnsAutoGeneratedEventArgs, 'ColumnsAutoGeneratedEventArgs');
    return ColumnsAutoGeneratedEventArgs;
}(Base));
export { ColumnsAutoGeneratedEventArgs };
/**
 * @hidden
 */
var ColumnsAutoGeneratedEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnsAutoGeneratedEventArgsDetail, _super);
    function ColumnsAutoGeneratedEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(ColumnsAutoGeneratedEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.k("columns", function (a) { return new ColumnCollection(); }, function (a) { return new Column(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    ColumnsAutoGeneratedEventArgsDetail.$t = markType(ColumnsAutoGeneratedEventArgsDetail, 'ColumnsAutoGeneratedEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnsAutoGeneratedEventArgsDetail;
}(BaseEventArgsDetail));
export { ColumnsAutoGeneratedEventArgsDetail };
/**
 * @hidden
 */
var ColumnCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnCollection, _super);
    function ColumnCollection() {
        return _super.call(this, Column.$, 0) || this;
    }
    ColumnCollection.$t = markType(ColumnCollection, 'ColumnCollection', ObservableCollection$1.$.specialize(Column.$));
    return ColumnCollection;
}(ObservableCollection$1));
export { ColumnCollection };
/**
 * @hidden
 */
var ColumnTemplateContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnTemplateContext, _super);
    function ColumnTemplateContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = new WCNativeHelper();
        _this.e = null;
        return _this;
    }
    Object.defineProperty(ColumnTemplateContext.prototype, "d", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnTemplateContext.prototype, "nativeElement", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
            this.c.o = this.e;
        },
        enumerable: false,
        configurable: true
    });
    ColumnTemplateContext.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(ColumnTemplateContext.prototype, "b", {
        get: function () {
            var ret_ = this.d.m("implicit", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("implicit", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnTemplateContext.prototype, "a", {
        get: function () {
            var ret_ = this.d.m("column", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("column", value_);
        },
        enumerable: false,
        configurable: true
    });
    ColumnTemplateContext.$t = markType(ColumnTemplateContext, 'ColumnTemplateContext');
    return ColumnTemplateContext;
}(Base));
export { ColumnTemplateContext };
/**
 * @hidden
 */
var SummaryOperand = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SummaryOperand, _super);
    function SummaryOperand() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.e = null;
        return _this;
    }
    Object.defineProperty(SummaryOperand.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SummaryOperand.prototype, "nativeElement", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
            this.b.o = this.e;
        },
        enumerable: false,
        configurable: true
    });
    SummaryOperand.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    SummaryOperand.prototype.d = function (a) {
        return (this.nativeElement.count(this.c.i(a)));
    };
    SummaryOperand.prototype.a = function (a, b, c, d) {
        return this.c.g(this.nativeElement.operate(this.c.i(a), this.c.i(b), this.c.i(c), this.c.i(d)), function (e) { return new SummaryResult(); });
    };
    SummaryOperand.$t = markType(SummaryOperand, 'SummaryOperand');
    return SummaryOperand;
}(Base));
export { SummaryOperand };
/**
 * @hidden
 */
var FilteringStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FilteringStrategy, _super);
    function FilteringStrategy() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.d = null;
        return _this;
    }
    Object.defineProperty(FilteringStrategy.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilteringStrategy.prototype, "nativeElement", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            this.b.o = this.d;
        },
        enumerable: false,
        configurable: true
    });
    FilteringStrategy.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    FilteringStrategy.prototype.a = function (a, b, c, d) {
        return (this.nativeElement.filter(this.c.i(a), this.c.i(b), this.c.i(c), this.c.i(d)));
    };
    FilteringStrategy.$t = markType(FilteringStrategy, 'FilteringStrategy');
    return FilteringStrategy;
}(Base));
export { FilteringStrategy };
/**
 * @hidden
 */
var GridBaseDirective = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridBaseDirective, _super);
    function GridBaseDirective() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c9 = null;
        _this.c6 = null;
        _this.de = null;
        _this.c7 = null;
        _this.di = null;
        _this.df = null;
        _this.dh = null;
        _this.dj = null;
        _this.dg = null;
        _this.dc = null;
        _this.db = null;
        _this.da = null;
        _this.dl = null;
        _this.dm = null;
        _this.dn = null;
        _this.dd = null;
        _this.dk = null;
        _this.c8 = null;
        _this.filteringExpressionsTreeChange = null;
        _this.advancedFilteringExpressionsTreeChange = null;
        _this.gridScroll = null;
        _this.cellClick = null;
        _this.formGroupCreated = null;
        _this.validationStatusChange = null;
        _this.selected = null;
        _this.rowSelectionChanging = null;
        _this.columnSelectionChanging = null;
        _this.columnPin = null;
        _this.columnPinned = null;
        _this.cellEditEnter = null;
        _this.cellEditExit = null;
        _this.cellEdit = null;
        _this.cellEditDone = null;
        _this.rowEditEnter = null;
        _this.rowEdit = null;
        _this.rowEditDone = null;
        _this.rowEditExit = null;
        _this.columnInit = null;
        _this.columnsAutogenerated = null;
        _this.sorting = null;
        _this.sortingDone = null;
        _this.filtering = null;
        _this.filteringDone = null;
        _this.rowAdded = null;
        _this.rowDeleted = null;
        _this.rowDelete = null;
        _this.rowAdd = null;
        _this.columnResized = null;
        _this.contextMenu = null;
        _this.doubleClick = null;
        _this.columnVisibilityChanging = null;
        _this.columnVisibilityChanged = null;
        _this.columnMovingStart = null;
        _this.columnMoving = null;
        _this.columnMovingEnd = null;
        _this.gridKeydown = null;
        _this.rowDragStart = null;
        _this.rowDragEnd = null;
        _this.gridCopy = null;
        _this.rowToggle = null;
        _this.rowPinning = null;
        _this.rowPinned = null;
        _this.activeNodeChange = null;
        _this.sortingExpressionsChange = null;
        _this.toolbarExporting = null;
        _this.rangeSelected = null;
        _this.rendered = null;
        _this.dataChanging = null;
        _this.dataChanged = null;
        _this.z = new ColumnCollection();
        return _this;
    }
    Object.defineProperty(GridBaseDirective.prototype, "cy", {
        get: function () {
            var ret_ = this.d.n("snackbarDisplayTime");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("snackbarDisplayTime", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "ce", {
        get: function () {
            var ret_ = this.d.n("autoGenerate");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("autoGenerate", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "i", {
        get: function () {
            var ret_ = this.d.n("autoGenerateExclude");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("autoGenerateExclude", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "ci", {
        get: function () {
            var ret_ = this.d.n("moving");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("moving", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "ds", {
        get: function () {
            return this.c9;
        },
        set: function (a) {
            this.c9 = a;
            this.d.s("emptyGridTemplate", function (b) { return b; }, this.c9);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "dp", {
        get: function () {
            return this.c6;
        },
        set: function (a) {
            this.c6 = a;
            this.d.s("addRowEmptyTemplate", function (b) { return b; }, this.c6);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "dx", {
        get: function () {
            return this.de;
        },
        set: function (a) {
            this.de = a;
            this.d.s("loadingGridTemplate", function (b) { return b; }, this.de);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cz", {
        get: function () {
            var ret_ = this.d.n("summaryRowHeight");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("summaryRowHeight", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "al", {
        get: function () {
            var ret_ = this.d.m("dataCloneStrategy", function (a) { return new DataCloneStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("dataCloneStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "w", {
        get: function () {
            var ret_ = this.d.m("clipboardOptions", function (a) { return new ClipboardOptions(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("clipboardOptions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "c4", {
        get: function () {
            var ret_ = this.d.n("rowClasses");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("rowClasses", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "c5", {
        get: function () {
            var ret_ = this.d.n("rowStyles");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("rowStyles", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "ed", {
        get: function () {
            var ret_ = this.d.n("primaryKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("primaryKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "s", {
        get: function () {
            var ret_ = this.d.l("actionStripComponents", function (a) { return new ActionStripCollection(); }, function (a) { return new ActionStrip(); }, ["ActionStrip"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "dq", {
        get: function () {
            return this.c7;
        },
        set: function (a) {
            this.c7 = a;
            this.d.s("dragGhostCustomTemplate", function (b) { return new GridRowDragGhostContext(); }, this.c7);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "d1", {
        get: function () {
            return this.di;
        },
        set: function (a) {
            this.di = a;
            this.d.s("rowEditTextTemplate", function (b) { return new GridRowEditTextTemplateContext(); }, this.di);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "dy", {
        get: function () {
            return this.df;
        },
        set: function (a) {
            this.df = a;
            this.d.s("rowAddTextTemplate", function (b) { return new GridEmptyTemplateContext(); }, this.df);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "d0", {
        get: function () {
            return this.dh;
        },
        set: function (a) {
            this.dh = a;
            this.d.s("rowEditActionsTemplate", function (b) { return new GridRowEditActionsTemplateContext(); }, this.dh);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "d2", {
        get: function () {
            return this.dj;
        },
        set: function (a) {
            this.dj = a;
            this.d.s("rowExpandedIndicatorTemplate", function (b) { return new GridRowTemplateContext(); }, this.dj);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "dz", {
        get: function () {
            return this.dg;
        },
        set: function (a) {
            this.dg = a;
            this.d.s("rowCollapsedIndicatorTemplate", function (b) { return new GridRowTemplateContext(); }, this.dg);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "dv", {
        get: function () {
            return this.dc;
        },
        set: function (a) {
            this.dc = a;
            this.d.s("headerExpandedIndicatorTemplate", function (b) { return new GridTemplateContext(); }, this.dc);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "du", {
        get: function () {
            return this.db;
        },
        set: function (a) {
            this.db = a;
            this.d.s("headerCollapsedIndicatorTemplate", function (b) { return new GridTemplateContext(); }, this.db);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "dt", {
        get: function () {
            return this.da;
        },
        set: function (a) {
            this.da = a;
            this.d.s("excelStyleHeaderIconTemplate", function (b) { return new GridHeaderTemplateContext(); }, this.da);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "d4", {
        get: function () {
            return this.dl;
        },
        set: function (a) {
            this.dl = a;
            this.d.s("sortAscendingHeaderIconTemplate", function (b) { return new GridHeaderTemplateContext(); }, this.dl);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "d5", {
        get: function () {
            return this.dm;
        },
        set: function (a) {
            this.dm = a;
            this.d.s("sortDescendingHeaderIconTemplate", function (b) { return new GridHeaderTemplateContext(); }, this.dm);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "d6", {
        get: function () {
            return this.dn;
        },
        set: function (a) {
            this.dn = a;
            this.d.s("sortHeaderIconTemplate", function (b) { return new GridHeaderTemplateContext(); }, this.dn);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "bo", {
        get: function () {
            var ret_ = this.d.l("toolbar", function (a) { return new GridToolbarCollection(); }, function (a) { return new GridToolbar(); }, ["GridToolbar"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "bt", {
        get: function () {
            var ret_ = this.d.l("paginationComponents", function (a) { return new PaginatorCollection(); }, function (a) { return new Paginator(); }, ["Paginator"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "bf", {
        get: function () {
            var ret_ = this.d.m("resourceStrings", function (a) { return new GridResourceStrings(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("resourceStrings", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "as", {
        get: function () {
            var ret_ = this.d.n("filteringLogic");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilteringLogic_$type, EnumUtil.getEnumValue(FilteringLogic_$type, this.d.f(FilteringLogic_$type, ret_)));
            return EnumUtil.getEnumValue(FilteringLogic_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(FilteringLogic_$type, a);
            value_ = this.d.f(FilteringLogic_$type, value_);
            this.d.v("filteringLogic", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "ao", {
        get: function () {
            var ret_ = this.d.m("filteringExpressionsTree", function (a) { return new FilteringExpressionsTree(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("filteringExpressionsTree", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "an", {
        get: function () {
            var ret_ = this.d.m("advancedFilteringExpressionsTree", function (a) { return new FilteringExpressionsTree(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("advancedFilteringExpressionsTree", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "ec", {
        get: function () {
            var ret_ = this.d.n("locale");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("locale", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "be", {
        get: function () {
            var ret_ = this.d.n("pagingMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridPagingMode_$type, EnumUtil.getEnumValue(GridPagingMode_$type, this.d.f(GridPagingMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridPagingMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridPagingMode_$type, a);
            value_ = this.d.f(GridPagingMode_$type, value_);
            this.d.v("pagingMode", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cg", {
        get: function () {
            var ret_ = this.d.n("hideRowSelectors");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("hideRowSelectors", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "ck", {
        get: function () {
            var ret_ = this.d.n("rowDraggable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("rowDraggable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "br", {
        get: function () {
            var ret_ = this.d.n("validationTrigger");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridValidationTrigger_$type, EnumUtil.getEnumValue(GridValidationTrigger_$type, this.d.f(GridValidationTrigger_$type, ret_)));
            return EnumUtil.getEnumValue(GridValidationTrigger_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridValidationTrigger_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("validationTrigger", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cl", {
        get: function () {
            var ret_ = this.d.n("rowEditable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("rowEditable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "eb", {
        get: function () {
            var ret_ = this.d.n("height");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("height", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "ee", {
        get: function () {
            var ret_ = this.d.n("width");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("width", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cx", {
        get: function () {
            var ret_ = this.d.n("rowHeight");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("rowHeight", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "d7", {
        get: function () {
            var ret_ = this.d.n("columnWidth");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("columnWidth", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "d9", {
        get: function () {
            var ret_ = this.d.n("emptyGridMessage");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("emptyGridMessage", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "ch", {
        get: function () {
            var ret_ = this.d.n("isLoading");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("isLoading", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cn", {
        get: function () {
            var ret_ = this.d.n("shouldGenerate");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("shouldGenerate", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "d8", {
        get: function () {
            var ret_ = this.d.n("emptyFilteredGridMessage");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("emptyFilteredGridMessage", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "bw", {
        get: function () {
            var ret_ = this.d.m("pinning", function (a) { return new PinningConfig(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("pinning", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cd", {
        get: function () {
            var ret_ = this.d.n("allowFiltering");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("allowFiltering", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cc", {
        get: function () {
            var ret_ = this.d.n("allowAdvancedFiltering");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("allowAdvancedFiltering", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "au", {
        get: function () {
            var ret_ = this.d.n("filterMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilterMode_$type, EnumUtil.getEnumValue(FilterMode_$type, this.d.f(FilterMode_$type, ret_)));
            return EnumUtil.getEnumValue(FilterMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(FilterMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("filterMode", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "bn", {
        get: function () {
            var ret_ = this.d.n("summaryPosition");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSummaryPosition_$type, EnumUtil.getEnumValue(GridSummaryPosition_$type, this.d.f(GridSummaryPosition_$type, ret_)));
            return EnumUtil.getEnumValue(GridSummaryPosition_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridSummaryPosition_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("summaryPosition", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "bm", {
        get: function () {
            var ret_ = this.d.n("summaryCalculationMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSummaryCalculationMode_$type, EnumUtil.getEnumValue(GridSummaryCalculationMode_$type, this.d.f(GridSummaryCalculationMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSummaryCalculationMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridSummaryCalculationMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("summaryCalculationMode", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "co", {
        get: function () {
            var ret_ = this.d.n("showSummaryOnCollapse");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("showSummaryOnCollapse", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "at", {
        get: function () {
            var ret_ = this.d.m("filterStrategy", function (a) { return new FilteringStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("filterStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "bl", {
        get: function () {
            var ret_ = this.d.m("sortStrategy", function (a) { return new GridSortingStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("sortStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "b8", {
        get: function () {
            var ret_ = this.d.m("sortingOptions", function (a) { return new SortingOptions(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("sortingOptions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "o", {
        get: function () {
            var ret_ = this.d.n("selectedRows");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("selectedRows", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "dw", {
        get: function () {
            return this.dd;
        },
        set: function (a) {
            this.dd = a;
            this.d.s("headSelectorTemplate", function (b) { return new HeadSelectorTemplateContext(); }, this.dd);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "d3", {
        get: function () {
            return this.dk;
        },
        set: function (a) {
            this.dk = a;
            this.d.s("rowSelectorTemplate", function (b) { return new RowSelectorTemplateContext(); }, this.dk);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "dr", {
        get: function () {
            return this.c8;
        },
        set: function (a) {
            this.c8 = a;
            this.d.s("dragIndicatorIconTemplate", function (b) { return new GridEmptyTemplateContext(); }, this.c8);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "p", {
        get: function () {
            var ret_ = this.d.m("sortingExpressions", function (a) { return new SortingExpression(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("sortingExpressions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cu", {
        get: function () {
            var ret_ = this.d.n("hiddenColumnsCount");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cv", {
        get: function () {
            var ret_ = this.d.n("pinnedColumnsCount");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cf", {
        get: function () {
            var ret_ = this.d.n("batchEditing");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("batchEditing", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "bh", {
        get: function () {
            var ret_ = this.d.n("cellSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.d.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("cellSelection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "bj", {
        get: function () {
            var ret_ = this.d.n("rowSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.d.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("rowSelection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "bi", {
        get: function () {
            var ret_ = this.d.n("columnSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.d.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("columnSelection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "c2", {
        get: function () {
            var ret_ = this.d.n("filteredData");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "k", {
        get: function () {
            var ret_ = this.d.n("filteredSortedData");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "aw", {
        get: function () {
            var ret_ = this.d.m("virtualizationState", function (a) { return new ForOfState(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "bs", {
        get: function () {
            var ret_ = this.d.m("outlet", function (a) { return new OverlayOutletDirective(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("outlet", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cr", {
        get: function () {
            var ret_ = this.d.n("defaultRowHeight");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cq", {
        get: function () {
            var ret_ = this.d.n("defaultHeaderGroupMinWidth");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "ab", {
        get: function () {
            var ret_ = this.d.l("columns", function (a) { return new ColumnCollection(); }, function (a) { return new Column(); }, ["Column", "ColumnGroup", "ColumnLayout"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "m", {
        get: function () {
            var ret_ = this.d.m("pinnedColumns", function (a) { return new Column(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "q", {
        get: function () {
            var ret_ = this.d.m("unpinnedColumns", function (a) { return new Column(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "r", {
        get: function () {
            var ret_ = this.d.m("visibleColumns", function (a) { return new Column(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "c0", {
        get: function () {
            var ret_ = this.d.n("totalRecords");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("totalRecords", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "j", {
        get: function () {
            var ret_ = this.d.n("dataView");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "cm", {
        get: function () {
            var ret_ = this.d.n("selectRowOnClick");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("selectRowOnClick", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridBaseDirective.prototype.filteringExpressionsTreeChangeChanged = function () {
        var _this = this;
        if (this.filteringExpressionsTreeChange != null) {
            this.d.r("filteringExpressionsTreeChange", function (a) { return _this.filteringExpressionsTreeChange(_this, FilteringExpressionsTreeEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("filteringExpressionsTreeChange");
        }
    };
    GridBaseDirective.prototype.advancedFilteringExpressionsTreeChangeChanged = function () {
        var _this = this;
        if (this.advancedFilteringExpressionsTreeChange != null) {
            this.d.r("advancedFilteringExpressionsTreeChange", function (a) { return _this.advancedFilteringExpressionsTreeChange(_this, FilteringExpressionsTreeEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("advancedFilteringExpressionsTreeChange");
        }
    };
    GridBaseDirective.prototype.gridScrollChanged = function () {
        var _this = this;
        if (this.gridScroll != null) {
            this.d.r("gridScroll", function (a) { return _this.gridScroll(_this, GridScrollEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("gridScroll");
        }
    };
    GridBaseDirective.prototype.cellClickChanged = function () {
        var _this = this;
        if (this.cellClick != null) {
            this.d.r("cellClick", function (a) { return _this.cellClick(_this, GridCellEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("cellClick");
        }
    };
    GridBaseDirective.prototype.formGroupCreatedChanged = function () {
        var _this = this;
        if (this.formGroupCreated != null) {
            this.d.r("formGroupCreated", function (a) { return _this.formGroupCreated(_this, GridFormGroupCreatedEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("formGroupCreated");
        }
    };
    GridBaseDirective.prototype.validationStatusChangeChanged = function () {
        var _this = this;
        if (this.validationStatusChange != null) {
            this.d.r("validationStatusChange", function (a) { return _this.validationStatusChange(_this, GridValidationStatusEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("validationStatusChange");
        }
    };
    GridBaseDirective.prototype.selectedChanged = function () {
        var _this = this;
        if (this.selected != null) {
            this.d.r("selected", function (a) { return _this.selected(_this, GridCellEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("selected");
        }
    };
    GridBaseDirective.prototype.rowSelectionChangingChanged = function () {
        var _this = this;
        if (this.rowSelectionChanging != null) {
            this.d.r("rowSelectionChanging", function (a) { return _this.rowSelectionChanging(_this, RowSelectionEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowSelectionChanging");
        }
    };
    GridBaseDirective.prototype.columnSelectionChangingChanged = function () {
        var _this = this;
        if (this.columnSelectionChanging != null) {
            this.d.r("columnSelectionChanging", function (a) { return _this.columnSelectionChanging(_this, ColumnSelectionEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("columnSelectionChanging");
        }
    };
    GridBaseDirective.prototype.columnPinChanged = function () {
        var _this = this;
        if (this.columnPin != null) {
            this.d.r("columnPin", function (a) { return _this.columnPin(_this, PinColumnCancellableEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("columnPin");
        }
    };
    GridBaseDirective.prototype.columnPinnedChanged = function () {
        var _this = this;
        if (this.columnPinned != null) {
            this.d.r("columnPinned", function (a) { return _this.columnPinned(_this, PinColumnEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("columnPinned");
        }
    };
    GridBaseDirective.prototype.cellEditEnterChanged = function () {
        var _this = this;
        if (this.cellEditEnter != null) {
            this.d.r("cellEditEnter", function (a) { return _this.cellEditEnter(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("cellEditEnter");
        }
    };
    GridBaseDirective.prototype.cellEditExitChanged = function () {
        var _this = this;
        if (this.cellEditExit != null) {
            this.d.r("cellEditExit", function (a) { return _this.cellEditExit(_this, GridEditDoneEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("cellEditExit");
        }
    };
    GridBaseDirective.prototype.cellEditChanged = function () {
        var _this = this;
        if (this.cellEdit != null) {
            this.d.r("cellEdit", function (a) { return _this.cellEdit(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("cellEdit");
        }
    };
    GridBaseDirective.prototype.cellEditDoneChanged = function () {
        var _this = this;
        if (this.cellEditDone != null) {
            this.d.r("cellEditDone", function (a) { return _this.cellEditDone(_this, GridEditDoneEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("cellEditDone");
        }
    };
    GridBaseDirective.prototype.rowEditEnterChanged = function () {
        var _this = this;
        if (this.rowEditEnter != null) {
            this.d.r("rowEditEnter", function (a) { return _this.rowEditEnter(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowEditEnter");
        }
    };
    GridBaseDirective.prototype.rowEditChanged = function () {
        var _this = this;
        if (this.rowEdit != null) {
            this.d.r("rowEdit", function (a) { return _this.rowEdit(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowEdit");
        }
    };
    GridBaseDirective.prototype.rowEditDoneChanged = function () {
        var _this = this;
        if (this.rowEditDone != null) {
            this.d.r("rowEditDone", function (a) { return _this.rowEditDone(_this, GridEditDoneEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowEditDone");
        }
    };
    GridBaseDirective.prototype.rowEditExitChanged = function () {
        var _this = this;
        if (this.rowEditExit != null) {
            this.d.r("rowEditExit", function (a) { return _this.rowEditExit(_this, GridEditDoneEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowEditExit");
        }
    };
    GridBaseDirective.prototype.columnInitChanged = function () {
        var _this = this;
        if (this.columnInit != null) {
            this.d.r("columnInit", function (a) { return _this.columnInit(_this, ColumnComponentEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("columnInit");
        }
    };
    GridBaseDirective.prototype.columnsAutogeneratedChanged = function () {
        var _this = this;
        if (this.columnsAutogenerated != null) {
            this.d.r("columnsAutogenerated", function (a) { return _this.columnsAutogenerated(_this, ColumnsAutoGeneratedEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("columnsAutogenerated");
        }
    };
    GridBaseDirective.prototype.sortingChanged = function () {
        var _this = this;
        if (this.sorting != null) {
            this.d.r("sorting", function (a) { return _this.sorting(_this, SortingEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("sorting");
        }
    };
    GridBaseDirective.prototype.sortingDoneChanged = function () {
        var _this = this;
        if (this.sortingDone != null) {
            this.d.r("sortingDone", function (a) { return _this.sortingDone(_this, SortingExpressionEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("sortingDone");
        }
    };
    GridBaseDirective.prototype.filteringChanged = function () {
        var _this = this;
        if (this.filtering != null) {
            this.d.r("filtering", function (a) { return _this.filtering(_this, FilteringEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("filtering");
        }
    };
    GridBaseDirective.prototype.filteringDoneChanged = function () {
        var _this = this;
        if (this.filteringDone != null) {
            this.d.r("filteringDone", function (a) { return _this.filteringDone(_this, FilteringExpressionsTreeEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("filteringDone");
        }
    };
    GridBaseDirective.prototype.rowAddedChanged = function () {
        var _this = this;
        if (this.rowAdded != null) {
            this.d.r("rowAdded", function (a) { return _this.rowAdded(_this, RowDataEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowAdded");
        }
    };
    GridBaseDirective.prototype.rowDeletedChanged = function () {
        var _this = this;
        if (this.rowDeleted != null) {
            this.d.r("rowDeleted", function (a) { return _this.rowDeleted(_this, RowDataEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowDeleted");
        }
    };
    GridBaseDirective.prototype.rowDeleteChanged = function () {
        var _this = this;
        if (this.rowDelete != null) {
            this.d.r("rowDelete", function (a) { return _this.rowDelete(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowDelete");
        }
    };
    GridBaseDirective.prototype.rowAddChanged = function () {
        var _this = this;
        if (this.rowAdd != null) {
            this.d.r("rowAdd", function (a) { return _this.rowAdd(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowAdd");
        }
    };
    GridBaseDirective.prototype.columnResizedChanged = function () {
        var _this = this;
        if (this.columnResized != null) {
            this.d.r("columnResized", function (a) { return _this.columnResized(_this, ColumnResizeEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("columnResized");
        }
    };
    GridBaseDirective.prototype.contextMenuChanged = function () {
        var _this = this;
        if (this.contextMenu != null) {
            this.d.r("contextMenu", function (a) { return _this.contextMenu(_this, GridCellEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("contextMenu");
        }
    };
    GridBaseDirective.prototype.doubleClickChanged = function () {
        var _this = this;
        if (this.doubleClick != null) {
            this.d.r("doubleClick", function (a) { return _this.doubleClick(_this, GridCellEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("doubleClick");
        }
    };
    GridBaseDirective.prototype.columnVisibilityChangingChanged = function () {
        var _this = this;
        if (this.columnVisibilityChanging != null) {
            this.d.r("columnVisibilityChanging", function (a) { return _this.columnVisibilityChanging(_this, ColumnVisibilityChangingEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("columnVisibilityChanging");
        }
    };
    GridBaseDirective.prototype.columnVisibilityChangedChanged = function () {
        var _this = this;
        if (this.columnVisibilityChanged != null) {
            this.d.r("columnVisibilityChanged", function (a) { return _this.columnVisibilityChanged(_this, ColumnVisibilityChangedEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("columnVisibilityChanged");
        }
    };
    GridBaseDirective.prototype.columnMovingStartChanged = function () {
        var _this = this;
        if (this.columnMovingStart != null) {
            this.d.r("columnMovingStart", function (a) { return _this.columnMovingStart(_this, ColumnMovingStartEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("columnMovingStart");
        }
    };
    GridBaseDirective.prototype.columnMovingChanged = function () {
        var _this = this;
        if (this.columnMoving != null) {
            this.d.r("columnMoving", function (a) { return _this.columnMoving(_this, ColumnMovingEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("columnMoving");
        }
    };
    GridBaseDirective.prototype.columnMovingEndChanged = function () {
        var _this = this;
        if (this.columnMovingEnd != null) {
            this.d.r("columnMovingEnd", function (a) { return _this.columnMovingEnd(_this, ColumnMovingEndEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("columnMovingEnd");
        }
    };
    GridBaseDirective.prototype.gridKeydownChanged = function () {
        var _this = this;
        if (this.gridKeydown != null) {
            this.d.r("gridKeydown", function (a) { return _this.gridKeydown(_this, GridKeydownEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("gridKeydown");
        }
    };
    GridBaseDirective.prototype.rowDragStartChanged = function () {
        var _this = this;
        if (this.rowDragStart != null) {
            this.d.r("rowDragStart", function (a) { return _this.rowDragStart(_this, RowDragStartEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowDragStart");
        }
    };
    GridBaseDirective.prototype.rowDragEndChanged = function () {
        var _this = this;
        if (this.rowDragEnd != null) {
            this.d.r("rowDragEnd", function (a) { return _this.rowDragEnd(_this, RowDragEndEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowDragEnd");
        }
    };
    GridBaseDirective.prototype.gridCopyChanged = function () {
        var _this = this;
        if (this.gridCopy != null) {
            this.d.r("gridCopy", function (a) { return _this.gridCopy(_this, GridClipboardEventEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("gridCopy");
        }
    };
    GridBaseDirective.prototype.rowToggleChanged = function () {
        var _this = this;
        if (this.rowToggle != null) {
            this.d.r("rowToggle", function (a) { return _this.rowToggle(_this, RowToggleEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowToggle");
        }
    };
    GridBaseDirective.prototype.rowPinningChanged = function () {
        var _this = this;
        if (this.rowPinning != null) {
            this.d.r("rowPinning", function (a) { return _this.rowPinning(_this, PinRowEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowPinning");
        }
    };
    GridBaseDirective.prototype.rowPinnedChanged = function () {
        var _this = this;
        if (this.rowPinned != null) {
            this.d.r("rowPinned", function (a) { return _this.rowPinned(_this, PinRowEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("rowPinned");
        }
    };
    GridBaseDirective.prototype.activeNodeChangeChanged = function () {
        var _this = this;
        if (this.activeNodeChange != null) {
            this.d.r("activeNodeChange", function (a) { return _this.activeNodeChange(_this, ActiveNodeChangeEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("activeNodeChange");
        }
    };
    GridBaseDirective.prototype.sortingExpressionsChangeChanged = function () {
        var _this = this;
        if (this.sortingExpressionsChange != null) {
            this.d.r("sortingExpressionsChange", function (a) { return _this.sortingExpressionsChange(_this, SortingExpressionEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("sortingExpressionsChange");
        }
    };
    GridBaseDirective.prototype.toolbarExportingChanged = function () {
        var _this = this;
        if (this.toolbarExporting != null) {
            this.d.r("toolbarExporting", function (a) { return _this.toolbarExporting(_this, GridToolbarExportEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("toolbarExporting");
        }
    };
    GridBaseDirective.prototype.rangeSelectedChanged = function () {
        var _this = this;
        if (this.rangeSelected != null) {
            this.d.r("rangeSelected", function (a) { return _this.rangeSelected(_this, GridSelectionRangeEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("rangeSelected");
        }
    };
    GridBaseDirective.prototype.renderedChanged = function () {
        var _this = this;
        if (this.rendered != null) {
            this.d.r("rendered", function (a) { return _this.rendered(_this, VoidEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("rendered");
        }
    };
    GridBaseDirective.prototype.dataChangingChanged = function () {
        var _this = this;
        if (this.dataChanging != null) {
            this.d.r("dataChanging", function (a) { return _this.dataChanging(_this, ForOfDataChangingEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("dataChanging");
        }
    };
    GridBaseDirective.prototype.dataChangedChanged = function () {
        var _this = this;
        if (this.dataChanged != null) {
            this.d.r("dataChanged", function (a) { return _this.dataChanged(_this, VoidEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("dataChanged");
        }
    };
    GridBaseDirective.prototype.fu = function (a) {
        this.nativeElement.isRecordPinnedByIndex(this.d.i(a));
    };
    GridBaseDirective.prototype.gr = function (a) {
        this.nativeElement.toggleColumnVisibility(this.d.i(a));
    };
    GridBaseDirective.prototype.fg = function () {
        this.nativeElement.expandAll();
    };
    GridBaseDirective.prototype.es = function () {
        this.nativeElement.collapseAll();
    };
    GridBaseDirective.prototype.fh = function (a) {
        this.nativeElement.expandRow(this.d.i(a));
    };
    GridBaseDirective.prototype.et = function (a) {
        this.nativeElement.collapseRow(this.d.i(a));
    };
    GridBaseDirective.prototype.gs = function (a) {
        this.nativeElement.toggleRow(this.d.i(a));
    };
    GridBaseDirective.prototype.ea = function (a) {
        return (this.nativeElement.getHeaderGroupWidth(this.d.i(a)));
    };
    GridBaseDirective.prototype.x = function (a) {
        return this.d.g(this.nativeElement.getColumnByName(this.d.i(a)), function (b) { return new Column(); });
    };
    GridBaseDirective.prototype.y = function (a) {
        return this.d.g(this.nativeElement.getColumnByVisibleIndex(this.d.i(a)), function (b) { return new Column(); });
    };
    GridBaseDirective.prototype.f0 = function () {
        this.nativeElement.recalculateAutoSizes();
    };
    GridBaseDirective.prototype.fw = function (a, b, c) {
        this.nativeElement.moveColumn(this.d.i(a), this.d.i(b), this.d.i(typeGetValue(this.d.f(DropPosition_$type, c))));
    };
    GridBaseDirective.prototype.fv = function () {
        this.nativeElement.markForCheck();
    };
    GridBaseDirective.prototype.c1 = function (a) {
        return (this.nativeElement.deleteRow(this.d.i(a)));
    };
    GridBaseDirective.prototype.gu = function (a, b, c) {
        this.nativeElement.updateCell(this.d.i(a), this.d.i(b), this.d.i(c));
    };
    GridBaseDirective.prototype.gv = function (a, b) {
        this.nativeElement.updateRow(this.d.i(a), this.d.i(b));
    };
    GridBaseDirective.prototype.c3 = function (a) {
        return (this.nativeElement.getRowData(this.d.i(a)));
    };
    GridBaseDirective.prototype.gn = function (a) {
        this.nativeElement.sort(this.d.i(a));
    };
    GridBaseDirective.prototype.fi = function (a, b, c, d) {
        if (d === void 0) {
            d = false;
        }
        this.nativeElement.filter(this.d.i(a), this.d.i(b), this.d.i(c), this.d.i(d));
    };
    GridBaseDirective.prototype.fj = function (a, b, c) {
        this.nativeElement.filterGlobal(this.d.i(a), this.d.i(b), this.d.i(c));
    };
    GridBaseDirective.prototype.fe = function (a) {
        this.nativeElement.enableSummaries(this.d.i(a));
    };
    GridBaseDirective.prototype.fc = function (a) {
        this.nativeElement.disableSummaries(this.d.i(a));
    };
    GridBaseDirective.prototype.eo = function (a) {
        this.nativeElement.clearFilter(this.d.i(a));
    };
    GridBaseDirective.prototype.eq = function (a) {
        this.nativeElement.clearSort(this.d.i(a));
    };
    GridBaseDirective.prototype.cj = function (a, b) {
        return (this.nativeElement.pinColumn(this.d.i(a), this.d.i(b)));
    };
    GridBaseDirective.prototype.cp = function (a, b) {
        return (this.nativeElement.unpinColumn(this.d.i(a), this.d.i(b)));
    };
    GridBaseDirective.prototype.f1 = function () {
        this.nativeElement.reflow();
    };
    GridBaseDirective.prototype.cs = function (a, b, c) {
        if (b === void 0) {
            b = false;
        }
        if (c === void 0) {
            c = false;
        }
        return (this.nativeElement.findNext(this.d.i(a), this.d.i(b), this.d.i(c)));
    };
    GridBaseDirective.prototype.ct = function (a, b, c) {
        if (b === void 0) {
            b = false;
        }
        if (c === void 0) {
            c = false;
        }
        return (this.nativeElement.findPrev(this.d.i(a), this.d.i(b), this.d.i(c)));
    };
    GridBaseDirective.prototype.cw = function (a, b) {
        if (a === void 0) {
            a = false;
        }
        if (b === void 0) {
            b = false;
        }
        return (this.nativeElement.refreshSearch(this.d.i(a), this.d.i(b)));
    };
    GridBaseDirective.prototype.ep = function () {
        this.nativeElement.clearSearch();
    };
    GridBaseDirective.prototype.fo = function (a) {
        if (a === void 0) {
            a = false;
        }
        this.nativeElement.getPinnedWidth(this.d.i(a));
    };
    GridBaseDirective.prototype.gm = function (a, b) {
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.selectRows(this.d.i(a), this.d.i(b));
    };
    GridBaseDirective.prototype.fb = function (a) {
        this.nativeElement.deselectRows(this.d.i(a));
    };
    GridBaseDirective.prototype.gi = function (a) {
        if (a === void 0) {
            a = false;
        }
        this.nativeElement.selectAllRows(this.d.i(a));
    };
    GridBaseDirective.prototype.e9 = function (a) {
        if (a === void 0) {
            a = false;
        }
        this.nativeElement.deselectAllRows(this.d.i(a));
    };
    GridBaseDirective.prototype.en = function () {
        this.nativeElement.clearCellSelection();
    };
    GridBaseDirective.prototype.gl = function (a) {
        this.nativeElement.selectRange(this.d.i(a));
    };
    GridBaseDirective.prototype.l = function () {
        return this.d.g(this.nativeElement.getSelectedRanges(), function (a) { return new GridSelectionRange(); });
    };
    GridBaseDirective.prototype.fq = function (a, b) {
        if (a === void 0) {
            a = false;
        }
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.getSelectedData(this.d.i(a), this.d.i(b));
    };
    GridBaseDirective.prototype.n = function () {
        return this.d.g(this.nativeElement.selectedColumns(), function (a) { return new Column(); });
    };
    GridBaseDirective.prototype.gj = function (a, b) {
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.selectColumns(this.d.i(a), this.d.i(b));
    };
    GridBaseDirective.prototype.fa = function (a) {
        this.nativeElement.deselectColumns(this.d.i(a));
    };
    GridBaseDirective.prototype.e8 = function () {
        this.nativeElement.deselectAllColumns();
    };
    GridBaseDirective.prototype.gh = function () {
        this.nativeElement.selectAllColumns();
    };
    GridBaseDirective.prototype.fp = function (a, b) {
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.getSelectedColumnsData(this.d.i(a), this.d.i(b));
    };
    GridBaseDirective.prototype.fx = function (a, b, c) {
        this.nativeElement.navigateTo(this.d.i(a), this.d.i(b), this.d.i(c));
    };
    GridBaseDirective.prototype.u = function (a, b, c) {
        return this.d.g(this.nativeElement.getNextCell(this.d.i(a), this.d.i(b), this.d.i(c)), function (d) { return new CellPosition(); });
    };
    GridBaseDirective.prototype.v = function (a, b, c) {
        return this.d.g(this.nativeElement.getPreviousCell(this.d.i(a), this.d.i(b), this.d.i(c)), function (d) { return new CellPosition(); });
    };
    GridBaseDirective.prototype.fy = function (a) {
        this.nativeElement.openAdvancedFilteringDialog(this.d.i(a));
    };
    GridBaseDirective.prototype.er = function (a) {
        this.nativeElement.closeAdvancedFilteringDialog(this.d.i(a));
    };
    GridBaseDirective.prototype.ff = function (a, b) {
        this.nativeElement.endEdit(this.d.i(a), this.d.i(b));
    };
    GridBaseDirective.prototype.eh = function (a, b) {
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.beginAddRowById(this.d.i(a), this.d.i(b));
    };
    Object.defineProperty(GridBaseDirective.prototype, "aa", {
        get: function () {
            return this.z;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridBaseDirective.prototype, "b9", {
        get: function () {
            var ret_ = this.d.l("stateComponents", function (a) { return new StateCollection(); }, function (a) { return new GridState(); }, ["GridState"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    GridBaseDirective.$t = markType(GridBaseDirective, 'GridBaseDirective', DisplayDensityBase.$);
    return GridBaseDirective;
}(DisplayDensityBase));
export { GridBaseDirective };
/**
 * @hidden
 */
var GridToolbar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridToolbar, _super);
    function GridToolbar() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.j = null;
        return _this;
    }
    Object.defineProperty(GridToolbar.prototype, "l", {
        get: function () {
            var ret_ = this.d.n("showProgress");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("showProgress", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridToolbar.prototype, "i", {
        get: function () {
            var ret_ = this.d.n("grid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("grid", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridToolbar.prototype, "m", {
        get: function () {
            var ret_ = this.d.n("name");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("name", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridToolbar.prototype, "k", {
        get: function () {
            if (this.j == null) {
                this.j = this.d.l("tools", function (a) { return new GridToolbarContentCollection(); }, null, ["GridToolbarActions", "GridToolbarTitle"]);
            }
            return this.j;
        },
        enumerable: false,
        configurable: true
    });
    GridToolbar.$t = markType(GridToolbar, 'GridToolbar', DisplayDensityBaseElement.$);
    return GridToolbar;
}(DisplayDensityBaseElement));
export { GridToolbar };
/**
 * @hidden
 */
var GridToolbarCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridToolbarCollection, _super);
    function GridToolbarCollection() {
        return _super.call(this, GridToolbar.$, 0) || this;
    }
    GridToolbarCollection.$t = markType(GridToolbarCollection, 'GridToolbarCollection', ObservableCollection$1.$.specialize(GridToolbar.$));
    return GridToolbarCollection;
}(ObservableCollection$1));
export { GridToolbarCollection };
/**
 * @hidden
 */
var GridCellEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridCellEventArgs, _super);
    function GridCellEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    GridCellEventArgs.a = function (a) {
        return ((function () {
            var $ret = new GridCellEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new GridCellEventArgsDetail(); });
            return $ret;
        })());
    };
    GridCellEventArgs.$t = markType(GridCellEventArgs, 'GridCellEventArgs');
    return GridCellEventArgs;
}(Base));
export { GridCellEventArgs };
/**
 * @hidden
 */
var GridCellEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridCellEventArgsDetail, _super);
    function GridCellEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(GridCellEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.m("cell", function (a) { return new CellType(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("cell", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellEventArgsDetail.prototype, "i", {
        get: function () {
            var ret_ = this.b.n("event");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("event", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridCellEventArgsDetail.$t = markType(GridCellEventArgsDetail, 'GridCellEventArgsDetail', BaseEventArgsDetail.$);
    GridCellEventArgsDetail.__marshalByValueIgnore = ["event"];
    return GridCellEventArgsDetail;
}(BaseEventArgsDetail));
export { GridCellEventArgsDetail };
/**
 * @hidden
 */
var GridEditDoneEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridEditDoneEventArgs, _super);
    function GridEditDoneEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    GridEditDoneEventArgs.a = function (a) {
        return ((function () {
            var $ret = new GridEditDoneEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new GridEditDoneEventArgsDetail(); });
            return $ret;
        })());
    };
    GridEditDoneEventArgs.$t = markType(GridEditDoneEventArgs, 'GridEditDoneEventArgs');
    return GridEditDoneEventArgs;
}(Base));
export { GridEditDoneEventArgs };
/**
 * @hidden
 */
var GridEditDoneEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridEditDoneEventArgsDetail, _super);
    function GridEditDoneEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(GridEditDoneEventArgsDetail.prototype, "p", {
        get: function () {
            var ret_ = this.b.n("rowID");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("rowID", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditDoneEventArgsDetail.prototype, "n", {
        get: function () {
            var ret_ = this.b.n("primaryKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("primaryKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditDoneEventArgsDetail.prototype, "i", {
        get: function () {
            var ret_ = this.b.m("cellID", function (a) { return new GridCellIdentifier(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("cellID", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditDoneEventArgsDetail.prototype, "o", {
        get: function () {
            var ret_ = this.b.n("rowData");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("rowData", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditDoneEventArgsDetail.prototype, "m", {
        get: function () {
            var ret_ = this.b.n("oldValue");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("oldValue", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditDoneEventArgsDetail.prototype, "l", {
        get: function () {
            var ret_ = this.b.n("newValue");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("newValue", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditDoneEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.m("column", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("column", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditDoneEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.n("owner");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("owner", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditDoneEventArgsDetail.prototype, "j", {
        get: function () {
            var ret_ = this.b.n("isAddRow");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("isAddRow", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditDoneEventArgsDetail.prototype, "k", {
        get: function () {
            var ret_ = this.b.n("valid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("valid", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridEditDoneEventArgsDetail.$t = markType(GridEditDoneEventArgsDetail, 'GridEditDoneEventArgsDetail', BaseEventArgsDetail.$);
    return GridEditDoneEventArgsDetail;
}(BaseEventArgsDetail));
export { GridEditDoneEventArgsDetail };
/**
 * @hidden
 */
var GridEditEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridEditEventArgs, _super);
    function GridEditEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    GridEditEventArgs.a = function (a) {
        return ((function () {
            var $ret = new GridEditEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new GridEditEventArgsDetail(); });
            return $ret;
        })());
    };
    GridEditEventArgs.$t = markType(GridEditEventArgs, 'GridEditEventArgs');
    return GridEditEventArgs;
}(Base));
export { GridEditEventArgs };
/**
 * @hidden
 */
var GridEditEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridEditEventArgsDetail, _super);
    function GridEditEventArgsDetail() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = new WCNativeHelper();
        _this.i = null;
        return _this;
    }
    Object.defineProperty(GridEditEventArgsDetail.prototype, "e", {
        get: function () {
            return this.d;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditEventArgsDetail.prototype, "nativeElement", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            this.i = a;
            this.d.o = this.i;
        },
        enumerable: false,
        configurable: true
    });
    GridEditEventArgsDetail.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(GridEditEventArgsDetail.prototype, "f", {
        get: function () {
            var ret_ = this.e.n("cancel");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("cancel", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditEventArgsDetail.prototype, "o", {
        get: function () {
            var ret_ = this.e.n("rowID");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("rowID", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditEventArgsDetail.prototype, "m", {
        get: function () {
            var ret_ = this.e.n("primaryKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("primaryKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditEventArgsDetail.prototype, "c", {
        get: function () {
            var ret_ = this.e.m("cellID", function (a) { return new GridCellIdentifier(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("cellID", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditEventArgsDetail.prototype, "n", {
        get: function () {
            var ret_ = this.e.n("rowData");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("rowData", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditEventArgsDetail.prototype, "l", {
        get: function () {
            var ret_ = this.e.n("oldValue");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("oldValue", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditEventArgsDetail.prototype, "k", {
        get: function () {
            var ret_ = this.e.n("newValue");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("newValue", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditEventArgsDetail.prototype, "a", {
        get: function () {
            var ret_ = this.e.m("column", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("column", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditEventArgsDetail.prototype, "b", {
        get: function () {
            var ret_ = this.e.n("owner");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("owner", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.e.n("isAddRow");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("isAddRow", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridEditEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.e.n("valid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("valid", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridEditEventArgsDetail.$t = markType(GridEditEventArgsDetail, 'GridEditEventArgsDetail');
    return GridEditEventArgsDetail;
}(Base));
export { GridEditEventArgsDetail };
/**
 * @hidden
 */
var GridFormGroupCreatedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridFormGroupCreatedEventArgs, _super);
    function GridFormGroupCreatedEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    GridFormGroupCreatedEventArgs.a = function (a) {
        return ((function () {
            var $ret = new GridFormGroupCreatedEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new GridFormGroupCreatedEventArgsDetail(); });
            return $ret;
        })());
    };
    GridFormGroupCreatedEventArgs.$t = markType(GridFormGroupCreatedEventArgs, 'GridFormGroupCreatedEventArgs');
    return GridFormGroupCreatedEventArgs;
}(Base));
export { GridFormGroupCreatedEventArgs };
/**
 * @hidden
 */
var GridFormGroupCreatedEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridFormGroupCreatedEventArgsDetail, _super);
    function GridFormGroupCreatedEventArgsDetail() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.d = null;
        return _this;
    }
    Object.defineProperty(GridFormGroupCreatedEventArgsDetail.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridFormGroupCreatedEventArgsDetail.prototype, "nativeElement", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            this.b.o = this.d;
        },
        enumerable: false,
        configurable: true
    });
    GridFormGroupCreatedEventArgsDetail.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(GridFormGroupCreatedEventArgsDetail.prototype, "a", {
        get: function () {
            var ret_ = this.c.n("owner");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("owner", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridFormGroupCreatedEventArgsDetail.$t = markType(GridFormGroupCreatedEventArgsDetail, 'GridFormGroupCreatedEventArgsDetail');
    return GridFormGroupCreatedEventArgsDetail;
}(Base));
export { GridFormGroupCreatedEventArgsDetail };
/**
 * @hidden
 */
var GridSortingStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridSortingStrategy, _super);
    function GridSortingStrategy() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.d = null;
        return _this;
    }
    Object.defineProperty(GridSortingStrategy.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridSortingStrategy.prototype, "nativeElement", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            this.b.o = this.d;
        },
        enumerable: false,
        configurable: true
    });
    GridSortingStrategy.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    GridSortingStrategy.prototype.a = function (a, b, c) {
        return (this.nativeElement.sort(this.c.i(a), this.c.i(b), this.c.i(c)));
    };
    GridSortingStrategy.$t = markType(GridSortingStrategy, 'GridSortingStrategy');
    return GridSortingStrategy;
}(Base));
export { GridSortingStrategy };
/**
 * @hidden
 */
var GridHeaderTemplateContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridHeaderTemplateContext, _super);
    function GridHeaderTemplateContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.d = null;
        return _this;
    }
    Object.defineProperty(GridHeaderTemplateContext.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridHeaderTemplateContext.prototype, "nativeElement", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            this.b.o = this.d;
        },
        enumerable: false,
        configurable: true
    });
    GridHeaderTemplateContext.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(GridHeaderTemplateContext.prototype, "a", {
        get: function () {
            var ret_ = this.c.m("implicit", function (a) { return new HeaderType(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("implicit", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridHeaderTemplateContext.$t = markType(GridHeaderTemplateContext, 'GridHeaderTemplateContext');
    return GridHeaderTemplateContext;
}(Base));
export { GridHeaderTemplateContext };
/**
 * @hidden
 */
var GridRowDragGhostContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridRowDragGhostContext, _super);
    function GridRowDragGhostContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.d = null;
        return _this;
    }
    Object.defineProperty(GridRowDragGhostContext.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridRowDragGhostContext.prototype, "nativeElement", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            this.b.o = this.d;
        },
        enumerable: false,
        configurable: true
    });
    GridRowDragGhostContext.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(GridRowDragGhostContext.prototype, "f", {
        get: function () {
            var ret_ = this.c.n("implicit");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("implicit", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridRowDragGhostContext.prototype, "e", {
        get: function () {
            var ret_ = this.c.n("data");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("data", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridRowDragGhostContext.prototype, "a", {
        get: function () {
            var ret_ = this.c.n("grid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("grid", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridRowDragGhostContext.$t = markType(GridRowDragGhostContext, 'GridRowDragGhostContext');
    return GridRowDragGhostContext;
}(Base));
export { GridRowDragGhostContext };
/**
 * @hidden
 */
var GridRowTemplateContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridRowTemplateContext, _super);
    function GridRowTemplateContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.d = null;
        return _this;
    }
    Object.defineProperty(GridRowTemplateContext.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridRowTemplateContext.prototype, "nativeElement", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            this.b.o = this.d;
        },
        enumerable: false,
        configurable: true
    });
    GridRowTemplateContext.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(GridRowTemplateContext.prototype, "a", {
        get: function () {
            var ret_ = this.c.m("implicit", function (a) { return new RowType(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("implicit", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridRowTemplateContext.$t = markType(GridRowTemplateContext, 'GridRowTemplateContext');
    return GridRowTemplateContext;
}(Base));
export { GridRowTemplateContext };
/**
 * @hidden
 */
var GridTemplateContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridTemplateContext, _super);
    function GridTemplateContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.d = null;
        return _this;
    }
    Object.defineProperty(GridTemplateContext.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridTemplateContext.prototype, "nativeElement", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            this.b.o = this.d;
        },
        enumerable: false,
        configurable: true
    });
    GridTemplateContext.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(GridTemplateContext.prototype, "a", {
        get: function () {
            var ret_ = this.c.n("implicit");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("implicit", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridTemplateContext.$t = markType(GridTemplateContext, 'GridTemplateContext');
    return GridTemplateContext;
}(Base));
export { GridTemplateContext };
/**
 * @hidden
 */
var GridToolbarExportEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridToolbarExportEventArgs, _super);
    function GridToolbarExportEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    GridToolbarExportEventArgs.a = function (a) {
        return ((function () {
            var $ret = new GridToolbarExportEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new GridToolbarExportEventArgsDetail(); });
            return $ret;
        })());
    };
    GridToolbarExportEventArgs.$t = markType(GridToolbarExportEventArgs, 'GridToolbarExportEventArgs');
    return GridToolbarExportEventArgs;
}(Base));
export { GridToolbarExportEventArgs };
/**
 * @hidden
 */
var GridToolbarExportEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridToolbarExportEventArgsDetail, _super);
    function GridToolbarExportEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(GridToolbarExportEventArgsDetail.prototype, "i", {
        get: function () {
            var ret_ = this.b.n("grid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("grid", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridToolbarExportEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.n("exporter");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("exporter", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridToolbarExportEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.n("options");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("options", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridToolbarExportEventArgsDetail.prototype, "j", {
        get: function () {
            var ret_ = this.b.n("cancel");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("cancel", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridToolbarExportEventArgsDetail.$t = markType(GridToolbarExportEventArgsDetail, 'GridToolbarExportEventArgsDetail', BaseEventArgsDetail.$);
    return GridToolbarExportEventArgsDetail;
}(BaseEventArgsDetail));
export { GridToolbarExportEventArgsDetail };
/**
 * @hidden
 */
var GridValidationStatusEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridValidationStatusEventArgs, _super);
    function GridValidationStatusEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    GridValidationStatusEventArgs.a = function (a) {
        return ((function () {
            var $ret = new GridValidationStatusEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new GridValidationStatusEventArgsDetail(); });
            return $ret;
        })());
    };
    GridValidationStatusEventArgs.$t = markType(GridValidationStatusEventArgs, 'GridValidationStatusEventArgs');
    return GridValidationStatusEventArgs;
}(Base));
export { GridValidationStatusEventArgs };
/**
 * @hidden
 */
var GridValidationStatusEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridValidationStatusEventArgsDetail, _super);
    function GridValidationStatusEventArgsDetail() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = new WCNativeHelper();
        _this.e = null;
        return _this;
    }
    Object.defineProperty(GridValidationStatusEventArgsDetail.prototype, "d", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridValidationStatusEventArgsDetail.prototype, "nativeElement", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
            this.c.o = this.e;
        },
        enumerable: false,
        configurable: true
    });
    GridValidationStatusEventArgsDetail.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(GridValidationStatusEventArgsDetail.prototype, "b", {
        get: function () {
            var ret_ = this.d.n("status");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(ValidationStatus_$type, EnumUtil.getEnumValue(ValidationStatus_$type, this.d.f(ValidationStatus_$type, ret_)));
            return EnumUtil.getEnumValue(ValidationStatus_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(ValidationStatus_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("status", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridValidationStatusEventArgsDetail.prototype, "a", {
        get: function () {
            var ret_ = this.d.n("owner");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("owner", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridValidationStatusEventArgsDetail.$t = markType(GridValidationStatusEventArgsDetail, 'GridValidationStatusEventArgsDetail');
    return GridValidationStatusEventArgsDetail;
}(Base));
export { GridValidationStatusEventArgsDetail };
/**
 * @hidden
 */
var GroupByRecord = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GroupByRecord, _super);
    function GroupByRecord() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f = new WCNativeHelper();
        _this.j = null;
        return _this;
    }
    Object.defineProperty(GroupByRecord.prototype, "g", {
        get: function () {
            return this.f;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GroupByRecord.prototype, "nativeElement", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
            this.f.o = this.j;
        },
        enumerable: false,
        configurable: true
    });
    GroupByRecord.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(GroupByRecord.prototype, "e", {
        get: function () {
            var ret_ = this.g.m("expression", function (a) { return new SortingExpression(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("expression", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GroupByRecord.prototype, "i", {
        get: function () {
            var ret_ = this.g.n("level");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("level", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GroupByRecord.prototype, "b", {
        get: function () {
            var ret_ = this.g.n("records");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("records", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GroupByRecord.prototype, "l", {
        get: function () {
            var ret_ = this.g.n("value");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("value", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GroupByRecord.prototype, "d", {
        get: function () {
            var ret_ = this.g.m("groupParent", function (a) { return new GroupByRecord(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("groupParent", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GroupByRecord.prototype, "a", {
        get: function () {
            var ret_ = this.g.m("groups", function (a) { return new GroupByRecord(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("groups", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GroupByRecord.prototype, "h", {
        get: function () {
            var ret_ = this.g.n("height");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("height", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GroupByRecord.prototype, "c", {
        get: function () {
            var ret_ = this.g.m("column", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("column", value_);
        },
        enumerable: false,
        configurable: true
    });
    GroupByRecord.$t = markType(GroupByRecord, 'GroupByRecord');
    return GroupByRecord;
}(Base));
export { GroupByRecord };
/**
 * @hidden
 */
var HeaderType = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HeaderType, _super);
    function HeaderType() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = new WCNativeHelper();
        _this.j = null;
        return _this;
    }
    Object.defineProperty(HeaderType.prototype, "e", {
        get: function () {
            return this.d;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HeaderType.prototype, "nativeElement", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
            this.d.o = this.j;
        },
        enumerable: false,
        configurable: true
    });
    HeaderType.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(HeaderType.prototype, "a", {
        get: function () {
            var ret_ = this.e.m("column", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("column", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HeaderType.prototype, "b", {
        get: function () {
            var ret_ = this.e.n("density");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DisplayDensity_$type, EnumUtil.getEnumValue(DisplayDensity_$type, this.e.f(DisplayDensity_$type, ret_)));
            return EnumUtil.getEnumValue(DisplayDensity_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(DisplayDensity_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.e.v("density", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HeaderType.prototype, "h", {
        get: function () {
            var ret_ = this.e.n("sorted");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("sorted", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HeaderType.prototype, "f", {
        get: function () {
            var ret_ = this.e.n("selectable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("selectable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HeaderType.prototype, "g", {
        get: function () {
            var ret_ = this.e.n("selected");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("selected", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HeaderType.prototype, "i", {
        get: function () {
            var ret_ = this.e.n("title");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("title", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HeaderType.prototype, "c", {
        get: function () {
            var ret_ = this.e.n("sortDirection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(SortingDirection_$type, EnumUtil.getEnumValue(SortingDirection_$type, this.e.f(SortingDirection_$type, ret_)));
            return EnumUtil.getEnumValue(SortingDirection_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SortingDirection_$type, a);
            value_ = this.e.f(SortingDirection_$type, value_);
            this.e.v("sortDirection", value_);
        },
        enumerable: false,
        configurable: true
    });
    HeaderType.$t = markType(HeaderType, 'HeaderType');
    return HeaderType;
}(Base));
export { HeaderType };
/**
 * @hidden
 */
var PinColumnCancellableEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PinColumnCancellableEventArgs, _super);
    function PinColumnCancellableEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    PinColumnCancellableEventArgs.a = function (a) {
        return ((function () {
            var $ret = new PinColumnCancellableEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new PinColumnCancellableEventArgsDetail(); });
            return $ret;
        })());
    };
    PinColumnCancellableEventArgs.$t = markType(PinColumnCancellableEventArgs, 'PinColumnCancellableEventArgs');
    return PinColumnCancellableEventArgs;
}(Base));
export { PinColumnCancellableEventArgs };
/**
 * @hidden
 */
var PinColumnCancellableEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PinColumnCancellableEventArgsDetail, _super);
    function PinColumnCancellableEventArgsDetail() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.g = null;
        return _this;
    }
    Object.defineProperty(PinColumnCancellableEventArgsDetail.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinColumnCancellableEventArgsDetail.prototype, "nativeElement", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            this.g = a;
            this.b.o = this.g;
        },
        enumerable: false,
        configurable: true
    });
    PinColumnCancellableEventArgsDetail.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(PinColumnCancellableEventArgsDetail.prototype, "a", {
        get: function () {
            var ret_ = this.c.m("column", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("column", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinColumnCancellableEventArgsDetail.prototype, "f", {
        get: function () {
            var ret_ = this.c.n("insertAtIndex");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("insertAtIndex", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinColumnCancellableEventArgsDetail.prototype, "e", {
        get: function () {
            var ret_ = this.c.n("isPinned");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("isPinned", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinColumnCancellableEventArgsDetail.prototype, "d", {
        get: function () {
            var ret_ = this.c.n("cancel");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("cancel", value_);
        },
        enumerable: false,
        configurable: true
    });
    PinColumnCancellableEventArgsDetail.$t = markType(PinColumnCancellableEventArgsDetail, 'PinColumnCancellableEventArgsDetail');
    return PinColumnCancellableEventArgsDetail;
}(Base));
export { PinColumnCancellableEventArgsDetail };
/**
 * @hidden
 */
var PinColumnEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PinColumnEventArgs, _super);
    function PinColumnEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    PinColumnEventArgs.a = function (a) {
        return ((function () {
            var $ret = new PinColumnEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new PinColumnEventArgsDetail(); });
            return $ret;
        })());
    };
    PinColumnEventArgs.$t = markType(PinColumnEventArgs, 'PinColumnEventArgs');
    return PinColumnEventArgs;
}(Base));
export { PinColumnEventArgs };
/**
 * @hidden
 */
var PinColumnEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PinColumnEventArgsDetail, _super);
    function PinColumnEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(PinColumnEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.m("column", function (a) { return new Column(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("column", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinColumnEventArgsDetail.prototype, "i", {
        get: function () {
            var ret_ = this.b.n("insertAtIndex");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("insertAtIndex", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinColumnEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.n("isPinned");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("isPinned", value_);
        },
        enumerable: false,
        configurable: true
    });
    PinColumnEventArgsDetail.$t = markType(PinColumnEventArgsDetail, 'PinColumnEventArgsDetail', BaseEventArgsDetail.$);
    return PinColumnEventArgsDetail;
}(BaseEventArgsDetail));
export { PinColumnEventArgsDetail };
/**
 * @hidden
 */
var PinRowEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PinRowEventArgs, _super);
    function PinRowEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    PinRowEventArgs.a = function (a) {
        return ((function () {
            var $ret = new PinRowEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new PinRowEventArgsDetail(); });
            return $ret;
        })());
    };
    PinRowEventArgs.$t = markType(PinRowEventArgs, 'PinRowEventArgs');
    return PinRowEventArgs;
}(Base));
export { PinRowEventArgs };
/**
 * @hidden
 */
var PinRowEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PinRowEventArgsDetail, _super);
    function PinRowEventArgsDetail() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.g = null;
        return _this;
    }
    Object.defineProperty(PinRowEventArgsDetail.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinRowEventArgsDetail.prototype, "nativeElement", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            this.g = a;
            this.b.o = this.g;
        },
        enumerable: false,
        configurable: true
    });
    PinRowEventArgsDetail.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(PinRowEventArgsDetail.prototype, "j", {
        get: function () {
            var ret_ = this.c.n("rowID");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("rowID", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinRowEventArgsDetail.prototype, "a", {
        get: function () {
            var ret_ = this.c.m("row", function (a) { return new RowType(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("row", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinRowEventArgsDetail.prototype, "f", {
        get: function () {
            var ret_ = this.c.n("insertAtIndex");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("insertAtIndex", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinRowEventArgsDetail.prototype, "e", {
        get: function () {
            var ret_ = this.c.n("isPinned");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("isPinned", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinRowEventArgsDetail.prototype, "i", {
        get: function () {
            var ret_ = this.c.n("owner");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("owner", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PinRowEventArgsDetail.prototype, "d", {
        get: function () {
            var ret_ = this.c.n("cancel");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("cancel", value_);
        },
        enumerable: false,
        configurable: true
    });
    PinRowEventArgsDetail.$t = markType(PinRowEventArgsDetail, 'PinRowEventArgsDetail');
    return PinRowEventArgsDetail;
}(Base));
export { PinRowEventArgsDetail };
/**
 * @hidden
 */
var RowDragEndEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RowDragEndEventArgs, _super);
    function RowDragEndEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    RowDragEndEventArgs.a = function (a) {
        return ((function () {
            var $ret = new RowDragEndEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new RowDragEndEventArgsDetail(); });
            return $ret;
        })());
    };
    RowDragEndEventArgs.$t = markType(RowDragEndEventArgs, 'RowDragEndEventArgs');
    return RowDragEndEventArgs;
}(Base));
export { RowDragEndEventArgs };
/**
 * @hidden
 */
var RowDragEndEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RowDragEndEventArgsDetail, _super);
    function RowDragEndEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(RowDragEndEventArgsDetail.prototype, "i", {
        get: function () {
            var ret_ = this.b.n("dragDirective");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("dragDirective", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowDragEndEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.m("dragData", function (a) { return new RowType(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("dragData", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowDragEndEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.n("animation");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("animation", value_);
        },
        enumerable: false,
        configurable: true
    });
    RowDragEndEventArgsDetail.$t = markType(RowDragEndEventArgsDetail, 'RowDragEndEventArgsDetail', BaseEventArgsDetail.$);
    return RowDragEndEventArgsDetail;
}(BaseEventArgsDetail));
export { RowDragEndEventArgsDetail };
/**
 * @hidden
 */
var RowDragStartEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RowDragStartEventArgs, _super);
    function RowDragStartEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    RowDragStartEventArgs.a = function (a) {
        return ((function () {
            var $ret = new RowDragStartEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new RowDragStartEventArgsDetail(); });
            return $ret;
        })());
    };
    RowDragStartEventArgs.$t = markType(RowDragStartEventArgs, 'RowDragStartEventArgs');
    return RowDragStartEventArgs;
}(Base));
export { RowDragStartEventArgs };
/**
 * @hidden
 */
var RowDragStartEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RowDragStartEventArgsDetail, _super);
    function RowDragStartEventArgsDetail() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.e = null;
        return _this;
    }
    Object.defineProperty(RowDragStartEventArgsDetail.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowDragStartEventArgsDetail.prototype, "nativeElement", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
            this.b.o = this.e;
        },
        enumerable: false,
        configurable: true
    });
    RowDragStartEventArgsDetail.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(RowDragStartEventArgsDetail.prototype, "f", {
        get: function () {
            var ret_ = this.c.n("dragDirective");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("dragDirective", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowDragStartEventArgsDetail.prototype, "a", {
        get: function () {
            var ret_ = this.c.m("dragData", function (a) { return new RowType(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("dragData", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowDragStartEventArgsDetail.prototype, "d", {
        get: function () {
            var ret_ = this.c.n("cancel");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("cancel", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowDragStartEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.c.n("owner");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("owner", value_);
        },
        enumerable: false,
        configurable: true
    });
    RowDragStartEventArgsDetail.$t = markType(RowDragStartEventArgsDetail, 'RowDragStartEventArgsDetail');
    return RowDragStartEventArgsDetail;
}(Base));
export { RowDragStartEventArgsDetail };
/**
 * @hidden
 */
var RowType = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RowType, _super);
    function RowType() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.h = new WCNativeHelper();
        _this.w = null;
        return _this;
    }
    Object.defineProperty(RowType.prototype, "i", {
        get: function () {
            return this.h;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "nativeElement", {
        get: function () {
            return this.w;
        },
        set: function (a) {
            this.w = a;
            this.h.o = this.w;
        },
        enumerable: false,
        configurable: true
    });
    RowType.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(RowType.prototype, "u", {
        get: function () {
            var ret_ = this.i.n("index");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("index", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "v", {
        get: function () {
            var ret_ = this.i.n("viewIndex");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("viewIndex", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "q", {
        get: function () {
            var ret_ = this.i.n("isGroupByRow");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("isGroupByRow", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "r", {
        get: function () {
            var ret_ = this.i.n("isSummaryRow");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("isSummaryRow", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "e", {
        get: function () {
            var ret_ = this.i.m("groupRow", function (a) { return new GroupByRecord(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("groupRow", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "z", {
        get: function () {
            var ret_ = this.i.n("key");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("key", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "d", {
        get: function () {
            var ret_ = this.i.m("validation", function (a) { return new GridValidationState(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("validation", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "x", {
        get: function () {
            var ret_ = this.i.n("data");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("data", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "a", {
        get: function () {
            var ret_ = this.i.m("cells", function (a) { return new CellType(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("cells", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "l", {
        get: function () {
            var ret_ = this.i.n("disabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("disabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "s", {
        get: function () {
            var ret_ = this.i.n("pinned");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("pinned", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "t", {
        get: function () {
            var ret_ = this.i.n("selected");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("selected", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "m", {
        get: function () {
            var ret_ = this.i.n("expanded");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("expanded", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "k", {
        get: function () {
            var ret_ = this.i.n("deleted");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("deleted", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "p", {
        get: function () {
            var ret_ = this.i.n("inEditMode");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("inEditMode", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "b", {
        get: function () {
            var ret_ = this.i.m("children", function (a) { return new RowType(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("children", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "f", {
        get: function () {
            var ret_ = this.i.m("parent", function (a) { return new RowType(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("parent", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "o", {
        get: function () {
            var ret_ = this.i.n("hasChildren");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("hasChildren", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "g", {
        get: function () {
            var ret_ = this.i.m("treeRow", function (a) { return new TreeGridRecord(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("treeRow", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "j", {
        get: function () {
            var ret_ = this.i.n("addRowUI");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("addRowUI", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "n", {
        get: function () {
            var ret_ = this.i.n("focused");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("focused", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowType.prototype, "c", {
        get: function () {
            var ret_ = this.i.n("grid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("grid", value_);
        },
        enumerable: false,
        configurable: true
    });
    RowType.prototype.af = function (a) {
        this.nativeElement.update(this.i.i(a));
    };
    RowType.prototype.y = function () {
        return (this.nativeElement.delete());
    };
    RowType.prototype.ac = function () {
        this.nativeElement.pin();
    };
    RowType.prototype.ae = function () {
        this.nativeElement.unpin();
    };
    Object.defineProperty(RowType.prototype, "ab", {
        get: function () {
            if (this.z == null) {
                return "Index:" + this.u.toString();
            }
            if (typeof this.z === 'string' || typeof this.z === 'number' || typeof this.z === 'number' || typeCast(Date_$type, this.z) !== null) {
                return "Key:" + this.z.toString();
            }
            else {
                return "Index:" + this.u.toString();
            }
        },
        enumerable: false,
        configurable: true
    });
    RowType.$t = markType(RowType, 'RowType');
    return RowType;
}(Base));
export { RowType };
