/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridToolbarBaseAction } from "./GridToolbarBaseAction";
import { WCNativeHelper } from "igniteui-react";
import { markType } from "igniteui-react-core";
import { OverlaySettings } from "./OverlaySettings";
import { ToggleViewCancelableEventArgs } from "./ToggleViewCancelableEventArgs";
import { ToggleViewEventArgs } from "./ToggleViewEventArgs";
import { ColumnToggledEventArgs } from "./ColumnToggledEventArgs";
/**
 * @hidden
 */
var BaseToolbarDirective = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BaseToolbarDirective, _super);
    function BaseToolbarDirective() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.h = new WCNativeHelper();
        _this.j = null;
        _this.opening = null;
        _this.opened = null;
        _this.closing = null;
        _this.closed = null;
        _this.columnToggle = null;
        return _this;
    }
    Object.defineProperty(BaseToolbarDirective.prototype, "i", {
        get: function () {
            return this.h;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseToolbarDirective.prototype, "nativeElement", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
            this.h.o = this.j;
        },
        enumerable: false,
        configurable: true
    });
    BaseToolbarDirective.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(BaseToolbarDirective.prototype, "l", {
        get: function () {
            var ret_ = this.i.n("columnListHeight");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("columnListHeight", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseToolbarDirective.prototype, "n", {
        get: function () {
            var ret_ = this.i.n("title");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("title", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseToolbarDirective.prototype, "m", {
        get: function () {
            var ret_ = this.i.n("prompt");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("prompt", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseToolbarDirective.prototype, "c", {
        get: function () {
            var ret_ = this.i.m("overlaySettings", function (a) { return new OverlaySettings(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("overlaySettings", value_);
        },
        enumerable: false,
        configurable: true
    });
    BaseToolbarDirective.prototype.openingChanged = function () {
        var _this = this;
        if (this.opening != null) {
            this.i.r("opening", function (a) { return _this.opening(_this, ToggleViewCancelableEventArgs.a(a)); }, false);
        }
        else {
            this.i.u("opening");
        }
    };
    BaseToolbarDirective.prototype.openedChanged = function () {
        var _this = this;
        if (this.opened != null) {
            this.i.r("opened", function (a) { return _this.opened(_this, ToggleViewEventArgs.a(a)); }, false);
        }
        else {
            this.i.u("opened");
        }
    };
    BaseToolbarDirective.prototype.closingChanged = function () {
        var _this = this;
        if (this.closing != null) {
            this.i.r("closing", function (a) { return _this.closing(_this, ToggleViewEventArgs.a(a)); }, false);
        }
        else {
            this.i.u("closing");
        }
    };
    BaseToolbarDirective.prototype.closedChanged = function () {
        var _this = this;
        if (this.closed != null) {
            this.i.r("closed", function (a) { return _this.closed(_this, ToggleViewEventArgs.a(a)); }, false);
        }
        else {
            this.i.u("closed");
        }
    };
    BaseToolbarDirective.prototype.columnToggleChanged = function () {
        var _this = this;
        if (this.columnToggle != null) {
            this.i.r("columnToggle", function (a) { return _this.columnToggle(_this, ColumnToggledEventArgs.a(a)); }, false);
        }
        else {
            this.i.u("columnToggle");
        }
    };
    BaseToolbarDirective.prototype.get_a = function () {
        var ret_ = this.i.n("name");
        return ret_;
    };
    BaseToolbarDirective.prototype.set_a = function (a) {
        var value_ = a;
        this.i.v("name", value_);
    };
    Object.defineProperty(BaseToolbarDirective.prototype, "a", {
        get: function () {
            return this.get_a();
        },
        set: function (a) {
            this.set_a(a);
        },
        enumerable: false,
        configurable: true
    });
    BaseToolbarDirective.$t = markType(BaseToolbarDirective, 'BaseToolbarDirective', GridToolbarBaseAction.$);
    return BaseToolbarDirective;
}(GridToolbarBaseAction));
export { BaseToolbarDirective };
