/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, runOn, delegateCombine, fromEnum, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, delegateRemove, enumGetBox } from "igniteui-react-core";
import { DomWrapper_$type } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { XCheckbox } from "igniteui-react-inputs";
import { XPrefix } from "igniteui-react-inputs";
import { XInputGroup } from "igniteui-react-inputs";
import { XIcon } from "igniteui-react-inputs";
import { XInput } from "igniteui-react-inputs";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { PrimaryKeyValue } from "./PrimaryKeyValue";
import { Thickness } from "igniteui-react-core";
import { CheckboxListIndexType_$type } from "./CheckboxListIndexType";
import { SRProvider } from "igniteui-react-core";
import { GridSelectedKeysCollection } from "./GridSelectedKeysCollection";
import { InputGroupDisplayType_$type } from "igniteui-react-inputs";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ScrollbarStyle_$type } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { FilterFactory } from "igniteui-react-core";
import { CheckedChangedEventArgs } from "./CheckedChangedEventArgs";
import { TemplateColumn } from "./TemplateColumn";
import { DataSourceSchemaPropertyType_$type } from "igniteui-react-core";
import { FastReflectionHelper } from "igniteui-react-core";
import { ColumnWidth } from "./ColumnWidth";
import { DateTimeColumn } from "./DateTimeColumn";
import { NumericColumn } from "./NumericColumn";
import { TextColumn } from "./TextColumn";
import { ArgumentException } from "igniteui-react-core";
import { SelectAllCheckboxChangedEventArgs } from "./SelectAllCheckboxChangedEventArgs";
import { stringIsNullOrWhiteSpace } from "igniteui-react-core";
/**
 * @hidden
 */
var CheckboxListView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CheckboxListView, _super);
    function CheckboxListView() {
        var _this = _super.call(this) || this;
        _this.e = new Dictionary$2(DomWrapper_$type, XCheckbox.$, 0);
        _this.j = null;
        _this.a = null;
        _this.i = null;
        _this.h = null;
        _this.c = null;
        _this.b = null;
        _this.f = null;
        _this.d = false;
        _this.g = null;
        return _this;
    }
    CheckboxListView.prototype.n = function () {
    };
    CheckboxListView.prototype.m = function (a) {
        if (a == null) {
            this.f = null;
            this.e.clear();
            return;
        }
        this.f = a;
        this.v();
        this.ae();
        this.ah();
        this.s();
        var b = Math.round(a.rootWrapper.width());
        var c = Math.round(a.rootWrapper.height());
        this.f.rootWrapper.setStyleProperty("position", "relative");
        this.f.rootWrapper.setStyleProperty("padding-bottom", "4px");
    };
    CheckboxListView.prototype.v = function () {
        if (this.f != null) {
            this.w(this.f);
        }
    };
    CheckboxListView.prototype.w = function (a) {
        var b = a.rootWrapper.getChildAt(0);
        this.h = b;
        this.b.r = new XInputGroup();
        var c = a.getSubRenderer(b);
        this.b.r.provideContainer(c);
        var d = c.getExternal(this.b.r, c.rootWrapper, c.getExternal(this.b, null, null));
        this.b.r.d = this.b.t;
        this.b.r.p = this.b.y;
        this.b.r.t = this.b.aa;
        var e = a.createElement("div");
        var f = a.getSubRenderer(e);
        var g = new XPrefix();
        g.provideContainer(f);
        var h = f.getExternal(g, f.rootWrapper, f.getExternal(this.b, null, null));
        var i = a.createElement("div");
        var j = a.getSubRenderer(i);
        this.c = new XIcon();
        this.c.provideContainer(j);
        this.c.fill = this.b.du;
        this.c.svgPath = CheckboxList.bt;
        var k = f.getExternal(this.c, j.rootWrapper, j.getExternal(this.b, null, null));
        g.appendContentChild(i);
        this.b.r.appendContentChild(e);
        this.b.r.inputs.add(g);
        var l = a.createElement("div");
        l.setRawStyleProperty("flex-grow", "1");
        var m = a.getSubRenderer(l);
        this.b.p = new XInput();
        this.b.p.provideContainer(m);
        this.b.p.b8 = "text";
        var n = m.getExternal(this.b.p, m.rootWrapper, m.getExternal(this.b, null, null));
        if (this.b.bg != null) {
            this.b.p.cg = this.b.bg;
        }
        this.b.r.appendContentChild(l);
        this.b.r.inputs.add(this.b.p);
        this.b.ck();
    };
    CheckboxListView.prototype.s = function () {
        if (this.f != null) {
            var a = this.f.rootWrapper.getChildAt(3);
            a.setStyleProperty("width", "100%");
            a.setStyleProperty("margin", "4px 0px 0px 0px");
            if (this.b.as == false) {
                a.setStyleProperty("height", "calc(100% - 50px");
            }
            else {
                a.setStyleProperty("height", "calc(100% - 75px");
            }
            if (!this.b.aq && !this.b.as) {
                a.setStyleProperty("height", "100%");
            }
        }
    };
    CheckboxListView.prototype.o = function (a, b, c) {
        var d = null;
        if (a.getChildCount() == 0) {
            d = new XCheckbox();
            var e = this.f.getSubRenderer(a);
            d.provideContainer(e);
            var f = this.f.getExternal(d, e.rootWrapper, this.f.getExternal(this.b, null, null));
            this.e.addItem(a, d);
            d.n = this.b.y;
            d.y = true;
            d.change = delegateCombine(d.change, runOn(this, this.k));
            var g = this.f.createElement("div");
            a.setStyleProperty("display", "flex");
            a.setStyleProperty("height", "100%");
            a.setStyleProperty("align-items", "center");
            switch (this.b.aa) {
                case 1:
                    a.setStyleProperty("margin-top", "-4px");
                    break;
                case 2:
                    a.setStyleProperty("margin-top", "-1px");
                    break;
                case 3:
                    a.setStyleProperty("margin-top", "1px");
                    break;
            }
            a.append(g);
        }
        else {
            d = this.e.item(a);
        }
        if (d != null) {
            var h = d.z;
            try {
                d.z = true;
                d.a4 = b;
                if (c) {
                    if (this.b.l == 0) {
                        d.checked = false;
                    }
                    else {
                        d.checked = true;
                    }
                }
                else {
                    if (this.b.l == 0) {
                        d.checked = true;
                    }
                    else {
                        d.checked = false;
                    }
                }
            }
            finally {
                d.z = h;
            }
            d.dk = this.b.dl;
            d.dd = this.b.dj;
            d.dl = this.b.dm;
            d.de = this.b.dk;
            d.dm = this.b.dn;
        }
    };
    CheckboxListView.prototype.z = function () {
        var e_1, _a;
        if (this.e != null) {
            try {
                for (var _b = __values(fromEnum(this.e)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    var b = a.value;
                    b.n = this.b.y;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
        if (this.a != null) {
            this.a.n = this.b.y;
        }
    };
    CheckboxListView.prototype.x = function () {
    };
    CheckboxListView.prototype.k = function (a, b) {
        var c = a;
        var d = parseInt(c.a4.toString());
        var e = c.checked;
        if (e == true) {
            if (this.b.l == 0) {
                this.b.cw(d);
            }
            else {
                this.b.b5(d);
            }
        }
        else {
            if (this.b.l == 0) {
                this.b.b5(d);
            }
            else {
                this.b.cw(d);
            }
        }
        this.b.ci(d, e);
        this.ag(false);
    };
    CheckboxListView.prototype.l = function () {
    };
    CheckboxListView.prototype.t = function (a, b) {
        var e_2, _a;
        try {
            for (var _b = __values(fromEnum(this.e)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.value;
                var e = parseInt(d.a4.toString());
                if (e == a) {
                    d.checked = b;
                    this.b.ci(e, b);
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.ag();
    };
    CheckboxListView.prototype.u = function (a) {
        var e_3, _a;
        try {
            for (var _b = __values(fromEnum(this.e)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = b.value;
                c.checked = a;
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
    };
    CheckboxListView.prototype.q = function (a) {
        this.j = a;
        if (null != this.j) {
            this.j.setStyleProperty("margin", "5px 0px 4px 0px");
        }
    };
    CheckboxListView.prototype.ah = function () {
        var a = this.f;
        if (null == a || null == this.j) {
            return;
        }
        var b = a.createElement("div");
        var c = a.getSubRenderer(b);
        this.a = new XCheckbox();
        this.a.provideContainer(c);
        var d = this.f.getExternal(this.a, c.rootWrapper, this.f.getExternal(this.b, null, null));
        this.a.n = this.b.y;
        this.i = a.createElement("label");
        this.i.setRawText(this.b.bx);
        this.i.setStyleProperty("font-size", "13px");
        this.j.setStyleProperty("display", "flex");
        this.j.setStyleProperty("flex-direction", "row");
        this.j.setStyleProperty("font-family", "Verdana");
        this.j.setStyleProperty("align-items", "center");
        this.j.append(b);
        this.j.append(this.i);
        this.ai();
        this.af();
        var e = this.a;
        e.change = delegateCombine(e.change, runOn(this, this.r));
        this.a.y = true;
    };
    CheckboxListView.prototype.af = function () {
        if (null != this.i) {
            this.i.setRawText(this.b.bx);
            NativeUI.q(this.i, this.b.dh);
        }
    };
    CheckboxListView.prototype.ai = function () {
        if (null != this.i) {
            var a = this.b.as ? "flex" : "none";
            this.j.setStyleProperty("display", a);
        }
    };
    CheckboxListView.prototype.ae = function () {
        if (this.h != null) {
            this.h.setStyleProperty("display", this.b.aq ? "block" : "none");
        }
        if (this.g != null) {
            this.g.setStyleProperty("display", this.b.aq ? "block" : "none");
        }
    };
    CheckboxListView.prototype.ag = function (a) {
        if (a === void 0) {
            a = true;
        }
        var b = this.d;
        this.d = true;
        var c = this.a.z;
        this.a.z = a;
        try {
            if (this.b.ao) {
                this.a.indeterminate = true;
                return;
            }
            this.a.indeterminate = false;
            if (this.b.l == 0) {
                this.a.checked = this.b.g.count == 0;
            }
            else {
                this.a.checked = this.b.g.count != 0;
            }
        }
        finally {
            this.a.z = c;
            this.d = b;
        }
    };
    CheckboxListView.prototype.r = function (a, b) {
        if (this.d || b.isIndeterminate) {
            return;
        }
        if (b.isChecked) {
            this.b.cy();
            this.b.cp(b.isChecked);
        }
        else {
            this.b.b9();
            this.b.cp(b.isChecked);
        }
    };
    CheckboxListView.prototype.ad = function () {
        var a = this.f;
        if (null == a) {
            return;
        }
        var b = a.rootWrapper;
        if (null != b) {
            NativeUI.q(b, this.b.dy);
            NativeUI.m(b, this.b.di);
        }
    };
    CheckboxListView.prototype.ab = function () {
        if (this.c != null) {
            this.c.fill = this.b.du;
        }
    };
    CheckboxListView.prototype.ac = function () {
        if (this.b.ae != null) {
            this.i.setStyleProperty("font", this.b.ae.fontString);
        }
        else {
            this.i.setStyleProperty("font-family", "Verdana");
            this.i.setStyleProperty("font-size", 13 + "px");
        }
    };
    CheckboxListView.prototype.y = function () {
        this.a.dk = this.b.dl;
        this.a.dd = this.b.dj;
        this.a.dl = this.b.dm;
        this.a.de = this.b.dk;
        this.a.dm = this.b.dn;
    };
    CheckboxListView.prototype.aa = function (a) {
        if (this.g != null) {
            NativeUI.w(this.g, a);
        }
    };
    CheckboxListView.prototype.p = function (a) {
        this.g = a;
    };
    CheckboxListView.$t = markType(CheckboxListView, 'CheckboxListView');
    return CheckboxListView;
}(Base));
export { CheckboxListView };
/**
 * @hidden
 */
var CheckboxList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CheckboxList, _super);
    function CheckboxList() {
        var _this = _super.call(this) || this;
        _this.m = null;
        _this.h = null;
        _this.i = null;
        _this.ab = null;
        _this.d = null;
        _this.ai = false;
        _this.c = null;
        _this.o = null;
        _this.q = null;
        _this.aj = false;
        _this.ag = null;
        _this.f = new GridSelectedKeysCollection();
        _this.a = null;
        _this.propertyChanged = null;
        _this.checkedChanged = null;
        _this.ay = null;
        _this.a0 = null;
        _this.a2 = null;
        _this.a1 = null;
        _this.s = 3;
        _this.au = -1;
        _this.ac = null;
        _this.k = 1;
        _this.x = 1;
        _this.z = 2;
        _this.dd = BrushUtil.h(255, 24, 29, 31);
        _this.db = null;
        _this.de = null;
        _this.dc = null;
        _this.ad = null;
        _this.c7 = null;
        _this.c5 = null;
        _this.c8 = null;
        _this.c6 = null;
        _this.c9 = null;
        _this.v = 0;
        _this.da = null;
        _this.bw = null;
        _this.df = null;
        _this.c3 = CheckboxList.dq;
        _this.ar = true;
        _this.c4 = CheckboxList.dp;
        _this.dg = CheckboxList.dq;
        _this.selectAllCheckboxChanged = null;
        _this.aw = -1;
        _this.ap = true;
        _this.am = true;
        var a = _this.f;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.cr));
        _this.d = new FilterFactory();
        var b = new CheckboxListView();
        b.b = _this;
        _this.m = b;
        _this.m.n();
        return _this;
    }
    Object.defineProperty(CheckboxList.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            this.q = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "p", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            this.o = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "e", {
        get: function () {
            if (this.h == null) {
                return null;
            }
            return this.h.actualDataSource;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "ah", {
        get: function () {
            if (this.ag == null) {
                this.ag = new SRProvider(this.m.f);
                this.ag.cb("DataGrid");
            }
            return this.ag;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "g", {
        get: function () {
            return this.f;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.cn("PrimaryKey", b, this.a);
            }
        },
        enumerable: false,
        configurable: true
    });
    CheckboxList.prototype.cr = function (a, b) {
        if (this.e == null || this.e.actualSchema == null || this.ai) {
            return;
        }
        switch (b.action) {
            case 0:
                for (var c = 0; c < b.newItems.count; c++) {
                    this.cl(b.newItems.item(c));
                }
                break;
            case 1:
                for (var d = 0; d < b.oldItems.count; d++) {
                    this.cm(b.oldItems.item(d));
                }
                break;
            case 2:
                for (var e = 0; e < b.oldItems.count; e++) {
                    this.cm(b.oldItems.item(e));
                }
                for (var f = 0; f < b.newItems.count; f++) {
                    this.cl(b.newItems.item(f));
                }
                break;
            case 4:
                this.m.u(this.l == 0);
                for (var g = 0; g < this.g.ae.count; g++) {
                    this.cl(this.g.ae._inner[g]);
                }
                break;
        }
    };
    CheckboxList.prototype.cl = function (a) {
        var b = this.e.indexOfKey(a.value);
        if (b >= 0) {
            this.m.t(b, this.l == 1);
        }
    };
    CheckboxList.prototype.cm = function (a) {
        var b = this.e.indexOfKey(a.value);
        if (b >= 0) {
            this.m.t(b, this.l == 0);
        }
    };
    CheckboxList.prototype.ci = function (a, b) {
        if (this.checkedChanged != null && this.aj == false) {
            this.checkedChanged(this, ((function () {
                var $ret = new CheckedChangedEventArgs();
                $ret.b = a;
                $ret.a = b;
                return $ret;
            })()));
        }
    };
    CheckboxList.prototype.notifySizeChanged = function () {
        this.m.l();
    };
    CheckboxList.prototype.destroy = function () {
        if (this.h != null) {
            var a = this.h;
            a.cellClicked = delegateRemove(a.cellClicked, runOn(this, this.cb));
            if (this.h.actualDataSource != null) {
                var b = this.h.actualDataSource;
                b.schemaChanged = delegateRemove(b.schemaChanged, runOn(this, this.co));
            }
        }
        if (this.o != null) {
            var c = this.o;
            c.change = delegateRemove(c.change, runOn(this, this.cc));
        }
        this.provideContainer(null, null, null);
        if (this.i != null) {
            var d = this.i;
            d.cellUpdating = delegateRemove(d.cellUpdating, runOn(this, this.b8));
        }
    };
    CheckboxList.prototype.provideContainer = function (a, b, c) {
        this.h = b;
        if (null != this.h) {
            this.h.scrollbarStyle = this.w;
            this.h.scrollbarBackground = this.dr;
            this.h.headerHeight = 0;
            this.h.rowSeparatorHeight = 0;
            this.h.defaultColumnMinWidth = NaN;
            this.h.autoGenerateColumns = false;
            this.h.activationMode = 0;
            this.h.editMode = 0;
            var d = this.h;
            d.cellClicked = delegateCombine(d.cellClicked, runOn(this, this.cb));
            if (this.ay != null) {
                this.h.itemsSource = this.ay;
                this.b7();
                this.cq();
            }
            if (this.a0 != null) {
                this.cq();
                this.c1();
            }
        }
        this.m.q(c);
        this.m.m(a);
    };
    CheckboxList.prototype.provideSelectAllSection = function (a) {
        this.m.q(a);
    };
    CheckboxList.prototype.cb = function (a, b) {
        if (b.cellInfo.l.a5 == 0) {
            return;
        }
        var c = b.cellInfo.l.x;
        if (-1 == c) {
            return;
        }
        var d = this.j(b.cellInfo.g4);
        if (this.g.contains(d)) {
            this.g.remove(d);
        }
        else {
            this.g.add(d);
        }
    };
    CheckboxList.prototype.b8 = function (a, b) {
        var c = b.cellInfo.l.x;
        if (-1 == c) {
            return;
        }
        var d = false;
        if (b.cellInfo.g4 != null) {
            var e = this.j(b.cellInfo.g4);
            if (this.g.contains(e)) {
                d = true;
            }
        }
        this.m.o(b.content.element, c, d);
    };
    CheckboxList.prototype.cj = function (a) {
        if (this.a0 != null) {
            var b = this.d.property(this.a0).cast(enumGetBox(DataSourceSchemaPropertyType_$type, 0)).toLower();
            var c = b.contains(a);
            if (!this.h.filterExpressions.k.contains(this.c)) {
                this.c = c;
                this.h.filterExpressions.add(this.c);
            }
            else {
                var d = this.h.filterExpressions.k.indexOf(this.c);
                this.h.filterExpressions.k.item(d, this.c = c);
            }
        }
    };
    Object.defineProperty(CheckboxList.prototype, "itemsSource", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.cn("ItemsSource", b, this.ay);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "bc", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            var b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.cn("DataMemberPath", b, this.a0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "b0", {
        get: function () {
            return this.a2;
        },
        set: function (a) {
            var b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.cn("SelectedMemberPath", b, this.a2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "bg", {
        get: function () {
            return this.a1;
        },
        set: function (a) {
            var b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.cn("FilterPlaceholderText", b, this.a1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "t", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.s;
            this.s = a;
            if (b != this.s) {
                this.cn("SearchInputType", enumGetBox(InputGroupDisplayType_$type, b), enumGetBox(InputGroupDisplayType_$type, this.s));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "ax", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.au;
            this.au = a;
            if (b != this.au) {
                this.cn("RowHeight", b, this.au);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "av", {
        get: function () {
            if (this.h != null) {
                return this.h.actualRowHeight;
            }
            return -1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "ae", {
        get: function () {
            return this.ac;
        },
        set: function (a) {
            var b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.cn("CellTextStyle", b, this.ac);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "l", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            if (b != this.k) {
                this.cn("IndexType", enumGetBox(CheckboxListIndexType_$type, b), enumGetBox(CheckboxListIndexType_$type, this.k));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.x;
            this.x = a;
            if (b != this.x) {
                this.cn("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.x));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.z;
            this.z = a;
            if (b != this.z) {
                this.cn("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.z));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "du", {
        get: function () {
            return this.dd;
        },
        set: function (a) {
            var b = this.dd;
            this.dd = a;
            if (b != this.dd) {
                this.cn("SearchIconColor", b, this.dd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "ds", {
        get: function () {
            return this.db;
        },
        set: function (a) {
            var b = this.db;
            this.db = a;
            if (b != this.db) {
                this.cn("SearchBackgroundColor", b, this.db);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "dv", {
        get: function () {
            return this.de;
        },
        set: function (a) {
            var b = this.de;
            this.de = a;
            if (b != this.de) {
                this.cn("SearchTextColor", b, this.de);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "dt", {
        get: function () {
            return this.dc;
        },
        set: function (a) {
            var b = this.dc;
            this.dc = a;
            if (b != this.dc) {
                this.cn("SearchBorderColor", b, this.dc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "af", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.cn("SearchTextStyle", b, this.ad);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "dl", {
        get: function () {
            return this.c7;
        },
        set: function (a) {
            var b = this.c7;
            this.c7 = a;
            if (b != this.c7) {
                this.cn("CheckboxTickColor", b, this.c7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "dj", {
        get: function () {
            return this.c5;
        },
        set: function (a) {
            var b = this.c5;
            this.c5 = a;
            if (b != this.c5) {
                this.cn("CheckboxCheckedBackgroundColor", b, this.c5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "dm", {
        get: function () {
            return this.c8;
        },
        set: function (a) {
            var b = this.c8;
            this.c8 = a;
            if (b != this.c8) {
                this.cn("CheckboxUncheckedBackgroundColor", b, this.c8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "dk", {
        get: function () {
            return this.c6;
        },
        set: function (a) {
            var b = this.c6;
            this.c6 = a;
            if (b != this.c6) {
                this.cn("CheckboxCheckedBorderColor", b, this.c6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "dn", {
        get: function () {
            return this.c9;
        },
        set: function (a) {
            var b = this.c9;
            this.c9 = a;
            if (b != this.c9) {
                this.cn("CheckboxUncheckedBorderColor", b, this.c9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "w", {
        get: function () {
            return this.v;
        },
        set: function (a) {
            var b = this.v;
            this.v = a;
            if (b != this.v) {
                this.cn("ScrollbarStyle", enumGetBox(ScrollbarStyle_$type, b), enumGetBox(ScrollbarStyle_$type, this.v));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "dr", {
        get: function () {
            return this.da;
        },
        set: function (a) {
            var b = this.da;
            this.da = a;
            if (b != this.da) {
                this.cn("ScrollbarBackground", b, this.da);
            }
        },
        enumerable: false,
        configurable: true
    });
    CheckboxList.prototype.cn = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.cs(a, b, c);
    };
    CheckboxList.prototype.cs = function (a, b, c) {
        switch (a) {
            case "ItemsSource":
                if (this.h != null) {
                    this.l = 1;
                    if (c != null) {
                        this.h.groupDescriptions.n();
                        this.h.sortDescriptions.n();
                        this.h.filterExpressions.clear();
                        this.h.summaryDescriptions.n();
                    }
                    if (this.h.actualDataSource != null) {
                        var d = this.h.actualDataSource;
                        d.schemaChanged = delegateRemove(d.schemaChanged, runOn(this, this.co));
                    }
                    this.h.itemsSource = this.ay;
                    this.b7();
                    if (this.h.actualDataSource != null) {
                        var e = this.h.actualDataSource;
                        e.schemaChanged = delegateCombine(e.schemaChanged, runOn(this, this.co));
                    }
                    this.aj = true;
                    this.cq();
                    this.aj = false;
                    this.m.ag();
                }
                break;
            case "DataMemberPath":
            case "SelectedMemberPath":
                if (this.h != null) {
                    if (this.a0 != null) {
                        this.cq();
                        this.c1();
                    }
                }
                break;
            case "PrimaryKey":
                if (this.h != null) {
                    this.h.primaryKey = this.b;
                }
                break;
            case "SelectAllCaptionTextColor":
                this.dh = null != this.dw ? this.dw : CheckboxList.dq;
                break;
            case "SelectAllCaption":
            case "ActualSelectAllCaptionTextColor":
                this.m.af();
                break;
            case "showSelectAll":
                this.m.ai();
                this.m.s();
                break;
            case "ShowFilter":
                this.m.ae();
                this.m.s();
                break;
            case "FilterPlaceholderText":
                if (this.o != null) {
                    this.o.cg = this.bg;
                }
                break;
            case "SearchInputType":
                if (this.q != null) {
                    this.q.d = this.t;
                }
                break;
            case "RowHeight":
                if (this.h != null) {
                    this.h.rowHeight = this.ax;
                }
                break;
            case "CellTextStyle":
                if (this.h != null) {
                    this.h.cellTextStyle = this.ae;
                }
                this.m.ac();
                break;
            case "BackgroundColor":
            case "TextColor":
                var f = this.h;
                if (null != f) {
                    f.cellTextColor = this.dy;
                    f.cellBackground = this.di;
                    f.cellSelectedBackground = this.di;
                }
                this.m.ad();
                break;
            case "BaseTheme":
                this.c0();
                break;
            case "Density":
                this.cz();
                break;
            case "IsRowHoverEnabled":
                if (this.h != null) {
                    this.h.isRowHoverEnabled = this.an;
                }
                break;
            case "ScrollbarStyle":
                if (this.h != null) {
                    this.h.scrollbarStyle = this.w;
                }
                break;
            case "ScrollbarBackground":
                if (this.h != null) {
                    this.h.scrollbarBackground = this.dr;
                }
                break;
            case "SearchIconColor":
                this.m.ab();
                break;
            case "SearchBackgroundColor":
                this.r.mc = this.ds;
                break;
            case "SearchBorderColor":
                this.r.md = this.dt;
                break;
            case "SearchTextColor":
                this.p.d8 = this.dv;
                break;
            case "SearchTextStyle":
                this.p.af = this.af;
                break;
            case "CheckboxTickColor":
            case "CheckboxCheckedBackgroundColor":
            case "CheckboxUncheckedBackgroundColor":
            case "CheckboxCheckedBorderColor":
            case "CheckboxUncheckedBorderColor":
                this.m.y();
                if (this.h != null) {
                    this.h.w9();
                }
                break;
        }
    };
    CheckboxList.prototype.cz = function () {
        if (this.h != null) {
            this.h.density = this.aa;
        }
        if (this.q != null) {
            this.q.t = this.aa;
        }
        this.m.x();
    };
    CheckboxList.prototype.c0 = function () {
        if (this.q != null) {
            this.q.p = this.y;
        }
        this.m.z();
    };
    CheckboxList.prototype.co = function (a, b) {
        this.aj = true;
        this.b7();
        if (b.schema != null) {
            this.cq();
            for (var c = 0; c < this.g.count; c++) {
                this.cl(this.g._inner[c]);
            }
            this.m.ag();
        }
        this.aj = false;
    };
    CheckboxList.prototype.cq = function () {
        if (this.ab == null && this.a2 != null && this.a2 != "") {
            this.ab = new FastReflectionHelper(false, this.a2);
        }
        if (this.ay != null && this.ab != null && this.h.actualDataSource.actualSchema != null) {
            this.ab.propertyName = this.a2;
            var a = this.h.actualDataSource.actualCount;
            for (var b = 0; b < a; b++) {
                var c = this.h.actualDataSource.getItemAtIndex(b);
                var d = this.ab.getPropertyValue(c);
                if (d == true) {
                    var e = this.j(c);
                    if (!this.g.contains(e)) {
                        this.g.add(e);
                    }
                }
            }
        }
    };
    CheckboxList.prototype.c1 = function () {
        this.h.actualColumns.clear();
        this.h.primaryKey = this.b;
        this.h.isGroupRowSticky = false;
        this.h.rowHeight = this.ax;
        this.h.cellBackground = this.di;
        this.h.cellSelectedBackground = this.di;
        this.h.density = this.aa;
        this.h.isRowHoverEnabled = this.an;
        this.h.borderWidth = new Thickness(0, 0);
        if (this.ae != null) {
            this.h.cellTextStyle = this.ae;
        }
        var a = new TemplateColumn();
        if (this.a2 == null) {
            this.a2 = "";
        }
        a.i8 = this.a2;
        a.jz = "CheckboxColumn";
        var b = new ColumnWidth();
        b.c = false;
        b.f = 28;
        a.width = b;
        a.h2 = 0;
        a.h3 = 0;
        a.cellUpdating = delegateCombine(a.cellUpdating, runOn(this, this.b8));
        this.h.columns.add(a);
        this.i = a;
        var c = this.h.actualDataSource.resolveSchemaPropertyType(this.a0);
        var d;
        switch (c) {
            case 8:
            case 9:
                d = new DateTimeColumn();
                break;
            case 1:
            case 3:
            case 4:
            case 5:
            case 6:
            case 7:
            case 10:
                d = new NumericColumn();
                break;
            case 2:
            case 11:
            case 0:
            default:
                d = new TextColumn();
                break;
        }
        d.i8 = this.a0;
        d.jz = "DataColumn";
        d.h2 = 0;
        d.e = 0;
        this.h.columns.add(d);
    };
    CheckboxList.prototype.updateHrMargin = function (a) {
        this.m.aa(a);
    };
    CheckboxList.prototype.provideHrElement = function (a) {
        this.m.p(a);
    };
    CheckboxList.prototype.ck = function () {
        var a = this.p;
        a.changing = delegateCombine(a.changing, runOn(this, this.cc));
    };
    CheckboxList.prototype.cc = function (a, b) {
        var c = b.value.toLowerCase();
        this.cj(c);
    };
    CheckboxList.prototype.j = function (a) {
        if (this.b == null) {
            return PrimaryKeyValue.createIdentityKey(a);
        }
        var b = new Array(this.b.length);
        var c = new Array(this.b.length);
        for (var d = 0; d < b.length; d++) {
            b[d] = this.b[d];
            c[d] = this.e.getItemProperty(a, b[d]);
        }
        return new PrimaryKeyValue(b, c);
    };
    CheckboxList.prototype.cw = function (a) {
        this.ai = true;
        var b = this.e.getItemAtIndex(a);
        var c = this.j(b);
        this.g.remove(c);
        this.ai = false;
    };
    CheckboxList.prototype.b5 = function (a) {
        this.ai = true;
        var b = this.e.getItemAtIndex(a);
        var c = this.j(b);
        this.g.add(c);
        this.ai = false;
    };
    CheckboxList.prototype.cy = function () {
        this.l = 0;
        this.g.clear();
        this.cd();
        this.m.ag();
    };
    CheckboxList.prototype.b9 = function () {
        this.l = 1;
        this.g.clear();
        this.cd();
        this.m.ag();
    };
    CheckboxList.prototype.cg = function (a, b, c) {
        if (this.h != null) {
            this.h.notifySetItem(a, b, c);
        }
    };
    CheckboxList.prototype.cd = function () {
        if (this.h != null) {
            this.h.notifyClearItems();
        }
    };
    CheckboxList.prototype.ce = function (a, b) {
        if (this.h != null) {
            this.h.notifyInsertItem(a, b);
        }
        ;
    };
    CheckboxList.prototype.cf = function (a, b) {
        if (this.h != null) {
            this.h.notifyRemoveItem(a, b);
        }
        ;
    };
    CheckboxList.prototype.b6 = function (a) {
        var b = null;
        if (this.b == null || this.b.length == 0) {
            b = new PrimaryKeyValue(null, a);
        }
        else if (this.b.length == a.length) {
            b = new PrimaryKeyValue(this.b, a);
        }
        else {
            throw new ArgumentException(1, "value length must match PrimaryKey length");
        }
        if (b != null) {
            this.g.add(b);
        }
    };
    CheckboxList.prototype.cx = function (a) {
        var b = null;
        if (this.b == null || this.b.length == 0) {
            b = new PrimaryKeyValue(null, a);
        }
        else if (this.b.length == a.length) {
            b = new PrimaryKeyValue(this.b, a);
        }
        else {
            throw new ArgumentException(1, "value length must match PrimaryKey length");
        }
        if (this.g.contains(b)) {
            this.g.remove(b);
        }
    };
    Object.defineProperty(CheckboxList.prototype, "bx", {
        get: function () {
            return this.bw != null ? this.bw : !stringIsNullOrWhiteSpace(this.ah.b1("Select_All")) ? this.ah.b1("Select_All") : "(Select All)";
        },
        set: function (a) {
            if (a == this.bw) {
                return;
            }
            var b = this.bw;
            this.bw = a;
            this.cn("SelectAllCaption", b, this.bw);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "dw", {
        get: function () {
            return this.df;
        },
        set: function (a) {
            var b = this.df;
            this.df = a;
            if (b != this.df) {
                this.cn("SelectAllCaptionTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "dh", {
        get: function () {
            return this.c3;
        },
        set: function (a) {
            var b = this.c3;
            this.c3 = a;
            if (b != this.c3) {
                this.cn("ActualSelectAllCaptionTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "ao", {
        get: function () {
            if (-1 == this.aw) {
                return false;
            }
            var a = this.g.count;
            if (0 == a) {
                return false;
            }
            if (a == this.aw) {
                return false;
            }
            return true;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "as", {
        get: function () {
            return this.ar;
        },
        set: function (a) {
            if (a == this.ar) {
                return;
            }
            var b = this.ar;
            this.ar = a;
            this.cn("showSelectAll", b, this.ar);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "di", {
        get: function () {
            return this.c4;
        },
        set: function (a) {
            var b = this.c4;
            this.c4 = a;
            if (b != this.c4) {
                this.cn("BackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "dy", {
        get: function () {
            return this.dg;
        },
        set: function (a) {
            var b = this.dg;
            this.dg = a;
            if (b != this.dg) {
                this.cn("TextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    CheckboxList.prototype.cp = function (a) {
        if (this.selectAllCheckboxChanged != null) {
            this.selectAllCheckboxChanged(this, ((function () {
                var $ret = new SelectAllCheckboxChangedEventArgs();
                $ret.a = a;
                return $ret;
            })()));
        }
    };
    CheckboxList.prototype.al = function () {
        if (-1 == this.aw) {
            return true;
        }
        var a = this.g.count;
        switch (this.l) {
            case 0: return this.aw == a;
            case 1: return 0 == a;
            default: return false;
        }
    };
    CheckboxList.prototype.ak = function () {
        if (-1 == this.aw) {
            return false;
        }
        var a = this.g.count;
        switch (this.l) {
            case 0: return 0 == a;
            case 1: return this.aw == a;
            default: return false;
        }
    };
    CheckboxList.prototype.b7 = function () {
        var a = this.h.actualDataSource;
        if (null != a) {
            if (null == a.actualSchema) {
                this.aw = -1;
                return;
            }
            var b = a.actualCount;
            this.aw = b;
        }
        else {
            this.aw = -1;
        }
    };
    Object.defineProperty(CheckboxList.prototype, "aq", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            if (a == this.ap) {
                return;
            }
            var b = this.ap;
            this.ap = a;
            this.cn("ShowFilter", b, this.ap);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CheckboxList.prototype, "an", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            if (a == this.am) {
                return;
            }
            var b = this.am;
            this.am = a;
            this.cn("IsRowHoverEnabled", b, this.am);
        },
        enumerable: false,
        configurable: true
    });
    CheckboxList.$t = markType(CheckboxList, 'CheckboxList', Base.$, [INotifyPropertyChanged_$type]);
    CheckboxList.dx = BrushUtil.h(255, 24, 29, 31);
    CheckboxList.bt = "M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14z";
    CheckboxList.dp = BrushUtil.h(255, 248, 248, 248);
    CheckboxList.dq = BrushUtil.h(255, 24, 29, 31);
    return CheckboxList;
}(Base));
export { CheckboxList };
