/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType } from "igniteui-react-core";
import { IColumnGroupingVisualModelExport_$type } from "./IColumnGroupingVisualModelExport";
import { StringBuilder } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var ColumnGroupingVisualModelExport = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnGroupingVisualModelExport, _super);
    function ColumnGroupingVisualModelExport() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = 0;
        _this.a = 0;
        _this.o = null;
        _this.h = 0;
        _this.f = 0;
        _this.e = 0;
        _this.i = 0;
        _this.l = null;
        _this.m = null;
        _this.n = null;
        _this.g = 0;
        _this.j = null;
        _this.k = null;
        _this.c = null;
        _this.d = null;
        return _this;
    }
    ColumnGroupingVisualModelExport.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.l("{");
        a.l("density : " + this.b + ", ");
        a.l("baseTheme : " + this.a + ", ");
        a.l("title : " + this.o + ", ");
        a.l("top : " + this.h + ", ");
        a.l("left : " + this.f + ", ");
        a.l("height : " + this.e + ", ");
        a.l("width : " + this.i + ", ");
        if (!stringIsNullOrEmpty(this.l)) {
            a.l("textStyleFontStyle : \"" + this.l + "\", ");
        }
        if (!stringIsNullOrEmpty(this.m)) {
            a.l("textStyleFontVariant : \"" + this.m + "\", ");
        }
        if (!stringIsNullOrEmpty(this.n)) {
            a.l("textStyleFontWeight : \"" + this.n + "\", ");
        }
        if (!stringIsNullOrEmpty(this.j)) {
            a.l("textStyleFontFamily : \"" + this.j + "\", ");
        }
        if (!stringIsNullOrEmpty(this.k)) {
            a.l("textStyleFontStretch : \"" + this.k + "\", ");
        }
        if (!isNaN_(this.g)) {
            a.l("textStyleFontSize : " + this.g + ", ");
        }
        a.l("groupPipsModels: [");
        for (var b = 0; b < this.c.count; b++) {
            if (b != 0) {
                a.l(",");
            }
            a.l(this.c._inner[b].h());
        }
        a.l("],");
        a.l("iconsModels: [");
        for (var c = 0; c < this.d.count; c++) {
            if (c != 0) {
                a.l(",");
            }
            a.l(this.d._inner[c].j());
        }
        a.l("]");
        a.l("}");
        return a.toString();
    };
    ColumnGroupingVisualModelExport.$t = markType(ColumnGroupingVisualModelExport, 'ColumnGroupingVisualModelExport', Base.$, [IColumnGroupingVisualModelExport_$type]);
    return ColumnGroupingVisualModelExport;
}(Base));
export { ColumnGroupingVisualModelExport };
