/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { GridColumnDataType_$type } from "./GridColumnDataType";
/**
 * @hidden
 */
var ColumnState = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnState, _super);
    function ColumnState() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.r = null;
        return _this;
    }
    Object.defineProperty(ColumnState.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "nativeElement", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            this.r = a;
            this.b.o = this.r;
        },
        enumerable: false,
        configurable: true
    });
    ColumnState.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(ColumnState.prototype, "m", {
        get: function () {
            var ret_ = this.c.n("pinned");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("pinned", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "p", {
        get: function () {
            var ret_ = this.c.n("sortable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("sortable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "g", {
        get: function () {
            var ret_ = this.c.n("filterable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("filterable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "f", {
        get: function () {
            var ret_ = this.c.n("editable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("editable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "q", {
        get: function () {
            var ret_ = this.c.n("sortingIgnoreCase");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("sortingIgnoreCase", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "h", {
        get: function () {
            var ret_ = this.c.n("filteringIgnoreCase");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("filteringIgnoreCase", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "x", {
        get: function () {
            var ret_ = this.c.n("headerClasses");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("headerClasses", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "y", {
        get: function () {
            var ret_ = this.c.n("headerGroupClasses");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("headerGroupClasses", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "z", {
        get: function () {
            var ret_ = this.c.n("maxWidth");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("maxWidth", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "i", {
        get: function () {
            var ret_ = this.c.n("groupable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("groupable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "l", {
        get: function () {
            var ret_ = this.c.n("movable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("movable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "k", {
        get: function () {
            var ret_ = this.c.n("hidden");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("hidden", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "a", {
        get: function () {
            var ret_ = this.c.n("dataType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridColumnDataType_$type, EnumUtil.getEnumValue(GridColumnDataType_$type, this.c.f(GridColumnDataType_$type, ret_)));
            return EnumUtil.getEnumValue(GridColumnDataType_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridColumnDataType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.c.v("dataType", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "j", {
        get: function () {
            var ret_ = this.c.n("hasSummary");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("hasSummary", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "v", {
        get: function () {
            var ret_ = this.c.n("field");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("field", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "u", {
        get: function () {
            var ret_ = this.c.n("width");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("width", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "w", {
        get: function () {
            var ret_ = this.c.n("header");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("header", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "n", {
        get: function () {
            var ret_ = this.c.n("resizable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("resizable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "o", {
        get: function () {
            var ret_ = this.c.n("searchable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("searchable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "d", {
        get: function () {
            var ret_ = this.c.n("columnGroup");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("columnGroup", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "t", {
        get: function () {
            var ret_ = this.c.n("parent");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("parent", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColumnState.prototype, "e", {
        get: function () {
            var ret_ = this.c.n("disableHiding");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("disableHiding", value_);
        },
        enumerable: false,
        configurable: true
    });
    ColumnState.$t = markType(ColumnState, 'ColumnState');
    return ColumnState;
}(Base));
export { ColumnState };
