/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PivotDimension } from "./PivotDimension";
import { PivotDimensionType_$type } from "./PivotDimensionType";
/**
 * @hidden
 */
var DimensionsChange = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DimensionsChange, _super);
    function DimensionsChange() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = new WCNativeHelper();
        _this.e = null;
        return _this;
    }
    Object.defineProperty(DimensionsChange.prototype, "d", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DimensionsChange.prototype, "nativeElement", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
            this.c.o = this.e;
        },
        enumerable: false,
        configurable: true
    });
    DimensionsChange.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(DimensionsChange.prototype, "a", {
        get: function () {
            var ret_ = this.d.m("dimensions", function (a) { return new PivotDimension(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("dimensions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DimensionsChange.prototype, "b", {
        get: function () {
            var ret_ = this.d.n("dimensionCollectionType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(PivotDimensionType_$type, EnumUtil.getEnumValue(PivotDimensionType_$type, this.d.f(PivotDimensionType_$type, ret_)));
            return EnumUtil.getEnumValue(PivotDimensionType_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(PivotDimensionType_$type, a);
            value_ = this.d.f(PivotDimensionType_$type, value_);
            this.d.v("dimensionCollectionType", value_);
        },
        enumerable: false,
        configurable: true
    });
    DimensionsChange.$t = markType(DimensionsChange, 'DimensionsChange');
    return DimensionsChange;
}(Base));
export { DimensionsChange };
