/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridCellBase } from "./GridCellBase";
import { DataSourceSchemaPropertyType_$type } from "igniteui-react-core";
import { enumGetBox, runOn, delegateCombine, delegateRemove, markType } from "igniteui-react-core";
import { EditorType_$type } from "./EditorType";
import { Popup } from "igniteui-react-core";
import { TextEditorView } from "./TextEditorView";
import { NumericEditorView } from "./NumericEditorView";
import { DateEditorView } from "./DateEditorView";
import { ComboEditorView } from "./ComboEditorView";
import { Rect } from "igniteui-react-core";
import { stringIsNullOrWhiteSpace } from "igniteui-react-core";
/**
 * @hidden
 */
var EditorCell = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(EditorCell, _super);
    function EditorCell(a) {
        var _this = _super.call(this, a) || this;
        _this.cn = null;
        _this.cw = null;
        _this.cv = null;
        _this.cu = null;
        _this.ct = null;
        _this.dc = null;
        _this.dd = null;
        _this.de = null;
        _this.cx = null;
        _this.c0 = false;
        _this.c4 = false;
        _this.c1 = false;
        _this.cj = 0;
        _this.dg = null;
        _this.cy = null;
        _this.cl = 1;
        _this.df = null;
        _this.dj = null;
        _this.ch = null;
        _this.c2 = true;
        _this.dk = null;
        _this.c3 = false;
        _this.c6 = false;
        _this.c7 = false;
        _this.c5 = false;
        _this.ae.setAttribute("tabindex", "-1");
        _this.ae.setStyleProperty("outline", "none");
        _this.ae.setStyleProperty("display", "flex");
        _this.ae.setStyleProperty("align-items", "center");
        _this.ae.listen("focusout", runOn(_this, _this.eb));
        _this.ae.listen("focusin", runOn(_this, _this.d9));
        return _this;
    }
    Object.defineProperty(EditorCell.prototype, "ck", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            var b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.bp("DataType", enumGetBox(DataSourceSchemaPropertyType_$type, b), enumGetBox(DataSourceSchemaPropertyType_$type, this.cj));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(EditorCell.prototype, "di", {
        get: function () {
            return this.dg;
        },
        set: function (a) {
            var b = this.dg;
            this.dg = a;
            this.bp("Value", b, this.dg);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(EditorCell.prototype, "cz", {
        get: function () {
            return this.cy;
        },
        set: function (a) {
            var b = this.cy;
            this.cy = a;
            if (b != this.cy) {
                this.bp("FontInfo", b, this.cy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(EditorCell.prototype, "cm", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.bp("EditorType", enumGetBox(EditorType_$type, b), enumGetBox(EditorType_$type, this.cl));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(EditorCell.prototype, "dh", {
        get: function () {
            return this.df;
        },
        set: function (a) {
            var b = this.df;
            this.df = a;
            if (b != this.df) {
                this.bp("ComboItemsSource", b, this.df);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(EditorCell.prototype, "dm", {
        get: function () {
            return this.dj;
        },
        set: function (a) {
            var b = this.dj;
            this.dj = a;
            if (b != this.dj) {
                this.bp("ComboTextField", b, this.dj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(EditorCell.prototype, "ci", {
        get: function () {
            return this.ch;
        },
        set: function (a) {
            var b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.bp("ComboValueField", b, this.ch);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(EditorCell.prototype, "da", {
        get: function () {
            return this.c2;
        },
        set: function (a) {
            var b = this.c2;
            this.c2 = a;
            if (b != this.c2) {
                this.bp("IsHidden", b, this.c2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(EditorCell.prototype, "dr", {
        get: function () {
            return this.dk;
        },
        set: function (a) {
            var b = this.dk;
            this.dk = a;
            if (b != this.dk) {
                this.bp("DateFormatString", b, this.dk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(EditorCell.prototype, "db", {
        get: function () {
            return this.c3;
        },
        set: function (a) {
            var b = this.c3;
            this.c3 = a;
            if (b != this.c3) {
                this.bp("ShowTodayButton", b, this.c3);
            }
        },
        enumerable: false,
        configurable: true
    });
    EditorCell.prototype.cs = function (a) {
        if (this.dc == null) {
            this.dc = this.ab.createElement("div");
            var b = this.ab.getSubRenderer(this.dc);
            this.cx = new Popup();
            this.cx.provideRenderer(b);
            this.de = this.ab.createElement("div");
            this.de.setStyleProperty("background-color", "rgba(0,0,0,0.7)");
            this.de.setStyleProperty("color", "#fff");
            this.de.setStyleProperty("padding", "5px");
            this.de.setStyleProperty("outline", "none");
            this.de.setAttribute("tabindex", "-1");
            this.dd = this.ab.createElement("div");
            this.dd.setStyleProperty("white-space", "pre");
            if (this.cz != null) {
                this.dd.setStyleProperty("font", this.cz.fontString);
            }
            this.de.append(this.dd);
            this.cx.appendPopupContent(this.de);
        }
        var c = null;
        switch (a) {
            case 1:
                c = this.cr();
                break;
            case 2:
                c = this.cq();
                break;
            case 3:
                c = this.cp();
                break;
            case 4:
                c = this.co();
                break;
        }
        return c;
    };
    EditorCell.prototype.cr = function () {
        if (this.cw != null) {
            this.d3();
            this.d8();
            return this.cw;
        }
        this.cw = new TextEditorView(this.ab, this.f.getTheme(), this.b);
        this.cw.setFont(this.cz);
        return this.cw;
    };
    EditorCell.prototype.cq = function () {
        if (this.cv != null) {
            this.d3();
            this.d8();
            return this.cv;
        }
        this.cv = new NumericEditorView(this.ab, this.f.getTheme(), this.b);
        this.cv.setFont(this.cz);
        return this.cv;
    };
    EditorCell.prototype.cp = function () {
        if (this.cu != null) {
            this.d3();
            this.d8();
            return this.cu;
        }
        this.cu = new DateEditorView(this.ab, this.f.getTheme(), this.b);
        this.cu.setFont(this.cz);
        return this.cu;
    };
    EditorCell.prototype.co = function () {
        if (this.ct != null) {
            this.d2();
            this.d3();
            this.d8();
            return this.ct;
        }
        this.ct = new ComboEditorView(this.ab, this.f.getTheme(), this.b);
        this.ct.setFont(this.cz);
        this.ct.ag = this.dh;
        this.ct.aj = this.dm;
        this.ct.z = this.ci;
        return this.ct;
    };
    EditorCell.prototype.ea = function (a, b) {
        if (b.g != b.d || b.h != b.e) {
            if (this.ct != null) {
                this.ct.am();
            }
            if (this.cu != null) {
                this.cu.ag();
            }
            this.d0();
        }
    };
    EditorCell.prototype.dy = function () {
        if (!this.c1) {
            if (this.cn != null) {
                this.cn.attachEvents();
                var a = this.cn;
                a.valueProvided = delegateCombine(a.valueProvided, runOn(this, this.eg));
                var b = this.cn;
                b.lostFocus = delegateCombine(b.lostFocus, runOn(this, this.d6));
                var c = this.cn;
                c.gotFocus = delegateCombine(c.gotFocus, runOn(this, this.d5));
                var d = this.cn;
                d.userTyping = delegateCombine(d.userTyping, runOn(this, this.ee));
                this.c1 = true;
            }
        }
    };
    EditorCell.prototype.dz = function () {
        if (this.c1) {
            if (this.cn != null) {
                this.cn.detachEvents();
                var a = this.cn;
                a.valueProvided = delegateRemove(a.valueProvided, runOn(this, this.eg));
                var b = this.cn;
                b.lostFocus = delegateRemove(b.lostFocus, runOn(this, this.d6));
                var c = this.cn;
                c.gotFocus = delegateRemove(c.gotFocus, runOn(this, this.d5));
                var d = this.cn;
                d.userTyping = delegateRemove(d.userTyping, runOn(this, this.ee));
                this.c1 = false;
            }
        }
    };
    EditorCell.prototype.ed = function (a) {
        this.c6 = false;
        this.c7 = false;
        this.c5 = false;
        if (!a) {
            this.c7 = true;
            this.cn.onTargetChanged();
        }
    };
    EditorCell.prototype.ef = function () {
        if (this.cn != null) {
            this.cn.value = this.di;
        }
    };
    EditorCell.prototype.d3 = function () {
    };
    EditorCell.prototype.d7 = function () {
        this.c0 = true;
        this.dz();
        this.ae.removeChildren();
        if (this.cn != null) {
            this.cn.cleanUp();
        }
        this.cn = this.cs(this.cm);
        this.ae.append(this.cn.container);
        this.dy();
        if (this.cn != null) {
            this.cn.isEnabled = !this.isRemoved;
            if (!this.da) {
                this.cn.onEditStarted();
            }
        }
        this.c0 = false;
    };
    EditorCell.prototype.d2 = function () {
        if (this.ct != null) {
            this.ct.ag = this.dh;
            this.ct.aj = this.dm;
            this.ct.z = this.ci;
        }
    };
    EditorCell.prototype.d8 = function () {
        if (this.cz != null) {
            if (this.cw != null) {
                this.cw.setFont(this.cz);
            }
            if (this.cv != null) {
                this.cv.setFont(this.cz);
            }
            if (this.cu != null) {
                this.cu.setFont(this.cz);
            }
            if (this.ct != null) {
                this.ct.setFont(this.cz);
            }
            this.dd.setStyleProperty("font", this.cz.fontString);
        }
    };
    EditorCell.prototype.d1 = function () {
        this.c4 = false;
        if (this.cn != null) {
            if (!this.da) {
                this.cn.onEditStarted();
            }
            else {
                this.cn.onEditEnded();
                this.cn.value = null;
                this.cn.value = this.di;
            }
        }
    };
    EditorCell.prototype.d4 = function () {
        if (this.cn != null && this.cu == this.cn) {
            this.cu.ae = this.dr;
        }
    };
    EditorCell.prototype.ec = function () {
        if (this.cn != null && this.cu == this.cn) {
            this.cu.ac = this.db;
        }
    };
    EditorCell.prototype.eh = function (a, b, c, d, e) {
        if (!stringIsNullOrWhiteSpace(a)) {
            this.dd.setRawText(a);
            this.cx.b8();
            this.ei();
        }
    };
    EditorCell.prototype.ei = function () {
        var rect_ = this.ae.getNativeElement().getBoundingClientRect();
        var a = new Rect(4);
        a.left = (rect_.left + window.pageXOffset);
        a.top = (rect_.top + window.pageYOffset);
        a.right = (rect_.right + window.pageXOffset);
        a.bottom = (rect_.bottom + window.pageYOffset);
        this.cx.showRelativeToExclusionRect(a, 1, 0);
    };
    EditorCell.prototype.d0 = function () {
        if (this.cx.aw) {
            this.cx.b5();
        }
    };
    EditorCell.prototype.bo = function () {
        if (this.cn == null) {
            this.d7();
            this.f.setViewportChangedHandler(runOn(this, this.ea));
        }
    };
    EditorCell.prototype.be = function () {
        if (this.cn != null) {
            this.cn.focus();
        }
    };
    EditorCell.prototype.bp = function (a, b, c) {
        _super.prototype.bp.call(this, a, b, c);
        switch (a) {
            case "EditorType":
                this.d7();
                break;
            case "ComboItemsSource":
            case "ComboTextField":
            case "ComboValueField":
                this.d2();
                break;
            case "DataType":
                this.d3();
                break;
            case "Value":
                this.ef();
                break;
            case "FontInfo":
                this.d8();
                break;
            case "IsHidden":
                this.d1();
                break;
            case "DateFormatString":
                this.d4();
                break;
            case "ShowTodayButton":
                this.ec();
                break;
            case "IsRemoved":
                if (this.cn != null) {
                    this.cn.isEnabled = !this.isRemoved;
                    if (!this.isRemoved) {
                        this.cn.onTargetChanged();
                    }
                }
                break;
        }
    };
    EditorCell.prototype.eg = function (a, b, c) {
        if (a == this.cn) {
            if (!c) {
                this.b.updateCellEditValue(b);
            }
        }
    };
    EditorCell.prototype.ee = function (a) {
        if (a == this.cn) {
            this.b.startEditMode();
        }
    };
    EditorCell.prototype.c9 = function (a) {
        if (a != null && this.cx != null && this.cx.aw) {
            var b = this.de.getNativeElement();
            return b.contains(a);
        }
        return false;
    };
    EditorCell.prototype.c8 = function (a) {
        if (a != null) {
            var b = this.ae.getNativeElement();
            return b.contains(a);
        }
        return false;
    };
    EditorCell.prototype.eb = function (a) {
        var _this = this;
        if (!this.c0) {
            var b = (a.originalEvent.relatedTarget);
            if (this.c5 && !this.c8(b) && !this.c9(b)) {
                this.b.editorCellLostFocus();
                this.d0();
            }
            var c = this.ab.rootWrapper.getNativeElement();
            if (c.contains(b)) {
                window.setTimeout(function () {
                    var d = document.activeElement.nodeName;
                    if (d == "INPUT" || d == "SELECT" || d == "TEXTAREA" || d == "BUTTON" || d == "OPTION") {
                        return;
                    }
                    if (_this.b.isEditRefocusDesired && _this.cn != null) {
                        _this.cn.focus();
                    }
                }, 0);
            }
        }
    };
    EditorCell.prototype.d9 = function (a) {
        if (this.c6 && !this.cx.aw) {
            this.ei();
        }
    };
    EditorCell.prototype.d6 = function (a) {
        this.c5 = true;
    };
    EditorCell.prototype.d5 = function (a) {
        this.c5 = false;
    };
    EditorCell.prototype.onContactStarted = function (a, b) {
        a.stopPropagation();
    };
    EditorCell.prototype.onContactCompleted = function (a, b) {
        a.stopPropagation();
    };
    EditorCell.prototype.onDoubleClick = function (a) {
        a.stopPropagation();
    };
    EditorCell.$t = markType(EditorCell, 'EditorCell', GridCellBase.$);
    return EditorCell;
}(GridCellBase));
export { EditorCell };
