/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridCellBase } from "./GridCellBase";
import { ComparisonOperatorSelector } from "./ComparisonOperatorSelector";
import { XIcon } from "igniteui-react-inputs";
import { DataSourceSchemaPropertyType_$type } from "igniteui-react-core";
import { EditorType_$type } from "./EditorType";
import { Base, runOn, delegateCombine, typeCast, delegateRemove, enumGetBox, markType } from "igniteui-react-core";
import { TextEditorView } from "./TextEditorView";
import { NumericEditorView } from "./NumericEditorView";
import { DateEditorView } from "./DateEditorView";
import { ColumnComparisonConditionOperatorType_$type } from "./ColumnComparisonConditionOperatorType";
import { ColumnComparisonFilterCondition } from "./ColumnComparisonFilterCondition";
import { ColumnCustomFilterCondition } from "./ColumnCustomFilterCondition";
import { tryParseNumber } from "igniteui-react-core";
/**
 * @hidden
 */
var FilterCell = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FilterCell, _super);
    function FilterCell(a) {
        var _this = _super.call(this, a) || this;
        _this.c4 = null;
        _this.c6 = null;
        _this.c2 = null;
        _this.c3 = null;
        _this.c5 = null;
        _this.cv = null;
        _this.cu = null;
        _this.ct = null;
        _this.ck = null;
        _this.cw = null;
        _this.cr = null;
        _this.cz = true;
        _this.cl = 0;
        _this.c0 = true;
        _this.cp = null;
        _this.cx = null;
        _this.c7 = null;
        _this.ch = null;
        _this.d6 = null;
        _this.c4 = a.createElement("div");
        _this.c4.setStyleProperty("display", "flex");
        _this.c4.setStyleProperty("flex-direction", "row");
        _this.c4.setStyleProperty("align-items", "center");
        _this.c4.setStyleProperty("height", "100%");
        _this.ae.append(_this.c4);
        _this.c6 = a.createElement("div");
        _this.c2 = a.getSubRenderer(_this.c6);
        _this.ck = new ComparisonOperatorSelector();
        _this.ck.ej(_this.c2);
        _this.c6.setStyleProperty("width", "24px");
        _this.c6.setStyleProperty("height", "24px");
        _this.c4.append(_this.c6);
        _this.c3 = a.createElement("div");
        _this.c3.setStyleProperty("display", "flex");
        _this.c3.setStyleProperty("flex", "1");
        _this.c3.setStyleProperty("margin", "0 4px");
        _this.c4.append(_this.c3);
        _this.c5 = a.createElement("div");
        _this.c5.setStyleProperty("transform", "scale(0.75)");
        _this.cw = new XIcon();
        _this.cw.provideContainer(a.getSubRenderer(_this.c5));
        _this.c4.append(_this.c5);
        _this.dp();
        return _this;
    }
    FilterCell.prototype.cs = function (a) {
        switch (this.cm) {
            case 0:
            case 1:
                if (this.cv == null) {
                    this.cv = new TextEditorView(this.ab, this.f.getTheme(), this.b);
                }
                return this.cv;
            case 2:
                if (this.cu == null) {
                    this.cu = new NumericEditorView(this.ab, this.f.getTheme(), this.b);
                }
                return this.cu;
            case 3:
                if (this.ct == null) {
                    this.ct = new DateEditorView(this.ab, this.f.getTheme(), this.b);
                }
                return this.ct;
            default: return null;
        }
    };
    FilterCell.prototype.d1 = function () {
        this.c3.removeChildren();
    };
    FilterCell.prototype.dm = function () {
        this.c3.append(this.cr.container);
    };
    FilterCell.prototype.du = function () {
        if (this.ae.getChildCount() == 0) {
            this.ae.append(this.c4);
        }
    };
    FilterCell.prototype.ds = function () {
        if (this.ae.getChildCount() > 0) {
            this.ae.removeChildren();
        }
    };
    FilterCell.prototype.bp = function (a, b, c) {
        _super.prototype.bp.call(this, a, b, c);
        this.d0(a, b, c);
    };
    FilterCell.prototype.bo = function () {
        this.dy();
    };
    FilterCell.prototype.d2 = function (a, b, c, d) {
        if (this.d != null) {
            var e = this.c6.getNativeElement();
            this.d.update("SelectorTop", (e.offsetTop));
            this.d.update("SelectorLeft", (e.offsetLeft));
            var f = this.c3.getNativeElement();
            this.d.update("EditorTop", (f.offsetTop));
            this.d.update("EditorLeft", (f.offsetLeft));
            var g = this.c5.getNativeElement();
            this.d.update("ClearIconTop", (g.offsetTop));
            this.d.update("ClearIconLeft", (g.offsetLeft));
        }
    };
    FilterCell.prototype.dp = function () {
        var a = this.ck;
        a.valueChanged = delegateCombine(a.valueChanged, runOn(this, this.dz));
        this.cw.svgPath = FilterCell.c9;
        this.d4(false);
        var b = this.cw;
        b.clicked = delegateCombine(b.clicked, runOn(this, this.dn));
    };
    FilterCell.prototype.dy = function () {
        if (this.cr == null) {
            this.dt();
        }
    };
    FilterCell.prototype.cn = function () {
        var a = 1;
        switch (this.cj) {
            case 11:
            case 2:
            case 0:
                a = 1;
                break;
            case 8:
                a = 3;
                break;
            case 10:
            case 6:
            case 5:
            case 1:
            case 3:
            case 4:
            case 7:
                a = 2;
                break;
        }
        switch (this.ck.b) {
            case 6:
            case 8:
            case 7:
            case 9:
                a = 2;
                break;
            case 38:
                a = 1;
                break;
            case 39:
                a = 2;
                break;
        }
        if (this.ck.b == 44) {
            if (this.cq != null && this.cq.count > 0) {
                var b = this.cq._inner[this.ck.x];
                switch (b.b) {
                    case 0:
                    case 1:
                        a = 1;
                        break;
                    case 2:
                        a = 2;
                        break;
                    case 3:
                        a = 3;
                        break;
                }
            }
        }
        return a;
    };
    FilterCell.prototype.d4 = function (a) {
        if (this.cw != null) {
            this.cw.disabled = !a;
            this.cw.ai = a ? 1 : 0.3;
        }
    };
    FilterCell.prototype.di = function (a) {
        if (!this.cz) {
            return;
        }
        if (this.ck.b == 44) {
            if (this.cq != null && this.cq.count > 0) {
                this.b.applyCustomFilter(this.ck.ae, this.ck.x, a);
            }
        }
        else {
            this.b.applyFilter(this.ck.b, a);
        }
    };
    FilterCell.prototype.dj = function () {
        if (!this.cz) {
            return;
        }
        if (this.b != null) {
            this.b.clearFilter();
        }
    };
    FilterCell.prototype.d0 = function (a, b, c) {
        switch (a) {
            case "DataType":
                this.dr();
                break;
            case "EditorType":
                this.dt();
                break;
            case "FontInfo":
                this.dx();
                break;
            case "Filter":
                this.dv();
                break;
            case "FilterOperands":
                this.dq();
                break;
            case "FilterValue":
                this.dw();
                break;
            case "IsEditorEnabled":
                this.cr.isEnabled = this.c1;
                break;
            case "TextColor":
                this.ck.eq = this.d7;
                this.cw.fill = this.d7;
                this.cr.textColor = this.d7;
                break;
        }
    };
    FilterCell.prototype.dv = function () {
        this.cz = false;
        if (this.cr != null) {
            if (this.ci != null) {
                if (typeCast(ColumnComparisonFilterCondition.$, this.ci) !== null) {
                    var a = typeCast(ColumnComparisonFilterCondition.$, this.ci);
                    this.ck.b = a.operator;
                    var b = this.cr.getEditorValue();
                    if (b != null) {
                        if (!Base.equalsStatic(b, a.value)) {
                            this.cr.value = a.value;
                            this.c8 = a.value;
                        }
                    }
                    else {
                        this.cr.value = a.value;
                        this.c8 = a.value;
                    }
                }
                else if (typeCast(ColumnCustomFilterCondition.$, this.ci) !== null) {
                    var c = typeCast(ColumnCustomFilterCondition.$, this.ci);
                    this.ck.ek(c.id, c.index);
                    var d = this.cr.getEditorValue();
                    if (d != null) {
                        if (!Base.equalsStatic(d, c.value)) {
                            this.cr.value = c.value;
                            this.c8 = c.value;
                        }
                    }
                    else {
                        this.cr.value = c.value;
                        this.c8 = c.value;
                    }
                }
                else if (!(typeCast(ColumnCustomFilterCondition.$, this.ci) !== null)) {
                    this.c8 = null;
                    this.cr.value = this.c8;
                    this.cr.setEditorValue(this.c8);
                }
            }
            else {
                this.c8 = null;
                this.cr.value = this.c8;
                this.cr.setEditorValue(this.c8);
                if (!this.c1) {
                    this.ck.b = 0;
                }
            }
        }
        this.cz = true;
    };
    FilterCell.prototype.dq = function () {
        this.ck.d7();
        for (var a = 0; a < this.cq.count; a++) {
            this.ck.d1(this.cq._inner[a].e, this.cq._inner[a].f, this.cq._inner[a].g, a);
        }
    };
    FilterCell.prototype.dr = function () {
        if (this.cj == 11) {
            this.c1 = false;
        }
        this.cm = this.cn();
    };
    FilterCell.prototype.dw = function () {
        this.d4(this.c8 != null);
        if (this.c8 == null || Base.equalsStatic(this.c8, "")) {
            this.dj();
        }
        else {
            this.di(this.c8);
        }
        if (this.d != null) {
            this.d.update("FilterValue", this.c8);
        }
    };
    FilterCell.prototype.dt = function () {
        if (this.cr != null) {
            this.cr.detachEvents();
            var a = this.cr;
            a.valueProvided = delegateRemove(a.valueProvided, runOn(this, this.d3));
        }
        this.d1();
        this.cr = this.cs(this.cm);
        this.cr.onEditStarted();
        if (this.cr != null) {
            this.cr.attachEvents();
            this.cr.setFont(this.cy);
            this.cr.isEnabled = this.c1;
            this.cr.focusOnValueChanged = false;
            this.cr.showClearButton = false;
            var b = this.cr;
            b.valueProvided = delegateCombine(b.valueProvided, runOn(this, this.d3));
            this.dm();
        }
        this.dn(null, null);
    };
    FilterCell.prototype.dx = function () {
        if (this.cy != null) {
            if (this.cr != null) {
                this.cr.setFont(this.cy);
            }
        }
    };
    FilterCell.prototype.dz = function (a, b) {
        this.cm = this.cn();
        switch (b.newValue) {
            case 40:
            case 11:
            case 43:
            case 42:
            case 26:
            case 29:
            case 23:
            case 32:
            case 24:
            case 27:
            case 21:
            case 30:
            case 25:
            case 28:
            case 22:
            case 31:
            case 41:
            case 34:
            case 35:
            case 36:
            case 37:
            case 18:
            case 19:
            case 10:
            case 33:
            case 20:
                this.c1 = false;
                break;
            default:
                this.c1 = true;
                break;
        }
        if (this.cj == 11) {
            this.c1 = false;
        }
        if (b.newValue == 44) {
            if (this.cq != null && this.cq.count > 0) {
                var c = this.cq._inner[this.ck.x];
                this.c1 = c.d;
            }
        }
        if (!this.c1) {
            this.di(null);
            this.d4(true);
        }
        else if (this.c8 != null && !Base.equalsStatic(this.c8, "")) {
            this.di(this.c8);
        }
        else {
            this.dj();
            this.d4(false);
        }
        if (this.d != null) {
            this.d.update("OperatorType", enumGetBox(ColumnComparisonConditionOperatorType_$type, this.ck.b));
        }
    };
    FilterCell.prototype.dn = function (a, b) {
        if (b != null) {
            if (!this.c1) {
                this.ck.b = 0;
                this.dj();
            }
        }
        this.c8 = null;
        if (this.cr != null) {
            this.cr.setEditorValue(null);
            this.cr.value = null;
        }
    };
    FilterCell.prototype.d3 = function (a, b, c) {
        if (this.cm == 2) {
            if (typeof b === 'string') {
                var d_1;
                if (((function () { var e = tryParseNumber(b, d_1); d_1 = e.p1; return e.ret; })())) {
                    b = d_1;
                }
            }
        }
        this.c8 = b;
    };
    FilterCell.prototype.d5 = function (a, b, c, d) {
        this.d2(a, b, c, d);
    };
    FilterCell.prototype.co = function (a, b) {
        if (a != null) {
            for (var c = 0; c < this.cq.count; c++) {
                if (this.cq._inner[c].g == a) {
                    return this.cq._inner[c];
                }
            }
        }
        if (b >= 0 && b < this.cq.count) {
            return this.cq._inner[b];
        }
        return null;
    };
    FilterCell.prototype.dl = function () {
        this.du();
    };
    FilterCell.prototype.dk = function () {
        this.ds();
    };
    Object.defineProperty(FilterCell.prototype, "cj", {
        get: function () {
            return this.ck.d;
        },
        set: function (a) {
            var b = this.ck.d;
            this.ck.d = a;
            if (b != a) {
                this.bp("DataType", enumGetBox(DataSourceSchemaPropertyType_$type, b), enumGetBox(DataSourceSchemaPropertyType_$type, this.ck.d));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilterCell.prototype, "cm", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cl = a;
            if (b != a) {
                this.bp("EditorType", enumGetBox(EditorType_$type, b), enumGetBox(EditorType_$type, this.cl));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilterCell.prototype, "c1", {
        get: function () {
            return this.c0;
        },
        set: function (a) {
            var b = this.c0;
            this.c0 = a;
            if (b != this.c0) {
                this.bp("IsEditorEnabled", b, this.c0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilterCell.prototype, "cq", {
        get: function () {
            return this.cp;
        },
        set: function (a) {
            var b = this.cp;
            this.cp = a;
            if (this.cp != null) {
                this.bp("FilterOperands", b, this.cp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilterCell.prototype, "cy", {
        get: function () {
            return this.cx;
        },
        set: function (a) {
            var b = this.cx;
            this.cx = a;
            if (b != this.cx) {
                this.bp("FontInfo", b, this.cx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilterCell.prototype, "c8", {
        get: function () {
            return this.c7;
        },
        set: function (a) {
            var b = this.c7;
            this.c7 = a;
            if (b != this.c7) {
                this.bp("FilterValue", b, this.c7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilterCell.prototype, "ci", {
        get: function () {
            return this.ch;
        },
        set: function (a) {
            var b = this.ch;
            this.ch = a;
            if (b != a) {
                this.bp("Filter", b, this.ch);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilterCell.prototype, "d7", {
        get: function () {
            return this.d6;
        },
        set: function (a) {
            var b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.bp("TextColor", b, this.d6);
            }
        },
        enumerable: false,
        configurable: true
    });
    FilterCell.$t = markType(FilterCell, 'FilterCell', GridCellBase.$);
    FilterCell.c9 = "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z";
    return FilterCell;
}(GridCellBase));
export { FilterCell };
