/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { CellModelExport } from "./CellModelExport";
import { DataSourceSchemaPropertyType_$type } from "igniteui-react-core";
import { ColumnComparisonConditionOperatorType_$type } from "./ColumnComparisonConditionOperatorType";
import { enumGetBox, markType } from "igniteui-react-core";
/**
 * @hidden
 */
var FilterCellModelExport = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FilterCellModelExport, _super);
    function FilterCellModelExport() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.af = 0;
        _this.ag = false;
        _this.ae = 0;
        _this.an = null;
        _this.am = 0;
        _this.al = 0;
        _this.ak = 0;
        _this.aj = 0;
        _this.ai = 0;
        _this.ah = 0;
        return _this;
    }
    FilterCellModelExport.prototype.get_ac = function () {
        return "FilterCell";
    };
    FilterCellModelExport.prototype.ad = function (a) {
        _super.prototype.ad.call(this, a);
        a.l("dataType: '" + enumGetBox(DataSourceSchemaPropertyType_$type, this.af) + "', ");
        a.l("isEnabled: " + this.ag.toString().toLowerCase() + ", ");
        a.l("filterValue: '" + this.an + "', ");
        a.l("operatorType: '" + enumGetBox(ColumnComparisonConditionOperatorType_$type, this.ae) + "', ");
        a.l("selectorTop: '" + this.am + "', ");
        a.l("selectorLeft: '" + this.al + "', ");
        a.l("editorTop: '" + this.ak + "', ");
        a.l("editorLeft: '" + this.aj + "', ");
        a.l("clearIconTop: '" + this.ai + "', ");
        a.l("clearIconLeft: '" + this.ah + "', ");
    };
    FilterCellModelExport.$t = markType(FilterCellModelExport, 'FilterCellModelExport', CellModelExport.$);
    return FilterCellModelExport;
}(CellModelExport));
export { FilterCellModelExport };
