/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-react-core";
/**
 * Indicates how filters across fields are combined.
 */
export var FilterLogicalOperator = /*@__PURE__*/ (function (FilterLogicalOperator) {
    /**
     * The filters applied through the filter UI across multiple fields are AND'ed together.
     */
    FilterLogicalOperator[FilterLogicalOperator["And"] = 0] = "And";
    /**
     * The filters applied through the filter UI across multiple fields are OR'ed together.
     */
    FilterLogicalOperator[FilterLogicalOperator["Or"] = 1] = "Or";
    return FilterLogicalOperator;
})({});
/**
 * @hidden
 */
export var FilterLogicalOperator_$type = /*@__PURE__*/ markEnum('FilterLogicalOperator', 'And,0|Or,1');
