/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { FilteringExpressionsTreeOrFilteringExpression } from "./FilteringExpressionsTreeOrFilteringExpression";
import { FilteringLogic_$type } from "./FilteringLogic";
import { FilteringExpressionsTreeType_$type } from "./FilteringExpressionsTreeType";
/**
 * @hidden
 */
var FilteringExpressionsTreeDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FilteringExpressionsTreeDetail, _super);
    function FilteringExpressionsTreeDetail() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e = new WCNativeHelper();
        _this.i = null;
        return _this;
    }
    Object.defineProperty(FilteringExpressionsTreeDetail.prototype, "f", {
        get: function () {
            return this.e;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilteringExpressionsTreeDetail.prototype, "nativeElement", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            this.i = a;
            this.e.o = this.i;
        },
        enumerable: false,
        configurable: true
    });
    FilteringExpressionsTreeDetail.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(FilteringExpressionsTreeDetail.prototype, "a", {
        get: function () {
            var ret_ = this.f.n("filteringOperands");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.v("filteringOperands", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilteringExpressionsTreeDetail.prototype, "d", {
        get: function () {
            var ret_ = this.f.n("operator");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilteringLogic_$type, EnumUtil.getEnumValue(FilteringLogic_$type, this.f.f(FilteringLogic_$type, ret_)));
            return EnumUtil.getEnumValue(FilteringLogic_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(FilteringLogic_$type, a);
            value_ = this.f.f(FilteringLogic_$type, value_);
            this.f.v("operator", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilteringExpressionsTreeDetail.prototype, "k", {
        get: function () {
            var ret_ = this.f.n("fieldName");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.v("fieldName", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FilteringExpressionsTreeDetail.prototype, "c", {
        get: function () {
            var ret_ = this.f.n("type");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilteringExpressionsTreeType_$type, EnumUtil.getEnumValue(FilteringExpressionsTreeType_$type, this.f.f(FilteringExpressionsTreeType_$type, ret_)));
            return EnumUtil.getEnumValue(FilteringExpressionsTreeType_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(FilteringExpressionsTreeType_$type, a);
            value_ = this.f.f(FilteringExpressionsTreeType_$type, value_);
            this.f.v("type", value_);
        },
        enumerable: false,
        configurable: true
    });
    FilteringExpressionsTreeDetail.prototype.g = function (a) {
        return (this.nativeElement.empty(this.f.i(a)));
    };
    FilteringExpressionsTreeDetail.prototype.b = function (a) {
        return this.f.g(this.nativeElement.find(this.f.i(a)), function (b) { return new FilteringExpressionsTreeOrFilteringExpression(); });
    };
    FilteringExpressionsTreeDetail.prototype.h = function (a) {
        return (this.nativeElement.findIndex(this.f.i(a)));
    };
    FilteringExpressionsTreeDetail.$t = markType(FilteringExpressionsTreeDetail, 'FilteringExpressionsTreeDetail');
    return FilteringExpressionsTreeDetail;
}(Base));
export { FilteringExpressionsTreeDetail };
