/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, runOn, markType, PointUtil } from "igniteui-react-core";
import { INativeCell_$type } from "./INativeCell";
import { GridExpansionIndicator } from "./GridExpansionIndicator";
import { PlaceholderView } from "./PlaceholderView";
import { Color } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { Random } from "igniteui-react-core";
import { intDivide, truncate, isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var GridCellBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridCellBase, _super);
    function GridCellBase(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.e = null;
        _this.c = null;
        _this.aa = null;
        _this.ac = null;
        _this.p = false;
        _this.ad = null;
        _this.i = null;
        _this.ap = 0;
        _this.am = 24;
        _this.ao = 0;
        _this.an = 0;
        _this.as = 0;
        _this.m = false;
        _this.n = false;
        _this.o = true;
        _this.k = false;
        _this.au = 0;
        _this.aw = 0;
        _this.av = 0;
        _this.at = 0;
        _this.ah = 0;
        _this.aj = 0;
        _this.ai = 0;
        _this.ag = 0;
        _this.cg = null;
        _this.aq = 0;
        _this.az = 0;
        _this.ar = 0;
        _this.j = null;
        _this.g = 0;
        _this.h = 0;
        _this.z = 0;
        _this.y = 0;
        _this.q = false;
        _this.a5 = 0;
        _this.a6 = 0;
        _this.af = 0;
        _this.ay = -1;
        _this.ak = 0;
        _this.l = false;
        _this.aa = a;
        _this.ac = _this.aa.createElement("div");
        _this.ac.setAttribute("tabindex", "-1");
        _this.ac.setRawStyleProperty("position", "absolute");
        _this.ac.setRawStyleProperty("overflow", "hidden");
        _this.ac.setRawStyleProperty("box-sizing", "border-box");
        _this.ac.setRawStyleProperty("outline", "none");
        var b = (window.navigator.msPointerEnabled && window.MSGesture !== undefined);
        var c = (window.PointerEvent !== undefined);
        var d = (window.TouchEvent);
        if ((b || c)) {
            _this.ac.listen("pointerdown", runOn(_this, _this.bq));
            _this.ac.listen("pointerup", runOn(_this, _this.bu));
            _this.ac.listen("pointermove", runOn(_this, _this.bt));
            _this.ac.listen("pointerleave", runOn(_this, _this.bs));
            _this.ac.listen("pointerenter", runOn(_this, _this.br));
        }
        else {
            _this.ac.listen("mousedown", runOn(_this, _this.bg));
            _this.ac.listen("mouseup", runOn(_this, _this.bk));
            _this.ac.listen("mousemove", runOn(_this, _this.bj));
            _this.ac.listen("mouseleave", runOn(_this, _this.bi));
            _this.ac.listen("touchstart", runOn(_this, _this.b8));
            _this.ac.listen("touchend", runOn(_this, _this.ca));
            _this.ac.listen("touchmove", runOn(_this, _this.b9));
        }
        return _this;
    }
    Object.defineProperty(GridCellBase.prototype, "b", {
        get: function () {
            return this.a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "f", {
        get: function () {
            return this.e;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "d", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "ab", {
        get: function () {
            return this.aa;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "ae", {
        get: function () {
            return this.ac;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "isRemoved", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.p;
            this.p = a;
            if (b != this.p) {
                this.bp("IsRemoved", b, this.p);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "a2", {
        get: function () {
            return this.ap;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "a0", {
        get: function () {
            return this.an;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "a1", {
        get: function () {
            return this.ao;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "a3", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.as;
            this.as = a;
            if (b != this.as) {
                this.bp("Indent", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "s", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            var b = this.m;
            this.m = a;
            if (b != this.m) {
                this.bp("IsCollapsable", b, this.m);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "t", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            var b = this.n;
            this.n = a;
            if (b != this.n) {
                this.bp("IsExpanded", b, this.n);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "v", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.o;
            this.o = a;
            if (b != this.o) {
                this.bp("IsHitTestVisible", b, this.o);
            }
        },
        enumerable: false,
        configurable: true
    });
    GridCellBase.prototype.bf = function () {
        this.ao = 10;
        this.an = this.a3 * 24;
        this.ap = 24;
        if (this.ad == null) {
            this.ad = this.aa.createElement("div");
            this.ad.setRawStyleProperty("display", "inline-block");
            this.ad.setRawStyleProperty("vertical-align", "middle");
            this.ad.setRawStyleProperty("width", this.ap + "px");
            this.ad.setRawStyleProperty("height", this.ap + "px");
            this.ad.setRawStyleProperty("cursor", "pointer");
            this.ad.setRawStyleProperty("position", "absolute");
            this.ad.setRawXPosition(this.au + this.an);
            this.ad.setRawYPosition(intDivide(this.aq, 2) - intDivide(this.am, 2));
        }
        if (this.i == null) {
            var a = this.aa.getSubRenderer(this.ad);
            this.i = new GridExpansionIndicator();
            this.i.ab(a);
            this.i.y(24, 24);
        }
        if (this.ad.parent() == null) {
            this.ac.append(this.ad);
        }
    };
    GridCellBase.prototype.bv = function () {
        this.ap = 0;
        this.ao = 0;
        if (this.ad != null) {
            if (this.ad.parent() != null) {
                this.ad.remove();
            }
        }
    };
    Object.defineProperty(GridCellBase.prototype, "r", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            this.k = a;
        },
        enumerable: false,
        configurable: true
    });
    GridCellBase.prototype.get_w = function () {
        return false;
    };
    Object.defineProperty(GridCellBase.prototype, "w", {
        get: function () {
            return this.get_w();
        },
        enumerable: false,
        configurable: true
    });
    GridCellBase.prototype.b4 = function (a, b, c, d) {
        this.au = a;
        this.aw = b;
        this.av = c;
        this.at = d;
        this.ac.setRawStyleProperty("padding-left", a.toString() + "px");
        this.ac.setRawStyleProperty("padding-top", b.toString() + "px");
        this.ac.setRawStyleProperty("padding-right", c.toString() + "px");
        this.ac.setRawStyleProperty("padding-bottom", d.toString() + "px");
    };
    GridCellBase.prototype.by = function (a, b, c, d, e) {
        this.ah = b;
        this.aj = c;
        this.ai = d;
        this.ag = e;
        this.cg = a;
        if (a == null) {
            this.ac.setRawStyleProperty("border", "");
        }
        else {
            this.ac.setRawStyleProperty("border-color", a._fill);
            this.ac.setRawStyleProperty("border-left-width", b.toString() + "px");
            this.ac.setRawStyleProperty("border-top-width", c.toString() + "px");
            this.ac.setRawStyleProperty("border-right-width", d.toString() + "px");
            this.ac.setRawStyleProperty("border-bottom-width", e.toString() + "px");
            this.ac.setRawStyleProperty("border-style", "solid");
        }
    };
    GridCellBase.prototype.get_u = function () {
        return false;
    };
    Object.defineProperty(GridCellBase.prototype, "u", {
        get: function () {
            return this.get_u();
        },
        enumerable: false,
        configurable: true
    });
    GridCellBase.prototype.b0 = function (a, b) {
        if (this.aq != a || this.ar != b) {
            var c = this.aq;
            this.aq = a;
            this.ar = b;
            var d = Math.max(0, this.aq - this.ar);
            this.ac.setRawStyleProperty("height", a.toString() + "px");
            this.ac.setRawStyleProperty("line-height", d.toString() + "px");
            if (this.ad != null) {
                this.ad.setRawYPosition(intDivide(this.aq, 2) - intDivide(this.ap, 2));
            }
            this.b7(this.az, this.aq, this.az, c);
        }
    };
    GridCellBase.prototype.b6 = function (a, b) {
        if (this.az != a) {
            var c = this.az;
            this.az = a;
            this.ac.setRawStyleProperty("width", a.toString() + "px");
            this.b7(this.az, this.aq, c, this.aq);
        }
    };
    GridCellBase.prototype.b7 = function (a, b, c, d) {
    };
    GridCellBase.prototype.bd = function () {
        if (!this.w) {
            return;
        }
        this.k = true;
        this.j = new PlaceholderView(this.aa);
        this.g = 0;
        this.h = 1;
        this.j.l = Color.u(120, 120, 120, 120);
        this.j.i = 0;
        this.ac.append(this.j.g);
    };
    GridCellBase.prototype.bx = function (a) {
        this.ac.setRawStyleProperty("background-color", a.colorString);
    };
    GridCellBase.prototype.b3 = function (a) {
        this.ac.setRawStyleProperty("opacity", a.toString());
    };
    GridCellBase.prototype.cf = function (a) {
        if (!this.w) {
            return;
        }
        this.j.i = (a * 0.20000000298023224);
    };
    GridCellBase.prototype.cd = function (a, b, c, d) {
        if (this.j != null) {
            var e = this.z;
            var f = this.y;
            if (this.h == 1) {
                b = truncate((b + (d / 2) - (f / 2)));
            }
            else if (this.h == 2) {
                b = truncate((b + (d) - (f)));
            }
            if (this.g == 1) {
                a = truncate((a + (c / 2) - (e / 2)));
            }
            else if (this.g == 2) {
                a = truncate((a + (c) - (e)));
            }
            this.j.g.setRawXPosition(a);
            this.j.g.setRawYPosition(b);
        }
    };
    GridCellBase.prototype.bn = function (a, b, c) {
    };
    GridCellBase.prototype.ce = function (a) {
        if (!this.w) {
            return;
        }
        var b = DeviceUtils.f(12);
        if (a.ag != null && !isNaN_(a.ag.e)) {
            b = a.ag.e;
        }
        if (this.y != b) {
            this.y = b;
            this.j.d = (b);
        }
        var c = a.gu * 0.2;
        var d = a.fc * 0.6;
        if (this.z >= c && this.z <= d && !this.q) {
            return;
        }
        this.q = false;
        var e = (GridCellBase.a4.nextDouble() * (d - c) + c);
        if (this.z != e) {
            this.z = e;
            this.j.e = e;
        }
        this.cd(this.au + this.an + this.ap, this.aw, this.az - (this.au + this.av), this.aq - (this.aw + this.at));
    };
    GridCellBase.prototype.cb = function (a, b) {
        if (!this.w) {
            return;
        }
        this.g = a;
        this.h = b;
        this.q = true;
    };
    GridCellBase.prototype.cc = function (a) {
        if (!this.w) {
            return;
        }
        if (a != null) {
            this.j.l = a.color;
        }
    };
    GridCellBase.prototype.bw = function (a) {
        this.a = a;
    };
    GridCellBase.prototype.b2 = function (a) {
        this.e = a;
    };
    GridCellBase.prototype.bz = function (a) {
        this.c = a;
    };
    GridCellBase.prototype.b1 = function (a, b) {
        switch (b) {
            case 0:
                this.ae.setRawStyleProperty("text-align", "left");
                break;
            case 1:
                this.ae.setRawStyleProperty("text-align", "center");
                break;
            case 2:
                this.ae.setRawStyleProperty("text-align", "right");
                break;
            case 3:
                this.ae.setRawStyleProperty("text-align", "center");
                break;
        }
    };
    GridCellBase.prototype.b5 = function (a, b) {
        switch (b) {
            case 0:
                a.setRawStyleProperty("vertical-align", "top");
                break;
            case 1:
                a.setRawStyleProperty("vertical-align", "center");
                break;
            case 2:
                a.setRawStyleProperty("vertical-align", "bottom");
                break;
            case 3:
                a.setRawStyleProperty("vertical-align", "center");
                break;
        }
    };
    GridCellBase.prototype.x = function (a) {
        return a.isClickActionDesired;
    };
    GridCellBase.prototype.bg = function (a) {
        this.onContactStarted(a, false);
    };
    GridCellBase.prototype.bk = function (a) {
        this.onContactCompleted(a, false);
    };
    GridCellBase.prototype.bj = function (a) {
        this.onContactMoved(a, false);
    };
    GridCellBase.prototype.bi = function (a) {
        this.bm(a, false);
    };
    GridCellBase.prototype.bh = function (a) {
        this.bl(a, false);
    };
    GridCellBase.prototype.bq = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.b8(e_);
        }
        else {
            this.bg(e_);
        }
    };
    GridCellBase.prototype.bt = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.b9(e_);
        }
        else {
            this.bj(e_);
        }
    };
    GridCellBase.prototype.bu = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.ca(e_);
        }
        else {
            this.bk(e_);
        }
    };
    GridCellBase.prototype.bs = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a != "touch") {
            this.bi(e_);
        }
    };
    GridCellBase.prototype.br = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a != "touch") {
            this.bh(e_);
        }
    };
    GridCellBase.prototype.b8 = function (a) {
        this.onContactStarted(a, true);
    };
    GridCellBase.prototype.b9 = function (a) {
        this.onContactMoved(a, true);
    };
    GridCellBase.prototype.ca = function (a) {
        this.onContactCompleted(a, true);
    };
    GridCellBase.prototype.onContactStarted = function (e_, a) {
        var b = false;
        if (this.s) {
            var indicator_ = this.i.q();
            b = (e_.originalEvent.srcElement === indicator_ || e_.originalEvent.target === indicator_);
        }
        this.l = false;
        if (b) {
            this.l = true;
        }
        else {
            if (this.a != null && this.x(this.a)) {
                this.a5 = e_.pageX;
                this.a6 = e_.pageY;
                if (this.ay != e_.which) {
                    this.ak = 0;
                }
                this.ay = e_.which;
                this.a.mouseDownCell(this.a5, this.a6);
            }
        }
    };
    GridCellBase.prototype.onContactMoved = function (a, b) {
        if (this.a != null) {
            var c = a.pageX;
            var d = a.pageY;
            if (this.x(this.a)) {
                if (this.a.isMouseDown) {
                    if (b) {
                        if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > GridCellBase.ax || Math.abs(d - this.a.mousePosition.y) > GridCellBase.ax) {
                            this.a.mouseUpCell(c, d);
                        }
                        else {
                            a.stopPropagation();
                        }
                    }
                    else {
                        if (PointUtil.equals(this.a.mousePosition, null)) {
                            this.a.mouseUpCell(c, d);
                        }
                        else if (this.ay == 1) {
                            if (Math.abs(c - this.a.mousePosition.x) > GridCellBase.al || Math.abs(d - this.a.mousePosition.y) > GridCellBase.al) {
                                this.a.isControlPressed = a.ctrlKey;
                                this.a.dragStarted();
                            }
                        }
                    }
                }
            }
            if (this.a.isHoverActionDesired) {
                this.a.mouseIsOver(c, d);
            }
        }
    };
    GridCellBase.prototype.onContactCompleted = function (e_, a) {
        var _this = this;
        this.ak++;
        window.setTimeout(function () { return _this.ak = 0; }, 250);
        var b = false;
        if (this.s) {
            var indicator_ = this.i.q();
            b = (e_.originalEvent.srcElement === indicator_ || e_.originalEvent.target === indicator_);
        }
        if (this.l && b) {
            this.b.clickExpansionIndicator();
        }
        else {
            if (this.a != null && this.x(this.a)) {
                var c = e_.pageX;
                var d = e_.pageY;
                if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > GridCellBase.ax || Math.abs(d - this.a.mousePosition.y) > GridCellBase.ax || this.a.isDrag) {
                    this.a.mouseUpCell(c, d);
                }
                if (this.a.isCellDown()) {
                    this.a.isControlPressed = e_.ctrlKey;
                    this.a.isShiftPressed = e_.shiftKey;
                    if (this.ak > 1) {
                        switch (this.ay) {
                            case 1:
                                this.a.doubleClicked(0);
                                break;
                            case 2:
                                this.a.doubleClicked(1);
                                break;
                            case 3:
                                this.a.doubleClicked(2);
                                break;
                            default:
                                this.a.doubleClicked(3);
                                break;
                        }
                    }
                    else {
                        switch (e_.which) {
                            case 1:
                                this.a.clickCell(0);
                                break;
                            case 2:
                                this.a.clickCell(1);
                                break;
                            case 3:
                                this.a.clickCell(2);
                                break;
                            default:
                                this.a.clickCell(3);
                                break;
                        }
                    }
                    this.a.mouseUpCell(e_.pageX, e_.pageY);
                }
            }
        }
        this.l = false;
    };
    GridCellBase.prototype.bm = function (a, b) {
        if (this.a != null && this.a.isLeaveActionDesired) {
            var c = a.pageX;
            var d = a.pageY;
            this.a.mouseLeaveCell(c, d);
        }
    };
    GridCellBase.prototype.bl = function (a, b) {
        if (this.a != null && this.a.isEnterActionDesired) {
            var c = a.pageX;
            var d = a.pageY;
            this.a.mouseEnterCell(c, d);
        }
    };
    GridCellBase.prototype.onDoubleClick = function (a) {
    };
    GridCellBase.prototype.bp = function (a, b, c) {
        switch (a) {
            case "Indent":
                this.an = this.a3 * 24;
                this.ao = this.a3 > 0 ? 10 : 0;
                if (this.ad != null) {
                    this.ad.setRawXPosition(this.au + this.an);
                    this.ad.setRawYPosition(intDivide(this.aq, 2) - intDivide(this.am, 2));
                }
                break;
            case "IsCollapsable":
                if (this.s) {
                    this.bf();
                }
                else {
                    this.bv();
                }
                break;
            case "IsExpanded":
                if (this.i != null) {
                    this.i.g = this.t;
                }
                break;
            case "IsHitTestVisible":
                this.ae.setRawStyleProperty("pointer-events", this.v ? "auto" : "none");
                break;
        }
    };
    GridCellBase.prototype.bo = function () {
    };
    GridCellBase.prototype.be = function () {
        this.ac.focus(true);
    };
    GridCellBase.prototype.bc = function () {
        if (this.a != null) {
            var a = this.ac.clone();
            this.a.passCellClone(a);
        }
    };
    GridCellBase.prototype.detach = function () {
    };
    GridCellBase.$t = markType(GridCellBase, 'GridCellBase', Base.$, [INativeCell_$type]);
    GridCellBase.a4 = new Random(0);
    GridCellBase.ax = 10;
    GridCellBase.al = 3;
    return GridCellBase;
}(Base));
export { GridCellBase };
