/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType, enumGetBox, EnumUtil, typeGetValue } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { BaseEventArgsDetail } from "./BaseEventArgsDetail";
import { HierarchicalGridBaseDirective } from "./HierarchicalGridBaseDirective";
import { CellType } from "./CellType";
import { RowType } from "./RowType";
import { BaseElement } from "igniteui-react";
import { ActionStrip } from "./ActionStrip";
import { DataCloneStrategy } from "./DataCloneStrategy";
import { ClipboardOptions } from "./ClipboardOptions";
import { ActionStripCollection } from "./ActionStripCollection";
import { GridRowDragGhostContext } from "./GridRowDragGhostContext";
import { GridRowEditTextTemplateContext } from "./GridRowEditTextTemplateContext";
import { GridEmptyTemplateContext } from "./GridEmptyTemplateContext";
import { GridRowEditActionsTemplateContext } from "./GridRowEditActionsTemplateContext";
import { GridRowTemplateContext } from "./GridRowTemplateContext";
import { GridTemplateContext } from "./GridTemplateContext";
import { GridHeaderTemplateContext } from "./GridHeaderTemplateContext";
import { GridToolbarCollection } from "./GridToolbarCollection";
import { PaginatorCollection } from "./PaginatorCollection";
import { GridResourceStrings } from "./GridResourceStrings";
import { FilteringLogic_$type } from "./FilteringLogic";
import { FilteringExpressionsTree } from "./FilteringExpressionsTree";
import { GridPagingMode_$type } from "./GridPagingMode";
import { GridValidationTrigger_$type } from "./GridValidationTrigger";
import { PinningConfig } from "./PinningConfig";
import { FilterMode_$type } from "./FilterMode";
import { GridSummaryPosition_$type } from "./GridSummaryPosition";
import { GridSummaryCalculationMode_$type } from "./GridSummaryCalculationMode";
import { FilteringStrategy } from "./FilteringStrategy";
import { GridSortingStrategy } from "./GridSortingStrategy";
import { SortingOptions } from "./SortingOptions";
import { HeadSelectorTemplateContext } from "./HeadSelectorTemplateContext";
import { RowSelectorTemplateContext } from "./RowSelectorTemplateContext";
import { SortingExpression } from "./SortingExpression";
import { GridSelectionMode_$type } from "./GridSelectionMode";
import { ColumnCollection } from "./ColumnCollection";
import { ForOfStateEventArgs } from "./ForOfStateEventArgs";
import { FilteringExpressionsTreeEventArgs } from "./FilteringExpressionsTreeEventArgs";
import { GridScrollEventArgs } from "./GridScrollEventArgs";
import { GridCellEventArgs } from "./GridCellEventArgs";
import { GridFormGroupCreatedEventArgs } from "./GridFormGroupCreatedEventArgs";
import { GridValidationStatusEventArgs } from "./GridValidationStatusEventArgs";
import { RowSelectionEventArgs } from "./RowSelectionEventArgs";
import { ColumnSelectionEventArgs } from "./ColumnSelectionEventArgs";
import { PinColumnCancellableEventArgs } from "./PinColumnCancellableEventArgs";
import { PinColumnEventArgs } from "./PinColumnEventArgs";
import { GridEditEventArgs } from "./GridEditEventArgs";
import { GridEditDoneEventArgs } from "./GridEditDoneEventArgs";
import { ColumnComponentEventArgs } from "./ColumnComponentEventArgs";
import { ColumnsAutoGeneratedEventArgs } from "./ColumnsAutoGeneratedEventArgs";
import { SortingEventArgs } from "./SortingEventArgs";
import { SortingExpressionEventArgs } from "./SortingExpressionEventArgs";
import { FilteringEventArgs } from "./FilteringEventArgs";
import { RowDataEventArgs } from "./RowDataEventArgs";
import { ColumnResizeEventArgs } from "./ColumnResizeEventArgs";
import { ColumnVisibilityChangingEventArgs } from "./ColumnVisibilityChangingEventArgs";
import { ColumnVisibilityChangedEventArgs } from "./ColumnVisibilityChangedEventArgs";
import { ColumnMovingStartEventArgs } from "./ColumnMovingStartEventArgs";
import { ColumnMovingEventArgs } from "./ColumnMovingEventArgs";
import { ColumnMovingEndEventArgs } from "./ColumnMovingEndEventArgs";
import { GridKeydownEventArgs } from "./GridKeydownEventArgs";
import { RowDragStartEventArgs } from "./RowDragStartEventArgs";
import { RowDragEndEventArgs } from "./RowDragEndEventArgs";
import { GridClipboardEventEventArgs } from "./GridClipboardEventEventArgs";
import { RowToggleEventArgs } from "./RowToggleEventArgs";
import { PinRowEventArgs } from "./PinRowEventArgs";
import { ActiveNodeChangeEventArgs } from "./ActiveNodeChangeEventArgs";
import { GridToolbarExportEventArgs } from "./GridToolbarExportEventArgs";
import { GridSelectionRangeEventArgs } from "./GridSelectionRangeEventArgs";
import { VoidEventArgs } from "igniteui-react";
import { ForOfDataChangingEventArgs } from "./ForOfDataChangingEventArgs";
import { Column } from "./Column";
import { DropPosition_$type } from "./DropPosition";
import { GridSelectionRange } from "./GridSelectionRange";
import { CellPosition } from "./CellPosition";
import { GridToolbar } from "./GridToolbar";
import { Paginator } from "./Paginator";
import { ObservableCollection$1 } from "igniteui-react-core";
/**
 * @hidden
 */
var GridCreatedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridCreatedEventArgs, _super);
    function GridCreatedEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    GridCreatedEventArgs.a = function (a) {
        return ((function () {
            var $ret = new GridCreatedEventArgs();
            $ret.b = WCNativeHelper.h(a, function (b) { return new GridCreatedEventArgsDetail(); });
            return $ret;
        })());
    };
    GridCreatedEventArgs.$t = markType(GridCreatedEventArgs, 'GridCreatedEventArgs');
    return GridCreatedEventArgs;
}(Base));
export { GridCreatedEventArgs };
/**
 * @hidden
 */
var GridCreatedEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridCreatedEventArgsDetail, _super);
    function GridCreatedEventArgsDetail() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(GridCreatedEventArgsDetail.prototype, "h", {
        get: function () {
            var ret_ = this.b.m("owner", function (a) { return new RowIsland(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("owner", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCreatedEventArgsDetail.prototype, "i", {
        get: function () {
            var ret_ = this.b.n("parentID");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("parentID", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridCreatedEventArgsDetail.prototype, "g", {
        get: function () {
            var ret_ = this.b.m("grid", function (a) { return new HierarchicalGrid(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.v("grid", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridCreatedEventArgsDetail.$t = markType(GridCreatedEventArgsDetail, 'GridCreatedEventArgsDetail', BaseEventArgsDetail.$);
    return GridCreatedEventArgsDetail;
}(BaseEventArgsDetail));
export { GridCreatedEventArgsDetail };
/**
 * @hidden
 */
var HierarchicalGrid = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HierarchicalGrid, _super);
    function HierarchicalGrid() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(HierarchicalGrid.prototype, "g6", {
        get: function () {
            var ret_ = this.d.l("childLayoutList", function (a) { return new RowIslandCollection(); }, function (a) { return new RowIsland(); }, ["RowIsland"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HierarchicalGrid.prototype, "he", {
        get: function () {
            var ret_ = this.d.n("id");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("id", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HierarchicalGrid.prototype, "g2", {
        get: function () {
            var ret_ = this.d.n("data");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("data", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HierarchicalGrid.prototype, "hc", {
        get: function () {
            var ret_ = this.d.n("totalItemCount");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("totalItemCount", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HierarchicalGrid.prototype, "g9", {
        get: function () {
            var ret_ = this.d.n("expandChildren");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("expandChildren", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HierarchicalGrid.prototype, "hd", {
        get: function () {
            var ret_ = this.d.n("foreignKey");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HierarchicalGrid.prototype, "g3", {
        get: function () {
            var ret_ = this.d.m("selectedCells", function (a) { return new CellType(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    HierarchicalGrid.prototype.g7 = function (a) {
        return this.d.g(this.nativeElement.getRowByIndex(this.d.i(a)), function (b) { return new RowType(); });
    };
    HierarchicalGrid.prototype.g8 = function (a) {
        return this.d.g(this.nativeElement.getRowByKey(this.d.i(a)), function (b) { return new RowType(); });
    };
    HierarchicalGrid.prototype.g4 = function (a, b) {
        return this.d.g(this.nativeElement.getCellByColumn(this.d.i(a), this.d.i(b)), function (c) { return new CellType(); });
    };
    HierarchicalGrid.prototype.g5 = function (a, b) {
        return this.d.g(this.nativeElement.getCellByKey(this.d.i(a), this.d.i(b)), function (c) { return new CellType(); });
    };
    HierarchicalGrid.prototype.ha = function (a, b) {
        if (b === void 0) {
            b = -1;
        }
        return (this.nativeElement.pinRow(this.d.i(a), this.d.i(b)));
    };
    HierarchicalGrid.prototype.hb = function (a) {
        return (this.nativeElement.unpinRow(this.d.i(a)));
    };
    HierarchicalGrid.prototype.hf = function (a) {
        this.nativeElement.getDefaultExpandState(this.d.i(a));
    };
    HierarchicalGrid.$t = markType(HierarchicalGrid, 'HierarchicalGrid', HierarchicalGridBaseDirective.$);
    return HierarchicalGrid;
}(HierarchicalGridBaseDirective));
export { HierarchicalGrid };
/**
 * @hidden
 */
var RowIsland = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RowIsland, _super);
    function RowIsland() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.bz = new WCNativeHelper();
        _this.co = null;
        _this.cx = null;
        _this.cu = null;
        _this.c2 = null;
        _this.cv = null;
        _this.c6 = null;
        _this.c3 = null;
        _this.c5 = null;
        _this.c7 = null;
        _this.c4 = null;
        _this.c0 = null;
        _this.cz = null;
        _this.cy = null;
        _this.c9 = null;
        _this.da = null;
        _this.db = null;
        _this.c1 = null;
        _this.c8 = null;
        _this.cw = null;
        _this.gridCreated = null;
        _this.gridInitialized = null;
        _this.dataPreLoad = null;
        _this.filteringExpressionsTreeChange = null;
        _this.advancedFilteringExpressionsTreeChange = null;
        _this.gridScroll = null;
        _this.cellClick = null;
        _this.formGroupCreated = null;
        _this.validationStatusChange = null;
        _this.selected = null;
        _this.rowSelectionChanging = null;
        _this.columnSelectionChanging = null;
        _this.columnPin = null;
        _this.columnPinned = null;
        _this.cellEditEnter = null;
        _this.cellEditExit = null;
        _this.cellEdit = null;
        _this.cellEditDone = null;
        _this.rowEditEnter = null;
        _this.rowEdit = null;
        _this.rowEditDone = null;
        _this.rowEditExit = null;
        _this.columnInit = null;
        _this.columnsAutogenerated = null;
        _this.sorting = null;
        _this.sortingDone = null;
        _this.filtering = null;
        _this.filteringDone = null;
        _this.rowAdded = null;
        _this.rowDeleted = null;
        _this.rowDelete = null;
        _this.rowAdd = null;
        _this.columnResized = null;
        _this.contextMenu = null;
        _this.doubleClick = null;
        _this.columnVisibilityChanging = null;
        _this.columnVisibilityChanged = null;
        _this.columnMovingStart = null;
        _this.columnMoving = null;
        _this.columnMovingEnd = null;
        _this.gridKeydown = null;
        _this.rowDragStart = null;
        _this.rowDragEnd = null;
        _this.gridCopy = null;
        _this.rowToggle = null;
        _this.rowPinning = null;
        _this.rowPinned = null;
        _this.activeNodeChange = null;
        _this.sortingExpressionsChange = null;
        _this.toolbarExporting = null;
        _this.rangeSelected = null;
        _this.rendered = null;
        _this.dataChanging = null;
        _this.dataChanged = null;
        return _this;
    }
    Object.defineProperty(RowIsland.prototype, "b0", {
        get: function () {
            return this.bz;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "nativeElement", {
        get: function () {
            return this.co;
        },
        set: function (a) {
            this.co = a;
            this.bz.o = this.co;
        },
        enumerable: false,
        configurable: true
    });
    RowIsland.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(RowIsland.prototype, "dv", {
        get: function () {
            var ret_ = this.b0.n("childDataKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("childDataKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "bq", {
        get: function () {
            var ret_ = this.b0.l("childLayoutList", function (a) { return new RowIslandCollection(); }, function (a) { return new RowIsland(); }, ["RowIsland"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "b", {
        get: function () {
            var ret_ = this.b0.n("data");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("data", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "b5", {
        get: function () {
            var ret_ = this.b0.n("expandChildren");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("expandChildren", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "d0", {
        get: function () {
            var ret_ = this.b0.n("hasChildrenKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("hasChildrenKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "ce", {
        get: function () {
            var ret_ = this.b0.n("showExpandAll");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("showExpandAll", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "b4", {
        get: function () {
            var ret_ = this.b0.n("batchEditing");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("batchEditing", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "cl", {
        get: function () {
            var ret_ = this.b0.n("snackbarDisplayTime");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("snackbarDisplayTime", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "b3", {
        get: function () {
            var ret_ = this.b0.n("autoGenerate");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("autoGenerate", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "a", {
        get: function () {
            var ret_ = this.b0.n("autoGenerateExclude");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("autoGenerateExclude", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "b8", {
        get: function () {
            var ret_ = this.b0.n("moving");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("moving", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "df", {
        get: function () {
            return this.cx;
        },
        set: function (a) {
            this.cx = a;
            this.b0.s("emptyGridTemplate", function (b) { return b; }, this.cx);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dc", {
        get: function () {
            return this.cu;
        },
        set: function (a) {
            this.cu = a;
            this.b0.s("addRowEmptyTemplate", function (b) { return b; }, this.cu);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dk", {
        get: function () {
            return this.c2;
        },
        set: function (a) {
            this.c2 = a;
            this.b0.s("loadingGridTemplate", function (b) { return b; }, this.c2);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "cm", {
        get: function () {
            var ret_ = this.b0.n("summaryRowHeight");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("summaryRowHeight", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "x", {
        get: function () {
            var ret_ = this.b0.m("dataCloneStrategy", function (a) { return new DataCloneStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("dataCloneStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "k", {
        get: function () {
            var ret_ = this.b0.m("clipboardOptions", function (a) { return new ClipboardOptions(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("clipboardOptions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "cs", {
        get: function () {
            var ret_ = this.b0.n("rowClasses");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("rowClasses", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "ct", {
        get: function () {
            var ret_ = this.b0.n("rowStyles");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("rowStyles", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "d3", {
        get: function () {
            var ret_ = this.b0.n("primaryKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("primaryKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "g", {
        get: function () {
            var ret_ = this.b0.l("actionStripComponents", function (a) { return new ActionStripCollection(); }, function (a) { return new ActionStrip(); }, ["ActionStrip"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dd", {
        get: function () {
            return this.cv;
        },
        set: function (a) {
            this.cv = a;
            this.b0.s("dragGhostCustomTemplate", function (b) { return new GridRowDragGhostContext(); }, this.cv);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dp", {
        get: function () {
            return this.c6;
        },
        set: function (a) {
            this.c6 = a;
            this.b0.s("rowEditTextTemplate", function (b) { return new GridRowEditTextTemplateContext(); }, this.c6);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dl", {
        get: function () {
            return this.c3;
        },
        set: function (a) {
            this.c3 = a;
            this.b0.s("rowAddTextTemplate", function (b) { return new GridEmptyTemplateContext(); }, this.c3);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dn", {
        get: function () {
            return this.c5;
        },
        set: function (a) {
            this.c5 = a;
            this.b0.s("rowEditActionsTemplate", function (b) { return new GridRowEditActionsTemplateContext(); }, this.c5);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dq", {
        get: function () {
            return this.c7;
        },
        set: function (a) {
            this.c7 = a;
            this.b0.s("rowExpandedIndicatorTemplate", function (b) { return new GridRowTemplateContext(); }, this.c7);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dm", {
        get: function () {
            return this.c4;
        },
        set: function (a) {
            this.c4 = a;
            this.b0.s("rowCollapsedIndicatorTemplate", function (b) { return new GridRowTemplateContext(); }, this.c4);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "di", {
        get: function () {
            return this.c0;
        },
        set: function (a) {
            this.c0 = a;
            this.b0.s("headerExpandedIndicatorTemplate", function (b) { return new GridTemplateContext(); }, this.c0);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dh", {
        get: function () {
            return this.cz;
        },
        set: function (a) {
            this.cz = a;
            this.b0.s("headerCollapsedIndicatorTemplate", function (b) { return new GridTemplateContext(); }, this.cz);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dg", {
        get: function () {
            return this.cy;
        },
        set: function (a) {
            this.cy = a;
            this.b0.s("excelStyleHeaderIconTemplate", function (b) { return new GridHeaderTemplateContext(); }, this.cy);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "ds", {
        get: function () {
            return this.c9;
        },
        set: function (a) {
            this.c9 = a;
            this.b0.s("sortAscendingHeaderIconTemplate", function (b) { return new GridHeaderTemplateContext(); }, this.c9);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dt", {
        get: function () {
            return this.da;
        },
        set: function (a) {
            this.da = a;
            this.b0.s("sortDescendingHeaderIconTemplate", function (b) { return new GridHeaderTemplateContext(); }, this.da);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "du", {
        get: function () {
            return this.db;
        },
        set: function (a) {
            this.db = a;
            this.b0.s("sortHeaderIconTemplate", function (b) { return new GridHeaderTemplateContext(); }, this.db);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "bc", {
        get: function () {
            var ret_ = this.b0.l("toolbar", function (a) { return new GridToolbarCollection(); }, function (a) { return new GridToolbar(); }, ["GridToolbar"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "bg", {
        get: function () {
            var ret_ = this.b0.l("paginationComponents", function (a) { return new PaginatorCollection(); }, function (a) { return new Paginator(); }, ["Paginator"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "a3", {
        get: function () {
            var ret_ = this.b0.m("resourceStrings", function (a) { return new GridResourceStrings(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("resourceStrings", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "ae", {
        get: function () {
            var ret_ = this.b0.n("filteringLogic");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilteringLogic_$type, EnumUtil.getEnumValue(FilteringLogic_$type, this.b0.f(FilteringLogic_$type, ret_)));
            return EnumUtil.getEnumValue(FilteringLogic_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(FilteringLogic_$type, a);
            value_ = this.b0.f(FilteringLogic_$type, value_);
            this.b0.v("filteringLogic", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "aa", {
        get: function () {
            var ret_ = this.b0.m("filteringExpressionsTree", function (a) { return new FilteringExpressionsTree(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("filteringExpressionsTree", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "z", {
        get: function () {
            var ret_ = this.b0.m("advancedFilteringExpressionsTree", function (a) { return new FilteringExpressionsTree(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("advancedFilteringExpressionsTree", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "d1", {
        get: function () {
            var ret_ = this.b0.n("locale");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("locale", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "a2", {
        get: function () {
            var ret_ = this.b0.n("pagingMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridPagingMode_$type, EnumUtil.getEnumValue(GridPagingMode_$type, this.b0.f(GridPagingMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridPagingMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridPagingMode_$type, a);
            value_ = this.b0.f(GridPagingMode_$type, value_);
            this.b0.v("pagingMode", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "b6", {
        get: function () {
            var ret_ = this.b0.n("hideRowSelectors");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("hideRowSelectors", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "ca", {
        get: function () {
            var ret_ = this.b0.n("rowDraggable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("rowDraggable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "bf", {
        get: function () {
            var ret_ = this.b0.n("validationTrigger");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridValidationTrigger_$type, EnumUtil.getEnumValue(GridValidationTrigger_$type, this.b0.f(GridValidationTrigger_$type, ret_)));
            return EnumUtil.getEnumValue(GridValidationTrigger_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridValidationTrigger_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("validationTrigger", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "cb", {
        get: function () {
            var ret_ = this.b0.n("rowEditable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("rowEditable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "ck", {
        get: function () {
            var ret_ = this.b0.n("rowHeight");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("rowHeight", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dw", {
        get: function () {
            var ret_ = this.b0.n("columnWidth");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("columnWidth", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dy", {
        get: function () {
            var ret_ = this.b0.n("emptyGridMessage");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("emptyGridMessage", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "b7", {
        get: function () {
            var ret_ = this.b0.n("isLoading");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("isLoading", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "cd", {
        get: function () {
            var ret_ = this.b0.n("shouldGenerate");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("shouldGenerate", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dx", {
        get: function () {
            var ret_ = this.b0.n("emptyFilteredGridMessage");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("emptyFilteredGridMessage", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "bj", {
        get: function () {
            var ret_ = this.b0.m("pinning", function (a) { return new PinningConfig(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("pinning", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "b2", {
        get: function () {
            var ret_ = this.b0.n("allowFiltering");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("allowFiltering", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "b1", {
        get: function () {
            var ret_ = this.b0.n("allowAdvancedFiltering");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("allowAdvancedFiltering", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "ag", {
        get: function () {
            var ret_ = this.b0.n("filterMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilterMode_$type, EnumUtil.getEnumValue(FilterMode_$type, this.b0.f(FilterMode_$type, ret_)));
            return EnumUtil.getEnumValue(FilterMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(FilterMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("filterMode", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "bb", {
        get: function () {
            var ret_ = this.b0.n("summaryPosition");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSummaryPosition_$type, EnumUtil.getEnumValue(GridSummaryPosition_$type, this.b0.f(GridSummaryPosition_$type, ret_)));
            return EnumUtil.getEnumValue(GridSummaryPosition_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridSummaryPosition_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("summaryPosition", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "ba", {
        get: function () {
            var ret_ = this.b0.n("summaryCalculationMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSummaryCalculationMode_$type, EnumUtil.getEnumValue(GridSummaryCalculationMode_$type, this.b0.f(GridSummaryCalculationMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSummaryCalculationMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridSummaryCalculationMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("summaryCalculationMode", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "cf", {
        get: function () {
            var ret_ = this.b0.n("showSummaryOnCollapse");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("showSummaryOnCollapse", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "af", {
        get: function () {
            var ret_ = this.b0.m("filterStrategy", function (a) { return new FilteringStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("filterStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "a9", {
        get: function () {
            var ret_ = this.b0.m("sortStrategy", function (a) { return new GridSortingStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("sortStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "bw", {
        get: function () {
            var ret_ = this.b0.m("sortingOptions", function (a) { return new SortingOptions(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("sortingOptions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "e", {
        get: function () {
            var ret_ = this.b0.n("selectedRows");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("selectedRows", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dj", {
        get: function () {
            return this.c1;
        },
        set: function (a) {
            this.c1 = a;
            this.b0.s("headSelectorTemplate", function (b) { return new HeadSelectorTemplateContext(); }, this.c1);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "dr", {
        get: function () {
            return this.c8;
        },
        set: function (a) {
            this.c8 = a;
            this.b0.s("rowSelectorTemplate", function (b) { return new RowSelectorTemplateContext(); }, this.c8);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "de", {
        get: function () {
            return this.cw;
        },
        set: function (a) {
            this.cw = a;
            this.b0.s("dragIndicatorIconTemplate", function (b) { return new GridEmptyTemplateContext(); }, this.cw);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "f", {
        get: function () {
            var ret_ = this.b0.m("sortingExpressions", function (a) { return new SortingExpression(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("sortingExpressions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "a5", {
        get: function () {
            var ret_ = this.b0.n("cellSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.b0.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("cellSelection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "a7", {
        get: function () {
            var ret_ = this.b0.n("rowSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.b0.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("rowSelection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "a6", {
        get: function () {
            var ret_ = this.b0.n("columnSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.b0.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b0.v("columnSelection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "n", {
        get: function () {
            var ret_ = this.b0.l("columns", function (a) { return new ColumnCollection(); }, function (a) { return new Column(); }, ["Column", "ColumnGroup", "ColumnLayout"]);
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "cn", {
        get: function () {
            var ret_ = this.b0.n("totalRecords");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("totalRecords", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RowIsland.prototype, "cc", {
        get: function () {
            var ret_ = this.b0.n("selectRowOnClick");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("selectRowOnClick", value_);
        },
        enumerable: false,
        configurable: true
    });
    RowIsland.prototype.gridCreatedChanged = function () {
        var _this = this;
        if (this.gridCreated != null) {
            this.b0.r("gridCreated", function (a) { return _this.gridCreated(_this, GridCreatedEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("gridCreated");
        }
    };
    RowIsland.prototype.gridInitializedChanged = function () {
        var _this = this;
        if (this.gridInitialized != null) {
            this.b0.r("gridInitialized", function (a) { return _this.gridInitialized(_this, GridCreatedEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("gridInitialized");
        }
    };
    RowIsland.prototype.dataPreLoadChanged = function () {
        var _this = this;
        if (this.dataPreLoad != null) {
            this.b0.r("dataPreLoad", function (a) { return _this.dataPreLoad(_this, ForOfStateEventArgs.b(a)); }, false);
        }
        else {
            this.b0.u("dataPreLoad");
        }
    };
    RowIsland.prototype.filteringExpressionsTreeChangeChanged = function () {
        var _this = this;
        if (this.filteringExpressionsTreeChange != null) {
            this.b0.r("filteringExpressionsTreeChange", function (a) { return _this.filteringExpressionsTreeChange(_this, FilteringExpressionsTreeEventArgs.b(a)); }, false);
        }
        else {
            this.b0.u("filteringExpressionsTreeChange");
        }
    };
    RowIsland.prototype.advancedFilteringExpressionsTreeChangeChanged = function () {
        var _this = this;
        if (this.advancedFilteringExpressionsTreeChange != null) {
            this.b0.r("advancedFilteringExpressionsTreeChange", function (a) { return _this.advancedFilteringExpressionsTreeChange(_this, FilteringExpressionsTreeEventArgs.b(a)); }, false);
        }
        else {
            this.b0.u("advancedFilteringExpressionsTreeChange");
        }
    };
    RowIsland.prototype.gridScrollChanged = function () {
        var _this = this;
        if (this.gridScroll != null) {
            this.b0.r("gridScroll", function (a) { return _this.gridScroll(_this, GridScrollEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("gridScroll");
        }
    };
    RowIsland.prototype.cellClickChanged = function () {
        var _this = this;
        if (this.cellClick != null) {
            this.b0.r("cellClick", function (a) { return _this.cellClick(_this, GridCellEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("cellClick");
        }
    };
    RowIsland.prototype.formGroupCreatedChanged = function () {
        var _this = this;
        if (this.formGroupCreated != null) {
            this.b0.r("formGroupCreated", function (a) { return _this.formGroupCreated(_this, GridFormGroupCreatedEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("formGroupCreated");
        }
    };
    RowIsland.prototype.validationStatusChangeChanged = function () {
        var _this = this;
        if (this.validationStatusChange != null) {
            this.b0.r("validationStatusChange", function (a) { return _this.validationStatusChange(_this, GridValidationStatusEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("validationStatusChange");
        }
    };
    RowIsland.prototype.selectedChanged = function () {
        var _this = this;
        if (this.selected != null) {
            this.b0.r("selected", function (a) { return _this.selected(_this, GridCellEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("selected");
        }
    };
    RowIsland.prototype.rowSelectionChangingChanged = function () {
        var _this = this;
        if (this.rowSelectionChanging != null) {
            this.b0.r("rowSelectionChanging", function (a) { return _this.rowSelectionChanging(_this, RowSelectionEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowSelectionChanging");
        }
    };
    RowIsland.prototype.columnSelectionChangingChanged = function () {
        var _this = this;
        if (this.columnSelectionChanging != null) {
            this.b0.r("columnSelectionChanging", function (a) { return _this.columnSelectionChanging(_this, ColumnSelectionEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("columnSelectionChanging");
        }
    };
    RowIsland.prototype.columnPinChanged = function () {
        var _this = this;
        if (this.columnPin != null) {
            this.b0.r("columnPin", function (a) { return _this.columnPin(_this, PinColumnCancellableEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("columnPin");
        }
    };
    RowIsland.prototype.columnPinnedChanged = function () {
        var _this = this;
        if (this.columnPinned != null) {
            this.b0.r("columnPinned", function (a) { return _this.columnPinned(_this, PinColumnEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("columnPinned");
        }
    };
    RowIsland.prototype.cellEditEnterChanged = function () {
        var _this = this;
        if (this.cellEditEnter != null) {
            this.b0.r("cellEditEnter", function (a) { return _this.cellEditEnter(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("cellEditEnter");
        }
    };
    RowIsland.prototype.cellEditExitChanged = function () {
        var _this = this;
        if (this.cellEditExit != null) {
            this.b0.r("cellEditExit", function (a) { return _this.cellEditExit(_this, GridEditDoneEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("cellEditExit");
        }
    };
    RowIsland.prototype.cellEditChanged = function () {
        var _this = this;
        if (this.cellEdit != null) {
            this.b0.r("cellEdit", function (a) { return _this.cellEdit(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("cellEdit");
        }
    };
    RowIsland.prototype.cellEditDoneChanged = function () {
        var _this = this;
        if (this.cellEditDone != null) {
            this.b0.r("cellEditDone", function (a) { return _this.cellEditDone(_this, GridEditDoneEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("cellEditDone");
        }
    };
    RowIsland.prototype.rowEditEnterChanged = function () {
        var _this = this;
        if (this.rowEditEnter != null) {
            this.b0.r("rowEditEnter", function (a) { return _this.rowEditEnter(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowEditEnter");
        }
    };
    RowIsland.prototype.rowEditChanged = function () {
        var _this = this;
        if (this.rowEdit != null) {
            this.b0.r("rowEdit", function (a) { return _this.rowEdit(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowEdit");
        }
    };
    RowIsland.prototype.rowEditDoneChanged = function () {
        var _this = this;
        if (this.rowEditDone != null) {
            this.b0.r("rowEditDone", function (a) { return _this.rowEditDone(_this, GridEditDoneEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowEditDone");
        }
    };
    RowIsland.prototype.rowEditExitChanged = function () {
        var _this = this;
        if (this.rowEditExit != null) {
            this.b0.r("rowEditExit", function (a) { return _this.rowEditExit(_this, GridEditDoneEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowEditExit");
        }
    };
    RowIsland.prototype.columnInitChanged = function () {
        var _this = this;
        if (this.columnInit != null) {
            this.b0.r("columnInit", function (a) { return _this.columnInit(_this, ColumnComponentEventArgs.b(a)); }, false);
        }
        else {
            this.b0.u("columnInit");
        }
    };
    RowIsland.prototype.columnsAutogeneratedChanged = function () {
        var _this = this;
        if (this.columnsAutogenerated != null) {
            this.b0.r("columnsAutogenerated", function (a) { return _this.columnsAutogenerated(_this, ColumnsAutoGeneratedEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("columnsAutogenerated");
        }
    };
    RowIsland.prototype.sortingChanged = function () {
        var _this = this;
        if (this.sorting != null) {
            this.b0.r("sorting", function (a) { return _this.sorting(_this, SortingEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("sorting");
        }
    };
    RowIsland.prototype.sortingDoneChanged = function () {
        var _this = this;
        if (this.sortingDone != null) {
            this.b0.r("sortingDone", function (a) { return _this.sortingDone(_this, SortingExpressionEventArgs.b(a)); }, false);
        }
        else {
            this.b0.u("sortingDone");
        }
    };
    RowIsland.prototype.filteringChanged = function () {
        var _this = this;
        if (this.filtering != null) {
            this.b0.r("filtering", function (a) { return _this.filtering(_this, FilteringEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("filtering");
        }
    };
    RowIsland.prototype.filteringDoneChanged = function () {
        var _this = this;
        if (this.filteringDone != null) {
            this.b0.r("filteringDone", function (a) { return _this.filteringDone(_this, FilteringExpressionsTreeEventArgs.b(a)); }, false);
        }
        else {
            this.b0.u("filteringDone");
        }
    };
    RowIsland.prototype.rowAddedChanged = function () {
        var _this = this;
        if (this.rowAdded != null) {
            this.b0.r("rowAdded", function (a) { return _this.rowAdded(_this, RowDataEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowAdded");
        }
    };
    RowIsland.prototype.rowDeletedChanged = function () {
        var _this = this;
        if (this.rowDeleted != null) {
            this.b0.r("rowDeleted", function (a) { return _this.rowDeleted(_this, RowDataEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowDeleted");
        }
    };
    RowIsland.prototype.rowDeleteChanged = function () {
        var _this = this;
        if (this.rowDelete != null) {
            this.b0.r("rowDelete", function (a) { return _this.rowDelete(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowDelete");
        }
    };
    RowIsland.prototype.rowAddChanged = function () {
        var _this = this;
        if (this.rowAdd != null) {
            this.b0.r("rowAdd", function (a) { return _this.rowAdd(_this, GridEditEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowAdd");
        }
    };
    RowIsland.prototype.columnResizedChanged = function () {
        var _this = this;
        if (this.columnResized != null) {
            this.b0.r("columnResized", function (a) { return _this.columnResized(_this, ColumnResizeEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("columnResized");
        }
    };
    RowIsland.prototype.contextMenuChanged = function () {
        var _this = this;
        if (this.contextMenu != null) {
            this.b0.r("contextMenu", function (a) { return _this.contextMenu(_this, GridCellEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("contextMenu");
        }
    };
    RowIsland.prototype.doubleClickChanged = function () {
        var _this = this;
        if (this.doubleClick != null) {
            this.b0.r("doubleClick", function (a) { return _this.doubleClick(_this, GridCellEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("doubleClick");
        }
    };
    RowIsland.prototype.columnVisibilityChangingChanged = function () {
        var _this = this;
        if (this.columnVisibilityChanging != null) {
            this.b0.r("columnVisibilityChanging", function (a) { return _this.columnVisibilityChanging(_this, ColumnVisibilityChangingEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("columnVisibilityChanging");
        }
    };
    RowIsland.prototype.columnVisibilityChangedChanged = function () {
        var _this = this;
        if (this.columnVisibilityChanged != null) {
            this.b0.r("columnVisibilityChanged", function (a) { return _this.columnVisibilityChanged(_this, ColumnVisibilityChangedEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("columnVisibilityChanged");
        }
    };
    RowIsland.prototype.columnMovingStartChanged = function () {
        var _this = this;
        if (this.columnMovingStart != null) {
            this.b0.r("columnMovingStart", function (a) { return _this.columnMovingStart(_this, ColumnMovingStartEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("columnMovingStart");
        }
    };
    RowIsland.prototype.columnMovingChanged = function () {
        var _this = this;
        if (this.columnMoving != null) {
            this.b0.r("columnMoving", function (a) { return _this.columnMoving(_this, ColumnMovingEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("columnMoving");
        }
    };
    RowIsland.prototype.columnMovingEndChanged = function () {
        var _this = this;
        if (this.columnMovingEnd != null) {
            this.b0.r("columnMovingEnd", function (a) { return _this.columnMovingEnd(_this, ColumnMovingEndEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("columnMovingEnd");
        }
    };
    RowIsland.prototype.gridKeydownChanged = function () {
        var _this = this;
        if (this.gridKeydown != null) {
            this.b0.r("gridKeydown", function (a) { return _this.gridKeydown(_this, GridKeydownEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("gridKeydown");
        }
    };
    RowIsland.prototype.rowDragStartChanged = function () {
        var _this = this;
        if (this.rowDragStart != null) {
            this.b0.r("rowDragStart", function (a) { return _this.rowDragStart(_this, RowDragStartEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowDragStart");
        }
    };
    RowIsland.prototype.rowDragEndChanged = function () {
        var _this = this;
        if (this.rowDragEnd != null) {
            this.b0.r("rowDragEnd", function (a) { return _this.rowDragEnd(_this, RowDragEndEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowDragEnd");
        }
    };
    RowIsland.prototype.gridCopyChanged = function () {
        var _this = this;
        if (this.gridCopy != null) {
            this.b0.r("gridCopy", function (a) { return _this.gridCopy(_this, GridClipboardEventEventArgs.b(a)); }, false);
        }
        else {
            this.b0.u("gridCopy");
        }
    };
    RowIsland.prototype.rowToggleChanged = function () {
        var _this = this;
        if (this.rowToggle != null) {
            this.b0.r("rowToggle", function (a) { return _this.rowToggle(_this, RowToggleEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowToggle");
        }
    };
    RowIsland.prototype.rowPinningChanged = function () {
        var _this = this;
        if (this.rowPinning != null) {
            this.b0.r("rowPinning", function (a) { return _this.rowPinning(_this, PinRowEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowPinning");
        }
    };
    RowIsland.prototype.rowPinnedChanged = function () {
        var _this = this;
        if (this.rowPinned != null) {
            this.b0.r("rowPinned", function (a) { return _this.rowPinned(_this, PinRowEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("rowPinned");
        }
    };
    RowIsland.prototype.activeNodeChangeChanged = function () {
        var _this = this;
        if (this.activeNodeChange != null) {
            this.b0.r("activeNodeChange", function (a) { return _this.activeNodeChange(_this, ActiveNodeChangeEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("activeNodeChange");
        }
    };
    RowIsland.prototype.sortingExpressionsChangeChanged = function () {
        var _this = this;
        if (this.sortingExpressionsChange != null) {
            this.b0.r("sortingExpressionsChange", function (a) { return _this.sortingExpressionsChange(_this, SortingExpressionEventArgs.b(a)); }, false);
        }
        else {
            this.b0.u("sortingExpressionsChange");
        }
    };
    RowIsland.prototype.toolbarExportingChanged = function () {
        var _this = this;
        if (this.toolbarExporting != null) {
            this.b0.r("toolbarExporting", function (a) { return _this.toolbarExporting(_this, GridToolbarExportEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("toolbarExporting");
        }
    };
    RowIsland.prototype.rangeSelectedChanged = function () {
        var _this = this;
        if (this.rangeSelected != null) {
            this.b0.r("rangeSelected", function (a) { return _this.rangeSelected(_this, GridSelectionRangeEventArgs.b(a)); }, false);
        }
        else {
            this.b0.u("rangeSelected");
        }
    };
    RowIsland.prototype.renderedChanged = function () {
        var _this = this;
        if (this.rendered != null) {
            this.b0.r("rendered", function (a) { return _this.rendered(_this, VoidEventArgs.b(a)); }, false);
        }
        else {
            this.b0.u("rendered");
        }
    };
    RowIsland.prototype.dataChangingChanged = function () {
        var _this = this;
        if (this.dataChanging != null) {
            this.b0.r("dataChanging", function (a) { return _this.dataChanging(_this, ForOfDataChangingEventArgs.a(a)); }, false);
        }
        else {
            this.b0.u("dataChanging");
        }
    };
    RowIsland.prototype.dataChangedChanged = function () {
        var _this = this;
        if (this.dataChanged != null) {
            this.b0.r("dataChanged", function (a) { return _this.dataChanged(_this, VoidEventArgs.b(a)); }, false);
        }
        else {
            this.b0.u("dataChanged");
        }
    };
    RowIsland.prototype.fm = function (a) {
        this.nativeElement.isRecordPinnedByIndex(this.b0.i(a));
    };
    RowIsland.prototype.gj = function (a) {
        this.nativeElement.toggleColumnVisibility(this.b0.i(a));
    };
    RowIsland.prototype.e6 = function () {
        this.nativeElement.expandAll();
    };
    RowIsland.prototype.eh = function () {
        this.nativeElement.collapseAll();
    };
    RowIsland.prototype.e7 = function (a) {
        this.nativeElement.expandRow(this.b0.i(a));
    };
    RowIsland.prototype.ei = function (a) {
        this.nativeElement.collapseRow(this.b0.i(a));
    };
    RowIsland.prototype.gk = function (a) {
        this.nativeElement.toggleRow(this.b0.i(a));
    };
    RowIsland.prototype.dz = function (a) {
        return (this.nativeElement.getHeaderGroupWidth(this.b0.i(a)));
    };
    RowIsland.prototype.l = function (a) {
        return this.b0.g(this.nativeElement.getColumnByName(this.b0.i(a)), function (b) { return new Column(); });
    };
    RowIsland.prototype.m = function (a) {
        return this.b0.g(this.nativeElement.getColumnByVisibleIndex(this.b0.i(a)), function (b) { return new Column(); });
    };
    RowIsland.prototype.fs = function () {
        this.nativeElement.recalculateAutoSizes();
    };
    RowIsland.prototype.fo = function (a, b, c) {
        this.nativeElement.moveColumn(this.b0.i(a), this.b0.i(b), this.b0.i(typeGetValue(this.b0.f(DropPosition_$type, c))));
    };
    RowIsland.prototype.fn = function () {
        this.nativeElement.markForCheck();
    };
    RowIsland.prototype.cp = function (a) {
        return (this.nativeElement.deleteRow(this.b0.i(a)));
    };
    RowIsland.prototype.gm = function (a, b, c) {
        this.nativeElement.updateCell(this.b0.i(a), this.b0.i(b), this.b0.i(c));
    };
    RowIsland.prototype.gn = function (a, b) {
        this.nativeElement.updateRow(this.b0.i(a), this.b0.i(b));
    };
    RowIsland.prototype.cq = function (a) {
        return (this.nativeElement.getRowData(this.b0.i(a)));
    };
    RowIsland.prototype.gf = function (a) {
        this.nativeElement.sort(this.b0.i(a));
    };
    RowIsland.prototype.e8 = function (a, b, c, d) {
        if (d === void 0) {
            d = false;
        }
        this.nativeElement.filter(this.b0.i(a), this.b0.i(b), this.b0.i(c), this.b0.i(d));
    };
    RowIsland.prototype.e9 = function (a, b, c) {
        this.nativeElement.filterGlobal(this.b0.i(a), this.b0.i(b), this.b0.i(c));
    };
    RowIsland.prototype.e4 = function (a) {
        this.nativeElement.enableSummaries(this.b0.i(a));
    };
    RowIsland.prototype.e2 = function (a) {
        this.nativeElement.disableSummaries(this.b0.i(a));
    };
    RowIsland.prototype.ed = function (a) {
        this.nativeElement.clearFilter(this.b0.i(a));
    };
    RowIsland.prototype.ef = function (a) {
        this.nativeElement.clearSort(this.b0.i(a));
    };
    RowIsland.prototype.b9 = function (a, b) {
        return (this.nativeElement.pinColumn(this.b0.i(a), this.b0.i(b)));
    };
    RowIsland.prototype.cg = function (a, b) {
        return (this.nativeElement.unpinColumn(this.b0.i(a), this.b0.i(b)));
    };
    RowIsland.prototype.ch = function (a, b, c) {
        if (b === void 0) {
            b = false;
        }
        if (c === void 0) {
            c = false;
        }
        return (this.nativeElement.findNext(this.b0.i(a), this.b0.i(b), this.b0.i(c)));
    };
    RowIsland.prototype.ci = function (a, b, c) {
        if (b === void 0) {
            b = false;
        }
        if (c === void 0) {
            c = false;
        }
        return (this.nativeElement.findPrev(this.b0.i(a), this.b0.i(b), this.b0.i(c)));
    };
    RowIsland.prototype.cj = function (a, b) {
        if (a === void 0) {
            a = false;
        }
        if (b === void 0) {
            b = false;
        }
        return (this.nativeElement.refreshSearch(this.b0.i(a), this.b0.i(b)));
    };
    RowIsland.prototype.ee = function () {
        this.nativeElement.clearSearch();
    };
    RowIsland.prototype.fe = function (a) {
        if (a === void 0) {
            a = false;
        }
        this.nativeElement.getPinnedWidth(this.b0.i(a));
    };
    RowIsland.prototype.gd = function (a, b) {
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.selectRows(this.b0.i(a), this.b0.i(b));
    };
    RowIsland.prototype.e1 = function (a) {
        this.nativeElement.deselectRows(this.b0.i(a));
    };
    RowIsland.prototype.f9 = function (a) {
        if (a === void 0) {
            a = false;
        }
        this.nativeElement.selectAllRows(this.b0.i(a));
    };
    RowIsland.prototype.ez = function (a) {
        if (a === void 0) {
            a = false;
        }
        this.nativeElement.deselectAllRows(this.b0.i(a));
    };
    RowIsland.prototype.ec = function () {
        this.nativeElement.clearCellSelection();
    };
    RowIsland.prototype.gc = function (a) {
        this.nativeElement.selectRange(this.b0.i(a));
    };
    RowIsland.prototype.c = function () {
        return this.b0.g(this.nativeElement.getSelectedRanges(), function (a) { return new GridSelectionRange(); });
    };
    RowIsland.prototype.fg = function (a, b) {
        if (a === void 0) {
            a = false;
        }
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.getSelectedData(this.b0.i(a), this.b0.i(b));
    };
    RowIsland.prototype.d = function () {
        return this.b0.g(this.nativeElement.selectedColumns(), function (a) { return new Column(); });
    };
    RowIsland.prototype.ga = function (a, b) {
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.selectColumns(this.b0.i(a), this.b0.i(b));
    };
    RowIsland.prototype.e0 = function (a) {
        this.nativeElement.deselectColumns(this.b0.i(a));
    };
    RowIsland.prototype.ey = function () {
        this.nativeElement.deselectAllColumns();
    };
    RowIsland.prototype.f8 = function () {
        this.nativeElement.selectAllColumns();
    };
    RowIsland.prototype.ff = function (a, b) {
        if (a === void 0) {
            a = false;
        }
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.getSelectedColumnsData(this.b0.i(a), this.b0.i(b));
    };
    RowIsland.prototype.fp = function (a, b, c) {
        this.nativeElement.navigateTo(this.b0.i(a), this.b0.i(b), this.b0.i(c));
    };
    RowIsland.prototype.i = function (a, b, c) {
        return this.b0.g(this.nativeElement.getNextCell(this.b0.i(a), this.b0.i(b), this.b0.i(c)), function (d) { return new CellPosition(); });
    };
    RowIsland.prototype.j = function (a, b, c) {
        return this.b0.g(this.nativeElement.getPreviousCell(this.b0.i(a), this.b0.i(b), this.b0.i(c)), function (d) { return new CellPosition(); });
    };
    RowIsland.prototype.fq = function (a) {
        this.nativeElement.openAdvancedFilteringDialog(this.b0.i(a));
    };
    RowIsland.prototype.eg = function (a) {
        this.nativeElement.closeAdvancedFilteringDialog(this.b0.i(a));
    };
    RowIsland.prototype.e5 = function (a, b) {
        this.nativeElement.endEdit(this.b0.i(a), this.b0.i(b));
    };
    RowIsland.prototype.d6 = function (a, b) {
        if (b === void 0) {
            b = false;
        }
        this.nativeElement.beginAddRowById(this.b0.i(a), this.b0.i(b));
    };
    Object.defineProperty(RowIsland.prototype, "d2", {
        get: function () {
            var ret_ = this.b0.n("name");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b0.v("name", value_);
        },
        enumerable: false,
        configurable: true
    });
    RowIsland.$t = markType(RowIsland, 'RowIsland', BaseElement.$);
    return RowIsland;
}(BaseElement));
export { RowIsland };
/**
 * @hidden
 */
var RowIslandCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RowIslandCollection, _super);
    function RowIslandCollection() {
        return _super.call(this, RowIsland.$, 0) || this;
    }
    RowIslandCollection.$t = markType(RowIslandCollection, 'RowIslandCollection', ObservableCollection$1.$.specialize(RowIsland.$));
    return RowIslandCollection;
}(ObservableCollection$1));
export { RowIslandCollection };
