/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseToolbarDirective } from "./BaseToolbarDirective";
import { enumGetBox, markType } from "igniteui-react-core";
import { ExporterEventArgs } from "./ExporterEventArgs";
import { VoidEventArgs } from "igniteui-react";
import { GridToolbarExporterType_$type } from "./GridToolbarExporterType";
/**
 * @hidden
 */
var GridToolbarExporter = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridToolbarExporter, _super);
    function GridToolbarExporter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.exportStarted = null;
        _this.exportEnded = null;
        return _this;
    }
    Object.defineProperty(GridToolbarExporter.prototype, "w", {
        get: function () {
            var ret_ = this.i.n("exportCSV");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("exportCSV", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridToolbarExporter.prototype, "x", {
        get: function () {
            var ret_ = this.i.n("exportExcel");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("exportExcel", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridToolbarExporter.prototype, "z", {
        get: function () {
            var ret_ = this.i.n("filename");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("filename", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridToolbarExporter.prototype, "y", {
        get: function () {
            var ret_ = this.i.n("isExporting");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("isExporting", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridToolbarExporter.prototype.exportStartedChanged = function () {
        var _this = this;
        if (this.exportStarted != null) {
            this.i.r("exportStarted", function (a) { return _this.exportStarted(_this, ExporterEventArgs.a(a)); }, false);
        }
        else {
            this.i.u("exportStarted");
        }
    };
    GridToolbarExporter.prototype.exportEndedChanged = function () {
        var _this = this;
        if (this.exportEnded != null) {
            this.i.r("exportEnded", function (a) { return _this.exportEnded(_this, VoidEventArgs.b(a)); }, false);
        }
        else {
            this.i.u("exportEnded");
        }
    };
    GridToolbarExporter.prototype.ab = function (a, b) {
        this.nativeElement.export(this.i.i(enumGetBox(GridToolbarExporterType_$type, a)), this.i.i(b));
    };
    GridToolbarExporter.$t = markType(GridToolbarExporter, 'GridToolbarExporter', BaseToolbarDirective.$);
    return GridToolbarExporter;
}(BaseToolbarDirective));
export { GridToolbarExporter };
