/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { ValidationStatus_$type } from "./ValidationStatus";
import { ValidationErrors } from "./ValidationErrors";
/**
 * @hidden
 */
var GridValidationState = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridValidationState, _super);
    function GridValidationState() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = new WCNativeHelper();
        _this.e = null;
        return _this;
    }
    Object.defineProperty(GridValidationState.prototype, "d", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridValidationState.prototype, "nativeElement", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
            this.c.o = this.e;
        },
        enumerable: false,
        configurable: true
    });
    GridValidationState.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(GridValidationState.prototype, "b", {
        get: function () {
            var ret_ = this.d.n("status");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(ValidationStatus_$type, EnumUtil.getEnumValue(ValidationStatus_$type, this.d.f(ValidationStatus_$type, ret_)));
            return EnumUtil.getEnumValue(ValidationStatus_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(ValidationStatus_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("status", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridValidationState.prototype, "a", {
        get: function () {
            var ret_ = this.d.m("errors", function (a) { return new ValidationErrors(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("errors", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridValidationState.$t = markType(GridValidationState, 'GridValidationState');
    return GridValidationState;
}(Base));
export { GridValidationState };
