/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridBaseDirective } from "./GridBaseDirective";
import { markType } from "igniteui-react-core";
import { ForOfStateEventArgs } from "./ForOfStateEventArgs";
/**
 * @hidden
 */
var HierarchicalGridBaseDirective = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HierarchicalGridBaseDirective, _super);
    function HierarchicalGridBaseDirective() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.dataPreLoad = null;
        return _this;
    }
    Object.defineProperty(HierarchicalGridBaseDirective.prototype, "g0", {
        get: function () {
            var ret_ = this.d.n("hasChildrenKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("hasChildrenKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HierarchicalGridBaseDirective.prototype, "gz", {
        get: function () {
            var ret_ = this.d.n("showExpandAll");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("showExpandAll", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HierarchicalGridBaseDirective.prototype, "gy", {
        get: function () {
            var ret_ = this.d.n("rootGrid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("rootGrid", value_);
        },
        enumerable: false,
        configurable: true
    });
    HierarchicalGridBaseDirective.prototype.dataPreLoadChanged = function () {
        var _this = this;
        if (this.dataPreLoad != null) {
            this.d.r("dataPreLoad", function (a) { return _this.dataPreLoad(_this, ForOfStateEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("dataPreLoad");
        }
    };
    HierarchicalGridBaseDirective.$t = markType(HierarchicalGridBaseDirective, 'HierarchicalGridBaseDirective', GridBaseDirective.$);
    return HierarchicalGridBaseDirective;
}(GridBaseDirective));
export { HierarchicalGridBaseDirective };
