/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PositionStrategy } from "./PositionStrategy";
import { ScrollStrategy } from "./ScrollStrategy";
/**
 * @hidden
 */
var OverlaySettings = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OverlaySettings, _super);
    function OverlaySettings() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = new WCNativeHelper();
        _this.h = null;
        return _this;
    }
    Object.defineProperty(OverlaySettings.prototype, "d", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(OverlaySettings.prototype, "nativeElement", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            this.h = a;
            this.c.o = this.h;
        },
        enumerable: false,
        configurable: true
    });
    OverlaySettings.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(OverlaySettings.prototype, "j", {
        get: function () {
            var ret_ = this.d.m("target", function (a) { });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("target", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(OverlaySettings.prototype, "a", {
        get: function () {
            var ret_ = this.d.m("positionStrategy", function (a) { return new PositionStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("positionStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(OverlaySettings.prototype, "b", {
        get: function () {
            var ret_ = this.d.m("scrollStrategy", function (a) { return new ScrollStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("scrollStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(OverlaySettings.prototype, "g", {
        get: function () {
            var ret_ = this.d.n("modal");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("modal", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(OverlaySettings.prototype, "f", {
        get: function () {
            var ret_ = this.d.n("closeOnOutsideClick");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("closeOnOutsideClick", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(OverlaySettings.prototype, "e", {
        get: function () {
            var ret_ = this.d.n("closeOnEscape");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("closeOnEscape", value_);
        },
        enumerable: false,
        configurable: true
    });
    OverlaySettings.$t = markType(OverlaySettings, 'OverlaySettings');
    return OverlaySettings;
}(Base));
export { OverlaySettings };
