/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { DisplayDensityBaseElement } from "./DisplayDensityBaseElement";
import { markType } from "igniteui-react-core";
import { OverlaySettings } from "./OverlaySettings";
import { PaginatorResourceStrings } from "./PaginatorResourceStrings";
import { NumberEventArgs } from "igniteui-react";
import { PageCancellableEventArgs } from "./PageCancellableEventArgs";
import { PageEventArgs } from "./PageEventArgs";
/**
 * @hidden
 */
var Paginator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Paginator, _super);
    function Paginator() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.perPageChange = null;
        _this.pageChange = null;
        _this.paging = null;
        _this.pagingDone = null;
        return _this;
    }
    Object.defineProperty(Paginator.prototype, "r", {
        get: function () {
            var ret_ = this.d.n("totalPages");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("totalPages", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Paginator.prototype, "p", {
        get: function () {
            var ret_ = this.d.n("page");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("page", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Paginator.prototype, "q", {
        get: function () {
            var ret_ = this.d.n("perPage");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("perPage", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Paginator.prototype, "s", {
        get: function () {
            var ret_ = this.d.n("totalRecords");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("totalRecords", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Paginator.prototype, "i", {
        get: function () {
            var ret_ = this.d.n("selectOptions");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("selectOptions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Paginator.prototype, "l", {
        get: function () {
            var ret_ = this.d.m("overlaySettings", function (a) { return new OverlaySettings(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("overlaySettings", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Paginator.prototype, "o", {
        get: function () {
            var ret_ = this.d.m("resourceStrings", function (a) { return new PaginatorResourceStrings(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("resourceStrings", value_);
        },
        enumerable: false,
        configurable: true
    });
    Paginator.prototype.perPageChangeChanged = function () {
        var _this = this;
        if (this.perPageChange != null) {
            this.d.r("perPageChange", function (a) { return _this.perPageChange(_this, NumberEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("perPageChange");
        }
    };
    Paginator.prototype.pageChangeChanged = function () {
        var _this = this;
        if (this.pageChange != null) {
            this.d.r("pageChange", function (a) { return _this.pageChange(_this, NumberEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("pageChange");
        }
    };
    Paginator.prototype.pagingChanged = function () {
        var _this = this;
        if (this.paging != null) {
            this.d.r("paging", function (a) { return _this.paging(_this, PageCancellableEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("paging");
        }
    };
    Paginator.prototype.pagingDoneChanged = function () {
        var _this = this;
        if (this.pagingDone != null) {
            this.d.r("pagingDone", function (a) { return _this.pagingDone(_this, PageEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("pagingDone");
        }
    };
    Paginator.prototype.u = function () {
        this.nativeElement.nextPage();
    };
    Paginator.prototype.aa = function () {
        this.nativeElement.previousPage();
    };
    Paginator.prototype.w = function (a) {
        this.nativeElement.paginate(this.d.i(a));
    };
    Object.defineProperty(Paginator.prototype, "t", {
        get: function () {
            var ret_ = this.d.n("name");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("name", value_);
        },
        enumerable: false,
        configurable: true
    });
    Paginator.$t = markType(Paginator, 'Paginator', DisplayDensityBaseElement.$);
    return Paginator;
}(DisplayDensityBaseElement));
export { Paginator };
