/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PivotAggregationType_$type } from "./PivotAggregationType";
/**
 * @hidden
 */
var PivotAggregator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PivotAggregator, _super);
    function PivotAggregator() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = new WCNativeHelper();
        _this.e = null;
        _this.aggregator = null;
        return _this;
    }
    Object.defineProperty(PivotAggregator.prototype, "d", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotAggregator.prototype, "nativeElement", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
            this.c.o = this.e;
        },
        enumerable: false,
        configurable: true
    });
    PivotAggregator.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(PivotAggregator.prototype, "g", {
        get: function () {
            var ret_ = this.d.n("key");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("key", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotAggregator.prototype, "h", {
        get: function () {
            var ret_ = this.d.n("label");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("label", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotAggregator.prototype, "b", {
        get: function () {
            var ret_ = this.d.n("aggregatorName");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(PivotAggregationType_$type, EnumUtil.getEnumValue(PivotAggregationType_$type, this.d.f(PivotAggregationType_$type, ret_)));
            return EnumUtil.getEnumValue(PivotAggregationType_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(PivotAggregationType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("aggregatorName", value_);
        },
        enumerable: false,
        configurable: true
    });
    PivotAggregator.prototype.aggregatorChanged = function () {
        if (this.aggregator != null) {
            var value_ = this.aggregator;
            this.d.v("aggregator", value_);
        }
        else {
            var value_ = null;
            this.d.v("aggregator", value_);
        }
    };
    PivotAggregator.$t = markType(PivotAggregator, 'PivotAggregator');
    return PivotAggregator;
}(Base));
export { PivotAggregator };
