/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PivotDimensionStrategy } from "./PivotDimensionStrategy";
import { PivotDimension } from "./PivotDimension";
import { PivotDimensionCollection } from "./PivotDimensionCollection";
import { PivotValueCollection } from "./PivotValueCollection";
import { PivotKeys } from "./PivotKeys";
import { PivotValue } from "./PivotValue";
/**
 * @hidden
 */
var PivotConfiguration = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PivotConfiguration, _super);
    function PivotConfiguration() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.h = new WCNativeHelper();
        _this.j = null;
        return _this;
    }
    Object.defineProperty(PivotConfiguration.prototype, "i", {
        get: function () {
            return this.h;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotConfiguration.prototype, "nativeElement", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
            this.h.o = this.j;
        },
        enumerable: false,
        configurable: true
    });
    PivotConfiguration.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(PivotConfiguration.prototype, "e", {
        get: function () {
            var ret_ = this.i.m("rowStrategy", function (a) { return new PivotDimensionStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("rowStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotConfiguration.prototype, "d", {
        get: function () {
            var ret_ = this.i.m("columnStrategy", function (a) { return new PivotDimensionStrategy(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("columnStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotConfiguration.prototype, "c", {
        get: function () {
            var ret_ = this.i.k("rows", function (a) { return new PivotDimensionCollection(); }, function (a) { return new PivotDimension(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotConfiguration.prototype, "a", {
        get: function () {
            var ret_ = this.i.k("columns", function (a) { return new PivotDimensionCollection(); }, function (a) { return new PivotDimension(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotConfiguration.prototype, "g", {
        get: function () {
            var ret_ = this.i.k("values", function (a) { return new PivotValueCollection(); }, function (a) { return new PivotValue(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotConfiguration.prototype, "b", {
        get: function () {
            var ret_ = this.i.k("filters", function (a) { return new PivotDimensionCollection(); }, function (a) { return new PivotDimension(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotConfiguration.prototype, "f", {
        get: function () {
            var ret_ = this.i.m("pivotKeys", function (a) { return new PivotKeys(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("pivotKeys", value_);
        },
        enumerable: false,
        configurable: true
    });
    PivotConfiguration.$t = markType(PivotConfiguration, 'PivotConfiguration');
    return PivotConfiguration;
}(Base));
export { PivotConfiguration };
