/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { PivotDimension } from "./PivotDimension";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { GridColumnDataType_$type } from "./GridColumnDataType";
import { GridResourceStrings } from "./GridResourceStrings";
import { PivotDateDimensionOptions } from "./PivotDateDimensionOptions";
/**
 * @hidden
 */
var PivotDateDimension = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PivotDateDimension, _super);
    function PivotDateDimension() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(PivotDateDimension.prototype, "t", {
        get: function () {
            var ret_ = this.g.n("enabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("enabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotDateDimension.prototype, "p", {
        get: function () {
            var ret_ = this.g.n("dataType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridColumnDataType_$type, EnumUtil.getEnumValue(GridColumnDataType_$type, this.g.f(GridColumnDataType_$type, ret_)));
            return EnumUtil.getEnumValue(GridColumnDataType_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridColumnDataType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("dataType", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotDateDimension.prototype, "q", {
        get: function () {
            var ret_ = this.g.m("resourceStrings", function (a) { return new GridResourceStrings(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("resourceStrings", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotDateDimension.prototype, "s", {
        get: function () {
            var ret_ = this.g.m("baseDimension", function (a) { return new PivotDimension(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("baseDimension", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotDateDimension.prototype, "r", {
        get: function () {
            var ret_ = this.g.m("options", function (a) { return new PivotDateDimensionOptions(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("options", value_);
        },
        enumerable: false,
        configurable: true
    });
    PivotDateDimension.$t = markType(PivotDateDimension, 'PivotDateDimension', PivotDimension.$);
    return PivotDateDimension;
}(PivotDimension));
export { PivotDateDimension };
