/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { PivotDimension } from "./PivotDimension";
import { FilteringExpressionsTree } from "./FilteringExpressionsTree";
import { SortingDirection_$type } from "./SortingDirection";
import { GridColumnDataType_$type } from "./GridColumnDataType";
/**
 * @hidden
 */
var PivotDimensionDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PivotDimensionDetail, _super);
    function PivotDimensionDetail() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f = new WCNativeHelper();
        _this.j = null;
        _this.memberFunction = null;
        return _this;
    }
    Object.defineProperty(PivotDimensionDetail.prototype, "g", {
        get: function () {
            return this.f;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotDimensionDetail.prototype, "nativeElement", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
            this.f.o = this.j;
        },
        enumerable: false,
        configurable: true
    });
    PivotDimensionDetail.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(PivotDimensionDetail.prototype, "d", {
        get: function () {
            var ret_ = this.g.m("childLevel", function (a) { return new PivotDimension(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("childLevel", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotDimensionDetail.prototype, "l", {
        get: function () {
            var ret_ = this.g.n("memberName");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("memberName", value_);
        },
        enumerable: false,
        configurable: true
    });
    PivotDimensionDetail.prototype.memberFunctionChanged = function () {
        if (this.memberFunction != null) {
            var value_ = this.memberFunction;
            this.g.v("memberFunction", value_);
        }
        else {
            var value_ = null;
            this.g.v("memberFunction", value_);
        }
    };
    Object.defineProperty(PivotDimensionDetail.prototype, "h", {
        get: function () {
            var ret_ = this.g.n("enabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("enabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotDimensionDetail.prototype, "a", {
        get: function () {
            var ret_ = this.g.m("filter", function (a) { return new FilteringExpressionsTree(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("filter", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotDimensionDetail.prototype, "e", {
        get: function () {
            var ret_ = this.g.n("sortDirection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(SortingDirection_$type, EnumUtil.getEnumValue(SortingDirection_$type, this.g.f(SortingDirection_$type, ret_)));
            return EnumUtil.getEnumValue(SortingDirection_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SortingDirection_$type, a);
            value_ = this.g.f(SortingDirection_$type, value_);
            this.g.v("sortDirection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotDimensionDetail.prototype, "b", {
        get: function () {
            var ret_ = this.g.n("dataType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridColumnDataType_$type, EnumUtil.getEnumValue(GridColumnDataType_$type, this.g.f(GridColumnDataType_$type, ret_)));
            return EnumUtil.getEnumValue(GridColumnDataType_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GridColumnDataType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("dataType", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotDimensionDetail.prototype, "m", {
        get: function () {
            var ret_ = this.g.n("width");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("width", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotDimensionDetail.prototype, "i", {
        get: function () {
            var ret_ = this.g.n("level");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.v("level", value_);
        },
        enumerable: false,
        configurable: true
    });
    PivotDimensionDetail.$t = markType(PivotDimensionDetail, 'PivotDimensionDetail');
    return PivotDimensionDetail;
}(Base));
export { PivotDimensionDetail };
