/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridCellBase } from "./GridCellBase";
import { TemplateCellContainer } from "./TemplateCellContainer";
import { runOn, markType } from "igniteui-react-core";
import { BaseDOMEventProxy } from "igniteui-react-core";
/**
 * @hidden
 */
var TemplateCell = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TemplateCell, _super);
    function TemplateCell(a) {
        var _this = _super.call(this, a) || this;
        _this.ch = null;
        _this.ch = new TemplateCellContainer(a);
        _this.ch.element.setRawStyleProperty("box-sizing", "border-box");
        _this.ae.append(_this.ch.element);
        _this.ae.listen("keydown", runOn(_this, _this.cj));
        return _this;
    }
    Object.defineProperty(TemplateCell.prototype, "ci", {
        get: function () {
            return this.ch;
        },
        enumerable: false,
        configurable: true
    });
    TemplateCell.prototype.get_w = function () {
        return true;
    };
    TemplateCell.prototype.bp = function (a, b, c) {
        _super.prototype.bp.call(this, a, b, c);
        if (a == "Indent" || a == "IsCollapsable") {
            this.ch.element.setRawStyleProperty("margin-left", this.a0 + this.a2 + this.a1 + "px");
        }
    };
    TemplateCell.prototype.be = function () {
        var a = this.ch.element.getNativeElement();
        if (a.contains(document.activeElement)) {
            return;
        }
        _super.prototype.be.call(this);
    };
    TemplateCell.prototype.cj = function (a) {
        var b = this.ch.element.getNativeElement();
        if (b.contains(document.activeElement) && document.activeElement.nodeName == "INPUT") {
            var c = BaseDOMEventProxy.c0(a);
            if (c == 14 || c == 16) {
                a.stopPropagation();
            }
        }
    };
    TemplateCell.$t = markType(TemplateCell, 'TemplateCell', GridCellBase.$);
    return TemplateCell;
}(GridCellBase));
export { TemplateCell };
