/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseEditorView } from "./BaseEditorView";
import { XInputGroup } from "igniteui-react-inputs";
import { XInput } from "igniteui-react-inputs";
import { runOn, delegateCombine, delegateRemove, markType } from "igniteui-react-core";
/**
 * @hidden
 */
var TextEditorView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TextEditorView, _super);
    function TextEditorView(a, b, c) {
        var _this = _super.call(this, a, c) || this;
        _this.aa = null;
        _this.z = null;
        _this.y = null;
        var d = a.createElement("div");
        d.setRawStyleProperty("display", "flex");
        d.setRawStyleProperty("width", "100%");
        d.setRawStyleProperty("margin-top", "-10px");
        d.setRawStyleProperty("height", "38px");
        _this.container = d;
        var e = a.getSubRenderer(d);
        _this.z = new XInputGroup();
        _this.z.provideContainer(e);
        _this.z.d = 0;
        _this.z.p = b;
        _this.z.t = 3;
        _this.z.disabled = !_this.isEnabled;
        var f = e.getExternal(_this.z, e.rootWrapper, null);
        var g = a.createElement("div");
        g.setRawStyleProperty("width", "100%");
        var h = a.getSubRenderer(g);
        _this.y = new XInput();
        _this.y.provideContainer(h);
        _this.y.b8 = "text";
        _this.y.disabled = !_this.isEnabled;
        _this.y.d8 = _this.textColor;
        var i = e.getExternal(_this.y, h.rootWrapper, null);
        _this.z.appendContentChild(g);
        _this.z.inputs.add(_this.y);
        return _this;
    }
    TextEditorView.prototype.setFont = function (a) {
        if (this.y != null) {
            this.y.af = a;
        }
    };
    TextEditorView.prototype.attachEvents = function () {
        if (this.y != null) {
            var a = this.y;
            a.changing = delegateCombine(a.changing, runOn(this, this.ac));
            var b = this.y;
            b.keyDown = delegateCombine(b.keyDown, runOn(this, this.onInputKeyDown));
            var c = this.y;
            c.compositionEnd = delegateCombine(c.compositionEnd, runOn(this, this.ab));
            var d = this.y;
            d.gotFocus = delegateCombine(d.gotFocus, runOn(this, this.ad));
            var e = this.y;
            e.lostFocus = delegateCombine(e.lostFocus, runOn(this, this.ae));
        }
    };
    TextEditorView.prototype.detachEvents = function () {
        if (this.y != null) {
            var a = this.y;
            a.changing = delegateRemove(a.changing, runOn(this, this.ac));
            var b = this.y;
            b.keyDown = delegateRemove(b.keyDown, runOn(this, this.onInputKeyDown));
            var c = this.y;
            c.compositionEnd = delegateRemove(c.compositionEnd, runOn(this, this.ab));
            var d = this.y;
            d.gotFocus = delegateRemove(d.gotFocus, runOn(this, this.ad));
            var e = this.y;
            e.lostFocus = delegateRemove(e.lostFocus, runOn(this, this.ae));
        }
    };
    TextEditorView.prototype.onTargetChanged = function () {
        this.aa = null;
        if (this.y != null) {
            this.focus();
        }
    };
    TextEditorView.prototype.onEditStarted = function () {
        _super.prototype.onEditStarted.call(this);
        if (!this.a.isEditRefocusDesired) {
            this.focus();
        }
    };
    TextEditorView.prototype.onEditEnded = function () {
        _super.prototype.onEditEnded.call(this);
        if (this.a.isEditRefocusDesired) {
            var a = this.h.rootWrapper.getNativeElement();
            if (a == document.activeElement || a.contains(document.activeElement)) {
                this.y.ct();
                this.focus();
            }
        }
    };
    TextEditorView.prototype.s = function () {
        var _this = this;
        if (this.y != null) {
            this.y.focus(true);
            if (this.y.b8 != "date") {
                window.setTimeout(function () { return _this.y.dp(); }, 0);
            }
        }
    };
    TextEditorView.prototype.w = function () {
        if (this.y != null) {
            if (this.value != null) {
                this.aa = null;
                this.y.cq = null;
                this.y.cq = this.value.toString();
                if (this.focusOnValueChanged) {
                    this.s();
                }
            }
            else {
                this.y.cq = null;
            }
        }
    };
    TextEditorView.prototype.r = function () {
        if (this.z != null) {
            this.z.disabled = !this.isEnabled;
        }
        if (this.y != null) {
            this.y.disabled = !this.isEnabled;
        }
    };
    TextEditorView.prototype.v = function () {
        _super.prototype.v.call(this);
        if (this.y != null) {
            this.y.d8 = this.textColor;
        }
    };
    TextEditorView.prototype.ac = function (a, b) {
        this.p();
        if (b.isCompositionInProgress) {
            return;
        }
        if (this.aa != null && this.aa != b.value) {
            this.aa = null;
            return;
        }
        this.q(b.value, false);
    };
    TextEditorView.prototype.ab = function (a, b) {
        this.aa = b.value;
        this.q(this.y.cq, false);
    };
    TextEditorView.prototype.ae = function (a, b) {
        this.o();
    };
    TextEditorView.prototype.ad = function (a, b) {
        this.n();
    };
    TextEditorView.prototype.getEditorValue = function () {
        if (this.y != null) {
            return this.y.cq;
        }
        return null;
    };
    TextEditorView.prototype.setEditorValue = function (a) {
        if (this.y != null) {
            this.y.cq = a;
        }
    };
    TextEditorView.$t = markType(TextEditorView, 'TextEditorView', BaseEditorView.$);
    return TextEditorView;
}(BaseEditorView));
export { TextEditorView };
