/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridCellBase } from "./GridCellBase";
import { GridSortIndicator } from "./GridSortIndicator";
import { GridFilterDialog } from "./GridFilterDialog";
import { ColumnOptionsIconBehavior_$type } from "./ColumnOptionsIconBehavior";
import { ColumnOptionsIconAlignment_$type } from "./ColumnOptionsIconAlignment";
import { enumGetBox, runOn, delegateCombine, markType } from "igniteui-react-core";
/**
 * @hidden
 */
var TextHeaderCell = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TextHeaderCell, _super);
    function TextHeaderCell(a) {
        var _this = _super.call(this, a) || this;
        _this.cs = null;
        _this.co = null;
        _this.cm = null;
        _this.ci = 0;
        _this.ch = 0;
        _this.ck = 3;
        _this.cu = null;
        _this.cx = -1;
        _this.cw = -1;
        _this.cq = false;
        _this.ct = null;
        _this.cr = false;
        _this.cs = a.createElement("span");
        _this.ae.setRawStyleProperty("text-align", "left");
        _this.ae.setRawStyleProperty("vertical-align", "middle");
        _this.cs.setRawStyleProperty("display", "inline-block");
        _this.cs.setRawStyleProperty("line-height", "normal");
        _this.cs.setRawStyleProperty("vertical-align", "middle");
        _this.cs.setRawStyleProperty("overflow", "hidden");
        _this.cs.setRawStyleProperty("white-space", "nowrap");
        _this.cs.setRawStyleProperty("text-overflow", "ellipsis");
        _this.ae.append(_this.cs);
        var b = 18;
        var c = 18;
        var d = a.createElement("div");
        d.setAttribute("aria-hidden", "true");
        d.setRawStyleProperty("display", "none");
        d.setRawStyleProperty("vertical-align", "middle");
        d.setRawStyleProperty("width", b + "px");
        d.setRawStyleProperty("height", c + "px");
        _this.ct = d;
        var e = a.getSubRenderer(d);
        _this.cm = new GridFilterDialog();
        _this.cm.bg(e, _this.ae, a);
        _this.ae.append(d);
        _this.cm.a8(b, c);
        _this.cm.af = 24;
        var f = _this.cm.x;
        _this.cm.x = false;
        _this.cm.a5();
        _this.cm.x = f;
        var g = 18;
        var h = 18;
        d = a.createElement("div");
        d.setAttribute("aria-hidden", "true");
        d.setRawStyleProperty("display", "inline-block");
        d.setRawStyleProperty("vertical-align", "middle");
        d.setRawStyleProperty("width", "0px");
        d.setRawStyleProperty("height", h + "px");
        d.setRawStyleProperty("margin", "0 0 0 5px");
        _this.cu = d;
        e = a.getSubRenderer(d);
        _this.co = new GridSortIndicator();
        _this.co.l = false;
        _this.co.ax(e);
        _this.ae.append(d);
        _this.co.ar(g, h);
        var i = _this.co;
        i.propertyChanged = delegateCombine(i.propertyChanged, runOn(_this, _this.c0));
        var j = _this.cm;
        j.dialogOpening = delegateCombine(j.dialogOpening, runOn(_this, _this.c1));
        var k = _this.cm;
        k.filterChanging = delegateCombine(k.filterChanging, runOn(_this, _this.c3));
        var l = _this.cm;
        l.filterChanged = delegateCombine(l.filterChanged, runOn(_this, _this.c2));
        _this.ae.listen("mouseenter", runOn(_this, _this.c7));
        _this.ae.listen("mouseleave", runOn(_this, _this.c6));
        return _this;
    }
    Object.defineProperty(TextHeaderCell.prototype, "cv", {
        get: function () {
            return this.cs;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TextHeaderCell.prototype, "cp", {
        get: function () {
            return this.co;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TextHeaderCell.prototype, "cn", {
        get: function () {
            return this.cm;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TextHeaderCell.prototype, "cl", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.ck;
            this.ck = a;
            this.bp("ColumnOptionsIconBehavior", enumGetBox(ColumnOptionsIconBehavior_$type, b), enumGetBox(ColumnOptionsIconBehavior_$type, this.ck));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TextHeaderCell.prototype, "cj", {
        get: function () {
            return this.ci;
        },
        set: function (a) {
            var b = this.ci;
            this.ci = a;
            this.bp("ColumnOptionsIconAlignment", enumGetBox(ColumnOptionsIconAlignment_$type, b), enumGetBox(ColumnOptionsIconAlignment_$type, this.ci));
        },
        enumerable: false,
        configurable: true
    });
    TextHeaderCell.prototype.x = function (a) {
        return true;
    };
    TextHeaderCell.prototype.b6 = function (a, b) {
        _super.prototype.b6.call(this, a, b);
        a -= 21;
        if (this.cr) {
            a -= 15;
        }
        var c = Math.max(0, a - b);
        if (c != this.cx) {
            this.cx = c;
            this.cs.setRawStyleProperty("max-width", c.toString() + "px");
        }
    };
    TextHeaderCell.prototype.b0 = function (a, b) {
        _super.prototype.b0.call(this, a, b);
        var c = Math.max(0, a - b);
        if (this.cw != c) {
            this.cw = c;
            this.cs.setRawStyleProperty("max-height", c.toString() + "px");
        }
    };
    TextHeaderCell.prototype.b7 = function (a, b, c, d) {
        this.cm.a7();
    };
    TextHeaderCell.prototype.c0 = function (a, b) {
        switch (b.propertyName) {
            case "CurrentOpacity":
                if (this.cp.r > 0) {
                    this.cu.setRawStyleProperty("width", "18px");
                    if (this.ch == 2) {
                        this.cu.setRawStyleProperty("margin", "0 5px 0 0");
                    }
                    else {
                        this.cu.setRawStyleProperty("margin", "0 0 0 5px");
                    }
                }
                else {
                    this.cu.setRawStyleProperty("width", "0px");
                    this.cu.setRawStyleProperty("margin", "0");
                }
                break;
        }
    };
    TextHeaderCell.prototype.c7 = function (a) {
        if (this.b.isGridDragging) {
            return;
        }
        switch (this.cl) {
            case 2:
            case 3:
                this.cm.bl();
                break;
        }
    };
    TextHeaderCell.prototype.c6 = function (a) {
        switch (this.cl) {
            case 2:
            case 3:
                this.cm.a5();
                break;
        }
    };
    TextHeaderCell.prototype.c2 = function (a, b) {
        this.b.columnFilterChanged(b.a);
    };
    TextHeaderCell.prototype.c3 = function (a, b) {
        this.b.columnFilterChanging(b.a);
    };
    TextHeaderCell.prototype.c1 = function (a, b) {
        if (this.b != null) {
            b.a = this.f.getColumn();
            this.b.cancelEditMode(false);
        }
    };
    TextHeaderCell.prototype.bn = function (a, b, c) {
        _super.prototype.bn.call(this, a, b, c);
        this.ch = c;
        this.cm.k = c;
        if (c == 2) {
            this.ae.removeChild(this.cu);
            this.ae.removeChild(this.ct);
            this.cs.before(this.ct);
            this.ct.before(this.cu);
            if (this.cj == 1) {
                this.ct.setRawStyleProperty("margin", "0 5px 0 0");
                this.cm.l = this.ch;
            }
            else {
                this.ct.setRawStyleProperty("margin", "0");
                this.cm.l = 0;
            }
        }
        else {
            this.ae.removeChild(this.cu);
            this.ae.removeChild(this.cs);
            this.ct.before(this.cs);
            this.ct.before(this.cu);
            if (this.cj == 1) {
                this.ct.setRawStyleProperty("margin", "0 0 0 5px");
                this.cm.l = this.ch;
            }
            else {
                this.ct.setRawStyleProperty("margin", "0");
                this.cm.l = 2;
            }
        }
    };
    TextHeaderCell.prototype.b4 = function (a, b, c, d) {
        _super.prototype.b4.call(this, a, b, c, d);
        this.cm.ai = a;
        this.cm.aj = c;
    };
    TextHeaderCell.prototype.c5 = function () {
        if (this.cj == 2 || this.cj == 0) {
            if (this.ch == 2) {
                this.cm.l = 0;
            }
            else {
                this.cm.l = 2;
            }
        }
        else {
            this.cm.l = this.ch;
            if (this.ch == 2) {
                this.ct.setRawStyleProperty("margin", "0 5px 0 0");
            }
            else {
                this.ct.setRawStyleProperty("margin", "0 0 0 5px");
            }
        }
    };
    TextHeaderCell.prototype.c4 = function () {
        switch (this.cl) {
            case 1:
                this.cm.x = false;
                this.cm.bl();
                break;
            case 2:
                this.cm.x = false;
                break;
            case 3:
                this.cm.x = true;
                break;
        }
    };
    TextHeaderCell.prototype.bp = function (a, b, c) {
        _super.prototype.bp.call(this, a, b, c);
        switch (a) {
            case "ColumnOptionsIconAlignment":
                this.c5();
                break;
            case "ColumnOptionsIconBehavior":
                this.c4();
                break;
        }
    };
    TextHeaderCell.prototype.onContactStarted = function (e_, a) {
        if (e_.button == 2) {
            return;
        }
        var filterIconCanvas_ = this.cm.aq();
        var b = (e_.originalEvent.srcElement === filterIconCanvas_ || e_.originalEvent.target === filterIconCanvas_);
        if (b) {
            this.cq = true;
            return;
        }
        if (this.cm.y) {
            this.cm.a2();
        }
        _super.prototype.onContactStarted.call(this, e_, a);
    };
    TextHeaderCell.prototype.onContactCompleted = function (e_, a) {
        if (!this.cq) {
            _super.prototype.onContactCompleted.call(this, e_, a);
        }
        this.cq = false;
    };
    TextHeaderCell.prototype.detach = function () {
        _super.prototype.detach.call(this);
        if (this.cm != null) {
            this.cm.a2();
        }
    };
    TextHeaderCell.prototype.get_u = function () {
        return true;
    };
    TextHeaderCell.$t = markType(TextHeaderCell, 'TextHeaderCell', GridCellBase.$);
    return TextHeaderCell;
}(GridCellBase));
export { TextHeaderCell };
