import { BaseEventArgsDetail as BaseEventArgsDetail_internal } from "./BaseEventArgsDetail";
var IgrBaseEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrBaseEventArgsDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrBaseEventArgsDetail.prototype.createImplementation = function () {
        return new BaseEventArgsDetail_internal();
    };
    Object.defineProperty(IgrBaseEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrBaseEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrBaseEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrBaseEventArgsDetail.prototype, "owner", {
        /**
         * Provides reference to the owner component.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrBaseEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrBaseEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrBaseEventArgsDetail;
}());
export { IgrBaseEventArgsDetail };
