import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { BaseEventArgs as BaseEventArgs_internal } from "./BaseEventArgs";
var IgrBaseEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrBaseEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrBaseEventArgs.prototype.createImplementation = function () {
        return new BaseEventArgs_internal();
    };
    Object.defineProperty(IgrBaseEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrBaseEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrBaseEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrBaseEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrBaseEventArgsDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrBaseEventArgs;
}());
export { IgrBaseEventArgs };
