import { __extends } from "tslib";
import { IgrFilteringOperand } from "./igr-filtering-operand";
import { BooleanFilteringOperand as BooleanFilteringOperand_internal } from "./BooleanFilteringOperand";
/**
 * Provides filtering operations for booleans
 * @export
*/
var IgrBooleanFilteringOperand = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrBooleanFilteringOperand, _super);
    function IgrBooleanFilteringOperand() {
        return _super.call(this) || this;
    }
    IgrBooleanFilteringOperand.prototype.createImplementation = function () {
        var impl = new BooleanFilteringOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    };
    Object.defineProperty(IgrBooleanFilteringOperand.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    return IgrBooleanFilteringOperand;
}(IgrFilteringOperand));
export { IgrBooleanFilteringOperand };
