import { Cell as Cell_internal } from "./Cell";
var IgrCell = /** @class */ /*@__PURE__*/ (function () {
    function IgrCell() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrCell.prototype.createImplementation = function () {
        return new Cell_internal();
    };
    Object.defineProperty(IgrCell.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrCell.prototype.onImplementationCreated = function () {
    };
    IgrCell.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrCell.prototype, "primaryKey", {
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCell.prototype, "state", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCell.prototype, "pendingValue", {
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCell.prototype, "editValue", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrCell.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrCell.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    IgrCell.prototype.castToNumber = function (value) {
        var iv = this.i.d(value);
        return (iv);
    };
    return IgrCell;
}());
export { IgrCell };
