import { IgrColumn } from "./igr-column";
import { ColumnComponentEventArgs as ColumnComponentEventArgs_internal } from "./ColumnComponentEventArgs";
var IgrColumnComponentEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnComponentEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrColumnComponentEventArgs.prototype.createImplementation = function () {
        return new ColumnComponentEventArgs_internal();
    };
    Object.defineProperty(IgrColumnComponentEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnComponentEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrColumnComponentEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrColumnComponentEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrColumnComponentEventArgs;
}());
export { IgrColumnComponentEventArgs };
