import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { ColumnExchanger as ColumnExchanger_internal } from './ColumnExchanger';
import { IgrColumnExchanger as IgrColumnExchanger } from './igr-column-exchanger';
var IgrColumnExchangersCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrColumnExchangersCollection, _super);
    function IgrColumnExchangersCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrColumnExchanger.$type) {
            IgrColumnExchanger.$type = markType(IgrColumnExchanger, "IgrColumnExchanger");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrColumnExchangersCollection.prototype._createInnerColl = function () {
        if (!IgrColumnExchanger.$type) {
            IgrColumnExchanger.$type = markType(IgrColumnExchanger, "IgrColumnExchanger");
        }
        var coll = new SyncableObservableCollection$2(IgrColumnExchanger.$type, ColumnExchanger_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrColumnExchanger();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrColumnExchangersCollection;
}(IgCollection));
export { IgrColumnExchangersCollection };
