import { IgrDataGridColumn } from "./igr-data-grid-column";
import { ColumnHiddenChangedEventArgs as ColumnHiddenChangedEventArgs_internal } from "./ColumnHiddenChangedEventArgs";
import { ensureBool } from "igniteui-react-core";
var IgrColumnHiddenChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnHiddenChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrColumnHiddenChangedEventArgs.prototype.createImplementation = function () {
        return new ColumnHiddenChangedEventArgs_internal();
    };
    Object.defineProperty(IgrColumnHiddenChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnHiddenChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrColumnHiddenChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrColumnHiddenChangedEventArgs.prototype, "column", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrDataGridColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnHiddenChangedEventArgs.prototype, "isHidden", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrColumnHiddenChangedEventArgs;
}());
export { IgrColumnHiddenChangedEventArgs };
