import { ColumnMovingService as ColumnMovingService_internal } from "./ColumnMovingService";
var IgrColumnMovingService = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnMovingService() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrColumnMovingService.prototype.createImplementation = function () {
        return new ColumnMovingService_internal();
    };
    Object.defineProperty(IgrColumnMovingService.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnMovingService.prototype.onImplementationCreated = function () {
    };
    IgrColumnMovingService.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrColumnMovingService.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrColumnMovingService.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrColumnMovingService;
}());
export { IgrColumnMovingService };
