import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { ColumnPropertySetter as ColumnPropertySetter_internal } from './ColumnPropertySetter';
import { IgrColumnPropertySetter as IgrColumnPropertySetter } from './igr-column-property-setter';
var IgrColumnPropertySettersCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrColumnPropertySettersCollection, _super);
    function IgrColumnPropertySettersCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrColumnPropertySetter.$type) {
            IgrColumnPropertySetter.$type = markType(IgrColumnPropertySetter, "IgrColumnPropertySetter");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrColumnPropertySettersCollection.prototype._createInnerColl = function () {
        if (!IgrColumnPropertySetter.$type) {
            IgrColumnPropertySetter.$type = markType(IgrColumnPropertySetter, "IgrColumnPropertySetter");
        }
        var coll = new SyncableObservableCollection$2(IgrColumnPropertySetter.$type, ColumnPropertySetter_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrColumnPropertySetter();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrColumnPropertySettersCollection;
}(IgCollection));
export { IgrColumnPropertySettersCollection };
