import { __extends } from "tslib";
import { IgrColumn } from "./igr-column";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ColumnResizeEventArgsDetail as ColumnResizeEventArgsDetail_internal } from "./ColumnResizeEventArgsDetail";
var IgrColumnResizeEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrColumnResizeEventArgsDetail, _super);
    function IgrColumnResizeEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrColumnResizeEventArgsDetail.prototype.createImplementation = function () {
        return new ColumnResizeEventArgsDetail_internal();
    };
    Object.defineProperty(IgrColumnResizeEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnResizeEventArgsDetail.prototype, "column", {
        get: function () {
            var r = this.i.g;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.g = null : this.i.g = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnResizeEventArgsDetail.prototype, "prevWidth", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnResizeEventArgsDetail.prototype, "newWidth", {
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnResizeEventArgsDetail.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        return null;
    };
    return IgrColumnResizeEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrColumnResizeEventArgsDetail };
