import { IgrColumnToggledEventArgsDetail } from "./igr-column-toggled-event-args-detail";
import { ColumnToggledEventArgs as ColumnToggledEventArgs_internal } from "./ColumnToggledEventArgs";
/**
 * Event emitted when a checkbox in the checkbox
 * list of an IgxColumnActions component is clicked.
*/
var IgrColumnToggledEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnToggledEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrColumnToggledEventArgs.prototype.createImplementation = function () {
        return new ColumnToggledEventArgs_internal();
    };
    Object.defineProperty(IgrColumnToggledEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnToggledEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrColumnToggledEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrColumnToggledEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrColumnToggledEventArgsDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrColumnToggledEventArgs;
}());
export { IgrColumnToggledEventArgs };
