import { ColumnVisibilityChangingEventArgsDetail as ColumnVisibilityChangingEventArgsDetail_internal } from "./ColumnVisibilityChangingEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
var IgrColumnVisibilityChangingEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnVisibilityChangingEventArgsDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrColumnVisibilityChangingEventArgsDetail.prototype.createImplementation = function () {
        return new ColumnVisibilityChangingEventArgsDetail_internal();
    };
    Object.defineProperty(IgrColumnVisibilityChangingEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnVisibilityChangingEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrColumnVisibilityChangingEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrColumnVisibilityChangingEventArgsDetail.prototype, "column", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnVisibilityChangingEventArgsDetail.prototype, "newValue", {
        /**
         * The new hidden state that the column will have, if operation is succesfull.
         * Will be `true` when hiding and `false` when showing.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnVisibilityChangingEventArgsDetail.prototype, "cancel", {
        /**
         * Provides the ability to cancel the event.
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnVisibilityChangingEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrColumnVisibilityChangingEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrColumnVisibilityChangingEventArgsDetail;
}());
export { IgrColumnVisibilityChangingEventArgsDetail };
