import { __extends } from "tslib";
import { IgrBaseDateTimeFilteringOperand } from "./igr-base-date-time-filtering-operand";
import { DateFilteringOperand as DateFilteringOperand_internal } from "./DateFilteringOperand";
/**
 * Provides filtering operations for Dates
 * @export
*/
var IgrDateFilteringOperand = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDateFilteringOperand, _super);
    function IgrDateFilteringOperand() {
        return _super.call(this) || this;
    }
    IgrDateFilteringOperand.prototype.createImplementation = function () {
        var impl = new DateFilteringOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    };
    Object.defineProperty(IgrDateFilteringOperand.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    return IgrDateFilteringOperand;
}(IgrBaseDateTimeFilteringOperand));
export { IgrDateFilteringOperand };
