import { __extends } from "tslib";
import { IgrDefinitionBase } from "./igr-definition-base";
import { EditorDefinition } from "./EditorDefinition";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
var IgrEditorDefinition = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrEditorDefinition, _super);
    function IgrEditorDefinition(props) {
        return _super.call(this, props) || this;
    }
    IgrEditorDefinition.prototype.createImplementation = function () {
        return new EditorDefinition();
    };
    Object.defineProperty(IgrEditorDefinition.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    return IgrEditorDefinition;
}(IgrDefinitionBase));
export { IgrEditorDefinition };
