import { ExporterEventArgsDetail as ExporterEventArgsDetail_internal } from "./ExporterEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
var IgrExporterEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrExporterEventArgsDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrExporterEventArgsDetail.prototype.createImplementation = function () {
        return new ExporterEventArgsDetail_internal();
    };
    Object.defineProperty(IgrExporterEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrExporterEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrExporterEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrExporterEventArgsDetail.prototype, "exporter", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterEventArgsDetail.prototype, "options", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterEventArgsDetail.prototype, "grid", {
        get: function () {
            var r = this.i.c;
            if (r == null) {
                return null;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.c = null : this.i.c = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterEventArgsDetail.prototype, "cancel", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrExporterEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.exporter && this.exporter.name && this.exporter.name == name) {
            return this.exporter;
        }
        if (this.options && this.options.name && this.options.name == name) {
            return this.options;
        }
        if (this.grid && this.grid.name && this.grid.name == name) {
            return this.grid;
        }
        return null;
    };
    IgrExporterEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrExporterEventArgsDetail;
}());
export { IgrExporterEventArgsDetail };
