import { IgrFilteringExpressionsTreeDetail } from "./igr-filtering-expressions-tree-detail";
import { FilteringExpressionsTreeEventArgs as FilteringExpressionsTreeEventArgs_internal } from "./FilteringExpressionsTreeEventArgs";
var IgrFilteringExpressionsTreeEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrFilteringExpressionsTreeEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrFilteringExpressionsTreeEventArgs.prototype.createImplementation = function () {
        return new FilteringExpressionsTreeEventArgs_internal();
    };
    Object.defineProperty(IgrFilteringExpressionsTreeEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrFilteringExpressionsTreeEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrFilteringExpressionsTreeEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrFilteringExpressionsTreeEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrFilteringExpressionsTreeDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrFilteringExpressionsTreeEventArgs;
}());
export { IgrFilteringExpressionsTreeEventArgs };
