import { IgrForOfStateDetail } from "./igr-for-of-state-detail";
import { ForOfStateEventArgs as ForOfStateEventArgs_internal } from "./ForOfStateEventArgs";
var IgrForOfStateEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrForOfStateEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrForOfStateEventArgs.prototype.createImplementation = function () {
        return new ForOfStateEventArgs_internal();
    };
    Object.defineProperty(IgrForOfStateEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrForOfStateEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrForOfStateEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrForOfStateEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrForOfStateDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrForOfStateEventArgs;
}());
export { IgrForOfStateEventArgs };
