import { __extends } from "tslib";
import { IgrCellType } from "./igr-cell-type";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GridCellEventArgsDetail as GridCellEventArgsDetail_internal } from "./GridCellEventArgsDetail";
var IgrGridCellEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridCellEventArgsDetail, _super);
    function IgrGridCellEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrGridCellEventArgsDetail.prototype.createImplementation = function () {
        return new GridCellEventArgsDetail_internal();
    };
    Object.defineProperty(IgrGridCellEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCellEventArgsDetail.prototype, "cell", {
        get: function () {
            var r = this.i.h;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrCellType();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.h = null : this.i.h = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCellEventArgsDetail.prototype, "event", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridCellEventArgsDetail.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.cell && this.cell.name && this.cell.name == name) {
            return this.cell;
        }
        return null;
    };
    return IgrGridCellEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrGridCellEventArgsDetail };
