import { IgrGridCellEventArgsDetail } from "./igr-grid-cell-event-args-detail";
import { GridCellEventArgs as GridCellEventArgs_internal } from "./GridCellEventArgs";
var IgrGridCellEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridCellEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridCellEventArgs.prototype.createImplementation = function () {
        return new GridCellEventArgs_internal();
    };
    Object.defineProperty(IgrGridCellEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridCellEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridCellEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridCellEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrGridCellEventArgsDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridCellEventArgs;
}());
export { IgrGridCellEventArgs };
