import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { DataGridColumn as DataGridColumn_internal } from './DataGridColumn';
import { IgrDataGridColumn as IgrDataGridColumn } from './igr-data-grid-column';
var IgrGridColumnCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridColumnCollection, _super);
    function IgrGridColumnCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrDataGridColumn.$type) {
            IgrDataGridColumn.$type = markType(IgrDataGridColumn, "IgrDataGridColumn");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrGridColumnCollection.prototype._createInnerColl = function () {
        if (!IgrDataGridColumn.$type) {
            IgrDataGridColumn.$type = markType(IgrDataGridColumn, "IgrDataGridColumn");
        }
        var coll = new SyncableObservableCollection$2(IgrDataGridColumn.$type, DataGridColumn_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrDataGridColumn._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrGridColumnCollection;
}(IgCollection));
export { IgrGridColumnCollection };
