/**
 * Event arguments for the DataCommitted event.
*/
var IgrGridDataCommittedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridDataCommittedEventArgs() {
        this.mounted = false;
    }
    Object.defineProperty(IgrGridDataCommittedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridDataCommittedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridDataCommittedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridDataCommittedEventArgs.prototype, "commitID", {
        /**
         * Gets the ID for this commit.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridDataCommittedEventArgs.prototype, "changes", {
        /**
         * Gets a list of the changes that were committed.
        */
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.a = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridDataCommittedEventArgs;
}());
export { IgrGridDataCommittedEventArgs };
