import { GridFilterDialogViewModelGrouping as GridFilterDialogViewModelGrouping_internal } from "./GridFilterDialogViewModelGrouping";
import { ensureBool } from "igniteui-react-core";
var IgrGridFilterDialogViewModelGrouping = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridFilterDialogViewModelGrouping() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridFilterDialogViewModelGrouping.prototype.createImplementation = function () {
        return new GridFilterDialogViewModelGrouping_internal();
    };
    Object.defineProperty(IgrGridFilterDialogViewModelGrouping.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridFilterDialogViewModelGrouping.prototype.onImplementationCreated = function () {
    };
    IgrGridFilterDialogViewModelGrouping.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridFilterDialogViewModelGrouping.prototype, "startIndex", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridFilterDialogViewModelGrouping.prototype, "endIndex", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridFilterDialogViewModelGrouping.prototype, "isOrGrouping", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrGridFilterDialogViewModelGrouping.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrGridFilterDialogViewModelGrouping;
}());
export { IgrGridFilterDialogViewModelGrouping };
