import { IgrColumnGroupDescriptionCollection } from "./igr-column-group-description-collection";
import { GridGroupDescriptionsChangedEventArgs as GridGroupDescriptionsChangedEventArgs_internal } from "./GridGroupDescriptionsChangedEventArgs";
/**
 * Information about the current grouping applied to the grid.
*/
var IgrGridGroupDescriptionsChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridGroupDescriptionsChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridGroupDescriptionsChangedEventArgs.prototype.createImplementation = function () {
        return new GridGroupDescriptionsChangedEventArgs_internal();
    };
    Object.defineProperty(IgrGridGroupDescriptionsChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridGroupDescriptionsChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridGroupDescriptionsChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridGroupDescriptionsChangedEventArgs.prototype, "groupDescriptions", {
        get: function () {
            var r = this.i.groupDescriptions;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrColumnGroupDescriptionCollection();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.groupDescriptions = null : this.i.groupDescriptions = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridGroupDescriptionsChangedEventArgs;
}());
export { IgrGridGroupDescriptionsChangedEventArgs };
