import { GridRowEditActionsTemplateContext as GridRowEditActionsTemplateContext_internal } from "./GridRowEditActionsTemplateContext";
var IgrGridRowEditActionsTemplateContext = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridRowEditActionsTemplateContext() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridRowEditActionsTemplateContext.prototype.createImplementation = function () {
        return new GridRowEditActionsTemplateContext_internal();
    };
    Object.defineProperty(IgrGridRowEditActionsTemplateContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridRowEditActionsTemplateContext.prototype.onImplementationCreated = function () {
    };
    IgrGridRowEditActionsTemplateContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridRowEditActionsTemplateContext.prototype, "implicit", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridRowEditActionsTemplateContext.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrGridRowEditActionsTemplateContext.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridRowEditActionsTemplateContext;
}());
export { IgrGridRowEditActionsTemplateContext };
