import { GridRowEditStartedEventArgs as GridRowEditStartedEventArgs_internal } from "./GridRowEditStartedEventArgs";
var IgrGridRowEditStartedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridRowEditStartedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridRowEditStartedEventArgs.prototype.createImplementation = function () {
        return new GridRowEditStartedEventArgs_internal();
    };
    Object.defineProperty(IgrGridRowEditStartedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridRowEditStartedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridRowEditStartedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridRowEditStartedEventArgs.prototype, "row", {
        /**
         * Gets the row that started editing.
        */
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridRowEditStartedEventArgs.prototype, "item", {
        /**
         * Gets the row item.
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridRowEditStartedEventArgs;
}());
export { IgrGridRowEditStartedEventArgs };
