import { GridRowEditTextTemplateContext as GridRowEditTextTemplateContext_internal } from "./GridRowEditTextTemplateContext";
var IgrGridRowEditTextTemplateContext = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridRowEditTextTemplateContext() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridRowEditTextTemplateContext.prototype.createImplementation = function () {
        return new GridRowEditTextTemplateContext_internal();
    };
    Object.defineProperty(IgrGridRowEditTextTemplateContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridRowEditTextTemplateContext.prototype.onImplementationCreated = function () {
    };
    IgrGridRowEditTextTemplateContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridRowEditTextTemplateContext.prototype, "implicit", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridRowEditTextTemplateContext.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrGridRowEditTextTemplateContext.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridRowEditTextTemplateContext;
}());
export { IgrGridRowEditTextTemplateContext };
