import { GridSelectionChangedEventArgs as GridSelectionChangedEventArgs_internal } from "./GridSelectionChangedEventArgs";
/**
 * Event arguments for the SelectionChanged event.
*/
var IgrGridSelectionChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridSelectionChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridSelectionChangedEventArgs.prototype.createImplementation = function () {
        return new GridSelectionChangedEventArgs_internal();
    };
    Object.defineProperty(IgrGridSelectionChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridSelectionChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridSelectionChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    return IgrGridSelectionChangedEventArgs;
}());
export { IgrGridSelectionChangedEventArgs };
