import { IgrGridState } from "./igr-grid-state";
import { GridStateComponentEventArgs as GridStateComponentEventArgs_internal } from "./GridStateComponentEventArgs";
var IgrGridStateComponentEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridStateComponentEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridStateComponentEventArgs.prototype.createImplementation = function () {
        return new GridStateComponentEventArgs_internal();
    };
    Object.defineProperty(IgrGridStateComponentEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridStateComponentEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridStateComponentEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridStateComponentEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrGridState._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridStateComponentEventArgs;
}());
export { IgrGridStateComponentEventArgs };
