import { GridStateInfoEventArgs as GridStateInfoEventArgs_internal } from "./GridStateInfoEventArgs";
import { interfaceToInternal } from "igniteui-react-core";
import { GridStateInfo } from "./GridStateInfo";
var IgrGridStateInfoEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridStateInfoEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridStateInfoEventArgs.prototype.createImplementation = function () {
        return new GridStateInfoEventArgs_internal();
    };
    Object.defineProperty(IgrGridStateInfoEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridStateInfoEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridStateInfoEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridStateInfoEventArgs.prototype, "detail", {
        get: function () {
            return this.i.a.nativeElement;
        },
        set: function (v) {
            this.i.a = interfaceToInternal(v, function () { return new GridStateInfo(); });
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridStateInfoEventArgs;
}());
export { IgrGridStateInfoEventArgs };
