import { GridToolbarExportEventArgs as GridToolbarExportEventArgs_internal } from "./GridToolbarExportEventArgs";
import { interfaceToInternal } from "igniteui-react-core";
import { GridToolbarExportEventArgsDetail } from "./GridToolbarExportEventArgsDetail";
var IgrGridToolbarExportEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridToolbarExportEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridToolbarExportEventArgs.prototype.createImplementation = function () {
        return new GridToolbarExportEventArgs_internal();
    };
    Object.defineProperty(IgrGridToolbarExportEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridToolbarExportEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridToolbarExportEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridToolbarExportEventArgs.prototype, "detail", {
        get: function () {
            return this.i.b.nativeElement;
        },
        set: function (v) {
            this.i.b = interfaceToInternal(v, function () { return new GridToolbarExportEventArgsDetail(); });
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridToolbarExportEventArgs;
}());
export { IgrGridToolbarExportEventArgs };
