import { IgrGroupByRecord } from "./igr-group-by-record";
import { GroupByRowSelectorTemplateDetails as GroupByRowSelectorTemplateDetails_internal } from "./GroupByRowSelectorTemplateDetails";
var IgrGroupByRowSelectorTemplateDetails = /** @class */ /*@__PURE__*/ (function () {
    function IgrGroupByRowSelectorTemplateDetails() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGroupByRowSelectorTemplateDetails.prototype.createImplementation = function () {
        return new GroupByRowSelectorTemplateDetails_internal();
    };
    Object.defineProperty(IgrGroupByRowSelectorTemplateDetails.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGroupByRowSelectorTemplateDetails.prototype.onImplementationCreated = function () {
    };
    IgrGroupByRowSelectorTemplateDetails.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGroupByRowSelectorTemplateDetails.prototype, "selectedCount", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGroupByRowSelectorTemplateDetails.prototype, "totalCount", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGroupByRowSelectorTemplateDetails.prototype, "groupRow", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrGroupByRecord();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrGroupByRowSelectorTemplateDetails.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.groupRow && this.groupRow.name && this.groupRow.name == name) {
            return this.groupRow;
        }
        return null;
    };
    IgrGroupByRowSelectorTemplateDetails.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGroupByRowSelectorTemplateDetails;
}());
export { IgrGroupByRowSelectorTemplateDetails };
