import { GroupingExpressionEventArgs as GroupingExpressionEventArgs_internal } from "./GroupingExpressionEventArgs";
var IgrGroupingExpressionEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGroupingExpressionEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGroupingExpressionEventArgs.prototype.createImplementation = function () {
        return new GroupingExpressionEventArgs_internal();
    };
    Object.defineProperty(IgrGroupingExpressionEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGroupingExpressionEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGroupingExpressionEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGroupingExpressionEventArgs.prototype, "detail", {
        get: function () {
            if (!this.i.a) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.a.length; i++) {
                var impl = this.i.a[i];
                ret.push(impl.nativeElement);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i]);
            }
            this.i.a = arr;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGroupingExpressionEventArgs;
}());
export { IgrGroupingExpressionEventArgs };
