import { __extends } from "tslib";
import { IgrFilteringOperand } from "./igr-filtering-operand";
import { NumberFilteringOperand as NumberFilteringOperand_internal } from "./NumberFilteringOperand";
/**
 * Provides filtering operations for numbers
 * @export
*/
var IgrNumberFilteringOperand = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrNumberFilteringOperand, _super);
    function IgrNumberFilteringOperand() {
        return _super.call(this) || this;
    }
    IgrNumberFilteringOperand.prototype.createImplementation = function () {
        var impl = new NumberFilteringOperand_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    };
    Object.defineProperty(IgrNumberFilteringOperand.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    return IgrNumberFilteringOperand;
}(IgrFilteringOperand));
export { IgrNumberFilteringOperand };
