import { OverlayOutletDirective as OverlayOutletDirective_internal } from "./OverlayOutletDirective";
var IgrOverlayOutletDirective = /** @class */ /*@__PURE__*/ (function () {
    function IgrOverlayOutletDirective() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrOverlayOutletDirective.prototype.createImplementation = function () {
        return new OverlayOutletDirective_internal();
    };
    Object.defineProperty(IgrOverlayOutletDirective.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrOverlayOutletDirective.prototype.onImplementationCreated = function () {
    };
    IgrOverlayOutletDirective.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrOverlayOutletDirective.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrOverlayOutletDirective.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrOverlayOutletDirective;
}());
export { IgrOverlayOutletDirective };
