import { IgrPinRowEventArgsDetail } from "./igr-pin-row-event-args-detail";
import { PinRowEventArgs as PinRowEventArgs_internal } from "./PinRowEventArgs";
/**
 * Event emitted when a row's pin state changes.
*/
var IgrPinRowEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrPinRowEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPinRowEventArgs.prototype.createImplementation = function () {
        return new PinRowEventArgs_internal();
    };
    Object.defineProperty(IgrPinRowEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPinRowEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrPinRowEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPinRowEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrPinRowEventArgsDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrPinRowEventArgs;
}());
export { IgrPinRowEventArgs };
