import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { PivotValue as PivotValue_internal } from './PivotValue';
import { IgrPivotValue as IgrPivotValue } from './igr-pivot-value';
var IgrPivotValueCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPivotValueCollection, _super);
    function IgrPivotValueCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrPivotValue.$type) {
            IgrPivotValue.$type = markType(IgrPivotValue, "IgrPivotValue");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrPivotValueCollection.prototype._createInnerColl = function () {
        if (!IgrPivotValue.$type) {
            IgrPivotValue.$type = markType(IgrPivotValue, "IgrPivotValue");
        }
        var coll = new SyncableObservableCollection$2(IgrPivotValue.$type, PivotValue_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrPivotValue();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrPivotValueCollection;
}(IgCollection));
export { IgrPivotValueCollection };
