import { IgrPivotValueDetail } from "./igr-pivot-value-detail";
import { PivotValueEventArgs as PivotValueEventArgs_internal } from "./PivotValueEventArgs";
var IgrPivotValueEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrPivotValueEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPivotValueEventArgs.prototype.createImplementation = function () {
        return new PivotValueEventArgs_internal();
    };
    Object.defineProperty(IgrPivotValueEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPivotValueEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrPivotValueEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPivotValueEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrPivotValueDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrPivotValueEventArgs;
}());
export { IgrPivotValueEventArgs };
