import { IgrRowType } from "./igr-row-type";
import { RowDragStartEventArgsDetail as RowDragStartEventArgsDetail_internal } from "./RowDragStartEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
var IgrRowDragStartEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrRowDragStartEventArgsDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrRowDragStartEventArgsDetail.prototype.createImplementation = function () {
        return new RowDragStartEventArgsDetail_internal();
    };
    Object.defineProperty(IgrRowDragStartEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrRowDragStartEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrRowDragStartEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrRowDragStartEventArgsDetail.prototype, "dragDirective", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowDragStartEventArgsDetail.prototype, "dragData", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrRowType();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowDragStartEventArgsDetail.prototype, "cancel", {
        /**
         * Provides the ability to cancel the event.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowDragStartEventArgsDetail.prototype, "owner", {
        /**
         * Provides reference to the owner component.
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrRowDragStartEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.dragData && this.dragData.name && this.dragData.name == name) {
            return this.dragData;
        }
        return null;
    };
    IgrRowDragStartEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrRowDragStartEventArgsDetail;
}());
export { IgrRowDragStartEventArgsDetail };
