import { __extends } from "tslib";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { RowExportingEventArgsDetail as RowExportingEventArgsDetail_internal } from "./RowExportingEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
/**
 * rowExporting event arguments
 * this.exporterService.rowExporting.subscribe((args: IRowExportingEventArgs) => {
 * // set args properties here
 * })
*/
var IgrRowExportingEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRowExportingEventArgsDetail, _super);
    function IgrRowExportingEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrRowExportingEventArgsDetail.prototype.createImplementation = function () {
        return new RowExportingEventArgsDetail_internal();
    };
    Object.defineProperty(IgrRowExportingEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowExportingEventArgsDetail.prototype, "rowData", {
        /**
         * Contains the exporting row data
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowExportingEventArgsDetail.prototype, "rowIndex", {
        /**
         * Contains the exporting row index
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowExportingEventArgsDetail.prototype, "cancel", {
        /**
         * Skip the exporting row when set to true
        */
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrRowExportingEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrRowExportingEventArgsDetail };
