import { RowSelectorTemplateDetails as RowSelectorTemplateDetails_internal } from "./RowSelectorTemplateDetails";
import { ensureBool } from "igniteui-react-core";
var IgrRowSelectorTemplateDetails = /** @class */ /*@__PURE__*/ (function () {
    function IgrRowSelectorTemplateDetails() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrRowSelectorTemplateDetails.prototype.createImplementation = function () {
        return new RowSelectorTemplateDetails_internal();
    };
    Object.defineProperty(IgrRowSelectorTemplateDetails.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrRowSelectorTemplateDetails.prototype.onImplementationCreated = function () {
    };
    IgrRowSelectorTemplateDetails.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrRowSelectorTemplateDetails.prototype, "index", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowSelectorTemplateDetails.prototype, "rowID", {
        /**
         * @deprecated Use the `key` property instead.
         * @deprecated Use the `key` property instead.
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowSelectorTemplateDetails.prototype, "key", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrRowSelectorTemplateDetails.prototype, "selected", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrRowSelectorTemplateDetails.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrRowSelectorTemplateDetails.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    IgrRowSelectorTemplateDetails.prototype.select = function () {
        this.i.j();
    };
    IgrRowSelectorTemplateDetails.prototype.deselect = function () {
        this.i.i();
    };
    return IgrRowSelectorTemplateDetails;
}());
export { IgrRowSelectorTemplateDetails };
