import { SortingEventArgsDetail as SortingEventArgsDetail_internal } from "./SortingEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
var IgrSortingEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrSortingEventArgsDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrSortingEventArgsDetail.prototype.createImplementation = function () {
        return new SortingEventArgsDetail_internal();
    };
    Object.defineProperty(IgrSortingEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrSortingEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrSortingEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrSortingEventArgsDetail.prototype, "sortingExpressions", {
        get: function () {
            if (!this.i.b) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.b.length; i++) {
                var impl = this.i.b[i];
                ret.push(impl.nativeElement);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i]);
            }
            this.i.b = arr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSortingEventArgsDetail.prototype, "groupingExpressions", {
        get: function () {
            if (!this.i.a) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.a.length; i++) {
                var impl = this.i.a[i];
                ret.push(impl.nativeElement);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i]);
            }
            this.i.a = arr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSortingEventArgsDetail.prototype, "owner", {
        /**
         * Provides reference to the owner component.
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSortingEventArgsDetail.prototype, "cancel", {
        /**
         * Provides the ability to cancel the event.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrSortingEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrSortingEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrSortingEventArgsDetail;
}());
export { IgrSortingEventArgsDetail };
