import { __extends } from "tslib";
import { IgrCellInfo } from "./igr-cell-info";
import { TextCellModel as TextCellModel_internal } from "./TextCellModel";
/**
 * Backing information for a text cell in the grid.
*/
var IgrTextCellInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTextCellInfo, _super);
    function IgrTextCellInfo() {
        return _super.call(this) || this;
    }
    IgrTextCellInfo.prototype.createImplementation = function () {
        return new TextCellModel_internal();
    };
    Object.defineProperty(IgrTextCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTextCellInfo.prototype, "textValue", {
        /**
         * Sets or gets the text value for the cell.
        */
        get: function () {
            return this.i.ll;
        },
        set: function (v) {
            this.i.ll = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrTextCellInfo;
}(IgrCellInfo));
export { IgrTextCellInfo };
