import { TransactionService as TransactionService_internal } from "./TransactionService";
var IgrTransactionService = /** @class */ /*@__PURE__*/ (function () {
    function IgrTransactionService() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrTransactionService.prototype.createImplementation = function () {
        return new TransactionService_internal();
    };
    Object.defineProperty(IgrTransactionService.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrTransactionService.prototype.onImplementationCreated = function () {
    };
    IgrTransactionService.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrTransactionService.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrTransactionService;
}());
export { IgrTransactionService };
