import { ValidationErrors as ValidationErrors_internal } from "./ValidationErrors";
var IgrValidationErrors = /** @class */ /*@__PURE__*/ (function () {
    function IgrValidationErrors() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrValidationErrors.prototype.createImplementation = function () {
        return new ValidationErrors_internal();
    };
    Object.defineProperty(IgrValidationErrors.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrValidationErrors.prototype.onImplementationCreated = function () {
    };
    IgrValidationErrors.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrValidationErrors.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrValidationErrors.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrValidationErrors;
}());
export { IgrValidationErrors };
