
    export declare type Constructor<T = {}> = new (...args: any[]) => T;

    export declare type AbstractConstructor<T = {}> = abstract new (...args: any[]) => T;
    
    export declare class LitElement extends HTMLElement {
    
    }
    export declare function EventEmitterMixin<E, T extends AbstractConstructor<LitElement>>(
        superClass: T
    ): T;
    export declare function EventEmitterMixin<E, T extends Constructor<LitElement>>(
        superClass: T
    ): T;
    
    export declare class TemplateContent {
        
    }

    /* blazorSuppress */
    export declare type IgcRenderFunction<T> = (context: T) => TemplateContent;
    
    export declare class Point {
        constructor(x: number, y: number);
        public x: number;
        public y: number;
    }
    