
import { IgcColumnGroupComponent } from './igc-column-group-component';




/* blazorIndirectRender */
/* blazorElement */
/* omitModule */
/* wcElementTag: igc-column-layout */
/* additionalIdentifier: Children.Field */
/* jsonAPIManageCollectionInMarkup */
/**
 * Column layout for declaration of Multi-row Layout
 *
 * @igxParent IgxGridComponent
 */

    export declare class IgcColumnLayoutComponent extends IgcColumnGroupComponent
    {

                

    /**
     * Gets the column visible index.
     * If the column is not visible, returns `-1`.
     * ```typescript
     * let visibleColumnIndex =  this.column.visibleIndex;
     * ```
     *
     * @memberof IgxColumnComponent
     */
    public get visibleIndex(): number;
        
    }


        