
import { IgcGroupByRecord } from './igc-group-by-record';
import { IgcGridValidationState } from './igc-grid-validation-state';
import { IgcCellType } from './igc-cell-type';
                import { IgcTreeGridRecord } from './igc-tree-grid-record';
import { IgcGridBaseDirective } from './igc-grid-base-directive';


/* jsonAPIPlainObject */


/* jsonAPIComplexValue */
/* marshalByValue */

    export declare class IgcRowType
    {

          
    public set index(value: number);
          public get index(): number;
  
          
    public set viewIndex(value: number);
          public get viewIndex(): number;
  
          
    public isGroupByRow?: boolean;
  
          
    public isSummaryRow?: boolean;
  
          
    public groupRow?: IgcGroupByRecord;
  
          
    public key?: any;
  
          
    public validation?: IgcGridValidationState;
  
          
    public data?: any;
  
          
    public cells?: IgcCellType[];
  
          
    public disabled?: boolean;
  
          
    public pinned?: boolean;
  
          
    public selected?: boolean;
  
          
    public expanded?: boolean;
  
          
    public deleted?: boolean;
  
          
    public inEditMode?: boolean;
  
          
    public children?: IgcRowType[];
  
          
    /* blazorAlternateName: RowParent */
    public parent?: IgcRowType;
  
          
    public hasChildren?: boolean;
  
          
    public treeRow?: IgcTreeGridRecord;
  
          
    public addRowUI?: boolean;
  
          
    public focused?: boolean;
  
          
    public set grid(value: IgcGridBaseDirective);
          public get grid(): IgcGridBaseDirective;
  
            
    public update?(value: any): void;

            
    public delete?(): any;

            
    public pin?(): void;

            
    public unpin?(): void;

    }


        