import { Base, Type } from "igniteui-react-core";
import { INativeCell } from "./INativeCell";
import { DomRenderer, NormalizedEvent } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { CellContentHorizontalAlignment } from "./CellContentHorizontalAlignment";
import { TextBlock } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { CellContentVerticalAlignment } from "./CellContentVerticalAlignment";
import { Brush } from "igniteui-react-core";
import { CellModel } from "./CellModel";
import { ICellActionManager } from "./ICellActionManager";
/**
 * @hidden
 */
export declare class CanvasGridCellBase extends Base implements INativeCell {
    static $t: Type;
    private a;
    private s;
    private o;
    protected get aa(): boolean;
    protected set aa(a: boolean);
    cm(a: () => void): void;
    private k;
    protected b7(): void;
    get isCanvasBased(): boolean;
    private bm;
    get bn(): DomRenderer;
    private q;
    get isRemoved(): boolean;
    set isRemoved(a: boolean);
    private b0;
    co(a: string): void;
    constructor(a: DomRenderer);
    get templateContext(): any;
    private l;
    get w(): boolean;
    set w(a: boolean);
    protected get_ac(): boolean;
    get ac(): boolean;
    ce(a: Brush, b: number, c: number, d: number, e: number): void;
    private aq;
    cf(a: number): void;
    private au;
    get bc(): number;
    private aw;
    get be(): number;
    private av;
    get bd(): number;
    private at;
    get bb(): number;
    private cy;
    private ai;
    get a7(): number;
    private ak;
    get a9(): number;
    private aj;
    get a8(): number;
    private ah;
    get a6(): number;
    private c6;
    private c2;
    private c5;
    private c3;
    private c1;
    private c4;
    private a0;
    protected get bg(): number;
    private a2;
    protected get bi(): number;
    private a3;
    private a4;
    protected get bj(): number;
    private bo;
    private j;
    private am;
    private al;
    private ao;
    private an;
    protected get_ad(): boolean;
    protected get ad(): boolean;
    b3(a: RenderingContext, b: number, c: number, d: number, e: number, f: number): void;
    get resized(): boolean;
    private u;
    ensureCorrectSize(): boolean;
    protected b4(a: RenderingContext, b: number, c: number, d: number, e: number, f: number, g: boolean, h: boolean, i: boolean): void;
    bu(): any;
    b8(a: RenderingContext): void;
    cl(a: number): void;
    renderStandardContent(): void;
    renderStandardBackground(): void;
    protected b9(a: RenderingContext): void;
    private v;
    protected b5(): void;
    private x;
    private bf;
    ck(a: number, b: number, c: number, d: number): void;
    private a1;
    get bh(): number;
    set bh(a: number);
    private cx;
    private c0;
    cp(a: Color): void;
    protected get_ab(): boolean;
    get ab(): boolean;
    private t;
    get ae(): boolean;
    set ae(a: boolean);
    private as;
    get ba(): number;
    private a5;
    get bl(): number;
    ch(a: number): void;
    cr(a: number): void;
    b2(): void;
    private cz;
    private m;
    cd(a: Color): void;
    private g;
    private c;
    private e;
    private bz;
    cj(a: number): void;
    private r;
    cn(a: boolean): void;
    private az;
    private ay;
    private static bw;
    cv(a: number): void;
    b6(a: number, b: number, c: number, d: number): void;
    private i;
    private p;
    private br;
    cg(a: FontInfo): void;
    cu(a: CellModel): void;
    cs(a: CellContentHorizontalAlignment, b: CellContentVerticalAlignment): void;
    ct(a: Brush): void;
    cc(a: ICellActionManager): void;
    private bx;
    private by;
    private n;
    private bp;
    private static bs;
    private b;
    protected get d(): CellContentHorizontalAlignment;
    ci(a: CellContentHorizontalAlignment): void;
    private ar;
    private h;
    private bt;
    private cw;
    private ap;
    protected bk(a: TextBlock, b: string, c: number, d: RenderingContext): number;
    private f;
    cq(a: CellContentVerticalAlignment): void;
    protected ag(a: ICellActionManager): boolean;
    private static bq;
    private ax;
    onContactStarted(a: NormalizedEvent, b: boolean): void;
    onContactMoved(a: NormalizedEvent, b: boolean): void;
    onContactCompleted(a: NormalizedEvent, b: boolean): void;
    onDoubleClick(a: NormalizedEvent): void;
    detach(): void;
}
