import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { EventArgs, Type } from "igniteui-react-core";
import { KeyEventArgs } from "igniteui-react-core";
import { InputChangeEventArgs } from "igniteui-react-inputs";
/**
 * @hidden
 */
export interface ComboEditorView_ComboExternal {
    labelVisible: boolean;
    columnHeadersVisible: boolean;
    rowSeparatorsVisible: boolean;
    height: string;
    defaultColumnWidth: string;
    textField: string;
    text: string;
    textStyle: string;
    textColor: string;
    valueField: string[];
    fields: string[];
    density: ControlDisplayDensity;
    baseTheme: BaseControlTheme;
    i: any;
    dataSource: any;
    value: any;
    closeUp(): void;
    focus(a: boolean): void;
    select(): void;
    selectedValueChanged: (sender: any, args: any) => void;
    textValueChanged: (sender: any, args: any) => void;
    gotFocus: (args: EventArgs) => void;
    lostFocus: (args: EventArgs) => void;
    keyDown: (sender: any, args: KeyEventArgs) => void;
    changing: (sender: any, args: InputChangeEventArgs) => void;
}
/**
 * @hidden
 */
export declare let ComboEditorView_ComboExternal_$type: Type;
