import { Type } from "igniteui-react-core";
/**
 * Indicates how filters will treat case sensitivity.
 */
export declare enum FilterComparisonType {
    /**
     * The default case sensitivity. Default is CaseInsensitive.
     */
    Default = 0,
    /**
     * Filtering is performed without case sensitivity.
     */
    CaseInsensitive = 1,
    /**
     * Filtering is performed with case sensitivity.
     */
    CaseSensitive = 2
}
/**
 * @hidden
 */
export declare let FilterComparisonType_$type: Type;
