import { Type } from "igniteui-react-core";
/**
 * Indicates how filters across fields are combined.
 */
export declare enum FilterLogicalOperator {
    /**
     * The filters applied through the filter UI across multiple fields are AND'ed together.
     */
    And = 0,
    /**
     * The filters applied through the filter UI across multiple fields are OR'ed together.
     */
    Or = 1
}
/**
 * @hidden
 */
export declare let FilterLogicalOperator_$type: Type;
