import { Base, Type } from "igniteui-react-core";
import { INativeCell } from "./INativeCell";
import { ICellActionManager } from "./ICellActionManager";
import { IGridInfoRequestor } from "./IGridInfoRequestor";
import { ICellModelExportUpdater } from "./ICellModelExportUpdater";
import { DomRenderer, DomWrapper, NormalizedEvent } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { CellContentHorizontalAlignment } from "./CellContentHorizontalAlignment";
import { CellContentVerticalAlignment } from "./CellContentVerticalAlignment";
import { Color } from "igniteui-react-core";
import { CellModel } from "./CellModel";
/**
 * @hidden
 */
export declare class GridCellBase extends Base implements INativeCell {
    static $t: Type;
    private a;
    protected get b(): ICellActionManager;
    private e;
    protected get f(): IGridInfoRequestor;
    private c;
    protected get d(): ICellModelExportUpdater;
    private aa;
    get ab(): DomRenderer;
    private ac;
    get ae(): DomWrapper;
    private p;
    get isRemoved(): boolean;
    set isRemoved(a: boolean);
    private ad;
    private i;
    private ap;
    private am;
    private ao;
    private an;
    protected get a2(): number;
    protected get a0(): number;
    protected get a1(): number;
    private as;
    get a3(): number;
    set a3(a: number);
    private m;
    get s(): boolean;
    set s(a: boolean);
    private n;
    get t(): boolean;
    set t(a: boolean);
    private o;
    get v(): boolean;
    set v(a: boolean);
    constructor(a: DomRenderer);
    private bf;
    bv(): void;
    private k;
    get r(): boolean;
    set r(a: boolean);
    protected get_w(): boolean;
    get w(): boolean;
    private au;
    private aw;
    private av;
    private at;
    b4(a: number, b: number, c: number, d: number): void;
    private ah;
    private aj;
    private ai;
    private ag;
    private cg;
    by(a: Brush, b: number, c: number, d: number, e: number): void;
    protected get_u(): boolean;
    get u(): boolean;
    private aq;
    private az;
    private ar;
    b0(a: number, b: number): void;
    b6(a: number, b: number): void;
    protected b7(a: number, b: number, c: number, d: number): void;
    bd(): void;
    bx(a: Color): void;
    private j;
    private g;
    private h;
    b3(a: number): void;
    private z;
    private y;
    private static a4;
    cf(a: number): void;
    cd(a: number, b: number, c: number, d: number): void;
    bn(a: DomWrapper, b: DomWrapper, c: CellContentHorizontalAlignment): void;
    ce(a: CellModel): void;
    private q;
    cb(a: CellContentHorizontalAlignment, b: CellContentVerticalAlignment): void;
    cc(a: Brush): void;
    bw(a: ICellActionManager): void;
    b2(a: IGridInfoRequestor): void;
    bz(a: ICellModelExportUpdater): void;
    private a5;
    private a6;
    private af;
    private static ax;
    private static al;
    private ay;
    protected b1(a: DomWrapper, b: CellContentHorizontalAlignment): void;
    protected b5(a: DomWrapper, b: CellContentVerticalAlignment): void;
    protected x(a: ICellActionManager): boolean;
    private bg;
    private bk;
    private bj;
    private bi;
    private bh;
    private bq;
    private bt;
    private bu;
    private bs;
    private br;
    private b8;
    private b9;
    private ca;
    onContactStarted(e_: NormalizedEvent, a: boolean): void;
    onContactMoved(a: NormalizedEvent, b: boolean): void;
    private ak;
    onContactCompleted(e_: NormalizedEvent, a: boolean): void;
    bm(a: NormalizedEvent, b: boolean): void;
    bl(a: NormalizedEvent, b: boolean): void;
    onDoubleClick(a: NormalizedEvent): void;
    private l;
    protected bp(a: string, b: any, c: any): void;
    bo(): void;
    be(): void;
    bc(): void;
    detach(): void;
}
