import { GridStateBaseDirective } from "./GridStateBaseDirective";
import { Base, Type } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { ColumnState } from "./ColumnState";
import { FilteringExpressionsTree } from "./FilteringExpressionsTree";
import { PagingState } from "./PagingState";
import { SortingExpression } from "./SortingExpression";
import { GroupingState } from "./GroupingState";
import { GridSelectionRange } from "./GridSelectionRange";
import { PinningConfig } from "./PinningConfig";
import { PivotConfiguration } from "./PivotConfiguration";
/**
 * @hidden
 */
export declare class GridState extends GridStateBaseDirective {
    static $t: Type;
    stateParsed: (sender: any, args: GridStateInfoEventArgs) => void;
    stateParsedChanged(): void;
    k(a: GridStateInfo, b: string[]): void;
    l(a: string, b: string[]): void;
    h(a: string[]): GridStateInfo;
    j(a: string[]): string;
}
/**
 * @hidden
 */
export declare class GridStateCollection extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private d;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get g(): string;
    set g(a: string);
    get f(): any;
    set f(a: any);
    get a(): GridState;
    set a(a: GridState);
}
/**
 * @hidden
 */
export declare class GridStateInfo extends Base {
    static $t: Type;
    private o;
    protected get p(): WCNativeHelper;
    private r;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get b(): ColumnState[];
    set b(a: ColumnState[]);
    get j(): FilteringExpressionsTree;
    set j(a: FilteringExpressionsTree);
    get i(): FilteringExpressionsTree;
    set i(a: FilteringExpressionsTree);
    get l(): PagingState;
    set l(a: PagingState);
    get q(): boolean;
    set q(a: boolean);
    get h(): SortingExpression[];
    set h(a: SortingExpression[]);
    get k(): GroupingState;
    set k(a: GroupingState);
    get a(): GridSelectionRange[];
    set a(a: GridSelectionRange[]);
    get g(): any[];
    set g(a: any[]);
    get c(): string[];
    set c(a: string[]);
    get f(): any[];
    set f(a: any[]);
    get m(): PinningConfig;
    set m(a: PinningConfig);
    get d(): any[];
    set d(a: any[]);
    get e(): GridStateCollection[];
    set e(a: GridStateCollection[]);
    get t(): string;
    set t(a: string);
    get n(): PivotConfiguration;
    set n(a: PivotConfiguration);
}
/**
 * @hidden
 */
export declare class GridStateInfoEventArgs extends Base {
    static $t: Type;
    a: GridStateInfo;
    static b(a: any): GridStateInfoEventArgs;
}
