import { Type } from "igniteui-react-core";
/**
 * The Different LayoutActions
 */
export declare enum LayoutAction {
    /**
     * Sorted
     */
    Sorted = 0,
    /**
     * Resized
     */
    Resized = 1,
    /**
     * Hidden
     */
    Hidden = 2,
    /**
     * Pinned
     */
    Pinned = 3,
    /**
     * Moved
     */
    Moved = 4,
    /**
     * Filtered
     */
    Filtered = 5,
    /**
     * Grouped
     */
    Grouped = 6,
    /**
     * Summed
     */
    Summed = 7
}
/**
 * @hidden
 */
export declare let LayoutAction_$type: Type;
