import { Header } from "./Header";
import { CellModel } from "./CellModel";
import { CellPath } from "./CellPath";
import { TemplateHeaderCellModel } from "./TemplateHeaderCellModel";
import { DataGrid } from "./DataGrid";
import { Type } from "igniteui-react-core";
import { TemplateHeaderCellUpdatingEventArgs } from "./TemplateHeaderCellUpdatingEventArgs";
/**
 * @hidden
 */
export declare class TemplateHeader extends Header {
    static $t: Type;
    constructor();
    protected l(a: CellPath): CellModel;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    fe(a: TemplateHeaderCellModel, b: any): void;
    cellUpdating: (sender: any, args: TemplateHeaderCellUpdatingEventArgs) => void;
}
