import { GridBaseDirective } from "./GridBaseDirective";
import { Type } from "igniteui-react-core";
import { TreeGridRecord } from "./TreeGridRecord";
import { CellType } from "./CellType";
import { RowType } from "./RowType";
/**
 * @hidden
 */
export declare class TreeGrid extends GridBaseDirective {
    static $t: Type;
    get hc(): string;
    set hc(a: string);
    get hd(): string;
    set hd(a: string);
    get he(): string;
    set he(a: string);
    get g6(): boolean;
    set g6(a: boolean);
    get hf(): string;
    set hf(a: string);
    get g0(): TreeGridRecord[];
    set g0(a: TreeGridRecord[]);
    get gz(): TreeGridRecord[];
    set gz(a: TreeGridRecord[]);
    get gx(): any[];
    set gx(a: any[]);
    get g9(): number;
    set g9(a: number);
    private ha;
    get hb(): (arg: any) => any;
    set hb(a: (arg: any) => any);
    get g1(): CellType[];
    hk(a: TreeGridRecord): void;
    hj(): void;
    hi(): void;
    hg(a: any, b: any): void;
    hh(a: number, b?: boolean): void;
    gy(a?: boolean, b?: boolean): any[];
    g4(a: number): RowType;
    g5(a: any): RowType;
    g2(a: number, b: string): CellType;
    g3(a: any, b: string): CellType;
    g7(a: any, b?: number): boolean;
    g8(a: any): boolean;
}
