import { ColumnExchanger as ColumnExchanger_internal } from "./ColumnExchanger";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Indicates a column that should be exchanged with another.
*/
export declare class IgrColumnExchanger {
    protected createImplementation(): ColumnExchanger_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ColumnExchanger_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The desired location of the new column
    */
    get targetIndex(): number;
    set targetIndex(v: number);
    findByName(name: string): any;
}
