import { IgrDefinitionBase, IIgrDefinitionBaseProps } from "./igr-definition-base";
import { ColumnResizingSeparator } from "./ColumnResizingSeparator";
export declare class IgrColumnResizingSeparator extends IgrDefinitionBase<IIgrColumnResizingSeparatorProps> {
    protected createImplementation(): ColumnResizingSeparator;
    /**
                                 * @hidden
                                 */
    get i(): ColumnResizingSeparator;
    constructor(props: IIgrColumnResizingSeparatorProps);
    get actualOpacity(): number;
    set actualOpacity(v: number);
    get opacity(): number;
    set opacity(v: number);
}
export interface IIgrColumnResizingSeparatorProps extends IIgrDefinitionBaseProps {
    actualOpacity?: number | string;
    opacity?: number | string;
}
