import { IgrColumn } from "./igr-column";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ColumnToggledEventArgsDetail as ColumnToggledEventArgsDetail_internal } from "./ColumnToggledEventArgsDetail";
/**
 * Event emitted when a checkbox in the checkbox
 * list of an IgxColumnActions component is clicked.
*/
export declare class IgrColumnToggledEventArgsDetail extends IgrBaseEventArgsDetail {
    protected createImplementation(): ColumnToggledEventArgsDetail_internal;
    /**
                                 * @hidden
                                 */
    get i(): ColumnToggledEventArgsDetail_internal;
    constructor();
    /**
     * The column that is toggled.
    */
    get column(): IgrColumn;
    set column(v: IgrColumn);
    /**
     * The checked state after the action.
    */
    get checked(): boolean;
    set checked(v: boolean);
    findByName(name: string): any;
}
