import { ColumnVisibilityChangingEventArgsDetail as ColumnVisibilityChangingEventArgsDetail_internal } from "./ColumnVisibilityChangingEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrColumnVisibilityChangingEventArgsDetail {
    protected createImplementation(): ColumnVisibilityChangingEventArgsDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ColumnVisibilityChangingEventArgsDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get column(): any;
    set column(v: any);
    /**
     * The new hidden state that the column will have, if operation is succesfull.
     * Will be `true` when hiding and `false` when showing.
    */
    get newValue(): boolean;
    set newValue(v: boolean);
    /**
     * Provides the ability to cancel the event.
    */
    get cancel(): boolean;
    set cancel(v: boolean);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
