import { PivotDimensionType } from "./PivotDimensionType";
import { IgrPivotDimension } from "./igr-pivot-dimension";
/**
 * Event emitted when dimension collection for rows, columns of filters is changed.
*/
export interface IgrDimensionsChange {
    /**
     * The new list of dimensions.
    */
    dimensions?: IgrPivotDimension[];
    /**
     * The dimension list type - Row, Column or Filter.
    */
    dimensionCollectionType?: PivotDimensionType | string;
}
