import { IgrDefinitionBase, IIgrDefinitionBaseProps } from "./igr-definition-base";
import { EditorDefinition } from "./EditorDefinition";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export declare class IgrEditorDefinition extends IgrDefinitionBase<IIgrEditorDefinitionProps> {
    protected createImplementation(): EditorDefinition;
    /**
                                 * @hidden
                                 */
    get i(): EditorDefinition;
    constructor(props: IIgrEditorDefinitionProps);
}
export interface IIgrEditorDefinitionProps extends IIgrDefinitionBaseProps {
}
