import { IgrBaseExporter } from "./igr-base-exporter";
import { IgrExporterOptionsBase } from "./igr-exporter-options-base";
import { IgrGridBaseDirective } from "./igr-grid-base-directive";
import { ExporterEventArgsDetail as ExporterEventArgsDetail_internal } from "./ExporterEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrExporterEventArgsDetail {
    protected createImplementation(): ExporterEventArgsDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ExporterEventArgsDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get exporter(): IgrBaseExporter;
    set exporter(v: IgrBaseExporter);
    get options(): IgrExporterOptionsBase;
    set options(v: IgrExporterOptionsBase);
    get grid(): IgrGridBaseDirective;
    set grid(v: IgrGridBaseDirective);
    get cancel(): boolean;
    set cancel(v: boolean);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
