import { FormatGroupTextEventArgs as FormatGroupTextEventArgs_internal } from "./FormatGroupTextEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrFormatGroupTextEventArgs {
    protected createImplementation(): FormatGroupTextEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): FormatGroupTextEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the group name.
    */
    get groupName(): string;
    set groupName(v: string);
    /**
     * Gets the original value before formatting.
    */
    get groupValue(): any;
    set groupValue(v: any);
    /**
     * Gets the group value as text, formatted based on the GroupDescription's ValueFormat.
    */
    get formattedValue(): string;
    set formattedValue(v: string);
    /**
     * Gets or sets the final text that will be displayed in the group header.
    */
    get formattedText(): string;
    set formattedText(v: string);
}
