import { IgrDataGridColumn } from "./igr-data-grid-column";
import { GridCellEditStartedEventArgs as GridCellEditStartedEventArgs_internal } from "./GridCellEditStartedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrGridCellEditStartedEventArgs {
    protected createImplementation(): GridCellEditStartedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridCellEditStartedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the column of the cell that started editing.
    */
    get column(): IgrDataGridColumn;
    set column(v: IgrDataGridColumn);
    /**
     * Gets the row index of the cell that started editing.
    */
    get row(): number;
    set row(v: number);
    /**
     * Gets the row item.
    */
    get item(): any;
    set item(v: any);
}
