import { GridColumnButtonOptions } from './GridColumnButtonOptions';
import { IgrGridColumnOptionsSectionBase } from "./igr-grid-column-options-section-base";
import { IIgrGridColumnOptionsSectionBaseProps } from "./igr-grid-column-options-section-base";
import { IgrApplyButtonClickEventArgs } from './igr-apply-button-click-event-args';
import { IgrCancelButtonClickEventArgs } from './igr-cancel-button-click-event-args';
export declare class IgrGridColumnButtonOptions extends IgrGridColumnOptionsSectionBase<IIgrGridColumnOptionsSectionBaseProps> {
    private _mainDiv;
    private _initialized;
    private _elRef;
    private _buttonsSectionRef;
    private _reactRenderer;
    private _getMainRef;
    private _getButtonsSectionRef;
    private verifyReferences;
    render(): JSX.Element;
    constructor(props: IIgrGridColumnButtonOptionsProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): GridColumnButtonOptions;
    get i(): GridColumnButtonOptions;
    get applyButtonCaption(): string;
    set applyButtonCaption(v: string);
    get cancelButtonCaption(): string;
    set cancelButtonCaption(v: string);
    private _applyButtonClick;
    private _applyButtonClick_wrapped;
    get applyButtonClick(): (s: IgrGridColumnButtonOptions, e: IgrApplyButtonClickEventArgs) => void;
    set applyButtonClick(ev: (s: IgrGridColumnButtonOptions, e: IgrApplyButtonClickEventArgs) => void);
    private _cancelButtonClick;
    private _cancelButtonClick_wrapped;
    get cancelButtonClick(): (s: IgrGridColumnButtonOptions, e: IgrCancelButtonClickEventArgs) => void;
    set cancelButtonClick(ev: (s: IgrGridColumnButtonOptions, e: IgrCancelButtonClickEventArgs) => void);
}
export interface IIgrGridColumnButtonOptionsProps extends IIgrGridColumnOptionsSectionBaseProps {
    applyButtonCaption?: string;
    cancelButtonCaption?: string;
    applyButtonClick?: (s: IgrGridColumnButtonOptions, e: IgrApplyButtonClickEventArgs) => void;
    cancelButtonClick?: (s: IgrGridColumnButtonOptions, e: IgrCancelButtonClickEventArgs) => void;
}
