import * as React from 'react';
import { GridColumnPinOptions } from './GridColumnPinOptions';
import { IgrGridColumnOptionsSimpleSectionBase } from "./igr-grid-column-options-simple-section-base";
import { IIgrGridColumnOptionsSimpleSectionBaseProps } from "./igr-grid-column-options-simple-section-base";
export declare class IgrGridColumnPinOptions extends IgrGridColumnOptionsSimpleSectionBase<IIgrGridColumnOptionsSimpleSectionBaseProps> {
    private _mainDiv;
    private _initialized;
    private _elRef;
    private _reactRenderer;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
        children: any[];
    }, any>;
    constructor(props: IIgrGridColumnPinOptionsProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): GridColumnPinOptions;
    get i(): GridColumnPinOptions;
    get pinLeftCaption(): string;
    set pinLeftCaption(v: string);
    get pinRightCaption(): string;
    set pinRightCaption(v: string);
}
export interface IIgrGridColumnPinOptionsProps extends IIgrGridColumnOptionsSimpleSectionBaseProps {
    pinLeftCaption?: string;
    pinRightCaption?: string;
}
