import { IgrDataGridColumn } from "./igr-data-grid-column";
import { IgrColumnWidth } from "./igr-column-width";
import { GridColumnWidthChangedEventArgs as GridColumnWidthChangedEventArgs_internal } from "./GridColumnWidthChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Event arguments for the GridColumnWidthChanged event.
*/
export declare class IgrGridColumnWidthChangedEventArgs {
    protected createImplementation(): GridColumnWidthChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridColumnWidthChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The column whose Width has changed
    */
    get column(): IgrDataGridColumn;
    set column(v: IgrDataGridColumn);
    /**
     * The old column width.
    */
    get oldWidth(): IgrColumnWidth;
    set oldWidth(v: IgrColumnWidth);
    /**
     * The new column width.
    */
    get newWidth(): IgrColumnWidth;
    set newWidth(v: IgrColumnWidth);
}
