import { IgrDataGridColumn } from "./igr-data-grid-column";
import { IgrFilterOperand } from "./igr-filter-operand";
import { GridCustomFilterRequestedEventArgs as GridCustomFilterRequestedEventArgs_internal } from "./GridCustomFilterRequestedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
import { IFilterExpression } from "igniteui-react-core";
import { FilterFactory } from "igniteui-react-core";
export declare class IgrGridCustomFilterRequestedEventArgs {
    protected createImplementation(): GridCustomFilterRequestedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridCustomFilterRequestedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The column that requested the filter.
    */
    get column(): IgrDataGridColumn;
    set column(v: IgrDataGridColumn);
    /**
     * The custom filter that was chosen.
    */
    get filter(): IgrFilterOperand;
    set filter(v: IgrFilterOperand);
    /**
     * The value that was provided in the editor for the filter.
    */
    get value(): any;
    set value(v: any);
    /**
     * Sets the filter expression to be used.
    */
    get expression(): IFilterExpression;
    set expression(v: IFilterExpression);
    /**
     * Gets the filter factory.
    */
    get filterFactory(): FilterFactory;
}
