import { IgrColumnGroupDescriptionCollection } from "./igr-column-group-description-collection";
import { GridGroupDescriptionsChangedEventArgs as GridGroupDescriptionsChangedEventArgs_internal } from "./GridGroupDescriptionsChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the current grouping applied to the grid.
*/
export declare class IgrGridGroupDescriptionsChangedEventArgs {
    protected createImplementation(): GridGroupDescriptionsChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridGroupDescriptionsChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get groupDescriptions(): IgrColumnGroupDescriptionCollection;
    set groupDescriptions(v: IgrColumnGroupDescriptionCollection);
}
