import { IgrGridSelectedCellRangesCollection } from "./igr-grid-selected-cell-ranges-collection";
import { GridSelectedCellRangesChangedEventArgs as GridSelectedCellRangesChangedEventArgs_internal } from "./GridSelectedCellRangesChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the change to the selected cell ranges in the grid.
*/
export declare class IgrGridSelectedCellRangesChangedEventArgs {
    protected createImplementation(): GridSelectedCellRangesChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridSelectedCellRangesChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    private _currentRanges;
    /**
     * The cell ranges currently in the selection.
    */
    get currentRanges(): IgrGridSelectedCellRangesCollection;
    set currentRanges(v: IgrGridSelectedCellRangesCollection);
    private _addedRanges;
    /**
     * The cell ranges added to the selection.
    */
    get addedRanges(): IgrGridSelectedCellRangesCollection;
    set addedRanges(v: IgrGridSelectedCellRangesCollection);
    private _removedRanges;
    /**
     * The cell ranges removed from the selection.
    */
    get removedRanges(): IgrGridSelectedCellRangesCollection;
    set removedRanges(v: IgrGridSelectedCellRangesCollection);
    private _updatedRanges;
    /**
     * The cell ranges that have been updated by the grid.
    */
    get updatedRanges(): IgrGridSelectedCellRangesCollection;
    set updatedRanges(v: IgrGridSelectedCellRangesCollection);
}
