import { IgrGridSelectedCellsCollection } from "./igr-grid-selected-cells-collection";
import { GridSelectedCellsChangedEventArgs as GridSelectedCellsChangedEventArgs_internal } from "./GridSelectedCellsChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the change to the selected cells in the grid.
*/
export declare class IgrGridSelectedCellsChangedEventArgs {
    protected createImplementation(): GridSelectedCellsChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridSelectedCellsChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    private _currentCells;
    /**
     * The current cells in the selection.
    */
    get currentCells(): IgrGridSelectedCellsCollection;
    set currentCells(v: IgrGridSelectedCellsCollection);
    private _addedCells;
    /**
     * The cells added to the selection.
    */
    get addedCells(): IgrGridSelectedCellsCollection;
    set addedCells(v: IgrGridSelectedCellsCollection);
    private _removedCells;
    /**
     * The cells removed from the selection.
    */
    get removedCells(): IgrGridSelectedCellsCollection;
    set removedCells(v: IgrGridSelectedCellsCollection);
}
