import { IgrFilteringExpressionsTree } from "./igr-filtering-expressions-tree";
import { IgrPagingState } from "./igr-paging-state";
import { IgrGroupingState } from "./igr-grouping-state";
import { IgrPinningConfig } from "./igr-pinning-config";
import { IgrPivotConfiguration } from "./igr-pivot-configuration";
import { IgrColumnState } from "./igr-column-state";
import { IgrSortingExpression } from "./igr-sorting-expression";
import { IgrGridSelectionRange } from "./igr-grid-selection-range";
import { IgrGridStateCollection } from "./igr-grid-state-collection";
export interface IgrGridStateInfo {
    columns?: IgrColumnState[];
    filtering?: IgrFilteringExpressionsTree;
    advancedFiltering?: IgrFilteringExpressionsTree;
    paging?: IgrPagingState;
    moving?: boolean | string;
    sorting?: IgrSortingExpression[];
    groupBy?: IgrGroupingState;
    cellSelection?: IgrGridSelectionRange[];
    rowSelection?: any[];
    columnSelection?: string[];
    rowPinning?: any[];
    pinningConfig?: IgrPinningConfig;
    expansion?: any[];
    rowIslands?: IgrGridStateCollection[];
    id?: string;
    pivotConfiguration?: IgrPivotConfiguration;
}
