import { IgrColumnSummaryDescriptionCollection } from "./igr-column-summary-description-collection";
import { GridSummaryDescriptionsChangedEventArgs as GridSummaryDescriptionsChangedEventArgs_internal } from "./GridSummaryDescriptionsChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Information about the current summaries applied to the grid.
*/
export declare class IgrGridSummaryDescriptionsChangedEventArgs {
    protected createImplementation(): GridSummaryDescriptionsChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridSummaryDescriptionsChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get summaryDescriptions(): IgrColumnSummaryDescriptionCollection;
    set summaryDescriptions(v: IgrColumnSummaryDescriptionCollection);
}
