import { GridValidationService as GridValidationService_internal } from "./GridValidationService";
import { ContentChildrenManager } from "igniteui-react-core";
import { IgrRecordValidationState } from "./igr-record-validation-state";
export declare class IgrGridValidationService {
    protected createImplementation(): GridValidationService_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridValidationService_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    findByName(name: string): any;
    setNativeElement(element: any): void;
    /**
     * Returns all invalid record states.
    
    */
    getInvalid(): IgrRecordValidationState[];
    markAsTouched(key: any, field: string): void;
    /**
     * Clears validation state by key or all states if none is provided.
     * key Optional. The key of the record for which to clear state.
    
    * @param key  * Optional. The key of the record for which to clear state.
    */
    clear(key: any): void;
}
