import { GroupData as GroupData_internal } from "./GroupData";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Object used to store group information for group headers.
*/
export declare class IgrGroupData {
    protected createImplementation(): GroupData_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GroupData_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The grouping key.
    */
    get groupName(): string;
    set groupName(v: string);
    /**
     * The group value.
    */
    get groupValue(): any;
    set groupValue(v: any);
    /**
     * The value as formatted text.
    */
    get formattedText(): string;
    set formattedText(v: string);
    findByName(name: string): any;
}
