import { IgrColumn } from "./igr-column";
import { DisplayDensity } from "./DisplayDensity";
import { SortingDirection } from "./SortingDirection";
import { HeaderType as HeaderType_internal } from "./HeaderType";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrHeaderType {
    protected createImplementation(): HeaderType_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): HeaderType_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get column(): IgrColumn;
    set column(v: IgrColumn);
    get density(): DisplayDensity;
    set density(v: DisplayDensity);
    get sorted(): boolean;
    set sorted(v: boolean);
    get selectable(): boolean;
    set selectable(v: boolean);
    get selected(): boolean;
    set selected(v: boolean);
    get title(): boolean;
    set title(v: boolean);
    get sortDirection(): SortingDirection;
    set sortDirection(v: SortingDirection);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
