import { IgrPinColumnEventArgsDetail } from "./igr-pin-column-event-args-detail";
import { PinColumnEventArgs as PinColumnEventArgs_internal } from "./PinColumnEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * The event arguments after a column's pin state is changed.
 * `insertAtIndex`specifies at which index in the pinned/unpinned area the column was inserted.
 * `isPinned` returns the actual pin state of the column after the operation completed.
*/
export declare class IgrPinColumnEventArgs {
    protected createImplementation(): PinColumnEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PinColumnEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get detail(): IgrPinColumnEventArgsDetail;
    set detail(v: IgrPinColumnEventArgsDetail);
}
