import { IgrPinRowEventArgsDetail } from "./igr-pin-row-event-args-detail";
import { PinRowEventArgs as PinRowEventArgs_internal } from "./PinRowEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Event emitted when a row's pin state changes.
*/
export declare class IgrPinRowEventArgs {
    protected createImplementation(): PinRowEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PinRowEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get detail(): IgrPinRowEventArgsDetail;
    set detail(v: IgrPinRowEventArgsDetail);
}
