import { IgrPivotValue } from "./igr-pivot-value";
import { IgrPivotDimension } from "./igr-pivot-dimension";
/**
 * Interface describing the Pivot column data.
 * Contains information on the related column dimensions and their values.
*/
export interface IgrPivotGridColumn {
    field?: string;
    /**
     * List of dimensions associated with the column.*
    */
    dimensions?: IgrPivotDimension[];
    value?: IgrPivotValue;
}
