import { GridHorizontalAlignment } from "./GridHorizontalAlignment";
import { GridVerticalAlignment } from "./GridVerticalAlignment";
import { IgrSize } from "./igr-size";
export interface IgrPositionSettings {
    /**
     * Attaching target for the component to show
    */
    target?: any;
    /**
     * Direction in which the component should show
    */
    horizontalDirection?: GridHorizontalAlignment | string;
    /**
     * Direction in which the component should show
    */
    verticalDirection?: GridVerticalAlignment | string;
    /**
     * Target's starting point
    */
    horizontalStartPoint?: GridHorizontalAlignment | string;
    /**
     * Target's starting point
    */
    verticalStartPoint?: GridVerticalAlignment | string;
    /**
     * The size up to which element may shrink when shown in elastic position strategy
    */
    minSize?: IgrSize;
}
