import { SortingEventArgsDetail as SortingEventArgsDetail_internal } from "./SortingEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
import { IgrSortingExpression } from "./igr-sorting-expression";
import { IgrGroupingExpression } from "./igr-grouping-expression";
export declare class IgrSortingEventArgsDetail {
    protected createImplementation(): SortingEventArgsDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): SortingEventArgsDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get sortingExpressions(): IgrSortingExpression[];
    set sortingExpressions(v: IgrSortingExpression[]);
    get groupingExpressions(): IgrGroupingExpression[];
    set groupingExpressions(v: IgrGroupingExpression[]);
    /**
     * Provides reference to the owner component.
    */
    get owner(): any;
    set owner(v: any);
    /**
     * Provides the ability to cancel the event.
    */
    get cancel(): boolean;
    set cancel(v: boolean);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
