import { IgrCellInfo } from "./igr-cell-info";
import { SummaryCellModel as SummaryCellModel_internal } from "./SummaryCellModel";
/**
 * Backing information for a section header cell in the grid.
*/
export declare class IgrSummaryCellInfo extends IgrCellInfo {
    protected createImplementation(): SummaryCellModel_internal;
    /**
                                 * @hidden
                                 */
    get i(): SummaryCellModel_internal;
    constructor();
    /**
     * Sets or gets the resolved summary label for the summary cell.
    */
    get resolvedSummaryLabel(): string;
    set resolvedSummaryLabel(v: string);
    /**
     * Sets or gets the resolved summary value for the sumamry cell.
    */
    get resolvedSummaryValue(): string;
    set resolvedSummaryValue(v: string);
    /**
     * Gets or sets the color of the text for the summary label in the cell.
    */
    get summaryLabelTextColor(): string;
    set summaryLabelTextColor(v: string);
    get font(): string;
    set font(v: string);
}
