import { SummaryChangedEventArgs as SummaryChangedEventArgs_internal } from "./SummaryChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Event args for the SummaryChanged event.
*/
export declare class IgrSummaryChangedEventArgs {
    protected createImplementation(): SummaryChangedEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): SummaryChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the unique ID for the changed summary.
    */
    get iD(): string;
    set iD(v: string);
    /**
     * Gets the current state of the changed summary.
    */
    get isEnabled(): boolean;
    set isEnabled(v: boolean);
}
