import { IgrCellInfo } from './igr-cell-info';
import { TemplateCellUpdatingEventArgs as TemplateCellUpdatingEventArgs_internal } from "./TemplateCellUpdatingEventArgs";
/**
 * Information about the cell that has content which is being created or updated.
*/
export declare class IgrTemplateCellUpdatingEventArgs {
    protected createImplementation(): TemplateCellUpdatingEventArgs_internal;
    protected _implementation: any;
    get i(): TemplateCellUpdatingEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    get isCanvasBased(): boolean;
    /**
     * The host in which to add or update content if this is a DOM based cell.
    */
    get content(): Element;
    ensureCorrectSize(): boolean;
    get context(): CanvasRenderingContext2D;
    renderStandardBackground(): void;
    renderStandardContent(): void;
    /**
     * The backing information for the current cell.
    */
    get cellInfo(): IgrCellInfo;
}
