import { IgrCellInfo } from './igr-cell-info';
import { TemplateSectionHeaderCellUpdatingEventArgs as TemplateSectionHeaderCellUpdatingEventArgs_internal } from "./TemplateSectionHeaderCellUpdatingEventArgs";
/**
 * Information about the cell that has content which is being created or updated.
*/
export declare class IgrTemplateSectionHeaderCellUpdatingEventArgs {
    protected createImplementation(): TemplateSectionHeaderCellUpdatingEventArgs_internal;
    protected _implementation: any;
    get i(): TemplateSectionHeaderCellUpdatingEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The host in which to add or update content.
    */
    get content(): Element;
    /**
     * The backing information for the current cell.
    */
    get cellInfo(): IgrCellInfo;
}
