import { TreeGridRecord as TreeGridRecord_internal } from "./TreeGridRecord";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrTreeGridRecord {
    protected createImplementation(): TreeGridRecord_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): TreeGridRecord_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get key(): any;
    set key(v: any);
    get data(): any;
    set data(v: any);
    get children(): IgrTreeGridRecord[];
    set children(v: IgrTreeGridRecord[]);
    get parent(): IgrTreeGridRecord;
    set parent(v: IgrTreeGridRecord);
    get level(): number;
    set level(v: number);
    get isFilteredOutParent(): boolean;
    set isFilteredOutParent(v: boolean);
    get expanded(): boolean;
    set expanded(v: boolean);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
